Package: httkexamples
Version: 0.0.1
Date: 2025-12-03
Title: High-Throughput Toxicokinetics Examples
Description: High throughput toxicokinetics ("HTTK") is the 
             combination of 1) chemical-specific in vitro measurements or in
             silico predictions and 2) generic mathematical models, to
             predict absorption, distribution, metabolism, and excretion by the
             body. HTTK methods have been described by Pearce et al. (2017) 
             (<doi:10.18637/jss.v079.i04>) and Breen et al. (2021) (<doi:10.1080/17425255.2021.1935867>).
             Here we provide examples (vignettes) applying HTTK to solve various
             problems in bioinformatics, toxicology, and exposure science.
             In accordance with Davidson-Fritz et al. (2025) (<doi:10.1371/journal.pone.0321321>),
             whenever a new HTTK model is developed, the code to generate the 
             figures evaluating that model is added as a new vignettte.  
Authors@R: c(
           person("John", "Wambaugh", email = "john.wambaugh@UL.org", 
             role = c("aut", "cre"),
             comment = c(ORCID = "0000-0002-4024-534X")), 
           person("Robert", "Pearce", role = c("aut"),
             comment = c(ORCID = "0000-0003-3168-4049")), 
           person("Caroline", "Ring", email = "Ring.Caroline@epa.gov", 
             role = c("aut"), comment = c(ORCID = "0000-0002-0463-1251")), 
           person("Greg", "Honda", email = "honda.gregory@epa.gov", 
             role = c("aut"), comment = c(ORCID = "0000-0001-7713-9850")), 
           person("Matt", "Linakis", email = "MLINAKIS@ramboll.com", 
             role = c("aut"), comment = c(ORCID = "0000-0003-0526-2395")), 
           person("Dustin", "Kapraun", email = "kapraun.dustin@epa.gov",
             role = c("aut"), comment = c(ORCID= "0000-0001-5570-6383")),
           person("Kimberly", "Truong", email = "truong.kimberly@epa.gov", 
             role = c("aut"), comment = c(ORCID = "0000-0003-1716-1006")), 
           person("Meredith", "Scherer", email="Scherer.Meredith@epa.gov",
             role = c("aut"), comment = c(ORCID = "0000-0002-9785-7363")),
           person("Annabel", "Meade", email = "aemeade7@gmail.com",
             role = c("aut"), comment = c(ORCID = "0000-0002-5452-8797")),
           person("Celia", "Schacht", email="Schacht.Celia@epa.gov",
             role = c("aut"), comment = c(ORCID = "0000-0002-8131-513X")),
           person("Elaina", "Kenyon",
             role = c("ctb"), comment = c(ORCID = "0000-0001-8781-2391"))
           )
Depends: R (>= 2.10)
Imports: httk, rmarkdown, knitr, Rdpack
RdMacros: Rdpack
Suggests: dplyr, tidyverse, xlsx, Metrics, ggplot2, ggforce, ggpubr,
        ggrepel, viridis, ggpubr, grid, ggh4x, readr, ggforce, tidyr,
        stringr, pracma, cgwtools, openxlsx, ggstar, latex2exp, smatr,
        reshape,
        gdata,censReg,gmodels,gplots,scales,colorspace,gridExtra,
        rvcheck
License: MIT + file LICENSE
LazyData: true
LazyDataCompression: xz
Encoding: UTF-8
VignetteBuilder: knitr
RoxygenNote: 7.3.3
URL: https://chemicalinsights.ul.org/
NeedsCompilation: no
Packaged: 2025-12-04 00:56:11 UTC; WambaughJohn
Author: John Wambaugh [aut, cre] (ORCID:
    <https://orcid.org/0000-0002-4024-534X>),
  Robert Pearce [aut] (ORCID: <https://orcid.org/0000-0003-3168-4049>),
  Caroline Ring [aut] (ORCID: <https://orcid.org/0000-0002-0463-1251>),
  Greg Honda [aut] (ORCID: <https://orcid.org/0000-0001-7713-9850>),
  Matt Linakis [aut] (ORCID: <https://orcid.org/0000-0003-0526-2395>),
  Dustin Kapraun [aut] (ORCID: <https://orcid.org/0000-0001-5570-6383>),
  Kimberly Truong [aut] (ORCID: <https://orcid.org/0000-0003-1716-1006>),
  Meredith Scherer [aut] (ORCID: <https://orcid.org/0000-0002-9785-7363>),
  Annabel Meade [aut] (ORCID: <https://orcid.org/0000-0002-5452-8797>),
  Celia Schacht [aut] (ORCID: <https://orcid.org/0000-0002-8131-513X>),
  Elaina Kenyon [ctb] (ORCID: <https://orcid.org/0000-0001-8781-2391>)
Maintainer: John Wambaugh <john.wambaugh@UL.org>
Repository: CRAN
Date/Publication: 2025-12-10 21:00:02 UTC
Built: R 4.6.0; ; 2026-04-29 19:53:16 UTC; unix

# R Package "httkexamples"

<img src="man/figures/httk.png" align="right" width="33%"/>

<!-- badges: start -->
[![CRAN_Status_Badge](https://www.r-pkg.org/badges/version/httkexamples)](https://cran.r-project.org/package=httkexamples)
[![Monthly Downloads](https://cranlogs.r-pkg.org/badges/last-month/httkexamples)](https://cranlogs.r-pkg.org/badges/last-month/httkexamples)
<!-- badges: end -->

High throughput toxicokinetics ("HTTK") is the 
             combination of in vitro data and generic mathematical models to
             predict absorption, distribution, metabolism, and excretion by the
             body, as decribed by Pearce et al. (2017) 
             (<doi:10.18637/jss.v079.i04>) and Breen et al. (2021) (<doi:10.1080/17425255.2021.1935867>).
             We provide examples (vignettes) applying HTTK to solve various
             problems in bioinformatics, toxicology, and exposure science.
             In accordance with Davidson-Fritz et al. (2025) (<doi:10.1371/journal.pone.0321321>),
             whenever a new HTTK model is developed, the code to generate the 
             figures evaluating that model is added as a new vignettte.

## Loading the httk walkthroughs ("vignettes")
* List all vignettes for httk 
```
httk.vignettes()
```
* Displays the vignette for a specified vignette 
```
vignette("IntroToHTTK")
```

## Authors

### Principal Investigator 
John Wambaugh [John.Wambaugh@UL.org]

### Vignette Authors
Robert Pearce,
Caroline Ring [Ring.Caroline@epa.gov],
Greg Honda [honda.gregory@epa.gov], 
Matt Linakis [MLINAKIS@ramboll.com],
Dustin Kapraun [kapraun.dustin@epa.gov],
Kimberly Truong [truong.kimberly@epa.gov],
Annabel Meade [aemeade7@gmail.com], 
Celia Schacht [Schacht.Celia@epa.gov], and
Elaina Kenyon

## ----configure_knitr, eval = TRUE---------------------------------------------
knitr::opts_chunk$set(collapse = TRUE, comment = '#>')
options(rmarkdown.html_vignette.check_title = FALSE)

## ----clear_memory, eval = TRUE------------------------------------------------
rm(list=ls()) 

## ----runchunks, eval = TRUE---------------------------------------------------
# Set whether or not the following chunks will be executed (run):
execute.vignette <- TRUE

## ----load_packages, eval = execute.vignette-----------------------------------
library(ggplot2)
library(httk)

## ----version_check, eval = execute.vignette-----------------------------------
packageVersion("httk")

## ----chemical_thining, eval = execute.vignette--------------------------------
NUM.CHEMS <- length(get_cheminfo(model="pbtk", suppress.messages = TRUE))
SKIP.CHEMS <- 100

## ----MC_samples, eval = execute.vignette--------------------------------------
NSAMP <- 10

## ----rat_pbtk_parameters, eval = execute.vignette-----------------------------
parameters <- try(parameterize_pbtk(chem.name = "triclosan", 
                                    species = "rat"))

## ----rat_pbtk_parameters2, eval = execute.vignette----------------------------
parameters <- parameterize_pbtk(chem.name = "triclosan", 
                                species = "rat", 
                                default.to.human = TRUE)

## ----use)pbtk_parameters, eval = execute.vignette-----------------------------
parameters["Funbound.plasma"] <- 0.001
out <- solve_pbtk(parameters = parameters, suppress.messages = TRUE)

## ----select_Chemicals, eval = execute.vignette--------------------------------
chem.list <- intersect(get_cheminfo(model = "pbtk", 
                                    suppress.messages = TRUE)[seq(
                                      1, NUM.CHEMS, SKIP.CHEMS)],
                       get_wetmore_cheminfo())

## ----make_Css_table, eval = execute.vignette----------------------------------
css.table <- NULL
for (this.cas in chem.list)
{
    ids <- get_chem_id(chem.cas=this.cas)
    this.row <- data.frame(Compound=ids$chem.name,
                              DTXSID=ids$dtxsid,
                              CAS=this.cas)
    this.row <- cbind(this.row,
                      as.data.frame(calc_analytic_css(chem.cas = this.cas,
                                                      model = "pbtk",
                                                      output.units = "uM",
                                                      suppress.messages=TRUE)))
    this.row <- cbind(this.row,
                      as.data.frame(get_wetmore_css(chem.cas = this.cas,
                                                    which.quantile = 0.50,
                                                    output.units = "uM",
                                                    suppress.messages=TRUE)))
    this.row <- cbind(this.row,
                        as.data.frame(calc_mc_css(chem.cas = this.cas,
                                                  which.quantile = 0.50,
                                                  output.units = "uM",
                                                  samples = NSAMP,
                                                  suppress.messages=TRUE)))
    css.table <- rbind(css.table, this.row)
}
colnames(css.table) <- c("Compound","DTXSID","CAS", "PBTK", "Wetmore", "MC")

## ----display_Css_table, eval = execute.vignette-------------------------------
knitr::kable(css.table, caption = "Literature and HTTK Plasma Css", 
             floating.environment="sidewaystable",
             row.names=FALSE,
             digits=3)
litvshttkcss <- ggplot(css.table, aes(Wetmore, MC)) +
    geom_point() + geom_abline() +
    scale_x_log10() + scale_y_log10() +
    xlab(bquote("Literature"~C[ss]~"("*mu*"M)")) +
    ylab(bquote("HTTK"~C[ss]~"("*mu*"M)")) +
    theme(axis.text = element_text(size = 16),
          axis.title = element_text(size = 16))
print(litvshttkcss)

## ----plot_examples, eval = execute.vignette-----------------------------------
out <- solve_pbtk(chem.name = "Bisphenol A", 
                  days = 50, 
                  doses.per.day = 3,
                  daily.dose=1,
                  output.units = "uM")
plot.data <- as.data.frame(out)

css <- calc_analytic_css(chem.name = "Bisphenol A",
                  output.units = "uM")

c.vs.t <- ggplot(plot.data, aes(time, Cplasma)) +
    geom_line() + geom_hline(yintercept = css) +
    ylab(bquote("Plasma Concentration ("*mu*"M)")) +
    xlab("Day") +
    theme(axis.text = element_text(size = 16),
          axis.title = element_text(size = 16),
          plot.title = element_text(size = 17, hjust=0.5)) +
    ggtitle("Bisphenol A")
print(c.vs.t)

## ----suppress_messages, eval = execute.vignette-------------------------------
out <- solve_pbtk(chem.name = "Bisphenol A", 
                  days = 50, 
                  doses.per.day = 3,
                  daily.dose=1,
                  output.units = "uM",
                  suppress.messages = TRUE)

css <- calc_analytic_css(chem.name = "Bisphenol A",
                  output.units = "uM",
                  suppress.messages = TRUE)

## ----stats_example1, eval = FALSE---------------------------------------------
# all.peak.stats <- calc_stats(days = 10, doses.per.day = 3, stats = "peak")

## ----stats_example2, eval = execute.vignette----------------------------------
triclosan.stats <- calc_stats(days = 10, chem.name = "triclosan")

## ----css_examples, eval = execute.vignette------------------------------------
get_wetmore_css(chem.cas = "80-05-7", daily.dose = 1,
                which.quantile = 0.5, output.units = "uM")

set.seed(654321)
calc_mc_css(chem.cas = "80-05-7", 
            daily.dose = 1, 
            which.quantile = 0.5,
            censored.params = list(
              Funbound.plasma = list(cv = 0.1, lod = 0.005)),
            vary.params = list(
              BW = 0.15, 
              Vliverc = 0.15, 
              Qgfrc = 0.15,
              Qtotal.liverc = 0.15, 
              million.cells.per.gliver = 0.15,
              Clint = 0.15),
            output.units = "uM", 
            samples = NSAMP,
            httkpop=FALSE,
            invitrouv=FALSE,
            suppress.messages = TRUE)

## ----css_examples2, eval = execute.vignette-----------------------------------
set.seed(654321)
calc_mc_css(chem.cas = "80-05-7", 
            daily.dose = 1, 
            which.quantile = 0.5,
            output.units = "uM", 
            samples = NSAMP,
            suppress.messages = TRUE)

## ----set_seed_example, eval = execute.vignette--------------------------------
# Random number generator seed 1:
set.seed(654321)
calc_mc_css(chem.cas = "80-05-7", 
            daily.dose = 1, 
            which.quantile = 0.5,
            output.units = "uM", 
            samples = NSAMP,
            suppress.messages = TRUE)

# Continuing to draw random numbers without resetting the seed:
calc_mc_css(chem.cas = "80-05-7", 
            daily.dose = 1, 
            which.quantile = 0.5,
            output.units = "uM", 
            samples = NSAMP,
            suppress.messages = TRUE)

# Random number generator seed 2:
set.seed(123456)
calc_mc_css(chem.cas = "80-05-7", 
            daily.dose = 1, 
            which.quantile = 0.5,
            output.units = "uM", 
            samples = NSAMP,
            suppress.messages = TRUE)

# Continuing to draw random numbers without resetting the seed:
calc_mc_css(chem.cas = "80-05-7", 
            daily.dose = 1, 
            which.quantile = 0.5,
            output.units = "uM", 
            samples = NSAMP,
            suppress.messages = TRUE)

# Random number generator seed 2 gives the same answer as it did above:
set.seed(123456)
calc_mc_css(chem.cas = "80-05-7", 
            daily.dose = 1, 
            which.quantile = 0.5,
            output.units = "uM", 
            samples = NSAMP,
            suppress.messages = TRUE)

# Random number generator seed 1 gives the same answer as it did above:
set.seed(654321)
calc_mc_css(chem.cas = "80-05-7", 
            daily.dose = 1, 
            which.quantile = 0.5,
            output.units = "uM", 
            samples = NSAMP,
            suppress.messages = TRUE)

## ----literature_oral_equivalent_example, eval = execute.vignette--------------
get_wetmore_oral_equiv(50, chem.cas = "80-05-7")
set.seed(654321)
calc_mc_oral_equiv(50, chem.cas = "80-05-7", samples = NSAMP)

## ----monte_carlo_css_example_1, eval = execute.vignette-----------------------
vary.params <- NULL
params <- parameterize_pbtk(chem.name = "Zoxamide")
for (this.param in names(subset(params, names(params) != "Funbound.plasma")))
  # Only want to vary numerical parameters:
  if (is.numeric(params[[this.param]])) 
      vary.params[this.param] <- 0.2

## ----monte_carlo_css_example_2, eval = execute.vignette-----------------------
censored.params <- list(Funbound.plasma = list(cv = 0.2, lod = 0.01))

## ----monte_carlo_css_example_3, eval = execute.vignette-----------------------
set.seed(1)
out <- calc_mc_tk(parameters=params, 
                  vary.params = vary.params,
                  censored.params = censored.params,
                  return.samples = TRUE, 
                  model = "pbtk",
                  suppress.messages = TRUE,
                  httkpop = FALSE,
                  invitrouv = FALSE,
                  samples = NSAMP,
                  solvemodel.arg.list = list(times = seq(0,0.5,0.025))
                  )

## ----monte_carlo_css_example_4, eval = execute.vignette-----------------------
zoxtable <- cbind(out[["means"]][,"time"],
                  out[["means"]][,"Cplasma"],
                  out[["means"]][,"Cplasma"] - 1.96*out[["sds"]][,"Cplasma"],
                  out[["means"]][,"Cplasma"] + 1.96*out[["sds"]][,"Cplasma"])
colnames(zoxtable) <- c("time","Cplasma","lcl","ucl")
knitr::kable(zoxtable, caption = "Zoxamide plasma concentration vs. time",
             floating.environment="sidewaystable")

## ----monte_carlo_css_example_5, eval = execute.vignette-----------------------
zoxamide1 <- ggplot(as.data.frame(zoxtable), aes(x=time,y=Cplasma)) +
    geom_line(color = "dark blue",linewidth=2) +
      geom_ribbon(aes(ymin=lcl, ymax=ucl), alpha = 0.3,
                  fill = "light blue", color="black", linetype="dotted")+
    ylab("Plasma concentration") +
    xlab("Time (days)") +
    theme(axis.text = element_text(size = 16),
          axis.title = element_text(size = 16))
print(zoxamide1)

## ----monte_carlo_css_example_6, eval = execute.vignette-----------------------
out <- calc_mc_css(parameters=params, 
                  vary.params = vary.params,
                  censored.params = censored.params,
                  return.samples = TRUE, 
                  model = "pbtk",
                  suppress.messages = TRUE,
                  httkpop = FALSE,
                  samples = NSAMP,
                  invitrouv = FALSE)

zoxamide2 <- ggplot(as.data.frame(out), aes(out)) +
    geom_histogram(fill = "blue", binwidth = 1/6) +
    scale_x_log10() + ylab("Number of Samples") +
    xlab(bquote(C[ss]~"("*mu*"M)")) +
    theme(axis.text = element_text(size = 16),
          axis.title = element_text(size = 16))
print(zoxamide2)

## ----add_a_tissue, eval = execute.vignette------------------------------------
new.tissue <- subset(tissue.data,Tissue == "adipose" & Species =="Human")
new.tissue[, "Tissue"] <- "mammary"
new.tissue[new.tissue$variable=="Vol (L/kg)","value"] <- 
  320/1000/60 # Itsukage et al. (2017) PMID: 29308107
new.tissue[new.tissue$variable %in% c('Flow (mL/min/kg^(3/4))'),'value'] <-
# We'll arbitrarily set flow to a tenth of total adipose:
  new.tissue[new.tissue$variable %in% c('Flow (mL/min/kg^(3/4))'),'value']/10
tissue.data <- rbind(tissue.data, new.tissue)
knitr::kable(subset(tissue.data,Tissue=="mammary"), 
             caption = "Approximate Mamary Tissue Parameters", 
             floating.environment="sidewaystable",
             row.names=FALSE,
             digits=3)

## ----add_a_tissue2, eval = FALSE----------------------------------------------
# # If we thought this tissue was included in the rest of the bod
# tissue.data[tissue.data$Tissue == "rest", 'value'] <-
#   tissue.data[tissue.data$Tissue == "rest", 'value'] -
#   new.tissue[new.tissue$variable %in% c(
#     'Vol (L/kg)',
#     'Flow (mL/min/kg^(3/4))'),
#     'value']

## ----add_a_tissue3, eval = execute.vignette-----------------------------------
compartments <- list(liver = c("liver", "gut"), kidney = "kidney",
                     breast = "mammary", brain = "brain",
                     thyroid = "thyroid")
tissues.to.include <- unique(tissue.data$Tissue)
tissues.to.include <- tissues.to.include[!(tissues.to.include=="placenta")]
Kp <- predict_partitioning_schmitt(
  chem.name = "Nicotine", 
  tissues = tissues.to.include,
  suppress.messages = TRUE)
lumped.params <- lump_tissues(Kp, tissuelist=compartments)
knitr::kable(as.data.frame(lumped.params), 
             caption = "PCs, Volumes, and Flows for Lumped Tissues", 
             floating.environment="sidewaystable",
             row.names=FALSE,
             digits=3)

## ----add_a_species1, eval = execute.vignette----------------------------------
new.species <- physiology.data[,"Rabbit"]
names(new.species) <- physiology.data[,"Parameter"]
rabbit.BW <- new.species["Average BW"] 
new.species["Average BW"] <- 31.2 # Rausch and Pearson (1972) https://doi.org/10.2307/3799057
new.species["Average Body Temperature"] <- 38.5 # Thiel et al. (2019) https://doi.org/10.1186/s12983-019-0319-8

physiology.data <- cbind(physiology.data, new.species)
colnames(physiology.data)[length(colnames(physiology.data))] <- "Wolverine"

knitr::kable(physiology.data[,c("Parameter","Units","Wolverine")], 
             caption = "Approximate Wolverine Physiological Parameters", 
             floating.environment="sidewaystable",
             row.names=FALSE,
             digits=3)

## ----add_a_species2, eval = execute.vignette----------------------------------
new.tissue.data <- subset(tissue.data,Species=="Rabbit")
new.tissue.data$Species <- "Wolverine"

tissue.data <- rbind(tissue.data,new.tissue.data)

new.physiology.data <- physiology.data[,"Rabbit"]
physiology.data <- rbind(physiology.data, new.physiology.data)
colnames(physiology.data)[length(colnames(physiology.data))] <- "Wolverine"

## ----add_a_species3, eval = execute.vignette----------------------------------
calc_mc_css(chem.cas="80-05-7",species="wolverine",
            parameterize.args.list =list(default.to.human=TRUE),
            suppress.messages=TRUE,
            samples = NSAMP)

## ----export, eval = FALSE-----------------------------------------------------
# export_pbtk_sbml(chem.name = "Bisphenol A", species = "Rat",
#                  initial.amounts = list(Agutlumen = 1),
#                  filename = "PBTKmodel.xml")

## ----figure3, eval = execute.vignette-----------------------------------------
css.data <- data.frame()
chem.list <- get_cheminfo(model='pbtk', suppress.messages = TRUE)[seq(
  1, NUM.CHEMS, SKIP.CHEMS)]
for (this.cas in chem.list) {
    css.info <- calc_css(chem.cas = this.cas,
                         doses.per.day = 1,
                         model="pbtk",
                         suppress.messages = TRUE)
    css.data[this.cas,"days"] <- css.info[["the.day"]]
    css.data[this.cas,"avg"] <- css.info[["avg"]]
    css.data[this.cas,"max"] <- css.info[["max"]]
}

hist <- ggplot(css.data, aes(days+0.1)) +
    geom_histogram(fill = "blue", bins=5) +
    scale_x_log10() + ylab("Number of Chemicals") + xlab("Days") +
    theme(axis.text = element_text(size = 16),
          axis.title = element_text(size = 16))
print(hist)

## ----figure4, eval = execute.vignette-----------------------------------------
avg.vs.max <- ggplot(css.data, aes(avg, max)) +
    geom_point() + geom_abline() +
    scale_x_log10() + scale_y_log10() +
    xlab(bquote("Avg. Conc. at Steady State ("*mu*"M)")) +
    ylab(bquote("Max. Conc. at Steady State ("*mu*"M)")) +
    theme(axis.text = element_text(size = 16),
          axis.title = element_text(size = 16))
print(avg.vs.max)

## ----configure_knitr, eval = TRUE---------------------------------------------
knitr::opts_chunk$set(echo = TRUE, fig.width=5, fig.height=4)

## ----clear_memory, eval = TRUE------------------------------------------------
rm(list=ls()) 

## ----runchunks, eval = TRUE---------------------------------------------------
# Set whether or not the following chunks will be executed (run):
execute.vignette <- FALSE

## ----setup, eval = execute.vignette-------------------------------------------
# knitr::opts_chunk$set(echo = TRUE, fig.width=5, fig.height=4)
# library(httk)
# library(httkexamples)
# library(ggplot2)
# library(gridExtra)
# library(cowplot)
# library(ggrepel)
# library(dplyr)
# library(stringr)
# library(forcats)
# library(smatr)
# library(scales)
# 
# # Path to working director:
# LOC.WD <- tempdir()

## ----data, eval = execute.vignette--------------------------------------------
# met_data <- httkexamples::metabolism_data_Linakis2020
# conc_data <- httkexamples::concentration_data_Linakis2020
# #conc_data <- subset(concentration_data_Linakis2020, !(SAMPLING_MATRIX %in%
# #                      c("EEB","MEB","EB")))
# #conc_data <- concentration_data_Linakis2020
# #  subset(concentration_data_Linakis2020, !(SOURCE_CVT %in% c(
# #  "11453305")))
# conc_data[,"DOSE_U"] <- ifelse(conc_data[,"DOSE_U"] == "ppm",
#                                yes = "ppmv",
#                                conc_data[,"DOSE_U"])
# conc_data[,"ORIG_CONC_U"] <- ifelse(conc_data[,"ORIG_CONC_U"] == "ppm",
#                                     yes = "ppmv",
#                                     conc_data[,"ORIG_CONC_U"])
# # Not sure what to do with percent:
# conc_data <- subset(conc_data,toupper(ORIG_CONC_U) != "PERCENT")
# # Rename this column:
# colnames(conc_data)[colnames(conc_data)=="ORIG_CONC_U"] <- "CONC_U"
# conc_data$ORIGINAL_CONC_U <- conc_data$CONC_U
# conc_data$ORIGINAL_CONC <- conc_data$CONCENTRATION
# # Maybe Linakis et al translated all concentrations to uM?
# conc_data$CONC_U <- "uM"

## ----convert_to_ppmweight, eval = FALSE---------------------------------------
# gas.media <- c("EB","MEB","EEB","EB (+W)")
# gas.units <- unique(subset(conc_data,
#   SAMPLING_MATRIX %in% gas.media)$CONC_U)
# target.unit <- "ppmv"
# for (this.unit in gas.units)
#   if (this.unit != target.unit)
#   {
#     these.chems <- unique(subset(conc_data,
#       SAMPLING_MATRIX %in% gas.media &
#       CONC_U==this.unit)$DTXSID)
#     for (this.chem in these.chems)
#     {
#       this.factor <- convert_units(
#         input.units=this.unit,
#         output.units=target.unit,
#         dtxsid=this.chem, state="gas")
#       print(paste("Use",this.factor,"to convert",this.unit,"to",target.unit))
# 
#       # Scale the observation
#       conc_data[conc_data$DTXSID==this.chem &
#                   conc_data$SAMPLING_MATRIX %in% gas.media &
#                   conc_data$CONC_U==this.unit,"CONCENTRATION"] <-
#         this.factor * conc_data[
#           conc_data$DTXSID==this.chem &
#             conc_data$SAMPLING_MATRIX %in% gas.media &
#             conc_data$CONC_U==this.unit,"CONCENTRATION"]
#       # Change the reported unit
#       conc_data[conc_data$DTXSID==this.chem &
#                   conc_data$SAMPLING_MATRIX %in% gas.media &
#                   conc_data$CONC_U==this.unit,"CONC_U"] <-
#         target.unit
# 
#     }
#   }

## ----normalize_other_units, eval = FALSE--------------------------------------
# tissue.media <- c("VBL","BL","ABL","PL","BL (+W)")
# tissue.units <- unique(subset(conc_data,
#   SAMPLING_MATRIX %in% tissue.media)$CONC_U)
# target.unit <- "uM"
# for (this.unit in tissue.units)
#   if (this.unit != target.unit)
#   {
#     these.chems <- unique(subset(conc_data,
#       SAMPLING_MATRIX %in% tissue.media &
#       CONC_U==this.unit)$DTXSID)
#     for (this.chem in these.chems)
#     {
#       this.factor <- try(convert_units(
#         input.units=this.unit,
#         output.units=target.unit,
#         dtxsid=this.chem))
#       print(paste("Use",this.factor,"to convert",this.unit,"to",target.unit))
# 
#       # Scale the observation
#       conc_data[conc_data$DTXSID==this.chem &
#                   conc_data$SAMPLING_MATRIX %in% tissue.media &
#                   conc_data$CONC_U==this.unit,"CONCENTRATION"] <-
#         this.factor * conc_data[
#           conc_data$DTXSID==this.chem &
#             conc_data$SAMPLING_MATRIX %in% tissue.media &
#             conc_data$CONC_U==this.unit,"CONCENTRATION"]
#       # Change the reported unit
#       conc_data[conc_data$DTXSID==this.chem &
#                   conc_data$SAMPLING_MATRIX %in% tissue.media &
#                   conc_data$CONC_U==this.unit,"CONC_U"] <-
#         target.unit
# 
#     }
#   }

## ----summary, eval = execute.vignette-----------------------------------------
# # Small molecule chemicals
# summary(met_data$AVERAGE_MASS)
# # Generally more lipophilic chemicals
# summary(met_data$OCTANOL_WATER_PARTITION_LOGP_OPERA_PRED)
# # Unsurprisingly then, the chemicals are generally less water-soluble
# summary(met_data$WATER_SOLUBILITY_MOL.L_OPERA_PRED)
# # ~60% of samples in humans
# table(conc_data$CONC_SPECIES)/nrow(conc_data)*100
# # ~72% of samples are from blood
# table(conc_data$SAMPLING_MATRIX)/nrow(conc_data)*100

## ----scenarios, eval = execute.vignette---------------------------------------
# # Create a dataframe with 1 row for each unique external exposure scenario
# unique_scenarios <- conc_data[with(conc_data,
#   order(PREFERRED_NAME,
#         CONC_SPECIES,
#         SAMPLING_MATRIX,
#         as.numeric(as.character(DOSE)),EXP_LENGTH,-TIME)),] %>%
#   distinct(DTXSID,DOSE,DOSE_U,EXP_LENGTH,CONC_SPECIES,SAMPLING_MATRIX, .keep_all = TRUE)

## ----runmodel, eval = execute.vignette----------------------------------------
# # Store the output of each simulation:
# simlist <- list()
# # Store the Cvt data relevant to each simulation
# obslist <- list()
# # Conduct one simulation for each unique combination of chemical, species, dose:
# for (i in 1:nrow(unique_scenarios))
#   if (unique_scenarios$CASRN[i] %in% get_cheminfo(model="gas_pbtk",
#                                                   suppress.messages = TRUE))
# {
#   # Identify relevant Cvt data:
#     relconc <- subset(conc_data,conc_data$DTXSID == unique_scenarios$DTXSID[i] &
#       conc_data$DOSE == unique_scenarios$DOSE[i] &
#       conc_data$EXP_LENGTH == unique_scenarios$EXP_LENGTH[i] &
#       conc_data$CONC_SPECIES == unique_scenarios$CONC_SPECIES[i] &
#       conc_data$SAMPLING_MATRIX == unique_scenarios$SAMPLING_MATRIX[i])
#     obslist[[i]] <- relconc
# #
# #
# #
# #
# #
# # THE FOLLOWING CODE RUNS solve_gas_pbtk FOR EACH SCENARIO
# # (UNIQUE COMBINATION OF CHEMICAL, SPECIES, DOSE, ETC.)
# #
# #
# #
# #
# #
#     solver.out <- try(suppressWarnings(as.data.frame(solve_gas_pbtk(
#         chem.cas = unique_scenarios$CASRN[i],
#         days = signif(max(obslist[[i]]$TIME)+0.25,2),
# # Make sure we get predicted conc's at the observed times (in days):
#         times=sort(unique(c(0, # Start time
#                             1e-3, # Small time after time zero
#                             signif(obslist[[i]]$TIME,4), # Times with CvT observations
#                             signif(unique_scenarios$EXP_LENGTH[i],4) # When the exposure stops
#                    ))), # days
#         tsteps = 4,
#         exp.conc = as.numeric(unique_scenarios$DOSE[i]), # SED (06-22-2021) think this is ppmv for all scenarios
#         input.units = unique_scenarios$DOSE_U[i], # specify the units for exp.conc (ppmv)
#         output.units="uM",
#         exp.duration = signif(unique_scenarios$EXP_LENGTH[i],4)*24, # solve_gas_pbtk expects hourse
#         period = 0, # simulate single dose
#         species = as.character(unique_scenarios$CONC_SPECIES[i]),
#         monitor.vars = c(
#           "Cven",
#           "Clung",
#           "Cart",
#           "Cplasma",
#           "Calvppmv",
#           "Cendexhppmv",
#           "Cmixexhppmv",
#           "Calv",
#           "Cendexh",
#           "Cmixexh",
#           "Cmuc",
#           "AUC"),
#         vmax.km = FALSE,
#         suppress.messages = TRUE,
#         hmin=1e-12#,
#        # method="rk4"
#    ))))
# #
# #
# #
# #
# #
# #
# #
# #
# #
# #
#     if (class(solver.out) %in% "try-error")
#       solver.out <- data.frame(time=NA,Conc=NA)
# 
#  #   print(solver.out)
# # Get the blood:plasma ratio:
#     this.Rb2p <- suppressWarnings(available_rblood2plasma(
#       chem.cas=unique_scenarios$CASRN[i],
#       species=as.character(unique_scenarios$CONC_SPECIES[i])))
#     solver.out$Rb2p <- this.Rb2p
# 
#     # The column simconc holds the appropriate prediction for the sampling matrix
#     # BL : blood
#     # EEB : end-exhaled breath
#     # MEB : mixed exhaled breath
#     # VBL : venous blood
#     # ABL : arterial blood
#     # EB : unspecified exhaled breath sample (assumed to be EEB)
#     # PL: plasma
#     # +W with work/exercise
#     #
#     # The model outputs are provided in the following units:
# 	  # uM: Cven, Clung, Cart, Cplasma, Calv, Cendexh, Cmixexh, Cmuc
# 	  # ppmv: Calvppmv, Cendexhppmv, Cmixexhppmv
# 	  # uM*days: AUC
#     if (unique_scenarios$SAMPLING_MATRIX[i] == "VBL" |
#       unique_scenarios$SAMPLING_MATRIX[i] == "BL" |
#       unique_scenarios$SAMPLING_MATRIX[i] == "BL (+W)")
#     {
#       solver.out$simconc <- solver.out$Cven*this.Rb2p
#       solver.out$unit <- "uM"
#     } else if (unique_scenarios$SAMPLING_MATRIX[i] == "ABL") {
#       solver.out$simconc <- solver.out$Cart*this.Rb2p
#       solver.out$unit <- "uM"
#     } else if (unique_scenarios$SAMPLING_MATRIX[i] == "EB" |
#       unique_scenarios$SAMPLING_MATRIX[i] == "EEB" |
#       unique_scenarios$SAMPLING_MATRIX[i] == "EB (+W)")
#     {
#       solver.out$simconc <- solver.out$Cendexh # uM
#       solver.out$unit <- "uM"
#     } else if (unique_scenarios$SAMPLING_MATRIX[i] == "MEB") {
#         solver.out$simconc <- solver.out$Cmixexh # uM
#         solver.out$unit <- "uM"
#     } else if (unique_scenarios$SAMPLING_MATRIX[i] == "PL") {
#       solver.out$simconc <- solver.out$Cplasma
#       solver.out$unit <- "uM"
#     } else {
#       solver.out$simconc <- NA
#       solver.out$unit <- NA
#     }
#     simlist[[i]] <- solver.out
# }

## ----Makestudyplots, eval = execute.vignette----------------------------------
# cvtlist <- list()
# for(i in 1:nrow(unique_scenarios))
# {
#     plot.data <- simlist[[i]]
#     relconc <- obslist[[i]]
# 
#     if (!is.null(plot.data))
#     {
# #Right now this is only calculating real concentrations according to mg/L in blood
#     cvtlist[[i]] <- ggplot(data=plot.data, aes(time*24, simconc)) +
#       geom_line() +
#       xlab("Time (h)") +
#       ylab(paste0("Simulated ",
#         unique_scenarios$SAMPLING_MATRIX[i],
#         "\nConcentration (" ,
#         solver.out$unit, ")")) +
#       ggtitle(paste0(
#         unique_scenarios$PREFERRED_NAME[i],
#         " (",
#         unique_scenarios$CONC_SPECIES[i],
#         ", ",
#         round(as.numeric(unique_scenarios$DOSE[i]), digits = 2),
#         unique_scenarios$DOSE_U[i],
#         " for ",
#         round(unique_scenarios$EXP_LENGTH[i]*24, digits = 2),
#         "h in ",
#         unique_scenarios$SAMPLING_MATRIX[i], ")")) +
#       geom_point(data = relconc, aes(TIME*24,CONCENTRATION)) +
#       theme(plot.title = element_text(face = 'bold', size = 20),
#         axis.title.x = element_text(face = 'bold', size = 20),
#         axis.text.x = element_text(size=16),
#         axis.title.y = element_text(face = 'bold', size = 20),
#         axis.text.y = element_text(size = 16),
#         legend.title = element_text(face = 'bold', size = 16),
#         legend.text = element_text(face = 'bold',size = 14))+
#       theme_bw()
#     }
# }

## ----init_dataset, eval = execute.vignette------------------------------------
# # Creation of simulated vs. observed concentration dataset
# unique_scenarios$RSQD <- 0
# unique_scenarios$RMSE <- 0
# unique_scenarios$AIC <- 0
# simobslist <- list()
# obvpredlist <- list()

## ----merge_datasets, eval = execute.vignette----------------------------------
# for(i in 1:length(simlist))
# {
#   obsdata <- as.data.frame(obslist[[i]])
#   simdata <- as.data.frame(simlist[[i]])
# # skips over anything for which there was no observed data or
# # insufficient information to run simulation:
#   if (!is.null(simdata) &
#       !is.null(obsdata) &
#       dim(simdata)[1]>1)
#   {
# # Make sure we are looking at consistent time points:
#     simobscomb <- simdata[simdata$time %in% signif(obsdata$TIME,4),]
#     obsdata <- subset(obsdata,signif(TIME,4) %in% simobscomb$time)
# # Merge with obsdata
#     colnames(obsdata)[colnames(obsdata) ==
#       "TIME"] <-
#       "obstime"
# # Round to match sim time:
#     obsdata$time <- signif(obsdata$obstime,4)
#     colnames(obsdata)[colnames(obsdata) ==
#       "CONCENTRATION"] <-
#       "obsconc"
#     colnames(obsdata)[colnames(obsdata) ==
#       "PREFERRED_NAME"] <-
#       "chem"
#     colnames(obsdata)[colnames(obsdata) ==
#       "DOSE"] <-
#       "dose"
#     colnames(obsdata)[colnames(obsdata) ==
#       "EXP_LENGTH"] <-
#       "explen"
#     colnames(obsdata)[colnames(obsdata) ==
#       "CONC_SPECIES"] <-
#       "species"
#     colnames(obsdata)[colnames(obsdata) ==
#       "SAMPLING_MATRIX"] <-
#       "matrix"
#     colnames(obsdata)[colnames(obsdata) ==
#       "AVERAGE_MASS"] <-
#       "mw"
#     colnames(obsdata)[colnames(obsdata) ==
#       "CONC_U"] <-
#       "CONC_U"
#     simobscomb <- suppressWarnings(merge(obsdata[,c(
#       "time",
#       "obstime",
#       "obsconc",
#       "chem",
#       "dose",
#       "explen",
#       "species",
#       "matrix",
#       "mw",
#       "CONC_U",
#       "ORIGINAL_CONC_U"
#       )], simobscomb, by="time", all.x=TRUE))
# 
# # Merge with met_data
#     this.met_data <- subset(met_data,
#       PREFERRED_NAME == simobscomb[1,"chem"] &
#       SPECIES == simobscomb[1,"species"])
#     colnames(this.met_data)[colnames(this.met_data)=="CHEM_CLASS"] <-
#       "chemclass"
#     colnames(this.met_data)[colnames(this.met_data) ==
#       "OCTANOL_WATER_PARTITION_LOGP_OPERA_PRED"] <-
#       "logp"
#     colnames(this.met_data)[colnames(this.met_data) ==
#       "WATER_SOLUBILITY_MOL.L_OPERA_PRED"] <-
#       "sol"
#     colnames(this.met_data)[colnames(this.met_data) ==
#       "HENRYS_LAW_ATM.M3.MOLE_OPERA_PRED"] <-
#       "henry"
#     colnames(this.met_data)[colnames(this.met_data) ==
#       "VMAX"] <-
#       "vmax"
#     colnames(this.met_data)[colnames(this.met_data) ==
#       "KM"] <-
#       "km"
#     simobscomb <- suppressWarnings(cbind(simobscomb,this.met_data[c(
#       "chemclass",
#       "logp",
#       "sol",
#       "henry",
#       "vmax",
#       "km")]))
#     simobslist[[i]] <- simobscomb
#   }
# }

## ----time_quartile, eval = execute.vignette-----------------------------------
# for(i in 1:length(simobslist))
#   if (!is.null(simobslist[[i]]))
#   {
#     simobscomb <- simobslist[[i]]
#     for (j in 1:nrow(simobscomb))
#     {
#       max.time <- max(simobscomb$time,na.rm=TRUE)
#       if (is.na(max.time)) simobscomb$tquart <- NA
#       else if (max.time == 0) simobscomb$tquart <- "1"
#       else if (!is.na(simobscomb$time[j]))
#       {
#         simobscomb$tquart[j] <- as.character(1 +
#           floor(simobscomb$time[j]/max.time/0.25))
#         simobscomb$tquart[simobscomb$tquart=="5"] <-
#           "4"
#       } else simobscomb$tquart[j] >- NA
#     }
#     simobslist[[i]] <- simobscomb
#   }

## ----calc_AUC, eval = execute.vignette----------------------------------------
# for(i in 1:length(simobslist))
#   if (!is.null(simobslist[[i]]))
#   {
#     simobscomb <- simobslist[[i]]
# # Calculat the AUC with the trapezoidal rule:
#     if (nrow(simobscomb)>1)
#     {
#       for (k in 2:max(nrow(simobscomb)-1,2,na.rm=TRUE))
#       {
#         simobscomb$obsAUCtrap[1] <- 0
#         simobscomb$simAUCtrap[1] <- 0
#         if (min(simobscomb$time) <= (simobscomb$explen[1]*1.03) &
#             nrow(simobscomb) >=2)
#         {
#           simobscomb$obsAUCtrap[k] <- simobscomb$obsAUCtrap[k-1] +
#             0.5*(simobscomb$time[k] - simobscomb$time[k-1]) *
#             (simobscomb$obsconc[k] + simobscomb$obsconc[k-1])
#           simobscomb$simAUCtrap[k] <- simobscomb$simAUCtrap[k-1] +
#             0.5*(simobscomb$time[k]-simobscomb$time[k-1]) *
#             (simobscomb$simconc[k] + simobscomb$simconc[k-1])
#         } else {
#           simobscomb$obsAUCtrap <- 0
#           simobscomb$simAUCtrap <- 0
#         }
#       }
#     } else {
#       simobscomb$obsAUCtrap <- 0
#       simobscomb$simAUCtrap <- 0
#     }
#     simobscomb$AUCobs <- max(simobscomb$obsAUCtrap)
#     simobscomb$AUCsim <- max(simobscomb$simAUCtrap)
#     simobscomb$calcAUC <- max(simobscomb$AUC)
#     if (min(simobscomb$time) <= simobscomb$explen[1]*1.03)
#     {
#       simobscomb$Cmaxobs <- max(simobscomb$obsconc)
#       simobscomb$Cmaxsim <- max(simobscomb$simconc)
#     } else {
#       simobscomb$Cmaxobs <- 0
#       simobscomb$Cmaxsim <- 0
#     }
#     simobslist[[i]] <- simobscomb
#   }

## ----calc_error, eval = execute.vignette--------------------------------------
# for(i in 1:length(simobslist))
#   if (!is.null(simobslist[[i]]))
#   {
#     simobscomb <- simobslist[[i]]
#     unique_scenarios$RSQD[i] <- 1 - (
#       sum((simobscomb$obsconc - simobscomb$simconc)^2) /
#       sum((simobscomb$obsconc-mean(simobscomb$obsconc))^2)
#       )
#     unique_scenarios$RMSE[i] <-
#       sqrt(mean((simobscomb$simconc - simobscomb$obsconc)^2))
#     unique_scenarios$AIC[i] <-
#       nrow(simobscomb)*(
#         log(2*pi) + 1 +
#         log((sum((simobscomb$obsconc-simobscomb$simconc)^2) /
#           nrow(simobscomb)))
#       ) + ((44+1)*2) #44 is the number of parameters from inhalation_inits.R
#     simobslist[[i]] <- simobscomb
#   }

## ----combine_studies, eval = execute.vignette---------------------------------
# obsvpredlist <- list()
# for(i in 1:length(simobslist))
#   if (!is.null(simobslist[[i]]))
#   {
#     simobscomb <- simobslist[[i]]
#     obsvpredlist[[i]] <- ggplot(simobscomb, aes(x = simconc, y = obsconc)) +
#       geom_point() +
#       geom_abline() +
#       xlab("Simulated Concentrations (uM)") +
#       ylab("Observed Concentrations (uM)") +
#       ggtitle(paste0(
#         unique_scenarios$PREFERRED_NAME[i],
#         " (",
#         unique_scenarios$CONC_SPECIES[i],
#         ", ",
#         round(as.numeric(unique_scenarios$DOSE[i]), digits = 2),
#         unique_scenarios$DOSE_U[i],
#         " for ",
#         round(unique_scenarios$EXP_LENGTH[i]*24, digits = 2),
#         "h in ",
#         unique_scenarios$SAMPLING_MATRIX[i], ")")) +
#       theme_bw() +
#       theme(plot.title = element_text(face = 'bold', size = 20),
#         axis.title.x = element_text(face = 'bold', size = 20),
#         axis.text.x = element_text(size=16),
#         axis.title.y = element_text(face = 'bold', size = 20),
#         axis.text.y = element_text(size = 16),
#         legend.title = element_text(face = 'bold', size = 16),
#         legend.text = element_text(face = 'bold',size = 14))
#   }

## ----obsvspredplots, eval = execute.vignette----------------------------------
# # Create pdfs of observed vs. predicted concentration plots
# pdf(paste0(LOC.WD,"obvpredplots.pdf"), width = 10, height = 10)
# for (i in 1:length(obsvpredlist)) {
#   print(obsvpredlist[[i]])
# }
# dev.off()

## ----annotate_study_stats, eval = execute.vignette----------------------------
# for (i in 1:length(cvtlist))
#   if (!is.null(cvtlist[[i]]))
# {
#   cvtlist[[i]] <- cvtlist[[i]] +
#     geom_text(
#       x = Inf,
#       y = Inf,
#       hjust = 1.3,
#       vjust = 1.3,
# #      size = 6,
#       label = paste0(
#         "RMSE: ",
#         round(unique_scenarios$RMSE[i],digits = 2),
#         "\nAIC: ",
#         round(unique_scenarios$AIC[i],digits = 2)))# +
# #    theme(
# #      plot.title = element_text(face = 'bold', size = 15),
# #      axis.title.x = element_text(face = 'bold', size = 20),
# #      axis.text.x = element_text(size=16),
# #      axis.title.y = element_text(face = 'bold', size = 20),
# #      axis.text.y = element_text(size = 16),
# #      legend.title = element_text(face = 'bold', size = 16),
# #      legend.text = element_text(face = 'bold',size = 14))
# }

## ----cvtplots, eval = execute.vignette----------------------------------------
# # Create pdfs of simulated concentration-time plots against observed c-t values
# pdf(paste0(LOC.WD,"simdataplots.pdf"))
# for (i in 1:length(cvtlist)) {
#   print(cvtlist[[i]])
# }
# dev.off()

## ----combine_obs_vs_pred, eval = execute.vignette-----------------------------
# simobsfull <- do.call("rbind",simobslist)
# simobsfullrat <- subset(simobsfull, simobsfull$species == "Rat")
# simobsfullhum <- subset(simobsfull, simobsfull$species == "Human")
# unique_scenarios <- subset(unique_scenarios,!is.na(unique_scenarios$RSQD))

## ----Standardize Units, eval = FALSE------------------------------------------
# these.chems <- unique(subset(simobsfull,unit=="ppmv")$chem)
# for (this.chem in these.chems)
# {
#   # Use HTTK unit conversion:
#   this.factor <- convert_units(
#     input.units="ppmv", output.units="um", chem.name=this.chem, state="gas")
# 
#   # Scale the observation
#   simobsfull[simobsfull$chem==this.chem &
#               simobsfull$unit=="ppmv","obsconc"] <-
#     this.factor * simobsfull[
#       simobsfull$chem==this.chem &
#         simobsfull$unit=="ppmv","obsconc"]
#   # Scale the prediction
#   simobsfull[simobsfull$chem==this.chem &
#               simobsfull$unit=="ppmv","simconc"] <-
#     this.factor * simobsfull[
#       simobsfull$chem==this.chem &
#         simobsfull$unit=="ppmv","simconc"]
#   # Change the reported unit
#   simobsfull[simobsfull$chem==this.chem &
#               simobsfull$unit=="ppmv","unit"] <-
#     "uM"
# }

## ----regression, eval = execute.vignette--------------------------------------
# table(unique_scenarios$CONC_SPECIES)
# nrow(simobsfull) - nrow(simobsfull[
#   !is.na(simobsfull$simconc) &
#   simobsfull$simconc > 0 &
#   simobsfull$obsconc > 0,])
# pmiss <- (nrow(simobsfull) -
#   nrow(simobsfull[
#     !is.na(simobsfull$simconc) &
#     simobsfull$simconc > 0 &
#     simobsfull$obsconc > 0,])) /
#   nrow(simobsfull) * 100
# missdata <- (simobsfull[
#   is.na(simobsfull$simconc) |
#   simobsfull$simconc <= 0 |
#   simobsfull$obsconc <= 0,])
# t0df <- simobsfull[simobsfull$obstime == 0,]
# lmall <- lm(
# #log transforms:
#   log10(simobsfull$obsconc[
#     !is.na(simobsfull$simconc) &
#     simobsfull$simconc > 0 &
#     simobsfull$obsconc > 0]) ~
# #log transforms:
#   log10(simobsfull$simconc[
#     !is.na(simobsfull$simconc) &
#     simobsfull$simconc > 0 &
#     simobsfull$obsconc > 0]))
# #Linear binned 1
# lmsub1 <- lm(
#   simobsfull$obsconc[
#     !is.na(simobsfull$simconc) &
#     simobsfull$simconc > 0 &
#     simobsfull$obsconc < 0.1] ~
#   simobsfull$simconc[
#     !is.na(simobsfull$simconc) &
#     simobsfull$simconc > 0 &
#     simobsfull$obsconc < 0.1])
# #Linear binned 2
# lmsub2 <- lm(
#   simobsfull$obsconc[
#     !is.na(simobsfull$simconc) &
#     simobsfull$simconc > 0 &
#     simobsfull$obsconc >= 0.1 &
#     simobsfull$obsconc < 10] ~
#   simobsfull$simconc[
#     !is.na(simobsfull$simconc) &
#     simobsfull$simconc > 0 &
#     simobsfull$obsconc >= 0.1 &
#     simobsfull$obsconc < 10])
# #Linear binned 3
# lmsub3 <- lm(
#   simobsfull$obsconc[
#     !is.na(simobsfull$simconc) &
#     simobsfull$simconc > 0 &
#     simobsfull$obsconc >= 10] ~
#   simobsfull$simconc[
#     !is.na(simobsfull$simconc) &
#     simobsfull$simconc > 0 &
#     simobsfull$obsconc >= 10])
# lmrat <- lm(
#   log10(simobsfullrat$obsconc[
#     !is.na(simobsfullrat$simconc) &
#     simobsfullrat$simconc > 0 &
#     simobsfullrat$obsconc > 0]) ~
#   log10(simobsfullrat$simconc[
#     !is.na(simobsfullrat$simconc) &
#     simobsfullrat$simconc > 0 &
#     simobsfullrat$obsconc > 0]))
# unique(simobsfullrat$chem)
# lmhum <- lm(
#   log10(simobsfullhum$obsconc[
#     !is.na(simobsfullhum$simconc) &
#     simobsfullhum$simconc > 0 &
#     simobsfullhum$obsconc > 0]) ~
#   log10(simobsfullhum$simconc[
#     !is.na(simobsfullhum$simconc) &
#     simobsfullhum$simconc > 0 &
#     simobsfullhum$obsconc > 0]))
# unique(simobsfullhum$chem)
# concregslope <- summary(lmall)$coef[2,1]
# concregr2 <- summary(lmall)$r.squared
# concregrmse <- sqrt(mean(lmall$residuals^2))
# totalrmse <- sqrt(mean((
#   log10(simobsfull$simconc[
#     !is.na(simobsfull$simconc) &
#     simobsfull$simconc > 0 &
#     simobsfull$obsconc > 0]) -
#   log10(simobsfull$obsconc[
#     !is.na(simobsfull$simconc) &
#     simobsfull$simconc > 0 &
#     simobsfull$obsconc > 0]))^2,
#    na.rm = TRUE))
# totalmae <- mean(abs(
#   log10(simobsfull$simconc[
#     !is.na(simobsfull$simconc) &
#     simobsfull$simconc > 0 &
#     simobsfull$obsconc > 0]) -
#   log10(simobsfull$obsconc[
#     !is.na(simobsfull$simconc) &
#     simobsfull$simconc > 0 &
#     simobsfull$obsconc > 0])),
#   na.rm = TRUE)
# totalaic <- nrow(
#   simobsfull[
#     !is.na(simobsfull$simconc) &
#     simobsfull$simconc >0 &
#     simobsfull$obsconc >
#     0,]) *
#   (log(2*pi) +
#      1 +
#      log((sum(
#        (simobsfull$obsconc[
#          !is.na(simobsfull$simconc) &
#          simobsfull$simconc > 0 &
#          simobsfull$obsconc > 0] -
#        simobsfull$simconc[
#          !is.na(simobsfull$simconc) &
#          simobsfull$simconc > 0 &
#          simobsfull$obsconc > 0])^2,
#        na.rm=TRUE) /
#      nrow(simobsfull[
#        !is.na(simobsfull$simconc) &
#        simobsfull$simconc > 0 &
#        simobsfull$obsconc > 0,])))) +
#   ((44+1)*2) #44 is the number of parameters from inhalation_inits.R
# mispred <- table(abs(
#   log10(simobsfull$simconc) -
#   log10(simobsfull$obsconc))>2 &
#   simobsfull$simconc>0)
# mispred[2]
# mispred[2] / nrow(simobsfull[
#   !is.na(simobsfull$simconc) &
#     simobsfull$simconc >0 &
#     simobsfull$obsconc > 0,])*100
# overpred <- table(
#   log10(simobsfull$simconc) -
#   log10(simobsfull$obsconc)>2 &
#   simobsfull$simconc>0)
# overpred[2]
# overpred[2] / nrow(simobsfull[
#   !is.na(simobsfull$simconc) &
#   simobsfull$simconc >0 &
#   simobsfull$obsconc > 0,])*100
# underpred <- table(
#   log10(simobsfull$obsconc) -
#   log10(simobsfull$simconc)>2 &
#   simobsfull$simconc>0)
# underpred[2]
# underpred[2] / nrow(simobsfull[
#   !is.na(simobsfull$simconc) &
#   simobsfull$simconc >0 &
#   simobsfull$obsconc > 0,])*100
# mispredhalf <- table(abs(
#   log10(simobsfull$simconc) -
#   log10(simobsfull$obsconc))>0.5 &
#   simobsfull$simconc>0)
# mispredhalf[2]
# mispredhalf[2] / nrow(simobsfull[
#   !is.na(simobsfull$simconc) &
#   simobsfull$simconc >0 &
#   simobsfull$obsconc > 0,])*100
# overpredhalf <- table(
#   log10(simobsfull$simconc) -
#   log10(simobsfull$obsconc)>0.5 &
#   simobsfull$simconc>0)
# overpredhalf[2]
# overpredhalf[2] / nrow(simobsfull[
#   !is.na(simobsfull$simconc) &
#   simobsfull$simconc >0 &
#   simobsfull$obsconc > 0,])*100
# underpredhalf <- table(
#   log10(simobsfull$obsconc) -
#   log10(simobsfull$simconc)>0.5 &
#   simobsfull$simconc>0)
# underpredhalf[2]
# underpredhalf[2] / nrow(simobsfull[
#   !is.na(simobsfull$simconc) &
#   simobsfull$simconc > 0 &
#   simobsfull$obsconc > 0,])*100
# chemunderpred <- subset(simobsfull,
#   log10(simobsfull$simconc) -
#   log10(simobsfull$obsconc) < 0 &
#   simobsfull$simconc > 0)
# table(chemunderpred$chemclass) / table(simobsfull$chemclass)*100

## ----obspredFig2, eval = execute.vignette-------------------------------------
# fig2 <- ggplot(
#   data = simobsfull[
#     simobsfull$simconc > 0 &
#     simobsfull$obsconc > 0,],
#   aes(x = log10(simconc), y = log10(obsconc))) +
#   geom_point(
#     color = ifelse(
#       abs(
#         log10(simobsfull[
#           simobsfull$simconc > 0 &
#           simobsfull$obsconc > 0,]$simconc) -
#         log10(simobsfull[
#           simobsfull$simconc > 0 &
#           simobsfull$obsconc > 0,]$obsconc)) >2,
#       'red',
#       'black')) +
#   geom_abline() +
#   xlab("Log(Simulated Concentrations)") +
#   ylab("Log(Observed Concentrations)") +
#   theme_bw() +
#   geom_smooth(method = 'lm',se = FALSE, aes(color = 'Overall')) +
#   geom_smooth(method = 'lm', se = FALSE, aes(color = species)) +
#   geom_text(
#     x = Inf,
#     y = -Inf,
#     hjust = 1.05,
#     vjust = -0.15,
#     size = 8,
#     label = paste0(
#   #    "Regression slope: ",
# #      round(summary(lmall)$coef[2,1],digits = 2),
#       "\nRegression R^2: ",
#       round(summary(lmall)$r.squared,digits = 2),
#       "\nRegression RMSE: ",
#       round(sqrt(mean(lmall$residuals^2)),digits = 2),
#       "\nRMSE (Identity): ",
#       round(totalrmse,digits = 2)
#  #     "\n% Missing:",
# #      round(pmiss, digits = 2), "%")
#     )) +
#   #geom_text(
#   #  data = simobsfull[
#   #    abs(log10(simobsfull$simconc) - log10(simobsfull$obsconc))>7 &
#   #    simobsfull$simconc>0 & simobsfull$obsconc > 0,],
#   #  aes(label = paste(chem,species,matrix)),
#    ## fontface = 'bold',
#   #  check_overlap = TRUE,
# #    size = 3.5,
#   #  hjust = 0.5,
#   #  vjust = -0.8) +
#   scale_color_discrete(name = 'Species', breaks = c("Overall","Human","Rat")) +
#   theme(
#     plot.title = element_text(face = 'bold', size = 15),
#     axis.title.x = element_text(face = 'bold', size = 30),
#     axis.text.x = element_text(size=16),
#     axis.title.y = element_text(face = 'bold', size = 30),
#     axis.text.y = element_text(size = 16),
#     legend.title = element_text(face = 'bold', size = 24),
#     legend.text = element_text(face = 'bold',size = 24))
# fig2 #Display plot in R

## ----make_how_to_add_models_version, eval=execute.vignette--------------------
# font.size.large <- 10
# font.size.small <- 8
# 
# figaddmodels <- ggplot(
#   data = simobsfull[
#     simobsfull$simconc > 0 &
#     simobsfull$obsconc > 0,],
#   aes(x = simconc, y = obsconc)) +
#   geom_point(
#     color = ifelse(
#       abs(
#         log10(simobsfull[
#           simobsfull$simconc > 0 &
#           simobsfull$obsconc > 0,]$simconc) -
#         log10(simobsfull[
#           simobsfull$simconc > 0 &
#           simobsfull$obsconc > 0,]$obsconc)) >2,
#       'red',
#       'black'),alpha=0.15) +
#   geom_abline() +
#   scale_y_log10(label=label_log(), limits=c(1e-4,1e4))+
#   scale_x_log10(label=label_log(), limits=c(1e-4,1e4))+
#   xlab("Simulated Concentrations") +
#   ylab("Observed Concentrations") +
#   theme_bw() +
#   geom_smooth(method = 'lm',se = FALSE, aes(color = 'Overall', linetype="Overall")) +
#   geom_smooth(method = 'lm', se = FALSE, aes(color = species, linetype = species)) +
#   geom_text(
#     x = 2,
#     y = -1,
#     size = 4,
#     label = paste0("RMSLE: ",
#             round(totalrmse,digits = 2)
#             )) +
#   scale_color_discrete(name = 'Species', breaks = c("Overall","Human","Rat")) +
#   scale_linetype_discrete(name = 'Species', breaks = c("Overall","Human","Rat")) +
#   theme(
#     plot.title = element_text(face = 'bold', size = font.size.small),
#     axis.title.x = element_text(face = 'bold', size = font.size.large),
#     axis.text.x = element_text(size=font.size.small),
#     axis.title.y = element_text(face = 'bold', size = font.size.large),
#     axis.text.y = element_text(size = font.size.small),
#     legend.title = element_text(face = 'bold', size = font.size.large),
#     legend.text = element_text(face = 'bold',size = font.size.large))
# print(figaddmodels)
# ggsave(paste0(LOC.WD,"AddModelsFig1.tiff"), width=6, height=4, dpi=300)
# 
# counts <- simobsfull[,c("chem","dose","explen","species")]
# counts <- subset(counts,!duplicated(counts))
# paste(length(unique(counts$chem)),
#       "chemicals across",dim(counts)[1],
#       "experimental conditions in",
#       length(unique(counts$species)),"species.")

## ----write_figure2, eval = FALSE----------------------------------------------
# pdf(paste0(LOC.WD,"Figure2.pdf"), width = 10, height = 10)
# print(fig2)
# dev.off()

## ----calculations, eval = execute.vignette------------------------------------
# # Create data and run calculations for populating plots
# cmaxfull <- subset(simobsfull, !duplicated(simobsfull$AUCobs) & simobsfull$Cmaxobs != 0)
# cmaxobs <- cmaxfull$Cmaxobs
# cmaxsim <- cmaxfull$Cmaxsim
# cmaxobs <- cmaxobs[!is.nan(cmaxsim)]
# cmaxsim <- cmaxsim[!is.nan(cmaxsim)]
# cmaxsim[!is.finite(log10(cmaxsim))] <- NA
# cmaxlm <- lm(log10(cmaxobs)~log10(cmaxsim), na.action = na.exclude)
# cmaxvcbkg <- subset(cmaxfull,
#   paste(
#     cmaxfull$chem,
#     cmaxfull$dose,
#     cmaxfull$explen,
#     cmaxfull$species,
#     cmaxfull$matrix) %in%
#   paste(
#     t0df$chem,
#     t0df$dose,
#     t0df$explen,
#     t0df$species,
#     t0df$matrix))
# cmaxvcbkg$cmaxcbkgratio <- cmaxvcbkg$Cmaxobs / cmaxvcbkg$obsconc
# cmaxvcbkg$adjustedCmaxsim <- cmaxvcbkg$Cmaxsim - cmaxvcbkg$obsconc
# aucfull <-subset(simobsfull,
#   !duplicated(simobsfull$AUCobs) &
#   simobsfull$AUCobs != 0)
# aucobs <- aucfull$AUCobs
# aucsim <- aucfull$AUCsim
# aucobs <- aucobs[!is.nan(aucsim)]
# aucsim <- aucsim[!is.nan(aucsim)]
# aucsim[!is.finite(log10(aucsim))] <- NA
# auclm <- lm(log10(aucobs)~log10(aucsim), na.action = na.exclude)
# cmaxslope <- summary(cmaxlm)$coef[2,1]
# cmaxrsq <- summary(cmaxlm)$r.squared
# totalrmsecmax <- sqrt(mean((log10(cmaxfull$Cmaxsim) -
#   log10(cmaxfull$Cmaxobs))^2, na.rm = TRUE))
# cmaxmiss <- nrow(cmaxfull[
#   abs(log10(cmaxfull$Cmaxsim) -
#   log10(cmaxfull$Cmaxobs)) > 1,])
# cmaxmissp <- nrow(cmaxfull[
#   abs(log10(cmaxfull$Cmaxsim) -
#   log10(cmaxfull$Cmaxobs)) > 1,]) /
#   nrow(cmaxfull) * 100
# cmaxmisschem <- table(cmaxfull[
#   abs(log10(cmaxfull$Cmaxsim) -
#   log10(cmaxfull$Cmaxobs)) > 1,]$chem)
# aucslope <- summary(auclm)$coef[2,1]
# aucrsq <- summary(auclm)$r.squared
# totalrmseauc <- sqrt(mean((
#   log10(aucfull$AUCsim) -
#   log10(aucfull$AUCobs))^2, na.rm = TRUE))
# aucmiss <- nrow(aucfull[
#   abs(log10(aucfull$AUCsim) -
#   log10(aucfull$AUCobs)) > 1,])
# aucmissp <- nrow(aucfull[
#   abs(log10(aucfull$AUCsim) -
#   log10(aucfull$AUCobs)) > 1,]) /
#   nrow(aucfull) * 100
# aucmisschem <- table(aucfull[
#   abs(log10(aucfull$AUCsim) -
#   log10(aucfull$AUCobs)) > 1,]$chem)

## ----Fig4plot, eval = execute.vignette----------------------------------------
# cmaxp <- ggplot(data = cmaxfull, aes(x = log10(Cmaxsim), y = log10(Cmaxobs))) +
#   geom_point(color =
#     ifelse(abs(log10(cmaxfull$Cmaxsim)  -log10(cmaxfull$Cmaxobs))>=2, "red","black"))  +
#   geom_abline()  +
#   xlab("Log(Simulated Max Concentration)") +
#   ylab("Log(Observed Max Concentration)") +
#   theme_bw() +
#   geom_smooth(method = 'lm', se = FALSE, aes(color = 'Overall')) +
#   geom_smooth(method = 'lm', se = FALSE, aes(color = species)) +
#   geom_text(x = Inf,
#     y = -Inf,
#     hjust = 1.05,
#     vjust = -0.15,
# #    size = 6,
#     label = paste0("Regression slope: ",
#       round(summary(cmaxlm)$coef[2,1],digits = 2),
#       "\nRegression R^2: ",
#       round(summary(cmaxlm)$r.squared,digits = 2))) +
#   geom_text_repel(
#     data = cmaxfull[
#       (log10(cmaxfull$Cmaxsim)-log10(cmaxfull$Cmaxobs))>=2 &
#       log10(cmaxfull$Cmaxsim) > 2,],
#     aes(label = paste(chem,species,matrix)),
#     force = 2,
#  #   size = 5.3,
#     fontface = 'bold',
#     color = 'black',
#     hjust = -0.05,
#     vjust = 0.5) +
#   scale_y_continuous(lim = c (-1,5)) +
#   scale_x_continuous(lim = c(-1,5)) +
#   geom_text_repel(
#     data = cmaxfull[
#       (log10(cmaxfull$Cmaxsim)-log10(cmaxfull$Cmaxobs))>=2 &
#       log10(cmaxfull$Cmaxsim) <= 2,],
#     aes(label = paste(chem,species,matrix)),
#     nudge_x = 0.0,
#     nudge_y = -0.2,
#     force = 2,
# #    size = 5.3,
#     fontface = 'bold',
#     color = 'black',
#     hjust = -0.05,
#     vjust = 0.5) +
#   geom_text(
#     data = cmaxfull[
#       (log10(cmaxfull$Cmaxsim)-log10(cmaxfull$Cmaxobs))<=-2,],
#     aes(label = paste(chem,species,matrix)),
# #    size = 5.3,
#     fontface = 'bold',
#     color = 'black',
#     hjust = 0.5,
#     vjust = -0.7) +
#   scale_color_discrete(
#     name = 'Species',
#     breaks = c("Overall","Human","Rat")) #+
# #  theme(plot.title = element_text(face = 'bold', size = 10),
# #    axis.title.x = element_text(face = 'bold', size = 10),
# #    axis.text.x = element_text(size=8),
# #    axis.title.y = element_text(face = 'bold', size = 10),
# #    axis.text.y = element_text(size = 8),
# #    legend.title = element_text(face = 'bold', size = 8),
# #    legend.text = element_text(face = 'bold',size = 8))
# cmaxp
# aucp <- ggplot(
#   data = aucfull,
#   aes(x = log10(AUCsim), y = log10(AUCobs))) +
#   geom_point(color =
#     ifelse(abs(log10(aucfull$AUCsim)-log10(aucfull$AUCobs))>=2, "red","black"))  +
#   geom_abline()  +
#   xlab("Log(Simulated AUC)") +
#   ylab("Log(Observed AUC)") +
#   theme_bw() +
#   geom_smooth(method = 'lm', se = FALSE, aes(color = "Overall")) +
#   geom_smooth(method = 'lm', se = FALSE, aes(color = species)) +
#   geom_text(
#     x = Inf,
#     y = -Inf,
#     hjust = 1.05,
#     vjust = -0.15,
# #    size = 6,
#     label = paste0(
#       "Regression slope: ",
#       round(summary(auclm)$coef[2,1],digits = 2),
#       "\nRegression R^2: ",
#       round(summary(auclm)$r.squared,digits = 2))) +
#   geom_text_repel(
#     data = aucfull[(log10(aucfull$AUCsim)-log10(aucfull$AUCobs))>=2,],
#     aes(label = paste(chem,species,matrix)),
# #    size = 5.3,
#     fontface = 'bold',
#     color = 'black',
#     hjust = -0.05,
#     vjust = 0.5) +
#   scale_y_continuous(lim = c (-2,4)) +
#   scale_x_continuous(lim = c(-2,4)) +
#   geom_text(
#     data = aucfull[(log10(aucfull$AUCsim)-log10(aucfull$AUCobs))<=-2,],
#     aes(label = paste(chem,species,matrix)),
# #    size = 5.3,
#     fontface = 'bold',
#     color = 'black',
#     hjust = 0.5,
#     vjust = -0.8) +
#   scale_color_discrete(name = 'Species', breaks = c("Overall","Human","Rat")) #+
# #  theme(
# #    plot.title = element_text(face = 'bold', size = 15),
# #    axis.title.x = element_text(face = 'bold', size = 20),
# #    axis.text.x = element_text(size=16),
# #    axis.title.y = element_text(face = 'bold', size = 20),
# #    axis.text.y = element_text(size = 16),
# #    legend.title = element_text(face = 'bold', size = 16),
# #    legend.text = element_text(face = 'bold',size = 14))
# aucp

## ----write_figure4, eval = execute.vignette-----------------------------------
# pdf(paste0(LOC.WD,"Figure4.pdf"), width = 20, height = 10)
# plot_grid(cmaxp,aucp,nrow = 1, labels = c('A','B'), label_size = 30)
# dev.off()

## ----Fig3plot, eval = execute.vignette----------------------------------------
# simobsfull$aggscen <- as.factor(paste(simobsfull$chem,
#   simobsfull$species,
#   simobsfull$matrix))
# chem.lm <- lm(
#   log10(simconc) - log10(obsconc) ~
#   aggscen,
#   data = simobsfull[simobsfull$simconc >0 & simobsfull$obsconc > 0,])
# chem.res <- resid(chem.lm)
# # Number of observations per chemical class
# numpt <- simobsfull[simobsfull$simconc >0 & simobsfull$obsconc > 0,] %>%
#   group_by(chemclass) %>% summarize(n = paste("n =", length(simconc)))
# fig3 <- ggplot(
#   data = simobsfull[simobsfull$simconc >0 & simobsfull$obsconc > 0,],
#   aes(x = aggscen, y = log10(simconc)-log10(obsconc), fill = chemclass)) +
#   geom_boxplot() +
#   geom_hline(yintercept = 0) +
#   geom_hline(yintercept = 2, linetype = 2)+
#   geom_hline(yintercept = -2, linetype = 2)+
#   xlab("Exposure Scenario") +
#   ylab("Log(Simulated Concentration)-\nLog(Observed Concentration)\n") +
#   facet_wrap(vars(chemclass), scales = 'free_x', nrow = 1) + #35 by 12 for poster
#   theme_bw() +
#   geom_text(
#     data = numpt,
#     aes(x = Inf, y = -Inf, hjust = 1.05, vjust = -0.5, label = n),
#     size = 10,
#     colour = 'black',
#     inherit.aes = FALSE,
#     parse = FALSE) +
#   theme(
#     axis.text.x = element_text(angle = 90, hjust = 1,vjust=0.5,size = 20, face = 'bold'),
#     strip.text.x = element_text(face = 'bold', size = 24),
#     legend.position = 'none',
#     axis.title.x = element_text(face = 'bold', size = 30),
#     axis.title.y = element_text(face = 'bold', size = 30),
#     axis.text.y = element_text(face = 'bold',size = 25, color = 'black'))
# fig3

## ----write_figure3, eval = execute.vignette-----------------------------------
# pdf(paste0(LOC.WD,"Figure3.pdf"), width = 40, height = 13)
# print(fig3)
# dev.off()

## ----FigS1, eval = execute.vignette-------------------------------------------
# figs1a <- ggplot(
#     data = simobsfull[simobsfull$simconc >0 & simobsfull$obsconc > 0,],
#     aes(x = tquart, y = log10(simconc)-log10(obsconc))) +
#   geom_boxplot()+
#   geom_hline(yintercept = 0)+
#   geom_hline(yintercept = 2, linetype = 2)+
#   geom_hline(yintercept = -2, linetype = 2)+
#   xlab("\nTime Quartile\n") +
#   ylab("Log(Simulated Concentration)-\nLog(Observed Concentration)\n") +
#   theme_bw()+
#   theme(
#     axis.text.x = element_text(size = 20, face = 'bold'),
#     strip.text.x = element_text(face = 'bold', size = 20),
#     legend.position = 'none',
#     axis.title.x = element_text(face = 'bold', size = 20),
#     axis.title.y = element_text(face = 'bold', size = 20),
#     axis.text.y = element_text(size = 20, face = 'bold'))
# figs1a
# figs1b <- ggplot(
#     data = simobsfull[simobsfull$simconc >0 & simobsfull$obsconc > 0,],
#     aes(x = mw, y = log10(simconc)-log10(obsconc))) +
#   geom_point()+
#   geom_hline(yintercept = 0)+
#   geom_hline(yintercept = 2, linetype = 2)+
#   geom_hline(yintercept = -2, linetype = 2)+
#   xlab("\nMolecular Weight (g/mol)\n") +
#   ylab("\nLog(Simulated Concentration)-\nLog(Observed Concentration)\n") +
#   theme_bw()+
#   theme(
#     axis.text.x = element_text(size = 20, face = 'bold'),
#     strip.text.x = element_text(face = 'bold', size = 20),
#     legend.position = 'none',
#     axis.title.x = element_text(face = 'bold', size = 20),
#     axis.title.y = element_text(face = 'bold', size = 20),
#     axis.text.y = element_text(size = 20, face = 'bold'))
# figs1b
# figs1c <- ggplot(
#     data = simobsfull[simobsfull$simconc >0 & simobsfull$obsconc > 0,],
#     aes(x = logp, y = log10(simconc)-log10(obsconc))) +
#   geom_point()+
#   geom_hline(yintercept = 0)+
#   geom_hline(yintercept = 2, linetype = 2)+
#   geom_hline(yintercept = -2, linetype = 2)+
#   xlab("\nLog P") +
#   ylab("Log(Simulated Concentration)-\nLog(Observed Concentration)\n") +
#   theme_bw() +
#   theme(
#     axis.text.x = element_text(size = 20, face = 'bold'),
#     strip.text.x = element_text(face = 'bold', size = 20),
#     legend.position = 'none',
#     axis.title.x = element_text(face = 'bold', size = 20),
#     axis.title.y = element_text(face = 'bold', size = 20),
#     axis.text.y = element_text(size = 20, face = 'bold'))
# figs1c
# figs1d <- ggplot(
#     data = simobsfull[simobsfull$simconc >0 & simobsfull$obsconc > 0,],
#     aes(x = sol, y = log10(simconc)-log10(obsconc))) +
#   geom_point()+
#   geom_hline(yintercept = 0)+
#   geom_hline(yintercept = 2, linetype = 2)+
#   geom_hline(yintercept = -2, linetype = 2)+
#   xlab("\nSolubility (mol/L)") +
#   ylab("\nLog(Simulated Concentration)-\nLog(Observed Concentration)\n") +
#   scale_x_log10()+
#   theme_bw() +
#   theme(
#     axis.text.x = element_text(size = 20, face = 'bold'),
#     strip.text.x = element_text(face = 'bold', size = 20),
#     legend.position = 'none',
#     axis.title.x = element_text(face = 'bold', size = 20),
#     axis.title.y = element_text(face = 'bold', size = 20),
#     axis.text.y = element_text(size = 20, face = 'bold'))
# figs1d

## ----write_figures1, eval = execute.vignette----------------------------------
# pdf(paste0(LOC.WD,"FigureS1.pdf"), width = 20, height = 20)
# plot_grid(figs1a,figs1b,figs1c,figs1d,nrow = 2, labels = c('A','B','C','D'), label_size = 30)
# dev.off()

## ----SupTable2, eval = execute.vignette---------------------------------------
# senschem <- list()
# sensslope <- list()
# sensrsq <- list()
# sensregrmse <- list()
# senstotalrmse <- list()
# senspmiss <- list()
# senscmaxslope <- list()
# senscmaxrsq <- list()
# senstotalrmsecmax <- list()
# sensaucslope <- list()
# sensaucrsq <- list()
# senstotalrmseauc <- list()
# for (i in 1:nrow(simobsfull))
# {
#   simobsfullsens <- subset(simobsfull,simobsfull$chem != simobsfull$chem[i])
#   senschem[i] <- as.character(simobsfull$chem[i])
#   senslm <- lm(
#     log10(simobsfullsens$obsconc[
#       !is.na(simobsfullsens$simconc) &
#       simobsfullsens$simconc > 0 &
#       simobsfullsens$obsconc > 0]) ~
#     log10(simobsfullsens$simconc[
#       !is.na(simobsfullsens$simconc) &
#       simobsfullsens$simconc >0 &
#       simobsfullsens$obsconc > 0]))
#   sensslope[i] <- round(summary(senslm)$coef[2,1],digits = 2)
#   sensrsq[i] <- round(summary(senslm)$r.squared,digits = 2)
#   sensregrmse[i] <- round(sqrt(mean(senslm$residuals^2)),digits = 2)
#   senstotalrmse[i] <- round(sqrt(mean((
#     log10(simobsfullsens$simconc[
#       !is.na(simobsfullsens$simconc) &
#       simobsfullsens$simconc >0 &
#       simobsfullsens$obsconc > 0]) -
#     log10(simobsfullsens$obsconc[
#       !is.na(simobsfullsens$simconc) &
#         simobsfullsens$simconc >0 &
#         simobsfullsens$obsconc > 0]))^2,
#     na.rm = TRUE)), digits = 2)
#   senspmiss[i] <- round((nrow(simobsfullsens) -
#     nrow(simobsfullsens[
#       !is.na(simobsfullsens$simconc) &
#       simobsfullsens$simconc >0 &
#       simobsfullsens$obsconc > 0,])) / nrow(simobsfullsens) * 100,
#     digits = 2)
#   senscmaxfull <- subset(simobsfullsens, !duplicated(simobsfullsens$Cmaxobs))
#   senscmaxlm <- lm(
#     log10(senscmaxfull$Cmaxobs[senscmaxfull$Cmaxobs>0]) ~
#     log10(senscmaxfull$Cmaxsim[senscmaxfull$Cmaxobs>0]),
#     na.action = na.exclude)
#   sensaucfull <-subset(simobsfullsens, !duplicated(simobsfullsens$AUCobs))
#   sensauclm <- lm(
#     log10(aucfull$AUCobs[aucfull$AUCobs>0]) ~
#     log10(aucfull$AUCsim[aucfull$AUCobs>0]),
#     na.action = na.exclude)
#   senscmaxslope[i] <- round(summary(senscmaxlm)$coef[2,1],digits = 2)
#   senscmaxrsq[i] <- round(summary(senscmaxlm)$r.squared,digits = 2)
#   senstotalrmsecmax[i] <- sqrt(mean((log10(senscmaxfull$Cmaxsim[senscmaxfull$Cmaxobs>0]) - log10(senscmaxfull$Cmaxobs[senscmaxfull$Cmaxobs>0]))^2, na.rm = TRUE))
#   sensaucslope[i] <- round(summary(sensauclm)$coef[2,1],digits = 2)
#   sensaucrsq[i] <- round(summary(sensauclm)$r.squared,digits = 2)
#   senstotalrmseauc[i] <- sqrt(mean((log10(sensaucfull$AUCsim[sensaucfull$AUCobs>0]) - log10(sensaucfull$AUCobs[sensaucfull$AUCobs>0]))^2, na.rm = TRUE))
# }
# sensitivitydf <- data.frame(Chemical <- as.character(senschem),
#                             sensSlope <- as.numeric(sensslope),
#                             sensRsq <- as.numeric(sensrsq),
#                             sensRegrmse <- as.numeric(sensregrmse),
#                             sensTotrmse <- as.numeric(senstotalrmse),
#                             sensPmiss <- as.numeric(senspmiss),
#                             sensCmaxslope <- as.numeric(senscmaxslope),
#                             sensCmaxrsq <- as.numeric(senscmaxrsq),
#                             sensCmaxrmse <- as.numeric(senstotalrmsecmax),
#                             sensAUCslope <- as.numeric(sensaucslope),
#                             sensAUCrsq <- as.numeric(sensaucrsq),
#                             sensAUCrmse <- as.numeric(senstotalrmseauc),
#                             stringsAsFactors=FALSE)
# sensitivitydf <- subset(sensitivitydf,!duplicated(sensitivitydf$Chemical....as.character.senschem.))
# names(sensitivitydf) <- c('Chemical Dropped','Regression Slope','Regression R^2','Regression RMSE','Orthogonal RMSE', 'Percent Data Censored','Cmax Regression Slope','Cmax Regression R^2','Cmax Orthogonal RMSE','AUC Regression Slope','AUC Regression R^2','AUC Orthogonal RMSE')
# notdropped <- c('None',concregslope,concregr2,concregrmse,totalrmse,pmiss,cmaxslope,cmaxrsq,totalrmsecmax,aucslope,aucrsq,totalrmseauc)
# sensitivitydf <- rbind(notdropped, sensitivitydf)
# sensitivitydf[,-1] <- sapply(sensitivitydf[,-1],as.numeric)
# sensitivitydf[,-1] <- round(sensitivitydf[,-1],2)
#   # Clean up and write file
# rm(chem.lm, obvpredplot, p, pdata1, plot.data, plots, relconc, sensaucfull, sensauclm, sensaucrsq, sensaucslope, senschem, senscmaxfull, senscmaxlm, senscmaxrsq, senscmaxslope, senslm, senspmiss, sensregrmse, sensrsq, sensslope, senstotalrmse, senstotalrmseauc, senstotalrmsecmax, solve, AUCrmse, AUCrsq, AUCslope, chem.res, Chemical, Cmaxrmse, Cmaxrsq, Cmaxslope, colors, count, i, j, k, met_col, name, name1, Pmiss, Regrmse, Rsq, Slope, rem, Totrmse)
# 
# write.csv(sensitivitydf, paste0(LOC.WD,'supptab2.csv'),row.names = FALSE)

## ----SupTable1, eval = execute.vignette---------------------------------------
# supptab1 <- subset(unique_scenarios, !duplicated(unique_scenarios$PREFERRED_NAME) | !duplicated(unique_scenarios$SOURCE_CVT) | !duplicated(unique_scenarios$CONC_SPECIES))
# for(i in 1:nrow(supptab1)){
#   tryCatch({
#     supptab1$Metabolism_Source[i] <- met_data$SOURCE_MET[met_data$DTXSID %in% supptab1$DTXSID[i] & met_data$SPECIES %in% supptab1$CONC_SPECIES[i]]
#     supptab1$Log_P[i] <- met_data$OCTANOL_WATER_PARTITION_LOGP_OPERA_PRED[met_data$DTXSID %in% supptab1$DTXSID[i]& met_data$SPECIES %in% supptab1$CONC_SPECIES[i]]
#     supptab1$Solubility[i] <- met_data$WATER_SOLUBILITY_MOL.L_OPERA_PRED[met_data$DTXSID %in% supptab1$DTXSID[i]& met_data$SPECIES %in% supptab1$CONC_SPECIES[i]]
#     supptab1$Blood_Air_Partition_Coefficient[i] <- met_data$CALC_PBA[met_data$DTXSID %in% supptab1$DTXSID[i]& met_data$SPECIES %in% supptab1$CONC_SPECIES[i]]
#     supptab1$Chem_Class[i] <- met_data$CHEM_CLASS[met_data$DTXSID %in% supptab1$DTXSID[i] & met_data$SPECIES %in% supptab1$CONC_SPECIES[i]]
#     supptab1$Species[i] <- met_data$SPECIES[met_data$DTXSID %in% supptab1$DTXSID[i] & met_data$SPECIES %in% supptab1$CONC_SPECIES[i]]
#     supptab1$Vmax[i] <- met_data$VMAX[met_data$DTXSID %in% supptab1$DTXSID[i] & met_data$SPECIES %in% supptab1$CONC_SPECIES[i]]
#     supptab1$Km[i] <- met_data$KM[met_data$DTXSID %in% supptab1$DTXSID[i] & met_data$SPECIES %in% supptab1$CONC_SPECIES[i]]
#   }, error = function(e){})
# }
# supptab1 <- supptab1[c('PREFERRED_NAME','DTXSID','CASRN','Chem_Class','AVERAGE_MASS','Log_P','Solubility','Blood_Air_Partition_Coefficient','Species','Vmax','Km','Metabolism_Source','SOURCE_CVT')]
# names(supptab1) <- c('Chemical','DTXSID','CASRN','CAMEO Chemical Class','Molecular Weight (g/mol)','Log P','Solubility (mol/L)','Blood Air Partition Coefficient','Available Species Data','Vmax (pmol/min/10^6 cells)','KM (uM)','Metabolism Data Source','Concentration-Time Data Source')
# write.csv(supptab1, paste0(LOC.WD,"supptab1.csv"), row.names = FALSE)

## ----configure_knitr, eval = TRUE---------------------------------------------
knitr::opts_chunk$set(collapse = TRUE, comment = '#>')
options(rmarkdown.html_vignette.check_title = FALSE)

## ----clear_memory, eval = TRUE------------------------------------------------
rm(list=ls()) 

## ----runchunks, eval = TRUE---------------------------------------------------
# Set whether or not the following chunks will be executed (run):
execute.vignette <- FALSE

## ----load_packages, eval = execute.vignette-----------------------------------
# #
# #
# # Setup
# #
# #
# library(httk)        # run Armitage.R and Kramer.R in vitro distribution models
# library(tidyverse)   # data wrangling
# library(data.table)  # data table functionality
# library(ggplot2)     # plotting
# library(ggrepel)     # jitter labels in plots
# library(ggpubr)      # arrange plots for publication
# library(viridis)     # colorblind palette
# library(scales)      # required for label_log
# 
# #save figures and tables to working directory: yes/no
# save_output = FALSE
# 
# #for saving outputs
# data.date <- "16JUL2025"
# path_out <- "C:/Users/mscherer/OneDrive - Environmental Protection Agency (EPA)
# /Profile/Desktop/IVDManuscriptData/manuscript figures 16JUL25/"
# 

## ----rmsle_func, eval = execute.vignette--------------------------------------
# #function to calculate RMSLE
# sle <- function (actual, predicted)
# {
#     log.act <- log10(actual)
#     log.pred <- log10(predicted)
#     good <- !is.na(log.act) & is.finite(log.act) &
#             !is.na(log.pred) & is.finite(log.pred)
#     log.act <- log.act[good]
#     log.pred <- log.pred[good]
#     return((log.act - log.pred)^2)
# }
# msle <- function (actual, predicted)
# {
#     mean(sle(actual, predicted))
# }
# rmsle <-function (actual, predicted)
# {
#     sqrt(msle(actual, predicted))
# }

## ----load_IVD_Manuscript_data, eval = execute.vignette------------------------
# 
# IVD_Manuscript_data <- httk::Scherer2025.IVD
# 
# cat(paste("Summarized data from ",
#           length(unique(IVD_Manuscript_data$Citation)),
#           " studies covering ",
#           length(unique(IVD_Manuscript_data$ChemicalName)),
#           " unique chemicals ",
#           "with ",
#           length(IVD_Manuscript_data$CellConcentration_uM),
#           " observations total.",
#           sep="")
#     )
# 
# #14 studies, 43 chemicals, 153 observations
# 
# #number each row
# IVD_Manuscript_data[,X:=1:length(IVD_Manuscript_data$ChemicalName)]
# 

## ----invitrodescriptors, eval = execute.vignette------------------------------
# 
# ### Create assay_component_endpoint_name columns for assay parameters ###
# 
# #create assay_name column
# IVD_Manuscript_data[, assay_name :=
#                       gsub(", ", "", IVD_Manuscript_data$Citation)]
# 
# #create the assay_component_endpoint_name column
# IVD_Manuscript_data[, assay_component_endpoint_name :=
#                       paste("IVD", gsub(", ", "", assay_name), sep="")]
# 
# #tack on the "interesting" part for each assay to create the endpoint_name
# IVD_Manuscript_data[assay_component_endpoint_name=="IVDBellwon2015b" |
#                       assay_component_endpoint_name == "IVDBroeders2013" |
#                       assay_component_endpoint_name == "IVDWei2010",
#                     assay_component_endpoint_name :=
#                       paste(assay_component_endpoint_name, CellType, sep="_")]
# #these two have multiple concentrations or time points
# IVD_Manuscript_data[assay_component_endpoint_name=="IVDMundy2004" |
#                       assay_component_endpoint_name=="IVDLundquist2014",
#                 assay_component_endpoint_name :=
#                   paste(paste(assay_component_endpoint_name,
#                               paste(ExposureDuration_hrs, "hr", sep = ""),
#                               sep="_"), paste(FBSf, "FBSf", sep = ""),
#                         sep = "_")]
# 
# #create a copy with the assay parameters for the options table (Table S7)
# options.IVD_Manuscript_data<-data.table::copy(IVD_Manuscript_data)
# 
# ### Pull in httk assay parameter table ###
# invitro.assay.params <- data.table::copy(invitro.assay.params)
# 
# #copy the experimental data frame to pull out the parameter lines
# parameters_only<-data.table::copy(IVD_Manuscript_data)
# 
# ### Set up assay parameters to match with invitro.assay.params.RData ###
# 
# #rename columns to align with the names in invitro.assay.params.RData
# parameters_only[, timepoint_hr := ExposureDuration_hrs] %>%
#   .[, media_serum := SerumType] %>%
#   .[, cell_type := CellType]
# 
# # get the list of columns we need
# ivpnames<-names(invitro.assay.params)
# 
# #add on the extra columns to match invitro.assay.params and parameters_only
# if(!all(ivpnames%in%names(parameters_only))){
#     parameters_only[,ivpnames[!(ivpnames %in% names(parameters_only))]] <-
#       as.double(NA)}
# 
# #filter parameters_only to match up with ivpnames and only the unique rows
# parameters_only<-parameters_only %>% select(as.character(ivpnames)) %>% unique()
# 
# # reassign own parameters table to pass to armitage and kramer functions
# user_assay_parameters<-parameters_only
# # should have 29 + 1649 = 1678 rows
# 
# #remove parameter columns since we will be pulling from "user_assay_parameters"
# ivpnames[2]<-NA #remove endpoint_name bc we need to be able to reference it
# IVD_Manuscript_data[,ivpnames[(ivpnames %in% names(IVD_Manuscript_data))]]<-
#   NULL
# 

## ----run_IVD_models, eval = execute.vignette----------------------------------
# 
# # run Armitage model, output concentrations in umol/L (e.g. uM)
# armitageOutput_data.dt <- armitage_eval(tcdata=IVD_Manuscript_data,
#                                        surface.area.switch = TRUE,
#                                        user_assay_parameters =
#                                          user_assay_parameters,
#                                        restrict.ion.partitioning = TRUE)
# 
# 
# 
# # run Kramer model, output concentrations in umol/L (e.g. uM)
# kramerOutput_data.dt <- kramer_eval(tcdata=IVD_Manuscript_data,
#                                     surface.area.switch = TRUE,
#                                     user_assay_parameters =
#                                       user_assay_parameters,
#                                     restrict.ion.partitioning = TRUE)
# 

## ----manipulate_for_plotting, eval = execute.vignette-------------------------
# 
# #delete nomconc column
# Armitage.dt<-subset(armitageOutput_data.dt, select=-c(nomconc))
# 
# #pull ioc types from armitage since kramer doesn't generate them
# IOC_Type_output<-Armitage.dt[,.(ChemicalName, IOC_Type)] %>% distinct()
# 
# #delete nomconc column and add in the IOC type column for Kramer
# Kramer.dt_subset<-subset(kramerOutput_data.dt, select=-c(nomconc))
# Kramer.dt<-Kramer.dt_subset[IOC_Type_output, on = "ChemicalName"]
# 
# #delete cellconc column and add in the IOC type column for Nominal
# Nominal.dt_subset<-subset(kramerOutput_data.dt,
#                           select = -c(concentration_cells))
# Nominal.dt<-Nominal.dt_subset[IOC_Type_output, on = "ChemicalName"]
# 
# #add tags
# Armitage.dt[,label:= "Armitage"]
# Kramer.dt[,label:= "Kramer"]
# Nominal.dt[,label:= "Nominal"]
# 
# #combine data for plotting (datasets are side by side)
# combodata<-merge(Armitage.dt, kramerOutput_data.dt, by = "X", all.x = TRUE)
#   #kramer output still has nomconc values
# 
# if(save_output){
#   write.csv(combodata, file = paste0(path_out,"ManuscriptOutput_",
#                                      data.date,"_",Sys.Date(),".csv"))
# }
# 

## ----ggplot_set_up, eval = execute.vignette-----------------------------------
# 
# #set default theme elements for visually consistent manuscript plots
# personal_theme <- function(){
#   theme_bw() +
#   theme(axis.line = element_blank(),
#         panel.border = element_rect(colour = "black", linewidth=1),
#         axis.title = element_text(size = rel(1.25)),
#         axis.text = element_text(size = rel(1.15)),
#         plot.title = element_text(size = rel(1.5),
#                                   hjust = 0.5),
#         panel.grid = element_blank(),
#         legend.position = "none")
# }
# 
# #set plot colors to correspond with each chemica
# plotcolors<-scales::viridis_pal()(length(
#   unique(armitageOutput_data.dt$ChemicalName)))
# names(plotcolors)<-armitageOutput_data.dt$ChemicalName %>% unique() %>% sort()
# 

## ----joint_intracel_plot_fig2, eval = execute.vignette------------------------
# 
# #ARMITAGE:
# 
# #Armitage RMSLE:
# arm_rmsle_long<-rmsle((Armitage.dt$CellConcentration_uM),(Armitage.dt$ccells))
# arm_rmsle<-round(arm_rmsle_long, 2)
# #1.12
# 
# #Armitage r^2:
# ml_arm_overall = lm(CellConcentration_uM~ccells, data = Armitage.dt)
# summary(ml_arm_overall)$r.squared
# #0.33
# 
# #plot set up
# yrng <- range(Armitage.dt$CellConcentration_uM)
# xrng <- range(Armitage.dt$ccells)
# n_chems<-n_distinct(Nominal.dt$ChemicalName)
# n_data<-nrow(Nominal.dt)
# 
# # now plot
# Armitage_ccell<-ggplot(Armitage.dt) +
#   geom_point(aes(x=ccells, y=CellConcentration_uM, color = ChemicalName)) +
#   geom_abline(intercept=0,slope=1, linetype = "dashed") +
#   xlab(expression("Armitage Predicted "*italic("C"["cell"])~"(\u03BCM)")) +
#   ylab(expression("Experimental "*italic(" C"["cell"])~"(\u03BCM)")) +
#   scale_x_log10(lim = c(0.00001, 400000), breaks = c(10^-4, 10^0, 10^4),
#                 labels = label_log(digits = 2)) +
#   scale_y_log10(lim = c(0.00001, 400000), breaks = c(10^-4, 10^0, 10^4),
#                 labels = label_log(digits = 2)) +
#   annotate(geom = "text", x = xrng[2], y = yrng[1], parse=TRUE, label = paste(
#       "N[data] ", "~'='~", n_data), hjust = 1, vjust = 0, size = 4) +
#   annotate(geom = "text", x = xrng[2], y = yrng[1], parse=TRUE, label = paste(
#       "N[chemicals] ", "~'='~", n_chems), hjust = 1, vjust = 1.2, size = 4)+
#   annotate(geom = "text", x = xrng[2], y = yrng[1],
#            label = paste("RMSLE =", arm_rmsle),
#            hjust = 1, vjust = 3, size = 4) +
#   personal_theme() +
#   scale_color_manual(values=plotcolors)
# 
# #KRAMER:
# 
# #Kramer RMSLE:
# kram_rmsle_long<-
#   rmsle((Kramer.dt$CellConcentration_uM),(Kramer.dt$concentration_cells))
# kram_rmsle<-format(round(kram_rmsle_long, digits=2), nsmall = 2)
# #1.30
# 
# #Kramer r^2:
# ml_kram_overall = lm(CellConcentration_uM~concentration_cells, data = Kramer.dt)
# summary(ml_kram_overall)$r.squared
# #0.03
# 
# #plot
# Kramer_ccell<-ggplot(Kramer.dt)+
#   geom_point(aes(x=concentration_cells, y=CellConcentration_uM,
#                  colour = ChemicalName)) +
#   geom_abline(intercept=0,slope=1, linetype = "dashed") +
#   scale_x_log10(lim = c(0.00001, 400000), breaks = c(10^-4, 10^0, 10^4),
#                 labels = label_log(digits = 2)) +
#   scale_y_log10(lim = c(0.00001, 400000), breaks = c(10^-4, 10^0, 10^4),
#                 labels = label_log(digits = 2)) +
#   xlab(expression("Kramer Predicted "*italic("C"["cell"])~"(\u03BCM)")) +
#   ylab(expression("Experimental "*italic(" C"["cell"])~"(\u03BCM)")) +
#   annotate(geom = "text", x = xrng[2], y = yrng[1], parse=TRUE, label = paste(
#       "N[data] ", "~'='~", n_data), hjust = 1, vjust = 0, size = 4) +
#   annotate(geom = "text", x = xrng[2], y = yrng[1], parse=TRUE, label = paste(
#       "N[chemicals] ", "~'='~", n_chems), hjust = 1, vjust = 1.2, size = 4)+
#   annotate(geom = "text", x = xrng[2], y = yrng[1],
#   label = paste("RMSLE =", kram_rmsle), hjust = 1, vjust = 3, size = 4) +
#   personal_theme() +
#   scale_color_manual(values=plotcolors)
# 
# #NOMINAL:
# 
# #Nominal RMSLE:
# nom_rmsle_long<-rmsle((Nominal.dt$CellConcentration_uM),(Nominal.dt$nomconc))
# nom_rmsle<-round(nom_rmsle_long, 2)
# #1.45
# 
# Nominal_ccell<-ggplot(Nominal.dt) +
#   geom_point(aes(x=nomconc, y=CellConcentration_uM, colour = ChemicalName))+
#   geom_abline(intercept=0,slope=1, linetype = "dashed") +
#   scale_x_log10(lim = c(0.00001, 400000), breaks = c(10^-4, 10^0, 10^4),
#                 labels = label_log(digits = 2)) +
#   scale_y_log10(lim = c(0.00001, 400000), breaks = c(10^-4, 10^0, 10^4),
#                 labels = label_log(digits = 2)) +
#   xlab(expression(italic("C"["nominal"])~"(\u03BCM)")) +
#   ylab(expression("Experimental "~italic("C"["cell"])~"(\u03BCM)")) +
#   labs(colour = "Chemical")+
#   annotate(geom = "text", x = xrng[2], y = yrng[1], parse=TRUE, label = paste(
#       "N[data] ", "~'='~", n_data), hjust = 1, vjust = 0, size = 4) +
#   annotate(geom = "text", x = xrng[2], y = yrng[1], parse=TRUE, label = paste(
#       "N[chemicals] ", "~'='~", n_chems), hjust = 1, vjust = 1.2, size = 4) +
#   annotate(geom = "text", x = xrng[2], y = yrng[1],
#            label = paste("RMSLE =", nom_rmsle),
#            hjust = 1, vjust = 3, size = 4) +
#   personal_theme() +
#   theme(legend.position = "bottom",
#         legend.key.size = unit(2, 'mm'),
#         legend.spacing = unit(10, "pt"))+
#         # legend.text = element_text(size = 8))+
#   guides(col = guide_legend(ncol = 5)) +
#   scale_color_manual(values=plotcolors)
# 
# #Combine the three plots w RMSLE
# Ccells_comboplot<-ggarrange(Nominal_ccell, Armitage_ccell, Kramer_ccell,
#                             ncol=3 , legend = "bottom", common.legend = TRUE)
# 
# #save
# if(save_output){
#   ggsave(file = paste0("Figure2_",data.date,"_",Sys.Date(),".png"),
#          path = path_out,
#          Ccells_comboplot, width = 10, height = 5.5, dpi = 300)
# }
# 
# print(Ccells_comboplot)
# 

## ----multiobs_intracel_plot_fig3, eval = execute.vignette---------------------
# 
# #Armitage.multobs.dt %>% count(ChemicalName, NominalDose_uM, Citation)
# #some of these have super close nomconcs because they are experimentally
# #measured - not really relevant for this comparison because they are replicates
# #chemicals to remove:
# #Hexachlorobenzene, Malathion, Pentachlorophenol, Propiconazole
# #(all of the chemicals from Stadnicka, 2014)
# 
# multiObsChemnameList<-Armitage.dt %>%
#   dplyr::filter(Citation != "Stadnicka, 2014") %>%
#   count(ChemicalName, NominalDose_uM) %>%
#   count(ChemicalName) %>% dplyr::filter(n>=2) %>%
#   select(ChemicalName) %>% distinct()
# #10 chemicals with multiple nominal doses measured
# 
# #filter measured data to just these chemicals
# Armitage.multobs.dt_og <- Armitage.dt %>%
#   dplyr::filter(ChemicalName %in% multiObsChemnameList$ChemicalName)
# 
# Kramer.multobs.dt_og <- Kramer.dt %>%
#   dplyr::filter(ChemicalName %in% multiObsChemnameList$ChemicalName)
# 
# Nominal.multobs.dt_og <- Nominal.dt %>%
#   dplyr::filter(ChemicalName %in% multiObsChemnameList$ChemicalName)
# #each have 89 observations
# 
# #merge the lines with multiple observations for the same nomconc (ie tox21)
# Armitage.multobs.dt<-Armitage.multobs.dt_og %>%
#   group_by(ChemicalName, NominalDose_uM) %>%
#   mutate(mean_measuredccell = mean(CellConcentration_uM),
#          mean_predictedccell = mean(ccells)) %>%
#   select(ChemicalName, NominalDose_uM, mean_measuredccell,
#          mean_predictedccell) %>% distinct()
# 
# Kramer.multobs.dt<-Kramer.multobs.dt_og %>%
#   group_by(ChemicalName, NominalDose_uM) %>%
#   mutate(mean_measuredccell = mean(CellConcentration_uM),
#          mean_predictedccell = mean(concentration_cells)) %>%
#   select(ChemicalName, NominalDose_uM, mean_measuredccell,
#          mean_predictedccell) %>% distinct()
# 
# Nominal.multobs.dt<-Nominal.multobs.dt_og %>%
#   group_by(ChemicalName, NominalDose_uM) %>%
#   mutate(mean_measuredccell = mean(CellConcentration_uM),
#          mean_predictedccell = mean(NominalDose_uM)) %>%
#   select(ChemicalName, NominalDose_uM, mean_measuredccell,
#          mean_predictedccell) %>% distinct()
# #down to 50 observations because the duplicates have been averaged
# 
# ### Plotting ###
# 
# #plot set up
# yrng_mult <- range(Armitage.multobs.dt$mean_measuredccell)
# xrng_mult <- range(Armitage.multobs.dt$mean_predictedccell)
# n_chems_mult<-n_distinct(Armitage.multobs.dt$ChemicalName)
# n_data_mult<-nrow(Armitage.multobs.dt)
# 
# #ARMITAGE
# 
# #Armitage RMSLE:
# arm_mult_rmsle_long<-rmsle((Armitage.multobs.dt$mean_measuredccell),
#                            (Armitage.multobs.dt$mean_predictedccell))
# arm_mult_rmsle<-round(arm_mult_rmsle_long, 2)
# #1.27
# 
# #r squared
# ml_arm <- lm(mean_measuredccell~mean_predictedccell, data = Armitage.multobs.dt)
# rsq_armitage_mult <- summary(ml_arm)$r.squared
# #0.87
# 
# # now plot
# Armitage_ccell_mult<-ggplot(Armitage.multobs.dt) +
#   geom_point(aes(mean_predictedccell, mean_measuredccell,
#                  colour = ChemicalName)) +
#   geom_smooth(aes(mean_predictedccell, mean_measuredccell,
#                   colour = ChemicalName), method=lm, se = FALSE) +
#   geom_abline(intercept=0,slope=1, linetype = "dashed") +
#   scale_x_log10(lim = c(0.0001, 400000), breaks = c(10^-4, 10^0, 10^4),
#                 labels = label_log(digits = 2)) +
#   scale_y_log10(lim = c(0.0001, 400000), breaks = c(10^-4, 10^0, 10^4),
#                 labels = label_log(digits = 2)) +
#   xlab(expression("Armitage Predicted "*italic("C"["cell"])~"(\u03BCM)")) +
#   ylab(expression("Experimental "*italic(" C"["cell"])~"(\u03BCM)")) +
#   labs(colour = "Chemical")+
#   annotate(geom = "text", x = xrng_mult[2], y = yrng_mult[1],
#            parse=TRUE,
#            label = paste("N[data] ", "~'='~", n_data_mult),
#            hjust = 1, vjust = 0, size = 4) +
#   annotate(geom = "text", x = xrng_mult[2], y = yrng_mult[1],
#            parse=TRUE,
#            label = paste("N[chemicals] ", "~'='~", n_chems_mult),
#            hjust = 1, vjust = 1.2, size = 4)+
#   annotate(geom = "text", x = xrng_mult[2], y = yrng_mult[1],
#   label = paste("RMSLE =", arm_mult_rmsle), hjust = 1, vjust = 3, size = 4) +
#   personal_theme()  +
#   scale_color_manual(values=plotcolors)
# 
# #KRAMER
# 
# #Kramer RMSLE:
# kram_mult_rmsle_long<-rmsle((Kramer.multobs.dt$mean_measuredccell),
#                             (Kramer.multobs.dt$mean_predictedccell))
# kram_mult_rmsle<-round(kram_mult_rmsle_long, 2)
# # 1.58
# 
# #r squared
# ml_kram <- lm(mean_measuredccell~mean_predictedccell, data = Kramer.multobs.dt)
# rsq_kramer_mult <- summary(ml_kram)$r.squared
# #0.87
# 
# # now plot
# Kramer_ccell_mult<-ggplot(Kramer.multobs.dt) +
#   geom_point(aes(mean_predictedccell, mean_measuredccell,
#                  colour = ChemicalName)) +
#   geom_smooth(aes(mean_predictedccell, mean_measuredccell,
#                   colour = ChemicalName), method=lm, se = FALSE) +
#   geom_abline(intercept=0,slope=1, linetype = "dashed") +
#   scale_x_log10(lim = c(0.0001, 400000), breaks = c(10^-4, 10^0, 10^4),
#                 labels = label_log(digits = 2)) +
#   scale_y_log10(lim = c(0.0001, 400000), breaks = c(10^-4, 10^0, 10^4),
#                 labels = label_log(digits = 2)) +
#   xlab(expression("Kramer Predicted "*italic("C"["cell"])~"(\u03BCM)")) +
#   ylab(expression("Experimental "*italic(" C"["cell"])~"(\u03BCM)")) +
#   labs(colour = "Chemical")+
#   annotate(geom = "text", x = xrng_mult[2], y = yrng_mult[1],
#            parse=TRUE,
#            label = paste("N[data] ", "~'='~", n_data_mult),
#            hjust = 1, vjust = 0, size = 4) +
#   annotate(geom = "text", x = xrng_mult[2], y = yrng_mult[1],
#            parse=TRUE,
#            label = paste("N[chemicals] ", "~'='~", n_chems_mult),
#            hjust = 1, vjust = 1.2, size = 4) +
#   annotate(geom = "text", x = xrng_mult[2], y = yrng_mult[1],
#   label = paste("RMSLE =", kram_mult_rmsle), hjust = 1, vjust = 3, size = 4) +
#   personal_theme()  +
#   scale_color_manual(values=plotcolors) +
#   theme(legend.key.size = unit(2, 'mm'),
#         legend.text = element_text(size = 6))
# 
# 
# #arrange
# Ccells_comboplot_mult<-ggarrange(Armitage_ccell_mult, Kramer_ccell_mult, ncol=2,
#                                  legend = "bottom", common.legend = TRUE)
# 
# if(save_output){
#   ggsave(file = paste0("Figure3_",data.date,"_",Sys.Date(),".png"),
#          path = path_out,
#          Ccells_comboplot_mult, width = 8, height = 4, dpi = 300)
# }
# 
# print(Ccells_comboplot_mult)
# 

## ----chemicalPart_intracel_plot_fig4, eval = execute.vignette-----------------
# 
# #Cwat_uM -------- Cwat_R
# Cwater_comparison<-ggplot(combodata) +
#   geom_point(aes(concentration_medium, cwat_s, colour = ChemicalName.x)) +
#   geom_abline(intercept=0,slope=1, linetype = "dashed") +
#   ggtitle("Medium Concentration") +
#   xlab(expression("Kramer Predicted "*italic("C"["medium"])~"(\u03BCM)")) +
#   ylab(expression("Armitage Predicted "*italic(" C"["medium"])~"(\u03BCM)")) +
#   scale_x_log10(labels = label_log(digits = 2)) +
#   scale_y_log10(labels = label_log(digits = 2)) +
#   personal_theme() +
#   scale_color_manual(values=plotcolors)
# 
# #Cair_uM -------- Cair_R
# Cair_comparison<-ggplot(combodata) +
#   geom_point(aes(concentration_air, cair, colour = ChemicalName.x)) +
#   geom_abline(intercept=0,slope=1, linetype = "dashed") +
#   ggtitle("Air Concentration") +
#   xlab(expression("Kramer Predicted "*italic("C"["air"])~"(\u03BCM)")) +
#   ylab(expression("Armitage Predicted "*italic(" C"["air"])~"(\u03BCM)")) +
#   scale_x_log10(labels = label_log(digits = 2)) +
#   scale_y_log10(labels = label_log(digits = 2)) +
#   personal_theme() +
#   scale_color_manual(values=plotcolors)
# 
# #C_cells_uM ----- Ccells
# Ccells_comparison<-ggplot(combodata) +
#   geom_point(aes(concentration_cells, ccells, colour = ChemicalName.x)) +
#   geom_abline(intercept=0,slope=1, linetype = "dashed") +
#   ggtitle("Cell Concentration") +
#   xlab(expression("Kramer Predicted "*italic("C"["cell"])~"(\u03BCM)")) +
#   ylab(expression("Armitage Predicted "*italic(" C"["cell"])~"(\u03BCM)")) +
#   scale_x_log10(lim = c(10^-4, 10^5), labels = label_log(digits = 2),
#                 breaks = c(10^-2, 10^0, 10^2, 10^4)) +
#   scale_y_log10(lim = c(10^-4, 10^5), labels = label_log(digits = 2),
#                 breaks = c(10^-2, 10^0, 10^2, 10^4)) +
#   personal_theme() +
#   scale_color_manual(values=plotcolors)
# 
# #Aplastic_uM_m2 - (Cplastic_R / Sarea_R)
# Aplastic_comparison<-ggplot(combodata) +
#   geom_point(aes(concentration_plastic, cplastic, colour = ChemicalName.x)) +
#   geom_abline(intercept=0,slope=1, linetype = "dashed") +
#   ggtitle("Plastic Concentration") +
#   xlab(expression("Kramer Predicted "*italic("C"["plastic"])~"(\u03BCM)")) +
#   ylab(expression("Armitage Predicted "*italic(" C"["plastic"])~"(\u03BCM)")) +
#   labs(colour = "Chemical")+
#   scale_x_log10(labels = label_log(digits = 2),
#                 breaks = c(10^-6, 10^-4, 10^-2, 10^0)) +
#   scale_y_log10(labels = label_log(digits = 2)) +
#   personal_theme() +
#   scale_color_manual(values=plotcolors) +
#   theme(legend.key.size = unit(1, 'mm'),
#         legend.spacing = unit(2, "pt"),
#         legend.text = element_text(size = 6))
# 
# 
# compartment_plots<-ggarrange(Ccells_comparison, Aplastic_comparison,
#                              Cwater_comparison, Cair_comparison,
#                              common.legend = TRUE, legend = "none")
# 
# if(save_output){
#   ggsave(file = paste0("Figure4_",data.date,"_",Sys.Date(),".png"),
#          path = path_out,
#          compartment_plots, width = 8, height = 6, dpi= 300)
# }
# 
# print(compartment_plots)
# 

## ----curated_values_plot_fig5, eval = execute.vignette------------------------
# 
# #load curated data info
# original_curated.data.dt <- httk::Dimitrijevic.IVD
# 
# #first - run using the default/dashboard values
# default.dt<-data.table::copy(original_curated.data.dt %>%
#                    select(-c( "Arnot_pka", "Arnot_pkb", "log KOW,N", "log KAW,N",
#                               "Predicted_Ccell_µM", "FoA")))
# 
# # run the model, output concentrations in umol/L (e.g. uM)
# armitageOutput_default.dt <- armitage_eval(tcdata=default.dt,
#                                         restrict.ion.partitioning = TRUE,
#                                         surface.area.switch = FALSE)
# 
# #next- run using curated values (EAS-E Suite)
# curated.data.dt<-data.table::copy(original_curated.data.dt)
# 
# #overwrite using curated physchem properties
# curated.data.dt[, pKa_Donor := as.character(Arnot_pka)] %>% #acidic
#   .[, pKa_Accept := as.character(Arnot_pkb)] %>% #basic
#   .[, gkow := `log KOW,N`] %>%
#   .[, gkaw_n := `log KAW,N`]
# 
# # run the model, output concentrations in umol/L (e.g. uM)
# armitageOutput_curated.data.dt <- armitage_eval(tcdata=curated.data.dt,
#                                         restrict.ion.partitioning = TRUE,
#                                         surface.area.switch = FALSE)
# 
# #save output with these values (Supplemental Materials T9)
# defaultvals<- armitageOutput_default.dt %>%
#   select(Name, casrn, gkow_n, gkaw_n, pKa_Donor, pKa_Accept)
# curatedvals<-armitageOutput_curated.data.dt %>%
#   select(Name, casrn, gkow_n, gkaw_n, pKa_Donor, pKa_Accept)
# #tie the two tables together for the supplement
# s9_table<-rbind(curatedvals, defaultvals)
# 
# #calculate rmsle
# 
# #default values
# 
# #individual
# armitageOutput_default.dt[,rmsle_ccell_default:=
#                             rmsle(Reported_Ccell_µM, ccells), by = Name]
# 
# #total
# RMSLE_default.dt<-rmsle(armitageOutput_default.dt$Reported_Ccell_µM,
#                         armitageOutput_default.dt$ccells)
# RMSLE_default.dt<-round(RMSLE_default.dt, 3)
# #0.586
# 
# #curated values
# 
# #individual
# armitageOutput_curated.data.dt[,rmsle_ccell_curated:=
#                                  rmsle(Reported_Ccell_µM, ccells), by = Name]
# 
# #total
# RMSLE_curated.data.dt<-rmsle(armitageOutput_curated.data.dt$Reported_Ccell_µM,
#                              armitageOutput_curated.data.dt$ccells)
# RMSLE_curated.data.dt<-round(RMSLE_curated.data.dt, 3)
# #0.570
# 
# #improvement when using curated data:
# RMSLE_default.dt-RMSLE_curated.data.dt
# #0.016
# 
# ## difference between the two on a per-chemical basis ##
# curated_data.dt<-merge(armitageOutput_default.dt,
#                        armitageOutput_curated.data.dt, by = "Name")
# 
# #calculate rmsle difference for each chemical
# curated_data.dt[,rmsle_difference:=
#                   rmsle_ccell_curated-rmsle_ccell_default, by = Name]
# 
# #which chemicals had the greatest magnitude of difference
# #largest improvement when using curated data
# head(curated_data.dt %>%
#   select(rmsle_difference, Name) %>%
#   arrange(rmsle_difference), 2)
# 
# #largest improvement when using default data
# tail(curated_data.dt %>%
#   select(rmsle_difference, Name) %>%
#   arrange(rmsle_difference), 2)
# 
# #set custom colors and shapes for plot below
# #tricky to tell apart with just colors
# custom_shapes <- c(22, 23, 24, 25, 22, 23,
#                    24, 25, 22, 23, 24, 25) # 12 distinct shapes
# custom_colors <- scales::viridis_pal()(length(
#   unique(curated_data.dt$Name))) # 12 distinct colors
# 
# #plot
# curated_difference_httk_plot<-ggplot(curated_data.dt) +
#   geom_point(aes(ccells.y, Reported_Ccell_µM.y, fill = Name, shape = Name), size = 4) +
#   geom_label_repel(aes(ccells.y, Reported_Ccell_µM.y,
#                        label = round(rmsle_difference, 2))) +
#   geom_abline(intercept=0,slope=1, linetype = "dashed") +
#   xlab(expression("Armitage Predicted "*italic("C"["cell"])~"(\u03BCM)")) +
#   ylab(expression("Experimental "*italic(" C"["cell"])~"(\u03BCM)")) +
#   labs(fill = "Chemical", shape = "Chemical")+
#   scale_x_log10(lim = c(10, 10000), labels = label_log(digits = 2)) +
#   scale_y_log10(lim = c(10, 10000), labels = label_log(digits = 2)) +
#   personal_theme() +
#   scale_shape_manual(values = custom_shapes) +
#   scale_fill_manual(values = custom_colors) +
#   theme(legend.position = "bottom",
#         legend.key.size = unit(2, 'mm'),
#         legend.spacing = unit(10, "pt"),
#         legend.text = element_text(size = 10))
# 
# if(save_output){
#   ggsave(file = paste0("Figure5_",data.date,"_",Sys.Date(),".png"),
#          path = path_out,
#          curated_difference_httk_plot, width = 8, height = 5, dpi = 300)
# 
#   write.csv(s9_table, file = paste0(path_out,"table_s9_",data.date,"_",
#                                     Sys.Date(),".csv"))
# }
# 

## ----fold_change_calculation, eval = execute.vignette-------------------------
# 
# # The Armitage model resulted in a slight over prediction of Ccell whereas
# # the Kramer model had the greatest spread but most evenly over and
# # underpredicted Ccell (Figure 2).
# range(Armitage.dt$ccells)
# #1.555754e-02 4.845393e+04
# range(Kramer.dt$concentration_cells)
# #5.838149e-04 2.663947e+04
# 
# #Kramer has a larger spread of predictions
# 
# ##create datatable with both outputs stacked
# stacked.data<-rbind(Armitage.dt, Kramer.dt, fill=TRUE)
# 
# #overpredict or underpredict for each model compared to experimental
# stacked.data_HL<-data.table::copy(stacked.data)
# stacked.data_HL[ccells>CellConcentration_uM,
#                 ARMITAGE_ccellcomp:="ARMITAGE higher"] %>%
#   .[ccells<CellConcentration_uM,
#     ARMITAGE_ccellcomp:="ARMITAGE lower"] %>%
#   .[concentration_cells>CellConcentration_uM,
#     KRAMER_ccellcomp:="KRAMER higher"] %>%
#   .[concentration_cells<CellConcentration_uM,
#     KRAMER_ccellcomp:="KRAMER lower"]
# 
# stacked.data_HL %>% count(ARMITAGE_ccellcomp, KRAMER_ccellcomp)
# #Armitage model more often over predicts
# #Kramer is pretty even split of over and under predictions
# 
# #pick out where armitage prediction or kramer prediction is larger
# sidebyside.data_HL<-data.table::copy(combodata)
# sidebyside.data_HL[ccells>concentration_cells, ARMITAGE:="ARMITAGE higher"] %>%
#   .[ccells<concentration_cells, KRAMER:="KRAMER higher"]
# 
# #count which is higher or lower by chemical
# sidebyside.data_HL %>% select(ChemicalName.x, ARMITAGE, KRAMER) %>%
#   distinct() %>% count(ARMITAGE, KRAMER)
# #armitage: higher for 38 chemicals
# #kramer: higher for 5 chemicals
# #38+5 = 43 chemicals overall
# 

## ----water_solublity, eval = execute.vignette---------------------------------
# 
# #Calculating water solubility using OPERA gswat
# #pull cyc a values from input data
# cycA.dt<-data.table::copy(IVD_Manuscript_data %>%
#                 dplyr::filter(ChemicalName == "Cyclosporin A"))
# 
# #using regular gswat value:
# #run armitage
# armitageOutput_cycA.dt_orig <- armitage_eval(tcdata=cycA.dt,
#                                        surface.area.switch = TRUE,
#                                        user_assay_parameters =
#                                          user_assay_parameters,
#                                        restrict.ion.partitioning = TRUE)
# 
# #regular gswat value is 2.341266 mg/L
# #armitageOutput_cycA.dt_orig$gswat_n
# 
# #check gswat value:
# # 1. pull from data.table
# chem.physical_and_invitro.data %>%
#   dplyr::filter(CAS == "59865-13-3") %>%
#   select(MW, logWSol, logWSol.Reference)
# 
# # 2. convert mol/L to mg/L which is what armitage uses
# #from chem.physical_and_invitro.data table:
# -3.739 #(mol/L) log10 water solubility
# 10^-3.739 # un-log = 0.0001823896 (mol/L)
# #convert to mg/L
# 0.0001823896*(1203*convert_units("g", "mg")) #1203 is MW in g/mol
# #output: 219.4147 mg/L = swat
# log10(219.4147)
# #output: 2.341266 mg/L = gswat
# 
# #calculate RMSLE
# cycA.dt_rmsle_orig<-round(rmsle((
#   armitageOutput_cycA.dt_orig$CellConcentration_uM),
#   (armitageOutput_cycA.dt_orig$ccells)),2)
# #2.89 - overall rmsle
# 
# #Calculating water solubility using experimental gswat
# #pull cyc a values from input data
# cycA.dt<-data.table::copy(IVD_Manuscript_data %>% dplyr::filter(ChemicalName == "Cyclosporin A"))
# 
# #using measured gswat value: mg/L
# cycA.dt[, gswat_n := log10(0.0073)]
# 
# #run armitage
# armitageOutput_cycA.dt_meas <- armitage_eval(tcdata=cycA.dt,
#                                        surface.area.switch = TRUE,
#                                        user_assay_parameters =
#                                          user_assay_parameters,
#                                        restrict.ion.partitioning = TRUE)
# 
# #measured gswat value is -2.136677 mg/L
# #armitageOutput_cycA.dt_meas$gswat_n
# 
# #calculate RMSLE
# cycA.dt_rmsle_meas<-round(rmsle((
#   armitageOutput_cycA.dt_meas$CellConcentration_uM),
#   (armitageOutput_cycA.dt_meas$ccells)),2)
# #1.47 - overall rmsle
# 

## ----experimental_nomconc, eval = execute.vignette----------------------------
# 
# #pull observations that did experimentally measure the nominal dose
# #exp_nom.dt<-data.table::copy(IVD_Manuscript_data[!(is.na(ExperimentalDose_uM)),])
# #6 citations did measure experimental dose
# #42 observations
# 
# #BUT - Stadnicka 2014 did not report a nominal dose to begin with,
# #only the experimentally measured values
# exp_nom.dt<-data.table::copy(IVD_Manuscript_data[!(is.na(ExperimentalDose_uM)) &
#                                        Citation != "Stadnicka, 2014",])
# #unique(exp_nom.dt$Citation)
# #5 citations measured experimental dose AND reported nominal dose
# #27 observations
# 
# #run armitage with nomconc as NominalDose_uM.x (not experimentally measured)
# arm_nomconc<-data.table::copy(exp_nom.dt[, nomconc := NominalDose_uM])
# 
# # run Armitage model, output concentrations in umol/L (e.g. uM)
# armitageOutput_arm_nomconc <- armitage_eval(tcdata=arm_nomconc,
#                                             surface.area.switch = TRUE,
#                                             user_assay_parameters =
#                                               user_assay_parameters,
#                                             restrict.ion.partitioning = TRUE)
# 
# #run armitage with nomconc as ExperimentalDose_uM.x (experimentally measured)
# arm_expconc<-data.table::copy(exp_nom.dt[, nomconc := ExperimentalDose_uM])
# 
# armitageOutput_arm_expconc <- armitage_eval(tcdata=arm_expconc,
#                                             surface.area.switch = TRUE,
#                                             user_assay_parameters =
#                                               user_assay_parameters,
#                                             restrict.ion.partitioning = TRUE)
# 
# #Armitage NOMCONC RMSLE:
# arm_nomconc_rmsle_long<-rmsle((armitageOutput_arm_nomconc$CellConcentration_uM),
#                               (armitageOutput_arm_nomconc$ccells))
# arm_nomconc_rmsle<-round(arm_nomconc_rmsle_long, 2)
# #1.87
# 
# #Armitage EXPCONC RMSLE:
# arm_expconc_rmsle_long<-rmsle((armitageOutput_arm_expconc$CellConcentration_uM),
#                               (armitageOutput_arm_expconc$ccells))
# arm_expconc_rmsle<-round(arm_expconc_rmsle_long, 2)
# #1.75
# 
# #improvement between the experimental and nomconc rmsles
# arm_nomconc_rmsle- arm_expconc_rmsle
# #0.12
# 

## ----physchem_data_tableS1, eval = execute.vignette---------------------------
# 
# #create datatable to hold the info
# table1.dt<-data.table::copy(Nominal.dt)
# 
# # pull out the columns we need
# data.dt<-table1.dt[, c("Citation", "casrn", "ChemicalName", "IOC_Type",
#                        "nomconc", "CellConcentration_uM"), with = FALSE]
# 
# 
# # pull dtxsids, log P, henry's law, and pka:
# 
# #dtxsids
# cheminfo.dt<-as.data.table(get_chem_id(chem.cas=unique(data.dt$casrn)))
# 
# cheminfo.dt[, casrn:=chem.cas] %>% #rename
#   .[,chem.cas:=NULL] %>% #delete
#   .[,chem.name:=NULL] #delete
# 
# #add dtxsid info to the storage file
# data.dt2<-data.dt[cheminfo.dt,on="casrn"]
# 
# #collect log P, henry's law, and pka values
# data.dt2[, c("logP","logHenry", "pKa_Donor", "pKa_Accept") :=
#            as.data.frame(get_physchem_param(param = c("logP","logHenry",
#                                                       "pKa_Donor",
#                                                       "pKa_Accept"),
#                                             chem.cas = casrn))]
# 
# 
# # calculate median CellConcentration_uM:cnom ratio
# # (for each citation if multiple) and number of observations per chemical
# 
# #get ccell : cnom ratio
# data.dt2[,cellconc_cnom_ratio:=CellConcentration_uM/nomconc]
# 
# #for each chemical/citation combination, calculate the median ccell:cnom ratio
# data.dt2[, median_ratio := median(cellconc_cnom_ratio),
#          by=list(Citation, ChemicalName)]
# 
# #count the number of observations by citation and chemname
# data.dt2[, number_of_obs:=.N, by=list(Citation, ChemicalName)]
# 
# #filter down to one observation per citation/casrn combo
# final_output<-data.dt2 %>%
#   mutate(logP=round(logP, 2),
#          logHenry=round(logHenry, 2),
#          median_ratio=round(median_ratio, 3)) %>%
#   select(-c("casrn", "nomconc", "CellConcentration_uM",
#             "cellconc_cnom_ratio")) %>% #get rid of extra rows
#   distinct(Citation, ChemicalName, .keep_all = TRUE)
# #1 obs per citation/chem pair
# 
# #save the output
# if(save_output){
#   write.csv(final_output, file = paste0(path_out,"table_s1_",data.date,"_",
#                                         Sys.Date(),".csv"))
# }
# 

## ----assay_descriptors_tableS2, eval = execute.vignette-----------------------
# 
# #copy table to manipulate
# parameter_table<-data.table::copy(Nominal.dt)
# 
# table_s2<-parameter_table[, c("Citation", "ChemicalName", "nomconc",
#                               "NominalDose_uM", "v_total", "v_working",
#                               "sarea", "well_number", "cell_yield", "FBSf",
#                               "FigureNumber", "CellType")] #subset columns
# 
# #save the output
# if(save_output){
#   write.csv(table_s2,
#             file = paste0(path_out,"table_s2_raw_",data.date,"_",
#                           Sys.Date(),".csv"))
# }
# 

## ----ionization_RMSLE_tableS4, eval = execute.vignette------------------------
# 
# #copy for editing
# ionization_rmsle<-data.table::copy(stacked.data)
# 
# #calculate RMSLSE and r^2 for each model and ionization type
# ionization_rmsle_output<- data.table::copy(ionization_rmsle[label=="Armitage",
#                                                 RMSLE_armitage_ionization:=
#                          rmsle(CellConcentration_uM, ccells),
#                        by = "IOC_Type"] %>% #RMSLE
#   .[label=="Armitage", rsq_armitage_ionization:=
#       summary(lm(CellConcentration_uM~ccells))$r.squared,
#     by = "IOC_Type"] %>% #r^2
#   .[label=="Kramer", RMSLE_kramer_ionization:=
#                          rmsle(CellConcentration_uM, concentration_cells),
#                        by = "IOC_Type"] %>% #RMSLE
#   .[label=="Kramer", rsq_kramer_ionization:=
#       summary(lm(CellConcentration_uM~concentration_cells))$r.squared,
#     by = "IOC_Type"] %>% #r^2
#   .[,numberofpoints:= .N/2, by = "IOC_Type"] %>%
#   .[, c("IOC_Type", "RMSLE_armitage_ionization",
#         "rsq_armitage_ionization", "RMSLE_kramer_ionization",
#         "rsq_kramer_ionization", "numberofpoints")] %>% #select columns we want
#   distinct())
# 
# print(ionization_rmsle_output)
# #number of points is overall, not for each calculation
# 
# #save the output
# if(save_output){
#   write.csv(ionization_rmsle_output,
#             file = paste0(path_out,"table_s4_",data.date,"_",Sys.Date(),".csv"))
# }
# 

## ----logP_RMSLE_tableS5, eval = execute.vignette------------------------------
# 
# #cut up into chunks
# gkowbins<-stacked.data %>% mutate(LogP_bins =
#                                     cut(gkow, breaks = c(-Inf, 1.30, 3.36, Inf),
#   labels = c("Hydrophilic", "Moderate Lipophilic", "Lipophilic")))
# 
# #calculate rmsle for each model and logP bin combo
# gkowbins_rmsle_output<-suppressWarnings(data.table::copy(
#   gkowbins[label == "Armitage", Armitage_RMSLE := rmsle(
#   CellConcentration_uM, ccells), by = LogP_bins] %>%
#   .[label == "Kramer", Kramer_RMSLE := rmsle(
#   CellConcentration_uM, concentration_cells), by = LogP_bins] %>%
#   .[, numberofpoints := .N, by = list(LogP_bins, label)] %>%
#   .[, c("LogP_bins", "Armitage_RMSLE", "Kramer_RMSLE",
#         "numberofpoints", "label")] %>%
#   distinct()))
# 
# print(gkowbins_rmsle_output)
# #number of points is overall, not for each calculation
# 
# #save the output
# if(save_output){
#   write.csv(gkowbins_rmsle_output,
#             file = paste0(path_out,"table_s5_",data.date,"_",Sys.Date(),".csv"))
# }
# 

## ----kaw_RMSLE_tableS6, eval = execute.vignette-------------------------------
# 
# #source for chunks is table 2 Volatility class in water:
# #https://www.epa.gov/pesticide-science-and-assessing-pesticide-risks/
# #guidance-reporting-environmental-fate-and-transport#:~:text=is%20very%20low.-,
# #Volatility%20from%20Water,the%20reciprocal%20of%20KAW.&text=GMW%20=%20gram%20
# #molecular%20weight%20in%20g/mole.&text=This%20value%20is%20the%20inverse,as%20
# #Cwater/Cair.&text=Note%20that%20all%20chemicals%20may,volatility%20potential%20
# #is%20very%20low.
# 
# #cut up kaw into relevant bins
# kawbins<-stacked.data %>%
#   mutate(Kaw_bins = cut(DR_kaw, breaks = c(Inf, 10^-2, 10^-3, 10^-5, -Inf),
#   labels = c("Rapidly lost from a water surface",
#              "Volatile from a water surface",
#              "Slightly volatile from a water surface", "Non-volatile")))
# 
# #calculate rmsle for each model and logP bin combo
# kaw_rmsle_output<-suppressWarnings(kawbins[label == "Armitage",
#                                     Armitage_RMSLE := rmsle(
#   CellConcentration_uM, ccells), by = Kaw_bins] %>%
#   .[label == "Kramer", Kramer_RMSLE := rmsle(
#   CellConcentration_uM, concentration_cells), by = Kaw_bins] %>%
#   .[, numberofpoints := .N, by = list(Kaw_bins, label)] %>%
#   .[, c("Kaw_bins", "Armitage_RMSLE", "Kramer_RMSLE",
#         "numberofpoints", "label")] %>%
#   distinct())
# 
# 
# #save the output
# if(save_output){
#   write.csv(kaw_rmsle_output,
#             file = paste0(path_out,"table_s6_",data.date,"_",Sys.Date(),".csv"))
# }
# 
# 

## ----multobs_RMSLE_tableS7, eval = execute.vignette---------------------------
# 
# #Armitage
# 
# #copy for editing
# multobs_rmsle_armitage<-data.table::copy(as.data.table(Armitage.multobs.dt))
# 
# #group by chemname, calc RMSLE, r^2, and number of obs
# multobs_rmsle_armitage[, RMSLE_armitage_mult:=
#                          rmsle(mean_measuredccell, mean_predictedccell),
#                        by = "ChemicalName"] %>% #rmsle
#   .[, rsq_armitage_mult:=
#       summary(lm(mean_measuredccell~mean_predictedccell))$r.squared,
#     by = "ChemicalName"] %>% #r^2
#   .[, numberofpoints:= .N, by = "ChemicalName"]
# 
# #numberofpoints = number of datapoints considered (includes averaged points)
# 
# #repeat for kramer
# 
# #copy for editing
# multobs_rmsle_kramer<-data.table::copy(as.data.table(Kramer.multobs.dt))
# 
# #group by chemname, calc RMSLE, r^2, and number of obs
# multobs_rmsle_kramer[, RMSLE_kramer_mult:=
#                          rmsle(mean_measuredccell, mean_predictedccell),
#                        by = "ChemicalName"] %>% #rmsle
#   .[, rsq_kramer_mult:=
#       summary(lm(mean_measuredccell~mean_predictedccell))$r.squared,
#     by = "ChemicalName"] %>% #r^2
#   .[, numberofpoints:= .N, by = "ChemicalName"]
# 
# 
# #cut down both to the columns we need and only 1 obs per chemical
# mult.dt<-merge(multobs_rmsle_armitage[, -c("NominalDose_uM",
#                                            "mean_measuredccell",
#                                            "mean_predictedccell")] %>%
#                  distinct() ,
#                multobs_rmsle_kramer[, -c("NominalDose_uM",
#                                          "mean_measuredccell",
#                                          "mean_predictedccell")] %>%
#                  distinct())
# 
# #for higher/lower rmsle comparison
# mult_HL<-data.table::copy(mult.dt[RMSLE_kramer_mult>RMSLE_armitage_mult,
#                       higherorlower:="Kramer higher"] %>%
#   .[RMSLE_kramer_mult<RMSLE_armitage_mult,
#     higherorlower:="kramer lower"])
# 
# mult_HL %>% count(higherorlower)
# #armitage predictions have lower error for 6 chemicals
# #kramer predictions are lower error for the other 4
# 
# #save the output
# if(save_output){
#   write.csv(mult.dt,
#             file = paste0(path_out,"table_s3_",data.date,"_",Sys.Date(),".csv"))
# }
# 

## ----options_tableS8, eval = execute.vignette---------------------------------
# 
# #list of options that can be changed in the armitage model:
# 
# # 		- this.option.kbsa2 Use alternative bovine-serum-albumin partitioning
# # 		- this.option.swat2 Use alternative water solubility correction
# # 		- this.option.kpl2 Use alternative plastic-water partitioning model
# # 		- option.plastic == TRUE (default) gives nonzero surface area
# # 		- option.bottom == TRUE (default) includes surface area of the bottom of
# #       the well in determining sarea
# # 		- restrict.ion.partitioning
# # 			§ False (default):  Treat entire chemical as neutral and allow it all
# #       to partition normally as such
# # 			§ True: Restrict so only the neutral fraction of the chemical is
# #       available to partition normally but the ionized portion is scaled
# 
# 
# ##filter to just the ones we can run with the surface area calculation since
# #option.plastic and option.bottom require that function:
# options.IVD_Manuscript_data_2<-
#   options.IVD_Manuscript_data[!is.na(well_number), ] %>%
#   .[,sarea:=NULL]  #delete sarea so the surface area function will run
# #126 out of the original 153 observations
# # length(options.IVD_Manuscript_data$Citation %>% unique()) #14 citations
# # length(options.IVD_Manuscript_data_2$Citation %>% unique()) #12 citations
# # 153-126 data points; 27 data points total removed
# 
# # create table to append the results to
# options.table <- NULL
# 
# # run basic armitage, only setting the surface area switch
# option.basic <- armitage_eval(tcdata=options.IVD_Manuscript_data_2,
#                               surface.area.switch = TRUE,
#                               user_assay_parameters = user_assay_parameters)
# 
# option.basic_RMSLE<-rmsle((option.basic$CellConcentration_uM),
#                           (option.basic$ccells))
# #1.148
# 
# #append to table
# options.table<-rbind(options.table, c(round(option.basic_RMSLE ,3),
#                                       "All Default"))
# 
# # run with this.option.kbsa2 == TRUE (default is false)
# option.kbsa <- armitage_eval(tcdata=options.IVD_Manuscript_data_2,
#                              this.option.kbsa2 = TRUE,
#                              surface.area.switch = TRUE,
#                              user_assay_parameters = user_assay_parameters)
# 
# option.kbsa_RMSLE<-rmsle((option.kbsa$CellConcentration_uM),
#                          (option.kbsa$ccells))
# #1.150
# 
# #append to table
# options.table<-rbind(options.table, c(round(option.kbsa_RMSLE, 3),
#                                       "option.kbsa=TRUE"))
# 
# 
# # run with this.option.swat2 == TRUE (default is false)
# option.swat <- armitage_eval(tcdata=options.IVD_Manuscript_data_2,
#                              this.option.swat2 = TRUE,
#                              surface.area.switch = TRUE,
#                              user_assay_parameters = user_assay_parameters)
# 
# option.swat_RMSLE<-rmsle((option.swat$CellConcentration_uM),
#                          (option.swat$ccells))
# #3.585
# 
# #append to table
# options.table<-rbind(options.table, c(round(option.swat_RMSLE, 3),
#                                       "option.swat2=TRUE"))
# 
# # run with this.option.kpl2 == TRUE (Fischer) (default is false/kramer)
# option.kpl <- armitage_eval(tcdata=options.IVD_Manuscript_data_2,
#                              this.option.kpl2 = TRUE,
#                             surface.area.switch = TRUE,
#                             user_assay_parameters = user_assay_parameters)
# 
# option.kpl_RMSLE<-rmsle((option.kpl$CellConcentration_uM),(option.kpl$ccells))
# #1.101
# 
# #append to table
# options.table<-rbind(options.table, c(round(option.kpl_RMSLE, 3),
#                                       "option.kpl2=TRUE"))
# 
# # run with option.plastic == FALSE (default is true)
# opt.plast_input<- data.table::copy(options.IVD_Manuscript_data_2)
# opt.plast_input[,option.plastic := FALSE]
# 
# option.plast <- armitage_eval(tcdata=opt.plast_input,
#                               surface.area.switch = TRUE,
#                               user_assay_parameters = user_assay_parameters)
# 
# option.plast_RMSLE<-rmsle((option.plast$CellConcentration_uM),
#                           (option.plast$ccells))
# #1.178
# 
# #append to table
# options.table<-rbind(options.table, c(round(option.plast_RMSLE, 3),
#                                       "option.plastic=FALSE"))
# 
# # run with option.bottom == FALSE (default is true)
# option.bottom_input<- data.table::copy(options.IVD_Manuscript_data_2)
# option.bottom_input[,option.bottom := FALSE]
# 
# option.bottom <- armitage_eval(tcdata=option.bottom_input,
#                                surface.area.switch = TRUE,
#                               user_assay_parameters = user_assay_parameters)
# 
# option.bottom_RMSLE<-rmsle((option.bottom$CellConcentration_uM),
#                            (option.bottom$ccells))
# #1.157
# 
# #append to table
# options.table<-rbind(options.table, c(round(option.bottom_RMSLE,3),
#                                       "option.bottom=FALSE"))
# 
# # run with restrict.ion.partitioning == TRUE (default is FALSE)
# option.restion <- armitage_eval(tcdata=options.IVD_Manuscript_data_2,
#                              restrict.ion.partitioning = TRUE,
#                              surface.area.switch = TRUE,
#                               user_assay_parameters = user_assay_parameters)
# 
# option.restion_RMSLE<-rmsle((option.restion$CellConcentration_uM),
#                             (option.restion$ccells))
# #1.152
# 
# #append to table
# options.table<-rbind(options.table, c(round(option.restion_RMSLE,3),
#                                       "restrict.ion.partitioning = TRUE"))
# 
# #save the output
# if(save_output){
#   write.csv(options.table,
#             file = paste0(path_out,"table_s7_",data.date,"_",Sys.Date(),".csv"))
# }
# 

## ----cell_type_tableS11, eval = execute.vignette------------------------------
# 
# #copy for editing
# celltype_rmsle<-data.table::copy(stacked.data)
# 
# #one set doesnt have cell type annotated, add here:
# celltype_rmsle[assay_name == "Tox21 Experiment", cell_type := "MCF-7"]
# 
# #check all assays have cell type added (no nas)
# unique(celltype_rmsle$cell_type)
# 
# #create bins for the cell types
# celltype_rmsle[cell_type == "PRH" |
#                  cell_type == "PHH" |
#                  cell_type == "HepaRG" |
#                  cell_type == "HepG2"
#                  , cell_type_class:="Liver"] %>%
#   .[cell_type == "Neocortical" |
#      cell_type == "PFC" |
#      cell_type == "Caco-2" |
#      cell_type == "LS180" |
#      cell_type == "MCF-7" |
#      cell_type == "H295R" |
#      cell_type == "PC12" |
#      cell_type == "RTgill W1" |
#      cell_type == "HEK293" |
#      cell_type == "Balb/c 3T3", cell_type_class:="Non-Liver"]
# 
# #check all are labeled
# celltype_rmsle %>% select(cell_type, cell_type_class) %>% distinct()
# 
# #calculate RMSLSE and r^2 for each model and ionization type
# celltype_rmsle_output<- data.table::copy(celltype_rmsle[label=="Armitage",
#                                                 RMSLE_armitage_cell_type:=
#                          rmsle(CellConcentration_uM, ccells),
#                        by = "cell_type_class"] %>% #RMSLE
#   .[label=="Armitage", rsq_armitage_cell_type:=
#       summary(lm(CellConcentration_uM~ccells))$r.squared,
#     by = "cell_type_class"] %>% #r^2
#   .[label=="Kramer", RMSLE_kramer_cell_type:=
#                          rmsle(CellConcentration_uM, concentration_cells),
#                        by = "cell_type_class"] %>% #RMSLE
#   .[label=="Kramer", rsq_kramer_cell_type:=
#       summary(lm(CellConcentration_uM~concentration_cells))$r.squared,
#     by = "cell_type_class"] %>% #r^2
#   .[,numberofpoints:= .N/2, by = "cell_type_class"] %>%
#   .[, c("cell_type_class", "RMSLE_armitage_cell_type",
#         "rsq_armitage_cell_type", "RMSLE_kramer_cell_type",
#         "rsq_kramer_cell_type", "numberofpoints")] %>% #select columns we want
#   distinct())
# 
# print(celltype_rmsle_output)
# #number of points is overall, not for each calculation
# 

## ----intracellular_histogram_plotS1, eval = execute.vignette------------------
# 
# #calculate RMSLE for each chemical
# combodata[, RMSLE_armitage_by_chem:= rmsle(CellConcentration_uM.x, ccells),
#           by = "ChemicalName.x"]
# combodata[, RMSLE_kramer_by_chem:=
#             rmsle(CellConcentration_uM.x, concentration_cells),
#           by = "ChemicalName.x"]
# combodata[, RMSLE_nominal_by_chem:= rmsle(CellConcentration_uM.x, nomconc),
#           by = "ChemicalName.x"]
# 
# #cut down to one observation per chemical
# histo.data<-data.table::copy(combodata %>%
#                    select(ChemicalName.x, RMSLE_armitage_by_chem,
#                           RMSLE_kramer_by_chem, RMSLE_nominal_by_chem) %>%
#                    unique())
# 
# #histo.data %>% arrange(desc(RMSLE_kramer_by_chem))
# 
# #plot histograms
# nominal_histogram_by_chem <-ggplot(histo.data, aes(x=RMSLE_nominal_by_chem)) +
#   geom_histogram(binwidth = 0.5, boundary = 0) +
#   labs(x = "Nominal RMSLE",
#        y = "Number of Observations") +
#   xlim(0, 5) + ylim(0, 17) +
#   theme_classic() +
#   theme(axis.text=element_text(size=12),
#         axis.title=element_text(size=14))
# 
# armitage_histogram_by_chem <-ggplot(histo.data, aes(x=RMSLE_armitage_by_chem)) +
#   geom_histogram(binwidth = 0.5, boundary = 0) +
#   labs(x = "Armitage RMSLE",
#        y = "Number of Observations") +
#   xlim(0, 5) + ylim(0, 17) +
#   theme_classic() +
#   theme(axis.text=element_text(size=12),
#         axis.title=element_text(size=14))
# 
# kramer_histogram_by_chem <- ggplot(histo.data, aes(x=RMSLE_kramer_by_chem)) +
#   geom_histogram(binwidth = 0.5, boundary = 0) +
#   labs(x = "Kramer RMSLE",
#        y = "Number of Observations") +
#   xlim(0, 5) + ylim(0, 17) +
#   theme_classic()+
#   theme(axis.text=element_text(size=12),
#         axis.title=element_text(size=14))
# 
# histogram_comboplot_by_chem<-ggarrange(nominal_histogram_by_chem +
#                                          theme(axis.ticks.y = element_blank(),
#                                                plot.margin = margin(r = 1)),
#                                        armitage_histogram_by_chem +
#                                          theme(axis.text.y = element_blank(),
#                                                axis.ticks.y = element_blank(),
#                                                axis.title.y = element_blank(),
#                                                plot.margin = margin(r = 1,
#                                                                     l = 1)),
#                                        kramer_histogram_by_chem +
#                                          theme(axis.text.y = element_blank(),
#                                                axis.ticks.y = element_blank(),
#                                                axis.title.y = element_blank(),
#                                                plot.margin = margin(r = 1,
#                                                                     l = 1)),
#                                        ncol=3)
# 
# if(save_output){
#   ggsave(file = paste0("Figure_S1_by_chem_",data.date,"_",Sys.Date(),".png"),
#          path = path_out,
#          histogram_comboplot_by_chem, width = 10, height = 5, dpi = 300)
# }
# 
# print(histogram_comboplot_by_chem)
# 

## ----knitrPrep, include=FALSE, eval = TRUE------------------------------------
knitr::opts_chunk$set(collapse = TRUE, comment = '#>', fig.width=5, fig.height=3)

## ----clear_memory, eval = TRUE------------------------------------------------
rm(list=ls()) 

## ----runchunks, eval = TRUE---------------------------------------------------
# Set whether or not the following chunks will be executed (run):
execute.vignette <- FALSE

## ----load_packages, eval = execute.vignette-----------------------------------
# library(scales)
# library(ggplot2)
# library(data.table)
# library(httk)
# library(RColorBrewer)
# library(grid)
# library(gplots)

## ----plot_funcs, eval = execute.vignette--------------------------------------
# # Multiple plot function
# #
# # ggplot objects can be passed in ..., or to plotlist (as a list of ggplot objects)
# # - cols:   Number of columns in layout
# # - layout: A matrix specifying the layout. If present, 'cols' is ignored.
# #
# # If the layout is something like matrix(c(1,2,3,3), nrow=2, byrow=TRUE),
# # then plot 1 will go in the upper left, 2 will go in the upper right, and
# # 3 will go all the way across the bottom.
# #
# multiplot <- function(..., plotlist=NULL, file, cols=1, layout=NULL, widths=unit(rep_len(1, cols), "null")) {
# 
#   # Make a list from the ... arguments and plotlist
#   plots <- c(list(...), plotlist)
# 
#   numPlots = length(plots)
# 
#   # If layout is NULL, then use 'cols' to determine layout
#   if (is.null(layout)) {
#     # Make the panel
#     # ncol: Number of columns of plots
#     # nrow: Number of rows needed, calculated from # of cols
#     layout <- matrix(seq(1, cols * ceiling(numPlots/cols)),
#                     ncol = cols, nrow = ceiling(numPlots/cols))
#   }
# 
#  if (numPlots==1) {
#     print(plots[[1]])
# 
#   } else {
#     # Set up the page
#     grid.newpage()
#     pushViewport(viewport(layout = grid.layout(nrow(layout), ncol(layout),widths=widths)))
# 
#     # Make each plot, in the correct location
#     for (i in 1:numPlots) {
#       # Get the i,j matrix positions of the regions that contain this subplot
#       matchidx <- as.data.frame(which(layout == i, arr.ind = TRUE))
# 
#       print(plots[[i]], vp = viewport(layout.pos.row = matchidx$row,
#                                       layout.pos.col = matchidx$col))
#     }
#   }
# }
# 
# lm_R2 <- function(m,prefix=NULL){
#     out <- substitute("MSE = "~mse*","~~italic(R)^2~"="~r2,
#          list(mse = signif(mean(m$residuals^2),3),
#               r2 = format(summary(m)$adj.r.squared, digits = 2)))
#     paste(prefix,as.character(as.expression(out)))
# }
# 
# heatmap.3 <- function(x,
#                       Rowv = TRUE, Colv = if (symm) "Rowv" else TRUE,
#                       distfun = dist,
#                       hclustfun = hclust,
#                       dendrogram = c("both","row", "column", "none"),
#                       symm = FALSE,
#                       scale = c("none","row", "column"),
#                       na.rm = TRUE,
#                       revC = identical(Colv,"Rowv"),
#                       add.expr,
#                       breaks,
#                       symbreaks = max(x < 0, na.rm = TRUE) || scale != "none",
#                       col = "heat.colors",
#                       colsep,
#                       rowsep,
#                       sepcolor = "white",
#                       sepwidth = c(0.05, 0.05),
#                       cellnote,
#                       notecex = 1,
#                       notecol = "cyan",
#                       na.color = par("bg"),
#                       trace = c("none", "column","row", "both"),
#                       tracecol = "cyan",
#                       hline = median(breaks),
#                       vline = median(breaks),
#                       linecol = tracecol,
#                       margins = c(5,5),
#                       ColSideColors,
#                       RowSideColors,
#                       side.height.fraction=0.3,
#                       cexRow = 0.2 + 1/log10(nr),
#                       cexCol = 0.2 + 1/log10(nc),
#                       labRow = NULL,
#                       labCol = NULL,
#                       key = TRUE,
#                       keysize = 1.5,
#                       density.info = c("none", "histogram", "density"),
#                       denscol = tracecol,
#                       symkey = max(x < 0, na.rm = TRUE) || symbreaks,
#                       densadj = 0.25,
#                       main = NULL,
#                       xlab = NULL,
#                       ylab = NULL,
#                       lmat = NULL,
#                       lhei = NULL,
#                       lwid = NULL,
#                       ColSideColorsSize = 1,
#                       RowSideColorsSize = 1,
#                       KeyValueName="Value",...){
# 
#     invalid <- function (x) {
#       if (missing(x) || is.null(x) || length(x) == 0)
#           return(TRUE)
#       if (is.list(x))
#           return(all(sapply(x, invalid)))
#       else if (is.vector(x))
#           return(all(is.na(x)))
#       else return(FALSE)
#     }
# 
#     x <- as.matrix(x)
#     scale01 <- function(x, low = min(x), high = max(x)) {
#         x <- (x - low)/(high - low)
#         x
#     }
#     retval <- list()
#     scale <- if (symm && missing(scale))
#         "none"
#     else match.arg(scale)
#     dendrogram <- match.arg(dendrogram)
#     trace <- match.arg(trace)
#     density.info <- match.arg(density.info)
#     if (length(col) == 1 && is.character(col))
#         col <- get(col, mode = "function")
#     if (!missing(breaks) && (scale != "none"))
#         warning("Using scale=\"row\" or scale=\"column\" when breaks are",
#             "specified can produce unpredictable results.", "Please consider using only one or the other.")
#     if (is.null(Rowv) || is.na(Rowv))
#         Rowv <- FALSE
#     if (is.null(Colv) || is.na(Colv))
#         Colv <- FALSE
#     else if (Colv == "Rowv" && !isTRUE(Rowv))
#         Colv <- FALSE
#     if (length(di <- dim(x)) != 2 || !is.numeric(x))
#         stop("`x' must be a numeric matrix")
#     nr <- di[1]
#     nc <- di[2]
#     if (nr <= 1 || nc <= 1)
#         stop("`x' must have at least 2 rows and 2 columns")
#     if (!is.numeric(margins) || length(margins) != 2)
#         stop("`margins' must be a numeric vector of length 2")
#     if (missing(cellnote))
#         cellnote <- matrix("", ncol = ncol(x), nrow = nrow(x))
#     if (!inherits(Rowv, "dendrogram")) {
#         if (((!isTRUE(Rowv)) || (is.null(Rowv))) && (dendrogram %in%
#             c("both", "row"))) {
#             if (is.logical(Colv) && (Colv))
#                 dendrogram <- "column"
#             else dedrogram <- "none"
#             warning("Discrepancy: Rowv is FALSE, while dendrogram is `",
#                 dendrogram, "'. Omitting row dendogram.")
#         }
#     }
#     if (!inherits(Colv, "dendrogram")) {
#         if (((!isTRUE(Colv)) || (is.null(Colv))) && (dendrogram %in%
#             c("both", "column"))) {
#             if (is.logical(Rowv) && (Rowv))
#                 dendrogram <- "row"
#             else dendrogram <- "none"
#             warning("Discrepancy: Colv is FALSE, while dendrogram is `",
#                 dendrogram, "'. Omitting column dendogram.")
#         }
#     }
#     if (inherits(Rowv, "dendrogram")) {
#         ddr <- Rowv
#         rowInd <- order.dendrogram(ddr)
#     }
#     else if (is.integer(Rowv)) {
#         hcr <- hclustfun(distfun(x))
#         ddr <- as.dendrogram(hcr)
#         ddr <- reorder(ddr, Rowv)
#         rowInd <- order.dendrogram(ddr)
#         if (nr != length(rowInd))
#             stop("row dendrogram ordering gave index of wrong length")
#     }
#     else if (isTRUE(Rowv)) {
#         Rowv <- rowMeans(x, na.rm = na.rm)
#         hcr <- hclustfun(distfun(x))
#         ddr <- as.dendrogram(hcr)
#         ddr <- reorder(ddr, Rowv)
#         rowInd <- order.dendrogram(ddr)
#         if (nr != length(rowInd))
#             stop("row dendrogram ordering gave index of wrong length")
#     }
#     else {
#         rowInd <- nr:1
#     }
#     if (inherits(Colv, "dendrogram")) {
#         ddc <- Colv
#         colInd <- order.dendrogram(ddc)
#     }
#     else if (identical(Colv, "Rowv")) {
#         if (nr != nc)
#             stop("Colv = \"Rowv\" but nrow(x) != ncol(x)")
#         if (exists("ddr")) {
#             ddc <- ddr
#             colInd <- order.dendrogram(ddc)
#         }
#         else colInd <- rowInd
#     }
#     else if (is.integer(Colv)) {
#         hcc <- hclustfun(distfun(if (symm)
#             x
#         else t(x)))
#         ddc <- as.dendrogram(hcc)
#         ddc <- reorder(ddc, Colv)
#         colInd <- order.dendrogram(ddc)
#         if (nc != length(colInd))
#             stop("column dendrogram ordering gave index of wrong length")
#     }
#     else if (isTRUE(Colv)) {
#         Colv <- colMeans(x, na.rm = na.rm)
#         hcc <- hclustfun(distfun(if (symm)
#             x
#         else t(x)))
#         ddc <- as.dendrogram(hcc)
#         ddc <- reorder(ddc, Colv)
#         colInd <- order.dendrogram(ddc)
#         if (nc != length(colInd))
#             stop("column dendrogram ordering gave index of wrong length")
#     }
#     else {
#         colInd <- 1:nc
#     }
#     retval$rowInd <- rowInd
#     retval$colInd <- colInd
#     retval$call <- match.call()
#     x <- x[rowInd, colInd]
#     x.unscaled <- x
#     cellnote <- cellnote[rowInd, colInd]
#     if (is.null(labRow))
#         labRow <- if (is.null(rownames(x)))
#             (1:nr)[rowInd]
#         else rownames(x)
#     else labRow <- labRow[rowInd]
#     if (is.null(labCol))
#         labCol <- if (is.null(colnames(x)))
#             (1:nc)[colInd]
#         else colnames(x)
#     else labCol <- labCol[colInd]
#     if (scale == "row") {
#         retval$rowMeans <- rm <- rowMeans(x, na.rm = na.rm)
#         x <- sweep(x, 1, rm)
#         retval$rowSDs <- sx <- apply(x, 1, sd, na.rm = na.rm)
#         x <- sweep(x, 1, sx, "/")
#     }
#     else if (scale == "column") {
#         retval$colMeans <- rm <- colMeans(x, na.rm = na.rm)
#         x <- sweep(x, 2, rm)
#         retval$colSDs <- sx <- apply(x, 2, sd, na.rm = na.rm)
#         x <- sweep(x, 2, sx, "/")
#     }
#     if (missing(breaks) || is.null(breaks) || length(breaks) < 1) {
#         if (missing(col) || is.function(col))
#             breaks <- 16
#         else breaks <- length(col) + 1
#     }
#     if (length(breaks) == 1) {
#         if (!symbreaks)
#             breaks <- seq(min(x, na.rm = na.rm), max(x, na.rm = na.rm),
#                 length = breaks)
#         else {
#             extreme <- max(abs(x), na.rm = TRUE)
#             breaks <- seq(-extreme, extreme, length = breaks)
#         }
#     }
#     nbr <- length(breaks)
#     ncol <- length(breaks) - 1
#     if (class(col) == "function")
#         col <- col(ncol)
#     min.breaks <- min(breaks)
#     max.breaks <- max(breaks)
#     x[x < min.breaks] <- min.breaks
#     x[x > max.breaks] <- max.breaks
#     if (missing(lhei) || is.null(lhei))
#         lhei <- c(keysize, 4)
#     if (missing(lwid) || is.null(lwid))
#         lwid <- c(keysize, 4)
#     if (missing(lmat) || is.null(lmat)) {
#         lmat <- rbind(4:3, 2:1)
# 
#         if (!missing(ColSideColors)) {
#            #if (!is.matrix(ColSideColors))
#            #stop("'ColSideColors' must be a matrix")
#             if (!is.character(ColSideColors) || nrow(ColSideColors) != nc)
#                 stop("'ColSideColors' must be a matrix of nrow(x) rows")
#             lmat <- rbind(lmat[1, ] + 1, c(NA, 1), lmat[2, ] + 1)
#             #lhei <- c(lhei[1], 0.2, lhei[2])
#              lhei=c(lhei[1], side.height.fraction*ColSideColorsSize/2, lhei[2])
#         }
# 
#         if (!missing(RowSideColors)) {
#             #if (!is.matrix(RowSideColors))
#             #stop("'RowSideColors' must be a matrix")
#             if (!is.character(RowSideColors) || ncol(RowSideColors) != nr)
#                 stop("'RowSideColors' must be a matrix of ncol(x) columns")
#             lmat <- cbind(lmat[, 1] + 1, c(rep(NA, nrow(lmat) - 1), 1), lmat[,2] + 1)
#             #lwid <- c(lwid[1], 0.2, lwid[2])
#             lwid <- c(lwid[1], side.height.fraction*RowSideColorsSize/2, lwid[2])
#         }
#         lmat[is.na(lmat)] <- 0
#     }
# 
#     if (length(lhei) != nrow(lmat))
#         stop("lhei must have length = nrow(lmat) = ", nrow(lmat))
#     if (length(lwid) != ncol(lmat))
#         stop("lwid must have length = ncol(lmat) =", ncol(lmat))
#     op <- par(no.readonly = TRUE)
#     on.exit(par(op))
# 
#     layout(lmat, widths = lwid, heights = lhei, respect = FALSE)
# 
#     if (!missing(RowSideColors)) {
#         if (!is.matrix(RowSideColors)){
#                 par(mar = c(margins[1], 0, 0, 0.5))
#                 image(rbind(1:nr), col = RowSideColors[rowInd], axes = FALSE)
#         } else {
#             par(mar = c(margins[1], 0, 0, 0.5))
#             rsc = t(RowSideColors[,rowInd, drop=FALSE])
#             rsc.colors = matrix()
#             rsc.names = names(table(rsc))
#             rsc.i = 1
#             for (rsc.name in rsc.names) {
#                 rsc.colors[rsc.i] = rsc.name
#                 rsc[rsc == rsc.name] = rsc.i
#                 rsc.i = rsc.i + 1
#             }
#             rsc = matrix(as.numeric(rsc), nrow = dim(rsc)[1])
#             image(t(rsc), col = as.vector(rsc.colors), axes = FALSE)
#             if (length(rownames(RowSideColors)) > 0) {
#                 axis(1, 0:(dim(rsc)[2] - 1)/max(1,(dim(rsc)[2] - 1)), rownames(RowSideColors), las = 2, tick = FALSE)
#             }
#         }
#     }
# 
#     if (!missing(ColSideColors)) {
# 
#         if (!is.matrix(ColSideColors)){
#             par(mar = c(0.5, 0, 0, margins[2]))
#             image(cbind(1:nc), col = ColSideColors[colInd], axes = FALSE)
#         } else {
#             par(mar = c(0.5, 0, 0, margins[2]))
#             csc = ColSideColors[colInd, , drop=FALSE]
#             csc.colors = matrix()
#             csc.names = names(table(csc))
#             csc.i = 1
#             for (csc.name in csc.names) {
#                 csc.colors[csc.i] = csc.name
#                 csc[csc == csc.name] = csc.i
#                 csc.i = csc.i + 1
#             }
#             csc = matrix(as.numeric(csc), nrow = dim(csc)[1])
#             image(csc, col = as.vector(csc.colors), axes = FALSE)
#             if (length(colnames(ColSideColors)) > 0) {
#                 axis(2, 0:(dim(csc)[2] - 1)/max(1,(dim(csc)[2] - 1)), colnames(ColSideColors), las = 2, tick = FALSE)
#             }
#         }
#     }
# 
#     par(mar = c(margins[1], 0, 0, margins[2]))
#     x <- t(x)
#     cellnote <- t(cellnote)
#     if (revC) {
#         iy <- nr:1
#         if (exists("ddr"))
#             ddr <- rev(ddr)
#         x <- x[, iy]
#         cellnote <- cellnote[, iy]
#     }
#     else iy <- 1:nr
#     image(1:nc, 1:nr, x, xlim = 0.5 + c(0, nc), ylim = 0.5 + c(0, nr), axes = FALSE, xlab = "", ylab = "", col = col, breaks = breaks, ...)
#     retval$carpet <- x
#     if (exists("ddr"))
#         retval$rowDendrogram <- ddr
#     if (exists("ddc"))
#         retval$colDendrogram <- ddc
#     retval$breaks <- breaks
#     retval$col <- col
#     if (!invalid(na.color) & any(is.na(x))) { # load library(gplots)
#         mmat <- ifelse(is.na(x), 1, NA)
#         image(1:nc, 1:nr, mmat, axes = FALSE, xlab = "", ylab = "",
#             col = na.color, add = TRUE)
#     }
#     axis(1, 1:nc, labels = labCol, las = 2, line = -0.5, tick = 0,
#         cex.axis = cexCol)
#     if (!is.null(xlab))
#         mtext(xlab, side = 1, line = margins[1] - 1.25)
#     axis(4, iy, labels = labRow, las = 2, line = -0.5, tick = 0,
#         cex.axis = cexRow)
#     if (!is.null(ylab))
#         mtext(ylab, side = 4, line = margins[2] - 1.25)
#     if (!missing(add.expr))
#         eval(substitute(add.expr))
#     if (!missing(colsep))
#         for (csep in colsep) rect(xleft = csep + 0.5, ybottom = rep(0, length(csep)), xright = csep + 0.5 + sepwidth[1], ytop = rep(ncol(x) + 1, csep), lty = 1, lwd = 1, col = sepcolor, border = sepcolor)
#     if (!missing(rowsep))
#         for (rsep in rowsep) rect(xleft = 0, ybottom = (ncol(x) + 1 - rsep) - 0.5, xright = nrow(x) + 1, ytop = (ncol(x) + 1 - rsep) - 0.5 - sepwidth[2], lty = 1, lwd = 1, col = sepcolor, border = sepcolor)
#     min.scale <- min(breaks)
#     max.scale <- max(breaks)
#     x.scaled <- scale01(t(x), min.scale, max.scale)
#     if (trace %in% c("both", "column")) {
#         retval$vline <- vline
#         vline.vals <- scale01(vline, min.scale, max.scale)
#         for (i in colInd) {
#             if (!is.null(vline)) {
#                 abline(v = i - 0.5 + vline.vals, col = linecol,
#                   lty = 2)
#             }
#             xv <- rep(i, nrow(x.scaled)) + x.scaled[, i] - 0.5
#             xv <- c(xv[1], xv)
#             yv <- 1:length(xv) - 0.5
#             lines(x = xv, y = yv, lwd = 1, col = tracecol, type = "s")
#         }
#     }
#     if (trace %in% c("both", "row")) {
#         retval$hline <- hline
#         hline.vals <- scale01(hline, min.scale, max.scale)
#         for (i in rowInd) {
#             if (!is.null(hline)) {
#                 abline(h = i + hline, col = linecol, lty = 2)
#             }
#             yv <- rep(i, ncol(x.scaled)) + x.scaled[i, ] - 0.5
#             yv <- rev(c(yv[1], yv))
#             xv <- length(yv):1 - 0.5
#             lines(x = xv, y = yv, lwd = 1, col = tracecol, type = "s")
#         }
#     }
#     if (!missing(cellnote))
#         text(x = c(row(cellnote)), y = c(col(cellnote)), labels = c(cellnote),
#             col = notecol, cex = notecex)
#     par(mar = c(margins[1], 0, 0, 0))
#     if (dendrogram %in% c("both", "row")) {
#         plot(ddr, horiz = TRUE, axes = FALSE, yaxs = "i", leaflab = "none")
#     }
#     else plot.new()
#     par(mar = c(0, 0, if (!is.null(main)) 5 else 0, margins[2]))
#     if (dendrogram %in% c("both", "column")) {
#         plot(ddc, axes = FALSE, xaxs = "i", leaflab = "none")
#     }
#     else plot.new()
#     if (!is.null(main))
#         title(main, cex.main = 1.5 * op[["cex.main"]])
#     if (key) {
#         par(mar = c(5, 4, 2, 1), cex = 0.75)
#         tmpbreaks <- breaks
#         if (symkey) {
#             max.raw <- max(abs(c(x, breaks)), na.rm = TRUE)
#             min.raw <- -max.raw
#             tmpbreaks[1] <- -max(abs(x), na.rm = TRUE)
#             tmpbreaks[length(tmpbreaks)] <- max(abs(x), na.rm = TRUE)
#         }
#         else {
#             min.raw <- min(x, na.rm = TRUE)
#             max.raw <- max(x, na.rm = TRUE)
#         }
# 
#         z <- seq(min.raw, max.raw, length = length(col))
#         image(z = matrix(z, ncol = 1), col = col, breaks = tmpbreaks,
#             xaxt = "n", yaxt = "n")
#         par(usr = c(0, 1, 0, 1))
#         lv <- pretty(breaks)
#         xv <- scale01(as.numeric(lv), min.raw, max.raw)
#         axis(1, at = xv, labels = lv)
#         if (scale == "row")
#             mtext(side = 1, "Row Z-Score", line = 2)
#         else if (scale == "column")
#             mtext(side = 1, "Column Z-Score", line = 2)
#         else mtext(side = 1, KeyValueName, line = 2)
#         if (density.info == "density") {
#             dens <- density(x, adjust = densadj, na.rm = TRUE)
#             omit <- dens$x < min(breaks) | dens$x > max(breaks)
#             dens$x <- dens$x[-omit]
#             dens$y <- dens$y[-omit]
#             dens$x <- scale01(dens$x, min.raw, max.raw)
#             lines(dens$x, dens$y/max(dens$y) * 0.95, col = denscol,
#                 lwd = 1)
#             axis(2, at = pretty(dens$y)/max(dens$y) * 0.95, pretty(dens$y))
#             title("Color Key\nand Density Plot")
#             par(cex = 0.5)
#             mtext(side = 2, "Density", line = 2)
#         }
#         else if (density.info == "histogram") {
#             h <- hist(x, plot = FALSE, breaks = breaks)
#             hx <- scale01(breaks, min.raw, max.raw)
#             hy <- c(h$counts, h$counts[length(h$counts)])
#             lines(hx, hy/max(hy) * 0.95, lwd = 1, type = "s",
#                 col = denscol)
#             axis(2, at = pretty(hy)/max(hy) * 0.95, pretty(hy))
#             title("Color Key\nand Histogram")
#             par(cex = 0.5)
#             mtext(side = 2, "Count", line = 2)
#         }
#         else title("Color Key")
#     }
#     else plot.new()
#     retval$colorTable <- data.frame(low = retval$breaks[-length(retval$breaks)],
#         high = retval$breaks[-1], color = retval$col)
#     invisible(retval)
# }
# 
# myclust <- function(c)
# {
#   hclust(c,method="average")
# }
# 
# na.dist <- function(x,method="euclidian",...)
# {
#   t.dist <- dist(x,...)
#   t.dist <- as.matrix(t.dist)
#   t.limit <- 1.1*max(t.dist,na.rm=TRUE)
#   t.dist[is.na(t.dist)] <- t.limit
#   t.dist <- as.dist(t.dist)
#   return(t.dist)
# }

## ----fig3, eval = execute.vignette--------------------------------------------
# physprop.matrix <- httk::chem.invivo.PK.aggregate.data[,c(
#                                     "Vdist",
#                                     "kelim",
#                                     "kgutabs",
#                                     "Fgutabs")]
# rownames(physprop.matrix) <- httk::chem.invivo.PK.aggregate.data$DTXSID
# rnames <- NULL
# for (this.chem in rownames(physprop.matrix))
# {
#   this.subset <- subset(chem.physical_and_invitro.data,DTXSID==this.chem)
#   if (dim(this.subset)[1]>0)
#   {
#     physprop.matrix[this.chem,"MW"] <- this.subset$MW
#     physprop.matrix[this.chem,"logP"] <- this.subset$logP
#     physprop.matrix[this.chem,"logWSol"] <- this.subset$logWSol
#     out <- calc_ionization(dtxsid=this.chem,pH=7.4)
#     physprop.matrix[this.chem,"Neutral.pH74"] <- out$fraction_neutral
#     physprop.matrix[this.chem,"Positive.pH74"] <- out$fraction_positive
#     physprop.matrix[this.chem,"Negative.pH74"] <- out$fraction_negative
#     physprop.matrix[this.chem,"Clint"] <- strsplit(this.subset$Human.Clint,",")[[1]][1]
#     physprop.matrix[this.chem,"Fup"] <- strsplit(this.subset$Human.Funbound.plasma,",")[[1]][1]
#   }
# }
# 
# row.side.cols <- rep("Black",dim(physprop.matrix)[1])
# row.side.cols[rownames(physprop.matrix) %in% pharma[1,]] <- "Grey"
# 
# apply(physprop.matrix,2,function(x) mean(x,na.rm=TRUE))
# for (this.col in colnames(physprop.matrix)[regexpr("log",colnames(physprop.matrix))==-1])
#   physprop.matrix[,this.col] <- log10(10^-6+as.numeric(physprop.matrix[,this.col]))
# 
# physprop.matrix <- apply(physprop.matrix,2,function(x) (x-mean(x,na.rm=TRUE))/sd(x,na.rm=TRUE))

## ----PlotFigure3, eval = execute.vignette-------------------------------------
# main_title="in vivo Toxicokinetic Parameters"
# heatmap.2(physprop.matrix,
#           hclustfun=myclust,
#           Colv=FALSE,
#           distfun=na.dist,
#           na.rm = TRUE,
#           scale="none",
#           trace="none",
#           RowSideColors=row.side.cols,
#           col=brewer.pal(11,"Spectral"),
#           margins=c(8,10))
# # The following has to be adjusted manually:
# #rect(0.65, 0.01, 0.87, 0.78, border="blue")
# #text(0.75,0.81,expression(paste("Estimated from ",italic("In Vivo")," Data")))

## ----Make FitData, eval = execute.vignette------------------------------------
# # Use joint analysis data from both labs:
# FitData <- httk::chem.invivo.PK.aggregate.data
# FitData$Compound <- unlist(sapply(FitData$DTXSID,
#                                   function(x)
#                                     ifelse(x%in%chem.physical_and_invitro.data$DTXSID,
#                                            chem.physical_and_invitro.data[
#                                       chem.physical_and_invitro.data$DTXSID==x,
#                                       "Compound"],
#                                       NA)))
# FitData$Source <- NA
# 
# FitData <- subset(FitData,Compound!="Bensulide"|Source=="Wambaugh et al. (2018), NHEERL/RTI")
# FitData <- subset(FitData,Compound!="Propyzamide"|Source=="Wambaugh et al. (2018), NHEERL/RTI")
# # Rename some columns to match original data files:
# FitData$Compound.abbrev <- strtrim(gsub("\"","",gsub(",","",gsub("-","",FitData$Compound))),4)
# # Add a column indicating chemical type:
# FitData$Chemical <- "Other"
# FitData[sapply(FitData$CAS,is.pharma),"Chemical"] <- "Pharmaceutical"

## ----fig4, eval = execute.vignette--------------------------------------------
# # Get rid of chemicals with Fup < LOD:
# FitData.Fup <- subset(FitData,
#                       !(CAS %in% subset(chem.physical_and_invitro.data,
#                                       Human.Funbound.plasma==0)$CAS))
# 
# # Rename some columns to match original data files:
# FitData.Fup$SelectedVdist <- FitData.Fup$Vdist
# #FitData.Fup$SelectedVdist.sd <- FitData.Fup$Vdist.sd
# 
# # Current invivoPKfit does not give SD's
# FitData.Fup$SelectedVdist.sd <- 1
# FitData.Fup$Vdist.sd <- 1
# FitData.Fup$kelim.sd <- 1
# 
# #Predict volume of Distribution
# FitData.Fup$Vdist.1comp.pred <- sapply(FitData.Fup$CAS,
#   function(x) suppressWarnings(as.numeric(try(calc_vdist(chem.cas=x,
#   species="Rat",
#   default.to.human = TRUE,
#   suppress.messages=TRUE)))))
# FitData.Fup$Vdist.1comp.pred.nocal <- sapply(FitData.Fup$CAS,
#   function(x) suppressWarnings(as.numeric(try(calc_vdist(chem.cas=x,
#   regression=FALSE,
#   species="Rat",
#   default.to.human = TRUE,
#   suppress.messages=TRUE)))))
# 
# FigVdista.fit <- lm(
#   log(SelectedVdist)~log(Vdist.1comp.pred),
#   data=subset(FitData.Fup,
#               !is.na(SelectedVdist) &
#               !is.na(Vdist.1comp.pred)))
# summary(FigVdista.fit)
# 
# FigVdista.fit.weighted <- lm(
#   log(SelectedVdist)~log(Vdist.1comp.pred),
#   data=subset(FitData.Fup,
#               !is.na(SelectedVdist) &
#                 !is.na(Vdist.1comp.pred)),
#   weights=1/SelectedVdist.sd^2)
# summary(FigVdista.fit)
# 
# FigVdista.fit.pharm <- lm(
#   log(SelectedVdist)~log(Vdist.1comp.pred),
#   data=subset(FitData.Fup,
#               Chemical!="Other" &
#                 !is.na(Vdist.1comp.pred)))
# summary(FigVdista.fit.pharm)
# 
# FigVdista.fit.other <- lm(
#   log(SelectedVdist)~log(Vdist.1comp.pred),
#   data=subset(FitData.Fup,
#               Chemical=="Other" &
#                 !is.na(Vdist.1comp.pred)))
# summary(FigVdista.fit.other)
# 
# dim(subset(FitData.Fup,
#            !is.na(SelectedVdist.sd) &
#              !is.na(Vdist.1comp.pred)))[1]
# 
# FigVdista <- ggplot(data=subset(FitData.Fup,!is.na(Vdist.1comp.pred))) +
#     geom_segment(color="Grey",
#                  aes(x=Vdist.1comp.pred,
#                      y=exp(log(SelectedVdist)-SelectedVdist.sd),
#                      xend=Vdist.1comp.pred,
#                      yend=exp(log(SelectedVdist)+SelectedVdist.sd))) +
#     geom_text(aes_string(y="SelectedVdist",
#                          x="Vdist.1comp.pred",
#                          label="Compound.abbrev",
#                          color="Chemical")) +
#    scale_y_log10(label=label_log(),limits = c(5*10^-2, 10^2)) +
#    scale_x_log10(label=label_log(),limits = c(5*10^-2, 10^2)) +
#    annotation_logticks() +
#    geom_abline(slope=1, intercept=0) +
#    annotate("text", x = 1*10^-1, y = 3*10^1, label = "A",size=6)  +
#    ylab(expression(paste(italic("In vivo")," estimated Volume of Distribution (L/kg)"))) +
#    xlab(expression(paste("Calibrated ",italic("In vitro")," predicted ",V[d]," (L/kg)"))) +
#    theme_bw()  +
#    theme(legend.position="bottom")+
#     guides(shape=guide_legend(nrow=2,byrow=TRUE),color=guide_legend(nrow=2,byrow=TRUE))
# 
# FigVdistb.fit <- lm(log(SelectedVdist) ~ log(Vdist.1comp.pred.nocal),
#                     data=subset(FitData.Fup,!is.na(Vdist.1comp.pred)))
# summary(FigVdistb.fit)
# 
# FigVdistb.fit.weighted <- lm(
#   log(SelectedVdist)~log(Vdist.1comp.pred.nocal),
#   data=subset(FitData.Fup,
#               !is.na(Vdist.1comp.pred)),
#   weights=1/SelectedVdist.sd^2)
# summary(FigVdistb.fit)
# 
# FigVdistb.fit.pharm <- lm(
#   log(SelectedVdist)~log(Vdist.1comp.pred.nocal),
#   data=subset(FitData.Fup,
#               Chemical!="Other" &
#               !is.na(Vdist.1comp.pred)))
# summary(FigVdistb.fit.pharm)
# 
# FigVdistb.fit.other<- lm(
#   log(SelectedVdist)~log(Vdist.1comp.pred.nocal),
#   data=subset(FitData.Fup,
#               Chemical=="Other" &
#               !is.na(Vdist.1comp.pred)))
# summary(FigVdistb.fit.other)
# 
# FigVdistb <- ggplot(data=subset(FitData.Fup,!is.na(Vdist.1comp.pred.nocal))) +
#    geom_segment(color="Grey",aes(x=Vdist.1comp.pred.nocal,y=exp(log(SelectedVdist)-SelectedVdist.sd),xend=Vdist.1comp.pred.nocal,yend=exp(log(SelectedVdist)+SelectedVdist.sd)))+
#    geom_text(aes_string(y="SelectedVdist",
#                          x="Vdist.1comp.pred.nocal",
#                          label="Compound.abbrev",
#                          color="Chemical"))+
#    scale_y_log10(label=label_log(),limits = c(5*10^-2, 10^2)) +
#    scale_x_log10(label=label_log(),limits = c(5*10^-2, 10^2)) +
#    annotation_logticks() +
#    geom_abline(slope=1, intercept=0) +
#    annotate("text", x = 1*10^-1, y = 3*10^1, label = "B",size=6) +
#    ylab(expression(paste(italic("In vivo")," estimated Volume of Distribution (L/kg)"))) +
#    xlab(expression(paste("Original ",italic("In vitro")," predicted ",V[d]," (L/kg)"))) +
#    theme_bw()  +
#    theme(legend.position="bottom")+
#     guides(shape=guide_legend(nrow=2,byrow=TRUE),color=guide_legend(nrow=2,byrow=TRUE))
# 
# 
# 
# #dev.new(width=10,height=6)
# multiplot(FigVdista,FigVdistb,cols=2,widths=c(1.75,1.75))
# 
# 
# Fig4a.data <- subset(FitData.Fup,!is.na(SelectedVdist)&!is.na(Vdist.1comp.pred))
# Fig4a.MSE <- mean((log(Fig4a.data$Vdist.1comp.pred)-log(Fig4a.data$SelectedVdist))^2)
# 
# 
# Fig4b.data <- subset(FitData.Fup,!is.na(SelectedVdist)&!is.na(Vdist.1comp.pred.nocal))
# Fig4b.MSE <- mean((log(Fig4b.data$Vdist.1comp.pred.nocal)-log(Fig4b.data$SelectedVdist))^2)
# 
# 

## ----fig5, eval = execute.vignette--------------------------------------------
# #FitData.Fup$CLtot.1comp <- FitData.Fup$Vdist.1comp.meas*FitData.Fup$kelim.1comp.meas
# #FitData.Fup$CLtot.1comp.sd <- (FitData.Fup$Vdist.1comp.meas.sd^2+FitData.Fup$kelim.1comp.meas.sd^2)^(1/2)
# #FitData.Fup[is.na(CLtot.1comp.sd)]$CLtot.1comp.sd <- Inf
# 
# #FitData.Fup[is.na(SelectedCLtot.sd)]$SelectedClearance.sd <- Inf
# 
# FitData.Fup$SelectedCLtot <- FitData.Fup$Vdist*FitData.Fup$kelim/24 # invivoPKfit rates are in units of 1/day
# FitData.Fup$SelectedCLtot.sd <- (FitData.Fup$Vdist.sd^2 +
#   FitData.Fup$kelim.sd^2)^(1/2)
# good.chems <- unique(c(get_cheminfo(suppress.messages=TRUE),
#                        get_cheminfo(species="rat", suppress.messages=TRUE)))
# FitData.Fup$CLtot.1comp.pred <- sapply(FitData.Fup$CAS,
#   function(x) as.numeric(try(
#     ifelse(x %in% good.chems,
#                     calc_total_clearance(chem.cas=x,
#                                          species="Rat",
#                                          default.to.human = TRUE,
#                                          suppress.messages=TRUE),
#            NA))))
# 
# Fig.SelectedClearance.fit <- lm(
#   log(SelectedCLtot)~log(CLtot.1comp.pred),
#   data=subset(FitData.Fup,!is.na(SelectedCLtot.sd)))
# summary(Fig.SelectedClearance.fit)
# Fig.SelectedClearance.fit.weighted <- lm(
#   log(SelectedCLtot)~log(CLtot.1comp.pred),
#   data=subset(FitData.Fup,!is.na(SelectedCLtot.sd)),
#   weights=1/SelectedCLtot.sd^2)
# summary(Fig.SelectedClearance.fit.weighted)
# Fig.SelectedClearance.fit.pharma <- lm(
#   log(SelectedCLtot)~log(CLtot.1comp.pred),
#   data=subset(FitData.Fup,Chemical!="Other" &
#                 !is.na(SelectedCLtot.sd)),
#   weights=1/SelectedCLtot.sd^2)
# summary(Fig.SelectedClearance.fit.pharma)
# Fig.SelectedClearance.fit.other<- lm(
#   log(SelectedCLtot)~log(CLtot.1comp.pred),
#   data=subset(FitData.Fup,Chemical=="Other" &
#                 !is.na(SelectedCLtot.sd)),
#   weights=1/SelectedCLtot.sd^2)
# summary(Fig.SelectedClearance.fit.other)
# Fig.SelectedClearance.fit.pharma <- lm(
#   log(SelectedCLtot)~log(CLtot.1comp.pred),
#   data=subset(FitData.Fup,Chemical!="Other"))
# summary(Fig.SelectedClearance.fit.pharma)
# Fig.SelectedClearance.fit.other<- lm(
#   log(SelectedCLtot)~log(CLtot.1comp.pred),
#   data=subset(FitData.Fup,Chemical=="Other"))
# summary(Fig.SelectedClearance.fit.other)
# 
# Fig.SelectedClearance <-
#   ggplot(
#     data=FitData.Fup,
#     aes(y=SelectedCLtot,x=CLtot.1comp.pred)) +
#   geom_segment(
#     data=subset(FitData.Fup,is.finite(SelectedCLtot.sd)),
#     color="grey",
#     aes(
#       x=CLtot.1comp.pred,
#       y=exp(log(SelectedCLtot)-SelectedCLtot.sd),
#       xend=CLtot.1comp.pred,
#       yend=exp(log(SelectedCLtot)+SelectedCLtot.sd))) +
#   geom_text(
#     aes_string(y="SelectedCLtot",
#                x="CLtot.1comp.pred",
#                label="Compound.abbrev",
#                color="Chemical"))+
# #    geom_point(data=twocomp.data,color="White",size=2,aes(shape=Source))+
#   scale_y_log10(label=label_log(),limits = c(10^-4, 10^3)) +
#   scale_x_log10(label=label_log(),limits = c(10^-4, 10^3)) +
#   annotation_logticks() +
#   geom_abline(slope=1, intercept=0) +
#   geom_line(aes(
#     x = CLtot.1comp.pred,
#     y = exp(Fig.SelectedClearance.fit.pharma$coefficients[1] +
#               Fig.SelectedClearance.fit.pharma$coefficients[2]*log(CLtot.1comp.pred))),
#     colour = "darkturquoise",
#     linetype="dotted", size=1.5) +
#   geom_line(aes(
#     x = CLtot.1comp.pred,
#     y = exp(Fig.SelectedClearance.fit.other$coefficients[1] +
#               Fig.SelectedClearance.fit.other$coefficients[2]*log(CLtot.1comp.pred))),
#     colour = "red",
#     linetype="dashed", size=1.5) +
#   ylab(expression(paste(italic("In vivo")," estimated clearance (mg/L/h)"))) +
#   xlab(expression(paste(italic("In vitro")," predicted clearance (mg/L/h)"))) +
#   theme_bw()   +
#   theme(legend.position="bottom")+
#   annotate("text",
#            x = 10^2/3/3/3,
#            y = 3*3*10^-4
#            ,size=4,
#            label = lm_R2(Fig.SelectedClearance.fit.pharma,prefix="Pharmaceutical:"),
#            parse=TRUE) +
#   annotate("text",
#            x = 10^2/3/3/3,
#            y = 3*3*3*10^-5,
#            size=4,
#            label = lm_R2(Fig.SelectedClearance.fit.other,prefix="Other:"),
#            parse=TRUE) +
#   theme(plot.margin = unit(c(1,1,1,1), "cm")) +
#   guides(
#     shape=guide_legend(nrow=2,byrow=TRUE),
#     color=guide_legend(nrow=2,byrow=TRUE))
# 
# 
# #dev.new(width=6,height=6)
# print(Fig.SelectedClearance)
# 
# paste("with",
#       with(FitData.Fup, sum(SelectedCLtot<CLtot.1comp.pred,na.rm=TRUE)),
#       "chemicals over-estimated and",
#       with(FitData.Fup, sum(SelectedCLtot>CLtot.1comp.pred,na.rm=TRUE)),
#       "under-estimated")
# 

## ----fig6, eval = execute.vignette--------------------------------------------
# FitData$Selectedkgutabs <- FitData$kgutabs/24 # invivoPKfit does time in days
# # Cutoff from optimizer is 1000:
# Figkgutabs <- ggplot(subset(FitData,Selectedkgutabs<999), aes(Selectedkgutabs, fill = Chemical)) +
#   geom_histogram(binwidth=0.5) +
#      scale_x_log10(label=label_log()) +
#      ylab("Number of Chemicals")+
#      xlab("Absorption Rate from Gut (1/h)")+
#      theme_bw() +
#         theme(legend.position="bottom")
# 
# #dev.new(width=6,height=6)
# print(Figkgutabs)
# 
# mean(subset(FitData,Selectedkgutabs<999)$Selectedkgutabs)
# min(subset(FitData,Selectedkgutabs<999)$Selectedkgutabs)
# max(subset(FitData,Selectedkgutabs<999)$Selectedkgutabs)
# median(subset(FitData,Selectedkgutabs<999)$Selectedkgutabs)
# cat(paste0("Median absortipon rate from the gut is ",
#     signif(median(subset(FitData,Selectedkgutabs<999)$Selectedkgutabs),2),
#     " h.\n"))

## ----fig7, eval = execute.vignette--------------------------------------------
# FitData$SelectedFbio <- FitData$Fgutabs
# good.chems <- get_cheminfo(info="dtxsid",suppress.messages=TRUE)
# FitData$Fbio.pred <-
#   unlist(sapply(FitData$DTXSID, function(x)
#     as.numeric(try(ifelse(
#       x %in% good.chems,
#       calc_fbio.oral(dtxsid=x,
#                      suppress.messages = TRUE),
#       NA)))))
# 
# FigFbioa <- ggplot(data=FitData) +
#     geom_text(aes_string(y="SelectedFbio",
#                          x="Fbio.pred",
#                          label="Compound.abbrev",
#                          color="Chemical"))+
#    scale_y_log10(label=label_log(),limits=c(10^-3,1)) +
#    scale_x_log10(label=label_log(),limits=c(10^-3,1)) +
# #    xlim(0, 1)+
# #    ylim(0, 1)+
#     annotate("text", x = .015/10, y = 0.55, label = "A",size=6) +
#     annotation_logticks() +
#     geom_abline(slope=1, intercept=0) +
#     ylab(expression(paste(italic("In vivo")," estimated Fraction Bioavailable"))) +
#     xlab(expression(paste(italic("In silico")," predicted ",F[bio]))) +
# #    scale_color_brewer(palette="Set2") +
#     theme_bw()  +
#     theme(legend.position="bottom")+
#     guides(shape=guide_legend(nrow=2,byrow=TRUE),color=guide_legend(nrow=2,byrow=TRUE))
# 
# 
# FigFbiob <- ggplot(FitData, aes(SelectedFbio, fill = Chemical)) +
#   geom_histogram(binwidth=0.5) +
#     scale_x_log10(label=label_log(),limits=c(10^-3,3)) +
#     annotate("text", x = .001, y = 18, label = "B",size=6) +
#     ylab("Number of Chemicals")+
#     xlab(expression(paste(italic("In vivo")," estimated Fraction Bioavailable"))) +
#     theme_bw()  +
#     theme(legend.position="bottom")+
#     guides(shape=guide_legend(nrow=2,byrow=TRUE),fill=guide_legend(nrow=2,byrow=TRUE))
# 
# 
# 
# #dev.new(width=10,height=6)
# multiplot(FigFbioa,FigFbiob,cols=2,widths=c(1.75,1.75))
# 
# summary(lm(log(SelectedFbio)~log(Fbio.pred), data=FitData))
# 
# paste("Fbio ranged from",signif(min(FitData[FitData$Chemical=="Pharmaceutical","SelectedFbio"],na.rm=TRUE),2),"to",signif(max(FitData[FitData$Chemical=="Pharmaceutical","SelectedFbio"],na.rm=TRUE),2),"for pharmaceutical compounds, but was observed to be as low as", signif(min(FitData[FitData$Chemical=="Other","SelectedFbio"],na.rm=TRUE),3),"for other compounds.")
# 
# min(FitData$SelectedFbio,na.rm=TRUE)

## ----fig8, eval = execute.vignette--------------------------------------------
# FitData$SelectedFbio <- FitData$Fgutabs
# FitData$SelectedCss <- FitData$Css.tkstats
# FitData$SelectedCss.sd <- 1
# good.chems <- get_cheminfo(species="rat", default.to.human=TRUE)
# FitData$Css.1comp.pred <- sapply(
#   FitData$CAS,
#   function(x) ifelse(x %in% good.chems,
#                      calc_analytic_css(
#                        chem.cas=x,
#                        species="Rat",
#                        model="3compartmentss",
#                        suppress.messages=TRUE,
#                        parameterize.args.list = list(
#                          default.to.human=TRUE,
#                          adjusted.Funbound.plasma=TRUE,
#                          regression=TRUE,
#                          minimum.Funbound.plasma=1e-4
#                        )
#                      ),
#                      NA)
#   )
# Fig.1compCss.fit <- lm(
#   log10(SelectedCss)~log10(Css.1comp.pred),
#   data=subset(FitData,
#               !is.na(log10(Css.1comp.pred)) &
#               !is.infinite(log10(Css.1comp.pred))))
# Fig.1compCss.fit.weighted <- lm(
#   log10(SelectedCss)~log10(Css.1comp.pred),
#   data=subset(FitData,
#               !is.na(log10(Css.1comp.pred)) &
#               !is.infinite(log10(Css.1comp.pred))),
#   weights=1/SelectedCss.sd^2)
# Fig.1compCss.fit.pharma <- lm(
#   log10(SelectedCss)~log10(Css.1comp.pred),
#   data=subset(FitData,Chemical!="Other" &
#               !is.na(log10(Css.1comp.pred)) &
#               !is.infinite(log10(Css.1comp.pred))))
# Fig.1compCss.fit.other <- lm(
#   log10(SelectedCss)~log10(Css.1comp.pred),
#   data=subset(FitData,
#               Chemical=="Other" &
#               !is.na(log10(Css.1comp.pred)) &
#               !is.infinite(log10(Css.1comp.pred))))
# 
# summary(Fig.1compCss.fit)
# summary(Fig.1compCss.fit.pharma)
# summary(Fig.1compCss.fit.other)
# 
# 
# textx <- 10^-3
# texty <- 1*10^1
# 
# Fig.Cssa <- ggplot(data=FitData) +
#   geom_segment(color="grey",aes(x=Css.1comp.pred,y=exp(log(SelectedCss)-SelectedCss.sd),xend=Css.1comp.pred,yend=exp(log(SelectedCss)+SelectedCss.sd)))+
#   geom_text(size=4,aes_string(y="SelectedCss", x="Css.1comp.pred",label="Compound.abbrev",color="Chemical"))+
#   scale_y_log10(label=label_log(),limits = c(5*10^-6, 110)) +
#   scale_x_log10(label=label_log(),limits = c(5*10^-6, 110)) +
#   annotation_logticks() +
#   geom_abline(slope=1, intercept=0) +
#   ylab(expression(paste(italic("In vivo")," estimated ",C[ss]," (mg/L)"))) +
#  xlab(expression(paste(italic("In vitro")," predicted ",C[ss]," (mg/L)"))) +
# #  scale_color_brewer(palette="Set2") +
#   theme_bw()  +
#   theme(legend.position="bottom")+
#     annotate("text", x = textx/15, y = 5*texty, label = "A",size=6) +
#   annotate("text",x = textx, y = texty,size=6, label = lm_R2(Fig.1compCss.fit),parse=TRUE)+
#     guides(shape=guide_legend(nrow=2,byrow=TRUE),color=guide_legend(nrow=2,byrow=TRUE))
# #  annotate("text",x = textx/3, y = texty/3,size=4, label = lm_R2(Fig.1compCss.fit.weighted,prefix="Weighted:"),parse=TRUE)
# #  annotate("text",x = textx, y = texty,size=4, label = lm_R2(Fig.1compCss.fit.pharma,prefix="Pharmaceutical:"),parse=TRUE)
# #  annotate("text",x = textx, y = texty/3,size=4, label = lm_R2(Fig.1compCss.fit.other,prefix="Other:"),parse=TRUE)
# 
# FitData$Css.Bio <- FitData$Css.1comp.pred*FitData$SelectedFbio
# Fig.1compCssb.fit <- lm(log(SelectedCss)~log(Css.Bio),data=FitData,na.rm=TRUE)
# Fig.1compCssb.fit.weighted <- lm(log(SelectedCss)~log(Css.Bio),data=FitData,na.rm=TRUE,weights=1/SelectedCss.sd^2)
# Fig.1compCssb.fit.pharma <- lm(log(SelectedCss)~log(Css.Bio),data=subset(FitData,Chemical!="Other"),na.rm=TRUE)
# Fig.1compCssb.fit.other <- lm(log(SelectedCss)~log(Css.Bio),data=subset(FitData,Chemical=="Other"),na.rm=TRUE)
# 
# Fig.Cssb <- ggplot(data=FitData) +
#   geom_segment(color="grey",aes(x=Css.Bio,y=exp(log(SelectedCss)-SelectedCss.sd),xend=Css.Bio,yend=exp(log(SelectedCss)+SelectedCss.sd)))+
#   geom_text(size=4,aes_string(y="SelectedCss", x="Css.Bio",label="Compound.abbrev",color="Chemical"))+
#   scale_y_log10(label=label_log(),limits = c(5*10^-6, 110)) +
#   scale_x_log10(label=label_log(),limits = c(5*10^-6, 110)) +
#   annotation_logticks() +
#   geom_abline(slope=1, intercept=0) +
#   ylab(expression(paste(italic("In vivo")," estimated ",C[ss]," (mg/L)"))) +
#  xlab(expression(paste(italic("In vitro")," predicted ",C[ss]," (mg/L) Using Measured ", F[bio]))) +
#  # scale_color_brewer(palette="Set2") +
#   theme_bw()  +
#   theme(legend.position="bottom")+
#     annotate("text", x = textx/15, y = 5*texty, label = "B",size=6) +
#   annotate("text",x = textx, y = texty,size=6, label = lm_R2(Fig.1compCssb.fit),parse=TRUE)+
#     guides(shape=guide_legend(nrow=2,byrow=TRUE),color=guide_legend(nrow=2,byrow=TRUE))
# 
# #dev.new(width=10,height=6)
# multiplot(Fig.Cssa,Fig.Cssb,cols=2,widths=c(1.75,1.75))
# 
# 

## ----fig9, eval = execute.vignette--------------------------------------------
# FitData$TriageCat <- FitData$Triage.Call
# FitData$CssResidual <- log10(FitData$Css.1comp.pred/FitData$SelectedCss)
# FitData[FitData$TriageCat%in%c("Does Not Reach Steady State","Plasma Binding Assay Failed"),"TriageCat"]<-"Problem"
# FitData$TriageCat <- factor(FitData$TriageCat,levels=c(">10x Underestimated",">3.2x Underestimated","On the Order",">3.2x Overestimated",">10x Overestimated","Problem"))
# 
# 
# Fig.Triage <- ggplot(data=subset(FitData,!is.na(TriageCat)&is.finite(CssResidual))) +
#   geom_text(size=4,aes_string(y="CssResidual", x="TriageCat",label="Compound.abbrev",color="Chemical"))+
#   geom_segment(aes(x = factor(">10x Underestimated",levels=levels(FitData$TriageCat)), y = log10(1/10), xend = factor(">10x Underestimated",levels=levels(FitData$TriageCat)), yend = log10(1/30)), size=3,colour = "grey") +
#  # geom_segment(aes(x = factor(">3.2x Underestimated",levels=levels(FitData$TriageCat)), y = log10(1/10), xend = factor(">3.2x Underestimated",levels=levels(FitData$TriageCat)), yend = log10(1/3.2)), size=3,colour = "grey") +
#   geom_segment(aes(x = factor("On the Order",levels=levels(FitData$TriageCat)), y = log10(1/3.2), xend = factor("On the Order",levels=levels(FitData$TriageCat)), yend = log10(3.2)), size=3,colour = "grey") +
#   geom_segment(aes(x = factor(">3.2x Overestimated",levels=levels(FitData$TriageCat)), y = log10(3.2), xend = factor(">3.2x Overestimated",levels=levels(FitData$TriageCat)), yend = log10(10)), size=3,colour = "grey") +
#   geom_segment(aes(x = factor(">10x Overestimated",levels=levels(FitData$TriageCat)), y = log10(10), xend = factor(">10x Overestimated",levels=levels(FitData$TriageCat)), yend = log10(500)), size=3,colour = "grey") +
#   geom_hline(yintercept=0)+
#   geom_hline(yintercept=log10(1/10),linetype="dashed")+
#     geom_hline(yintercept=log10(1/3.2),linetype="dashed")+
#   geom_hline(yintercept=log10(3.2),linetype="dashed")+
#   geom_hline(yintercept=log10(10),linetype="dashed")+
#   geom_text(size=4,aes_string(y="CssResidual", x="TriageCat",label="Compound.abbrev",color="Chemical"))+
#   scale_y_continuous(name=expression(paste("Actual error in ",C[ss]," prediction")),breaks=c(log10(1/10),log10(1/3.2),0,log10(3.2),1),labels=c(">10x Under",">3.2x Under","On the Order",">3.2x Over",">10x Over")) +
#   xlab("Predicted Error") +
#   theme_bw()  +
#   theme(legend.position="bottom")+
#   theme(axis.text.x = element_text(angle = 45, hjust = 1))+
#     guides(shape=guide_legend(nrow=2,byrow=TRUE),color=guide_legend(nrow=2,byrow=TRUE))
# 
# 
# #dev.new(width=6,height=6)
# print(Fig.Triage)
# 
# 
# 

## ----makestatpreds, eval = execute.vignette-----------------------------------
# PKstats <- httk::chem.invivo.PK.summary.data
# PKstats$Cmax <- PKstats$Cmax.tkstats
# PKstats$AUC <- PKstats$AUC_infinity.tkstats
# 
# good.chems <- get_cheminfo(info="dtxsid",
#                            species="rat",
#                            model="pbtk",
#                            default.to.human = TRUE,
#                            suppress.messages=TRUE)
# num.treatments <- dim(PKstats)[1]
# preds <- data.frame(AUC= rep(NA,num.treatments),
#                     mean = rep(NA,num.treatments),
#                     max = rep(NA,num.treatments),
#                     Fbio = rep(NA,num.treatments))
# for (i in 1:dim(PKstats)[1])
# {
#   if (PKstats[i,"DTXSID"] %in% good.chems)
#   {
#     preds[i,c("AUC","peak","mean")] <-
#       unlist(as.numeric(try(calc_tkstats(dtxsid=PKstats[i,"DTXSID"],
#                  species=PKstats[i,"Species"],
#                  route=PKstats[i,"Route"],
#                  dose=PKstats[i,"Dose"],
#                  concentration=PKstats[i,"Media"],
#                  parameterize.args.list=list(default.to.human=TRUE),
#                  suppress.messages=TRUE))))
#     preds[i,"Fbio"] <- as.numeric(try(calc_fbio.oral(
#       dtxsid=PKstats[i,"DTXSID"],
#       suppress.messages=TRUE)$fbio.oral))
#   }
# }
# # Values predicted with current httk:
# PKstats$AUC.pred <- preds[,"AUC"]
# PKstats$Cmax.pred <- preds[,"peak"]
# # Value predicted as if httk used in vivo bioavailability:
# PKstats$Cmax.pred.Fbio <- preds[,"peak"] / preds[,"Fbio"] * PKstats[,"Fgutabs"]
# PKstats$AUC.pred.Fbio <- preds[,"AUC"] / preds[,"Fbio"] * PKstats[,"Fgutabs"]
# 
# # Add a column indicating chemical type:
# PKstats$Chemical <- "Other"
# PKstats[unlist(sapply(PKstats$CAS,function(x)
#   ifelse(is.na(x),
#          FALSE,
#          is.pharma(x)))),"Chemical"] <- "Pharmaceutical"
# 

## ----fig10, eval = execute.vignette-------------------------------------------
# FigCmaxa.fit <- lm(log10(Cmax)~log10(Cmax.pred),
#                    data=subset(PKstats,
#                                is.finite(log10(Cmax)) &
#                                !is.na(log10(Cmax.pred)) &
#                                is.finite(log10(Cmax.pred))))
#   summary(FigCmaxa.fit)
# 
# FigCmaxa <- ggplot(data=subset(PKstats,is.finite(Cmax))) +
#     geom_point(size=3,aes_string(y="Cmax",
#                          x="Cmax.pred",
#                          shape="Route",
#                          color="Chemical"))+
#    scale_y_log10(label=label_log(),limits = c(10^-4, 10^4)) +
#    scale_x_log10(label=label_log(),limits = c(10^-4, 10^4)) +
#     annotation_logticks() +
#     geom_abline(slope=1, intercept=0) +
#     ylab(expression(paste(italic("In vivo")," estimated ",C[max]))) +
#     xlab(expression(paste(italic("In vitro")," predicted ",C[max]))) +
# #    scale_color_brewer(palette="Set2") +
#     annotate("text", x = 10^-3, y = 300, label = "A",size=6) +
#     annotate("text",x = 3*10^1, y = 10^-3, label = lm_R2(FigCmaxa.fit),parse=TRUE,size=6) +
#     theme_bw()  +
#     theme(legend.position="bottom")+
#     guides(shape=guide_legend(nrow=2,byrow=TRUE),color=guide_legend(nrow=2,byrow=TRUE))
# 
# 
# 
# 
# FigCmaxb.fit <- lm(
#   log10(Cmax)~log10(Cmax.pred.Fbio),
#   data=subset(PKstats,is.finite(Cmax)))
# summary(FigCmaxb.fit)
# 
# FigCmaxb <- ggplot(data=subset(PKstats,is.finite(Cmax))) +
#     geom_point(size=3,aes_string(y="Cmax",
#                          x="Cmax.pred.Fbio",
#                          shape="Route",
#                          color="Chemical"))+
#    scale_y_log10(label=label_log(),limits = c(10^-4, 10^4)) +
#    scale_x_log10(label=label_log(),limits = c(10^-4, 10^4)) +
#     annotation_logticks() +
#     geom_abline(slope=1, intercept=0) +
#     ylab(expression(paste(italic("In vivo")," estimated ",C[max]))) +
#     xlab(expression(paste("Predicted ", C[max], " Using Measured ", F[bio ]))) +
#     annotate("text", x = 10^-3, y = 300, label = "B",size=6) +
#     annotate("text",x = 3*10^1, y = 10^-3, label = lm_R2(FigCmaxb.fit),parse=TRUE,size=6) +
# #    scale_color_brewer(palette="Set2") +
#     theme_bw()  +
#     theme(legend.position="bottom")+
#     guides(shape=guide_legend(nrow=2,byrow=TRUE),color=guide_legend(nrow=2,byrow=TRUE))
# 
# #dev.new(width=10,height=6)
# multiplot(FigCmaxa,FigCmaxb,cols=2,widths=c(1.75,1.75))
# 

## ----fig11, eval = execute.vignette-------------------------------------------
# FigAUCa.fit <- lm(
#   log10(AUC)~log10(AUC.pred),
#   data=subset(PKstats,is.finite(log10(AUC))))
# FigAUCb.fit <- lm(
#   log10(AUC)~log10(AUC.pred.Fbio),
#   data=subset(PKstats,is.finite(log10(AUC))))
# summary(FigAUCa.fit)
# summary(FigAUCb.fit)
# 
# FigAUCa <- ggplot(data=subset(PKstats,is.finite(log(AUC)))) +
#     geom_point(size=3,aes_string(y="AUC",
#                          x="AUC.pred",
#                          shape="Route",
#                          color="Chemical"))+
#    scale_y_log10(label=label_log(),limits = c(10^-3, 10^4)) +
#    scale_x_log10(label=label_log(),limits = c(10^-3, 10^4)) +
#     annotation_logticks() +
#     geom_abline(slope=1, intercept=0) +
#     ylab(expression(paste(italic("In vivo")," estimated AUC (mg*h/L)"))) +
#     xlab(expression(paste(italic("In vitro")," predicted Area under the Curve (AUC, mg*h/L)"))) +
#     annotate("text", x = 10^-2, y = 3000, label = "A",size=6) +
#     annotate("text",x = 3*10^1, y = 10^-2, label = lm_R2(FigAUCa.fit),parse=TRUE,size=6) +
#     theme_bw()  +
#     theme(legend.position="bottom")+
#     guides(shape=guide_legend(nrow=2,byrow=TRUE),color=guide_legend(nrow=2,byrow=TRUE))
# 
# 
# FigAUCb <- ggplot(data=subset(PKstats,is.finite(log(AUC)))) +
#     geom_point(size=3,aes_string(y="AUC",
#                          x="AUC.pred.Fbio",
#                          shape="Route",
#                          color="Chemical"))+
#    scale_y_log10(label=label_log(),limits = c(10^-3, 10^4)) +
#    scale_x_log10(label=label_log(),limits = c(10^-3, 10^4)) +
#     annotation_logticks() +
#     geom_abline(slope=1, intercept=0) +
#     ylab(expression(paste(italic("In vivo")," estimated AUC (mg*h/L)"))) +
#     xlab(expression(paste("Predicted AUC (mg*h/L) Using Measured ", F[bio]))) +
#     annotate("text", x = 10^-2, y = 3000, label = "B",size=6) +
#     annotate("text",x = 3*10^1, y = 10^-2, label = lm_R2(FigAUCb.fit),parse=TRUE,size=6) +
#     theme_bw()  +
#     theme(legend.position="bottom")+
#     guides(shape=guide_legend(nrow=2,byrow=TRUE),color=guide_legend(nrow=2,byrow=TRUE))
# 
# #dev.new(width=10,height=6)
# multiplot(FigAUCa,FigAUCb,cols=2,widths=c(1.75,1.75))
# 

## ----knitrPrep, include=FALSE, eval = TRUE------------------------------------
knitr::opts_chunk$set(echo = TRUE, fig.width=5, fig.height=4)

## ----clear_memory, eval = TRUE------------------------------------------------
rm(list=ls()) 

## ----runchunks, eval = TRUE---------------------------------------------------
# Set whether or not the following chunks will be executed (run):
execute.vignette <- FALSE

## ----setup, eval = execute.vignette-------------------------------------------
# library(httk)
# library(ggplot2)
# library(scales)
# library(httkexamples)

## ----Frank2018data, eval = execute.vignette-----------------------------------
# chem.table <- httkexamples::Frank2018invivo

## ----ivive.loop, eval = execute.vignette--------------------------------------
# for (this.row in 1:dim(chem.table)[1])
# {
#   this.cas <- chem.table[this.row,"Substance_CASRN"]
#   if (tolower(chem.table[this.row,"Species"])=="rodent")
#   {
#     this.species <- "rat"
#   } else if (tolower(chem.table[this.row,"Species"])=="rat")
#   {
#     this.species <- "rat"
#   } else if (tolower(chem.table[this.row,"Species"])=="human")
#   {
#     this.species <- "human"
#   }
#   else if (tolower(chem.table[this.row,"Species"])=="mouse")
#   {
#     this.species <- "mouse"
#   }
#   else browser()
#   if (chem.table[this.row,"Route"] %in% c("i.p.","s.c.","i.m.")) iv.dose =TRUE
#   else if (chem.table[this.row,"Route"]=="oral") iv.dose = F
#   else browser()
#   this.dose <- chem.table[this.row,"Dose"]
#   this.days <- chem.table[this.row,"Days"]
# # Make sure the dose units are in mg/kg body weight:
#   if (regexpr("ug",chem.table[this.row,"Dose.Units"])!=-1)
#   {
#     this.dose <- this.dose/1000
#   }
#   if (regexpr("/kg",chem.table[this.row,"Dose.Units"])==-1)
#   {
#     this.dose <- this.dose/0.25
#   }
# # Here we run the HTTK PBPK Model:
#   out <- suppressWarnings(solve_pbtk(chem.cas=this.cas,
#            dose=this.dose,
#            species=this.species,
# # This was used in 2017 but I don't agree with it anymore:
# #           restrictive.clearance=FALSE,
#            days=this.days,
#            iv.dose=iv.dose,
#            default.to.human=TRUE))
# 
# # Record the Cmax and the AUC:
#   chem.table[this.row,"Cmax"] <- max(out[,"Cplasma"])
#   chem.table[this.row,"AUC"] <- max(out[,"AUC"])
# }

## ----Frank2018.Fig6, eval = execute.vignette----------------------------------
# Fig.AUC <- ggplot(data=chem.table) +
#   geom_segment(color="grey",aes(x=AUC,y=Lower.95..CI,xend=AUC,yend=Higher.95..CI))+
# #  geom_point(aes(x=AUC,y=Critical.concentration,color="Chemical"))+
#    geom_text(aes(x=AUC,y=Critical.concentration,label=Compound.abbrev,color=Chemical)) +
#    scale_y_log10(label=label_log(),limits=c(10^-7,100)) +
#    scale_x_log10(label=label_log(),limits=c(10^-7,100)) +
#     annotation_logticks() +
#     geom_abline(slope=1, intercept=0) +
#     geom_abline(slope=1, intercept=1,linetype="dashed") +
#     geom_abline(slope=1, intercept=-1,linetype="dashed") +
#     xlab(expression(paste(italic("In vivo")," AUC estimated with HTTK (uM*day)"))) +
#     ylab(expression(paste(italic("In vitro")," predicted Critical Conc. (uM)"))) +
#     scale_color_brewer(palette="Set2") +
#     theme_bw()  +
#     theme(legend.position="bottom")
# 
# print(Fig.AUC)

## ----include=FALSE------------------------------------------------------------
knitr::opts_chunk$set(collapse = TRUE, comment = '#>')

## ----clear_memory, eval = TRUE------------------------------------------------
rm(list=ls()) 

## ----runchunks, eval = TRUE---------------------------------------------------
# Set whether or not the following chunks will be executed (run):
execute.vignette <- FALSE

## ----load_packages, eval = execute.vignette-----------------------------------
# library("httk")
# library("data.table")

## ----subpop_specs, eval = execute.vignette------------------------------------
# nsamp<-1000
# #List subpop names
# ExpoCast.group<-list("Total",
#                      "Age.6.11",
#                      "Age.12.19",
#                      "Age.20.65",
#                      "Age.GT65",
#                      "BMIgt30",
#                      "BMIle30",
#                      "Females",
#                      "Males",
#                      "ReproAgeFemale",
#                      "Age.20.50.nonobese")
# #List subpop gender specifications
# gendernum <- c(rep(list(NULL),7),
#                list(list(Male=0, Female=1000)),
#                list(list(Male=1000, Female=0)),
#                list(list(Male=0, Female=1000)),
#                list(NULL))
# #List subpop age limits in years
# agelim<-c(list(c(0,79),
#                c(6,11),
#                c(12,19),
#                c(20,65),
#                c(66,79)),
#           rep(list(c(0,79)),4),
#           list(c(16,49)),
#           list(c(20,50)))
# #List subpop weight categories
# bmi_category <- c(rep(list(c('Underweight',
#                              'Normal',
#                              'Overweight',
#                              'Obese')),
#                       5),
#                   list('Obese', c('Underweight','Normal', 'Overweight')),
#                   rep(list(c('Underweight',
#                              'Normal',
#                              'Overweight',
#                              'Obese')),
#                       3),
#                   list(c('Underweight', 'Normal', 'Overweight')))

## ----generate_parallel, eval = execute.vignette-------------------------------
# tmpfun <- function(gendernum, agelim, bmi_category, ExpoCast_grp,
#                    nsamp, method){
#   result <- tryCatch({
#                      pops <- httk::httkpop_generate(
#                   method=method,
#                   nsamp = nsamp,
#                   gendernum = gendernum,
#                   agelim_years = agelim,
#                   weight_category = bmi_category)
# 
#                   filepart <- switch(method,
#                                      'virtual individuals' = 'vi',
#                                      'direct resampling' = 'dr')
# saveRDS(object=pops,
#           file=paste0(paste('data/httkpop',
#                       filepart, ExpoCast_grp,
#                       sep='_'),
#                       '.Rdata'))
# return(getwd())
# }, error = function(err){
#   print(paste('Error occurred:', err))
#   return(1)
# })
# }
# 
# cluster <- parallel::makeCluster(2, # Reduced from 40 to 2 cores
#                        outfile='subpopulations_parallel_out.txt')
# 
# evalout <- parallel::clusterEvalQ(cl=cluster,
#              {library(data.table)
#               library(httk)})
# parallel::clusterExport(cl = cluster,
#               varlist = 'tmpfun')
# #Set seeds on all workers for reproducibility
# parallel::clusterSetRNGStream(cluster,
#                               010180)
# out_vi <- parallel::clusterMap(cl=cluster,
#                   fun = tmpfun,
#                   gendernum=gendernum,
#                   agelim=agelim,
#                   bmi_category=bmi_category,
#                   ExpoCast_grp = ExpoCast.group,
#                   MoreArgs = list(nsamp = nsamp,
#                                   method = 'virtual individuals'))
# out_dr <- parallel::clusterMap(cl=cluster,
#                   fun = tmpfun,
#                   gendernum=gendernum,
#                   agelim=agelim,
#                   bmi_category=bmi_category,
#                   ExpoCast_grp = ExpoCast.group,
#                   MoreArgs = list(nsamp = nsamp,
#                                   method = 'direct resampling'))
# parallel::stopCluster(cluster)

## ----configure_knitr, eval = TRUE---------------------------------------------
knitr::opts_chunk$set(collapse = TRUE, comment = '#>', fig.width=5, fig.height=3)

## ----clear_memory, eval = TRUE------------------------------------------------
rm(list=ls()) 

## ----runchunks, eval = TRUE---------------------------------------------------
# Set whether or not the following chunks will be executed (run):
execute.vignette <- FALSE

## ----setup, eval = execute.vignette-------------------------------------------
# library(data.table)
# library(httk)
# library(httkexamples)
# library(ggplot2)
# library(stringr)
# library(scales)
# library(grid)
# library(reshape)

## ----lmr2, eval = execute.vignette--------------------------------------------
# lm_R2 <- function(m,prefix=NULL){
#     out <- substitute("RMSE = "~mse*","~~italic(R)^2~"="~r2,
#          list(mse = signif(mean(m$residuals^2)^(1/2),3),
#               r2 = format(summary(m)$adj.r.squared, digits = 2)))
#     paste(prefix,as.character(as.expression(out)))
# }

## ----multi.plot, eval = execute.vignette--------------------------------------
# multiplot <- function(..., plotlist=NULL, file, cols=1, layout=NULL, heights=NULL, widths=unit(rep_len(1, cols), "null")) {
# 
#   # Make a list from the ... arguments and plotlist
#   plots <- c(list(...), plotlist)
# 
#   numPlots = length(plots)
# 
#   # If layout is NULL, then use 'cols' to determine layout
#   if (is.null(layout)) {
#     # Make the panel
#     # ncol: Number of columns of plots
#     # nrow: Number of rows needed, calculated from # of cols
#     layout <- matrix(seq(1, cols * ceiling(numPlots/cols)),
#                     ncol = cols, nrow = ceiling(numPlots/cols))
#   }
# 
#  if (numPlots==1) {
#     print(plots[[1]])
# 
#   } else {
#     # Set up the page
#     grid.newpage()
#     if (!is.null(heights))
#     {
#       pushViewport(viewport(layout = grid.layout(nrow(layout), ncol(layout),heights=heights,widths=widths)))
#     } else {
#       pushViewport(viewport(layout = grid.layout(nrow(layout), ncol(layout),widths=widths)))
#     }
#     # Make each plot, in the correct location
#     for (i in 1:numPlots) {
#       # Get the i,j matrix positions of the regions that contain this subplot
#       matchidx <- as.data.frame(which(layout == i, arr.ind = TRUE))
# 
#       print(plots[[i]], vp = viewport(layout.pos.row = matchidx$row,
#                                       layout.pos.col = matchidx$col))
#     }
#   }
# }

## ----cssfun.u, eval = execute.vignette----------------------------------------
# cssfun_u <- function(chemcas,
#                       MW,
#                       hepatic.bioavailability,
#                       Fabsgut=1,
#                       probs=0.95,
#                       minimum.Funbound.plasma=0.0001)
# {
#   if (chemcas %in% intersect(get_cheminfo(suppress.messages=TRUE,
#                                  model="3compartmentss"),
#                      get_cheminfo(suppress.messages=TRUE,
#                                   model="schmitt")))
#   {
#   # Create a data table with uncertainty only:
#   pop_u_httk <- as.data.table(parameterize_steadystate(chem.cas=chemcas,
#     clint.pvalue.threshold=1,
#     minimum.Funbound.plasma=0,
#                                  suppress.messages=TRUE))
# 
#   if (!is.na(pop_u_httk[,"Clint.dist"]) &
#       !is.na(pop_u_httk[,"Funbound.plasma.dist"]))
#   {
#   # Get the physico-chemical properties:
#   params.schmitt <-parameterize_schmitt(chem.cas=chemcas,
#                                  suppress.messages=TRUE)
#   psd <- params.schmitt$pKa_Donor
#   psa <- params.schmitt$pKa_Accept
#   params.schmitt <- params.schmitt[regexpr("pKa",names(params.schmitt))==-1]
#   pop_u_httk[,names(params.schmitt):=params.schmitt]
#   pop_u_httk[,pKa_Donor := paste(psd, collapse=",")]
#   pop_u_httk[,pKa_Accept := paste(psa, collapse=",")]
#   pop_u_httk <- pop_u_httk[rep(1,1000)]
# 
#   # Calculate the distribution coefficient:
#   ions <- calc_ionization(pH=7.4,parameters=pop_u_httk)
#   pop_u_httk[,Dow74 := Pow * (ions$fraction_neutral +
#     0.001 * ions$fraction_charged + ions$fraction_zwitter)]
# 
#   # Parse the Funbound.plasma.dist into quantiles:
#   Funbound.plasma.dist <- unlist(pop_u_httk[1,"Funbound.plasma.dist"])
#   if (nchar(Funbound.plasma.dist) -
#     nchar(gsub(",","",Funbound.plasma.dist))!=2)
#   {
#     stop("Funbound.plasma distribution should be three values (median,low95th,high95th) separated by commas.")
#   }
#   temp <- strsplit(Funbound.plasma.dist,",")
#   ppb.median <- as.numeric(temp[[1]][1])
#   ppb.low95 <- as.numeric(temp[[1]][2])
#   ppb.high95 <- as.numeric(temp[[1]][3])
# 
#   if (ppb.median>minimum.Funbound.plasma)
#   {
#     # Use optim to estimate alpha and beta for fup such that the median and 95%
#     # credible interval approximate the estimate from MCMC:
#     ppb.fit <- optim(c(2,(1-ppb.median)/ppb.median*2),
#       function(x) (0.95-pbeta(ppb.high95,x[1],x[2])+
#       pbeta(ppb.low95,x[1],x[2]))^2+
#       (ppb.median-qbeta(0.5,x[1],x[2]))^2,
#       method="BFGS")
#   # We are drawing new values for the unadjusted Fup:
#     pop_u_httk[, unadjusted.Funbound.plasma:=rbeta(1000,
#       ppb.fit$par[1],
#       ppb.fit$par[2])]
#   } else if (ppb.high95>minimum.Funbound.plasma)
#   {
#     # Assume that since the median is zero but the u95 is not, that there is
#     # an exponential distribution:
#     # 97.5% of clearance values will be below Funbound.plasma.u95:
#     pop_u_httk[,unadjusted.Funbound.plasma:=runif(1000,
#       minimum.Funbound.plasma,
#       min(1,minimum.Funbound.plasma+
#       2*(ppb.high95-minimum.Funbound.plasma)))]
#     pop_u_httk[as.logical(rbinom(1000,1,.95)),
#       unadjusted.Funbound.plasma:=minimum.Funbound.plasma]
#   } else {
#     pop_u_httk[, unadjusted.Funbound.plasma:=minimum.Funbound.plasma]
#   }
# 
# # then we need to adjust for in vitro binding:
#   pop_u_httk[,Flipid:=subset(physiology.data,
#     Parameter=='Plasma Effective Neutral Lipid Volume Fraction')[,
#     which(colnames(physiology.data) == 'Human')]]
#   pop_u_httk[,Funbound.plasma.adjustment:=1 / (Dow74 * Flipid +
#     1 / unadjusted.Funbound.plasma)/unadjusted.Funbound.plasma]
#   pop_u_httk[,
#     Funbound.plasma:=unadjusted.Funbound.plasma*Funbound.plasma.adjustment]
# 
# # Enforce a minimum ppb:
#   pop_u_httk[Funbound.plasma<minimum.Funbound.plasma,
#     Funbound.plasma:=minimum.Funbound.plasma]
# 
# # If Fup varies, then Rb2p and hepatic bioavailability also vary:
#   Rblood2plasma <- get_rblood2plasma(chem.cas=chemcas)
#   if (is.na(Rblood2plasma))
#   {
#     pop_u_httk[, Rblood2plasma:=calc_rblood2plasma(parameters=pop_u_httk,
#                                  suppress.messages=TRUE)]
#   # Right now we don't simulate variability on a known blood:plasma ratio
#   } else pop_u_httk[, Rblood2plasma:=Rblood2plasma]
# 
#   # Parse the clint.dist to retrieve the quantiles:
#   Clint.dist <- unlist(pop_u_httk[1,"Clint.dist"])
#   if (nchar(Clint.dist) -
#     nchar(gsub(",","",Clint.dist))!=3)
#   {
#     stop("Clint distribution should be four values (median,low95th,high95th,pValue) separated by commas.")
#   }
#   temp <- strsplit(Clint.dist,",")
#   Clint.median <- as.numeric(temp[[1]][1])
#   Clint.low95 <- as.numeric(temp[[1]][2])
#   Clint.high95 <- as.numeric(temp[[1]][3])
#   Clint.pvalue <- as.numeric(temp[[1]][4])
# 
#     # Use optim to estimate mean and standard deviation of Clint such that the
#   # median and 95% credible interval approximate the estimate from MCMC:
#   if (Clint.high95>0)
#   {
#     if (Clint.median>0)
#     {
#       clint.fit <- optim(c(log(Clint.median),0.3), function(x)
#         (0.95-plnorm(Clint.high95,x[1],x[2])+plnorm(Clint.low95,x[1],x[2]))^2+
#         (Clint.median-qlnorm(0.5,x[1],x[2]))^2)
#       pop_u_httk[,Clint:=rlnorm(1000,clint.fit$par[1],clint.fit$par[2])]
#     } else {
#       pop_u_httk[,Clint:=exp(runif(1000,log(1),
#       (log(Clint.high95)-log(1))/0.975))]
#     }
#   } else pop_u_httk[,Clint:=0]
#   pop_u_httk[as.logical(rbinom(1000,1,Clint.pvalue)),Clint:=0] # the Bayesian "p-value" here reflects how often there is no clearance
# 
#   pop_u_httk[, CLh:=calc_hep_clearance(chem.cas=chemcas,
#     parameters=pop_u_httk,hepatic.model='unscaled',
#     suppress.messages=TRUE,clint.pvalue.threshold=1)]
#   pop_u_httk[, Qliver:=Qtotal.liverc*BW^0.75]
#   pop_u_httk[, hepatic.bioavailability:= Qliver / (Qliver +
#     Funbound.plasma * Clint / Rblood2plasma)]
#   pop_u_httk[, (setdiff(names(pop_u_httk),
#     names(httk::parameterize_steadystate(chem.cas=chemcas,
#                                  suppress.messages=TRUE)))):=NULL]
# 
# 
#   #compute Css for each individual
#   # calc_analytic_css is vectorized so that this will work.
#   css <- httk::calc_analytic_css(parameters=pop_u_httk,
#                                  clint.pvalue.threshold=1,
#                                  daily.dose=1,
#                                  clint.pop.cv=NULL,
#                                  fup.pop.cv=NULL,
#                                  output.units="uM",
#                                  model="3compartmentss",
#                                  species="Human",
#                                  suppress.messages=TRUE)#,
#                             #     recalc.blood2plasma=TRUE)
#   #get Css95
#   cssquants <- quantile(css, probs=probs)
#   return(cssquants)
#   }
#   }
# }

## ----hlfun.u, eval = execute.vignette-----------------------------------------
# hlfun_u <- function(chemcas,
#                       MW,
#                       probs=0.95,
#                       minimum.Funbound.plasma=0.0001)
# {
#   if (chemcas %in% intersect(get_cheminfo(suppress.messages=TRUE,
#                                  model="3compartmentss"),
#                      get_cheminfo(suppress.messages=TRUE,
#                                   model="schmitt")))
#   {
#   # Create a data table with uncertainty only:
#   print(chemcas)
#   pop_u_httk <- as.data.table(parameterize_steadystate(chem.cas=chemcas,
#     clint.pvalue.threshold=1,
#     minimum.Funbound.plasma=0,
#     suppress.messages=TRUE))
#   if (!is.na(pop_u_httk[,"Clint.dist"]) &
#       !is.na(pop_u_httk[,"Funbound.plasma.dist"]))
#   {
#   params.schmitt <-parameterize_schmitt(chem.cas=chemcas,
#     suppress.messages=TRUE)
#   psd <- params.schmitt$pKa_Donor
#   psa <- params.schmitt$pKa_Accept
#   params.schmitt <- params.schmitt[regexpr("pKa",names(params.schmitt))==-1]
#   pop_u_httk[,names(params.schmitt):=params.schmitt]
#   pop_u_httk[,pKa_Donor := paste(psd, collapse=",")]
#   pop_u_httk[,pKa_Accept := paste(psa, collapse=",")]
#   pop_u_httk <- pop_u_httk[rep(1,1000)]
# 
#   ions <- calc_ionization(pH=7.4,parameters=pop_u_httk)
#   pop_u_httk[,Dow74 := Pow * (ions$fraction_neutral + 0.001 * ions$fraction_charged + ions$fraction_zwitter)]
# 
#   # Parse the Funbound.plasma.dist into quantiles:
#   Funbound.plasma.dist <- unlist(pop_u_httk[1,"Funbound.plasma.dist"])
#   print(paste(chemcas,Funbound.plasma.dist))
#   if (nchar(Funbound.plasma.dist) -
#     nchar(gsub(",","",Funbound.plasma.dist))!=2)
#   {
#     stop("Funbound.plasma distribution should be three values (median,low95th,high95th) separated by commas.")
#   }
#   temp <- strsplit(Funbound.plasma.dist,",")
#   ppb.median <- as.numeric(temp[[1]][1])
#   ppb.low95 <- as.numeric(temp[[1]][2])
#   ppb.high95 <- as.numeric(temp[[1]][3])
# 
#   if (ppb.median>minimum.Funbound.plasma)
#   {
#     # Use optim to estimate alpha and beta for fup such that the median and 95%
#     # credible interval approximate the estimate from MCMC:
#     ppb.fit <- optim(c(2,(1-ppb.median)/ppb.median*2),
#       function(x) (0.95-pbeta(ppb.high95,x[1],x[2])+
#       pbeta(ppb.low95,x[1],x[2]))^2+
#       (ppb.median-qbeta(0.5,x[1],x[2]))^2,
#       method="BFGS")
#   # We are drawing new values for the unadjusted Fup:
#     pop_u_httk[, unadjusted.Funbound.plasma:=rbeta(1000,
#       ppb.fit$par[1],
#       ppb.fit$par[2])]
#   } else if (ppb.high95>minimum.Funbound.plasma)
#   {
#     # Assume that since the median is zero but the u95 is not, that there is
#     # an exponential distribution:
#     # 97.5% of clearance values will be below Funbound.plasma.u95:
#     pop_u_httk[, unadjusted.Funbound.plasma:=runif(1000,
#       minimum.Funbound.plasma,
#       min(1,(ppb.high95-minimum.Funbound.plasma)/0.975))]
#     pop_u_httk[as.logical(rbinom(1000,1,.975)),
#       unadjusted.Funbound.plasma:=minimum.Funbound.plasma]
#   } else {
#     pop_u_httk[, unadjusted.Funbound.plasma:=minimum.Funbound.plasma]
#   }
# 
# # then we need to adjust for in vitro binding:
#   pop_u_httk[,Flipid:=subset(physiology.data,
#     Parameter=='Plasma Effective Neutral Lipid Volume Fraction')[,
#     which(colnames(physiology.data) == 'Human')]]
#   pop_u_httk[,Funbound.plasma.adjustment:=1 / (Dow74 * Flipid +
#     1 / unadjusted.Funbound.plasma)/unadjusted.Funbound.plasma]
#   pop_u_httk[,
#     Funbound.plasma:=unadjusted.Funbound.plasma*Funbound.plasma.adjustment]
# 
# # Enforce a minimum ppb:
#   pop_u_httk[Funbound.plasma<minimum.Funbound.plasma,
#     Funbound.plasma:=minimum.Funbound.plasma]
# 
#   Rblood2plasma <- get_rblood2plasma(chem.cas=chemcas)
#   if (is.na(Rblood2plasma))
#   {
#     pop_u_httk[, Rblood2plasma:=calc_rblood2plasma(parameters=pop_u_httk,
#                                         suppress.messages=TRUE)]
#   } else pop_u_httk[, Rblood2plasma:=Rblood2plasma] # Right now we don't simulate variability on a known blood:plasma ratio
#   # Parse the clint.dist to retrieve the quantiles:
#   Clint.dist <- unlist(pop_u_httk[1,"Clint.dist"])
#   if (nchar(Clint.dist) -
#     nchar(gsub(",","",Clint.dist))!=3)
#   {
#     stop("Clint distribution should be four values (median,low95th,high95th,pValue) separated by commas.")
#   }
#   temp <- strsplit(Clint.dist,",")
#   Clint.median <- as.numeric(temp[[1]][1])
#   Clint.low95 <- as.numeric(temp[[1]][2])
#   Clint.high95 <- as.numeric(temp[[1]][3])
#   Clint.pvalue <- as.numeric(temp[[1]][4])
# 
#     # Use optim to estimate mean and standard deviation of Clint such that the
#   # median and 95% credible interval approximate the estimate from MCMC:
#   if (Clint.high95>0)
#   {
#     if (Clint.median>0)
#     {
#       clint.fit <- optim(c(log(Clint.median),0.3), function(x)
#         (0.95-plnorm(Clint.high95,x[1],x[2])+plnorm(Clint.low95,x[1],x[2]))^2+
#         (Clint.median-qlnorm(0.5,x[1],x[2]))^2)
#       pop_u_httk[,Clint:=rlnorm(1000,clint.fit$par[1],clint.fit$par[2])]
#     } else {
#       pop_u_httk[,Clint:=exp(runif(1000,log(1),
#       (log(Clint.high95)-log(1))/0.975))]
#     }
#   } else pop_u_httk[,Clint:=0]
#   pop_u_httk[as.logical(rbinom(1000,1,Clint.pvalue)),Clint:=0] # the Bayesian "p-value" here reflects how often there is no clearance
# 
#   pop_u_httk[, CLh:=calc_hep_clearance(
#     chem.cas=chemcas,
#     parameters=pop_u_httk,
#     hepatic.model='unscaled',
#     suppress.messages=TRUE,
#     clint.pvalue.threshold=1)]
#   pop_u_httk[, Qliver:=Qtotal.liverc*BW^0.75]
#   pop_u_httk[, hepatic.bioavailability:= Qliver / (Qliver + Funbound.plasma * Clint / Rblood2plasma)]
# 
#   PC.names <- names(predict_partitioning_schmitt(chem.cas="80-05-7",
#                                         suppress.messages=TRUE))
#   pop_u_httk<-cbind(pop_u_httk,
#                     as.data.table(predict_partitioning_schmitt(parameters=pop_u_httk,
#                                         suppress.messages=TRUE)))
#   pop_u_httk[,hl:=calc_elimination_rate(parameters=pop_u_httk,
#                                         suppress.messages=TRUE)]
# 
#   return(log(2)/quantile(unlist(pop_u_httk[,"hl",with=FALSE]),probs=probs))
#   }
#   }
# }

## ----Wambaugh2019.Fig1, eval = execute.vignette-------------------------------
# Fig1.table <- httkexamples::wambaugh2019.raw
# Fig1.table$Error1 <- Fig1.table$Base.Fup.High - Fig1.table$Base.Fup.Low
# Fig1.table$Error2 <- Fig1.table$Affinity.Fup.High - Fig1.table$Affinity.Fup.Low
# Fig1.table$Sigma1 <- Fig1.table$Error1/(2*qnorm(0.975))
# Fig1.table$Mean1 <- (Fig1.table$Base.Fup.High + Fig1.table$Base.Fup.Low)/(qnorm(0.975))
# Fig1.table$CV1 <- Fig1.table$Sigma1/Fig1.table$Mean1
# Fig1.table$Sigma2 <- Fig1.table$Error2/(2*qnorm(0.975))
# Fig1.table$Mean2 <- (Fig1.table$Base.Fup.High + Fig1.table$Base.Fup.Low)/(qnorm(0.975))
# Fig1.table$CV2 <- Fig1.table$Sigma2/Fig1.table$Mean2
# Fig1.table$ErrorClint <- Fig1.table$CLint.1uM.High95th - Fig1.table$CLint.1uM.Low95th
# Fig1.table$SigmaClint <- Fig1.table$ErrorClint/(2*qnorm(0.975))
# Fig1.table$MeanClint <- (Fig1.table$CLint.1uM.High95th + Fig1.table$CLint.1uM.Low95th)/(qnorm(0.975))
# Fig1.table$CVClint <- Fig1.table$SigmaClint/Fig1.table$MeanClint
# 
# Fupmeasured <- subset(Fig1.table,!is.na(Affinity.Fup.Med))
# Fupmeasured <- subset(Fupmeasured,!duplicated(CAS))
# CLintmeasured <- subset(Fig1.table,!is.na(CLint.1uM.Median))
# CLintmeasured <- subset(CLintmeasured,!duplicated(CAS))
# 
# 
# 
# print(paste("New HTTK experimental measurements were made for",length(unique(Fig1.table$CAS)),"chemicals from the ToxCast HTS library."))
# 
# print(paste("Fup was successfully measured for",length(unique(subset(Fig1.table,!is.na(Affinity.Fup.Med))$CAS)),"chemicals from the ToxCast HTS library."))
# 
# print(paste("CLint was successfully measured for",length(unique(subset(Fig1.table,!is.na(CLint.1uM.Median))$CAS)),"chemicals from the ToxCast HTS library."))
# 
# 
# 
# 
# Fig1a <- ggplot(Fig1.table)+
#    geom_freqpoly(binwidth = 0.5,lwd=1.5,color="Red",aes(Base.Fup.Med))+
#    geom_freqpoly(binwidth = 0.5,lwd=1.5,lty=3,color="Blue",aes(Affinity.Fup.Med))+
#   xlab(expression(paste("Measured ",F[up]))) +
#   ylab("Number of chemicals")+
#    scale_x_log10(label=label_log(),limits=c(10^-6,1.05))+
#    labs(title=paste(length(unique(subset(Fig1.table,!is.na(Affinity.Fup.Med))$CAS)),"Chemicals Measured"))+
#     theme_bw()+
#     theme( text  = element_text(size=10)) +
#     annotate("text", x=10^-6,y=80,size=8,label="a")
# 
# print(paste("Median 100%:",signif(median(Fig1.table$Base.Fup.Med,na.rm=TRUE),2)))
# print(paste("Median Titration:",signif(median(Fig1.table$Affinity.Fup.Med,na.rm=TRUE),2)))
# 
# 
# 
# Fig1b <- ggplot(Fig1.table)+
#    geom_histogram(binwidth = 0.5,alpha=0.6,fill="green",aes(CLint.1uM.Median))+
#    xlab(expression(paste("Measured ",Cl[int]," (uL/min/",10^6," hepatocytes)"))) +
#   ylab("Number of chemicals")+
#   scale_x_log10(label=label_log(),limits=c(10^-1,5*10^3))+
#   labs(title=paste(length(unique(subset(Fig1.table,!is.na(CLint.1uM.Median))$CAS)),"Chemicals Measured"))+
#     theme_bw()+
#     theme( text  = element_text(size=10)) +
#     annotate("text", x=2*10^-1,y=80,size=8,label="b")
# 
# print(paste(sum(Fig1.table$CLint.1uM.Median==0,na.rm=TRUE),"Zero Measurments"))
# print(paste("Median Non-Zero:",signif(median(Fig1.table$CLint.1uM.Median,na.rm=TRUE),3)))
# 
# 
# 
# Fig1c <- ggplot(Fig1.table)+
#    geom_histogram(binwidth = 0.1,alpha=0.2,fill="Red",aes(Error1))+
#    geom_histogram(binwidth = 0.1,alpha=0.2,fill="Blue",aes(Error2))+
#   xlab("Width of Credible Interval") +
#   ylab("Number of chemicals")+
#    scale_x_log10(label=label_log(),limits=c(5*10^-4,1.05))+
#    labs(title=paste("CI:",signif(median(Fig1.table$Error1,na.rm=TRUE),2),"CV:",signif(median(Fig1.table$CV1,na.rm=TRUE),1),"/ CI:",signif(median(Fig1.table$Error2,na.rm=TRUE),1),"CV:",signif(median(Fig1.table$CV2,na.rm=TRUE),1)))+
#     theme_bw()+
#     theme( text  = element_text(size=10))+
#     annotate("text", x=5*10^-4,y=42,size=8,label="c")
# 
# print(paste("Median 100% CI:",signif(median(Fig1.table$Error1,na.rm=TRUE),2),"CV:",signif(median(Fig1.table$CV1,na.rm=TRUE),2)))
# print(paste("Median Titr. CI:",signif(median(Fig1.table$Error2,na.rm=TRUE),2),"CV:",signif(median(Fig1.table$CV2,na.rm=TRUE),2)))
# 
# 
# Fig1d <- ggplot(Fig1.table)+
#    geom_histogram(binwidth = 0.1,alpha=0.6,fill="green",aes(ErrorClint))+
#   xlab("Width of Credible Interval") +
#   ylab("Number of chemicals")+
#   scale_x_log10(label=label_log(),limits=c(10^0,10^3))+
#    labs(title=paste("Median CI:",signif(median(Fig1.table$ErrorClint,na.rm=TRUE),2),"CV:",signif(median(Fig1.table$CVClint,na.rm=TRUE),2)))+
#     theme_bw()+
#     theme( text  = element_text(size=10))+
#     annotate("text", x=1.5,y=25,size=8,label="d")
# 
# print(paste("Median CI:",signif(median(Fig1.table$ErrorClint,na.rm=TRUE),2),"CV:",signif(median(Fig1.table$CVClint,na.rm=TRUE),2)))
# 
# multiplot(Fig1a,Fig1c,Fig1b,Fig1d,cols=2,widths=c(1.75,1.75))

## ----Wambaugh2019.Fig2, eval = execute.vignette-------------------------------
# Fig2.table <- httkexamples::wambaugh2019.raw
# print(paste(sum(!is.na(Fig2.table$Fup.point)),"total successful Fup estimates using point estimation."))
# print(paste(sum(!is.na(Fig2.table$Base.Fup.Med)),"total successful Fup estimates using BAyesian analysis of top protein concentration."))
# Fig2.table$Error1 <- Fig2.table$Base.Fup.High - Fig2.table$Base.Fup.Low
# Fig2.table$Error2 <- Fig2.table$Affinity.Fup.High - Fig2.table$Affinity.Fup.Low
# Fig2.table$Sigma1 <- Fig2.table$Error1/(2*qnorm(0.975))
# Fig2.table$Mean1 <- (Fig2.table$Base.Fup.High + Fig2.table$Base.Fup.Low)/(qnorm(0.975))
# Fig2.table$CV1 <- Fig2.table$Sigma1/Fig2.table$Mean1
# Fig2.table$Sigma2 <- Fig2.table$Error2/(2*qnorm(0.975))
# Fig2.table$Mean2 <- (Fig2.table$Base.Fup.High + Fig2.table$Base.Fup.Low)/(qnorm(0.975))
# Fig2.table$CV2 <- Fig2.table$Sigma2/Fig2.table$Mean2
# Fig2.table$Point.Estimate <- "Good"
# Fig2.table[Fig2.table$Fup.point<0&!is.na(Fig2.table$Fup.point),"Point.Estimate"]<-"<0"
# Fig2.table[Fig2.table$Fup.point>1&!is.na(Fig2.table$Fup.point),"Point.Estimate"]<-">1"
# Fig2.table[is.na(Fig2.table$Fup.point),"Point.Estimate"]<-"No Value"
# Fig2.table[Fig2.table$Point.Estimate%in%c("<0","No Value"),"Fup.point"] <-  Fig2.table[Fig2.table$Point.Estimate%in%c("<0","No Value"),"Base.Fup.Med"]
# Fig2.table$Uncertain<-"Yes"
# Fig2.table[is.na(Fig2.table$CV1),"CV1"] <- -999
# Fig2.table[Fig2.table$CV1<0.49,"Uncertain"] <- "No"
# Fig2.table[Fig2.table$CV1==-999,"CV1"] <- NA
# 
# Fig2a <- ggplot(subset(Fig2.table,!is.na(Base.Fup.Med)),aes(x=Fup.point,y=Base.Fup.Med,shape=Point.Estimate,alpha=Uncertain,colour=Point.Estimate)) +
#          geom_point(size=3)+
# #         geom_errorbar(aes(ymax = Base.Fup.High, ymin=Base.Fup.Low))+
#    scale_y_log10(label=label_log(),limits=c(10^-6,2)) +
#    scale_x_log10(label=label_log(),limits=c(10^-6,2)) +
#   ylab(expression(paste(F[up]," Bayesian Analysis (Single Conc.)"))) +
#   xlab(expression(paste(F[up]," Point Estimate (Traditional Analysis)"))) +
#   geom_abline(intercept = 0, slope = 1,linetype="dashed", colour="Blue") +
# #  geom_vline(xintercept = 1, size=2,linetype="dashed", colour="red")+
#   geom_vline(xintercept = 0.01, size=2,linetype="dotted", colour="red")+
#   geom_hline(yintercept = 0.01, size=2,linetype="dotted", colour="red")+
#     scale_colour_discrete(name="Point Estimate")+
#     scale_shape_discrete(name="Point Estimate") +
#     scale_alpha_manual(values=c(1,0.3))+
#         theme_bw() +
#      theme(legend.position="bottom", text  = element_text(size=12))+
#      annotate("text", size=8,x = 10^-6, y = 2, label = "a")+
#     guides(alpha=guide_legend(nrow=2,byrow=TRUE),colour=guide_legend(nrow=2,byrow=TRUE),shape=guide_legend(nrow=2,byrow=TRUE))
# 
# #print(Fig2a)
# 
# print(paste(sum(Fig2.table$Uncertain=="Yes"),"uncertain estimates using single conc."))
# print(paste(sum(Fig2.table$Point.Estimate=="<0"),"chemicals with negative point estimates."))
# print(paste(sum(Fig2.table$Point.Estimate==">1"),"chemicals with Fup > 1."))
# 
# 
# 
# summary(lm(data=subset(Fig2.table,!is.na(Fup.point)&Fup.point>0&Base.Fup.Med>0),log(Fup.point)~log(Base.Fup.Med)))
# 
# 
# 
# 
# Fig2.table$Uncertain2<-"Yes"
# Fig2.table[is.na(Fig2.table$CV2),"CV2"] <- -999
# Fig2.table[Fig2.table$CV2<0.49,"Uncertain2"] <- "No"
# Fig2.table[Fig2.table$CV2==-999,"CV2"] <- NA
# Fig2.table$TopFail <- ""
# Fig2.table[!is.na(Fig2.table$Affinity.Fup.Med)&Fig2.table$Uncertain2=="No","TopFail"]<-"No"
# Fig2.table[Fig2.table$TopFail=="No"&!is.na(Fig2.table$Base.Fup.Med)&Fig2.table$Uncertain=="Yes","TopFail"]<-"Single Conc. Only"
# Fig2.table[!is.na(Fig2.table$Affinity.Fup.Med)&Fig2.table$Uncertain2=="Yes","TopFail"]<-"Yes"
# Fig2.table[!is.na(Fig2.table$Affinity.Fup.Med)&is.na(Fig2.table$Base.Fup.Med),"TopFail"] <- "Single Conc. Only"
# Fig2.table[is.na(Fig2.table$Base.Fup.Med),"Base.Fup.Med"] <-  Fig2.table[is.na(Fig2.table$Base.Fup.Med),"Affinity.Fup.Med"]
# 
# 
# Fig2b <- ggplot(subset(Fig2.table,!is.na(Affinity.Fup.Med)),aes(x=Base.Fup.Med,y=Affinity.Fup.Med,shape=TopFail,alpha=TopFail,colour=TopFail)) +
#          geom_point(size=3)+
#          geom_point(data=subset(Fig2.table,TopFail=="No"),size=3)+
# #         geom_errorbar(aes(ymax = Fup.High.x, ymin=Fup.Low.x))+
# #         geom_errorbarh(aes(xmin=Fup.Low.y,xmax=Fup.High.y))+
#    scale_y_log10(label=label_log(),limits=c(10^-8,2)) +
#    scale_x_log10(label=label_log(),limits=c(10^-8,2)) +
#   xlab(expression(paste(F[up]," Bayesian Analysis (Single Conc.)"))) +
#   ylab(expression(paste(F[up]," Bayesian Analysis (Three Conc.)"))) +
#   geom_abline(intercept = 0, slope = 1,linetype="dashed", colour="Blue")+
#   scale_colour_discrete(name="Uncertain")+
#   scale_shape_discrete(name="Uncertain") +
# #    annotate("text",size=8, x = 10^-4, y = 1, label = "B")+
#    scale_alpha_manual(name="Uncertain",values=c(1,0.6,0.3))+
#      theme_bw() +
#   theme(legend.position="bottom", text  = element_text(size=12))+
#       annotate("text", size=8,x = 10^-8, y = 2, label = "b")+
#     guides(alpha=guide_legend(nrow=2,byrow=TRUE),colour=guide_legend(nrow=2,byrow=TRUE),shape=guide_legend(nrow=2,byrow=TRUE))
# 
# #print(Fig2b)
# 
# # Need to reduce to unique chemicals.
# Fupbaseworked <- subset(Fig2.table,!is.na(Base.Fup.Med)&Uncertain=="No")
# Fupbasenot <- subset(Fig2.table,!is.na(Base.Fup.Med)&Uncertain=="Yes")
# Fupbaseworked <- subset(Fupbaseworked,!duplicated(CAS))
# Fupbasenot <- subset(Fupbasenot,!duplicated(CAS))
# # Also need to count a chemical as a success if it worked for either duplicate:
# Fupbasenot <- subset(Fupbasenot,!(CAS%in%Fupbaseworked$CAS))
# 
# Fupaffinityworked <- subset(Fig2.table,!is.na(Affinity.Fup.Med)&Uncertain2=="No")
# Fupaffinitynot <- subset(Fig2.table,!is.na(Affinity.Fup.Med)&Uncertain2=="Yes")
# Fupaffinityworked <- subset(Fupaffinityworked,!duplicated(CAS))
# Fupaffinitynot <- subset(Fupaffinitynot,!duplicated(CAS))
# Fupaffinitynot <- subset(Fupaffinitynot,!(CAS%in%Fupaffinityworked$CAS))
# 
# 
# print(paste(dim(Fupbaseworked)[1],"total successful Fup estimates using single conc."))
# print(paste(signif(dim(Fupbasenot)[1]/(dim(Fupbaseworked)[1]+dim(Fupbasenot)[1])*100,3),"percent failure rate using single conc."))
# print(paste(dim(Fupaffinityworked)[1],"total successful Fup estimates using protein titration."))
# print(paste(signif(dim(Fupaffinitynot)[1]/(dim(Fupaffinityworked)[1]+dim(Fupaffinitynot)[1])*100,3),"percent failure rate using protein titration."))
# print(paste(dim(Fupbasenot)[1],"uncertain estimates using original protocol."))
# print(paste(dim(Fupaffinitynot)[1],"uncertain estimates using protein titration."))
# print(paste(dim(Fupaffinityworked)[1]-dim(Fupbaseworked)[1],"chemicals that could not be measured at 100% plasma protein."))
# 
# Wetmore.data <- httkexamples:::Wetmore.data
# W2015 <- subset(Wetmore.data,Reference=="Wetmore 2015")
# 
# W2012 <- subset(Wetmore.data,Reference=="Wetmore 2012")
# print(paste("The Fup assay failed for ",signif(sum(W2012$Fub==0.005)/length(W2012$Fub)*100,3),"% of chemicals in {Wetmore, 2012} and ",signif(sum(W2015$Fub==0)/length(W2015$Fub)*100,3),"% of chemicals in {Wetmore, 2015}."))
# 
# 
# Fuplod <- subset(Fig2.table,TopFail=="Single Conc. Only")
# print(paste("Among the chemicals that were uncertain using the original protocol but could be measured using the new three concentration protocol, the median estimated Fup was ",signif(median(Fuplod$Affinity.Fup.Med),2),"with values as low as ",signif(min(Fuplod$Affinity.Fup.Med),2),"and as high as",signif(max(Fuplod$Affinity.Fup.Med),2),". Previously, a default of 0.005 has been assumed when Fup could not be measured {Rotroff, 2010}.}"))
# 
# 
# summary(lm(data=subset(Fig2.table,!is.na(Base.Fup.Med)&Affinity.Fup.Med>0&Base.Fup.Med>0),log(Base.Fup.Med)~log(Affinity.Fup.Med)))
# 
# #dev.new(width=10,height=6)
# multiplot(Fig2a,Fig2b,cols=2,widths=c(1.75,1.75))

## ----Wambaugh2019.Fig3, eval = execute.vignette-------------------------------
# Fig1.table$Class <- "Other"
# Fig1.table[Fig1.table$DTXSID %in% pharma[,1],"Class"]<-"Pharmaceutical"
# Fig1.table$Class <- as.factor(Fig1.table$Class)
# 
#   Fig3 <- ggplot(Fig1.table,aes(Affinity.Kd.Med,fill=Class))+
#     geom_histogram(binwidth = 0.5)+
#     xlab(expression(paste("Binding Affinity (", mu,"M)",sep=""))) +
#       ylab("Number of chemicals")+
#     scale_x_log10(label=label_log())+
#       scale_fill_discrete(name="Chemical Class")+
#       theme_bw()  +
#     theme(legend.position="bottom", text  = element_text(size=18))
# 
#  # dev.new()
#   print(Fig3)

## ----Wambaugh2019.Fig4, eval = execute.vignette-------------------------------
# clearance.table <- subset(httkexamples::wambaugh2019.raw,!is.na(CLint.1uM.Median))
# 
# print(paste(sum(clearance.table$CLint.1uM.Median==0),"zero valued median Bayesian posteriors"))
# print(paste(sum(clearance.table$CLint.1uM.Point==0 &
#                   clearance.table$CLint.1uM.Median>0,
#                 na.rm=TRUE),
#             "zero valued point estimates where median posterior>0"))
# print(paste(sum(clearance.table$CLint.1uM.Point>0 &
#                   clearance.table$CLint.1uM.Median==0,
#                 na.rm=TRUE),
#             "zero valued median Bayesian posteriors where point estimate was non-zero"))
# print(paste(sum(is.na(clearance.table$CLint.1uM.Point) &
#                   clearance.table$CLint.1uM.Median==0,
#                 na.rm=TRUE),
#             "zero valued median Bayesian posteriors where point estimate was NA"))
# print(paste(sum(is.na(clearance.table$CLint.1uM.Point) &
#                   clearance.table$CLint.1uM.Median>0,
#                 na.rm=TRUE),
#             "non-zero valued median Bayesian posteriors where point estimate was NA"))
# 
# 
# 
# 
# clearance.table$Fit <- "Decreasing"
# clearance.table[clearance.table$CLint.1uM.Median == 0,"Fit"] <- "Median Zero"
# #clearance.table[is.na(clearance.table$CLint.1uM.Point == 0),"Fit"] <- "Point Est. Missing"
# for (i in 1:dim(clearance.table)[1])
#   if (!is.na(clearance.table[i,"CLint.1uM.Point"]))
#   {
#     if (clearance.table[i,"CLint.1uM.Point"] == 0) clearance.table[i,"Fit"] <- "Point Est. Zero"
#   } else clearance.table[i,"Fit"] <- "Point Est. Failed"
# 
# 
# set.seed(123456)
# clearance.table[is.na(clearance.table$CLint.1uM.Point),"CLint.1uM.Point"]<-runif(sum(is.na(clearance.table$CLint.1uM.Point)),0.1,0.2)
# clearance.table[clearance.table$CLint.1uM.Point==0,"CLint.1uM.Point"]<-runif(sum(clearance.table$CLint.1uM.Point==0),0.3,0.8)
# clearance.table[clearance.table$CLint.1uM.Low95th==0,"CLint.1uM.Low95th"]<-0.1
# clearance.table[clearance.table$CLint.1uM.Median==0,"CLint.1uM.Median"]<-0.1
# clearance.table[clearance.table$CLint.1uM.High95th==0,"CLint.1uM.High95th"]<-0.1
# clearance.table[clearance.table$CLint.1uM.High95th>1000,"CLint.1uM.High95th"]<-1000
# clearance.table[clearance.table$CLint.1uM.Low95th<0.1,"CLint.1uM.Low95th"]<-0.1
# 
# clearance.fit <- lm(log10(CLint.1uM.Median)~log10(CLint.1uM.Point),data=subset(clearance.table,!is.na(CLint.1uM.Point)&CLint.1uM.Point>1))
# Fig4 <- ggplot(clearance.table, aes(x=CLint.1uM.Point,y=CLint.1uM.Median,colour=Fit)) +
#   geom_segment(aes(x=CLint.1uM.Point,xend=CLint.1uM.Point,y=CLint.1uM.Low95th,yend=CLint.1uM.High95th),size=1,alpha=0.5)+
#   geom_point(size=3) +
#   scale_y_log10(label=label_log(),limits=c(10^-1,1000)) +
#   scale_x_log10(label=label_log(),limits=c(10^-1,1000)) +
#   xlab(expression(paste(CL[int]," (",mu,"L/min/",10^{6}," Hep.) Point Estimate",sep="")))+
#   ylab(expression(paste(CL[int]," (",mu,"L/min/",10^{6}," Hep.) Bayesian",sep="")))+
#   geom_vline(xintercept = 0.25, size=2,colour="black")+
#   geom_vline(xintercept = 0.9, size=2,colour="black")+
#   geom_abline(intercept = 0, slope = 1,linetype="dashed")+
#   scale_colour_discrete(name="Assay Result")+
#   theme_bw() +
#   theme(legend.position="bottom", text  = element_text(size=14))+
#   guides(colour=guide_legend(nrow=2,byrow=TRUE))+
#   annotate("text",x = 10^2, y = 10^0,size=6, label = lm_R2(clearance.fit,prefix=""),parse=TRUE)
# 
# #dev.new()
# print(Fig4)
# 
# summary(clearance.fit)

## ----Wambaugh2019.Fig5, eval = execute.vignette-------------------------------
# # This section takes a long time because calc_vdist is not yet data.table compatible:
# ceetox <- as.data.table(subset(httkexamples::wambaugh2019,
#                                !is.na(Human.Funbound.plasma) &
#                                !is.na(Human.Clint)&!is.na(logP)))
# httk_cas <- ceetox$CAS[ceetox$CAS %in% get_cheminfo(model="3compartmentss",
#                                                     suppress.messages=TRUE)]
# 
# # back up chem.physical_and_invitro.data:
# HTTK.data <- chem.physical_and_invitro.data
# 
# # Use the point estimates:
# chem.physical_and_invitro.data <- add_chemtable(httkexamples::wambaugh2019.raw,
#   current.table=chem.physical_and_invitro.data,
#   data.list=list(Compound="Name",
#                  CAS="CAS",
#                  Clint="CLint.1uM.Point",
#                  Funbound.plasma="Fup.point"),
#   reference="Wambaugh 2019",
#   species="Human",
#   overwrite=TRUE)
# 
# 
# 
# schmitt_cas <- httk_cas[httk_cas %in% get_cheminfo(model="schmitt",
#                                                    suppress.messages=TRUE)]
# ceetox[CAS%in%schmitt_cas,
#        hlpoint:=log(2)/httk::calc_elimination_rate(chem.cas=CAS,
#                                         suppress.messages=TRUE),
#        by=.(CAS)]
# 
# chem.physical_and_invitro.data <- HTTK.data
# 
# ceetox[CAS%in%schmitt_cas,
#        hl_975:=hlfun_u(chemcas=CAS,
#                           MW=MW,
#                           probs=0.975),
#        by=.(CAS)]
# 
# ceetox[CAS%in%schmitt_cas,
#        hl_med:=hlfun_u(chemcas=CAS,
#                           MW=MW,
#                           probs=0.5),
#        by=.(CAS)]
# 
# ceetox[CAS%in%schmitt_cas,
#        hl_25:=hlfun_u(chemcas=CAS,
#                          MW=MW,
#                           probs=0.025),
#        by=.(CAS)]
# 
# ceetox[,hlpointEstimated:=TRUE]
# ceetox[is.na(hlpoint),hlpointEstimated:=FALSE]
# ceetox[is.na(hlpoint),hlpoint:=hl_med]

## ----Wambaugh2019.Fig6, eval = execute.vignette-------------------------------
# set.seed(42)
# ceetox[CAS%in%httk_cas,
#        css95_uv:=calc_mc_css(chem.cas=CAS,
#                                 # clint.pvalue.threshold=1, #Don't need to use p-values here (Bayesian)
#                                  output.units="uM",
#                                  model="3compartmentss",
#                                  species="Human",
#                                         suppress.messages=TRUE),
#        by=.(CAS)]
# 
# set.seed(42)
# ceetox[CAS%in%httk_cas,
#        css95_v:=calc_mc_css(chem.cas=CAS,
#                                  #clint.pvalue.threshold=1, #Don't need to use p-values here (Bayesian)
#                                  output.units="uM",
#                                  invitro.mc.arg.list=list(
#                                    clint.meas.cv=NULL,
#                                    fup.meas.cv=NULL,
#                                    clint.pop.cv=0.3,
#                                    fup.pop.cv=0.3
#                                  ),
#                                  model="3compartmentss",
#                                  species="Human",
#                                         suppress.messages=TRUE),
#        by=.(CAS)]
# 
# 
# 
# set.seed(42)
# ceetox[CAS%in%httk_cas,
#        css95_u:=cssfun_u(chemcas=CAS,
#                           MW=MW),
#        by=.(CAS)]
# 
# set.seed(42)
# ceetox[CAS%in%httk_cas,
#        cssmed_u:=cssfun_u(chemcas=CAS,
#                           MW=MW,
#                           probs=0.5),
#        by=.(CAS)]
# 
# set.seed(42)
# ceetox[CAS%in%httk_cas,
#        css25_u:=cssfun_u(chemcas=CAS,
#                           MW=MW,
#                           probs=0.025),
#        by=.(CAS)]
# 
# set.seed(42)
# ceetox[CAS%in%httk_cas,
#        css975_u:=cssfun_u(chemcas=CAS,
#                           MW=MW,
#                           probs=0.975),
#        by=.(CAS)]
# 
# ceetox[CAS%in%httk_cas,
#        cssmed:=httk::calc_analytic_css(chem.cas=CAS,
#                                  clint.pvalue.threshold=1,
#                                  output.units="uM",
#                                  model="3compartmentss",
#                                  species="Human",
#                                  suppress.messages=TRUE),
#        by=.(CAS)]

## ----Wambaugh2019.Fig5.2, eval = execute.vignette-----------------------------
# hlfit <- lm(data=subset(ceetox,hlpointEstimated &
#                           !is.na(log10(hlpoint)) &
#                           !is.na(log10(hl_med)) &
#                           !is.infinite(log10(hl_med))),
#             log10(hlpoint)~log10(hl_med))
# Fig5a <- ggplot(data=subset(ceetox,hlpointEstimated),aes(x=hlpoint,y=hl_med)) +
#   geom_point(size=3,alpha=0.5) +
#   geom_errorbar(aes(ymax = hl_975, ymin=hl_25),alpha=0.3)+
#   scale_y_log10(label=label_log(),limits=c(1,10^6)) +
#   scale_x_log10(label=label_log(),limits=c(1,10^6)) +
#   xlab("half-life (h) Point Estimate")+
#   ylab("Bayesian half-life (h)")+
#   geom_abline(intercept = 0, slope = 1,linetype="dashed",color="blue")+
#   annotate("text", size=8,x = 1, y = 10^6, label = "A")+
#   theme_bw() +
#   theme(text  = element_text(size=18))+
#   annotate("text",x = 3*10^3, y = 10^0,size=5, label = lm_R2(hlfit,prefix=""),parse=TRUE)
# 
# 
# cssfit <- lm(data=subset(ceetox,
#                          !is.na(log10(cssmed)) &
#                          !is.na(log10(cssmed_u)) &
#                          !is.infinite(log10(cssmed_u))),
#              log10(cssmed)~log10(cssmed_u))
# Fig5b <- ggplot(data=ceetox,aes(x=cssmed,y=cssmed_u)) +
#   geom_point(size=3,alpha=0.5) +
#   geom_errorbar(aes(ymin=css25_u,ymax=css975_u),alpha=0.3)+
#   scale_y_log10(label=label_log(),limits=c(10^-3,10^5)) +
#   scale_x_log10(label=label_log(),limits=c(10^-3,10^5)) +
#   xlab(expression(paste(C[ss]," Point Estimate (uM)")))+
#   ylab(expression(paste("Bayesian ",C[ss]," (uM)")))+
#   annotate("text", size=8,x = 10^-3, y = 10^5, label = "B")+
#   theme_bw() +
#   theme(text  = element_text(size=18)) +
#   geom_abline(intercept = 0, slope = 1,linetype="dashed",color="blue")+
#   annotate("text",x = 10^2, y = 10^-3,size=5, label = lm_R2(cssfit,prefix=""),parse=TRUE)
# 
# 
# #dev.new(width=8,height=5)
# multiplot(Fig5a,Fig5b,cols=2,widths=c(1.75,1.75))

## ----Wambaugh2019.Fig6.2, eval = execute.vignette-----------------------------
# # Go back to Bayes estimates:
# chem.physical_and_invitro.data <- HTTK.data
# 
# dt_melt <- data.table::melt(ceetox[, .(Compound, CAS, css95_u, css95_v, css95_uv, cssmed)],
#                             id.vars=c("Compound","CAS", "cssmed"),
#                             variable.name="type",
#                             value.name="css95")
# 
# dt_melt[, type:=gsub(x=type, pattern="css95_uv", replacement="Both", fixed=TRUE)]
# dt_melt[, type:=gsub(x=type, pattern="css95_u", replacement="Uncertainty", fixed=TRUE)]
# dt_melt[, type:=gsub(x=type, pattern="css95_v", replacement="Variability", fixed=TRUE)]
# 
# 
# #now set the factor levels explicitly
# dt_melt[, type:=factor(type,
#                        levels=c("Uncertainty", "Variability", "Both"))]
# 
# 
# dt_melt[, Norm:=css95/cssmed]
# 
# 
# #now set the factor levels explicitly
# dt_melt[, Compound:=factor(Compound,
#                        levels=dt_melt[type=="Both",Compound][order(dt_melt[type=="Both",Norm])])]
# 
# 
# Fig6 <- ggplot(data=dt_melt) +
#   geom_point(size=2,alpha=0.7,aes(x=Compound,
#                 y=Norm,
#                 color=type,
#                 shape=type)) +
#    scale_y_log10(label=label_log(),limits=c(0.9,500)) +
#   ylab(expression(paste("Ratio of ",C[ss]," ",95^th," Percentile to Median Estimate"))) +
#   xlab("Chemicals")+
#   scale_colour_discrete(name=expression(paste(C[ss]," Varied to Reflect")))+
#   scale_shape_discrete(name=expression(paste(C[ss]," Varied to Reflect"))) +
#   theme_bw() +
#   theme(legend.position="bottom",axis.text.x = element_blank())+
#   annotate("text", size=8,x = levels(dt_melt$Compound)[length(unique(dt_melt$Compound))/2], y = 400, label = paste("Median Ratio for Uncertainty:",signif(median(subset(dt_melt,type=="Uncertainty")$Norm),3)))+
#   annotate("text", size=8,x = levels(dt_melt$Compound)[length(unique(dt_melt$Compound))/2], y = 200, label = paste("Median Ratio for Variability:",signif(median(subset(dt_melt,type=="Variability")$Norm),3)))+
#   annotate("text", size=8,x = levels(dt_melt$Compound)[length(unique(dt_melt$Compound))/2], y = 100, label = paste("Median Ratio for Both:",signif(median(subset(dt_melt,type=="Both")$Norm),3)))
# 
# #dev.new(width=10,height=6)
# print(Fig6)

## ----Wambaugh2019.Fig7,  eval = execute.vignette------------------------------
# # Head to ftp://newftp.epa.gov/COMPTOX/High_Throughput_Screening_Data/Previous_Data/ToxCast_Data_Release_Oct_2015/ to get the ToxCast/Tox21 data:
# # These are the concentrations that caused activity in exess of the background (ACC) "hits".
# #
# # # Load the ACC table into an object Tox21.acc:
# # Tox21.acc <- read.csv("INVITRODB_V2_LEVEL5/EXPORT_LVL5&6_ASID7_TOX21_151020.csv",stringsAsFactors=FALSE)
# # # Subset to the chemicals of interest:
# # Tox21.acc <- subset(Tox21.acc,casn%in%Fig1.table$CAS)
# # # We only need hits:
# # Tox21.acc <- subset(Tox21.acc,hitc==1)
# #
# # # Pare this down to just the data we need:
# # Tox21.acc <- Tox21.acc[,c("code","chid","chnm","casn","aenm","modl_acc","flags")]
# #
# # # In this vignette we use the precalculated quantiles of the ACC's
# # # to help keep the HTTK package smaller:
# #
# # wambaugh2019.tox21 <- NULL
# # for (this.chem in sort(unique(Tox21.acc$casn)))
# # {
# #   this.subset <- subset(Tox21.acc,casn==this.chem)
# #   this.row <- data.frame(casn=this.chem,
# #     med.conc =
# #       median(10^(this.subset$modl_acc)),
# #     q10.conc =
# #       quantile(10^(this.subset$modl_acc),0.1),
# #     low.conc =
# #       min(10^(this.subset$modl_acc)),
# #     q90.conc =
# #       quantile(10^(this.subset$modl_acc),0.9),
# #     high.conc =
# #       max(10^(this.subset$modl_acc)),
# #     stringsAsFactors = F)
# #   wambaugh2019.tox21  <- rbind(wambaugh2019.tox21, this.row)
# # }
# 
# chem.preds <- httkexamples::wambaugh2019.seem3
# directnhanes.preds <- httkexamples::wambaugh2019.nhanes
# Tox21.acc.numeric <- httkexamples::wambaugh2019.tox21
# 
# #Subset to those chemicals with HTS hits:
# human.hits <- subset(ceetox,CAS%in%Tox21.acc.numeric$casn)
# 
# # Now calculate the oral equivalent dose for each chemical:
# # Must make sure that CSS is in units of uM!!
# for (this.chem in human.hits$CAS)
# {
#   med.conc <-
#     Tox21.acc.numeric[Tox21.acc.numeric$casn==this.chem,"med.conc"]
#   q10.conc <-
#     Tox21.acc.numeric[Tox21.acc.numeric$casn==this.chem,"q10.conc"]
#   low.conc <-
#     Tox21.acc.numeric[Tox21.acc.numeric$casn==this.chem,"low.conc"]
#   q90.conc <-
#     Tox21.acc.numeric[Tox21.acc.numeric$casn==this.chem,"q90.conc"]
#   high.conc <-
#     Tox21.acc.numeric[Tox21.acc.numeric$casn==this.chem,"high.conc"]
#   css95.v <- human.hits[human.hits$CAS==this.chem][["css95_v"]]
#   css95.uv <- human.hits[human.hits$CAS==this.chem][["css95_uv"]]
#   human.hits[human.hits$CAS==this.chem,"HTS.Median.ACC"] <- med.conc
#   human.hits[human.hits$CAS==this.chem,"HTS.Q10.ACC"] <- q10.conc
#   human.hits[human.hits$CAS==this.chem,"HTS.Q90.ACC"] <- q90.conc
#   human.hits[human.hits$CAS==this.chem,"HTS.Low.ACC"] <- low.conc
#   human.hits[human.hits$CAS==this.chem,"HTS.High.ACC"] <- high.conc
#   human.hits[human.hits$CAS==this.chem,"HTS.Median.equivdose.v"] <- med.conc/css95.v
#   human.hits[human.hits$CAS==this.chem,"HTS.Q10.equivdose.v"] <- q10.conc/css95.v
#   human.hits[human.hits$CAS==this.chem,"HTS.Q90.equivdose.v"] <- q90.conc/css95.v
#   human.hits[human.hits$CAS==this.chem,"HTS.Low.equivdose.v"] <- low.conc/css95.v
#   human.hits[human.hits$CAS==this.chem,"HTS.High.equivdose.v"] <- high.conc/css95.v
#   human.hits[human.hits$CAS==this.chem,"HTS.Median.equivdose.uv"] <- med.conc/css95.uv
#   human.hits[human.hits$CAS==this.chem,"HTS.Q10.equivdose.uv"] <- q10.conc/css95.uv
#   human.hits[human.hits$CAS==this.chem,"HTS.Q90.equivdose.uv"] <- q90.conc/css95.uv
#   human.hits[human.hits$CAS==this.chem,"HTS.Low.equivdose.uv"] <- low.conc/css95.uv
#   human.hits[human.hits$CAS==this.chem,"HTS.High.equivdose.uv"] <- high.conc/css95.uv
# }
# 
# 
# 
# #Add the exposure predictions:
# for (this.chem in human.hits$CAS)
# {
#   print(this.chem)
# # If we have direct inferrences from NHANES, use those exposures:
#   if (this.chem %in% directnhanes.preds$CASRN)
#   {
#     human.hits[human.hits$CAS==this.chem,"Exposure.median"] <- directnhanes.preds[directnhanes.preds$CASRN==this.chem,"lP"]
#     human.hits[human.hits$CAS==this.chem,"Exposure.high"] <- directnhanes.preds[directnhanes.preds$CASRN==this.chem,"lP.max"]
# # Otherwise use the heuristics model (Wambaugh 2014):
#   } else if (this.chem %in% chem.preds$CAS) {
#     human.hits[human.hits$CAS==this.chem,"Exposure.median"] <- chem.preds[chem.preds$CAS==this.chem,"seem3"]
#     human.hits[human.hits$CAS==this.chem,"Exposure.high"] <- chem.preds[chem.preds$CAS==this.chem,"seem3.u95"]
#   }
# }
# 
# # Drop chemicals without exposure predictions:
# human.hits<- subset(human.hits,!is.na(Exposure.median))
# 
# 
# # This code puts the chemicals into order by margin between exposure and activity:
# chem.names <- unique(human.hits$Compound)
# chem.names <- chem.names[!is.na(chem.names)]
# potency <- rep(Inf,times=length(chem.names))
# names(potency) <- chem.names
# potency.u <- potency
# for (this.chem in chem.names)
# {
#   this.subset <- subset(human.hits,Compound==this.chem)
#   if (dim(this.subset)[1]>0)
#   {
#     potency[this.chem] <- this.subset$HTS.Q10.equivdose.v/this.subset$Exposure.high
#     potency.u[this.chem] <- this.subset$HTS.Q10.equivdose.uv/this.subset$Exposure.high
#   }
# }
# potency <- sort(potency)
# human.hits$Compound <- factor(human.hits$Compound, levels=names(potency))
# 
# potency.u <- potency.u[names(potency.u)[potency.u<1]]
# if (any(names(potency)[potency>1] %in% names(potency.u)))
# {
#   potency.u <- potency.u[names(potency)[potency>1]]
# 
# new.overlaps <- names(potency.u[!is.na(potency.u)])
# first.change <- new.overlaps[1]
# last.change <- new.overlaps[length(new.overlaps)]
# window.start <- names(potency)[which(names(potency)==first.change)-5]
# window.end <- names(potency)[which(names(potency)==last.change)+5]
# window.names <- names(potency)[(which(names(potency)==first.change)-5):(which(names(potency)==last.change)+5)]
# # Initialize a new plot:
# Fig7a <- ggplot(data=human.hits) +
#   geom_segment(aes(x=Compound,xend=Compound,y=HTS.Q10.equivdose.v,yend=HTS.Q90.equivdose.v),size=1,color="white",alpha=0.5) +
#   geom_rect(mapping=aes(xmin=window.start,xmax=window.end,ymin=10^-9,ymax=10^3),color="grey",alpha=0.5)+
#   geom_segment(aes(x=Compound,xend=Compound,y=HTS.Q10.equivdose.v,yend=HTS.Q90.equivdose.v),size=1,color="red",alpha=0.5) +
#   geom_point(aes(x=Compound,y=HTS.Median.equivdose.v),shape=3) +
#   geom_point(aes(x=Compound,y=HTS.Q10.equivdose.v)) +
#   theme_bw() +
#   theme(axis.text.x = element_blank()) +
#   theme(axis.title.x = element_text(size=16)) +
#   theme(axis.title.y = element_text(size=16)) +
#   scale_y_log10(label=label_log(),limits = c(10^-9,10^3)) +
#   geom_segment(aes(x=Compound,xend=Compound,y=Exposure.high,yend=Exposure.median),size=1,color="blue",alpha=0.5) +
#   geom_point(aes(x=Compound,y=Exposure.median),shape=2) +
#   ylab("Bioactive Dose & Exposure\nmg/kg BW/day\n(Variability Only)") +
#   xlab("Chemicals Ranked By Ratio Between Bioactive Dose and Exposure")+
#   annotate("text", size=8,x = names(potency)[10], y = 100, label = "a")
# 
# # Initialize a new plot:
# Fig7c <- ggplot() +
#   geom_segment(data=human.hits,aes(x=Compound,xend=Compound,y=HTS.Q10.equivdose.v,yend=HTS.Q90.equivdose.v),size=3,color="grey") +
#   geom_segment(data=human.hits,aes(x=Compound,xend=Compound,y=HTS.Q10.equivdose.uv,yend=HTS.Q90.equivdose.uv),size=3,color="red",alpha=0.5) +
#   geom_point(data=human.hits,aes(x=Compound,y=HTS.Median.equivdose.uv),shape=3,size=2) +
#   geom_point(data=human.hits,aes(x=Compound,y=HTS.Q10.equivdose.uv),size=2) +
#   theme_bw() +
#   theme(axis.text.x = element_text(angle = 60, hjust = 1,size=6)) +
#   theme(axis.text.x = element_blank()) +
#   theme(axis.title.x = element_text(size=16)) +
#   theme(axis.title.y = element_text(size=16)) +
#   xlim(window.names) +
#   scale_y_log10(label=label_log(),limits = c(10^-8,2*10^2)) +
#   geom_segment(data=human.hits,aes(x=Compound,xend=Compound,y=Exposure.high,yend=Exposure.median),size=3,color="blue",alpha=0.5) +
#   geom_segment(data=subset(human.hits,Compound%in%names(potency.u)),aes(x=Compound,xend=Compound,y=10^-8,yend=Exposure.median/1.5),size=2,arrow=arrow(length=unit(0.5,"cm")))+
#   geom_point(data=human.hits,aes(x=Compound,y=Exposure.median),shape=2,size=2) +
#   xlab("") +
#   ylab("Bioactive Dose & Exposure\nmg/kg BW/day\n(Uncertainty and Variability)") +
#   annotate("text", size=8,x = window.names[1], y = 100, label = "b")
# 
# 
# #print(Fig10b)
# #dev.new(width=10,height=6)
# multiplot(Fig7a,Fig7c,cols=1,heights=c(0.5,0.5))
# 
# write.csv(subset(human.hits,Exposure.high>HTS.Q10.equivdose.uv)[,c("Compound","DSSTox_Substance_Id","Human.Clint","Human.Funbound.plasma","HTS.Q10.ACC","HTS.Q10.equivdose.v","HTS.Q10.equivdose.uv","Exposure.high")],file=paste("SupTable5-",Sys.Date(),".txt",sep=""),row.names=FALSE)
# }

## ----calc.stats,  eval = execute.vignette-------------------------------------
# Wetmore.chems <- subset(chem.physical_and_invitro.data,regexpr("Wetmore",Human.Clint.Reference)!=-1)[,c("Compound","CAS","DTXSID","Formula")]
# Wetmore.chems <- subset(Wetmore.chems,CAS%in%get_cheminfo())
# 
# for (this.cas in Wetmore.chems$CAS)
# {
#   Wetmore.chems[Wetmore.chems$CAS==this.cas,"Css.Lit"] <- get_lit_css(
#     chem.cas=this.cas,
#     output.units="uM")
#   set.seed(42)
#   Wetmore.chems[Wetmore.chems$CAS==this.cas,"Css.v192"] <- calc_mc_css(
#     chem.cas=this.cas,
#     invitro.mc.arg.list=list(
#       fup.meas.cv=NULL,
#       clint.meas.cv=NULL,
#       fup.censored.dist=TRUE),
#     output.units="uM")
#   set.seed(42)
#   Wetmore.chems[Wetmore.chems$CAS==this.cas,"Css.v110"] <- calc_mc_css(
#     chem.cas=this.cas,
#     output.units="uM")
# }
# 
# median(Wetmore.chems$Css.v110/Wetmore.chems$Css.Lit,na.rm=TRUE)
# 
# ceetox$Human.Clint2 <- sapply(as.character(ceetox$Human.Clint),
#                               function(x) as.numeric(strsplit(x,",")[[1]][1]))
# ceetox$Human.Fup2 <- sapply(as.character(ceetox$Human.Funbound.plasma),
#                             function(x) as.numeric(strsplit(x,",")[[1]][1]))
# write.csv(ceetox[,c(1,2,8,9,16,17,6,7,12,30,10,11,15,31,13,14,18:28)],row.names=FALSE,file=paste("Supplemental-Table4-",Sys.Date(),".txt",sep=""))
# 
# print(paste("Complete HTTK data on",sum(get_cheminfo()%in%ceetox$CAS),"new chemicals."))

## ----configure_knitr, eval = TRUE, echo=FALSE---------------------------------
knitr::opts_chunk$set(echo = TRUE, collapse = TRUE, comment = '#>')
knitr::opts_chunk$set(echo = TRUE,out.width=700, fig.align='center') #figure out.width=700px
options(rmarkdown.html_vignette.check_title = FALSE)

# Clear memory
rm(list=ls()) 

# Useful function
`%!in%`<- Negate(`%in%`)

## ----runchunks, eval = TRUE---------------------------------------------------
# Set whether or not the following chunks will be executed (run):
run.simulations <- FALSE # Change FALSE to TRUE here to make the vignette work
make.plots <- FALSE # change to TRUE to make the plots
run.simulations.2 <- FALSE #for second part of vignette
make.plots.2 <- FALSE # change to TRUE to make the plots

## ----setup, eval = TRUE-------------------------------------------------------
# Set working directory
loc.wd <- tempdir()
#loc.wd <- "C:/Users/jwambaug/OneDrive - Environmental Protection Agency (EPA)/Profile/Documents/Research Projects/DermalTK/vingette"
#loc.wd <- "/Users/ameade/Library/CloudStorage/GoogleDrive-aemeade7@gmail.com/My Drive/EPA/HTTK-Dermal/HTTK-Dermal-Vignette"

#loc.wd = "C:/Users/cschacht/OneDrive - Environmental Protection Agency (EPA)/Profile/Documents/CCTE_2023_2024/dermal/thisone"

# Set location of httk package
#loc.httk <- "C:/Users/jwambaug/git/httk-dev/httk"


# Load packages
packages <- c("httk","httkexamples","dplyr",
              "tidyverse","xlsx","Metrics", #for data manipulation
              "ggplot2","ggforce","ggpubr","ggrepel","viridis", #for plotting
              "knitr", "ggpubr","grid","ggh4x","readr","ggforce","knitr","tidyr",
              "stringr","pracma") #to make pretty visual tables

sapply(packages, require, character.only=TRUE)

# Make sure we're using a clean version of the httk chemical library:
#reset_httk()

## ----1_load_data, eval = FALSE------------------------------------------------
# # Load CvT table database
# load(paste0(loc.wd,"/R_CvT_Database/CvT_all_tables_2022-08-17.Rdata")) #Necessary file that is not included yet
#   # Load CvT data that is not yet in CvT database (Annabel did this)
# load(paste0(loc.wd,"/R_CvT_Database/CvT_all_tables_2023-07-05_noSQL.Rdata")) #Necessary file that is not included yet
# 
#   #Add cumulative_amount column in SQL DB_series (we don't use any cumulative amounts from SQL data in final results)
#   DB_series <- DB_series %>% mutate(cumulative_amount=NA)
# 
# # Bind data sets from database and noSQL collection.
# DB_documents_noSQL<-DB_documents_noSQL[colnames(DB_documents_noSQL) %in% colnames(DB_documents)] #Keep only columns from DB_documents_noSQL that are also found in DB_documents
# DB_documents <- rbind(DB_documents,DB_documents_noSQL)
# DB_studies_noSQL<-DB_studies_noSQL[colnames(DB_studies_noSQL) %in% colnames(DB_studies)]
# DB_studies <- rbind(DB_studies,DB_studies_noSQL)
# DB_chemicals <- rbind(DB_chemicals,DB_chemicals_noSQL)
# DB_subjects <- rbind(DB_subjects,DB_subjects_noSQL)
# DB_series <- rbind(DB_series,DB_series_noSQL)
# DB_conc_time_values_noSQL<-DB_conc_time_values_noSQL[colnames(DB_conc_time_values_noSQL) %in% colnames(DB_conc_time_values)]
# DB_conc_time_values <- rbind(DB_conc_time_values,DB_conc_time_values_noSQL)

## ----1_filter_data, eval = FALSE----------------------------------------------
# # Join necessary DBs: conc_time_values, series, studies, subjects
# df.full <- DB_conc_time_values %>%
#   left_join(DB_series,by=c("fk_series_id"="id")) %>%
#   left_join(DB_studies,by=c("fk_study_id"="id")) %>%
#   left_join(DB_subjects,by=c("fk_subject_id"="id")) %>%
#   left_join(DB_documents[,c("id","pmid")],by=c("fk_extraction_document_id" = "id")) %>%
#   dplyr::rename(extraction_document_pmid=pmid) %>%
#   select(!(ends_with(".x") | ends_with(".y"))) %>%
#   filter(!is.na(test_substance_dtxsid)) %>% #remove series w/o defined chemicals (Changed from study to series AG)
#   filter( !is.na(conc)) %>% #filter out NA data
#   filter(!is.na(conc_medium_normalized)) %>% #remove series w/o defined medium (i.e., plasma, blood, urine, etc.)
#   filter(test_substance_dtxsid==analyte_dtxsid | is.na(analyte_dtxsid)) #analyte (measured substance) and test substance must be the same
# 
# df.full <- distinct(df.full)
# 
# # Remove empty cells
# df.full <- type_convert(df.full)
# df.full <- df.full %>% filter(!is.na(conc))
# 
# # Get list of chemicals that have dermal data
# df.dermal <- df.full %>% filter(administration_route_normalized=="dermal")
# dermal_dtxsid <- unique(df.dermal$test_substance_dtxsid)
# 
# # Only keep data for chemicals that have dermal data
# df <- df.full %>% filter(test_substance_dtxsid %in% dermal_dtxsid)

## ----load_CvT_data, eval = run.simulations------------------------------------
# df <- httkexamples::dermalCvT2025

## ----summarize_cvt, eval=run.simulations--------------------------------------
# table <- df %>% mutate(Chemical = get_chem_id(dtxsid=test_substance_dtxsid)$chem.name) %>% dplyr::count(Chemical,test_substance_dtxsid,extraction_document_pmid,sort=F) %>% dplyr::rename(Number.of.Data.Points = n)
# row.names(table) <- 1:nrow(table)
# knitr::kable(table, row.names=TRUE,caption="List of chemicals with dermal data before cleaning data.")
# dir.create(normalizePath(paste0(loc.wd,"/tables")))
# write.table(table,
#             file=normalizePath(paste0(loc.wd,"/tables/ChemicalswDermalData.txt")),
#             col.names=TRUE,
#             row.names=FALSE,
#             quote=FALSE,
#             sep="\t")

## ----1_supptable, eval=FALSE--------------------------------------------------
# # Load chemical info
# supptab1_meade2023 <- read.xlsx(file=paste0(loc.wd,"/CCD-Batch-Search_2022-11-29_07_06_35.xlsx"),
#                                 sheetName="Main Data") #A separate download was needed for this file AG 12/6/23
# 
# # Rename chemical properties and change units
# supptab1_meade2023 <- supptab1_meade2023 %>% mutate(Water.Solubility.mg.L = WATER_SOLUBILITY_MOL.L_OPERA_PRED*AVERAGE_MASS*1000,
#                                                     Vapor.Pressure.mmHg = VAPOR_PRESSURE_MMHG_OPERA_PRED,
#                                                     Boiling.Point.C = BOILING_POINT_DEGC_OPERA_PRED,
#                                                     logP = OCTANOL_WATER_PARTITION_LOGP_OPERA_PRED,
#                                                     MW = AVERAGE_MASS,
# ) %>%
#   select(c(PREFERRED_NAME,DTXSID,Water.Solubility.mg.L,Vapor.Pressure.mmHg,Boiling.Point.C,logP,MW))
# 
# # Add column for "Volatility
# supptab1_meade2023 <- supptab1_meade2023 %>% mutate(Volatility = ifelse(Boiling.Point.C<=75,"Very Volatile",
#                                                                         ifelse(Boiling.Point.C>400,"Not Volatile",
#                                                                                ifelse((Boiling.Point.C>=250)&(Boiling.Point.C<=400),"Semi-Volatile","Volatile"))),
#                                                     # Rename long chemicals to nick-names
#                                                     PREFERRED_NAME = ifelse(PREFERRED_NAME=="Methyl tert-butyl ether","MBTE",PREFERRED_NAME),
#                                                     PREFERRED_NAME = ifelse(PREFERRED_NAME=="3,3',5,5'-Tetrabromobisphenol A","Bromdian",PREFERRED_NAME),
#                                                     PREFERRED_NAME = ifelse(PREFERRED_NAME=="4,4'-Sulfonyldiphenol","Bisphenol S",PREFERRED_NAME),
#                                                     PREFERRED_NAME = ifelse(PREFERRED_NAME=="Dichloromethane","DCM",PREFERRED_NAME),
#                                                     PREFERRED_NAME = ifelse(PREFERRED_NAME=="Tetrachloroethylene","PERC/TCE",PREFERRED_NAME),
#                                                     PREFERRED_NAME = ifelse(PREFERRED_NAME=="1-Methylbenzene","Toluene",PREFERRED_NAME))
# 
# supptab1_meade2023$Volatility <- factor(supptab1_meade2023$Volatility, levels=c("Not Volatile","Semi-Volatile","Volatile","Very Volatile"))
# #save chemical dataframe
# save(supptab1_meade2023,file=noramlizePath(paste0(loc.wd,"/meade2023_",format(Sys.time(), "%b_%d_%Y"),".Rdata")))
# 
# supptab1_meade2023[,c(3:7)]=signif(supptab1_meade2023[,c(3:7)],3)
# knitr::kable(supptab1_meade2023,
#              #row.names=TRUE,
#              caption="Chemical properties",
#              floating.environment="sidewaystable",
#              align="c")
# write.table(supptab1_meade2023,
#             file=paste0(loc.wd,"/tables/ChemicalProperties.txt"),
#             col.names=TRUE,
#             row.names=FALSE,
#             quote=FALSE,
#             sep="\t")
# 

## ----load_suptable, eval=run.simulations--------------------------------------
# supptab1_meade2023 <- httkexamples::meade2025
# supptab1_meade2023[,c(3:7)]=signif(supptab1_meade2023[,c(3:7)],3)

## ----1_load_QSAR, eval=run.simulations----------------------------------------
# load_dawson2021() #get QSAR data, overwrite for p-values greater than 0.05

## ----1_clean_data, eval=run.simulations---------------------------------------
# # Select route (dermal/iv/oral)
# route.ls = c("iv","dermal","oral")
# 
# # Reduce data based on available in vitro data
# # df.reduced <- df %>% filter(administration_route_normalized %in% route.ls) %>% #only iv, oral, dermal routes
# #   filter(test_substance_dtxsid %!in% c("DTXSID4021557","DTXSID4025371","DTXSID3020752")) #no metabolism data for: dibromomethane, halothane, isoflurane
# df.reduced <- df %>% filter(administration_route_normalized %in% route.ls) %>% #only iv, oral, dermal routes
#   filter(!(test_substance_dtxsid %in% c("DTXSID4021557","DTXSID4025371","DTXSID3020752"))) #no metabolism data for: dibromomethane, halothane, isoflurane
# 
# df.reduced <- type_convert(df.reduced) #change dose_level_normalized to numeric
# 
# #Join df.reduced with the Volatility/chemical info from supptab1_meade2023
# df.reduced = df.reduced %>% left_join(supptab1_meade2023,by=c("test_substance_dtxsid"="DTXSID"))
# 
# df.reduced=subset(df.reduced, !(conc_medium_normalized %in%c("feces","urine")))
# # Display which chemicals are being looked at
# table <- df.reduced %>%
#   mutate(Chemical = get_chem_id(dtxsid=test_substance_dtxsid)$chem.name) %>%
#   dplyr::count(Chemical,test_substance_dtxsid,extraction_document_pmid,conc_medium_normalized,sort=F) %>%
#   dplyr::rename("Number.of.Data.Points" = n)
# row.names(table) <- 1:nrow(table)
# knitr::kable(table,
#              row.names=TRUE,
#              caption="List of chemicals with dermal data after cleaning data.")
# write.table(table,
#             file=paste0(loc.wd,"/tables/ChemicalswDermalDataCleaned.txt"),
#             col.names=TRUE,
#             row.names=FALSE,
#             quote=FALSE,
#             sep="\t")

## ----conc_cleanup, eval=run.simulations---------------------------------------
# # Set dummy column for Concentration units
# df.reduced$conc_normalized = NA
# df.reduced$conc_units_normalized = df.reduced$conc_units_original
# 
# allset = which(df.reduced$conc_units_original %in% c("ug/mL","ug/g","mg/kg", "mcg/mL","mg/L"))
# df.reduced$conc_units_normalized[allset]="mg/L"; df.reduced$conc_normalized[allset]=df.reduced$conc_original[allset]
# 
# ngml = which(df.reduced$conc_units_original=="ng/ml");df.reduced$conc_normalized[ngml]=  df.reduced$conc_original[ngml]*0.001
# df.reduced$conc_units_normalized[ngml]="mg/L"
# 
# ngl = which(df.reduced$conc_units_original=="ng/l");df.reduced$conc_normalized[ngl]=  df.reduced$conc_original[ngl]*1e-06
# df.reduced$conc_units_normalized[ngl]="mg/L"
# 
# molunts = which(df.reduced$conc_units_original %in% c("uM","nmol/L","umol/L"))
# dtx=unique(df.reduced[molunts,c("test_substance_dtxsid","conc_units_original")])
# dtx$mw = get_physchem_param(param="MW", dtxsid=dtx$test_substance_dtxsid)
# 
# for(z in 1:dim(dtx)[1]){
#   these.rows=which(df.reduced$test_substance_dtxsid==dtx$test_substance_dtxsid[z] & df.reduced$conc_units_original==dtx$conc_units_original[z])
#   conversion_val = convert_units(input.units = dtx$conc_units_original[z],output.units = "mg/L",dtxsid=dtx$test_substance_dtxsid[z])
#   df.reduced[these.rows,"conc_normalized"] = df.reduced[these.rows,"conc_original"] * conversion_val
#   df.reduced$conc_units_normalized[these.rows] = "mg/L"
# }
# 
# perc.dose=which(df.reduced$conc_units_original %in%c("% dose", "% dose/h"))
# df.reduced[perc.dose, "conc_normalized"]=df.reduced[perc.dose, "conc_original"]*df.reduced[perc.dose, "dose_level_original"]
# #df.reduced[perc.dose,"conc_units_normalized"]=df.reduced[perc.dose,"dose_level_original_units"]
# df.reduced[perc.dose,"conc_units_normalized"]="mg/L"
# # ppbv
# ppbv = which(df.reduced$conc_units_original=="ppbv")
# df.reduced[ppbv, "conc_normalized"] = convert_units(input.units = "ppbv",output.units = "mg/L",dtxsid=unique(df.reduced$analyte_dtxsid[ppbv]),state="gas") * df.reduced[ppbv, "conc_original"]
# df.reduced$conc_units_normalized[ppbv] = "mg/L"
# 
# 

## ----1_convert_dose_units, eval=run.simulations-------------------------------
# # Convert ug/mL to mg
# df.reduced <- df.reduced %>%
#   separate(dose_volume,
#            into=c("dose_volume","dose_volume_units"),
#            sep=" ") %>% #separate dose volume into number and units, units either NA or ml/mL
#   mutate(dose_volume=as.numeric(dose_volume)) %>%
#   mutate(dose_level_new =
#            ifelse(tolower(dose_level_original_units)=="ug/ml",
#                   dose_level_original*dose_volume/1e+3, # ug >- mg, vol in mL
#                   dose_level_original), #convert ug/ml to mg
#          dose_level_new_units =
#            ifelse(tolower(dose_level_original_units)=="ug/ml",
#                   "mg",
#                   dose_level_original_units))
# 
# 
# # Convert ppm units to mg/L (assuming ppm is in air) - add MW to dataframe to do this
# df.reduced <- df.reduced %>%
#   left_join(chem.physical_and_invitro.data[,c("DTXSID","MW")],
#             by=c("test_substance_dtxsid"="DTXSID"))
# df.reduced$MW.y=NULL
# colnames(df.reduced)=gsub("MW.x","MW",colnames(df.reduced)) #fix MW
# df.reduced  = df.reduced %>% #
#   mutate(MW = as.numeric(MW)) %>%
#   group_by(test_substance_dtxsid) %>%
#   mutate(dose_level_new =
#            ifelse(dose_level_original_units=="ppm" ,
#                   dose_level_new *
#                     convert_units(input.units="ppmw", #?? whatever
#                                   output.units = "mg/l",
#                                   MW = unique(MW)),
#                   dose_level_new),
#          # dose_level_new =
#          #   ifelse(dose_level_original_units=="ppm" & administration_route_original!="dermal vapor",
#          #          dose_level_new *
#          #            convert_units(input.units="ppmw", #?? whatever
#          #                          output.units = "mg/l",
#          #                          MW = unique(MW), state="liquid"),
#          #          dose_level_new),
#          dose_level_new_units =
#            ifelse(tolower(dose_level_original_units)=="ppm",
#                   "mg/L",
#                   dose_level_new_units))
# df.reduced$dose_level_new_units[which(df.reduced$dose_level_new_units=="ppm")]="mg/L"
# 
# # Set normalized vehicle
# df.reduced <- df.reduced %>%
#   mutate(dose_vehicle_normalized =
#            ifelse(grepl("corn oil",dose_vehicle) |
#                     grepl("ethanol",dose_vehicle),"octanol",
#                   ifelse(!is.na(dose_vehicle) &
#                            !grepl("Cookie",dose_vehicle),
#                          "water",
#                          NA)))
# 
# # Remove added chemical MW column for now
# df.reduced <- df.reduced %>% select(!MW)
# 
# # Display dosing scenarios
# table <- df.reduced %>%
#   mutate(dose_level_original=signif(dose_level_original,3),
#          dose_level_new = signif(dose_level_new,3),
#          Chemical = get_chem_id(dtxsid=test_substance_dtxsid)$chem.name) %>%
#   count(Chemical,dose_level_original,
#         dose_level_original_units,
#         dose_level_new,
#         dose_level_new_units,
#         dose_volume,
#         dose_volume_units,
#         dose_vehicle,
#         dose_vehicle_normalized,
#         dermal_applied_area,
#         dermal_applied_area_units,sort=F) %>%
#   rename("Number.of.Data.Points" = n)
# row.names(table) <- 1:nrow(table)
# knitr::kable(table,
#              #row.names=TRUE,
#              caption="Dosing Scenarios in CvT Data",
#              floating.environment="sidewaystable",
#              align="c")

## ----summarize_cvt2, eval=run.simulations-------------------------------------
# table <- df %>% mutate(Chemical = get_chem_id(dtxsid=test_substance_dtxsid)$chem.name) %>% dplyr::count(Chemical,test_substance_dtxsid,extraction_document_pmid,sort=F) %>% dplyr::rename(Number.of.Data.Points = n)
# row.names(table) <- 1:nrow(table)
# knitr::kable(table, row.names=TRUE,caption="List of chemicals with dermal data before cleaning data.")

## ----1_updateparms, eval=run.simulations--------------------------------------
# df.new=df.reduced
# 
# df.new$species = tolower(df.new$species)
# # get dose duration in numbers and time units
# df.new$dose_duration_num = as.numeric(str_extract(df.new$dose_duration, "[0-9]+"))
# df.new$dose_duration_units = str_extract(df.new$dose_duration, "[aA-zZ]+")
# df.cases <- df.new %>% mutate(BW = ifelse(!is.na(weight_kg),weight_kg,
#                                                     case_when(
#                                                       species=="rat" ~ 0.4,
#                                                       species=="human" ~ 70,
#                                                       species=="mouse" ~ 0.025,
#                                                       species=="rabbit" ~ 1.6
#                                                     )),
#                                         # Set human default height to 175 cm if not listed
#                                         height_cm = ifelse(species=="human" & is.na(height_cm),175,height_cm),
#                                         totalSA = case_when(
#                                           species=="rat" ~ 9.83*(BW*1000)^(2/3), # formula from Gouma et al., 2012, 195-240grams
#                                           species=="human" ~ sqrt(height_cm * BW/3600) * 100^2,
#                                           species=="mouse" ~ 9.83*(BW*1000)^(2/3),
#                                           species=="rabbit" ~ 100*11*(BW)^(2/3)  # formula from Tadashi et al., 2018
#                                         ),
#                                         #Assume Fskin_exposed = 10% if not stated
#                                         Fskin_exposed = ifelse(!is.na(dermal_applied_area),dermal_applied_area/totalSA,0.1),
#                                         #Infinite Dose if dosing units are concentration mg/l AJG 4/13/24: Double check that mg/l are listed in the correct places in the previous chunk.
#                                         InfiniteDose = ifelse(dose_level_new_units=="mg/L",1,0), # omg
# 
#                                         Vvehicle = ifelse(tolower(dose_volume_units)=="ml",dose_volume/1e3,dose_volume),
#                                         #Standardize time units for dose duration AJG 5/7/24
#                                         dose_duration_units = case_when(
#                                           dose_duration_units %in% c("hr","h","hour","hrs","hours") ~ "hours",
#                                           dose_duration_units %in% c("min","m","minute","minutes","mins") ~ "mins",
#                                           dose_duration_units %in% c("day","d","days") ~ "days"
#                                         ),
#                               dose_duration_num2 = ifelse(dose_duration_units=="mins", dose_duration_num/60, dose_duration_num),
#                               dose_duration_units2 = ifelse(dose_duration_units=="mins", "hours", dose_duration_units)
# 
# 
# )
# # remove experiments where conc_medium_normalized = feces and set observation to collect
# df.cases = subset(df.cases, !(conc_medium_normalized %in%c("urine","feces")))
# df.cases = df.cases%>%
#   mutate(conc_medium_obs = recode(conc_medium_normalized,
#                                   "blood"="Cven",
#                                   "liver"="Cliver",
#                                   "lung"="Clung",
#                                   "kidney"="Ckidney",
#                                   "plasma"="Cplasma",
#                                   "serum"="Cplasma",
#                                   "expired air" = "Aexhaled"
#   ))
# 
# 
# # Display dosing scenarios
# table <- df.cases %>%
#   mutate(dose_level_original=signif(dose_level_original,3),
#          dose_level_new = signif(dose_level_new,3),
#          Chemical = get_chem_id(dtxsid=test_substance_dtxsid)$chem.name) %>%
#   count(Chemical, species,dose_level_original,
#         dose_level_original_units,
#         dose_level_new,
#         dose_level_new_units,
#         dose_volume,
#         dose_volume_units,
#         dose_vehicle,
#         dose_vehicle_normalized,
#         dose_duration_num2,
#         dermal_applied_area,
#         dermal_applied_area_units,
#         extraction_document_pmid,sort=F)
# row.names(table) <- 1:nrow(table)
# knitr::kable(table,
#              #row.names=TRUE,
#              caption="Dosing Scenarios in CvT Data",
#              floating.environment="sidewaystable",
#              align="c")
# write.table(table,
#             file=paste0(loc.wd,"/tables/CvTdbDosingScenarios.txt"),
#             col.names=TRUE,
#             row.names=FALSE,
#             quote=FALSE,
#             sep="\t")
# 

## ----1_mergetable, eval=run.simulations---------------------------------------
# df.cases_new = df.cases
# df.cases_new$Kvehicle2water = df.cases_new$dose_vehicle_normalized # set this parameter
# df.cases_new =  df.cases_new %>% mutate(
#   administration_route_normalized = case_when(
#     administration_route_normalized == "oral" ~ "Oral",
#     administration_route_normalized == "iv" ~ "IV",
#     administration_route_normalized == "dermal" ~ "Dermal"
#   ),
#     #Add exhalation for volatile compounds
#     Exhalation = case_when(
#       levels(Volatility)[Volatility] == "Very Volatile" ~ TRUE,
#       levels(Volatility)[Volatility] == "Volatile" ~ TRUE,
#       levels(Volatility)[Volatility] == "Semi-Volatile" ~ TRUE,
#       levels(Volatility)[Volatility] == "Not Volatile" ~ FALSE
#     ),
#     # Set default vehicle volume when it is unknown. Assume a uniform 1 mm layer of vehicle on skin. Then there is 0.0001 L vehicle per cm^2 of exposed skin. For cases with non-dermal routes of exposure, these values are NA.
#     Vvehicle = case_when(
#       administration_route_normalized=="Dermal" ~ ifelse(!is.na(Vvehicle), Vvehicle, Fskin_exposed*totalSA*0.0001),
#       administration_route_normalized=="Oral" ~ NA,
#       administration_route_normalized=="IV" ~ NA)
# 
# )
# 
# # save what we want
# concentration_data_meade2023 = df.cases_new

## ----resavedata, eval=FALSE---------------------------------------------------
# cgwtools::resave(concentration_data_meade2023,
#                  file=normalizePath(paste0(loc.wd,
#                                            "meade2023_",
#                                            format(Sys.time(),
#                                            "%b_%d_%Y"),".Rdata")))
# 

## ----1_simsetup, eval=run.simulations-----------------------------------------
# 
# # Set output units for dermal model to be same as data
# output.units.original <- c( "Agut"="mg", "Agutlumen"="mg", "Aliver"="mg", "Aven"="mg", "Alung"="mg", "Arest"="mg", "Akidney"="mg", "Atubules"="mg", "Ametabolized"="mg", "Avehicle"="mg", "Ain"="mg",
#                             "Cgut"="mg/L", "Cliver"="mg/L", "Cven"="mg/L", "Clung"="mg/L", "Cart"="mg/L", "Crest"="mg/L", "Ckidney"="mg/L", "Cplasma"="mg/L", "Cvehicle"="mg/L", "Cvehicle_infinite"="mg/L")
# 
# df.simulation = concentration_data_meade2023
# 
# 
# 
# # Find experiments with unique dosing regimes/species/etc and average those that had multiple time points
# # for the same type of experiment. Rename each experiment with new_id.
# keep.cols=c("PREFERRED_NAME","test_substance_dtxsid", "conc_medium_obs", "conc_medium_normalized", "administration_route_normalized", "species", "BW", "dose_level_new", "dose_level_new_units","totalSA","Vvehicle","InfiniteDose","dose_duration_num2","dose_duration_units2","Fskin_exposed","Exhalation","dose_vehicle_normalized","Water.Solubility.mg.L", "Vapor.Pressure.mmHg","Boiling.Point.C","logP", "Volatility", "Kvehicle2water")
# df.simulation_red=data.frame(df.simulation%>%group_by(across(all_of(c("time_hr",keep.cols) )))%>%
#   summarize(conc_normalized=mean(conc_normalized),.groups="drop")%>%group_by(across(all_of(keep.cols)))%>% arrange(time_hr)%>% mutate(new_id=cur_group_id())%>%
#   ungroup())
# 
# df.simulation_red2=df.simulation_red%>%mutate(across(c(dose_duration_num2,dose_duration_units2,Vvehicle),~ifelse(is.na(.x),list(NULL),.x)))

## ----1_simulations,eval=run.simulations---------------------------------------
# df.run.sims = df.simulation_red2
# fkID = unique(df.run.sims$new_id)
# method.perm = c("Potts-Guy", "UK-Surrey")# for
# Kvehicle2water=c("octanol","water") # for
# exhalation_for_simulation = c("TRUE","FALSE")
# 
# 
# conc_predictions_meade2023LIST=list()
# 
# 
# for (include.e in exhalation_for_simulation){
#   for(i in 1:length(fkID)){
#     for(mp in 1:length(method.perm)){
#       for(k in 1:length(Kvehicle2water)){
#         sub.df = subset(df.run.sims, new_id == fkID[i])
#         specs = unique(sub.df[,c("test_substance_dtxsid","conc_medium_obs","administration_route_normalized",
#                                  "species","BW","dose_level_new","dose_level_new_units",
#                                  "totalSA","Vvehicle","InfiniteDose","dose_duration_num2","dose_duration_units2",
#                                 "Fskin_exposed","Exhalation")])
#         # check for experiments with only 1 timepoint and reset sub.df
#         if(length(sub.df$time_hr)==1){
#             sub.df=rbind(sub.df, sub.df[rep(1,1),])
#             sub.df[1,c("conc_normalized","time_hr")]=0
#         }
# 
#         parms = parameterize_dermal_pbtk(dtxsid = specs$test_substance_dtxsid,
#                                  species = specs$species,
#                                  totalSA = specs$totalSA,
#                                  default.to.human=T,
#                                  Kvehicle2water = Kvehicle2water[k],
#                                  InfiniteDose = specs$InfiniteDose,
#                                  method.permeability = method.perm[mp],
# 
#                                  model.type="dermal_1subcomp",
#                                  clint.pvalue.threshold = Inf,
#                                  suppress.messages = T
#                                  )
#         parms$BW = specs$BW
#         parms$Fskin_exposed = specs$Fskin_exposed
# 
#         # Remove exhalation or keep exhalation (except for collected air which is )
#         if(include.e == FALSE) {parms$Qalvc = 0}
# 
#         if(unique(sub.df$PREFERRED_NAME!="DCM"))
#           { # tolerance is bad for DCM, so set tolerance to default values for all other compounds.
#            rtol=1e-5; atol=1e-5
#         }else{
#            rtol=1e-4; atol=1e-4
#         }
# 
# 
#         sub.df=sub.df[order(sub.df$time_hr),]
#         timey = unique(c(0,sub.df$time_hr)) #time in hours
#         gc() # garbage collection (memory)
#         ok=data.frame(solve_dermal_pbtk(parameters = parms,
#                         times = timey/24, #convert to days
#                          route = tolower(specs$administration_route_normalized),
#                          model.type="dermal_1subcomp",
#                          plot = FALSE,
#                          output.units = output.units.original,
#                          washoff = TRUE,
#                          input.units = specs$dose_level_new_units,
#                          initial.dose=specs$dose_level_new,
#                          dose.duration = unlist(specs$dose_duration_num2),
#                          dose.duration.units = unlist(specs$dose_duration_units2),
#                          Vvehicle = unlist(specs$Vvehicle),
#                         #dosing.dermal = dosing.dermal,
#                          Kvehicle2water = Kvehicle2water[k],
#                          suppress.messages = TRUE,
#                         atol = atol, rtol= rtol,
#                         method="lsoda"
#                          ))
#          # extract only times we need
#           ok.time = subset(ok, time%in%c(ok$time[!(is.na(match(ok$time, sub.df$time_hr/24)))]))
#           sub.df$Prediction = ok.time[,c(specs$conc_medium_obs)]
#           sub.df$exhalation_for_simulation = include.e
# 
#           # specify vehicle and perm. method and vehicle if dermal
#           if(specs$administration_route_normalized != "Dermal"){
#             sub.df$method.perm = NA
#             sub.df$Kvehicle2water = NA
#             sub.df$method.name = specs$administration_route_normalized
#           }else{
#             sub.df$method.perm = method.perm[mp]
#             sub.df$Kvehicle2water = Kvehicle2water[k]
#             sub.df$method.name = paste(method.perm[mp], "- vehicle = ", Kvehicle2water[k])
#           }
# 
#         conc_predictions_meade2023LIST[[paste0(fkID[i],".",Kvehicle2water[k],".",method.perm[mp],".exh",include.e)]]= sub.df
#       }
#     }
#   }
# }
# #Bind data together to create a dataframe and organize some columns
#  conc_predictions_meade2023DF = do.call(rbind, conc_predictions_meade2023LIST)
#  rownames(conc_predictions_meade2023DF)=NULL
# 
# 
# 
#  #cgwtools::resave(conc_predictions_meade2023DF, conc_predictions_meade2023LIST, file=paste0(loc.wd,"/meade2023_",format(Sys.time(), "%b_%d_%Y"),".Rdata"))
# 

## ----load_data, eval=FALSE----------------------------------------------------
# # load(paste0(loc.wd, "/meade2023_Jun_13_2025.Rdata"))
# load(paste0(loc.wd, "/meade2023_Sep_02_2025.Rdata"))

## ----1_prepareData, eval = make.plots-----------------------------------------
# conc_predictions_meade2023DF$method.perm = gsub( "UK-Surrey","Surrey", conc_predictions_meade2023DF$method.perm)
# conc_predictions_meade2023DF$method.name = gsub( "UK-Surrey","Surrey", conc_predictions_meade2023DF$method.name)
# df.sim = conc_predictions_meade2023DF
# # Convert aexhaled air from mg to mg/l (assume a room of x liters, for humans - humans
# # the only species in these exhaled experiments)
# df.sim[which(df.sim$conc_medium_obs=="Aexhaled"),"Prediction"]=df.sim[which(df.sim$conc_medium_obs=="Aexhaled"),"Prediction"]/10000
# 
# df.sim$conc_normalized[which(df.sim$conc_normalized==0)]=1e-10
# df.sim$Prediction[which(df.sim$Prediction==0)]=1e-10
# df.sim.rmsle=df.sim %>% group_by(PREFERRED_NAME, method.name, exhalation_for_simulation)%>%
#   mutate(cmax_obs = max(conc_normalized), cmax_pred=max(Prediction)) %>%
#   mutate(RMSLE = rmse(log10(conc_normalized),log10(Prediction)),
#     Cmax_RMSLE = rmse(log10(cmax_obs), log10(cmax_pred)))
# 
# 
# # Linear fit
# ddf.sim.rmsle <- df.sim.rmsle %>% group_by(method.name) %>% do(
#   {
#     Adjusted.R2 = summary(lm(log10(Prediction) ~ log10(conc_normalized),data=.))$adj.r.squared
#     Coefficient = lm(log10(Prediction) ~ log10(conc_normalized),data=.)$coefficients[2]
#     Intercept = lm(log10(Prediction) ~ log10(conc_normalized),data=.)$coefficients[1]
#     Residuals = lm(log10(Prediction) ~ log10(conc_normalized),data=.)$residuals
#     Fitted.Values = lm(log10(Prediction) ~ log10(conc_normalized),data=.)$fitted.values
#     data.frame(.,Adjusted.R2,Coefficient,Intercept,Residuals,Fitted.Values)
#   }
# )
# 

## ----1_plot3, eval = make.plots, fig.height=10, fig.width=20------------------
# # Plot RMSLE vs Boiling Point
# 
# data = subset(df.sim.rmsle, exhalation_for_simulation==TRUE)
# 
# data=data%>%group_by(PREFERRED_NAME, Boiling.Point.C,method.name)%>%
#   summarize(Chemical.cmax.RMSLE = rmse(log10(cmax_obs),log10(cmax_pred)),
#     Chemical.RMSLE=rmse(log10(conc_normalized),log10(Prediction)))
# 
# data.rect = data.frame(xmin=c(0,75,250,400),
#                        xmax=c(75,250,400,Inf),
#                        ymin=rep(-Inf,4),
#                        ymax=rep(Inf,4),
#                        Volatility=c("Very Volatile",
#                                     "Volatile",
#                                     "Semi-Volatile",
#                                     "Not Volatile"))
# data.rect$Volatility <- factor(data.rect$Volatility, levels=data.rect$Volatility)
# viridis.colors <- viridis(4)
# plot <- ggplot(data=data,aes(x=`Boiling.Point.C`,y=Chemical.RMSLE)) +
#   geom_point()+
#   geom_smooth(method="lm",formula='y~x') +
#   geom_text_repel(data=data,aes(x=`Boiling.Point.C`,y=Chemical.RMSLE,label=PREFERRED_NAME),
#                   max.overlaps=Inf)+
#   facet_wrap(~method.name,scales="free") +
#   #scale_x_log10() +
#   geom_rect(data=data.rect,
#             aes(xmin=xmin,xmax=xmax,ymin=ymin,ymax=ymax,fill=Volatility),
#             alpha=0.5,
#             inherit.aes=FALSE) +
#   scale_fill_manual(values=c(`Not Volatile`=viridis.colors[1],
#                              `Semi-Volatile`=viridis.colors[2],
#                              `Volatile`=viridis.colors[3],
#                              `Very Volatile`=viridis.colors[4]))+
# 
#   labs(y="RMSLE",title="Boiling Point vs. RMSLE",x="Boiling Point (C)")+
#   theme_bw() +
#   theme(text=element_text(size=33),
#         plot.title=element_text(hjust=0.5),
#         legend.position="bottom")
# plot
# ggsave(paste(loc.wd, "/Figures_August2025/BPvsRMSLE_suppl.png",sep=""),
#        width = 20, height = 10, units = "in")
# 
# plot2 <- ggplot(data=data,aes(x=`Boiling.Point.C`,y=Chemical.cmax.RMSLE)) +
#   geom_point()+
#   geom_smooth(method="lm",formula='y~x') +
#   geom_text_repel(data=data,aes(x=`Boiling.Point.C`,y=Chemical.cmax.RMSLE,label=PREFERRED_NAME),
#                   max.overlaps=Inf)+
#   facet_wrap(~method.name,scales="free") +
#   #scale_x_log10() +
#   geom_rect(data=data.rect,
#             aes(xmin=xmin,xmax=xmax,ymin=ymin,ymax=ymax,fill=Volatility),
#             alpha=0.5,
#             inherit.aes=FALSE) +
#   scale_fill_manual(values=c(`Not Volatile`=viridis.colors[1],
#                              `Semi-Volatile`=viridis.colors[2],
#                              `Volatile`=viridis.colors[3],
#                              `Very Volatile`=viridis.colors[4]))+
# 
#   labs(y="RMSLE",title="Boiling Point vs. Cmax RMSLE",x="Boiling Point (C)")+
#   theme_bw() +
#   theme(text=element_text(size=33),
#         plot.title=element_text(hjust=0.5),
#         legend.position="bottom")
# #annotate_figure(plot2,top=text_grob("Boiling Point vs RMSLE",size=40,face="bold"))
# ggsave(paste(loc.wd, "/Figures_August2025/BPvsRMSLE_cmax_suppl.png",sep=""),
#        width = 20, height = 10, units = "in")
# 
# 

## ----1_exhalation_rmsle_plot,  eval=make.plots, fig.height=10, fig.width=30----
# df.exh.compare=df.sim.rmsle
# 
# Exh = data.frame(df.exh.compare %>% group_by(PREFERRED_NAME,method.name, Boiling.Point.C)%>%
#   arrange(exhalation_for_simulation) %>%
#   summarize(Cmax=Cmax_RMSLE[exhalation_for_simulation==FALSE]-Cmax_RMSLE[exhalation_for_simulation==TRUE], Full_time_course = RMSLE[exhalation_for_simulation==FALSE]-RMSLE[exhalation_for_simulation==TRUE]))
# 
# Exh$method.name= sub(" - ", " -\n", Exh$method.name)
# 
# 
# 
# #stack data
# stackExh = data.frame(Exh %>%
#   pivot_longer(cols = c("Cmax", "Full_time_course"),
#                names_to = "ind",
#                values_to = "values"))
# 
# data.text = unique(stackExh[,c("Boiling.Point.C","values","PREFERRED_NAME","ind","method.name")])
# data.rect = data.frame(xmin=c(0,75,250,400),
#                        xmax=c(75,250,400,Inf),
#                        ymin=rep(-Inf,4),
#                        ymax=rep(Inf,4),
#                        Volatility=c("Very Volatile",
#                                     "Volatile",
#                                     "Semi-Volatile",
#                                     "Not Volatile"))
# data.rect$Volatility <- factor(data.rect$Volatility,
#                                levels=data.rect$Volatility)
# viridis.colors <- viridis(4)
# 
# # rename labels for facets
# # labeller=labeller(ind = c(Cmax="Cmax",
# #               Full_time_course = "Full time-course"))
# 
# plot <- ggplot(data=stackExh,aes(x=Boiling.Point.C,y=values)) +
#   geom_point()+ #geom_line()+
#   theme_bw()+
#   geom_smooth(method='lm') +
#   facet_grid(ind~method.name, scales="free", labeller=labeller(ind = c(Cmax="Cmax",
#               Full_time_course = "Full time-course")))+
#   geom_rect(data=data.rect,
#             aes(xmin=xmin,xmax=xmax,ymin=ymin,ymax=ymax,fill=Volatility),
#             alpha=0.5,
#             inherit.aes=FALSE) +
#   scale_fill_manual(values=c(`Not Volatile`=viridis.colors[1],
#                              `Semi-Volatile`=viridis.colors[2],
#                              `Volatile`=viridis.colors[3],
#                              `Very Volatile`=viridis.colors[4]))+
#   geom_text_repel(data=data.text,aes(x=Boiling.Point.C,y=values,label=PREFERRED_NAME),
#                   max.overlaps=Inf)+
#   #facet_grid(cols=vars(Route.or.Method.if.Dermal), rows=vars(RMSLE.Type),scales="free_y")+
#   #scale_x_log10() +
#   geom_hline(aes(yintercept=0)) +
#   labs(y=expression(Delta~"RMSLE"),x="Boiling Point (C)",title="Change in RMSLE when Exhalation is Added")+
#   scale_color_brewer(type="qual",palette="Paired") +
#   theme(axis.text.x = element_text(angle=45,vjust=1,hjust=1),
#         plot.title=element_text(hjust=0.5),
#         text=element_text(size=30),
#         legend.position="bottom")
# plot
# 
# ggsave(paste(loc.wd, "/Figures_August2025/BP_RMSLE_Exhalation_main.png",sep=""),
#        width = 20, height = 10, units = "in")
# 
# # P-values for regression lines
# stackExhStats = stackExh%>% group_by(ind, method.name) %>%
#   summarize(model = list(lm(values~Boiling.Point.C, data=cur_data())),
#             .groups="drop")%>%
#   rowwise()%>%
#   mutate(msummary=list(summary(model)),
#          rsquared=msummary$r.squared,
#          p_val= pf(msummary$fstatistic[1], msummary$fstatistic[2], msummary$fstatistic[3], lower.tail=FALSE)
#         )%>%select(ind,method.name,rsquared,p_val)
# 

## ----cvt_plot_by_exh, eval =make.plots, fig.height=3, fig.width=3-------------
# df.sim2 = df.sim.rmsle
# 
# chem = unique(df.sim2$PREFERRED_NAME)
# 
# for(chx in 1:length(chem)){
#   each.chem = subset(df.sim2, PREFERRED_NAME==chem[chx])
#   #each.chem$dose = paste(each.chem$dose_level_new, each.chem$dose_level_new_units)
#   each.chem$dose=paste(each.chem$dose_level_new, each.chem$dose_level_new_units)
#   # each.chem$dose = factor(each.chem$dose,
#   #                         levels=unique(each.chem$dose)[order(unique(each.chem$dose_level_new))])
# 
#   each.chem$method.name= sub(" - ", " -\n", each.chem$method.name)
#   each.chem$subject=paste(each.chem$species, "BW",each.chem$BW, "kg")
# 
# 
#  ggplot(each.chem)+
#     geom_point(data=each.chem, aes(x=time_hr, y=conc_normalized,colour=dose))+
#     geom_line(data=each.chem, aes(x=time_hr, y=Prediction,colour=dose,linetype=exhalation_for_simulation),linewidth=1)+
#     labs(title=paste(chem[chx], "\n Log-transformed Concentrations v time"), x=" Time (hr)", y="Log Concentrations (mg/L)", colour="")+
#     facet_nested(~conc_medium_normalized+method.name,scales="free")+
#    scale_y_log10() +
#      theme(legend.position = "bottom")
# 
# 
#   ggsave(paste(loc.wd, "/Figures_August2025/cvt_eachchem_by_exhalation_suppl", unique(each.chem$test_substance_dtxsid),".png",sep=""),
#          width = 8, height = 6, units = "in")
# }
# 

## ----1_plot1,eval =make.plots, fig.height=3, fig.width=3----------------------
# df.new = subset(df.sim.rmsle, exhalation_for_simulation==Exhalation)
# 
# chem = unique(df.new$PREFERRED_NAME)
# 
# for(chx in 1:length(chem)){
#   each.chem = subset(df.new, PREFERRED_NAME==chem[chx])
#   #each.chem$dose = paste(each.chem$dose_level_new, each.chem$dose_level_new_units)
#   each.chem$dose=paste(each.chem$dose_level_new, each.chem$dose_level_new_units)
#   each.chem$dose = factor(each.chem$dose,
#                           levels=unique(each.chem$dose)[order(unique(each.chem$dose_level_new))])
# 
#   each.chem$method.name= sub(" - ", " -\n", each.chem$method.name)
#   each.chem$subject=paste(each.chem$species, "BW",each.chem$BW, "kg")
# 
#   ggplot(each.chem, aes(x=conc_normalized,y=Prediction))+
#     geom_point(aes(colour=dose,shape=conc_medium_normalized))+
#     labs(title=paste(chem[chx], "\n Log-transformed Concentrations"), x="Observed Concentrations (mg/L)", x="Predicted Concentrations (mg/L)", colour="", shape="")+
#     #facet_wrap(~dose,scales="free")+
#     facet_wrap(~method.name,scales="free")+
#     geom_smooth(method='lm',formula='y~x',colour="black")+
#      geom_abline(linetype=2)+
#      #geom_smooth(aes(color=method.name),method='lm',formula='y~x')+
#           scale_x_log10() +
#     scale_y_log10() +
#     theme_bw() + theme(text=element_text(size=11),
#                        strip.text=element_text(size=13))
#     #theme(legend.position = "bottom")
# 
#   ggsave(paste(loc.wd, "/Figures_August2025/pvo_bydose_suppl", unique(each.chem$test_substance_dtxsid),".png",sep=""),
#          width = 6, height = 6, units = "in")
# 
# 
# }
# 
# 
# # Linear fit for these.
# linear.fit.new <- df.new %>% group_by(method.name) %>% do(
#   {
#     Adjusted.R2 = summary(lm(log10(Prediction) ~ log10(conc_normalized),data=.))$adj.r.squared
#     Coefficient = lm(log10(Prediction) ~ log10(conc_normalized),data=.)$coefficients[2]
#     Intercept = lm(log10(Prediction) ~ log10(conc_normalized),data=.)$coefficients[1]
#     Residuals = lm(log10(Prediction) ~ log10(conc_normalized),data=.)$residuals
#     Fitted.Values = lm(log10(Prediction) ~ log10(conc_normalized),data=.)$fitted.values
#     data.frame(.,Adjusted.R2,Coefficient,Intercept,Residuals,Fitted.Values)
#   }
# )
# # RMSLE grouped by method type
# rmsle.all = df.new%>%group_by(method.name)%>%
#   summarize(  Adjusted.R2 = summary(lm(log10(Prediction) ~ log10(conc_normalized)))$adj.r.squared,
#               RMSLE_total =rmse(log10(Prediction),log10(conc_normalized)),
#                 CMAX_RMSLE_total =rmse(log10(cmax_pred) ,log10(cmax_obs)    )
# 
#               )
# 

## ----1_plot6, eval=make.plots, fig.height=10, fig.width=20--------------------
# df.new = subset(df.sim, exhalation_for_simulation==Exhalation)
# df.sim.rmsle2=df.new %>% group_by(PREFERRED_NAME, method.name)%>%
#   mutate(cmax_obs = max(conc_normalized), cmax_pred=max(Prediction)) %>%
#   mutate(RMSLE = rmse(log10(conc_normalized),log10(Prediction)),
#     Cmax_RMSLE = rmse(log10(cmax_obs), log10(cmax_pred)))
# 
# 
# col=c("#440154ff","indianred","#2d708eff","steelblue1","#7ad151ff","#fde725ff")
# plot.pvo=ggplot(df.sim.rmsle2, aes(x=conc_normalized, y=Prediction))+
#   geom_point(aes( colour=method.name,shape=PREFERRED_NAME), alpha=1,size=2)+
#     labs(title=paste0("(A) Concentrations"),
#        y = "Simulated (mg/L)", x="Observed (mg/L)",
#        color="Route or\n Method",shape="Chemical")+
#     scale_shape_manual(values=1: length(unique(df.sim.rmsle2$PREFERRED_NAME)))+
#     geom_smooth(aes(colour=method.name),method="lm",se=F)+
#   #scale_color_brewer(type="qual",palette="Paired",direction=-1) +
#   scale_colour_manual(values=col)+
#   theme_bw() +
#   scale_x_log10() + scale_y_log10() +
#   geom_abline(lty="dashed") +
#   #coord_fixed(xlim=lims,ylim=lims) +
#   theme(plot.title=element_text(hjust=0.5),
#         text=element_text(size=30))
# 
# 
# noiv=subset(df.sim.rmsle2,!(method.name%in%"IV"))
# plot.cmax = ggplot(noiv, aes(x=cmax_obs, y=cmax_pred))+
#   geom_point(aes( colour=method.name,shape=PREFERRED_NAME), alpha=1,size=2)+
#     labs(title=paste0("(B) Max Concentrations"),
#        y = "Simulated (mg/L)", x="Observed (mg/L)",
#        color="Route or\n Method", shape="Chemical")+
#   #scale_color_brewer(type="qual",palette="Paired",direction=-1) +
#    scale_colour_manual(values=col[-1])+
#      scale_shape_manual(values=1: length(unique(noiv$PREFERRED_NAME)))+
#   theme_bw() +
#   scale_x_log10() + scale_y_log10() +
#   geom_abline(lty="dashed") +
#   #coord_fixed(xlim=lims,ylim=lims) +
#   theme(plot.title=element_text(hjust=0.5),
#         text=element_text(size=30))
# 
# 
# ggarrange(plot.pvo, plot.cmax, common.legend=T,legend="right")
# ggsave(paste(loc.wd, "/Figures_Sep2025/PvO_main.png",sep=""),
#        width = 20, height = 10, units = "in",dpi=300)
# 
# 
# method.rmsle.only=df.new %>% group_by(PREFERRED_NAME, method.name)%>%
#     mutate(cmax_obs = max(conc_normalized), cmax_pred=max(Prediction)) %>%
#     summarize(RMSLE = rmse(log10(conc_normalized),log10(Prediction)),
#            Cmax_RMSLE = rmse(log10(cmax_obs), log10(cmax_pred))) %>%group_by(method.name)%>%summarize(mean(Cmax_RMSLE),
#                                                                                                       mean(RMSLE))
# #COMPARE AUCs
# #library("pracma")
# 
# df.sim.derm=subset(df.sim.rmsle2,administration_route_normalized=="Dermal")
# auc.df=df.sim.derm %>% group_by(PREFERRED_NAME, method.name,conc_medium_normalized,dose_level_new)%>%
# mutate(auc_observed=trapz(time_hr,conc_normalized), auc_pred=trapz(time_hr,Prediction))
# auc.df=data.frame(auc.df)
# 
# auc.pvo=ggplot(auc.df, aes(x=auc_observed, y=auc_pred))+
#   geom_point(aes( colour=method.name,shape=PREFERRED_NAME), alpha=1,size=2)+
#   labs(title="Dermal AUCs - Observed vs. Predicted",
#        y = "Simulated (AUC mg/L-h)", x="Observed (AUC mg/L-h)",
#        color="Route or\n Method",shape="Chemical")+
#   scale_shape_manual(values=1: length(unique(df.sim.rmsle2$PREFERRED_NAME)))+
#   geom_smooth(aes(colour=method.name),method="lm",se=F)+
#   #scale_color_brewer(type="qual",palette="Paired",direction=-1) +
#   scale_colour_manual(values=col)+
#   theme_bw() +
#   scale_x_log10() + scale_y_log10() +
#   geom_abline(lty="dashed") +
#   #coord_fixed(xlim=lims,ylim=lims) +
#   theme(plot.title=element_text(hjust=0.5),
#         text=element_text(size=30))
# ggsave(paste(loc.wd, "/Figures_Sep2025/PvO_AUC.png",sep=""),
#        width = 16, height = 10, units = "in",dpi=300)
# 

## ----1_exhalation_correct, eval=make.plots------------------------------------
# # Extract correct exhalation
# 
# # df = conc_predictions_meade2023DF
# # df$conc_normalized[which(df$conc_normalized==0)]=1e-10
# # df$Prediction[which(df$Prediction==0)]=1e-10
# df=df.sim
# dfmatchE =  subset(df, exhalation_for_simulation==Exhalation)
# # order chemicals by volatility
# vol.chem = unique(dfmatchE[,c("PREFERRED_NAME","Boiling.Point.C")])
# vol.chem2=vol.chem[order(vol.chem$Boiling.Point.C,decreasing=F),]
# 
# #also want to extract table to identify  experiments that actually did list the vehicle as either water or octanol (or similar)
# dfmatchE2 = data.frame(dfmatchE%>%group_by(PREFERRED_NAME,method.name,dose_vehicle_normalized,Kvehicle2water,administration_route_normalized)%>%
#       mutate(cmax_obs = max(conc_normalized), cmax_pred=max(Prediction)) %>%
#   summarize(Cmax_RMSLE = rmse(log10(cmax_obs),log10(cmax_pred)),
#          RMSLE = rmse(log10(conc_normalized),log10(Prediction))))
# 
# # Reorganize the columns so RMSLE values can be grouped by Cmax or total RMSLE and then take average RMSLE values of oral or iv values so we have one per chemical
# dfmatchE3 = data.frame(dfmatchE2 %>%
#   pivot_longer(cols = c("Cmax_RMSLE", "RMSLE"),
#                names_to = "ind",
#                values_to = "value") %>% group_by(PREFERRED_NAME,ind,administration_route_normalized) %>%
#     mutate(value = if_else(administration_route_normalized !="Dermal", mean(value[administration_route_normalized !="Dermal"]), value)
#            ))
# 
# # Make PREFERRED_NAME a factor and set the levels to match those from the volatility order.
# dfmatchE3$PREFERRED_NAME = factor(dfmatchE3$PREFERRED_NAME,
#                                               levels=vol.chem2$PREFERRED_NAME)
# 
# 
# 

## ----1_heatmap, eval=make.plots, fig.height=8, fig.width=11-------------------
# dfmatchE4=dfmatchE3[-which(dfmatchE3$method.name=="IV" & dfmatchE3$ind=="Cmax_RMSLE"),] # remove IV CMax
# ggplot(dfmatchE4, aes(y=PREFERRED_NAME, x=method.name))+
#   geom_tile(aes(fill=value))+
#   #geom_tile(aes(fill=Chemical.Cmax.RMSLE.NE))+
#   facet_wrap(~ind)+
#   theme(axis.text.x = element_text(angle = 90, vjust = 0.5, hjust=1))+
#   scale_fill_viridis()+
#   geom_text(aes(label=round(value,2)),colour="white",size=4)+
#   labs(title="",
#        x="Route or\n Method",
#        fill="RMSLE",y="Chemical")+
#   theme_bw() +
#   theme(axis.text.x=element_text(angle=45,vjust=1,hjust=1),
#         axis.text.y=element_text(angle=45,vjust=1.05,hjust=0.9),
#         plot.title=element_text(hjust=0.5),
#         text=element_text(size=20))+
#   geom_tile(data=subset(dfmatchE3, dose_vehicle_normalized==Kvehicle2water & administration_route_normalized=="Dermal"),aes(y=PREFERRED_NAME, x=method.name),
#             size=1.5,fill=NA,colour="red" )
# ggsave(paste(loc.wd,"/Figures_August2025/RMSLE_compare_main_september.png",sep=""),width=11,height=8,units="in")
# 

## ----2_load_data, eval=FALSE--------------------------------------------------
# # Load in vitro data
# load("invitrodb_3_5_mc5.Rdata")

## ----2_load_insilicohttk, eval=run.simulations.2------------------------------
# # Get chemicals of interest
# load_sipes2017(overwrite=F)

## ----2_load_chem_data, eval=FALSE---------------------------------------------
# # Using list, download chem info from CompTox Dashboard for chem.list chemicals, and load.
# df.chem <- read_excel(
#   "C:/Users/WambaughJohn/Downloads/CCD-Batch-Search_2023-03-08_12_23_25.xlsx",
#   sheet=2)
# df.chem <- as.data.frame(df.chem)
# # %>%filter(!is.na(BOILING_POINT_DEGC_OPERA_PRED))
# df.chem <- type_convert(df.chem,na="N/A")
# df.chem <- type_convert(df.chem,na="N/A")

## ----2_clean_data, eval=FALSE-------------------------------------------------
# #Get list of chemicals that can run in dermal model:
# chem.list <- get_cheminfo(info="DTXSID",species="Human",model="dermal_1subcomp")
# write.table(chem.list,
#             file=paste0(loc.wd,"/tables/ChemicalList.txt"),
#             col.names=TRUE,
#             row.names=FALSE,
#             quote=FALSE,
#             sep="\t")
# 
# # Take out volatile chemicals
# chems.from.invivo <- c("DTXSID0020232",
#                        "DTXSID6022923",
#                        "DTXSID8024151",
#                        "DTXSID3022409",
#                        "DTXSID1026081")
# df.chem <- df.chem %>% filter(!is.na(BOILING_POINT_DEGC_OPERA_PRED))%>%
#   filter((BOILING_POINT_DEGC_OPERA_PRED >= 400) | (DTXSID %in% chems.from.invivo))
# chem.list <- df.chem$DTXSID
# 
# #get sample to test code with
# set.seed(100)
# #chem.list <- sample(chem.list,50)

## ----load_chem_list, eval=run.simulations.2-----------------------------------
# chem.list <- httkexamples::dermal.nonvolatilechems

## ----subset_toxcast_data, eval=FALSE------------------------------------------
# toxcast.dermal <- mc5 %>% subset(dsstox_substance_id %in% chem.list)

## ----2_conc_of_interest, eval=FALSE-------------------------------------------
# # CONCENTRATIONS OF INTEREST - https://doi.org/10.1093/bioinformatics/btw680 ----------------
# toxcast.table <- NULL
# old.time <- Sys.time()
# num.chem <- length(chem.list)
# for(k.chem in 1:num.chem){ #for each chemical
#   this.id <- chem.list[k.chem]
#   # Modulus operator
#   if(k.chem %% 100==0){
#     new.time <- difftime(Sys.time(), old.time,units="secs")
#     cat(paste0("Run ", k.chem,":",round(new.time)," secs \n"))
#   }
#   toxcast.dermal.chem <- subset(toxcast.dermal, dsstox_substance_id == this.id) #subset over chemical
#   toxcast.dermal.chem.hits <- subset(toxcast.dermal.chem, hitc==1) #only look at hits
#   if(dim(toxcast.dermal.chem.hits)[1]>0){ #if there were any hits
#     this.row <- data.frame(Chemical = as.character(toxcast.dermal.chem.hits[1,"chnm"]),
#                            DTXSID = this.id,
#                            Total.Assays = dim(toxcast.dermal.chem)[1],
#                            Unique.Assays = length(unique(toxcast.dermal.chem$aeid)),
#                            Total.Hits = dim(toxcast.dermal.chem.hits)[1],
#                            Unique.Hits = length(unique(toxcast.dermal.chem.hits$aeid)),
#                            Low.AC50 = min(toxcast.dermal.chem.hits$modl_ga),
#                            Low.AC10 = min(toxcast.dermal.chem.hits$modl_ac10),
#                            Low.ACC = min(toxcast.dermal.chem.hits$modl_acc),
#                            Q10.AC50 = quantile(toxcast.dermal.chem.hits$modl_ga,probs=0.1),
#                            Q10.AC10 = quantile(toxcast.dermal.chem.hits$modl_ac10,probs=0.1),
#                            Q10.ACC = quantile(toxcast.dermal.chem.hits$modl_acc,probs=0.1),
#                            Med.AC50 = quantile(toxcast.dermal.chem.hits$modl_ga,probs=0.5),
#                            Med.AC10 = quantile(toxcast.dermal.chem.hits$modl_ac10,probs=0.5),
#                            Med.ACC = quantile(toxcast.dermal.chem.hits$modl_acc,probs=0.5),
#                            Q90.AC50 = quantile(toxcast.dermal.chem.hits$modl_ga,probs=0.9),
#                            Q90.AC10 = quantile(toxcast.dermal.chem.hits$modl_ac10,probs=0.9),
#                            Q90.ACC = quantile(toxcast.dermal.chem.hits$modl_acc,probs=0.9)
#                            )
#     toxcast.table <- rbind(toxcast.table, this.row)
#   }
# }
# rownames(toxcast.table) <- seq(1,dim(toxcast.table)[1]) # set rownames to be sequential numbers

## ----load_toxcast, eval=run.simulations.2-------------------------------------
# toxcast.table <- httkexamples::dermal.toxcast
# #View table
# knitr::kable(head(toxcast.table[,1:6]), caption = "Summarized ToxCast Data",
#              floating.environment="sidewaystable")
# write.table(toxcast.table,
#             file=paste0(loc.wd,"/tables/ToxCastSummaryTable.txt"),
#             col.names=TRUE,
#             row.names=FALSE,
#             quote=FALSE,
#             sep="\t")

## ----2_equivalant_dose, eval=run.simulations.2--------------------------------
# 
# # Get Cmax = max(Cplasma) from dermal model for each chemical in toxcast table
# old.time <- Sys.time()
# include.these=which(toxcast.table$DTXSID %in% get_cheminfo(info="dtxsid", suppress.messages=T))
# toxcast.table2 = subset(toxcast.table,DTXSID %in% toxcast.table$DTXSID[include.these])
# 
# atol <- rtol <- 1e-5
# 
# num.chem <- length(toxcast.table2$DTXSID)
# plot.each=F
# # Set Dermal Solutions
# method.ls <- c("Potts-Guy","UK-Surrey")
# toxcast.ls=list()
# for(k.chem in 1:num.chem){
#   this.id = toxcast.table2$DTXSID[k.chem]
#   suppress.messages = TRUE
# 
#     for(k.method in 1:2){
#       this.method <- method.ls[k.method];
#     #  if (this.method=="2-Compartment") this.method.input <- "NULL"
#       this.model.type <-"dermal_1subcomp"
#       end.time=0
#       parms=parameterize_dermal_pbtk(dtxsid=this.id,
#                                      model.type = this.model.type,
#                                      method.permeability = this.method,
#                                      clint.pvalue.threshold=Inf,
#                                      suppress.messages=TRUE,
#                                      Kvehicle2water = 1,
#                                      species="Human",
#                                      default.to.human = T)
#       parms$InfiniteDose=1
#       #if(end.time<2){ #make sure solver finishes
#         out=try( solve_dermal_pbtk(parameters=parms,
#                                      model.type=this.model.type,
#                                      method.permeability=this.method,
#                                      #Kvehicle2water=1, #vehicle is water
#                                      days=5,
#                                      initial.dose = 1,
#                                      input.units = "ppm",
#                                      dose.duration=8,
#                                      dose.duration.units="hr",
#                                      washoff=T,
#                                     # InfiniteDose=T,
#                                      atol = atol, rtol= rtol,
#                                      method="lsoda",
#                                      suppress.messages=suppress.messages) )#put SA for hands!!!
#          if (is(out,"try-error")){
#            Cmax=0
#            browser()
#          }
# 
#         else{end.time <- out[nrow(out),"time"]
# 
# 
#       Cmax <- max(out[,"Cplasma"])
# 
#         }
#        toxcast.ls[[paste0(k.chem,".",this.method)]]=cbind(toxcast.table2[toxcast.table2$DTXSID==this.id,],Cmax=Cmax,Permeability = this.method)
#     }
# 
# }
# 
# toxcast2.all=do.call(rbind,toxcast.ls)
# 
# #     # Calculate the EquivDose in units same as input.units (ppm)
# toxcast2.all$EquivDose = signif(10^toxcast2.all$Q10.AC50 /
#                                   toxcast2.all$Cmax,
#                                 4)
# # Edit data
# toxcast3=toxcast2.all%>%
#   rename(`Permeability Type` = Permeability,
#          `Equivalent Dose`=EquivDose)%>%
#   mutate(Chemical = ifelse(Chemical=="Methyl tert-butyl ether","MTBE",Chemical),
#          Chemical = ifelse(Chemical=="3,3',5,5'-Tetrabromobisphenol A","Bromdian",Chemical),
#          Chemical = ifelse(Chemical=="4,4'-Sulfonyldiphenol","Bisphenol S",Chemical),
#          Chemical = ifelse(Chemical=="Dichloromethane","DCM",Chemical),
#          Chemical = ifelse(Chemical=="Tetrachloroethylene","PERC/TCE",Chemical),
#          Chemical = ifelse(Chemical=="1-Methylbenzene","Toluene",Chemical))
# 
# # Remove unused columns
# ivive_meade2023 <- toxcast3 %>% select(Chemical,DTXSID,`Permeability Type`,`Equivalent Dose`,Cmax)
# 

## ----add_water_solubility, eval=run.simulations.2-----------------------------
# chem.props <- subset(chem.physical_and_invitro.data,
#                      DTXSID %in% ivive_meade2023$DTXSID)[
#                        ,c("DTXSID","MW","logWSol")]
# 
# 
# ivive_meade2023 <- merge(ivive_meade2023,
#                          all.x = TRUE,
#                          chem.props,
#                          by="DTXSID")
# ivive_meade2023 <- within(ivive_meade2023,
#                           WS.ppm <-
# signif(MW*10^logWSol*1.001142303,4))

## ----resave, eval=FALSE-------------------------------------------------------
# cgwtools::resave(ivive_meade2023,
#                   file=paste0(
#                     loc.wd,
#                     "/meade2023_",
#                     format(Sys.time(), "%b_%d_%Y"),
#                     ".Rdata"))

## ----2_load_without_running, eval = FALSE-------------------------------------
# # load file with ivive_meade2023
# load("meade2023_Sep_02_2025.Rdata")

## ----identify_potent, eval=make.plots.2---------------------------------------
# # Modify for plotting
# ivive_meade2023$`Permeability Type` = gsub("UK-Surrey","Surrey",ivive_meade2023$`Permeability Type`)
# ivive_meade2023[ivive_meade2023==Inf] = 1e15
# write.table(subset(ivive_meade2023,
#                    ivive_meade2023[,"Equivalent Dose"] <
#                      ivive_meade2023[,"WS.ppm"]),
#             file=paste0(loc.wd,"/tables/IVIVEAchievable.txt"),
#             col.names=TRUE,
#             row.names=FALSE,
#             quote=FALSE,
#             sep="\t")
# ivive_meade2023$`Equivalent Dose` <- log10(ivive_meade2023$`Equivalent Dose`)
# ivive_meade2023$`Permeability Type` = paste0("Permeability Method is ",ivive_meade2023$`Permeability Type`)
# write.table(ivive_meade2023,
#             file=paste0(loc.wd,"/tables/IVIVEResults.txt"),
#             col.names=TRUE,
#             row.names=FALSE,
#             quote=FALSE,
#             sep="\t")

## ----2_plot1,fig.width=20,fig.height=12, eval=make.plots.2--------------------
# # Plot Histogram
# data = ivive_meade2023 %>% group_by(`Permeability Type`) %>% mutate(Mean = mean(`Equivalent Dose`,na.rm=TRUE)) %>% mutate(Median = median(`Equivalent Dose`,na.rm=TRUE))
# AED.labels <- c("Needs Protection (AED caused by <1ppm)",
#                 "AED Possibly Acheivable",
#                 "\"Safe\" (Unachievable AED)",
#                 "No Dermal Penetration")
# 
# # Shaded rectangles with cutoff at 10,000 ppm:
# data.rect.1e4ppm = data.frame(xmin=c(-Inf,0,4,12),
#                        xmax=c(0,4,12,Inf),
#                        ymin=rep(-Inf,4),
#                        ymax=rep(Inf,4),
#                        Bioactivity=AED.labels)
# # Shaded rectangles with cutoff at 1,000,000 ppm:
# data.rect.1e6ppm = data.frame(xmin=c(-Inf,0,6,12),
#                        xmax=c(0,6,12,Inf),
#                        ymin=rep(-Inf,4),
#                        ymax=rep(Inf,4),
#                        Bioactivity=AED.labels)
# data.rect.1e4ppm$Bioactivity <- factor(data.rect.1e4ppm$Bioactivity,
#                                        levels=data.rect.1e4ppm$Bioactivity)
# data.rect.1e6ppm$Bioactivity <- factor(data.rect.1e6ppm$Bioactivity,
#                                        levels=data.rect.1e6ppm$Bioactivity)
# 
# data.med = unique(data[,c("Permeability Type","Mean","Median")]) %>% pivot_longer(cols=c("Mean","Median"),names_to="Statistic",values_to="Statistic.Value")
# viridis.colors <- viridisLite::viridis(4)
# plot <- ggplot(data,aes(x=`Equivalent Dose`)) +
#   geom_histogram(na.rm=TRUE,alpha=0.5,position="identity") +
#   geom_freqpoly(na.rm=TRUE) +
#   geom_vline(data = data.med, aes(xintercept=Statistic.Value,linetype=Statistic)) +
#   geom_rect(data=data.rect.1e4ppm,
#             aes(xmin=xmin,xmax=xmax,ymin=ymin,ymax=ymax,fill=Bioactivity),
#             alpha=0.5,
#             inherit.aes=FALSE) +
#   #scale_x_log10() +
#   scale_fill_manual(values=setNames(viridis.colors[4:1], AED.labels))+
#   labs(title=paste0("Distribution of concentrations causing AED\nfor hands submerged for 8 hours a day\nfor five days"),
#        y = "Number of Chemicals", x="Log10 of Administrered Equivalent Doses (AEDs) ppm in water") +
#   facet_col(vars(`Permeability Type`),scales="fixed") +
#   theme_bw() +
#   theme(plot.title=element_text(hjust=0.5))
# plot
# ggsave(paste(loc.wd, "/Figures_August2025/histogram2.png",sep=""),
#        width = 20, height = 12, units = "cm")

## ----2_dataprep_for_plot2, fig.width=15, fig.height=10,eval=make.plots.2------
# 
# # WATER SOLUBILITY
# ivive_meade2023 <-
#   ivive_meade2023 %>%
#   mutate(WSol = case_when( ((MW*10^logWSol)>=10) ~ "Water Soluble (WSol>10g/L)",
#                            ((MW*10^logWSol)<10) ~ "Not Soluble"
#                            ))
# #ivive_meade2023ALL <- ivive_meade2023WS; ivive_meade2023ALL$WSol = "Non-Water Soluble"
# ivive_meade2023WS <- ivive_meade2023 %>% filter(WSol=="Water Soluble (WSol>10g/L)")
# ivive_meade2023NonWS <- ivive_meade2023 %>% filter(WSol=="Not Soluble")
# # Different bands for soluble/non-soluble:
# data.rect.1e4ppm$WSol <- "Not Soluble"
# data.rect.1e6ppm$WSol <- "Water Soluble (WSol>10g/L)"
# data.rect <- rbind(data.rect.1e4ppm,data.rect.1e6ppm)
# data.rect[,"Permeability Type"] <- "Permeability Method is Potts-Guy"
# data.rect2 <- data.rect
# data.rect2[,"Permeability Type"] <- "Permeability Method is Surrey"
# data.rect <- rbind(data.rect,data.rect2)
# 
# ivive_meade2023 <- rbind(ivive_meade2023NonWS,ivive_meade2023WS)
# data = ivive_meade2023 %>% group_by(`Permeability Type`,`WSol`) %>% mutate(Mean = mean(`Equivalent Dose`,na.rm=TRUE)) %>% mutate(Median = median(`Equivalent Dose`,na.rm=TRUE))
# data.med = unique(data[,c("Permeability Type","WSol","Mean","Median")]) %>% pivot_longer(cols=c("Mean","Median"),names_to="Statistic",values_to="Statistic.Value")

## ----2_plot2, fig.width=15, fig.height=10,eval=make.plots.2-------------------
# chem.to.label <-  c("DTXSID0020232",
#                   # "DTXSID6022923",
#                   # "DTXSID8024151",
#                    "DTXSID3022409",
#                    "DTXSID1026081", "DTXSID9048699",
#                    "DTXSID0022858","DTXSID1037","DTXSID0023163",
#                    "DTXSID5024845" )
# data.text = data %>% filter(DTXSID %in% chem.to.label)
# #PLOT WS
# plot <- ggplot(data) +
#   geom_rect(data=data.rect,
#             aes(xmin=xmin,xmax=xmax,ymin=ymin,ymax=ymax,fill=Bioactivity),
#             alpha=0.5#,
#             #inherit.aes=FALSE
#             ) +
#   geom_histogram(na.rm=TRUE,alpha=0.5,position="identity",aes(x=`Equivalent Dose`)) +
#   geom_freqpoly(na.rm=TRUE,aes(x=`Equivalent Dose`)) +
#   geom_vline(data = data.med, aes(xintercept=Statistic.Value,linetype=Statistic)) +
# #  geom_point(data=data.text,aes(x=`Equivalent Dose`,y=0),size=2) +
# #  geom_text_repel(data=data.text,aes(x=`Equivalent Dose`,y=0,label=Chemical),
# #                  max.overlaps=14,
# #                  hjust = "right",nudge_x=-1,nudge_y=0.2)+
#   scale_fill_manual(values=setNames(viridis.colors[4:1], AED.labels))+
#   #ylim(0,135)+
#   #geom_text(x=) +
#   labs(title=paste0("Distribution of concentrations causing AED\nfor hands submerged for 8 hours a day\nfor five days"),
#        y = "Number of Chemicals", x="Log10 of Needed Concentration (ppm) in water") +
#   facet_wrap(vars(`Permeability Type`,`WSol`),scales="free_y",ncol=2) +
#   theme_bw() +
#   theme(plot.title=element_text(hjust=0.5),
#         text=element_text(size=20))
# plot
# ggsave(paste(loc.wd, "/Figures_August2025/histogram_all_main.png",sep=""),
#        width = 15, height = 10, units = "in")
# 

## ----finallist2, eval=FALSE---------------------------------------------------
# data2=data[order(data$`Equivalent Dose`),]
# data2$`Equivalent Dose`= exp(data2$`Equivalent Dose`)
# data3=data.frame(data2%>%group_by(Chemical,DTXSID, `Permeability Type`,WSol,logWSol)%>%
#   mutate(row=row_number())%>%
#   ungroup() %>%
# pivot_wider(id_cols=c(Chemical, DTXSID, row, WSol,logWSol),
#   names_from = `Permeability Type`,
#                     values_from = c(`Equivalent Dose`),
#                     names_sep=""))
# data4=data3[,-3]
# data4=data4[order(data4$Permeability.Method.is.Surrey),]
# 
# 
# 

## ----finallist, eval=FALSE----------------------------------------------------
# pmat=list()
# pm=c("UK-Surrey","Potts-Guy")
# kw=c("water","octanol")
# for(i in 1:length(supptab1_meade2023$DTXSID)){
#   for(m in 1:2){ #each method
#     for(k in 1:2){ # each vehicle
#   p=parameterize_dermal_pbtk(dtxsid=supptab1_meade2023$DTXSID[i],
#                              method.permeability =pm[m] ,species="Human",
#                              Kvehicle2water = kw[k])
#   pmat[[paste(i,".",m,".",k)]]=cbind(p$P, pm[m], kw[k],p$MW, supptab1_meade2023$DTXSID[i])
# 
#   }
#   }
# }
# 
# pmat2=do.call(rbind,pmat)
# colnames(pmat2)=c("Perm", "Method","Vehicle","MW","DTXSID")
# pmat2=data.frame(pmat2)
# pmat2$Method=gsub("UK-Surrey","Surrey",pmat2$Method)
# pmat2$Vehicle=paste("Vehicle is", pmat2$Vehicle)
# 
# pmat3=merge(pmat2,supptab1_meade2023, by="DTXSID")
# 
# 
# ggplot(pmat3,aes(x=as.numeric(MW.x),y=as.numeric(Perm)))+
#   geom_point()+
#   facet_grid(Method~Vehicle,scales="free")+
#   labs(x="MW",y="Kp - Permeability")
# ggsave(paste(loc.wd, "/Figures_August2025/MWvPerm.png",sep=""),
#        width = 4, height = 3.5, units = "in")
# 
# ggplot(pmat3,aes(x=as.numeric(logP),y=as.numeric(Perm)))+
#   geom_point()+
#   facet_grid(Method~Vehicle,scales="free")+
#   labs(x="log(Kow)",y="Kp- Permeability")
# ggsave(paste(loc.wd, "/Figures_August2025/logKowvPerm.png",sep=""),
#        width = 4, height = 3.5, units = "in")
# 
# 

## ----save_workspace, eval=make.plots.2----------------------------------------
# save.image(paste0(loc.wd,
#                       "MeadeWorkspace",
#                       Sys.Date(),
#                       ".RData"))

## ----PCA_data, eval=make.plots.2----------------------------------------------
# cvt.chems <- sort(unique(conc_predictions_meade2023DF$test_substance_dtxsid))
# ivive.chems <- sort(unique(ivive_meade2023$DTXSID))
# all.chems <- sort(unique(c(cvt.chems,ivive.chems)))
# all.chems <- all.chems[all.chems %in% get_cheminfo(info="dtxsid",
#                                                    model="dermal_1subcomp",
#                                                    suppress.messages=TRUE)]
# any(cvt.chems %in% ivive.chems)
# length(cvt.chems)
# length(ivive.chems)
# chem.props <- subset(chem.physical_and_invitro.data, DTXSID %in% all.chems)
# rownames(chem.props) <- chem.props$DTXSID
# chem.props <- chem.props[,c("logHenry","logP","logPwa","logWSol","MP","MW")]
# for (this.chem in rownames(chem.props))
# {
#   p <- parameterize_dermal_pbtk(dtxsid=this.chem,
#                                 suppress.messages=TRUE)
#   chem.props[this.chem,c("Rblood2plasma",
#                          "MA",
#                          "Kskin2pu",
#                          "Kskin2vehicle",
#                          "Kblood2air",
#                          "Funbound.plasma",
#                          "Fabsgut",
#                          "Clint")] <- p[
#                            c("Rblood2plasma",
#                              "MA",
#                              "Kskin2pu",
#                              "Kskin2vehicle",
#                              "Kblood2air",
#                              "Funbound.plasma",
#                              "Fabsgut",
#                              "Clint")]
# }

## ----PCA_table, eval=make.plots.2---------------------------------------------
# #library(plotly)
# #library(stats)
# chem.props2 <- chem.props#[,!(colnames(chem.props) %in% "MW")]
# chem.props2$MW <- log10(chem.props2$MW)
# chem.props2$Kblood2air <- log10(chem.props2$Kblood2air)
# chem.props2$MA <- log10(chem.props2$MA)
# chem.props2$MP <- log10(chem.props2$MP+273)
# chem.props2$Kskin2pu <- log10(chem.props2$Kskin2pu)
# chem.props2$Kskin2vehicle <- log10(chem.props2$Kskin2vehicle)
# chem.props2$Rblood2plasma <- log10(chem.props2$Rblood2plasma)
# chem.props2$Clint <- log10(chem.props2$Clint)
# chem.props2$Clint[is.infinite((chem.props2$Clint))] <- -3
# chem.props2 <- chem.props2[apply(chem.props2,
#                                  1,
#                                  function(x) all(!is.na(x))), ]
# chem.props2 <- apply(chem.props2,
#                      2,
#                      function(x) (x - mean(x)/sd(x)))
# prin_comp <- prcomp(chem.props2)
# explained_variance_ratio <- summary(prin_comp)[["importance"]]['Proportion of Variance',]
# chem.props.pca <- as.data.frame(chem.props2 %*% prin_comp$rotation)
# chem.props.pca$CvT <- "None"
# chem.props.pca[rownames(chem.props.pca) %in% cvt.chems,"CvT"] <- "CvT"
# chem.props.pca$IVIVE <- "None"
# chem.props.pca[rownames(chem.props.pca) %in% ivive.chems,"IVIVE"] <- "IVIVE"
# 
# pca.fig <- ggplot(data=chem.props.pca) +
#    geom_point(data=subset(chem.props.pca,CvT=="CvT"),
# size=3,
#     aes(
#     x=PC1,
#     y=PC2,
#     shape=IVIVE,
#     color=CvT))+
#  geom_point(alpha=0.2,size=3,
#     aes(
#     x=PC1,
#     y=PC2,
#     color=CvT,
#     shape=IVIVE))#+
#    # xlim(-1300,200)+
#     #ylim(-75,25)
# 
# print(pca.fig)
# ggsave(paste(loc.wd, "/Figures_August2025/pca.png",sep=""),
#        width = 4, height = 3.5, units = "in")

## ----configure_knitr, eval = TRUE---------------------------------------------
knitr::opts_chunk$set(collapse = TRUE, comment = '#>')
options(rmarkdown.html_vignette.check_title = FALSE)

## ----clear_memory, eval = TRUE------------------------------------------------
rm(list=ls()) 

## ----runchunks, eval = TRUE---------------------------------------------------
# Set whether or not the following chunks will be executed (run):
execute.vignette <- FALSE

## ----load_packages, eval = execute.vignette-----------------------------------
# #
# #
# # Setup
# #
# #
# #library(readxl)
# library(ggplot2)
# library(httk)
# library(httkexamples)
# library(scales)
# library(gridExtra)
# library(cowplot)

## ----load_code, eval = execute.vignette---------------------------------------
# scientific_10 <- function(x) {
#   out <- gsub("1e", "10^", scientific_format()(x))
#   out <- gsub("\\+","",out)
#   out <- gsub("10\\^01","10",out)
#   out <- parse(text=gsub("10\\^00","1",out))
# }
# 
# RMSE <- function(x)
# {
#   mean(x$residuals^2)^(1/2)
# }

## ----chem_numbers, eval=FALSE-------------------------------------------------
# length(get_cheminfo(model="fetal_pbtk",suppress.messages=TRUE))

## ----load_aylward_data, eval = execute.vignette-------------------------------
# #MFdata <- read_excel("Aylward-MatFet.xlsx")
# MFdata <- as.data.frame(httk::aylward2014)
# 
# cat(paste("summarized data from over 100 studies covering ",
#   length(unique(MFdata$DTXSID)[!(unique(MFdata$DTXSID)%in%c("","-"))]),
#   " unique chemicals structures\n",sep=""))
# 
# # We don't want to exclude the volatiles and PFAS at this point:
# MFdata.httk <- subset(MFdata,DTXSID %in% get_cheminfo(
#   info="DTXSID",
#   suppress.messages=TRUE))
# MFdata.httk[MFdata.httk$Chemical.Category=="bromodiphenylethers",
#   "Chemical.Category"] <- "Bromodiphenylethers"
# MFdata.httk[MFdata.httk$Chemical.Category=="organochlorine Pesticides",
#   "Chemical.Category"] <- "Organochlorine Pesticides"
#   MFdata.httk[MFdata.httk$Chemical.Category=="polyaromatic hydrocarbons",
#   "Chemical.Category"] <- "Polyaromatic Hydrocarbons"
# 
# colnames(MFdata.httk)[colnames(MFdata.httk) ==
#   "infant.maternal.conc...Central.tendency..calculate.j.k..or.report.paired.result."] <-
#   "MFratio"
# colnames(MFdata.httk)[colnames(MFdata.httk) ==
#   "PREFERRED_NAME"] <-
#   "Chemical"
# colnames(MFdata.httk)[colnames(MFdata.httk) ==
#   "details.on.matrix.comparison...e.g...cord.blood.lipid..maternal.serum.lipid..or.cord.blood.wet.weight..maternal.whole.blood.wet.weight"] <-
#   "Matrix"
# 
# # Format the columns:
# MFdata.httk$MFratio <- as.numeric(MFdata.httk$MFratio)
# MFdata.httk$Chemical <- as.factor(MFdata.httk$Chemical)
# MFdata.httk$Matrix <- as.factor(MFdata.httk$Chemical)
# MFdata.httk$Chemical.Category <- as.factor(MFdata.httk$Chemical.Category)
# 
# colnames(MFdata.httk)[15] <- "infant"
# colnames(MFdata.httk)[16] <- "maternal"
# colnames(MFdata.httk)[17] <- "obs.units"
# 
# MFdata.httk$infant <- suppressWarnings(as.numeric(MFdata.httk$infant))
# MFdata.httk$maternal <- suppressWarnings(as.numeric(MFdata.httk$maternal))
# MFdata.httk$AVERAGE_MASS <- as.numeric(MFdata.httk$AVERAGE_MASS)

## ----process_aylward_data, eval = execute.vignette----------------------------
# convert1.units <- c("ng/ml","ng/mL","ug/L","ug/l","ng/mL serum","ng/g",
#   "ng/g wet wt.","ppb")
# 
# MFdata.httk[MFdata.httk$obs.units%in%convert1.units,"infant"] <-
#   MFdata.httk[MFdata.httk$obs.units%in%convert1.units,"infant"] / # ng/ml = ug/L
#   MFdata.httk[MFdata.httk$obs.units%in%convert1.units,"AVERAGE_MASS"]  # ug/L -> uM
# MFdata.httk[MFdata.httk$obs.units%in%convert1.units,"maternal"] <-
#   MFdata.httk[MFdata.httk$obs.units%in%convert1.units,"maternal"] / # ng/ml = ug/L
#   MFdata.httk[MFdata.httk$obs.units%in%convert1.units,"AVERAGE_MASS"]  # ug/L -> uM
# MFdata.httk[MFdata.httk$obs.units%in%convert1.units,"obs.units"] <- "uM"
# 
# convert2.units <- c("mg/L","ppm")
# 
# MFdata.httk[MFdata.httk$obs.units%in%convert2.units,"infant"] <-
#   MFdata.httk[MFdata.httk$obs.units%in%convert2.units,"infant"] * 1000 / # mg/L = ug/L
#   MFdata.httk[MFdata.httk$obs.units%in%convert2.units,"AVERAGE_MASS"]  # ug/L -> uM
# MFdata.httk[MFdata.httk$obs.units%in%convert2.units,"maternal"] <-
#   MFdata.httk[MFdata.httk$obs.units%in%convert2.units,"maternal"]* 1000 / # mg/L = ug/L
#   MFdata.httk[MFdata.httk$obs.units%in%convert2.units,"AVERAGE_MASS"]  # ug/L -> uM
# MFdata.httk[MFdata.httk$obs.units%in%convert2.units,"obs.units"] <- "uM"

## ----make_aylward_preds, eval = execute.vignette------------------------------
# # Simulate starting from the 13th week of gestation until full term (40 weeks):
# times <- sort(unique(c(seq(13 * 7, 40 * 7, 0.25),seq(278,280,.1))))
# 
# # For each chemical with maternal-fetal ratio data and HTTK in vitro data:
# for (this.id in unique(MFdata.httk$DTXSID))
# {
#   print(this.id)
#   p <- parameterize_steadystate(dtxsid=this.id,
#                         suppress.messages=TRUE)
#   # skip chemicals where Fup is 0:
#   if (p$Funbound.plasma>1e-4)
#   {
# 
#     # Load the chemical-specifc paramaters:
#     p <- parameterize_fetal_pbtk(dtxsid=this.id,
#                                                   fetal_fup_adjustment =TRUE,
#                                                   suppress.messages=TRUE)
#     # Skip chemicals where the 95% credible interval for Fup spans more than 0.1 to
#     # 0.9 (that is, Fup is effectively unknown):
#     if (!is.na(p$Funbound.plasma.dist))
#     {
#       if (as.numeric(strsplit(p$Funbound.plasma.dist,",")[[1]][3])>0.9 &
#           as.numeric(strsplit(p$Funbound.plasma.dist,",")[[1]][2])<0.11)
#       {
#         skip <- TRUE
#       } else skip <- FALSE
#     } else skip <- FALSE
# 
#     if (!skip)
#     {
#       # Solve the PBTK equations for the full simulation time assuming 1 total daily
#       # dose of 1 mg/kg/day spread out over three evenly spaces exposures:
#       out <- solve_fetal_pbtk(
#         parameters=p,
#         dose=0,
#         times=times,
#         daily.dose=1,
#         doses.per.day=3,
#         output.units = "uM",
#         suppress.messages=TRUE)
#       # Identify the concentrations from the final (279th) day:
#       last.row <- which(out[,"time"]>279)
#       last.row <- last.row[!duplicated(out[last.row,"time"])]
#       # Average over the final day:
#       MFdata.httk[MFdata.httk$DTXSID==this.id,"Mat.pred"] <- mean(out[last.row,"Cplasma"])
#       MFdata.httk[MFdata.httk$DTXSID==this.id,"Fet.pred"] <- mean(out[last.row,"Cfplasma"])
#       MFdata.httk[MFdata.httk$DTXSID==this.id,"MFratio.pred"] <-
#         mean(out[last.row,"Cplasma"])/mean(out[last.row,"Cfplasma"])
# 
#       # Repeat the analysis without the adjustment to fetal Fup:
#       p <- parameterize_fetal_pbtk(dtxsid=this.id,
#                                                     fetal_fup_adjustment =FALSE,
#                                                     suppress.messages = TRUE)
#       out <- solve_fetal_pbtk(
#         parameters=p,
#         dose=0,
#         times=times,
#         daily.dose=1,
#         doses.per.day=3,
#         output.units = "uM",
#         maxsteps=1e7,
#         suppress.messages = TRUE)
# 
#       last.row <- which(out[,"time"]>279) # The whole final day
#       last.row <- last.row[!duplicated(out[last.row,"time"])]
#       MFdata.httk[MFdata.httk$DTXSID==this.id,"Mat.pred.nofup"] <- mean(out[last.row,"Cplasma"])
#       MFdata.httk[MFdata.httk$DTXSID==this.id,"Fet.pred.nofup"] <- mean(out[last.row,"Cfplasma"])
#       MFdata.httk[MFdata.httk$DTXSID==this.id,"MFratio.pred.nofup"] <-
#         mean(out[last.row,"Cplasma"])/mean(out[last.row,"Cfplasma"])
#     }
#   }
# }
# 
# # Something is wrong with cotinine:
# MFdata.httk <- subset(MFdata.httk,Chemical!="Cotinine")
# 
# max.chem <- MFdata.httk[which(MFdata.httk$MFratio==max(MFdata.httk$MFratio)),]
# min.chem <- MFdata.httk[which(MFdata.httk$MFratio==min(MFdata.httk$MFratio)),]
# cat(paste("The minimum observed ratio was ",
#   signif(min.chem[,"MFratio"],2),
#   " for ",
#   min.chem[,"Chemical"],
#   " and the maximum was ",
#   signif(max.chem[,"MFratio"],2),
#   " for ",
#   max.chem[,"Chemical"],
#   ".\n",sep=""))
# 
# 

## ----cleanup_repeated_aylward_figure, eval = execute.vignette-----------------
# MFdata.main <- NULL
# MFdata.outliers <- NULL
# for (this.id in unique(MFdata.httk$DTXSID))
# {
#   this.subset <- subset(MFdata.httk,DTXSID==this.id)
#   this.row <- this.subset[1,]
#   this.row$N.obs <- dim(this.subset)[1]
#   this.row$MFratio <- median(this.subset$MFratio)
#   this.row$MFratio.Q25 <- quantile(this.subset$MFratio,0.25)
#   this.row$MFratio.Q75 <- quantile(this.subset$MFratio,0.75)
#   MFdata.main <- rbind(MFdata.main,this.row)
#   this.subset <- subset(this.subset,
#     MFratio<this.row$MFratio.Q25 |
#     MFratio>this.row$MFratio.Q75)
#   MFdata.outliers <- rbind(MFdata.outliers,this.subset)
# }

## ----aylward_figure_no_fup, eval = execute.vignette---------------------------
# FigCa  <- ggplot(data=MFdata.main) +
#   geom_segment(color="grey",aes(
#     x=MFratio.pred.nofup,
#     y=MFratio.Q25,
#     xend=MFratio.pred.nofup,
#     yend=MFratio.Q75))+
#   geom_point(aes(
#     x=MFratio.pred.nofup,
#     y=MFratio,
#     shape=Chemical.Category,
#     color=Chemical.Category),
#     size=4)   +
#   scale_shape_manual(values=c(15, 16,2, 23, 0, 1, 17, 5, 6))+
#   geom_point(data=MFdata.outliers,aes(
#     x=MFratio.pred.nofup,
#     y=MFratio,
#     shape=Chemical.Category,
#     color=Chemical.Category),
#     size=2)   +
#   xlim(0,2) +
#   ylim(0,3) +
# #   geom_text(aes(x=AUC,y=Critical.concentration,label=Compound.abbrev,color=Chemical)) +
# #   scale_y_log10(label=scientific_10) +
# #,limits=c(10^-7,100)) +
# #   scale_x_log10(label=scientific_10) +
# #   ,limits=c(10^-7,100)) +
# #    annotation_logticks() +
#   geom_abline(slope=1, intercept=0) +
# #    geom_abline(slope=1, intercept=1,linetype="dashed") +
# #    geom_abline(slope=1, intercept=-1,linetype="dashed") +
#   ylab(expression(paste(italic("In vivo")," Mat:Fet Plasma Ratio"))) +
#   xlab("Generic PBTK Predicted Ratio") +
# #    scale_color_brewer(palette="Set2") +
#   theme_bw()  +
#   theme(legend.position="bottom")+
#   theme( text  = element_text(size=14))+
#   theme(legend.text=element_text(size=10))+
#   guides(color=guide_legend(title="Class",nrow=3,byrow=TRUE))+
#   guides(shape=guide_legend(title="Class",nrow=3,byrow=TRUE))
# 
# print(FigCa)

## ----aylward_analysis_text, eval = execute.vignette---------------------------
# 
# cat(paste("In Figure 4 we compare predictions made with our high-throughput \
# human gestational PBTK model with experimental observations on a per chemical \
# basis wherever we had both in vitro HTTK data and in vivo observations (",
# length(unique(MFdata.main$DTXSID)),
# " chemicals).\n",sep=""))
# 
# 
# repeats <- subset(MFdata.main,N.obs>1)
# 
# cat(paste("Multiple observations were available for ",
#   dim(repeats)[1],
#   " of the chemicals,\n",sep=""))
# 
# 
# max.chem <- as.data.frame(repeats[which(repeats$MFratio==max(repeats$MFratio)),])
# min.chem <- as.data.frame(repeats[which(repeats$MFratio==min(repeats$MFratio)),])
# 
# cat(paste("However, among the chemicals with repeated observations, the median \
# observations only ranged from ",
#   signif(min.chem[,"MFratio"],2),
#   " for ",
#   min.chem[,"Chemical"],
#   " to ",
#   signif(max.chem[,"MFratio"],2),
#   " for ",
#   max.chem[,"Chemical"],
#   ".\n",sep=""))
# 
# max.chem <- as.data.frame(MFdata.main[which(MFdata.main$MFratio.pred==max(MFdata.main$MFratio.pred,na.rm=TRUE)),])
# min.chem <- as.data.frame(MFdata.main[which(MFdata.main$MFratio.pred==min(MFdata.main$MFratio.pred,na.rm=TRUE)),])
# 
# cat(paste("The predictions for all chemicals ranged from ",
#   signif(min.chem[,"MFratio.pred"],2),
#   " for ",
#   min.chem[,"Chemical"],
#   " to ",
#   signif(max.chem[,"MFratio.pred"],2),
#   " for ",
#   max.chem[,"Chemical"],
#   ".\n",sep=""))
# 
# 
# 
# fit1 <- lm(data=MFdata.main,MFratio~MFratio.pred.nofup)
# summary(fit1)
# RMSE(fit1)
# 
# fit1sub <- lm(data=subset(MFdata.main,
#   !(Chemical.Category %in% c(
#     "Fluorinated compounds",
#     "Polyaromatic Hydrocarbons"))),
#   MFratio~MFratio.pred.nofup)
# summary(fit1sub)
# RMSE(fit1sub)
# 

## ----aylward_figure_with_fup, eval = execute.vignette-------------------------
# FigCb  <- ggplot(data=MFdata.main) +
#   geom_segment(color="grey",aes(
#     x=MFratio.pred,
#     y=MFratio.Q25,
#     xend=MFratio.pred,
#     yend=MFratio.Q75))+
#   geom_point(aes(
#     x=MFratio.pred,
#     y=MFratio,
#     shape=Chemical.Category,
#     color=Chemical.Category),
#     size=3)   +
#   scale_shape_manual(values=c(15, 16,2, 23, 0, 1, 17, 5, 6))+
#   geom_point(data=MFdata.outliers,aes(
#     x=MFratio.pred,
#     y=MFratio,
#     shape=Chemical.Category,
#     color=Chemical.Category),
#     size=1)   +
#   xlim(0,2) +
#   ylim(0,3) +
# #   geom_text(aes(x=AUC,y=Critical.concentration,label=Compound.abbrev,color=Chemical)) +
# #   scale_y_log10(label=scientific_10) +
# #,limits=c(10^-7,100)) +
# #   scale_x_log10(label=scientific_10) +
# #   ,limits=c(10^-7,100)) +
# #    annotation_logticks() +
#   geom_abline(slope=1, intercept=0) +
# #    geom_abline(slope=1, intercept=1,linetype="dashed") +
# #    geom_abline(slope=1, intercept=-1,linetype="dashed") +
#   ylab(expression(paste(italic("In vivo")," Mat:Fet Plasma Ratio"))) +
#   xlab(expression(paste(italic("In vitro")," Predicted Ratio"))) +
# #    scale_color_brewer(palette="Set2") +
#   theme_bw()  +
#   theme(legend.position="bottom")+
#   theme( text  = element_text(size=14))+
#   theme(legend.text=element_text(size=10))+
#   guides(color=guide_legend(title="Class",nrow=3,byrow=TRUE))+
#   guides(shape=guide_legend(title="Class",nrow=3,byrow=TRUE))
# 
# print(FigCb)
# 

## ----voc_analysis, eval = execute.vignette------------------------------------
# # Mean logHenry's law constant for PAH's:
# mean(subset(chem.physical_and_invitro.data,DTXSID%in%subset(MFdata.main,Chemical.Category=="Polyaromatic Hydrocarbons")$DTXSID)$logHenry)
# 
# nonvols <- subset(chem.physical_and_invitro.data,logHenry < -4.5)$DTXSID
# fluoros <- chem.physical_and_invitro.data$DTXSID[regexpr("fluoro",tolower(chem.physical_and_invitro.data$Compound))!=-1]
# 
# fit2 <- lm(data=MFdata.main,MFratio~MFratio.pred)
# summary(fit2)
# RMSE(fit2)
# 
# fit2sub <- lm(data=subset(MFdata.main,
#   !(Chemical.Category %in% c(
#     "Fluorinated compounds",
#     "Polyaromatic Hydrocarbons"))),
#   MFratio~MFratio.pred)
# summary(fit2sub)
# 
# RMSE(fit2sub)
# 
# cat(paste("When volatile and fluorinated chemicals are omitted only ",
#   dim(subset(MFdata.main,
#   !(Chemical.Category %in% c(
#     "Fluorinated compounds",
#     "Polyaromatic Hydrocarbons"))))[1],
#   " evaluation chemicals remain, but the R2 is ",
#   signif(summary(fit1sub)$adj.r.squared,2),
#   " and the RMSE is ",
#   signif(RMSE(fit1sub),2),
#   " without the correction. When the fetal plasma fraction unbound correction is used, the predictivity decreases, slightly: R2 is ",
#   signif(summary(fit2sub)$adj.r.squared,2),
#   " and the RMSE is ",
#   signif(RMSE(fit2sub),2),
#   " for the non-volatile, non-fluorinated chemicals.\n",
#   sep=""))
# 
# 
# 
# cat(paste("We compare the RMSE for our predictions to the standard deviation \
# of the observations ",
#   signif(sd(MFdata.main$MFratio)[1],2),
#   " (",
#   signif(sd(subset(MFdata.main,
#   !(Chemical.Category %in% c(
#     "Fluorinated compounds",
#     "Polyaromatic Hydrocarbons")))$MFratio),2),
#   " for non PAH or fluorinated compounds).\n",sep=""))
# 
# cat(paste("The average standard deviation for chemicals with repeated observations was ",
#   signif(sd(subset(MFdata.main,N.obs>1)$MFratio)[1],2),
#   " (",
#   signif(sd(subset(MFdata.main,
#   N.obs > 1 &
#   !(Chemical.Category %in% c(
#     "Fluorinated compounds",
#     "Polyaromatic Hydrocarbons")))$MFratio),2),
#   " for non PAH or fluorinated compounds).\n",sep=""))
# 
# fit3 <- lm(data=repeats,MFratio~MFratio.pred.nofup)
# summary(fit3)
# RMSE(fit3)
# 
# fit3sub <- lm(data=subset(MFdata.main, N.obs > 1 &
#   !(Chemical.Category %in% c(
#     "Fluorinated compounds",
#     "Polyaromatic Hydrocarbons"))),
#   MFratio~MFratio.pred.nofup)
# summary(fit3sub)
# 
# 
# fit4 <- lm(data=subset(MFdata.main,N.obs > 1),MFratio~MFratio.pred)
# summary(fit4)
# RMSE(fit4)
# 
# fit4sub <- lm(data=subset(MFdata.main, N.obs > 1 &
#   !(Chemical.Category %in% c(
#     "Fluorinated compounds",
#     "Polyaromatic Hydrocarbons"))),
#   MFratio~MFratio.pred)
# summary(fit4sub)
# 
# cat(paste("Overall, we observed relatively poor correlation (R2 = ",
#   signif(summary(fit1)$adj.r.squared,2),
#   ", RMSE = ",
#   signif(RMSE(fit1),2),
#   ") without our fetal fup correction that was unchanged with that assumption (R2 = ",
#   signif(summary(fit2)$adj.r.squared,2),
#   ", RMSE = ",
#   signif(RMSE(fit2),2),
#   ").\n",sep=""))
# 
# repeats <-subset(MFdata.main,N.obs > 1)
# cat(paste("The RMSE of the predictions for the ",
#   dim(subset(repeats,!(Chemical.Category %in% c(
#     "Fluorinated compounds",
#     "Polyaromatic Hydrocarbons"))))[1],
#   " non-PAH and non-fluorinated compounds with repeated observations is ",
#   signif(RMSE(fit4sub),2),
#   " with the fup correction and ",
#   signif(RMSE(fit3sub),2),
#   " without.\n",sep=""))
# 
# cat(paste("These values are close to the standard deviation of the mean but the p-value for the chemicals with repeated observations is ",
#   signif(pf(
#     summary(fit4sub)$fstatistic[1],
#     summary(fit4sub)$fstatistic[2],
#     summary(fit4sub)$fstatistic[3]),2),
# " indicating some value for the predictive model, albeit for only ",
# dim(subset(repeats,!(Chemical.Category %in% c(
#   "Fluorinated compounds",
#   "Polyaromatic Hydrocarbons"))))[1],
#  " chemicals",sep=""))
# 
# 
# 
# Fig4.table <- data.frame()
# Fig4.table["Number of Chemicals","All Fig 4"] <- length(unique(MFdata.httk$DTXSID))
# Fig4.table["Number of Observations","All Fig 4"] <- dim(MFdata.httk)[1]
# Fig4.table["Observed Mean (Min - Max)","All Fig 4"] <- paste(
#   signif(mean(MFdata.httk$MFratio),2)," (",
#   signif(min(MFdata.httk$MFratio),2)," - ",
#   signif(max(MFdata.httk$MFratio),2),")",sep="")
# Fig4.table["Observed Standard Deviation","All Fig 4"] <- signif(sd(MFdata.httk$MFratio),2)
# Fig4.table["Predicted Mean (Min - Max)","All Fig 4"] <-  paste(
#   signif(mean(MFdata.main$MFratio.pred,na.rm=TRUE),2)," (",
#   signif(min(MFdata.main$MFratio.pred,na.rm=TRUE),2)," - ",
#   signif(max(MFdata.main$MFratio.pred,na.rm=TRUE),2),")",sep="")
# Fig4.table["RMSE","All Fig 4"] <- signif(RMSE(fit2),2)
# Fig4.table["R-squared","All Fig 4"] <- signif(summary(fit2)[["adj.r.squared"]],2)
# Fig4.table["p-value","All Fig 4"] <- signif(summary(fit2)[["coefficients"]]["MFratio.pred",4],2)
# 
# MFdata.sub1 <- subset(MFdata.httk,
#   !(Chemical.Category %in% c(
#     "Fluorinated compounds",
#     "Polyaromatic Hydrocarbons")))
# 
# Fig4.table["Number of Chemicals","No PFAS/PAH"] <- length(unique(MFdata.sub1$DTXSID))
# Fig4.table["Number of Observations","No PFAS/PAH"] <- dim(MFdata.sub1)[1]
# Fig4.table["Observed Mean (Min - Max)","No PFAS/PAH"] <- paste(
#   signif(mean(MFdata.sub1$MFratio,na.rm=TRUE),2)," (",
#   signif(min(MFdata.sub1$MFratio,na.rm=TRUE),2)," - ",
#   signif(max(MFdata.sub1$MFratio,na.rm=TRUE),2),")",sep="")
# Fig4.table["Observed Standard Deviation","No PFAS/PAH"] <- signif(sd(MFdata.sub1$MFratio),2)
# 
# MFdata.sub2 <- subset(MFdata.main,
#   !(Chemical.Category %in% c(
#     "Fluorinated compounds",
#     "Polyaromatic Hydrocarbons")))
# 
# Fig4.table["Predicted Mean (Min - Max)","No PFAS/PAH"] <-  paste(
#   signif(mean(MFdata.sub2$MFratio.pred,na.rm=TRUE),2)," (",
#   signif(min(MFdata.sub2$MFratio.pred,na.rm=TRUE),2)," - ",
#   signif(max(MFdata.sub2$MFratio.pred,na.rm=TRUE),2),")",sep="")
# Fig4.table["RMSE","No PFAS/PAH"] <- signif(RMSE(fit2sub),2)
# Fig4.table["R-squared","No PFAS/PAH"] <- signif(summary(fit2sub)[["adj.r.squared"]],2)
# Fig4.table["p-value","No PFAS/PAH"] <- signif(summary(fit2sub)[["coefficients"]]["MFratio.pred",4],2)
# 
# 
# MFdata.sub3 <- subset(MFdata.main,N.obs > 1 &
#   !(Chemical.Category %in% c(
#     "Fluorinated compounds",
#     "Polyaromatic Hydrocarbons")))
# 
# Fig4.table["Number of Chemicals","Replicates Only"] <- length(unique(MFdata.sub3$DTXSID))
# Fig4.table["Number of Observations","Replicates Only"] <- dim(MFdata.sub3)[1]
# Fig4.table["Observed Mean (Min - Max)","Replicates Only"] <- paste(
#   signif(mean(MFdata.sub3$MFratio),2)," (",
#   signif(min(MFdata.sub3$MFratio),2)," - ",
#   signif(max(MFdata.sub3$MFratio),2),")",sep="")
# Fig4.table["Observed Standard Deviation","Replicates Only"] <- signif(sd(MFdata.sub3$MFratio),2)
# 
# Fig4.table["Predicted Mean (Min - Max)","Replicates Only"] <-  paste(
#   signif(mean(MFdata.sub3$MFratio.pred,na.rm=TRUE),2)," (",
#   signif(min(MFdata.sub3$MFratio.pred,na.rm=TRUE),2)," - ",
#   signif(max(MFdata.sub3$MFratio.pred,na.rm=TRUE),2),")",sep="")
# Fig4.table["RMSE","Replicates Only"] <- signif(RMSE(fit4sub),2)
# Fig4.table["R-squared","Replicates Only"] <- signif(summary(fit4sub)[["adj.r.squared"]],2)
# Fig4.table["p-value","Replicates Only"] <- signif(summary(fit4sub)[["coefficients"]]["MFratio.pred",4],2)
# 
# write.csv(Fig4.table[1:6,],file="Fig4Table.csv")

## ----dallmann2018_data, eval = execute.vignette-------------------------------
# #TKstats <- as.data.frame(read_excel("MaternalFetalAUCData.xlsx"))
# TKstats <- httk::pregnonpregaucs
# 
# 
# ids <- unique(TKstats$DTXSID)
# cat(paste(sum(ids %in% get_cheminfo(
#   model="fetal_pbtk",
#   info="dtxsid",
#   suppress.messages=TRUE)),
#           "chemicals for which the model fetal_pbtk can run that are in the Dallmann data set."))
# 
# 
# TKstats.Cmax <- subset(TKstats,DTXSID!="" & Parameter=="Cmax")
# TKstats <- subset(TKstats,DTXSID!="" & Parameter %in% c("AUCinf","AUClast"))
# 
# ids <- unique(TKstats$DTXSID)
# cat(paste(sum(ids %in% get_cheminfo(
#   model="fetal_pbtk",
#   info="dtxsid",
#   suppress.messages=TRUE)),
#           "chemicals for which the model fetal_pbtk can run that have AUCs in the Dallmann data set."))
# 
# 
# # Assumed body weight (kg) from Kapraun 2019
# BW.nonpreg <- 61.103
# 
# #TKstats$Dose <- TKstats$Dose/BW
# #TKstats$Dose.Units <- "mg/kg"
# colnames(TKstats)[colnames(TKstats)=="Observed Pregnant"] <- "Observed.Pregnant"
# colnames(TKstats)[colnames(TKstats)=="Observed Pregnant5"] <- "Observed.Pregnant5"
# colnames(TKstats)[colnames(TKstats)=="Observed Non-Pregnant"] <- "Observed.Non.Pregnant"
# colnames(TKstats)[colnames(TKstats)=="Observed Non-Pregnant2"] <- "Observed.Non.Pregnant2"
# colnames(TKstats)[colnames(TKstats)=="Dose Route"] <- "Dose.Route"

## ----dallmann2018_preds, eval = execute.vignette------------------------------
# for (this.id in unique(TKstats$DTXSID))
# {
#   if (any(regexpr("ng",TKstats[TKstats$DTXSID==this.id,"Dose Units"])!=-1))
#   {
#   }
#   if (this.id %in% get_cheminfo(
#     info="DTXSID",
#     model="fetal_pbtk",
#     suppress.messages=TRUE))
#   {
#     this.subset <- subset(TKstats,DTXSID==this.id)
#     p <- parameterize_pbtk(
#       dtxsid=this.id,
#       suppress.messages=TRUE)
#     p$hematocrit <- 0.39412 # Kapraun 2019 (unitless)
#     p$Rblood2plasma <- calc_rblood2plasma(
#       parameters=p,
#       suppress.messages=TRUE)
#     p$BW <- BW.nonpreg
#     p$Qcardiacc <- 301.78 / p$BW^(3/4) # Kapraun 2019 (L/h/kg^3/4)
#     for (this.route in unique(this.subset$Dose.Route))
#     {
#       this.route.subset <- subset(this.subset, Dose.Route==this.route)
#       if (this.route.subset[1,"Gestational.Age.Weeks"] > 12)
#       {
#         this.dose <- this.route.subset$Dose
#         # Non-pregnant PBPK:
#         out.nonpreg <- solve_pbtk(
#           parameters=p,
#           times = seq(0, this.route.subset[1,"NonPreg.Duration.Days"],
#                       this.route.subset[1,"NonPreg.Duration.Days"]/100),
#           dose=this.dose/BW.nonpreg, # mg/kg
#           daily.dose=NULL,
#           iv.dose=(this.route=="iv"),
#           output.units="uM",
#           suppress.messages=TRUE)
#         # Pregnant PBPK:
#         BW.preg <- suppressWarnings(calc_maternal_bw(
#           week=this.route.subset[1,"Gestational.Age.Weeks"]))
#         out.preg <- solve_fetal_pbtk(
#           dtxsid=this.id,
#           times = seq(
#             this.route.subset[1,"Gestational.Age.Weeks"]*7,
#             this.route.subset[1,"Gestational.Age.Weeks"]*7 +
#               this.route.subset[1,"Preg.Duration.Days"],
#             this.route.subset[1,"Preg.Duration.Days"]/100),
#           dose=this.dose/BW.preg, # mg/kg
#           iv.dose=(this.route=="iv"),
#           daily.dose=NULL,
#           output.units="uM",
#           suppress.messages=TRUE)
#         if (any(regexpr("AUC",this.subset$Parameter)!=-1))
#         {
#           TKstats[TKstats$DTXSID==this.id &
#                     TKstats$Dose.Route == this.route &
#                     regexpr("AUC",TKstats$Parameter)!=-1,
#                   "Predicted.Non.Pregnant.httk"] <- max(out.nonpreg[,"AUC"])*24 #uMdays->uMh
#           TKstats[TKstats$DTXSID==this.id &
#                     TKstats$Dose.Route == this.route &
#                     regexpr("AUC",TKstats$Parameter)!=-1,
#                   "Predicted.Pregnant.httk"] <- max(out.preg[,"AUC"])*24 # uM days -> uM h
#         }
#         if (any(regexpr("Cmax",this.subset$Parameter)!=-1))
#         {
#           TKstats[TKstats$DTXSID==this.id &
#                     TKstats$Dose.Route == this.route &
#                     regexpr("Cmax",TKstats$Parameter)!=-1,
#                   "Predicted.Non.Pregnant.httk"] <- max(out.nonpreg[,"Cplasma"])
#           TKstats[TKstats$DTXSID==this.id &
#                     TKstats$Dose.Route == this.route &
#                     regexpr("Cmax",TKstats$Parameter)!=-1,
#                   "Predicted.Pregnant.httk"] <- max(out.preg[,"Cfplasma"])
#         }
#       }
#     }
#   }
# }
# 
# TKstats$Ratio.obs <- TKstats$Observed.Pregnant / TKstats$Observed.Non.Pregnant
# TKstats$Ratio.httk <- TKstats$Predicted.Pregnant.httk / TKstats$Predicted.Non.Pregnant.httk
# TKstats <- subset(TKstats, !is.na(TKstats$Ratio.httk))
# 
# write.csv(TKstats,file="Table-Dallmann2018.csv",row.names=FALSE)

## ----dallmann2018_figure, eval = execute.vignette-----------------------------
# FigEa  <- ggplot(data=TKstats) +
#   geom_point(aes(
#     y=Observed.Non.Pregnant2,
#     x=Predicted.Non.Pregnant.httk,
#     shape=Dose.Route,
#     alpha=Drug,
#     fill=Drug),
#     size=5)   +
#   geom_abline(slope=1, intercept=0) +
#   geom_abline(slope=1, intercept=1, linetype=3) +
#   geom_abline(slope=1, intercept=-1, linetype=3) +
#   scale_shape_manual(values=c(22,24))+
#   xlab("httk Predicted (uM*h)") +
#   ylab("Observed") +
#   scale_x_log10(#limits=c(10^-3,10^3),
#     label=scientific_10) +
#   scale_y_log10(#limits=c(10^-3,10^3),
#     label=scientific_10) +
#   ggtitle("Non-Pregnant") +
#   theme_bw()  +
#   theme(legend.position="none")+
#   theme( text  = element_text(size=12)) +
#   annotate("text", x = 0.1, y = 1000, label = "A", fontface =2)
# 
# #print(FigEa)
# cat(paste(
#   "For the Dallman et al. (2018) data we observe an average-fold error (AFE)\n\ of",
#   signif(mean(TKstats$Predicted.Non.Pregnant.httk/TKstats$Observed.Non.Pregnant2),2),
#   "and a RMSE (log10-scale) of",
#   signif((mean((log10(TKstats$Predicted.Non.Pregnant.httk)-log10(TKstats$Observed.Non.Pregnant2))^2))^(1/2),2),
#   "for non-pregnant woman.\n"))
# 
# FigEb  <- ggplot(data=TKstats) +
#   geom_point(aes(
#     y=Observed.Pregnant5,
#     x=Predicted.Pregnant.httk,
#     shape=Dose.Route,
#     alpha=Drug,
#     fill=Drug),
#     size=5)   +
#       geom_abline(slope=1, intercept=0) +
#   geom_abline(slope=1, intercept=1, linetype=3) +
#   geom_abline(slope=1, intercept=-1, linetype=3) +
#   scale_shape_manual(values=c(22,24))+
#   xlab("httk Predicted (uM*h)") +
#   ylab("Observed") +
#   scale_x_log10(#limits=c(10^-5,10^3),
#                 label=scientific_10) +
#   scale_y_log10(#limits=c(10^-5,10^3),
#                 label=scientific_10) +
#   ggtitle("Pregnant")+
#   theme_bw()  +
#   theme(legend.position="none")+
#   theme( text  = element_text(size=12)) +
#   annotate("text", x = 0.1, y = 300, label = "B", fontface =2)
# 
# #print(FigEb)
# cat(paste(
#   "We observe an AFE of",
#   signif(mean(TKstats$Predicted.Pregnant.httk/TKstats$Observed.Pregnant5),2),
#   "and a RMSE (log10-scale) of",
#   signif((mean((log10(TKstats$Predicted.Pregnant.httk)-log10(TKstats$Observed.Pregnant5))^2))^(1/2),2),
#   "for pregnant woman.\n"))
# 
# 
# 
# FigEc  <- ggplot(data=TKstats) +
#   geom_point(aes(
#     x=Predicted.Non.Pregnant.httk,
#     y=Predicted.Pregnant.httk,
#     shape=Dose.Route,
#     alpha=Drug,
#     fill=Drug),
#     size=5)   +
#       geom_abline(slope=1, intercept=0) +
#   geom_abline(slope=1, intercept=1, linetype=3) +
#   geom_abline(slope=1, intercept=-1, linetype=3) +
#   scale_shape_manual(values=c(22,24),name="Route")+
#   ylab("httk Pregnant (uM*h)") +
#   xlab("httk Non-Pregnant (uM*h)") +
#   scale_x_log10(#limits=c(10^-1,10^2),
#                 label=scientific_10) +
#   scale_y_log10(#limits=c(10^-1,10^2),
#                 label=scientific_10) +
#   ggtitle("Model Comparison") +
#   theme_bw()  +
#   theme(legend.position="left")+
#   theme( text  = element_text(size=12))+
#   theme(legend.text=element_text(size=10))+
#   guides(fill=guide_legend(ncol=2,override.aes=list(shape=21)),alpha=guide_legend(ncol=2),shape=guide_legend(ncol=2))
#  print(FigEc)
# FigEc <- get_legend(FigEc)
# 
# 
# FigEd  <- ggplot(data=subset(TKstats,!is.na(Ratio.httk))) +
#   geom_point(aes(
#     y=Ratio.obs,
#     x=Ratio.httk,
#     shape=Dose.Route,
#     alpha=Drug,
#     fill=Drug),
#     size=5)   +
#   scale_shape_manual(values=c(22,24))+
#   xlab("httk Predicted") +
#   ylab("Observed") +
#   scale_x_continuous(limits=c(0.25,3)) +
#   scale_y_continuous(limits=c(0.25,3)) +
#   geom_abline(slope=1, intercept=0) +
#  geom_abline(slope=1, intercept=1, linetype=3) +
#   geom_abline(slope=1, intercept=-1, linetype=3) +
#   ggtitle("Ratio") +
#   theme_bw()  +
#   theme(legend.position="none")+
#   theme( text  = element_text(size=12)) +
#   annotate("text", x = 0.5, y = 2.75, label = "C", fontface =2)
# 
# dev.new()
# grid.arrange(FigEa,FigEb,FigEc,FigEd,nrow=2)
# 
# write.csv(subset(TKstats,
#   !is.na(Ratio.httk)),
#   file="DallmanTable.txt")
# 

## ----curley1969_data, eval = execute.vignette---------------------------------
# Curley <- as.data.frame(read_excel("Curley1969.xlsx"))
# dim(Curley)
# Curley.compounds <- Curley[1,4:13]
# Curley <- Curley[4:47,]
# colnames(Curley)[1] <- "Tissue"
# colnames(Curley)[2] <- "N"
# colnames(Curley)[3] <- "Stat"

## ----curley1969_calcpcs, eval = execute.vignette------------------------------
# Curley.pcs <- NULL
# cord.blood <- subset(Curley, Tissue == "Cord Blood")
# suppressWarnings(
# for (this.tissue in unique(Curley$Tissue))
#   if (this.tissue != "Cord Blood")
#   {
#     this.subset <- subset(Curley, Tissue == this.tissue)
#     for (this.chemical in colnames(Curley)[4:13])
#     {
#       if (!is.na(as.numeric(subset(this.subset,Stat=="Mean")[,this.chemical])) &
#         !is.na(as.numeric(subset(cord.blood,Stat=="Mean")[,this.chemical])))
#       {
#         this.row <- data.frame(
#           Compound = Curley.compounds[,this.chemical],
#           DTXSID = this.chemical,
#           Tissue = this.tissue,
#           PC = as.numeric(subset(this.subset,Stat=="Mean")[,this.chemical]) /
#             as.numeric(subset(cord.blood,Stat=="Mean")[,this.chemical])
#           )
#         Curley.pcs <- rbind(Curley.pcs,this.row)
#       } else if (!is.na((as.numeric(subset(this.subset,Stat=="Range")[,this.chemical]))) &
#         !is.na((as.numeric(subset(cord.blood,Stat=="Mean")[,this.chemical]))))
#       {
#         this.row <- data.frame(
#           Compound = Curley.compounds[,this.chemical],
#           DTXSID = this.chemical,
#           Tissue = this.tissue,
#           PC = as.numeric(subset(this.subset,Stat=="Range")[,this.chemical]) /
#             as.numeric(subset(cord.blood,Stat=="Mean")[,this.chemical])
#           )
#         Curley.pcs <- rbind(Curley.pcs,this.row)
#       }
#     }
#   }
# )
# Curley.pcs[Curley.pcs$Tissue=="Lungs","Tissue"] <- "Lung"
# 
# pearce2017 <- read_excel("PC_Data.xlsx")
# pearce2017 <- subset(pearce2017,DTXSID%in%Curley.pcs$DTXSID)
# any(pearce2017$DTXSID%in%Curley.pcs$DTXSID)
# print("None of the Curley chems were in the Pearce 2017 PC predictor evaluation.")

## ----csanady2002_pcs, eval = execute.vignette---------------------------------
# csanadybpa <- read_excel("Csanady2002.xlsx",sheet="Table 2")
# csanadybpa$Compound <- "Bisphenol A"
# csanadybpa$DTXSID <- "DTXSID7020182"
# csanadybpa <- csanadybpa[,c("Compound","DTXSID","Tissue","Mean")]
# colnames(csanadybpa) <- colnames(Curley.pcs)
# 
# csanadydaid <- read_excel("Csanady2002.xlsx",sheet="Table 3",skip=1)
# csanadydaid$Compound <- "Daidzein"
# csanadydaid$DTXSID <- "DTXSID9022310"
# csanadydaid <- csanadydaid[,c("Compound","DTXSID","Tissue","Mean...6")]
# colnames(csanadydaid) <- colnames(Curley.pcs)
# 
# Curley.pcs <- rbind(Curley.pcs,csanadybpa,csanadydaid)
# Curley.pcs <- subset(Curley.pcs,Tissue!="Mammary gland")

## ----weijs2013_loadPCs, eval = execute.vignette-------------------------------
# weijstab3 <- read_excel("Weijs2013.xlsx",sheet="Table3",skip=1)
# weijstab3 <- subset(weijstab3, !is.na(Compound) & !is.na(Tissue))
# weijstab4 <- read_excel("Weijs2013.xlsx",sheet="Table4",skip=1)
# weijstab4 <- subset(weijstab4, !is.na(Compound) & !is.na(Tissue))
# 
# for (this.compound in unique(weijstab3$Compound))
#   for (this.tissue in unique(weijstab3$Tissue))
#   {
#     Curley.pcs[
#       Curley.pcs$DTXSID==this.compound & Curley.pcs$Tissue==this.tissue,
#       "Weijs2013"] <- weijstab3[weijstab3$Compound==this.compound &
#                                   weijstab3$Tissue==this.tissue,"value"]
# 
#   }
# 
# for (this.compound in unique(weijstab4$Compound))
#   for (this.tissue in unique(weijstab4$Tissue))
#   {
#     Curley.pcs[
#       Curley.pcs$DTXSID==this.compound & Curley.pcs$Tissue==this.tissue,
#       "Weijs2013"] <- weijstab4[weijstab4$Compound==this.compound &
#                                   weijstab4$Tissue==this.tissue,"value"]
# 
#   }
# 
# write.csv(Curley.pcs,"PCs-table.csv",row.names=FALSE)
# 

## ----curley1969_makepreds, eval = execute.vignette----------------------------
# Curley.pcs <- httk::fetalpcs
# dtxsid.list <- get_cheminfo(
#   info="DTXSID",
#   model="fetal_pbtk",
#   suppress.messages=TRUE)
# 
# suppressWarnings(load_sipes2017())
# for (this.chemical in unique(Curley.pcs$DTXSID))
#   if (this.chemical %in% dtxsid.list)
#   {
#     this.subset <- subset(Curley.pcs,DTXSID==this.chemical)
#     p <- parameterize_fetal_pbtk(dtxsid=this.chemical,
#       fetal_fup_adjustment = FALSE,
#       suppress.messages=TRUE,
#       minimum.Funbound.plasma = 1e-16)
#     fetal.blood.pH <- 7.26
#     Fup <- p$Fraction_unbound_plasma_fetus
#     fetal_schmitt_parms <- parameterize_schmitt(
#       dtxsid=this.chemical,
#       suppress.messages=TRUE,
#       minimum.Funbound.plasma = 1e-16)
#     fetal_schmitt_parms$plasma.pH <- fetal.blood.pH
#     fetal_schmitt_parms$Funbound.plasma <- Fup
#     Curley.pcs[Curley.pcs$DTXSID==this.chemical,"Fup"] <- Fup
#     # httk gives tissue:fup (unbound chemical in plasma) PC's:
#     fetal_pcs <- predict_partitioning_schmitt(
#       parameters = fetal_schmitt_parms,
#       suppress.messages=TRUE,
#       model="fetal_pbtk",
#       minimum.Funbound.plasma = 1e-16)
#     fetal_pcs.nocal <- predict_partitioning_schmitt(
#       parameters = fetal_schmitt_parms,
#       regression=FALSE,
#       suppress.messages=TRUE,
#       model="fetal_pbtk",
#       minimum.Funbound.plasma = 1e-16)
#     out <- solve_fetal_pbtk(
#       dtxsid = this.chemical,
#       fetal_fup_adjustment =FALSE,
#       suppress.messages=TRUE,
#       minimum.Funbound.plasma = 1e-16)
#     Rb2p <- out[dim(out)[1],"Rfblood2plasma"]
#     Curley.pcs[Curley.pcs$DTXSID==this.chemical,"Rb2p"] <- Rb2p
#     # Convert to tissue:blood PC's:
#     for (this.tissue in this.subset$Tissue)
#       if (tolower(this.tissue) %in%
#         unique(subset(tissue.data,Species=="Human")$Tissue))
#       {
#         Curley.pcs[Curley.pcs$DTXSID==this.chemical &
#           Curley.pcs$Tissue == this.tissue, "HTTK.pred.t2up"] <-
#           fetal_pcs[[paste("K",tolower(this.tissue),"2pu",sep="")]]
#         Curley.pcs[Curley.pcs$DTXSID==this.chemical &
#           Curley.pcs$Tissue == this.tissue, "HTTK.pred.nocal.t2up"] <-
#           fetal_pcs.nocal[[paste("K",tolower(this.tissue),"2pu",sep="")]]
#         Curley.pcs[Curley.pcs$DTXSID==this.chemical &
#           Curley.pcs$Tissue == this.tissue, "HTTK.pred"] <-
#           fetal_pcs[[paste("K",tolower(this.tissue),"2pu",sep="")]]*Fup/Rb2p
#         Curley.pcs[Curley.pcs$DTXSID==this.chemical &
#           Curley.pcs$Tissue == this.tissue, "HTTK.pred.nocal"] <-
#           fetal_pcs.nocal[[paste("K",tolower(this.tissue),"2pu",sep="")]]*Fup/Rb2p
#       } else {
#        print(this.tissue)
#       }
#   } else print(this.chemical)
# reset_httk()
# 
# cat(paste(
#   "For the two placental observations (",
#   signif(subset(Curley.pcs,Compound=="Bisphenol A" & Tissue=="Placenta")[,"PC"],2),
#   " for Bisphenol A and ",
#   signif(subset(Curley.pcs,Compound=="Daidzein" & Tissue=="Placenta")[,"PC"],2),
#   " for Diadzen) the predictions were ",
#   signif(subset(Curley.pcs,Compound=="Bisphenol A" & Tissue=="Placenta")[,"HTTK.pred"],2),
#   " and ",
#   signif(subset(Curley.pcs,Compound=="Daidzein" & Tissue=="Placenta")[,"HTTK.pred"],2),
#   ", respectively.\n",sep=""))
# 
# 

## ----curley1969_figure_compounds, eval = execute.vignette---------------------
# FigFa  <- ggplot(data=subset(Curley.pcs,!is.na(HTTK.pred.nocal))) +
#   geom_point(size=2,aes(
#     y=Weijs2013,
#     x=HTTK.pred,
#     shape=Compound,
#     color=Compound)) +
#   geom_point(size=5,aes(
#     y=PC,
#     x=HTTK.pred,
#     shape=Compound,
#     color=Compound)) +
#   geom_abline(slope=1, intercept=0, size=2) +
#   geom_abline(slope=1, intercept=1, linetype=3, size=2) +
#   geom_abline(slope=1, intercept=-1, linetype=3, size=2) +
#   scale_shape_manual(values=rep(c(15,16,17,18),4))+
#   xlab("Predicted Tissue:Blood Partition Coefificent") +
#   ylab("Observed") +
#   scale_x_log10(label=scientific_10,limits=c(10^-1,10^2)) +
#   scale_y_log10(label=scientific_10,limits=c(10^-1,10^4)) +
#   theme_bw()  +
#   theme(legend.position="bottom")+
#   theme( text  = element_text(size=28))+
#   theme(legend.text=element_text(size=12))+
#    theme(legend.title = element_blank())+
#   guides(shape=guide_legend(nrow=3,byrow=TRUE))
# 
# print(FigFa)
# 
# fitFa <- lm(data=Curley.pcs,log10(PC)~log10(HTTK.pred))
# RMSE(fitFa)
# fitFb <- lm(data=Curley.pcs,log10(PC)~log10(HTTK.pred.nocal))
# RMSE(fitFb)

## ----curley1969_figure_tissues, eval = execute.vignette-----------------------
# FigFb  <- ggplot(data=subset(Curley.pcs,!is.na(HTTK.pred))) +
#   geom_point(size=2,aes(
#     y=Weijs2013,
#     x=HTTK.pred,
#     shape=Tissue,
#     color=Tissue)) +
#   geom_point(size=5, aes(
#     y=PC,
#     x=HTTK.pred,
#     shape=Tissue,
#     color=Tissue))   +
#   geom_abline(slope=1, intercept=0, size=2) +
#   geom_abline(slope=1, intercept=1, linetype=3, size=2) +
#   geom_abline(slope=1, intercept=-1, linetype=3, size=2) +
#   scale_shape_manual(values=rep(c(15,16,17,18),4))+
#   xlab("Predicted Tissue:Blood Partition Coefificent") +
#   ylab("Observed") +
#   scale_x_log10(label=scientific_10,limits=c(10^-1,10^2)) +
#   scale_y_log10(label=scientific_10,limits=c(10^-1,10^4)) +
#   theme_bw()  +
#   theme(legend.position="bottom")+
#   theme( text  = element_text(size=28))+
#   theme(legend.text=element_text(size=20))+
#    theme(legend.title = element_blank())+
#   guides(shape=guide_legend(nrow=3,byrow=TRUE))
# 
# print(FigFb)

## ----read_pksim_pcs, eval = execute.vignette----------------------------------
# pksim.pcs <- as.data.frame(read_excel("PartitionCoefficients.xlsx"))
# dim(pksim.pcs)
# for (this.id in unique(pksim.pcs$DTXSID))
# {
#   httk.PCs <- predict_partitioning_schmitt(dtxsid=this.id,
#                                            suppress.messages = TRUE)
#   p <-
#     parameterize_fetal_pbtk(dtxsid=this.id,
#     suppress.messages = TRUE)
#   httk.PCs[["Kplacenta2pu"]] <- p[["Kplacenta2pu"]]
#   httk.PCs[["Fup"]] <- p[["Funbound.plasma"]]
#   lapply(httk.PCs,as.numeric)
#   this.subset <- subset(pksim.pcs,DTXSID==this.id)
#   for (this.tissue in unique(this.subset$Tissue))
#   {
#     if (any(regexpr(tolower(this.tissue),names(httk.PCs))!=-1))
#     {
#       pksim.pcs[pksim.pcs$DTXSID==this.id & pksim.pcs$Tissue==this.tissue,
#         "HTTK.pred"] <-
#         httk.PCs[regexpr(tolower(this.tissue),names(httk.PCs))!=-1][[1]]*
#         httk.PCs[["Fup"]][[1]]
#     }
#   }
# }
# colnames(pksim.pcs)[colnames(pksim.pcs) ==
#                       "Tissue-to-plasma partition coefficient"] <- "PKSim.pred"
# colnames(pksim.pcs)[colnames(pksim.pcs) ==
#         "Method for calculating tissue-to-plasma partition coefficients"] <-
#   "Method"
# pksim.pcs[,"Method"] <- as.factor(pksim.pcs[,"Method"])
# pksim.pcs[,"Drug"] <- as.factor(pksim.pcs[,"Drug"])
# pksim.pcs[,"Tissue"] <- as.factor(pksim.pcs[,"Tissue"])
# 
# 
# pksim.pcs[,"PKSim.pred"] <- as.numeric(
#   pksim.pcs[,"PKSim.pred"])
# 

## ----compare_pksim_pcs, eval = execute.vignette-------------------------------
# pksim.pcs <- httk::pksim.pcs
# 
# pksim.fit1 <- lm(data=pksim.pcs,
#                 log10(PKSim.pred)~log10(HTTK.pred))
# summary(pksim.fit1)
# 
# pksim.fit2 <- lm(data=pksim.pcs,
#                 log10(PKSim.pred)~log10(HTTK.pred)+
#                   Drug+Tissue+Method)
# summary(pksim.fit2)
# 

## ----wang2018_loaddata, eval = execute.vignette-------------------------------
# #Wangchems <- read_excel("Wang2018.xlsx",sheet=3,skip=2)
# Wangchems <- httk::wang2018
# maternal.list <- Wangchems$CASRN[Wangchems$CASRN %in%
#   get_cheminfo(model="fetal_pbtk",
#   suppress.messages=TRUE)]
# nonvols <- subset(chem.physical_and_invitro.data,logHenry < -4.5)$CAS
# nonfluoros <- chem.physical_and_invitro.data$CAS[
#   regexpr("fluoro",tolower(chem.physical_and_invitro.data$Compound))==-1]
# maternal.list <- maternal.list[maternal.list %in% intersect(nonvols,nonfluoros)]

## ----wang2018_makepreds, eval = execute.vignette------------------------------
# 
# pred.table1 <- subset(get_cheminfo(
#   info=c("Compound","CAS","DTXSID","logP","pka_accept","pka_donor"),
#   model="fetal_pbtk"),
#   CAS %in% maternal.list,
#   suppress.messages=TRUE)
# pred.table1$Compound <- gsub("\"","",pred.table1$Compound)
# 
# for (this.cas in maternal.list)
# {
#   Fup <- subset(get_cheminfo(
#     info="all",
#     suppress.messages=TRUE),
#     CAS==this.cas)$Human.Funbound.plasma
#   # Check if Fup is provided as a distribution:
#   if (regexpr(",",Fup)!=-1)
#   {
#     if (as.numeric(strsplit(Fup,",")[[1]][1])==0 |
#       (as.numeric(strsplit(Fup,",")[[1]][3])>0.9 &
#       as.numeric(strsplit(Fup,",")[[1]][2])<0.11))
#     {
#       skip <- TRUE
#     } else skip <- FALSE
#     Fup.upper <- as.numeric(strsplit(Fup,",")[[1]][3])
#     Fup <- as.numeric(strsplit(Fup,",")[[1]][1])
#     # These results are actually from a Bayesian posterior, but we can approximate that
#     # they are normally distributed about the median to estimate a standard deviation:
#     Fup.sigma <- (Fup.upper - Fup)/1.96
#   # If it's not a distribution use defaults (see Wambaugh et al. 2019)
#   } else if (as.numeric(Fup)== 0)
#   {
#     skip <- TRUE
#   } else {
#     skip <- FALSE
#     Fup <- as.numeric(Fup)
#     Fup.sigma <- Fup*0.4
#     Fup.upper  <- min(1,(1+1.96*0.4)*Fup)
#   }
# 
#   # Only run the simulation if we have the necessary parameters:
#   if (!skip)
#   {
#     print(this.cas)
#     out <- solve_fetal_pbtk(
#       chem.cas=this.cas,
#       dose=0,
#       daily.dose=1,
#       doses.per.day=3,
#       fetal_fup_adjustenment=TRUE,
#       suppress.messages=TRUE)
#     last.row <- which(out[,"time"]>279)
#     last.row <- last.row[!duplicated(out[last.row,"time"])]
#     pred.table1[pred.table1$CAS==this.cas,"fup"] <- signif(Fup,3)
#     pred.table1[pred.table1$CAS==this.cas,"fup.sigma"] <- signif(Fup.sigma,3)
#     pred.table1[pred.table1$CAS==this.cas,"fup.upper"] <- signif(Fup.upper,3)
#     pred.table1[pred.table1$CAS==this.cas,"Ratio.pred"] <-
#       signif(mean(out[last.row,"Cfplasma"])/mean(out[last.row,"Cplasma"]),3)
#   }
# }

## ----brain_uncertainty_prop_table, eval = execute.vignette--------------------
# PC.table <- pred.table1
# colnames(PC.table)[colnames(PC.table)=="Ratio.pred"] <- "R.plasma.FtoM"
# pred.table1$Uncertainty <- "Predicted F:M Plasma Ratio"

## ----Rfetmat_uncertainty, eval = execute.vignette-----------------------------
# pred.table3 <- pred.table1
# pred.table3$Uncertainty <- "Plasma Error (Fig. 4)"
# empirical.error <- RMSE(fit2sub)
# for (this.cas in maternal.list)
# {
# 
#   pred.table3[pred.table3$CAS==this.cas,"Ratio.pred"] <- signif(
#     1/((1/pred.table1[pred.table3$CAS==this.cas,"Ratio.pred"])*
#          (1-1.96*empirical.error)), 3)
# }
# # Update final table for paper:
# PC.table$RMSE <- signif(RMSE(fit2sub),3)
# PC.table$R.plasma.FtoM.upper <- pred.table3$Ratio.pred

## ----Rfetbrain, eval = execute.vignette---------------------------------------
# pred.table4 <- pred.table1
# pred.table4$Uncertainty <- "Fetal Brain Partitioning"
# for (this.cas in maternal.list)
# {
#   print(this.cas)
#   p <- parameterize_fetal_pbtk(chem.cas=this.cas,
#       fetal_fup_adjustment=TRUE,
#       suppress.messages=TRUE)
#   Kbrain2pu <- p$Kfbrain2pu
#   fup <- pred.table4[pred.table4$CAS==this.cas,"fup"]
#   pred.table4[pred.table4$CAS==this.cas,"Ratio.pred"] <- signif(
#      PC.table[PC.table$CAS==this.cas,"R.plasma.FtoM"]*
#     Kbrain2pu * fup, 3)
#   PC.table[PC.table$CAS==this.cas,"Kbrain2pu"] <- Kbrain2pu
#   PC.table[PC.table$CAS==this.cas,"R.brain.FtoM"] <-
#     pred.table4[pred.table4$CAS==this.cas,"Ratio.pred"]
# }

## ----Rfetbrain_uncertainty, eval = execute.vignette---------------------------
# 
# pred.table5 <- pred.table1
# pred.table5$Uncertainty <- "Brain Partitioning Error (Pearce et al., 2017)"
# for (this.cas in maternal.list)
# {
#   p <- parameterize_fetal_pbtk(chem.cas=this.cas,
#       fetal_fup_adjustment=TRUE,
#       suppress.messages=TRUE)
#   Kbrain2pu <- p$Kfbrain2pu
# 
#   fup <- pred.table5[pred.table5$CAS==this.cas,"fup"]
#   sigma.fup <- pred.table5[pred.table5$CAS==this.cas,"fup.sigma"]
#   Rmatfet <- 1/PC.table[PC.table$CAS==this.cas,"R.plasma.FtoM"]
#   Rbrain2matblood <- Kbrain2pu * fup / Rmatfet
# 
# # From Pearce et al. (2017) PC paper:
#   sigma.logKbrain <- 0.647
#   Kbrain2pu.upper <- signif(10^(log10(Kbrain2pu)+1.96*sigma.logKbrain),3)
# 
#   error.Rmatfet <- PC.table[PC.table$CAS==this.cas,"RMSE"]
#   sigma.Rbrain2matblood <- Rbrain2matblood *
#     (log(10)^2*sigma.logKbrain^2 +
#     sigma.fup^2/fup^2 +
#     error.Rmatfet^2/Rmatfet^2)^(1/2)
#   Rbrain2matblood.upper <- Rbrain2matblood *
#     (1 + 1.96*(log(10)^2*sigma.logKbrain^2 +
#     sigma.fup^2/fup^2 +
#     error.Rmatfet^2/Rmatfet^2)^(1/2))
#   pred.table5[pred.table5$CAS==this.cas,"Ratio.pred"] <-
#     signif(Rbrain2matblood.upper,3)
#   PC.table[PC.table$CAS==this.cas,"sigma.logKbrain"] <-
#     signif(sigma.logKbrain, 3)
#   PC.table[PC.table$CAS==this.cas,"Kbrain2pu.upper"] <-
#     signif(Kbrain2pu.upper, 3)
#   PC.table[PC.table$CAS==this.cas,"sigma.Rbrain2matblood"] <-
#     signif(sigma.Rbrain2matblood, 3)
#   PC.table[PC.table$CAS==this.cas,"R.brain.FtoM.upper"] <-
#     pred.table5[pred.table5$CAS==this.cas,"Ratio.pred"]
# }

## ----Wang_Uncertainty_Propagation, eval = execute.vignette--------------------
# 
# pred.levels <- pred.table5$Compound[order(pred.table5$Ratio.pred)]
# 
# pred.table <- rbind(
#   pred.table1,
# #  pred.table2,
#   pred.table3,
#   pred.table4,
#   pred.table5)
# pred.table$Compound <- factor(pred.table$Compound,
#   levels = pred.levels)
# 
# pred.table$Uncertainty <- factor(pred.table$Uncertainty,
#   levels = c(pred.table1[1,"Uncertainty"],
# #    pred.table2[1,"Uncertainty"],
#     pred.table3[1,"Uncertainty"],
#     pred.table4[1,"Uncertainty"],
#     pred.table5[1,"Uncertainty"]))

## ----wang2018_figure, eval = execute.vignette---------------------------------
# #Wang 2018 confirmed 6 chemical identities:
# confirmed.chemicals <- c(
#   "2,4-Di-tert-butylphenol",
#   "2,4-Dinitrophenol",
#   "Pyrocatechol",
#   "2'-Hydroxyacetophenone",
#   "3,5-Di-tert-butylsalicylic acid",
#   "4-Hydroxycoumarin"
#   )
# confirmed.chemicals <- c(
#   "96-76-4",
#   "19715-19-6",
#   "51-28-5",
#   "120-80-9",
#   "118-93-4",
#   "1076-38-6")
# 
# 
# FigG  <- ggplot(data=pred.table) +
#   geom_point(aes(
#     x=Ratio.pred,
#     y=Compound,
#     color = Uncertainty,
#     shape = Uncertainty),
#     size=3)   +
#     scale_shape_manual(values=c(15, 16,2, 23, 0, 1, 17, 5, 6))+
#   scale_x_log10(limits=c(10^-2,10^3),label=scientific_10)+
#   ylab(expression(paste(
#     "Chemicals Found in Maternal Plasma by Wang   ",italic("et al.")," (2018)"))) +
#   xlab("Predicted Ratio to Maternal Plasma") +
#   theme_bw()  +
# #  theme(legend.position="bottom")+
#   theme( text  = element_text(size=14))+
#   theme(legend.text=element_text(size=10))#+
#  # guides(color=guide_legend(nrow=4,byrow=TRUE))+
#   #guides(shape=guide_legend(nrow=4,byrow=TRUE))
#   #+
#  # theme(legend.justification = c(0, 0), legend.position = c(0, 0))
# 
# print(FigG)

## ----wang2018_details, eval = execute.vignette--------------------------------
# 
# for (this.col in 7:14)
#   PC.table[,this.col] <- signif(PC.table[,this.col],3)
# 
# PC.table <- PC.table[order(PC.table$R.brain.FtoM.upper,decreasing=TRUE),]
# 
# for (this.row in 1:dim(PC.table)[1])
# {
#   out <- calc_ionization(
#     pH=7.26,
#     pKa_Donor=PC.table[this.row,"pKa_Donor"],
#     pKa_Accept=PC.table[this.row,"pKa_Accept"])
#   if (out$fraction_neutral>0.9) PC.table[this.row,"Charge_726"] <- "Neutral"
#   else if (out$fraction_positive>0.1) PC.table[this.row,"Charge_726"] <-
#     paste(signif(out$fraction_positive*100,2),"% Positive",sep="")
#   else if (out$fraction_negative>0.1) PC.table[this.row,"Charge_726"] <-
#     paste(signif(out$fraction_negative*100,2),"% Negative",sep="")
#   else if (out$fraction_zwitter>0.1) PC.table[this.row,"Charge_726"] <-
#     paste(signif(out$fraction_zwitter*100,2),"% Zwitterion",sep="")
# }
# 
# PC.table <- PC.table[,c(
#   "Compound",
#   "CAS",
#   "DTXSID",
#   "logP",
#   "Charge_726",
#   "R.plasma.FtoM",
#   "RMSE",
#   "R.plasma.FtoM.upper",
#   "Kbrain2pu",
#   "fup",
#   "R.brain.FtoM",
#   "Kbrain2pu.upper",
#   "R.brain.FtoM.upper")]
# 
# write.csv(PC.table,
#   file="WangTable.txt",
#   row.names=FALSE)

## ----impact_of_model, eval = execute.vignette---------------------------------
# MFbrainfit <- lm(R.brain.FtoM.upper~Kbrain2pu.upper,data=PC.table)
# summary(MFbrainfit)
# 
# cat(paste("As expected, the predicted fetal brain to maternal blood ratio was strongly correlated with the predicted brain partition coefficient (R2 = ",
#   signif(summary(MFbrainfit)$adj.r.square,2),
#   ", p-value ",
#   signif(summary(MFbrainfit)$coefficients[2,4],2),
#   "). However, the PBTK simulation impacted the plasma and tissue concentrations such that ",
#   dim(subset(PC.table, rank(R.brain.FtoM.upper) <  rank(Kbrain2pu.upper)))[1],
#   " chemicals were ranked higher than they would have been using partitioning alone.",
#   sep=""))

## ----wang2018_makepreds_nofup, eval = execute.vignette------------------------
# 
# pred.table1.nofup <- subset(get_cheminfo(
#   info=c("Compound","CAS","DTXSID","logP","pka_accept","pka_donor"),
#   model="fetal_pbtk",
#   suppress.messages=TRUE),
#   CAS %in% maternal.list)
# pred.table1.nofup$Compound <- gsub("\"","",pred.table1.nofup$Compound)
# 
# for (this.cas in maternal.list)
# {
#   Fup <- subset(get_cheminfo(
#     info="all",
#     suppress.messages=TRUE),
#     CAS==this.cas)$Human.Funbound.plasma
#   # Check if Fup is provided as a distribution:
#   if (regexpr(",",Fup)!=-1)
#   {
#     if (as.numeric(strsplit(Fup,",")[[1]][1])==0 |
#       (as.numeric(strsplit(Fup,",")[[1]][3])>0.9 &
#       as.numeric(strsplit(Fup,",")[[1]][2])<0.11))
#     {
#       skip <- TRUE
#     } else skip <- FALSE
#     Fup.upper <- as.numeric(strsplit(Fup,",")[[1]][3])
#     Fup <- as.numeric(strsplit(Fup,",")[[1]][1])
#     # These results are actually from a Bayesian posterior, but we can approximate that
#     # they are normally distributed about the median to estimate a standard deviation:
#     Fup.sigma <- (Fup.upper - Fup)/1.96
#   # If it's not a distribution use defaults (see Wambaugh et al. 2019)
#   } else if (as.numeric(Fup)== 0)
#   {
#     skip <- TRUE
#   } else {
#     skip <- FALSE
#     Fup <- as.numeric(Fup)
#     Fup.sigma <- Fup*0.4
#     Fup.upper  <- min(1,(1+1.96*0.4)*Fup)
#   }
# 
#   # Only run the simulation if we have the necessary parameters:
#   if (!skip)
#   {
#     out <- solve_fetal_pbtk(
#       chem.cas=this.cas,
#       dose=0,
#       daily.dose=1,
#       doses.per.day=3,
#       fetal_fup_adjustenment=FALSE,
#       suppress.messages=TRUE)
#     last.row <- which(out[,"time"]>279)
#     last.row <- last.row[!duplicated(out[last.row,"time"])]
#     pred.table1.nofup[pred.table1.nofup$CAS==this.cas,"fup"] <- signif(Fup,3)
#     pred.table1.nofup[pred.table1.nofup$CAS==this.cas,"fup.sigma"] <- signif(Fup.sigma,3)
#     pred.table1.nofup[pred.table1.nofup$CAS==this.cas,"fup.upper"] <- signif(Fup.upper,3)
#     pred.table1.nofup[pred.table1.nofup$CAS==this.cas,"Ratio.pred"] <-
#       signif(mean(out[last.row,"Cfplasma"])/mean(out[last.row,"Cplasma"]),3)
#   }
# }

## ----brain_uncertainty_prop_table_nofup, eval = execute.vignette--------------
# PC.table.nofup <- pred.table1.nofup
# colnames(PC.table.nofup)[colnames(PC.table.nofup)=="Ratio.pred"] <- "R.plasma.FtoM"
# pred.table1.nofup$Uncertainty <- "Predicted F:M Plasma Ratio"

## ----Rfetmat_uncertainty_nofup, eval = execute.vignette-----------------------
# pred.table3.nofup <- pred.table1.nofup
# pred.table3.nofup$Uncertainty <- "Plasma Error (Fig. 4)"
# empirical.error <- RMSE(fit2sub)
# for (this.cas in maternal.list)
# {
# 
#   pred.table3.nofup[pred.table3.nofup$CAS==this.cas,"Ratio.pred"] <- signif(
#     1/((1/pred.table1.nofup[pred.table3.nofup$CAS==this.cas,"Ratio.pred"])*
#          (1-1.96*empirical.error)), 3)
# }
# # Update final table for paper:
# PC.table.nofup$RMSE <- signif(RMSE(fit2sub),3)
# PC.table.nofup$R.plasma.FtoM.upper <- pred.table3.nofup$Ratio.pred

## ----Rfetbrain_nofup, eval = execute.vignette---------------------------------
# pred.table4.nofup <- pred.table1.nofup
# pred.table4.nofup$Uncertainty <- "Fetal Brain Partitioning"
# for (this.cas in maternal.list)
# {
#   p <- parameterize_fetal_pbtk(chem.cas=this.cas,
#       fetal_fup_adjustment=FALSE,
#       suppress.messages=TRUE)
#   Kbrain2pu <- p$Kfbrain2pu
#   fup <- pred.table4.nofup[pred.table4.nofup$CAS==this.cas,"fup"]
#   pred.table4.nofup[pred.table4.nofup$CAS==this.cas,"Ratio.pred"] <- signif(
#      PC.table.nofup[PC.table.nofup$CAS==this.cas,"R.plasma.FtoM"]*
#     Kbrain2pu * fup, 3)
#   PC.table.nofup[PC.table.nofup$CAS==this.cas,"Kbrain2pu"] <- Kbrain2pu
#   PC.table.nofup[PC.table.nofup$CAS==this.cas,"R.brain.FtoM"] <-
#     pred.table4.nofup[pred.table4.nofup$CAS==this.cas,"Ratio.pred"]
# }

## ----Rfetbrain_uncertainty_nofup, eval = execute.vignette---------------------
# 
# pred.table5.nofup <- pred.table1.nofup
# pred.table5.nofup$Uncertainty <- "Brain Partitioning Error (Pearce et al., 2017)"
# for (this.cas in maternal.list)
# {
#   p <- parameterize_fetal_pbtk(chem.cas=this.cas,
#       fetal_fup_adjustment=FALSE,
#       suppress.messages=TRUE)
#   Kbrain2pu <- p$Kfbrain2pu
# 
#   fup <- pred.table5.nofup[pred.table5.nofup$CAS==this.cas,"fup"]
#   sigma.fup <- pred.table5.nofup[pred.table5.nofup$CAS==this.cas,"fup.sigma"]
#   Rmatfet <- 1/PC.table[PC.table.nofup$CAS==this.cas,"R.plasma.FtoM"]
#   Rbrain2matblood <- Kbrain2pu * fup / Rmatfet
# 
# # From Pearce et al. (2017) PC paper:
#   sigma.logKbrain <- 0.647
#   Kbrain2pu.upper <- signif(10^(log10(Kbrain2pu)+1.96*sigma.logKbrain),3)
# 
#   error.Rmatfet <- PC.table.nofup [PC.table.nofup $CAS==this.cas,"RMSE"]
#   sigma.Rbrain2matblood <- Rbrain2matblood *
#     (log(10)^2*sigma.logKbrain^2 +
#     sigma.fup^2/fup^2 +
#     error.Rmatfet^2/Rmatfet^2)^(1/2)
#   Rbrain2matblood.upper <- Rbrain2matblood *
#     (1 + 1.96*(log(10)^2*sigma.logKbrain^2 +
#     sigma.fup^2/fup^2 +
#     error.Rmatfet^2/Rmatfet^2)^(1/2))
#   pred.table5.nofup [pred.table5.nofup $CAS==this.cas,"Ratio.pred"] <-
#     signif(Rbrain2matblood.upper,3)
#   PC.table.nofup [PC.table.nofup $CAS==this.cas,"sigma.logKbrain"] <-
#     signif(sigma.logKbrain, 3)
#   PC.table.nofup [PC.table.nofup $CAS==this.cas,"Kbrain2pu.upper"] <-
#     signif(Kbrain2pu.upper, 3)
#   PC.table.nofup [PC.table.nofup $CAS==this.cas,"sigma.Rbrain2matblood"] <-
#     signif(sigma.Rbrain2matblood, 3)
#   PC.table.nofup [PC.table.nofup $CAS==this.cas,"R.brain.FtoM.upper"] <-
#     pred.table5.nofup [pred.table5.nofup $CAS==this.cas,"Ratio.pred"]
# }

## ----compare_fup_correction_case_study,eval=FALSE-----------------------------
# case.study.fup.correct.table <- merge(PC.table,PC.table.nofup,by=c("Compound","CAS","DTXSID"))
# 
# MFbrainfit.fup <- lm(R.brain.FtoM.upper.x~R.brain.FtoM.upper.y,
#                      data=case.study.fup.correct.table)
# summary(MFbrainfit.fup)
# 
# cat(paste("The predictions for fetal brain to maternal blood ratio with or without the fetal plasma binding correction (Eqn. 1) were strongly correlated (R2 = ",
#   signif(summary(MFbrainfit.fup)$adj.r.square,2),
#   "). There were ",
#   dim(subset(case.study.fup.correct.table,
#              rank(R.brain.FtoM.upper.x) > rank(R.brain.FtoM.upper.y)))[1],
#   " chemicals that were ranked higher with the correction than without, with an average increase of ",
#   signif(mean(
#     case.study.fup.correct.table$R.brain.FtoM.upper.y /
#       case.study.fup.correct.table$R.brain.FtoM.upper.x),2),
#   " times when the plasma binding change was included.\n",
#   sep=""))
# 

## ----fup_table, eval = execute.vignette---------------------------------------
# fup.table <- NULL
# all.chems <- get_cheminfo(
#   model="fetal_pbtk",
#   info="all",
#   suppress.messages=TRUE)
# # Get rid of median fup 0:
# all.chems <- subset(all.chems,
#   as.numeric(unlist(lapply(strsplit(
#     all.chems$Human.Funbound.plasma,","),function(x) x[[1]])))!=0)
# for (this.chem in all.chems[,"CAS"])
# {
#   temp <- parameterize_fetal_pbtk(chem.cas=this.chem,suppress.messages = TRUE)
#   state <- calc_ionization(
#       pH=7.26,
#       pKa_Donor=temp$pKa_Donor,
#       pKa_Accept=temp$pKa_Accept)
#   if (state$fraction_positive > 0.5) this.charge <- "Positive"
#   else if (state$fraction_negative > 0.5) this.charge <- "Negative"
#   else this.charge <- "Neutral"
#   this.row <- data.frame(DTXSID=all.chems[all.chems[,"CAS"]==this.chem,"DTXSID"],
#     Compound=all.chems[all.chems[,"CAS"]==this.chem,"Compound"],
#     CAS=this.chem,
#     Fup.Mat.Pred = temp$Funbound.plasma,
#     Fup.Neo.Pred = temp$Fraction_unbound_plasma_fetus,
#     Charge = this.charge
#     )
#   fup.table <- rbind(fup.table,this.row)
# }
# 
# fup.table[fup.table$Charge=="Positive","Charge"] <- paste("Positive (n=",
#   sum(fup.table$Charge=="Positive"),
#   ")",sep="")
# fup.table[fup.table$Charge=="Negative","Charge"] <- paste("Negative (n=",
#   sum(fup.table$Charge=="Negative"),
#   ")",sep="")
# fup.table[fup.table$Charge=="Neutral","Charge"] <- paste("Neutral (n=",
#   sum(fup.table$Charge=="Neutral"),
#   ")",sep="")

## ----fup_figure, eval = execute.vignette--------------------------------------
# FigA  <- ggplot(data=fup.table) +
#   geom_point(alpha=0.25, aes(
#     x=Fup.Mat.Pred,
#     y=Fup.Neo.Pred,
#     shape=Charge,
#     color=Charge),
#     size=3)   +
#   geom_abline(slope=1, intercept=0) +
#   ylab(expression(paste("Adjusted Neonate ",f[up]))) +
#   xlab(expression(paste(italic("In vitro")," Measured Adult ",f[up]))) +
#    scale_x_log10(label=scientific_10) +
#    scale_y_log10(label=scientific_10) +
#   theme_bw()  +
#   theme( text  = element_text(size=14))
# 
# print(FigA)

## ----MFratio_allhttk_preds, eval = execute.vignette---------------------------
# times <- sort(unique(c(seq(13 * 7, 40 * 7, 0.25),seq(278,280,.1))))
# 
# MFratio.pred <- NULL
# all.chems <- get_cheminfo(
#   model="fetal_pbtk",
#   info=c("Compound","DTXSID","CAS","Funbound.plasma"),
#   suppress.messages=TRUE)
# for (this.cas in all.chems$CAS)
#   if ((this.cas %in% nonvols) &
#     !(this.cas %in% fluoros))
# {
#   this.id <- all.chems[all.chems$CAS==this.cas,"DTXSID"]
#   Fup <- subset(all.chems,DTXSID==this.id)$Human.Funbound.plasma
#   if (regexpr(",",Fup)!=-1)
#   {
#     if (as.numeric(strsplit(Fup,",")[[1]][1])==0 |
#       (as.numeric(strsplit(Fup,",")[[1]][3])>0.9 &
#       as.numeric(strsplit(Fup,",")[[1]][2])<0.1))
#     {
#       skip <- TRUE
#     } else skip <- FALSE
#   } else if (Fup== 0)
#   {
#     skip <- TRUE
#   } else skip <- FALSE
# 
#   if (!skip)
#   {
#     p <- parameterize_fetal_pbtk(dtxsid=this.id,
#     fetal_fup_adjustment =TRUE,
#     suppress.messages=TRUE)
#     out <- solve_fetal_pbtk(
#       parameters=p,
#       dose=0,
#       times=times,
#       daily.dose=1,
#       doses.per.day=3,
#       output.units = "uM",
#       suppress.messages=TRUE)
#     last.row <- which(out[,"time"]>279)
#     last.row <- last.row[!duplicated(out[last.row,"time"])]
#     new.row <- data.frame(
#       Chemical = all.chems[all.chems$DTXSID==this.id,"Compound"],
#       DTXSID = this.id,
#       Mat.pred = mean(out[last.row,"Cplasma"]),
#       Fet.pred = mean(out[last.row,"Cfplasma"]),
#       MFratio.pred = mean(out[last.row,"Cplasma"])/mean(out[last.row,"Cfplasma"])
#       )
#     MFratio.pred <- rbind(MFratio.pred,new.row)
#   }
#   }

## ----MFratio_allhttk_figure, eval = execute.vignette--------------------------
# FigD <- ggplot(data=MFratio.pred)+
#    geom_histogram(binwidth = 0.05,fill="Red",aes(MFratio.pred))+
#   xlab("Maternal:Fetal Plasma Concentration Ratio") +
#   ylab("Number of chemicals")+
#     theme_bw()+
#     theme( text  = element_text(size=14))
# 
# 
# print(FigD)

## ----MFratio_allhttk_stats, eval = execute.vignette---------------------------
# max.chem <- MFratio.pred[which(
#   MFratio.pred$MFratio.pred==max(MFratio.pred$MFratio.pred,na.rm=TRUE)),]
# min.chem <- MFratio.pred[which(
#   MFratio.pred$MFratio.pred==min(MFratio.pred$MFratio.pred,na.rm=TRUE)),]
# cat(paste("In Figure X we examine the ratios predicted for the ",
#   dim(MFratio.pred)[1],
#   " appropriate (non-volatile or PFAS) chemicals with measured HTTK data.\n",
#   sep=""))
# 
# 
# cat(paste("We observe a median ratio of ",
#   signif(median(MFratio.pred$MFratio.pred,na.rm=TRUE),3),
#   ", with values ranging from ",
#   signif(min.chem[,"MFratio.pred"],3),
#   " for ",
#   min.chem[,"DTXSID"],
#   " to ",
#   signif(max.chem[,"MFratio.pred"],3),
#   " for ",
#   max.chem[,"DTXSID"],
#   ".\n",sep=""))
# 
# # Check out phys-chem > 1.6, < 1:
# highratio <- subset(chem.physical_and_invitro.data,DTXSID%in%subset(MFratio.pred,MFratio.pred>1.6)$DTXSID)
# 
# cat(paste("There are",
#   dim(highratio)[1],
#   "chemicals with ratios greater than 1.6, indicating a tendency to have higher concentrations"))
# 
# # all highly bound
# highratio$Compound
# suppressWarnings(apply(highratio,2,function(x) mean(as.numeric(x),na.rm=TRUE)))
# 
# 
# lowratio <- subset(chem.physical_and_invitro.data,DTXSID%in%subset(MFratio.pred,MFratio.pred<0.9)$DTXSID)
# # No obvious pattern

## ----MFratio_allhttk_preds_nofup, eval = execute.vignette---------------------
# times <- sort(unique(c(seq(13 * 7, 40 * 7, 0.25),seq(278,280,.1))))
# 
# MFratio.pred.nofup <- NULL
# all.chems <- get_cheminfo(
#   model="fetal_pbtk",
#   info=c("Compound","DTXSID","CAS","Funbound.plasma"),
#   suppress.messages=TRUE)
# for (this.cas in all.chems$CAS)
#   if ((this.cas %in% nonvols) &
#     !(this.cas %in% fluoros))
# {
#   this.id <- all.chems[all.chems$CAS==this.cas,"DTXSID"]
#   Fup <- subset(all.chems,DTXSID==this.id)$Human.Funbound.plasma
#   if (regexpr(",",Fup)!=-1)
#   {
#     if (as.numeric(strsplit(Fup,",")[[1]][1])==0 |
#       (as.numeric(strsplit(Fup,",")[[1]][3])>0.9 &
#       as.numeric(strsplit(Fup,",")[[1]][2])<0.1))
#     {
#       skip <- TRUE
#     } else skip <- FALSE
#   } else if (Fup== 0)
#   {
#     skip <- TRUE
#   } else skip <- FALSE
# 
#   if (!skip)
#   {
#     p <- parameterize_fetal_pbtk(dtxsid=this.id,
#     fetal_fup_adjustment =FALSE,
#     suppress.messages=TRUE))
#     out <- suppressWarnings(solve_fetal_pbtk(
#       parameters=p,
#       dose=0,
#       times=times,
#       daily.dose=1,
#       doses.per.day=3,
#       output.units = "uM",
#       suppress.messages=TRUE)
#     last.row <- which(out[,"time"]>279)
#     last.row <- last.row[!duplicated(out[last.row,"time"])]
#     new.row <- data.frame(
#       Chemical = all.chems[all.chems$DTXSID==this.id,"Compound"],
#       DTXSID = this.id,
#       Mat.pred = mean(out[last.row,"Cplasma"]),
#       Fet.pred = mean(out[last.row,"Cfplasma"]),
#       MFratio.pred = mean(out[last.row,"Cplasma"])/mean(out[last.row,"Cfplasma"])
#       )
#     MFratio.pred.nofup <- rbind(MFratio.pred.nofup,new.row)
#   }
#   }

## ----MFratio_allhttk_figure_nofup, eval = execute.vignette--------------------
# FigSupD <- ggplot(data=MFratio.pred.nofup)+
#    geom_histogram(binwidth = 0.05,fill="Red",aes(MFratio.pred))+
#   xlab("Maternal:Fetal Plasma Concentration Ratio (No Fup Corr.)") +
#   ylab("Number of chemicals")+
#     theme_bw()+
#     theme( text  = element_text(size=14))
# 
# 
# print(FigSupD)

## ----MFratio_allhttk_stats_nofup, eval = execute.vignette---------------------
# max.chem <- MFratio.pred.nofup[which(
#   MFratio.pred.nofup$MFratio.pred==max(MFratio.pred.nofup$MFratio.pred,na.rm=TRUE)),]
# min.chem <- MFratio.pred.nofup[which(
#   MFratio.pred.nofup$MFratio.pred==min(MFratio.pred.nofup$MFratio.pred,na.rm=TRUE)),]
# cat(paste("In Figure X we examine the ratios predicted for the ",
#   dim(MFratio.pred)[1],
#   " appropriate (non-volatile or PFAS) chemicals with measured HTTK data.\n",
#   sep=""))
# 
# 
# cat(paste("We observe a median ratio of ",
#   signif(median(MFratio.pred.nofup$MFratio.pred,na.rm=TRUE),3),
#   ", with values ranging from ",
#   signif(min.chem[,"MFratio.pred"],3),
#   " for ",
#   min.chem[,"DTXSID"],
#   " to ",
#   signif(max.chem[,"MFratio.pred"],3),
#   " for ",
#   max.chem[,"DTXSID"],
#   ".\n",sep=""))
# 
# # Check out phys-chem > 1.6, < 1:
# highratio <- subset(chem.physical_and_invitro.data,DTXSID%in%subset(MFratio.pred.nofup,MFratio.pred>1.6)$DTXSID)
# 
# cat(paste("There are",
#   dim(highratio)[1],
#   "chemicals with ratios greater than 1.6, indicating a tendency to have higher concentrations"))
# 
# # all highly bound
# highratio$Compound
# suppressWarnings(apply(highratio,2,function(x) mean(as.numeric(x),na.rm=2)))
# 
# 
# lowratio <- subset(chem.physical_and_invitro.data,DTXSID%in%subset(MFratio.pred.nofup,MFratio.pred<0.9)$DTXSID)
# # No obvious pattern

## ----create_distributable_data, eval = execute.vignette-----------------------
# aylward2014 <-MFdata
# pregnonpregaucs <- TKstats
# fetalpcs <- Curley.pcs
# wang2018 <- Wangchems
# 
# save(aylward2014,pregnonpregaucs,fetalpcs,wang2018,pksim.pcs,
#      file="Kapraun2022Vignette.RData",version=2)

## -----------------------------------------------------------------------------
knitr::opts_chunk$set(collapse = TRUE, comment = '#>')
options(rmarkdown.html_vignette.check_title = FALSE)

## ----clear_memory-------------------------------------------------------------
rm(list=ls()) 

## ----runchunks, eval = TRUE---------------------------------------------------
# Set whether or not the following chunks will be executed (run):
execute.vignette <- FALSE

## ----load_packages, eval = execute.vignette-----------------------------------
# #
# #
# # Setup
# #
# #
# library(ggplot2)
# library(httkexamples)
# library(httk)
# library(grid)
# library(scales)
# library(viridis)
# library(ggpubr)
# library(readxl)
# library(knitr)
# 
# LOC.WD <- tempdir() # Replace with permanent folder if desired
# PFAS.MODEL.USED <- "sumclearancespfas"
# NONPFAS.MODEL.USED <- "sumclearances"

## ----fig_properties, eval = execute.vignette----------------------------------
# FONT.SIZE <- 24
# POINT.SIZE <- 4

## ----RMSLE_function, eval = execute.vignette----------------------------------
# RMSLE <- function(tab,colx,coly)
# {
#     return(signif(mean(log10(tab[,colx]/tab[,coly])^2,na.rm=TRUE)^(1/2),3))
# }

## ----withinten_function, eval = execute.vignette------------------------------
# withinten <- function(tab,colx,coly)
# {
#     tab <- subset(tab, !is.na(colx) & !is.na(coly))
#     return(paste0(
#     dim(subset(tab,abs(log10(tab[,colx]/tab[,coly]))<=1))[1],
#     " out of ",
#     dim(tab)[1],
#     " predictions were within a factor of ten of the observations"))
# }

## ----rb2peval, eval = execute.vignette----------------------------------------
# rb2p.table <- subset(httk::chem.physical_and_invitro.data,
#                      Human.Rblood2plasma.Reference %in% "Poothong 2017")
# rb2p.table <- rb2p.table[,colnames(rb2p.table) %in%
#                                      c("Compound","DTXSID",
#                                        "Human.Rblood2plasma"
#                                      )]
# for (this.chem in rb2p.table$DTXSID)
# {
#   if (this.chem %in% get_2023pfasinfo(info="dtxsid", suppress.messages=TRUE,
#                                    model=PFAS.MODEL.USED))
#   {
#     rb2p.table[rb2p.table$DTXSID==this.chem,"HTTK.Rb2p"] <-
#       calc_rblood2plasma(dtxsid=this.chem,
#                          class.exclude=FALSE)
#   }
#   p <- try(parameterize_pfas1comp(dtxsid=this.chem))
#   if(!is(p, "try-error"))
#     rb2p.table[rb2p.table$DTXSID==this.chem,"ML.Rb2p"] <-
#     p$Rblood2plasma
# }
# kable(rb2p.table)

## ----MAeval, eval = execute.vignette------------------------------------------
# logma.table <- subset(chem.physical_and_invitro.data,
#                      logMA.Reference %in% "Droge 2019")
# logma.table <- logma.table[,colnames(logma.table) %in%
#                                      c("Compound","DTXSID",
#                                        "logMA"
#                                      )]
# for (this.chem in logma.table$DTXSID)
# {
#   logma.table[logma.table$DTXSID==this.chem,"HTTK.logMA"] <-
#       signif(log10(calc_ma(dtxsid=this.chem,
#                            pfas.calibration=FALSE,
#                            suppress.messages=TRUE)),3)
# }
# kable(logma.table)

## ----fit_logma, eval = execute.vignette---------------------------------------
# fit.logma <- lm(logMA~HTTK.logMA,data=logma.table)
# summary(fit.logma)
# 
# logma.table$Fit.logMA <- signif(fit.logma$coefficients[1] +
#   fit.logma$coefficients[2]*logma.table$HTTK.logMA,3)

## ----fig_logma, eval = execute.vignette---------------------------------------
# fig.logma  <- ggplot(data=logma.table) +
#   geom_point(aes(
#     x=HTTK.logMA,
#     y=logMA
#     ),
#     size=POINT.SIZE) +
#   geom_abline(slope=1,intercept=0,linetype="dashed")+
#   geom_line(aes(x=HTTK.logMA,
#     y=Fit.logMA), color="red")+
#   ylab("Droge (2019) logMA") +
#   xlab("HTTK log Membrane Affinity") +
#   scale_x_log10(label=label_log())+
#   scale_y_log10(label=label_log())+
#   theme_bw()  +
#   theme( text  = element_text(size=FONT.SIZE))
# 
# print(fig.logma)

## ----plot_clint_fup, eval = execute.vignette----------------------------------
# new.pfas <- get_2023pfasinfo(info="dtxsid",
#                                       model=PFAS.MODEL.USED,
#                                       suppress.messages=TRUE)
# # What chems does sumclearances model work for overall?
# good.chems <- get_cheminfo(info="dtxsid", model = PFAS.MODEL.USED)
# cat(paste("were incorporated from the scientific literature into R package \\“httk\\” for",
#           sum(new.pfas %in% good.chems),
#           "PFAS\n"))
# cat(paste("Out of",
#           length(new.pfas),
#           "PFAS with new in vitro TK data reported,",
#           sum(new.pfas %in% good.chems),
#           "had the Clint, fup, and physicochemical",
#           "property predictions needed to make HTTK predictions.\n"))
# 
# 
# 
# clint.fup <- subset(chem.physical_and_invitro.data,
#                     !is.na(Human.Funbound.plasma) &
#                     !is.na(Human.Clint) &
#                     (regexpr("PFAS",Chemical.Class)==-1 |
#                     DTXSID %in% new.pfas))
# clint.fup$Human.Clint <- sapply(clint.fup$Human.Clint,
#                                 function(x) as.numeric(strsplit(x,",")[[1]][1]))
# clint.fup$Human.Funbound.plasma <- sapply(clint.fup$Human.Funbound.plasma,
#                                 function(x) as.numeric(strsplit(x,",")[[1]][1]))
# clint.fup[clint.fup$Chemical.Class=="","Chemical.Class"] <- "Non-PFAS"
# clint.fup[clint.fup$Chemical.Class=="PFAS","Chemical.Class"] <- "Newly Measured PFAS"
# clint.fup.pfas <- subset(clint.fup,Chemical.Class!="Non-PFAS")
# clint.fup.pfas <- merge(clint.fup.pfas,subset(httk::dawson2023,Species=="Human" &
#                               Sex=="Female" &
#                               DosingAdj=="Oral")[,c("DTXSID","ClassPredFull")],
#       by="DTXSID",all.x=TRUE)
# colnames(clint.fup.pfas)[colnames(clint.fup.pfas)=="ClassPredFull"] <- "ML.Class"
# save(clint.fup,
#      clint.fup.pfas,
#      file=paste0(LOC.WD,"Clint-Fup-Values.RData"))
# write.table(clint.fup.pfas,
#             quote=FALSE,
#             row.names=FALSE,
#             sep="\t",
#             file=paste0(LOC.WD,"PFAS-Clint_Fup.txt"))
# cat(paste("(fraction unbound in plasma) in",
#           sum(!is.na(clint.fup.pfas$Human.Funbound.plasma)),
#           "PFAS\n"))
# cat(paste("(intrinsic hepatocyte clearance) in",
#           sum(!is.na(clint.fup.pfas$Human.Clint)),
#           "PFAS\n"))

## ----clint.fup.figures, eval = execute.vignette-------------------------------
# load(paste0(LOC.WD,"Clint-Fup-Values.RData"))
# fig.clint.fup  <- ggplot(data=clint.fup) +
#   geom_point(aes(
#     x=Human.Funbound.plasma+10^-8,
#     y=Human.Clint+10^-5,
#     colour=Chemical.Class,
#     shape=Chemical.Class),
#     size=POINT.SIZE) +
#   ylab(expression(italic("In Vitro")~"Measured Cl"[int]~"("*mu*"L/min/10"^'6'~"hep.)")) +
#   xlab(expression(italic("In Vitro")~"Measured f"[up])) +
#   scale_x_log10(label=label_log())+
#   scale_y_log10(label=label_log())+
#   theme_bw()  +
#   theme( text  = element_text(size=FONT.SIZE)) +
#         scale_color_viridis(discrete=2)
# 
# print(fig.clint.fup)
# 
# fig.fup.hist <- ggplot(data=clint.fup) +
#   geom_histogram(aes(
#     x=Human.Funbound.plasma+10^-8,
#     colour=Chemical.Class,
#     fill=Chemical.Class)) +
#   xlab(expression(italic("In Vitro")~"Measured f"[up])) +
#   scale_x_log10(label=label_log())+
#   theme_bw()  +
#   theme( text  = element_text(size=FONT.SIZE))+
#         scale_fill_viridis(discrete=2)+
#         scale_color_viridis(discrete=2)
# 
# print(fig.fup.hist)
# 
# fig.clint.hist <- ggplot(data=clint.fup) +
#   geom_histogram(aes(
#     x=Human.Clint+10^-5,
#     colour=Chemical.Class,
#     fill=Chemical.Class)) +
#   xlab(expression(italic("In Vitro")~"Measured Cl"[int]~"("*mu*"L/min/10"^'6'~"hep.)")) +
#   scale_x_log10(label=label_log())+
#   theme_bw()  +
#   theme( text  = element_text(size=FONT.SIZE))+
#         scale_fill_viridis(discrete=2)+
#         scale_color_viridis(discrete=2)+
#   coord_flip()
# 
# print(fig.clint.hist)
# 
# fig.henry.hist <- ggplot(data=clint.fup) +
#   geom_histogram(aes(
#     x=10^logHenry,
#     colour=Chemical.Class,
#     fill=Chemical.Class)) +
#   xlab(expression("Henry's Law Constant (Atm.-m"^"3"*"/mole)")) +
#   scale_x_log10(label=label_log())+
#   geom_vline(xintercept =10^-4.5,linetype="dashed",color="blue")+
#   theme_bw()  +
#   theme( text  = element_text(size=FONT.SIZE))+
#         scale_fill_viridis(discrete=2)+
#         scale_color_viridis(discrete=2)
# 
# print(fig.henry.hist)

## ----multipanelnewclintfupdata, eval = execute.vignette-----------------------
# ggarrange(fig.clint.fup, fig.clint.hist, fig.fup.hist, fig.henry.hist,
#           labels = c("A", "B", "C", "D"),
#           ncol = 2, nrow = 2,
#           common.legend = TRUE, legend = "bottom")
# tiff(file = paste0(LOC.WD,"Fig_NewClintFup.tiff"),
#          height = 5*200, width = 5*200, compression = "lzw")
# ggarrange(fig.clint.fup, fig.clint.hist, fig.fup.hist, fig.henry.hist,
#           labels = c("A", "B", "C", "D"),
#           ncol = 2, nrow = 2,
#           common.legend = TRUE, legend = "bottom")
# dev.off()

## ----calc_Kbloodair, eval = execute.vignette----------------------------------
# pfas.data <- subset(clint.fup,Chemical.Class=="Newly Measured PFAS")
# pfas.data[,"logKblood2air"] <- apply(pfas.data,
#                                      1,
#                                      function(x) try(log10(calc_kair(
#                                        dtxsid=x["DTXSID"],
#                                        suppress.messages=TRUE)$Kblood2air)))

## ----kblood2air_results, eval = execute.vignette------------------------------
# good.Kblood2air <- pfas.data$logKblood2air
# good.logHenry <- pfas.data$logHenry
# good.logHenry <- good.logHenry[!is.na(good.Kblood2air)]
# good.Kblood2air <- good.Kblood2air[!is.na(good.Kblood2air)]
# cat(paste0("Out of ",
#           length(good.logHenry),
#           " PFAS for which the Henry's Law Constant could be predicted, ",
#           signif(sum(good.logHenry >
#                        -4.5)/length(good.logHenry)*100,2),
#           "% were more volatile than acetone.\n"))
# most.volatile <- pfas.data[pfas.data$logKblood2air %in% min(good.Kblood2air),
#                            "Compound"]
# cat(paste0("The most volatile chemical was ", most.volatile,
#           " with a predicted logKblood2air of ", signif(min(good.Kblood2air),3),
#           ".\n"))

## ----removeoldhttk, eval = execute.vignette-----------------------------------
# chem.physical_and_invitro.data$Rat.Clint <- NA
# chem.physical_and_invitro.data$Rat.Funbound.plasma <- NA

## ----load_bioavailability_preds, eval = execute.vignette----------------------
# load_honda2023()

## ----invivoeval, eval = execute.vignette--------------------------------------
# cl.table <- httk::pfas.clearance
# human.ML.table <- subset(httk::dawson2023,
#                          Species=="Human" &
#                          Sex=="Female" &
#                          DosingAdj=="Oral")
# 
# for (this.chem in unique(cl.table$DTXSID))
#   if (this.chem %in% get_2023pfasinfo(info="dtxsid",
#                                       model=PFAS.MODEL.USED,
#                                       suppress.messages=TRUE))
#   {
#     chem.subset <- subset(cl.table, DTXSID==this.chem)
#     for (this.species in unique(cl.table$Species))
#     {
#       httk.normal <- calc_total_clearance(dtxsid=this.chem,
#                                species=this.species,
#                                model=NONPFAS.MODEL.USED,
#                                default.to.human=TRUE,
#                                class.exclude=FALSE,
#                                physchem.exclude=FALSE,
#                                suppress.messages=TRUE)
#       httk.pfas <- calc_total_clearance(dtxsid=this.chem,
#                                species=this.species,
#                                model=PFAS.MODEL.USED,
#                                default.to.human=TRUE,
#                                class.exclude=FALSE,
#                                physchem.exclude=FALSE,
#                                suppress.messages=TRUE)
#       if (any(cl.table$DTXSID==this.chem &
#                cl.table$Species==this.species))
#       {
#         cl.table[cl.table$DTXSID==this.chem &
#                cl.table$Species==this.species,
#                "HTTK.Cltot.Lphpkgbw"] <- httk.normal
#         cl.table[cl.table$DTXSID==this.chem &
#                cl.table$Species==this.species,
#                "HTTKPFAS.Cltot.Lphpkgbw"] <- httk.pfas
#       } else {
#         new.row <- cl.table[1,]
#         new.row[] <- NA
#         new.row[,"DTXSID"] <- this.chem
#         new.row[,"Species"] <- this.species
#         new.row[,"Sex"] <- "Female"
#         new.row[,"HTTK.Cltot.Lphpkgbw"] <- httk.normal
#         new.row[,"HTTKPFAS.Cltot.Lphpkgbw"] <- httk.pfas
#         cl.table <- rbind(cl.table,new.row)
#         new.row[,"Sex"] <- "Male"
#         cl.table <- rbind(cl.table,new.row)
#       }
#     }
#   }
# cat(paste0(dim(cl.table)[1]," rows of in vivo clearance data.\n"))

## ----invivoeval2, eval = execute.vignette-------------------------------------
# outside.doa <- NULL
# for (this.chem in unique(cl.table$DTXSID))
#   {
#     chem.subset <- subset(cl.table, DTXSID==this.chem)
#     for (this.species in unique(cl.table$Species))
#     {
#       p <- try(parameterize_pfas1comp(dtxsid=this.chem,
#                                   species=this.species,
#                                   suppress.messages=TRUE))
#       # Clearance in units of L/h/kgBW
#       if(!is(p, "try-error"))
#       {
#         cl.table[cl.table$DTXSID==this.chem &
#                cl.table$Species==this.species,
#                "MachineLearning.Cltot.Lphpkgbw"] <- p$kelim*p$Vd
#       } else {
#         outside.doa <- c(outside.doa, this.chem)
#       }
# 
#     }
# }
# outside.doa <- unique(outside.doa)
# outside.doa <- subset(chem.physical_and_invitro.data,DTXSID%in%outside.doa)$Compound

## ----invivo_interspecies_eval_scaling, eval = execute.vignette----------------
# cl.table <- as.data.frame(cl.table)
# for (this.sex in c("Female","Male"))
# {
#   human.data <- subset(cl.table, Species=="Human" &
#                             Sex==this.sex)
#   for (this.species in unique(cl.table$Species))
#   if (this.species != "Human")
#   {
#     species.data <- subset(cl.table, Species==this.species &
#                                      Sex==this.sex)
#     for (this.chem in union(human.data$DTXSID, species.data$DTXSID))
#     {
#       cl.table.index <- cl.table$Sex==this.sex &
#                cl.table$Species==this.species &
#                cl.table$DTXSID==this.chem
#       human.table.index <- human.data$Sex==this.sex &
#                human.data$DTXSID==this.chem
#       species.table.index <- species.data$Sex==this.sex &
#                species.data$DTXSID==this.chem
#       if (any(human.table.index) & any(species.table.index))
#       {
#         cl.table[cl.table.index, "TK.Ratio.InVivo"] <-
#         signif(species.data[species.table.index, "ClLphpkgbw"] /
#         human.data[human.table.index, "ClLphpkgbw"], 4)
# 
#         cl.table[cl.table.index, "TK.Ratio.HTTK"] <-
#         signif(species.data[species.table.index, "HTTK.Cltot.Lphpkgbw"] /
#         human.data[human.table.index, "HTTK.Cltot.Lphpkgbw"], 4)
# 
#         cl.table[cl.table.index, "TK.Ratio.ML"] <-
#         signif(species.data[species.table.index, "MachineLearning.Cltot.Lphpkgbw"] /
#         human.data[human.table.index, "MachineLearning.Cltot.Lphpkgbw"], 4)
# 
#         cl.table[cl.table.index, "TK.Ratio.HTTKPFAS"] <-
#         signif(species.data[species.table.index, "HTTKPFAS.Cltot.Lphpkgbw"] /
#         human.data[human.table.index, "HTTKPFAS.Cltot.Lphpkgbw"], 4)
#       }
#     }
#   }
# }
# cat(paste0(dim(cl.table)[1],"rows of in vivo clearance data.\n"))

## ----cl_lit_Data, eval = execute.vignette-------------------------------------
# #huh.data <- as.data.frame(read_excel(paste0(
# #  LOC.WD,"Huh-2011-HumanCL.xlsx")))
# huh.data <- httkexamples::huh2011
# # Huh Data is in ml/min/kg:
# Human.CL.mLpminpkg <- sapply(huh.data[,4],function(x) signif(as.numeric(strsplit(x," ")[[1]][1]),3))
# huh.data$Human.CL.Lphpkg <- signif(Human.CL.mLpminpkg/1000*60, 3)
# huh.data$Rat.CL.Lphpkg <- signif(
#   as.numeric(huh.data$a)*(0.25)^as.numeric(huh.data$b)*60/1000, 3)
# 
# # List of chemicals where we have HTTK data:
# httk.chem.list <- get_cheminfo(model=NONPFAS.MODEL.USED,
#                                info="DTXSID",
#                                suppress.messages = TRUE)
# for (this.chem in sort(unique(huh.data[,"DTXSID"])))
#   if (!is.na(this.chem))
#   {
#     print(this.chem)
#     this.row <- which(huh.data[,"DTXSID"]==this.chem)
#     new.row <- cl.table[1,]
#     new.row[1,] <- NA
#     new.row[1, "DTXSID"] <- huh.data[this.row, "DTXSID"]
#     new.row[1, "Sex"] <- "Female"
#     new.row[1, "ClLphpkgbw"] <- huh.data[this.row, "Human.CL.Lphpkg"]
# 
#     new.row[1, "TK.Ratio.InVivo"] <-
#       huh.data[this.row, "Rat.CL.Lphpkg"] /
#       huh.data[this.row, "Human.CL.Lphpkg"]
#     if (this.chem %in% httk.chem.list)
#     {
#       print("found HTTK data")
#       # Calculate human clearance:
#       HTTK.Human.Cltot.Lphpkgbw <-
#         calc_total_clearance(dtxsid = this.chem,
#                              model=NONPFAS.MODEL.USED,
#                              species="Human",
#                              suppress.messages=TRUE)
#       # Add human row (with NA ratio):
#       new.row[1, "Species"] <- "Human"
#       new.row[1, "HTTK.Cltot.Lphpkgbw"] <- HTTK.Human.Cltot.Lphpkgbw
#       print("added human row")
#       cl.table <- rbind(cl.table,new.row)
#       # Make a row for rat:
#       new.row[1, "Species"] <- "Rat"
#       new.row[1, "ClLphpkgbw"] <- huh.data[this.row, "Rat.CL.Lphpkg"]
#       HTTK.Rat.Cltot.Lphpkgbw <-
#         calc_total_clearance(dtxsid = this.chem,
#                              model=NONPFAS.MODEL.USED,
#                              species="Rat",
#                              default.to.human=TRUE,
#                              suppress.messages=TRUE)
#       new.row[1, "HTTK.Cltot.Lphpkgbw"] <- HTTK.Rat.Cltot.Lphpkgbw
#       new.row[1, "TK.Ratio.HTTK"] <- signif(HTTK.Rat.Cltot.Lphpkgbw /
#                                               HTTK.Human.Cltot.Lphpkgbw, 4)
#       # Add rat row:
#       cl.table <- rbind(cl.table,new.row)
#       print("added rat row")
#     }
#   }
# cat(paste0(dim(cl.table)[1],"rows of in vivo clearance data.\n"))

## ----annotate_chemical_class, eval = execute.vignette-------------------------
# cat(paste0(dim(cl.table)[1],"rows of in vivo clearance data.\n"))
# cl.table$Class <- "PFAS"
# cl.table[!(cl.table$DTXSID %in%
#              subset(chem.physical_and_invitro.data,Chemical.Class=="PFAS")$DTXSID),
#          "Class"] <- "Non-PFAS"
# cl.table$Class <- factor(cl.table$Class, levels=c("PFAS","Non-PFAS"))
# cat(paste("Also in Figure 2 Panel B are clearances based upon",
#   sum(cl.table$Class!="PFAS")/2,
#   "non-PFAS chemicals\n"))
# cl.table <- merge(cl.table,subset(httk::dawson2023,DosingAdj=="Oral")[,
#                     c("DTXSID","Species","Sex","ClassPredFull","ClassModDomain")],
#                   by=c("DTXSID","Species","Sex"),
#                   all.x=TRUE)
# colnames(cl.table)[colnames(cl.table)=="ClassPredFull"] <- "ML.Class"
# save(cl.table, file=paste0(LOC.WD,"InVivo-CL-Table.RData"))
# write.table(cl.table, file=paste0(LOC.WD,"InVivo-CL-Table.txt"),sep="\t",row.names=FALSE,quote = FALSE)
# cat(paste0(dim(cl.table)[1],"rows of in vivo clearance data.\n"))

## ----fit_non_pfas_trend, eval = execute.vignette------------------------------
# load(paste0(LOC.WD,"InVivo-CL-Table.RData"))
# nonpfasratiotrend <- lm(log10(TK.Ratio.InVivo)~log10(TK.Ratio.HTTK),
#                         data=subset(cl.table, Species=="Rat" & Class!="PFAS"))
# summary(nonpfasratiotrend)
# cat(paste0("For typical organic chemicals, HTTK in vitro data combined with ",
#            "species-specific physiological parameters predicts the Rat:Human ",
#            "clearance ratio with a root mean squared log10 error (RMSLE) of ",
#            signif(RMSLE(subset(cl.table,
#                                Species=="Rat" & Class!="PFAS"),
#                         "TK.Ratio.InVivo", "TK.Ratio.HTTK"),2),
#            ".\n"))

## ----fig_clhttk, eval = execute.vignette--------------------------------------
# load(paste0(LOC.WD,"InVivo-CL-Table.RData"))
# fig.clhttk.invivo  <- ggplot(data=subset(cl.table, Class=="PFAS")) +
#   geom_point(aes(
#     x=HTTK.Cltot.Lphpkgbw,
#     y=ClLphpkgbw,
#     color=Species,
#     shape=Sex),
#     size=POINT.SIZE) +
#   geom_abline(slope=1,intercept=0,linetype="dashed")+
# #  geom_line(aes(x=logP,y=logPfit1),color="black") +
# #  geom_line(aes(x=logP,y=logPfit2),color="blue",linetype = "dashed") +
#   ylab("PFAS In Vivo Clearance (L/h/kg bw)") +
#   xlab("Default HTTK Clearance (L/h/kg bw)") +
#   scale_x_log10(label=label_log())+
#   scale_y_log10(label=label_log())+
#    scale_color_viridis(discrete=4)+
#   theme_bw()  +
#   theme( text  = element_text(size=FONT.SIZE))+
#   annotate("text", size=FONT.SIZE/3, x = 10^-4, y = 10^-1,
#            label = paste("RMSLE:",
#                          RMSLE(subset(cl.table, Class=="PFAS"),
#                                "HTTK.Cltot.Lphpkgbw","ClLphpkgbw")))+
#   theme(legend.title = element_text(size = FONT.SIZE/3),
#                legend.text = element_text(size = FONT.SIZE/2))
# 
# print(fig.clhttk.invivo)
# 

## ----fig_ratio_httk, eval = execute.vignette----------------------------------
# load(paste0(LOC.WD,"InVivo-CL-Table.RData"))
# fig.ratio.httk  <- ggplot(data=subset(cl.table, Species=="Rat")) +
#   geom_point(aes(
#     x=TK.Ratio.HTTK,
#     y=TK.Ratio.InVivo,
#     color=Class,
#     shape=Class),
#     size=POINT.SIZE) +
#   geom_abline(slope=1,intercept=0,linetype="dashed")+
# #  geom_line(aes(x=logP,y=logPfit1),color="black") +
# #  geom_line(aes(x=logP,y=logPfit2),color="blue",linetype = "dashed") +
#   ylab("In Vivo Derived Human:Rat Clearance Ratio") +
#   xlab("Default HTTK Clearance Ratio") +
#   scale_x_log10(label=label_log())+
#   scale_y_log10(label=label_log())+
#   theme_bw()  +
#   theme( text  = element_text(size=FONT.SIZE)) +
#   scale_color_viridis(discrete=2)
# 
# print(fig.ratio.httk)
# #  ggsave(paste0(LOC.WD,
# #    "Fig_rat_cl_ratio.tiff"),
# #         height =11, width =12, dpi = 300)

## ----multipanelclearancefigureforpaper, eval = execute.vignette---------------
# ggarrange(fig.clhttk.invivo, fig.ratio.httk,
#           labels = c("A", "B"),
#           ncol = 2, nrow = 1,
#           common.legend = FALSE, legend = "bottom")
# tiff(file = paste0(LOC.WD,"Fig_PFASRatioEval.tiff"),
#          height = 2.5*200, width = 5*200, compression = "lzw")
# ggarrange(fig.clhttk.invivo, fig.ratio.httk,
#           labels = c("A", "B"),
#           ncol = 2, nrow = 1,
#           hjust=-2.5,
#           common.legend = FALSE, legend = "top",
#           font.label=list(size=20))
# dev.off()

## ----summary_table, eval = execute.vignette-----------------------------------
# ratio.table <- data.frame()
# ratio.table["Non-PFAS In Vivo Clearance Ratio","Median"] <-
#   median(subset(cl.table,
#                 Species=="Rat" &
#                   Class != "PFAS")$TK.Ratio.InVivo,na.rm=TRUE)
# ratio.table["Non-PFAS In Vivo Clearance Ratio","Min"] <-
#   min(subset(cl.table,
#                 Species=="Rat" &
#                   Class != "PFAS")$TK.Ratio.InVivo,na.rm=TRUE)
# ratio.table["Non-PFAS In Vivo Clearance Ratio","Max"] <-
#   max(subset(cl.table,
#                 Species=="Rat" &
#                   Class != "PFAS")$TK.Ratio.InVivo,na.rm=TRUE)
# ratio.table["Non-PFAS Default HTTK Clearance Ratio","Median"] <-
#   median(subset(cl.table,
#                 Species=="Rat" &
#                   Class != "PFAS")$TK.Ratio.HTTK, na.rm=TRUE)
# ratio.table["Non-PFAS Default HTTK Clearance Ratio","Min"] <-
#   min(subset(cl.table,
#                 Species=="Rat" &
#                   Class != "PFAS")$TK.Ratio.HTTK, na.rm=TRUE)
# ratio.table["Non-PFAS Default HTTK Clearance Ratio","Max"] <-
#   max(subset(cl.table,
#                 Species=="Rat" &
#                   Class != "PFAS")$TK.Ratio.HTTK, na.rm=TRUE)
# ratio.table["Non-PFAS Default HTTK Clearance Ratio","RMSLE"] <-
#   RMSLE(subset(cl.table,
#                 Species=="Rat" &
#                   Class != "PFAS"),"TK.Ratio.HTTK", "TK.Ratio.InVivo")
# ratio.table["PFAS In Vivo Clearance Ratio","Median"] <-
#   median(subset(cl.table,
#                 Species=="Rat" &
#                   Class == "PFAS")$TK.Ratio.InVivo,na.rm=TRUE)
# ratio.table["PFAS In Vivo Clearance Ratio","Min"] <-
#   min(subset(cl.table,
#                 Species=="Rat" &
#                   Class == "PFAS")$TK.Ratio.InVivo,na.rm=TRUE)
# ratio.table["PFAS In Vivo Clearance Ratio","Max"] <-
#   max(subset(cl.table,
#                 Species=="Rat" &
#                   Class == "PFAS")$TK.Ratio.InVivo, na.rm=TRUE)
# ratio.table["PFAS Default HTTK Clearance Ratio","Median"] <-
#   median(subset(cl.table,
#                 Species=="Rat" &
#                   Class == "PFAS")$TK.Ratio.HTTK, na.rm=TRUE)
# ratio.table["PFAS Default HTTK Clearance Ratio","Min"] <-
#   min(subset(cl.table,
#                 Species=="Rat" &
#                   Class == "PFAS")$TK.Ratio.HTTK, na.rm=TRUE)
# ratio.table["PFAS Default HTTK Clearance Ratio","Max"] <-
#   max(subset(cl.table,
#                 Species=="Rat" &
#                   Class == "PFAS")$TK.Ratio.HTTK, na.rm=TRUE)
# ratio.table["PFAS Default HTTK Clearance Ratio","RMSLE"] <-
#   RMSLE(subset(cl.table,
#                 Species=="Rat" &
#                   Class == "PFAS"), "TK.Ratio.HTTK", "TK.Ratio.InVivo")
# ratio.table <- signif(ratio.table, 2)
# write.table(ratio.table, file=paste0(LOC.WD,"Ratio-Table.txt"),
#             sep="\t")
# kable(ratio.table)
# 
# cat(paste0("RMSLE is much larger for PFAS (",
#            ratio.table["PFAS Default HTTK Clearance Ratio","RMSLE"],
#            " = ",
#            signif(10^ratio.table["PFAS Default HTTK Clearance Ratio","RMSLE"],2),
#            "-fold error) than for non-PFAS chemicals (",
#            ratio.table["Non-PFAS Default HTTK Clearance Ratio","RMSLE"],
#            " = ",
#            signif(10^ratio.table["Non-PFAS Default HTTK Clearance Ratio","RMSLE"],2),
#            "-fold error).\n"))

## ----make_ml_clint_table, eval = execute.vignette-----------------------------
# load(paste0(LOC.WD,"Clint-Fup-Values.RData"))
# clint.fup.pfas[is.na(clint.fup.pfas$Human.Clint.pValue),"Human.Clint.pValue"] <- 0
# ml.clint.table <- data.frame()
# ml.clint.table["Class 1", "Description"] <- "Rapidly Cleared"
# ml.clint.table["Class 2", "Description"] <- "Moderate"
# ml.clint.table["Class 3", "Description"] <- "Slow"
# ml.clint.table["Class 4", "Description"] <- "Very Slow"
# ml.clint.table["Class 1", "Half-Life"] <- "< 12 h"
# ml.clint.table["Class 2", "Half-Life"] <- "< 1 week"
# ml.clint.table["Class 3", "Half-Life"] <- "< 2 months"
# ml.clint.table["Class 4", "Half-Life"] <- "> 2 months"
# ml.clint.table["Class 1", "Number Crizer (2024) Chemicals"] <-
#   dim(subset(clint.fup.pfas,
#              ML.Class==1))[1]
# ml.clint.table["Class 2", "Number Crizer (2024) Chemicals"] <-
#   dim(subset(clint.fup.pfas,
#              ML.Class==2))[1]
# ml.clint.table["Class 3", "Number Crizer (2024) Chemicals"] <-
#   dim(subset(clint.fup.pfas,
#              ML.Class==3))[1]
# ml.clint.table["Class 4", "Number Crizer (2024) Chemicals"] <-
#   dim(subset(clint.fup.pfas,
#              ML.Class==4))[1]
# ml.clint.table["Class 1", "Number Non-Zero Clint"] <-
#   dim(subset(clint.fup.pfas,
#              ML.Class==1 &
#              Human.Clint > 0 &
#              Human.Clint.pValue < 0.05))[1]
# ml.clint.table["Class 2", "Number Non-Zero Clint"] <-
#   dim(subset(clint.fup.pfas,
#              ML.Class==2 &
#              Human.Clint > 0 &
#              Human.Clint.pValue < 0.05))[1]
# ml.clint.table["Class 3", "Number Non-Zero Clint"] <-
#   dim(subset(clint.fup.pfas,
#              ML.Class==3 &
#              Human.Clint > 0 &
#              Human.Clint.pValue < 0.05))[1]
# ml.clint.table["Class 4", "Number Non-Zero Clint"] <-
#   dim(subset(clint.fup.pfas,
#              ML.Class==4 &
#              Human.Clint > 0 &
#              Human.Clint.pValue < 0.05))[1]
# write.table(ml.clint.table, file=paste0(LOC.WD,
#                                         "ML-Clint-table.txt"), sep="\t")
# kable(ml.clint.table)

## ----rat_human_scaling, eval = execute.vignette-------------------------------
# half.lives <- NULL
# for (this.chem in new.pfas)
# {
#   new.row <- data.frame(DTXSID=this.chem,
#                         Human.HL=try(calc_half_life(
#                           dtxsid=this.chem,
#                           species="human",
#                           model="sumclearances",
#                           class.exclude=FALSE,
#                           physchem.exclude=FALSE,
#                           suppress.messages=TRUE)),
#                         Rat.HL=try(calc_half_life(
#                           dtxsid=this.chem,
#                           species="rat",
#                           model="sumclearances",
#                           default.to.human=TRUE,
#                           class.exclude=FALSE,
#                           physchem.exclude=FALSE,
#                           suppress.messages=TRUE)))
#   new.row$Type <- "HTTK"
#   half.lives <- rbind(half.lives, new.row)
#   param.human <- try(parameterize_pfas1comp(dtxsid=this.chem,
#                                   species="human",
#                                   suppress.messages=TRUE))
#   param.rat <- try(parameterize_pfas1comp(dtxsid=this.chem,
#                                   species="rat",
#                                   suppress.messages=TRUE))
#   if ("kelim" %in% names(param.human) &
#       "kelim" %in% names(param.rat))
#     new.row <- data.frame(DTXSID=this.chem,
#                         Human.HL=log(2)/param.human$kelim,
#                         Rat.HL=log(2)/param.rat$kelim)
#   new.row$Type <- "ML"
#   half.lives <- rbind(half.lives, new.row)
# }
# half.lives$Ratio <- half.lives$Human.HL / half.lives$Rat.HL
# save(half.lives,file=paste0(LOC.WD,"All-Half-Lives.RData"))

## ----half_life_fig, eval = execute.vignette-----------------------------------
# load(paste0(LOC.WD,"All-Half-Lives.RData"))
# fig.species.scaling <- ggplot(data=half.lives) +
#   geom_histogram(aes(
#     x=Ratio,
#     colour=Type,
#     fill=Type),
#     bins=10) +
#   xlab(expression(Human:Rat~t[1/2]~Ratio)) +
#   scale_x_log10(label=label_log())+
#   theme_bw()  +
#   theme( text  = element_text(size=FONT.SIZE))+
#         scale_fill_viridis(discrete=2)+
#         scale_color_viridis(discrete=2)
# 
# 
# print(fig.species.scaling)

## ----wallis_2023_halflives, eval = execute.vignette---------------------------
# Dawson.known.human.HLs <- c(
# "DTXSID1037303",
# "DTXSID1037303",
# "DTXSID3031860",
# "DTXSID3031860",
# "DTXSID3031862",
# "DTXSID3031862",
# "DTXSID3031864",
# "DTXSID3031864",
# "DTXSID4059916",
# "DTXSID4059916",
# "DTXSID5030030",
# "DTXSID5030030",
# "DTXSID7040150",
# "DTXSID7040150",
# "DTXSID70880215",
# "DTXSID70880215",
# "DTXSID8031863",
# "DTXSID8031863",
# "DTXSID8031865",
# "DTXSID8031865",
# "DTXSID80892506",
# "DTXSID80892506"
# )
# 
# #wallis <- as.data.frame(read_excel(paste0(LOC.WD,"Wallis-2023-PFASHL.xlsx")))
# wallis <- httkexamples::wallis2023
# wallis$HL.Low <- sapply(wallis[,4],function(x) as.numeric(strsplit(x,", ")[[1]][1]))
# wallis$HL.High <- sapply(wallis[,4],function(x) as.numeric(strsplit(x,", ")[[1]][2]))
# 
# #abraham <- as.data.frame(read_excel(paste0(LOC.WD,"Abraham-2024-PFASHL.xlsx")))
# abraham <- httkexamples::abraham2024
# abraham$HL.Low <- sapply(abraham[,"Halflife.95.d"],function(x) as.numeric(strsplit(x,"–")[[1]][1]))
# abraham$HL.High <- sapply(abraham[,"Halflife.95.d"],function(x) as.numeric(strsplit(x,"–")[[1]][2]))
# abraham$HL.High[is.na(abraham$HL.High)] <- abraham$HL.Low*100
# 
# wallis$Reference <- "Wallis 2023"
# abraham$Reference <- "Abraham 2024"
# 
# human.invivo.hl <- wallis[,c("PREFERRED_NAME","DTXSID","CASRN","Reference","HL.Low","HL.High")]
# human.invivo.hl <- rbind(human.invivo.hl,
#                          abraham[,c("PREFERRED_NAME","DTXSID","CASRN","Reference","HL.Low","HL.High")])
# human.invivo.hl$Status <- "Novel"
# human.invivo.hl[human.invivo.hl$DTXSID %in% Dawson.known.human.HLs, "Status"] <- "Known"
# 
# for (this.chem in human.invivo.hl$DTXSID)
# {
#   param.human <- try(parameterize_pfas1comp(dtxsid=this.chem,
#                                   species="human",
#                                   suppress.messages=TRUE,
#                                   restrict.doa="none"))
#   if ("kelim" %in% names(param.human))
#     human.invivo.hl[human.invivo.hl$DTXSID == this.chem, "HL.ML"] <- log(2)/param.human$kelim/24
# }

## ----results_from_new_model_run, eval = execute.vignette----------------------
# human.invivo.hl[human.invivo.hl$DTXSID=="DTXSID90723993","HL.ML"] <- 29000/24
# human.invivo.hl[human.invivo.hl$DTXSID=="DTXSID50723994","HL.ML"] <- 29000/24
# human.invivo.hl[human.invivo.hl$DTXSID=="DTXSID20892348","HL.ML"] <- 53/24
# for (this.col in c("HL.Low","HL.High","HL.ML"))
# {
#   temp.col <- human.invivo.hl[, this.col]
#   bad.rows <- is.na(temp.col)
#   temp.col[bad.rows] <- -1
#   new.col <- paste0(this.col,".Class")
#     human.invivo.hl[, new.col] <- 4
#   human.invivo.hl[temp.col < 60,
#        new.col] <- 3
#   human.invivo.hl[temp.col < 7,
#        new.col] <- 2
#   human.invivo.hl[temp.col< 0.5,
#        new.col] <- 1
#   human.invivo.hl[bad.rows, new.col] <- NA
# }
# human.invivo.hl$Agree <- human.invivo.hl$HL.Low.Class ==
#                            human.invivo.hl$HL.ML.Class |
#                          human.invivo.hl$HL.High.Class ==
#                            human.invivo.hl$HL.ML.Class
# human.invivo.hl$Underestimate <- human.invivo.hl$HL.High.Class <
#                            human.invivo.hl$HL.ML.Class

## ----human_hl_stats, eval = execute.vignette----------------------------------
# human.invivo.hl$HL.GeoMean <- exp((log(human.invivo.hl$HL.Low)+log(human.invivo.hl$HL.High))/2)
# fit.overall <- lm(log10(HL.GeoMean) ~ log10(HL.ML),
#                   data=human.invivo.hl)
# fit.known <- lm(log10(HL.GeoMean) ~ log10(HL.ML),
#                 data=subset(human.invivo.hl,Status=="Known"))
# fit.novel <- lm(log10(HL.GeoMean) ~log10(HL.ML),
#                 data=subset(human.invivo.hl,Status=="Novel"))
# hl.known <- subset(human.invivo.hl,Status=="Known")
# RMSLE.known <- RMSLE(hl.known,
#                  "HL.GeoMean",
#                  "HL.ML")
# agree.known <- sum(hl.known$Agree)/dim(hl.known)[1]
# under.known <- sum(hl.known$Underestimate)/dim(hl.known)[1]
# hl.novel <- subset(human.invivo.hl,Status=="Novel" & !is.na(HL.ML))
# RMSLE.novel <- RMSLE(hl.novel,
#                  "HL.GeoMean",
#                  "HL.ML")
# agree.novel <- sum(hl.novel$Agree)/dim(hl.novel)[1]
# agree.count.novel <- sum(hl.novel$Agree)
# under.novel <- sum(hl.novel$Underestimate)/dim(hl.known)[1]
# under.count.novel <- sum(hl.novel$Underestimate)
# num.novel.pfas.hl <- dim(hl.novel)[1]
# cat(paste(num.novel.pfas.hl,"novel PFAS human half-lives.\n"))
# save(human.invivo.hl,
#      hl.known,
#      hl.novel,
#      file=paste0(LOC.WD,"Human-Invivo-HL.RData"))

## ----human_hl_eval_fig, eval = execute.vignette-------------------------------
# load(paste0(LOC.WD,"Human-Invivo-HL.RData"))
# set.seed(1234)
# human.invivo.hl$HL.ML.jitter <- human.invivo.hl$HL.ML*(1.0+runif(dim(human.invivo.hl)[1],-0.5,0.5))
# 
# human.invivo.hl.fig <- ggplot(data=human.invivo.hl) +
#   geom_segment(aes(
#     x=HL.ML.jitter,
#     xend=HL.ML.jitter,
#     y=HL.Low,
#     yend=HL.High,
#     colour=Status),
#     linewidth=3,
#     alpha=0.5) +
#   geom_point(aes(
#     x=HL.ML.jitter,
#     y=HL.GeoMean,
#     shape=Reference,
#     colour=Status),
#     size=2) +
#     geom_abline(slope=1,intercept=0,linetype="dashed")+
#   xlab(expression(Machine~Learning~t[1/2]~Prediction))+
#   ylab("In Vivo Measurment") +
#   scale_x_log10(label=label_log())+
#   scale_y_log10(label=label_log())+
#   theme_bw()  +
#   annotate("text", x = 5, y = 10^4, size=6, hjust=0,
#            label = paste("RMSLE for ",
#                          num.novel.pfas.hl,
#                          " novel PFAS: ",
#                          RMSLE.novel,"\n"#,
#                          #agree.count.novel,
#                          #" agree\n",
#                          #under.count.novel,
#                          #" underestimated",
#                          ,sep=""))+
#   theme( text  = element_text(size=FONT.SIZE))+
#         scale_color_viridis(discrete=2)+
#     theme(legend.title = element_text(size = FONT.SIZE/3),
#                legend.text = element_text(size = FONT.SIZE/2))
# 
# print(human.invivo.hl.fig)
# 
# #tiff(file = paste0(LOC.WD,"InVivoComparison.tiff"),
# #     width=9,
# #     height=7,
# #     units="in",
# #     res=300)
# #print(human.invivo.hl.fig)
# #dev.off()
# 
# subset(human.invivo.hl, is.na(HL.ML))

## ----multipanelMLfigureforpaper, eval = execute.vignette----------------------
# ggarrange(fig.species.scaling, human.invivo.hl.fig,
#           labels = c("A", "B"),
#           ncol = 2, nrow = 1,
#           common.legend = FALSE, legend = "bottom")
# tiff(file = paste0(LOC.WD,"Fig_MLModelEval.tiff"),
#          height = 2.5*200, width = 5*200, compression = "lzw")
# ggarrange(fig.species.scaling, human.invivo.hl.fig,
#           labels = c("A", "B"),
#           ncol = 2, nrow = 1,
#           hjust=-2.5,
#           common.legend = FALSE, legend = "top",
#           font.label=list(size=20))
# dev.off()

## ----fig_clml, eval = execute.vignette----------------------------------------
# load(paste0(LOC.WD,"InVivo-CL-Table.RData"))
# fig.clml.invivo  <- ggplot(data=subset(cl.table, Class=="PFAS")) +
#   geom_jitter(aes(
#     x=MachineLearning.Cltot.Lphpkgbw,
#     y=ClLphpkgbw,
#     color=Species,
#     shape=Sex),
#     size=POINT.SIZE,
#     height=0,width=0.1) +
#   geom_abline(slope=1,intercept=0,linetype="dashed")+
# #  geom_line(aes(x=logP,y=logPfit1),color="black") +
# #  geom_line(aes(x=logP,y=logPfit2),color="blue",linetype = "dashed") +
#   ylab("In Vivo Clearance (L/h/kg bw)") +
#   xlab("ML One Comp. Clearance (L/h/kg bw)") +
#   scale_x_log10(label=label_log())+
#   scale_y_log10(label=label_log())+
#    scale_color_viridis(discrete=4)+
#   theme_bw()  +
#   theme( text  = element_text(size=FONT.SIZE))+
#   annotate("text", x = 3*10^-5, y = 10^-1,size=FONT.SIZE/3,
#            label = paste("RMSLE:",
#                          RMSLE(cl.table,
#                                "MachineLearning.Cltot.Lphpkgbw",
#                                "ClLphpkgbw")))
# 
# print(fig.clml.invivo)

## ----fig_ratio_ml, eval = execute.vignette------------------------------------
# load(paste0(LOC.WD,"InVivo-CL-Table.RData"))
# fig.ratio.ml  <- ggplot(data=subset(cl.table, Species!="Human" & Class=="PFAS")) +
#   geom_point(aes(
#     x=TK.Ratio.ML,
#     y=TK.Ratio.InVivo,
#     color=Species,
#     shape=Sex),
#     size=POINT.SIZE) +
#   geom_abline(slope=1,intercept=0,linetype="dashed")+
# #  geom_line(aes(x=logP,y=logPfit1),color="black") +
# #  geom_line(aes(x=logP,y=logPfit2),color="blue",linetype = "dashed") +
#   ylab("In Vivo Observed Clearance Ratio") +
#   xlab("ML One Comp. Predicted Clearance Ratio") +
#   scale_x_log10(label=label_log())+
#   scale_y_log10(label=label_log())+
#    scale_color_viridis(discrete=3)+
#   theme_bw()  +
#   theme( text  = element_text(size=FONT.SIZE))
# 
# print(fig.ratio.ml)
#   ggsave(paste0(LOC.WD,
#     "Fig_ml_cl_ratio.tiff"),
#          height = 11, width = 12, dpi = 300)

## ----fig_clhttkpfas, eval = execute.vignette----------------------------------
# load(paste0(LOC.WD,"InVivo-CL-Table.RData"))
# fig.clhttkpfas.invivo  <- ggplot(data=subset(cl.table, Class=="PFAS")) +
#   geom_point(aes(
#     x=HTTKPFAS.Cltot.Lphpkgbw,
#     y=ClLphpkgbw,
#     color=Species,
#     shape=Sex),
#     size=POINT.SIZE) +
#   geom_abline(slope=1,intercept=0,linetype="dashed")+
# #  geom_line(aes(x=logP,y=logPfit1),color="black") +
# #  geom_line(aes(x=logP,y=logPfit2),color="blue",linetype = "dashed") +
#   ylab("PFAS In Vivo Clearance (L/h/kg bw)") +
#   xlab("HTTK-PFAS Clearance (L/h/kg bw)") +
#   scale_x_log10(label=label_log())+
#   scale_y_log10(label=label_log())+
#    scale_color_viridis(discrete=4)+
#   theme_bw()  +
#   theme( text  = element_text(size=FONT.SIZE))+
#   annotate("text", size=FONT.SIZE/3, x = 10^-6*10, y = 10^-1,
#            label = paste("RMSLE:",
#                          RMSLE(subset(cl.table, Class=="PFAS"),
#                                "HTTKPFAS.Cltot.Lphpkgbw","ClLphpkgbw")))+
#   theme(legend.title = element_text(size = FONT.SIZE/3),
#                legend.text = element_text(size = FONT.SIZE/2))
# 
# print(fig.clhttkpfas.invivo)
# 

## ----multipanelclearancenewmodelfigureforpaper, eval = execute.vignette-------
# multiclerancenewmodel <- ggarrange(fig.clml.invivo+ rremove("ylab") , fig.clhttkpfas.invivo+ rremove("ylab") ,
#           labels = c("A", "B"),
#           ncol = 2, nrow = 1,
#           common.legend = TRUE, legend = "bottom")
# multiclerancenewmodel <- annotate_figure(multiclerancenewmodel ,
#                 left = textGrob(expression(paste("PFAS ",
#                   italic("In Vivo"),
#                   "Clearance (L/h/kg bw)")),
#                                 rot = 90, vjust = 1, gp = gpar(cex = 1.75)),
#                 )
# print(multiclerancenewmodel)
# tiff(file = paste0(LOC.WD,"Fig_PFASClearanceEval.tiff"),
#          height = 2.5*200, width = 5*200, compression = "lzw")
# print(multiclerancenewmodel)
# dev.off()

## ----fig_ratio_httkpfas, eval = execute.vignette------------------------------
# load(paste0(LOC.WD,"InVivo-CL-Table.RData"))
# fig.ratio.httkpfas  <- ggplot(data=subset(cl.table, Species!="Human" & Class=="PFAS")) +
#   geom_point(aes(
#     x=TK.Ratio.HTTKPFAS,
#     y=TK.Ratio.InVivo,
#     color=Species,
#     shape=Sex),
#     size=POINT.SIZE) +
#   geom_abline(slope=1,intercept=0,linetype="dashed")+
# #  geom_line(aes(x=logP,y=logPfit1),color="black") +
# #  geom_line(aes(x=logP,y=logPfit2),color="blue",linetype = "dashed") +
#   ylab(expression(paste(italic("In Vivo"),
#     "Observed Clearance Ratio"))) +
#   xlab("HTTK-PFAS Predicted Clearance Ratio") +
#   scale_x_log10(label=label_log())+
#   scale_y_log10(label=label_log())+
#   scale_color_viridis(discrete=3)+
#   annotate("text", size=FONT.SIZE/3, x = 5*10^2, y = 3,
#            label = paste("RMSLE:",
#                          RMSLE(subset(cl.table, Species!="Human" & Class=="PFAS"),
#                                "TK.Ratio.HTTKPFAS","TK.Ratio.InVivo")))+
#   theme_bw()  +
#   theme( text  = element_text(size=FONT.SIZE))
# 
# print(fig.ratio.httkpfas)
#   ggsave(paste0(LOC.WD,
#     "Fig_httkpfas_cl_ratio.tiff"),
#          height = 5*1.5, width = 6*1.5, dpi = 300)

## ----MakeSupTableChange, eval = execute.vignette------------------------------
# pfas.httk.table <- get_2023pfasinfo(info="all")
# for (this.chem in pfas.httk.table$DTXSID)
# {
#   this.row <- pfas.httk.table$DTXSID==this.chem
#   pfas.httk.table[this.row, "Css.HTTK.Classic"] <- try(calc_analytic_css(
#                                                 dtxsid=this.chem,
#                                                 class.exclude=FALSE,
#                                                 physchem.exclude=FALSE,
#                                                 suppress.messages=TRUE,
#                                                 model="3compartmentss"))
#   pfas.httk.table[this.row, "Css.HTTK.Exhale"] <- try(calc_analytic_css(
#                                                 dtxsid=this.chem,
#                                                 class.exclude=FALSE,
#                                                 suppress.messages=TRUE,
#                                                 model="sumclearances"))
#   pfas.httk.table[this.row, "Css.HTTK.PFAS"] <- try(calc_analytic_css(
#                                                 dtxsid=this.chem,
#                                                 suppress.messages=TRUE,
#                                                 model="sumclearancespfas"))
#   pfas.httk.table[this.row, "Css.ML"] <- try(calc_analytic_css(
#                                                 dtxsid=this.chem,
#                                                 suppress.messages=TRUE,
#                                                 model="pfas1compartment"))
#     fractions <- try(calc_clearance_frac(dtxsid=this.chem,
#                                        model="sumclearancespfas",
#                                        suppress.messages=TRUE,
#                                       fraction.params = c("Clint",
#                                                           "Qgfrc",
#                                                           "Qalvc")))
#   if (!is(fractions, "try-error"))
#   {
#     pfas.httk.table[this.row, "Frac.Metabolism"] <- fractions[["Clint"]]
#     pfas.httk.table[this.row, "Frac.Glomerular"] <- fractions[["Qgfrc"]]
#     pfas.httk.table[this.row, "Frac.Exhalation"] <- fractions[["Qalvc"]]
#   }
# }
# pfas.httk.table$Css.HTTK.Classic <- as.numeric(pfas.httk.table$Css.HTTK.Classic)
# pfas.httk.table$Css.HTTK.Exhale <- as.numeric(pfas.httk.table$Css.HTTK.Exhale)
# pfas.httk.table$Css.HTTK.PFAS <- as.numeric(pfas.httk.table$Css.HTTK.PFAS)
# pfas.httk.table$Css.ML <- as.numeric(pfas.httk.table$Css.ML)
# pfas.httk.table$Css.Exhale.FoldChange <-
#   signif(pfas.httk.table$Css.HTTK.Exhale/pfas.httk.table$Css.HTTK.Classic, 3)
# pfas.httk.table$Css.PFAS.FoldChange <-
#   signif(pfas.httk.table$Css.HTTK.PFAS/pfas.httk.table$Css.HTTK.Classic, 3)
# pfas.httk.table <-
#   merge(pfas.httk.table,subset(httk::dawson2023,
#                                Species=="Human" &
#                                Sex=="Female" &
#                                DosingAdj=="Oral")[
#   ,c("DTXSID","ClassPredFull")],by="DTXSID",all.x=TRUE)
# colnames(pfas.httk.table)[colnames(pfas.httk.table)=="ClassPredFull"] <- "ML.Class"
# pfas.httk.table$InVitroMetabolism <- "No"
# clint.pvalue <- pfas.httk.table$Human.Clint.pValue
# clint.pvalue[is.na(clint.pvalue)] <- 0
# pfas.httk.table[pfas.httk.table$Human.Clint > 0 &
#                 clint.pvalue < 0.05,
#                 "InVitroMetabolism"] <- "Yes"
# 
# 
# write.table(pfas.httk.table,
#           row.names=FALSE,
#           quote=FALSE,
#           sep="\t",
#           file=paste(LOC.WD,"new-pfas-css-uM.txt",sep=""))
# save(pfas.httk.table,file=paste0(LOC.WD,"PFAS-Css-Table.RData"))

## ----cssfigpanela, eval = execute.vignette------------------------------------
# load(paste0(LOC.WD,"PFAS-Css-Table.RData"))
# pfas.httk.table$ML.Class <- as.factor(pfas.httk.table$ML.Class)
# fig.css.httk  <- ggplot(data=subset(pfas.httk.table,!is.na(ML.Class))) +
#   geom_point(aes(
#     x=Css.HTTK.Classic,
#     y=Css.HTTK.PFAS,
#     shape=InVitroMetabolism,
#     color=ML.Class
#     ),
#     size=POINT.SIZE) +
#   geom_abline(slope=1,intercept=0,linetype="dashed")+
#   geom_abline(slope=1,intercept=1,linetype="dotted", color="blue")+
#   geom_abline(slope=1,intercept=-1,linetype="dotted", color="blue") +
#   ylab(expression(paste("HTTK-PFAS",
#                          ~C[ss],
#                          " (",
#                          mu,
#                          "M)"))) +
#   xlab(expression(paste("Default HTTK",
#                          ~C[ss],
#                          " (",
#                          mu,
#                          "M)"))) +
#   scale_x_log10(limits=c(10^-2,10^6),label=label_log())+
#   scale_y_log10(limits=c(10^-2,10^6),label=label_log())+
#   theme_bw()  +
#   theme( text  = element_text(size=FONT.SIZE)) +
#   scale_color_viridis(discrete=3)+
#   guides(color=guide_legend(title="ML Halflife Class"),
#          shape=guide_legend(title="In Vitro Metabolism"))
# 
# print(fig.css.httk)
# #  ggsave(paste0(LOC.WD,
# #    "Fig_httkpfas_cl_ratio.tiff"),
# #         height = 11, width = 12, dpi = 300)

## ----cssfigpanelb, eval = execute.vignette------------------------------------
# load(paste0(LOC.WD,"PFAS-Css-Table.RData"))
# pfas.httk.table$ML.Class <- as.factor(pfas.httk.table$ML.Class)
# fig.css.ml  <- ggplot(data=subset(pfas.httk.table,!is.na(ML.Class))) +
#   geom_point(aes(
#     x=Css.ML,
#     y=Css.HTTK.PFAS,
#     shape=InVitroMetabolism,
#     color=ML.Class
#     ),
#     size=POINT.SIZE) +
#   geom_abline(slope=1,intercept=0,linetype="dashed")+
#   geom_abline(slope=1,intercept=1,linetype="dotted", color="blue")+
#   geom_abline(slope=1,intercept=-1,linetype="dotted", color="blue") +
#   ylab(expression(paste("HTTK-PFAS",
#                          ~C[ss],
#                          " (",
#                          mu,
#                          "M)"))) +
#   xlab(expression(paste("ML One Comp.",
#                          ~C[ss],
#                          " (",
#                          mu,
#                          "M)"))) +
#   scale_x_log10(limits=c(10^-2,10^6),label=label_log())+
#   scale_y_log10(limits=c(10^-2,10^6),label=label_log())+
#   theme_bw()  +
#   theme( text  = element_text(size=FONT.SIZE)) +
#   scale_color_viridis(discrete=3)+
#   guides(color=guide_legend(title="ML Halflife Class"),
#          shape=guide_legend(title="In Vitro Metabolism"))
# 
# print(fig.css.ml)
# #  ggsave(paste0(LOC.WD,
# #    "Fig_httkpfas_cl_ratio.tiff"),
# #         height = 11, width = 12, dpi = 300)

## ----multipanelcssfigureforpaper, eval = execute.vignette---------------------
# multipanelcss <- ggarrange(fig.css.httk + rremove("ylab") ,
#                                    fig.css.ml + rremove("ylab") ,
#           labels = c("A", "B"),
#           ncol = 2, nrow = 1,
#           common.legend = TRUE, legend = "bottom")
# multipanelcss <- annotate_figure(multipanelcss,
#                 left = textGrob(expression(paste("HTTK-PFAS",
#                          ~C[ss],
#                          " (",
#                          mu,
#                          "M)")),
#                 rot = 90,
#                 vjust = 1,
#                 gp = gpar(cex = 1.75)),
#                 )
# print(multipanelcss)
# tiff(file = paste0(LOC.WD,"Fig_Css.tiff"),
#          height = 2.5*200, width = 5*200, compression = "lzw")
# print(multipanelcss)
# dev.off()

## ----text_for_paper, eval = execute.vignette----------------------------------
# cat("\nAbstract\n")
# cat(paste0("For typical organic chemicals, HTTK in vitro data combined with ",
#            "species-specific physiological parameters predicts the Rat:Human ",
#            "clearance ratio with a root mean squared log10 error (RMSLE) of ",
#            signif(RMSLE(subset(cl.table,
#                                Species=="Rat" & Class!="PFAS"),
#                         "TK.Ratio.InVivo", "TK.Ratio.HTTK"),2),
#            ".\n"))
# cat("\n")
# cat(paste0("With this and other modifications, HTTK methods for PFAS achieve ",
#            "improved prediction of interspecies clearance ratios, with an ",
#            "RMSLE of ",
#            signif(RMSLE(subset(cl.table, Species!="Human" & Class=="PFAS"),
#                         "TK.Ratio.HTTKPFAS","TK.Ratio.InVivo"),2),
#            ".\n"))
# 
# cat("\nResults: 3.2\n")
# cat(paste0("RMSLE is much larger for PFAS (",
#            ratio.table["PFAS Default HTTK Clearance Ratio","RMSLE"],
#            " = ",
#            signif(10^ratio.table["PFAS Default HTTK Clearance Ratio","RMSLE"],2),
#            "-fold error) than for non-PFAS chemicals (",
#            ratio.table["Non-PFAS Default HTTK Clearance Ratio","RMSLE"],
#            " = ",
#            signif(10^ratio.table["Non-PFAS Default HTTK Clearance Ratio","RMSLE"],2),
#            "-fold error).\n"))
# 
# cat(paste0("HTTK-based predictions of clearance have a root mean squared log10 error of ",
# RMSLE(subset(cl.table, Class=="PFAS"),
#                                "HTTK.Cltot.Lphpkgbw","ClLphpkgbw"),
# " meaning that they are accurate to within a factor of ",
# signif(10^RMSLE(subset(cl.table, Class=="PFAS"),
#                                "HTTK.Cltot.Lphpkgbw","ClLphpkgbw"),
#        2),
# " on average. "))
# cat(paste0(withinten(subset(cl.table, Class=="PFAS"),
#                                "HTTK.Cltot.Lphpkgbw","ClLphpkgbw"),
#            ".\n"))
# 
# cat("\nResults: 3.3\n")
# cat(paste0("The ML model performs well on the ",
#            num.novel.pfas.hl,
#            " novel chemicals, with a RMSLE of ",
#            RMSLE(hl.novel,
#                  "HL.GeoMean",
#                  "HL.ML"),
#            ".\n"))
# cat(paste0(withinten(hl.novel,
#                  "HL.GeoMean",
#                  "HL.ML"),
#            ".\n"))
# 
# cat("\n")
# cat(paste0("As shown in panel A of Figure 4, this model does well (RMSLE ",
#            RMSLE(cl.table,
#                  "MachineLearning.Cltot.Lphpkgbw",
#                  "ClLphpkgbw"),
#            ") at reproducing the data on which it was essentially trained.\n"))
# cat(paste0(withinten(subset(cl.table, Class=="PFAS"),
#                  "MachineLearning.Cltot.Lphpkgbw",
#                  "ClLphpkgbw"),
#            ".\n"))
# 
# cat("\nResults: 3.4\n")
# cat(paste0("The overall RMSLE is ",
#            RMSLE(subset(cl.table, Class=="PFAS"),
#                  "HTTKPFAS.Cltot.Lphpkgbw",
#                  "ClLphpkgbw"),
#            ".\n"))
# cat(paste0(withinten(subset(cl.table, Class=="PFAS"),
#                  "HTTKPFAS.Cltot.Lphpkgbw",
#                  "ClLphpkgbw"),
#            ".\n"))
# cat("\n")
# cat(paste0("HTTK-PFAS clearance ratios are improved, in contrast to Figure 2, with an RMSLE of ",
#            RMSLE(subset(cl.table, Species!="Human" & Class=="PFAS"),
#                  "TK.Ratio.HTTKPFAS","TK.Ratio.InVivo"),
#            ".\n"))
# cat(paste0(withinten(subset(cl.table, Species!="Human" & Class=="PFAS"),
#                         "TK.Ratio.HTTKPFAS","TK.Ratio.InVivo"),
#            ".\n"))

## ----firstpass, eval = execute.vignette---------------------------------------
# firstpass.table <- NULL
# for (this.chem in get_2023pfasinfo(info="dtxsid", suppress.messages=TRUE,
#                                    model=PFAS.MODEL.USED))
# {
#       params <- parameterize_sumclearances(dtxsid=this.chem,
#                                          suppress.messages=TRUE,
#                                          class.exclude=FALSE)
#       params2 <- parameterize_schmitt(dtxsid=this.chem,
#                                       suppress.messages=TRUE,
#                                       class.exclude=FALSE)
#       ion <- calc_ionization(
#         pH=7.4,
#         pKa_Donor=params2[["pKa_Donor"]],
#         pKa_Accept=params2[["pKa_Accept"]])
#       fraction_neutral <- ion$fraction_neutral
#       if (fraction_neutral < 0.5) params[['Rblood2plasma']] <- 0.5
#       else params[['Rblood2plasma']] <- 20
#   params[["Clmetabolismc"]] <- calc_hep_clearance(parameters=params,
#           hepatic.model='unscaled',
#           suppress.messages=TRUE)#L/h/kg body weight
#   this.row <- data.frame(DTXSID=this.chem,
#                          Fsystemic=calc_hep_bioavailability(
#                            parameters=params)
#   )
#   firstpass.table <- rbind(firstpass.table, this.row)
# }

## ----firstpass_fig, eval = execute.vignette-----------------------------------
# fig.firstpass  <- ggplot(data=firstpass.table) +
#   geom_histogram(aes(
#     x=Fsystemic),bins=10) +
#   ylab("Number of Chemicals") +
#   xlab("Fraction Systemically Available") +
#   theme_bw()  +
#   theme( text  = element_text(size=FONT.SIZE))
# 
# print(fig.firstpass)

## ----fig_clspecies_invivo, eval = execute.vignette----------------------------
# fig.clspecies.invivo  <- ggplot(data=cl.table) +
#   geom_point(aes(
#     x=Species,
#     y=ClLphpkgbw,
#     color=Species,
#     shape=Sex),
#     size=POINT.SIZE) +
#   geom_line(aes(x=Species,
#               y=ClLphpkgbw,
#               group = DTXSID)) +
# #  geom_line(aes(x=logP,y=logPfit1),color="black") +
# #  geom_line(aes(x=logP,y=logPfit2),color="blue",linetype = "dashed") +
#   ylab("In Vivo Clearance (L/h/kg bw)") +
#   xlab("Species") +
#   scale_y_log10(label=label_log())+
#   theme_bw()  +
#   theme( text  = element_text(size=FONT.SIZE))
# 
# print(fig.clspecies.invivo)

## ----fig_clspecies_httk, eval = execute.vignette------------------------------
# fig.clspecies.httk  <- ggplot(data=cl.table) +
#   geom_point(aes(
#     x=Species,
#     y=HTTK.Cltot.Lphpkgbw,
#     color=Species,
#     shape=Sex),
#     size=POINT.SIZE) +
# #  geom_segment(color="#69b3a2",
# #                  aes(
# #                    x=Species,
# #                    y=HTTK.Cltot.Lphpkgbw,
# #                    xend = c(tail(Species, n = -1), NA),
# #                    yend = c(tail(HTTK.Cltot.Lphpkgbw, n = -1), NA)
# #                  ))+
# geom_line(aes(x=Species,
#               y=HTTK.Cltot.Lphpkgbw,
#               group = DTXSID)) +
# ylab("HTTK Clearance (L/h/kg bw)") +
#   xlab("Species") +
#   scale_y_log10(label=label_log())+
#   theme_bw()  +
#   theme( text  = element_text(size=FONT.SIZE))
# 
# print(fig.clspecies.httk)

## ----clearance_fraction, eval = execute.vignette------------------------------
# FigClearanceFrac1<- ggplot(data=pfas.httk.table)+
#    geom_histogram(binwidth = 0.1,alpha=1,fill="Red",aes(Frac.Metabolism))+
#   xlab(" ") +
#   ylab(" ")+
#   ggtitle("Hepatic Metabolism")+
#   scale_x_continuous(limits=c(-.05,1.05))+
#   scale_y_log10(limits=c(0.1,100))
# FigClearanceFrac2<- ggplot(data=pfas.httk.table)+
#    geom_histogram(binwidth = 0.1,alpha=1,fill="Blue",aes(Frac.Glomerular))+
#   xlab(" ") +
#   ylab("Number of chemicals")+
#   ggtitle("Glomerular Filtration")+
#   scale_x_continuous(limits=c(-.05,1.05))+
#   scale_y_log10(limits=c(0.1,100))
# FigClearanceFrac3<- ggplot(data=pfas.httk.table)+
#    geom_histogram(binwidth = 0.1,alpha=1,fill="Green",aes(Frac.Exhalation))+
#   xlab("Fraction of Total Clearance") +
#   ylab(" ")+
#   ggtitle("Exhalation")+
#   scale_x_continuous(limits=c(-.05,1.05))+
#   scale_y_log10(limits=c(0.1,100))
# ggarrange(FigClearanceFrac1, FigClearanceFrac2, FigClearanceFrac3,
#           ncol = 1, nrow = 3,
#           common.legend = TRUE, legend = "right")
# tiff(file = paste0(LOC.WD,"Fig_FracClearance.tiff"),
#          height = 3*100, width = 5*100, compression = "lzw")
# ggarrange(FigClearanceFrac1, FigClearanceFrac2, FigClearanceFrac3,
#           ncol = 1, nrow = 3,
#           common.legend = TRUE, legend = "right")
# dev.off()

## ----two_panel_Css_histogram, eval = execute.vignette-------------------------
# Fig.Cssa <- ggplot(data=pfas.httk.table)+
#   geom_histogram(binwidth = 0.01,aes(Css.Exhale.FoldChange))+
#   xlab("Css Fold Change Due to Exhalation")
# Fig.Cssb <- ggplot(data=pfas.httk.table)+
#   geom_histogram(binwidth = 10,aes(Css.PFAS.FoldChange))+
#   xlab("Css Fold Change Due to PFAS Resorption")
# ggarrange(Fig.Cssa, Fig.Cssb,
#           labels = c("A", "B"),
#           ncol = 2, nrow = 1,
#           common.legend = TRUE, legend = "bottom")
# tiff(file = paste0(LOC.WD,"Fig_CssFoldChange.tiff"),
#          height = 3*100, width = 5*100, compression = "lzw")
# ggarrange(Fig.Cssa, Fig.Cssb,
#           labels = c("A", "B"),
#           ncol = 2, nrow = 1,
#           common.legend = TRUE, legend = "top")
# dev.off()

## ----configure-knitr, include = FALSE-----------------------------------------
knitr::opts_chunk$set(collapse = TRUE, comment = '#>')
options(rmarkdown.html_vignette.check_title = FALSE)

## ----clear-memory, eval = TRUE------------------------------------------------
rm(list = ls())

## -----------------------------------------------------------------------------
execute.vignette <- FALSE

## ----invitro-data, eval = execute.vignette------------------------------------
# ac50.dt <- httk::thyroid.ac50s
# 

## ----libraries, message = FALSE, eval = execute.vignette----------------------
# library(httk)
# library(data.table)
# library(dplyr)
# library(openxlsx)
# library(ggpubr)
# library(cowplot)
# library(ggrepel)
# library(latex2exp)
# library(viridis)
# library(scales)
# library(ggstar)

## ----exp-TK-chems, warning = FALSE, eval = execute.vignette-------------------
# # how many chems had experimental TK params?
# human.data.pre <- subset(get_cheminfo(info = 'all', species = 'Human',
#                                       model = '3compartmentss'),
#                          DTXSID %in% ac50.dt$dsstox_substance_id)
# 
# nrow(human.data.pre)
# 

## ----insilico-preds, message=FALSE, warning=FALSE, eval = execute.vignette----
# # predict Clint/fup values for missing chems
# # this loads new chem.physical_and_invitro.data table into the global env
# load_dawson2021() # most data for ToxCast chems
# load_sipes2017() # most data for pharma compounds
# load_pradeep2020() # best ML method for in silico prediction
# 

## ----missing-chems, warning = FALSE, eval = execute.vignette------------------
# human.httk.dt <- subset(ac50.dt, dsstox_substance_id %in% get_cheminfo(info = 'DTXSID',
#                                                                        species = 'Human',
#                                                                        model = '3compartmentss',
#                                                                        physchem.exclude = FALSE,
#                                                                        median.only = TRUE))
# 
# missing.dtxsids <- setdiff(ac50.dt$dsstox_substance_id, human.httk.dt$dsstox_substance_id)
# 
# View(ac50.dt[dsstox_substance_id %in% missing.dtxsids])
# 

## ----3compss-aeds, warning = FALSE, message = FALSE, eval = execute.vignette----
# 
# for (i in 1:nrow(human.httk.dt)) {
# 
#   message('Calculating for chemical: ', human.httk.dt$chnm[i], '\n')
#   set.seed(123)
#   out <- calc_mc_css(dtxsid = human.httk.dt$dsstox_substance_id[i],
#                      species = 'Human',
#                      daily.dose = 1,
#                      which.quantile = c(0.5, 0.95),
#                      model = '3compartmentss',
#                      output.units = 'uM',
#                      parameterize.args.list=list(physchem.exclude=FALSE),
#                      suppress.messages = TRUE)
# 
#   human.httk.dt$mc.css50[i] <- out["50%"]
# 
#   set.seed(123)
#   oralequiv.out <- calc_mc_oral_equiv(conc = human.httk.dt$min_ac50[i],
#                                       dtxsid = human.httk.dt$dsstox_substance_id[i],
#                                       species = 'Human',
#                                       which.quantile = c(0.5, 0.95),
#                                       input.units = 'uM',
#                                       output.units = 'mgpkgpday',
#                                       model = '3compartmentss',
#                                       restrictive.clearance = TRUE,
#                                       parameterize.args.list=list(physchem.exclude=FALSE),
#                                       suppress.messages = TRUE)
# 
#    human.httk.dt$oral_equiv50[i] <- oralequiv.out["50%"]
# }
# 
# human.httk.dt[, calc.aed50 := min_ac50/mc.css50]
# human.httk.dt[, fold_diff50 := log10(oral_equiv50/calc.aed50)]
# 

## ----seem3, eval = execute.vignette-------------------------------------------
# 
# # let's use the aed values from the division
# human.httk.dt2 <- human.httk.dt[, c('dsstox_substance_id', 'chnm',
#                                     'DIO1', 'DIO2', 'DIO3', 'IYD', 'min_ac50',
#                                     'mc.css50', 'calc.aed50')]
# 
# SEEM <- httk::truong25.seem3
# 
# # integrate SEEM3 predictions with merge
# human.httk.dt2.seem3 <- merge.data.table(human.httk.dt2,
#                                          SEEM[, c("dsstox_substance_id", "seem3", "seem3.u95")],
#                                          by = c("dsstox_substance_id"),
#                                          all.x = TRUE)
# 
# human.httk.dt2.seem3[, plasmaBER50 := calc.aed50/seem3.u95]
# human.httk.dt2.seem3[, log.pBER50 := log10(plasmaBER50)]
# 
# ivive.moe.tb <- human.httk.dt2.seem3
# setnames(ivive.moe.tb, "dsstox_substance_id", "dtxsid")
# 

## ----half-lives, warning = FALSE, eval = execute.vignette---------------------
# for (i in 1:nrow(ivive.moe.tb)) {
#   ivive.moe.tb$half.life[i] <- calc_half_life(dtxsid = ivive.moe.tb$dtxsid[i], # t1/2 in hours
#                                               physchem.exclude = FALSE)
#   ivive.moe.tb$half.life.days[i] <- ivive.moe.tb$half.life[i]/24 # in days
# }
# 

## ----fullpreg-sim, message = FALSE, warning = FALSE, eval = execute.vignette----
# 
# # tissues where DIO enzymes live
# impacted_tissues <- c('Cliver', 'Cthyroid', 'Cfliver', 'Cfbrain', 'Cfthyroid',
#                       'Cplacenta', 'Cconceptus', 'Cplasma')
# targets <- c('DIO1', 'DIO2', 'DIO3', 'IYD')
# 
# # max conc in every tissue for every chemical
# Cmax.tissues <- data.frame(matrix(NA, ncol = length(impacted_tissues) + 1,
#                                   nrow = nrow(ivive.moe.tb),
#                                   dimnames = list(NULL, c('dtxsid', impacted_tissues))))
# 
# for(i in 1:nrow(ivive.moe.tb)) {
# 
#   sol.out <- solve_full_pregnancy(dtxsid = ivive.moe.tb$dtxsid[i],
#                             daily.dose = 1,
#                             doses.per.day = 1,
#                             time.course = seq(0, 40*7, 1/24), # view solution by hour
#                             track.vars = impacted_tissues,
#                             physchem.exclude = FALSE)
# 
# 
#   # get max of every column re: compt
#   Cmax.tissues[i, impacted_tissues] <- apply(sol.out[, impacted_tissues], 2, max, na.rm = T)
#   Cmax.tissues[i, 'dtxsid'] <- ivive.moe.tb$dtxsid[i]
# 
# }
# 

## ----preg-aeds, eval = execute.vignette---------------------------------------
# tissue.aeds <- list()
# 
# # tissues specific for each target
# tissue_list <- list(DIO1 = c('Cliver', 'Cfliver', 'Cthyroid', 'Cfthyroid', 'Cconceptus'),
#                     DIO2 = c('Cthyroid', 'Cfthyroid', 'Cfbrain', 'Cconceptus'),
#                     DIO3 = c('Cthyroid', 'Cfthyroid', 'Cfbrain', 'Cplacenta', 'Cconceptus'),
#                     IYD = c('Cthyroid', 'Cfthyroid', 'Cconceptus'))
# 
# for (i in names(tissue_list)) {
#   active.chem.ind <- which(!is.na(ivive.moe.tb[, ..i]))
#   n.chems <- length(active.chem.ind)
# 
#   empty.mat <- matrix(NA, nrow = n.chems, ncol = length(tissue_list[[i]]) + 1)
#   df.target <- data.frame(empty.mat)
#   colnames(df.target) <- c('dtxsid', tissue_list[[i]])
# 
#   df.target[, 2: (length(tissue_list[[i]])+1) ] <- mapply(function(x,y) x/y, ivive.moe.tb[active.chem.ind, ..i], Cmax.tissues[active.chem.ind, tissue_list[[i]]])
# 
#   df.target$dtxsid <- ivive.moe.tb$dtxsid[active.chem.ind]
#   tissue.aeds[[i]] <- df.target
# }
# 

## ----fig9-wrangling, eval = execute.vignette----------------------------------
# impacted_tissues <- c('Cliver', 'Cthyroid', 'Cfliver', 'Cfbrain', 'Cfthyroid',
#                       'Cplacenta', 'Cconceptus', 'Cplasma')
# 
# get_ber_data <- function(name, df) {
# 
#   df$exposure <- ivive.moe.tb$seem3.u95[match(df$dtxsid, ivive.moe.tb$dtxsid)]
#   df.m <- df %>% select(-exposure) %>%
#     reshape2::melt(id.vars = c('dtxsid'),
#                    variable.name = 'compt', value.name = 'aed')
#   df.m$exposure <- ivive.moe.tb$seem3.u95[match(df.m$dtxsid, ivive.moe.tb$dtxsid)]
#   df.m$ber = df.m$aed/df.m$exposure
#   df.m2 <- df.m %>%
#     select(-exposure) %>%
#     reshape2::melt(id.vars = c('dtxsid', 'compt', 'ber'))
# 
#   # add melted ExpoCast data as rows for each unique chem
#   expocast.dat <- df %>% select(dtxsid, exposure) %>%
#     reshape2::melt(id.vars = c('dtxsid'))
# 
#   df.m2 <- bind_rows(df.m2, expocast.dat)
#   df.m2$value <- log10(df.m2$value)
#   df.m2$ber <- log10(df.m2$ber)
#   df.m2$chnm <- ivive.moe.tb$chnm[match(df.m2$dtxsid, ivive.moe.tb$dtxsid)]
#   df.m2$enzyme <- name
#   return(df.m2)
# }
# 
# new.list <- Map(get_ber_data, names(tissue.aeds), tissue.aeds)
# ggdata = bind_rows(new.list)
# setDT(ggdata)
# 
# # order chemicals within each enzyme group by the most sensitive tissue/lifestage BER
# ggdata[, min_ber := min(ber, na.rm = TRUE), keyby = .(enzyme, dtxsid)]
# ggdata <- ggdata[order(min_ber), .SD, keyby = .(enzyme)]
# 
# # exposure values are dependent on dtxsid not httk compt
# ggdata[variable == 'exposure', compt := 'exposure']
# 
# # make a deep copy or else it will be modified by reference
# tissue.bers <- copy(ggdata)
# 
# # round all numerical values including BERs to 2 sigfigs
# num.cols <- c("value", "ber", "min_ber")
# tissue.bers[, c(num.cols) := lapply(.SD, signif, digits = 2), .SDcols = num.cols]
# 

## ----fig9-plt, eval = execute.vignette----------------------------------------
# min_val <- tissue.bers[min_ber <= 3, min(value), by = enzyme][, min(V1)]
# max_val <- tissue.bers[min_ber <= 3, max(value), by = enzyme][, max(V1)]
# ylims <- c(min_val, max_val)
# 
# # generate a set of 3 viridis colors for lifestage
# # yellow represents neither maternal or fetal, i.e., conceptus
# my_viridis_colors <- viridis(n = 3)
# 
# listgg <- list()
# for(k in names(tissue.aeds)) {
# 
#   aeds <- tissue.bers[enzyme == k & ber <= 3]
#   chems <- tissue.bers[enzyme == k & ber <= 3, dtxsid]
#   exposures <- tissue.bers[enzyme == k & variable == "exposure" & dtxsid %in% chems]
# 
#   listgg[[k]] <- ggplot(data = rbind(aeds,exposures),
#                         mapping = aes(x = reorder(chnm, -min_ber),
#                                       y = value)) +
#     geom_star(aes(starshape = compt, fill = compt, color = compt),
#               alpha = 0.65, size = 1.25, # default: 1.5
#               starstroke = 0.25, # default: 0.5
#               show.legend = T) +
#     scale_y_continuous(breaks = seq(ylims[1], ylims[2], 1),
#                        limits = ylims) +
#     scale_starshape_manual(name = "Compartment corresponding to AED \n or Exposure",
#                        labels = c("maternal liver", "fetal liver",
#                                   "maternal thyroid", "fetal thyroid",
#                                   "conceptus",
#                                   "fetal brain",
#                                   "placenta", "exposure"),
#                        values = c('Cfbrain' = 15,
#                                   'exposure' = 28,
#                                   'Cliver' = 11,
#                                   'Cfliver' = 11,
#                                   'Cplacenta' = 13,
#                                   'Cthyroid' = 1,
#                                   'Cfthyroid' = 1,
#                                   'Cconceptus' = 23),
#                        drop = F) + # this makes sure all levels of a factor are displayed even if unused
#     scale_fill_manual(name = "Compartment corresponding to AED \n or Exposure",
#                        labels = c("maternal liver", "fetal liver",
#                                   "maternal thyroid", "fetal thyroid",
#                                   "conceptus",
#                                   "fetal brain",
#                                   "placenta", "exposure"),
#                        values = c('Cfbrain' = my_viridis_colors[2],
#                                   'exposure' = 'dimgrey',
#                                   'Cliver' = my_viridis_colors[1],
#                                   'Cfliver' = my_viridis_colors[2],
#                                   'Cplacenta' = '#990066',
#                                   'Cthyroid' = my_viridis_colors[1],
#                                   'Cfthyroid' = my_viridis_colors[2],
#                                   'Cconceptus' = '#73D055FF'),
#                        drop = F) +
#      scale_color_manual(name = "Compartment corresponding to AED \n or Exposure",
#                        labels = c("maternal liver", "fetal liver",
#                                   "maternal thyroid", "fetal thyroid",
#                                   "conceptus",
#                                   "fetal brain",
#                                   "placenta", "exposure"),
#                        values = c('Cfbrain' = my_viridis_colors[2],
#                                   'exposure' = 'dimgrey',
#                                   'Cliver' = my_viridis_colors[1],
#                                   'Cfliver' = my_viridis_colors[2],
#                                   'Cplacenta' = '#990066',
#                                   'Cthyroid' = my_viridis_colors[1],
#                                   'Cfthyroid' = my_viridis_colors[2],
#                                   'Cconceptus' = '#73D055FF'),
#                        drop = F) +
#     labs(x = 'Chemical', y = 'Oral AED or Exposure (log10 mg/kg-bw/day)', title = k) +
#     theme_bw() +
#     theme(legend.position = "none",
#           plot.title = element_text(size = 8, face = "bold"),
#           plot.margin = unit(c(0.1,0.1,0.1,0.1), "cm"),
#           axis.title = element_text(size = 6),
#           axis.text.y = element_text(size = 5),
#           axis.text.x = element_text(size = 6),
#           legend.text = element_text(size = 6),
#           legend.title = element_text(size = 6, hjust = 0.5))+
#     coord_flip()
# }
# 
# # remove extra axis labels
# listgg$IYD <- listgg$IYD + labs(x = '', y = '')
# listgg$DIO3 <- listgg$DIO3 +
#   labs(x = '')
# listgg$DIO1 <- listgg$DIO1 + labs(y = '')
# 
# # arrange DIO1 and DIO2 with equal sizes since they have ~20 chems each (21 vs 24)
# pcol1 <- plot_grid(listgg$DIO1, listgg$DIO2,
#                   align = "hv", nrow = 2,
#                   rel_heights = c(1,1.1))
# 
# # make DIO3 3x taller than IYD (44 chems vs 4)
# pcol2 <- plot_grid(listgg$IYD, listgg$DIO3,
#                    align = "hv", nrow = 2,
#                    rel_heights = c(1,3))
# 
# # combine two columns of plots
# prow <- plot_grid(pcol1, pcol2,
#                     align = "h", ncol = 2,
#                     rel_widths = c(1,1))
# 
# # extract legend from one of the plots
# grobs <- ggplotGrob(
#   listgg$DIO2 +
#   guides(
#     starshape = guide_legend(ncol = 2, byrow = F,
#                              keyheight = unit(0.25, "cm")),
#     fill = guide_legend(ncol = 2, byrow = F,
#                         keyheight = unit(0.25, "cm")),
#     color = guide_legend(ncol = 2, byrow = F,
#                          keyheight = unit(0.25, "cm")),
#   ) +
#   theme(legend.position = "bottom")
#   )$grobs
# legend2 <- grobs[[which(sapply(grobs, function(x) x$name) == "guide-box")]]
# 
# # add the legend underneath the plots; make it 10% of the height of the combined plots
# fig9 <- plot_grid(prow, legend2,
#           nrow = 2, rel_heights = c(0.88,0.12)) +
#    theme(plot.background = element_rect(fill = "white", color = "white"))
# 
# # ggsave(plot = fig9,
# #        units = "mm",
# #        dpi = 300,
# #        width = 190, height = 150,
# #        device = "png",
# #        filename = "./figures/preg_prioritization_by_BER.png")
# 

## ----table-8, warning = FALSE, eval = execute.vignette------------------------
# targets <- c('DIO1', 'DIO2', 'DIO3', 'IYD')
# 
# # DATA WRANGLING
# tissue.bers[min_ber == ber, most_sensitive_tissue := compt]
# 
# # table matching order of chemicals in enzyme subplots with all calculated BERs
# # every enzyme x chem x min BER constitutes a row
# minber.by.chem <- tissue.bers[!is.na(most_sensitive_tissue),
#                        .(chnm, min_ber, most_sensitive_tissue), by = .(enzyme, dtxsid)]
# 
# # check if there are multiple most-sensitive tissues per chem in each enzyme group
# minber.by.chem[, if(.N > 1) .SD, by = .(enzyme, dtxsid)][, length(unique(dtxsid))] #70 chems
# 
# # collapse multiple most-sensitive tissues per chem in each enzyme group
# min.ber.reduced <- minber.by.chem[, most_sensitive_compts := paste(most_sensitive_tissue, collapse = ", "), by = .(enzyme, dtxsid)][, .(chnm, min_ber, most_sensitive_compts), by = .(enzyme, dtxsid)]
# min.ber.reduced <- unique(min.ber.reduced)
# 
# # min BER matrix
# min.ber.mat <- data.table::dcast(min.ber.reduced[, 1:4],
#                      dtxsid + chnm ~ enzyme, value.var = c('min_ber'))
# min.ber.mat[, min_across_enzyme := pmin(DIO1, DIO2, DIO3, IYD, na.rm = T)]
# min.ber.mat <- min.ber.mat[order(min_across_enzyme)]
# 
# # find the target corresponding to the min_across_enzyme
# min.ber.mat[, enzyme := mapply(function(x) targets[x], apply(min.ber.mat[, targets, with = FALSE], 1, which.min))]
# 
# # merge data on most sensitive tissues reflecting min BER
# new.ranking.tissues <- merge.data.table(min.ber.mat,
#                                  minber.by.chem[, .(dtxsid, chnm, enzyme, min_ber, most_sensitive_tissue)],
#                                  by = c('dtxsid', 'chnm', 'enzyme'),
#                                  all.x = TRUE)
# setnames(new.ranking.tissues, old = 'enzyme', new = 'target_min')
# 
# # round all BERs to 2 sigfigs for easy table viewing
# ranked.by.plasma <- ivive.moe.tb[, lmoe50 := signif(log.pBER50, digits = 2)][order(lmoe50)]
# 
# final.new.ranking <- new.ranking.tissues[, -c("target_min", "min_ber")]
# final.new.ranking <- final.new.ranking[order(min_across_enzyme)]
# 
# # comparing tissue BERs from full preg model with plasma BERs from 3compss model
# plasma.tissue.bers <- merge.data.table(ranked.by.plasma[, c('dtxsid', 'chnm', 'lmoe50')],
#                            final.new.ranking[, -c('chnm')],
#                            by = c('dtxsid'))
# 
# setnames(plasma.tissue.bers, old = colnames(plasma.tissue.bers)[3:8],
#          new = c('plasma_BER50', 'DIO1_BER', 'DIO2_BER', 'DIO3_BER', 'IYD_BER', 'min_BER'))
# 
# plasma.tissue.bers <- plasma.tissue.bers[order(min_BER)]
# 

## ----fig10, eval = execute.vignette-------------------------------------------
# # merge min BER with plasma BER for each chem with unique row for each chem
# # ignoring multiple sensitive tissues
# ber.comp <- merge.data.table(ranked.by.plasma[, c('dtxsid', 'chnm', 'lmoe50')],
#                              min.ber.mat[, -c("chnm")],
#                              by = c("dtxsid"))
# 
# setnames(ber.comp, old = colnames(ber.comp)[3:8],
#          new = c('plasma_BER50', 'DIO1_BER', 'DIO2_BER', 'DIO3_BER', 'IYD_BER', 'min_BER'))
# 
# max_ber <- max(ber.comp[, c('plasma_BER50', 'min_BER')], na.rm = T)
# min_ber <- min(ber.comp[, c('plasma_BER50', 'min_BER')], na.rm = T)
# ber.lims <- c(floor(min_ber), ceiling(max_ber))
# 
# # chems with labels
# chem.labels <- ber.comp[min_BER < 0][order(min_BER)][1:6, chnm]
# 
# # theme for the next 2 figures
# my_theme <- theme_bw() +
#   theme(axis.title = element_text(size = 8, face = "bold"),
#         axis.text = element_text(size = 7))
# 
# preg.vs.nonpreg.pp <- ggplot(data = ber.comp, aes(x = plasma_BER50, y = min_BER)) +
#   geom_point(alpha = 0.75, size = 1,
#              show.legend = T) +
#   geom_abline(slope = 1, linewidth = 0.5, linetype = 'solid', color = "#666666") +
#   geom_abline(aes(slope = 1, intercept = 1), linetype = 'longdash', color = 'grey', linewidth = 0.5) + # default linesize = 1
#   geom_abline(aes(slope = 1, intercept = -1), linetype = 'longdash', color = 'grey', linewidth = 0.5) +
#   geom_label_repel(aes(label = chnm),
#                    data = ber.comp[chnm %in% chem.labels],
#                    max.overlaps = Inf,
#                    force = 50,
#                    size = 2,
#                    label.padding = 0.1,
#                    label.size = 0.1,
#                    label.r = 0.08,
#                    segment.size = 0.2,
#                    min.segment.length = 0) +
#   my_theme +
#   scale_x_continuous(breaks = seq(ber.lims[1], ber.lims[2], 1),
#                      limits = ber.lims) +
#   scale_y_continuous(breaks = seq(ber.lims[1], ber.lims[2], 1),
#                      limits = ber.lims) +
#   labs(x = 'plasma BER using 3compss model', y = 'min BER across DIO/IYD targets and tissues')
# 
# # how many chems to the right of y = x?
# ber.comp[plasma_BER50 > min_BER, .N] #89 chems
# 
# # plot SEEM3 uncertainty
# ivive.moe.tb$uncertainty = log10(ivive.moe.tb$seem3.u95/ivive.moe.tb$seem3)
# ber.comp$uncertainty <- ivive.moe.tb$uncertainty[match(ber.comp$dtxsid, ivive.moe.tb$dtxsid)]
# 
# min.min.ber <- min(ber.comp$min_BER)
# max.min.ber <- max(ber.comp$min_BER)
# min.ber.lims <- c(floor(min.min.ber), ceiling(max.min.ber))
# max.uncertainty <- max(ber.comp$uncertainty)
# 
# seem3pp <- ggplot(data = ber.comp,
#        mapping = aes(x = min_BER,
#                      y = uncertainty)) +
#   geom_point(size = 1, alpha = 0.8) +
#   geom_label_repel(aes(label = chnm),
#                    data = subset(ber.comp, chnm %in% chem.labels),
#                    max.overlaps = Inf,
#                    force = 75,
#                    size = 2,
#                    label.padding = 0.1,
#                    label.size = 0.1,
#                    label.r = 0.08,
#                    segment.size = 0.2,
#                    min.segment.length = 0) +
#   my_theme +
#   scale_x_continuous(breaks = seq(min.ber.lims[1], min.ber.lims[2], 1),
#                      limits = min.ber.lims) +
#   scale_y_continuous(breaks = seq(0, ceiling(max.uncertainty), 1),
#                      limits = c(0, ceiling(max.uncertainty))) +
#   labs(x = 'min BER by Chemical', y = TeX(r'($log_{10}ExpoCast_{u95} - log_{10}ExpoCast_{med}$)'))
# 
# median(ber.comp$min_BER)
# #> [1] 2.9
# 
# fig10 <- plot_grid(preg.vs.nonpreg.pp, seem3pp,
#           labels = "AUTO", label_size = 10)
# 
# # ggsave(plot = fig10,
# #        units = "mm",
# #        dpi = 300,
# #        width = 190, height = 100,
# #        device = "png",
# #        filename = "./figures/BER_uncertainty.png")
# 

## ----create_distributable_data, eval = FALSE----------------------------------
# thyroid.ac50s <- ac50.dt
# truong25.seem3 <- SEEM
# 
# save(thyroid.ac50s, truong25.seem3,
#      file="./httk/Truong2025Vignette.RData")

## ----knitrPrep, include=FALSE, eval = TRUE------------------------------------
knitr::opts_chunk$set(echo = TRUE, fig.width=5, fig.height=4)

## ----clear_memory, eval = TRUE------------------------------------------------
rm(list=ls()) 

## ----runchunks, eval = TRUE---------------------------------------------------
# Set whether or not the following chunks will be executed (run):
execute.vignette <- FALSE

## ----load_libraries, eval=execute.vignette------------------------------------
# library(httk)
# library(gdata)
# library(ggplot2)
# library(viridis)
# library(censReg)
# library(gmodels)
# library(gplots)
# library(scales)
# library(colorspace)
# library(gridExtra)

## ----setuppctable, eval=execute.vignette--------------------------------------
# pc.table <- NULL
# pc.data <- subset(pc.data,fu != 0 & Exp_PC != 0 & Tissue %in% c("Adipose","Bone","Brain","Gut",
#     "Heart","Kidney","Liver","Lung","Muscle","Skin","Spleen","Blood Cells") &
#     tolower(Species) == 'rat' & !CAS %in% c('10457-90-6','5786-21-0','17617-23-1','69-23-8','2898-12-6',
#     '57562-99-9','59-99-4','2955-38-6','155-97-5','41903-57-5','58-55-9','77-32-7','59-05-2','60-54-8'))
# cas.list <- get_cheminfo(model='schmitt',species='rat',suppress.messages=TRUE)
# cas.list <-  cas.list[cas.list %in% pc.data[,'CAS']]
# ma.data.list <- subset(chem.physical_and_invitro.data,!is.na(logMA))[,'CAS']
# for(this.cas in cas.list){
#   parameters <- parameterize_schmitt(
#     chem.cas=this.cas,
#     species='rat',
#     suppress.messages=TRUE)
#   init.parameters <- parameters
#   charge <- calc_ionization(
#     chem.cas=this.cas,
#     pH=7.4)$fraction_charged
#   if(!this.cas %in% ma.data.list){
#     init.parameters$MA <- 10^(0.999831 - 0.016578*38.7 + 0.881721 * log10(parameters$Pow))
#   }
#   pcs <- predict_partitioning_schmitt(
#     parameters=parameters,
#     species='rat',
#     regression=FALSE,
#     suppress.messages=TRUE
#     )
#   init.pcs <- predict_partitioning_schmitt(
#     parameters=init.parameters,
#     species='rat',
#     regression=FALSE,
#     suppress.messages=TRUE)
#   for(this.tissue in subset(pc.data,CAS==this.cas)[,'Tissue']){
#     if(this.tissue == 'Blood Cells') this.pc <- 'rbc'
#     else this.pc <- this.tissue
#         pc.table <- rbind(pc.table,
#                       cbind(
#                         as.data.frame(this.cas),
#                         as.data.frame(this.tissue),
#                         as.data.frame(log10(
#                           init.pcs[[which(substr(names(init.pcs),
#                             2,
#                             nchar(names(init.pcs))-3) ==
#                             tolower(this.pc))]] *
#                           init.parameters$Funbound.plasma)),
#                         as.data.frame(log10(
#                           pcs[[which(substr(names(pcs),
#                             2,
#                             nchar(names(pcs))-3) ==
#                             tolower(this.pc))]] *
#                           parameters$unadjusted.Funbound.plasma)),
#                         as.data.frame(log10(
#                           init.pcs[[which(substr(names(init.pcs),
#                             2,
#                             nchar(names(init.pcs))-3) ==
#                             tolower(this.pc))]] *
#                           init.parameters$unadjusted.Funbound.plasma)),
#                         as.data.frame(log10(
#                           pcs[[which(substr(names(pcs),
#                             2,
#                             nchar(names(pcs))-3) == tolower(this.pc))]] *
#                             parameters$Funbound.plasma)),
#                         as.data.frame(log10(
#                           subset(pc.data,
#                             CAS==this.cas & Tissue==this.tissue)[,'Exp_PC'])),
#                         as.data.frame(subset(pc.data,
#                           CAS==this.cas & Tissue==this.tissue)[,'LogP']),
#                         as.data.frame(charge),
#                         as.data.frame(as.character(subset(pc.data,
#                           CAS == this.cas)[1,'A.B.N'])),
#                         as.data.frame(subset(pc.data,
#                           CAS == this.cas)[1,'fu'])))
#   }
# }
# colnames(pc.table) <- c('CAS','Tissue',
#                         'fup.correction',
#                         'ma.correction',
#                         'init.Predicted',
#                         'Predicted',
#                         'Experimental',
#                         'logP',
#                         'charge',
#                         'type',
#                         'fup')
# init.error <- pc.table[,'Experimental'] - pc.table[,'init.Predicted']
# fup.error <- pc.table[,'Experimental'] - pc.table[,'fup.correction']
# ma.error <- pc.table[,'Experimental'] - pc.table[,'ma.correction']
# final.error <- pc.table[,'Experimental'] - pc.table[,'Predicted']
# fup.improvement <- abs(init.error) - abs(fup.error)
# ma.improvement <- abs(init.error) - abs(ma.error)
# final.improvement <- abs(init.error) - abs(final.error)
# pc.table <- cbind(pc.table,fup.improvement,ma.improvement, final.improvement,
#                   final.error,init.error,ma.error,fup.error)

## ----KpFigures, eval=execute.vignette-----------------------------------------
# init.plot <- ggplot() +
#   geom_point(data=pc.table,aes(10^(init.Predicted),10^(Experimental))) +
#   geom_abline() +
#   labs(y=expression(paste("Measured ",K[p])),
#        x=expression(paste("Predicted ",K[p]))) +
#   theme(axis.text=element_text(size=16),axis.title=element_text(size=16),
#     plot.title=element_text(size=18,hjust = 0.5)) +
#   scale_x_log10(label=label_log(),limits=c(0.01,10^4.5)) +
#   scale_y_log10(label=label_log(),limits=c(0.01,10^4.5)) +
#   ggtitle('(A)')
# print(init.plot)
# init.stats <- summary(lm(Experimental ~ init.Predicted,
#                          data=pc.table))
# 
# final.plot <- ggplot() +
#   geom_point(data=pc.table,aes(10^(Predicted),10^(Experimental))) +
#   geom_abline() +
#   labs(y=expression(paste("Measured ",K[p])),
#        x=expression(paste("Predicted ",K[p]))) +
#   theme(axis.text=element_text(size=16),axis.title=element_text(size=16),
#     plot.title=element_text(size=18,hjust=0.5)) +
#   scale_x_log10(label=label_log(),limits=c(0.01,10^4.5)) +
#   scale_y_log10(label=label_log(),limits=c(0.01,10^4.5)) +
#   ggtitle('(B)')
# print(final.plot)
# final.stats <- summary(lm(Experimental ~ Predicted,
#                           data=pc.table))
# 
# fup.change.plot <-  ggplot() +
#   geom_point(data=pc.table[order(pc.table[,'fup.improvement'],decreasing=F),],
#     aes(10^(fup.correction),10^(Experimental),color=fup.improvement)) +
#   geom_abline() +
#   labs(y=expression(paste("Measured ",K[p])),
#        x=expression(paste("Predicted ",K[p])),color='Improvement') +
#   theme(axis.text=element_text(size=16),axis.title=element_text(size=16)) +
#   scale_x_log10(label=label_log(),limits=c(0.01,10^4.5)) +
#   scale_y_log10(label=label_log(),limits=c(0.01,10^4.5)) +
#   scale_color_viridis(direction=-1,option='inferno')
# print(fup.change.plot)
# fup.stats <- summary(lm(Experimental ~ fup.correction,
#                      data=pc.table))
# 
# ma.subset <- subset(pc.table,!CAS %in% ma.data.list)
# ma.change.plot <- ggplot() +
#     geom_point(data=ma.subset[order(ma.subset[,'ma.improvement']
#       ,decreasing=F),],
#       aes(10^(ma.correction),10^(Experimental),color=ma.improvement)) +
#     geom_abline() +
#     labs(y=expression(paste("Measured ",K[p])),
#       x=expression(paste("Predicted ",K[p])),color='Improvement') +
#     theme(axis.text=element_text(size=16),axis.title=element_text(size=16)) +
#     scale_x_log10(label=label_log(),limits=c(0.01,10^4.5)) +
#     scale_y_log10(label=label_log(),limits=c(0.01,10^4.5)) +
#     scale_color_viridis(direction=-1,option='inferno')
# print(ma.change.plot)
# ma.stats <- summary(lm(Experimental ~ ma.correction,
#                     data=ma.subset))
# 
# fup.table <- data.frame(Test=c("Initial Tissue PC Accuracy","Fup Lipid Correction","Membrane Affinity","Final"),
#                            RSquared = signif(c(init.stats$adj.r.squared,
#                                          fup.stats$adj.r.squared,
#                                          ma.stats$adj.r.squared,
#                                          final.stats$adj.r.squared),3),
#                            RMSLE = signif(c(mean(init.stats$residuals^2,na.rm=TRUE)^(1/2),
#                                      mean(fup.stats$residuals^2,na.rm=TRUE)^(1/2),
#                                      mean(ma.stats$residuals^2,na.rm=TRUE)^(1/2),
#                                      mean(final.stats$residuals^2,na.rm=TRUE)^(1/2)),3)
#                           )
# knitr::kable(fup.table)

## ----performPCregressions, eval=execute.vignette------------------------------
# regressions <- NULL
# 
# for(tissue in as.character(unique(pc.table[,'Tissue']))){
#   fit <- lm(Experimental ~ Predicted ,data=subset(pc.table,Tissue==tissue))
#   smry <- summary(fit)
#   est <- estimable(fit, cm=diag(2), beta0=c(0,1), joint.test=TRUE)
#   regressions <- rbind(regressions,cbind(tissue,as.data.frame(fit$coefficients[['(Intercept)']]),
#       as.data.frame(fit$coefficients[['Predicted']]),
#       as.data.frame(smry$coefficients[['Predicted','Pr(>|t|)']]),
#       as.data.frame(smry$sigma),as.data.frame(smry$r.squared),
#       as.data.frame(smry[[11]][1,1]),as.data.frame(smry[[11]][2,2]),
#       as.data.frame(smry[[11]][1,2]),as.data.frame(smry$df[2]),as.data.frame(est[[3]])))
# }
# colnames(regressions) <- c('Tissue','Intercept','Slope','P-value','SE','R-squared',
#                            'Int Var','Slp Var','Cov','df','estimable')
# 
# for (this.col in 2:10) regressions[,this.col] <- signif(regressions[,this.col], 3)
# regressions <- regressions[order(regressions[,1]),]
# 
# knitr::kable(regressions, caption = "Table 1: The regressions for each tissue, after fup and membrane affinity adjustments, of the log10-transformed measured Kp regressed on
# predicted Kp")
# 
# write.table(regressions,
#             file=paste0("Pearce2017PCCalibration=",Sys.Date(),".txt"),
#             sep="/t",
#             row.names=FALSE)

## ----PCRegressionFigure, eval=execute.vignette--------------------------------
# x.cf <- seq(-2,3.5,.01)
# for(tissue in  as.character(unique(pc.table[,'Tissue'])))
# {
#   conf <- qt(0.975,df=subset(regressions,Tissue==tissue)[['df']]+1) *
#       subset(regressions,Tissue==tissue)[['SE']] *
#       sqrt(subset(regressions,Tissue==tissue)[['Int Var']] +
#       x.cf^2 * subset(regressions,Tissue==tissue)[['Slp Var']] +
#       2 * x.cf * subset(regressions,Tissue==tissue)[['Cov']] + 1)
#   line <- subset(regressions,Tissue==tissue)[['Intercept']] +
#       x.cf * subset(regressions,Tissue==tissue)[['Slope']]
#   y.cf <- line + conf
#   y.ncf <- line - conf
# 
#   cf <- cbind(as.data.frame(x.cf),as.data.frame(y.cf),as.data.frame(y.ncf))
#   if(tissue == 'Blood Cells'){
#     eval(parse(text= paste('Blood <- ggplot() +
#                                geom_abline(linetype = "dashed") +
#                                geom_point(data=subset(pc.table,Tissue == \'',tissue,'\'),aes(10^(Predicted),
#                                10^(Experimental)))  +  theme(axis.text=element_text(size=14),
#                                axis.title=element_text(size=14),plot.title=element_text(size=14)) +
#                                scale_x_log10(label=label_log(),limits=c(0.01,1000)) +
#                                scale_y_log10(label=label_log(),limits=c(0.01,1000)) +
#                                ylab(ifelse(tissue=="Brain",expression(paste("Inferred ",K[p])),"")) +
#                                xlab(ifelse(tissue=="Skin", expression(paste("Predicted ",K[p])),"")) +
#                                geom_line(data=cf,aes(10^(x.cf),10^(y.cf))) +
#                                geom_line(data=cf,aes(10^(x.cf),10^(y.ncf))) +
#                                geom_abline(intercept=subset(regressions,Tissue==tissue)[[\'Intercept\']],
#                                slope=subset(regressions,Tissue==tissue)[[\'Slope\']]) +
#                                ggtitle(\'Red Blood Cells\')',sep='')))
#   }else{
#     eval(parse(text= paste(tissue,' <- ggplot() + labs(y=expression(paste("Measured ",K[p]))
#                                ,x=expression(paste("Predicted ",K[p]))) + geom_abline(linetype = "dashed") +
#                                geom_point(data=subset(pc.table,Tissue == \'',tissue,'\'),
#                                aes(10^(Predicted),10^(Experimental))) + theme(axis.text=element_text(size=14),
#                                axis.title=element_text(size=14),plot.title=element_text(size=14)) +
#                                scale_x_log10(label=label_log(),limits=c(0.01,1000)) +
#                                scale_y_log10(label=label_log(),limits=c(0.01,1000)) +
#                                ylab(ifelse(tissue=="Brain",expression(paste("Inferred ",K[p])),"")) +
#                                xlab(ifelse(tissue=="Skin", expression(paste("Predicted ",K[p])),"")) +
#                                geom_line(data=cf,aes(10^(x.cf),10^(y.cf))) +
#                                geom_line(data=cf,aes(10^(x.cf),10^(y.ncf))) +
#                                geom_abline(intercept=subset(regressions,Tissue==tissue)[[\'Intercept\']],
#                                slope=subset(regressions,Tissue==tissue)[[\'Slope\']]) +
#                                ggtitle(\'',tissue,'\')',sep='')))
#   }
# }
# 
# grid.arrange(Adipose, Blood, Bone, Brain, Gut, Heart, Kidney, Liver, Lung, Muscle, Skin, Spleen, nrow=4)

## ----Vdevalaution, eval=execute.vignette--------------------------------------
# obach <- subset(Obach2008,CAS %in% get_cheminfo(model='schmitt'))
# vd.table <- NULL
# 
# for(this.cas in obach[,'CAS']){
#   parameters <- parameterize_schmitt(
#     chem.cas=this.cas,
#     suppress.messages=TRUE)
#   init.parameters <- parameters
#   if(!this.cas %in% ma.data.list){
#     init.parameters$MA <- 10^(0.999831 - 0.016578*37 + 0.881721 * log10(parameters$Pow))
#   }
#   pcs <- predict_partitioning_schmitt(
#     parameters=parameters,
#     regression=FALSE,
#     suppress.messages=TRUE)
#   init.pcs <- predict_partitioning_schmitt(
#     parameters=init.parameters,
#     regression=FALSE,
#     suppress.messages=TRUE)
#   reg.pcs <- predict_partitioning_schmitt(
#     parameters=parameters,
#     regression=TRUE,
#     suppress.messages=TRUE)
#   vdist <- calc_vdist(
#     parameters=c(pcs,Funbound.plasma=parameters$Funbound.plasma),
#     suppress.messages=TRUE)
#   init.vdist <- calc_vdist(
#     parameters=c(
#       init.pcs,
#       Funbound.plasma=parameters$unadjusted.Funbound.plasma),
#     suppress.messages = TRUE)
#   reg.vdist <- calc_vdist(
#     parameters=c(reg.pcs,Funbound.plasma=parameters$Funbound.plasma),
#     suppress.messages = TRUE)
#   vd.table <- rbind(
#     vd.table,
#     cbind(as.data.frame(this.cas),as.data.frame(log10(init.vdist)),
#     as.data.frame(log10(vdist)),as.data.frame(log10(reg.vdist)),
#     as.data.frame(log10(subset(obach,CAS==this.cas)[['VDss (L/kg)']]))))
# }
# colnames(vd.table) <- c(
#   'CAS',
#   'init.vdist',
#   'corrected.vdist',
#   'calibrated.vdist',
#   'Experimental')
# init.error <- vd.table[,'Experimental'] - vd.table[,'init.vdist']
# correction.error <- vd.table[,'Experimental'] - vd.table[,'corrected.vdist']
# calibration.error <- vd.table[,'Experimental'] - vd.table[,'calibrated.vdist']
# correction.improvement <- abs(init.error) - abs(correction.error)
# calibration.improvement <- abs(correction.error) - abs(calibration.error)
# vd.table <- cbind(vd.table,correction.improvement,calibration.improvement,
#                   init.error,correction.error,calibration.error)

## ----VdistRegressions, eval=execute.vignette----------------------------------
# fit <- lm(Experimental ~ calibrated.vdist,data=vd.table)
# smry <- summary(fit)
# calibrated.reg <- cbind(as.data.frame(fit$coefficients['(Intercept)']),
#                         as.data.frame(fit$coefficients['calibrated.vdist']),
#                         as.data.frame(smry$coefficients['calibrated.vdist','Pr(>|t|)']),
#                         as.data.frame(smry$sigma),as.data.frame(smry$r.squared))
# fit <- lm(Experimental ~ init.vdist,data=vd.table)
# smry <- summary(fit)
# init.reg <- cbind(as.data.frame(fit$coefficients['(Intercept)']),
#                   as.data.frame(fit$coefficients['init.vdist']),
#                   as.data.frame(smry$coefficients['init.vdist','Pr(>|t|)']),
#                   as.data.frame(smry$sigma),as.data.frame(smry$r.squared))
# fit <- lm(Experimental ~ corrected.vdist,data=vd.table)
# smry <- summary(fit)
# corrected.reg <- cbind(as.data.frame(fit$coefficients['(Intercept)']),
#                        as.data.frame(fit$coefficients['corrected.vdist']),
#                        as.data.frame(smry$coefficients['corrected.vdist','Pr(>|t|)']),
#                        as.data.frame(smry$sigma),as.data.frame(smry$r.squared))
# colnames(init.reg) <- colnames(corrected.reg) <-
# colnames(calibrated.reg) <- c('Intercept','Slope','P-value','Std Err','R-squared')

## ----VdistPlots, eval=execute.vignette----------------------------------------
# init.vd.plot <- ggplot(vd.table,aes(10^(init.vdist),10^(Experimental))) + geom_point() +
#     geom_abline(intercept = init.reg[['Intercept']], slope = init.reg[["Slope"]]) +
#     geom_abline(linetype = "dashed") + xlab("Predicted Volume of Distribution") +
#     ylab("Measured Volume of Distribution") + theme(axis.text=element_text(size=16),
#     axis.title=element_text(size=16),plot.title=element_text(size=18,hjust = 0.5)) +
#     scale_x_log10(label=label_log(),limits=c(10^(-1.5),10^(8.5))) +
#     scale_y_log10(label=label_log(),limits=c(10^(-1.5),10^(8.5))) +
#     ggtitle('(A)')
# print(init.vd.plot)
# 
# correction.plot <- ggplot() +
#     geom_point(data=vd.table[order(vd.table[,'correction.improvement'],decreasing=F),],
#     aes(10^(corrected.vdist),10^(Experimental),color=correction.improvement)) +
#     geom_abline(intercept = corrected.reg[['Intercept']],slope = corrected.reg[["Slope"]]) +
#     geom_abline(linetype = "dashed") + xlab("Predicted Volume of Distribution") +
#     ylab("Measured Volume of Distribution") + theme(legend.position = c(.95, .95),
#     legend.justification = c("right", "top"),legend.box.just = "right",
#     legend.margin = margin(6, 6, 6, 6),axis.text=element_text(size=16),
#     axis.title=element_text(size=16),plot.title=element_text(size=18,hjust = 0.5)) +
#     scale_x_log10(limits=c(10^(-1.5),10^(3))) + scale_y_log10(limits=c(10^(-1.5),10^(3))) +
#     ggtitle('(B)') + scale_color_viridis(direction=-1,option='inferno')
# print(correction.plot)
# 
# calibration.plot <- ggplot() +
#     geom_point(data=vd.table[order(vd.table[,'calibration.improvement'],decreasing=F),],
#     aes(10^(calibrated.vdist),10^(Experimental),color=calibration.improvement)) +
#     geom_abline(intercept = calibrated.reg[['Intercept']],slope = calibrated.reg[["Slope"]]) +
#     geom_abline(linetype = "dashed") + xlab("Predicted Volume of Distribution") +
#     ylab("Measured Volume of Distribution") + theme(legend.position = c(.95, .95),
#     legend.justification = c("right", "top"),legend.box.just = "right",
#     legend.margin = margin(6, 6, 6, 6),axis.text=element_text(size=16),
#     axis.title=element_text(size=16),plot.title=element_text(size=18,hjust = 0.5)) +
#     scale_x_log10(limits=c(10^(-1.5),10^(3))) + scale_y_log10(limits=c(10^(-1.5),10^(3))) +
#     ggtitle('(C)') + scale_color_viridis(direction=-1,option='inferno')
# print(calibration.plot)

## ----bloodtoplasmaevaluation, eval=execute.vignette---------------------------
# rb2p.data <- subset(chem.physical_and_invitro.data,!is.na(Human.Rblood2plasma))
# measured.rb2p <- NULL
# measured.krbc <- NULL
# predicted.rb2p <- NULL
# predicted.krbc <- NULL
# cas <- NULL
# charge <- NULL
# fup <- NULL
# logP <- NULL
# pka_donor <- NULL
# pka_accept <- NULL
# for(this.cas in rb2p.data[rb2p.data[,'CAS'] %in%
#   get_cheminfo(model='schmitt', suppress.messages = TRUE),'CAS'])
# {
#   rb2p <- get_rblood2plasma(chem.cas=this.cas)
#   krbc <- (rb2p + .44 - 1) / 0.44
#   measured.rb2p <- c(measured.rb2p,rb2p)
#   measured.krbc <- c(measured.krbc,krbc)
#   parameters <- parameterize_schmitt(
#     chem.cas=this.cas,
#     suppress.messages = TRUE)
#   pcs <- predict_partitioning_schmitt(
#     parameters=parameters,
#     suppress.messages=TRUE)
#   predicted.krbc <- c(predicted.krbc,pcs[['Krbc2pu']] * parameters$Funbound.plasma)
#   cas <- c(cas,this.cas)
#   charge <- c(charge,calc_ionization(chem.cas=this.cas,pH=7.4)$fraction_charged)
#   fup <- c(fup,parameters$unadjusted.Funbound.plasma)
#   logP <-  c(logP,log10(parameters$Pow))
#   pka_donor <- c(pka_donor,paste(parameters$pKa_Donor,collapse=','))
#   pka_accept <- c(pka_accept,paste(parameters$pKa_Accept,collapse=','))
# }
# predicted.rb2p <-  1 - 0.44 + 0.44 * predicted.krbc
# rb2p.table <- cbind(as.data.frame(cas),as.data.frame(predicted.rb2p),as.data.frame(measured.rb2p))
# colnames(rb2p.table) <- c('cas','predicted.rb2p','measured.rb2p')
# error <- log10(rb2p.table[,'measured.rb2p']) - log10(rb2p.table[,'predicted.rb2p'])
# rb2p.table <- cbind(rb2p.table,error,charge,fup,logP)
# 
# error <- log10(measured.krbc) -  log10(predicted.krbc)
# krbc.table <- cbind(as.data.frame(cas),as.data.frame(predicted.krbc),as.data.frame(measured.krbc),
#                     as.data.frame(error),charge,fup,logP,pka_donor,pka_accept)

## ----RBCStats, eval=execute.vignette------------------------------------------
# pdta <- data.frame(x = predicted.krbc,
#                    y = measured.krbc)
# pdta$y[pdta$y <= 0.1] <- 0.1
# pdta$Censoring <- factor(c("Not Censored","Censored")[as.numeric(pdta$y <= 0.1) + 1])
# y <- measured.krbc
# x <- cbind(rep(1, length(y)),-1 * log10(predicted.krbc))
# colnames(x) <- c("Intercept","Predicted")
# cc <- as.numeric(y <= 0.1)
# y[y < 0.1] <- 0.1
# y <- -log10(y)
# 
# out <- censReg(y~x, data = pdta, left=0.1)
# out$betas <- out$estimate

## ----RBCFigure, eval=execute.vignette-----------------------------------------
# censored.regression <- ggplot() +
#     geom_point(data=pdta,aes(x=x,y=y, color=Censoring)) +
#     scale_x_log10(limits=c(.0009,40)) + scale_y_log10(limits=c(.1,4),breaks=c(.1,.5,2.5)) +
#     labs(y=expression(paste("Inferred ",K[p])),x=expression(paste("Predicted ",K[p]))) +
#     geom_abline(intercept=0, slope=1, linetype='dashed') +
#     theme(axis.text=element_text(size=16),axis.title=element_text(size=16),
#     plot.title=element_text(size=18,hjust=0.5),legend.position = c(0.11, .8)) +
#     geom_abline(slope=out$betas[2],intercept=-out$betas[1]) + ggtitle('(B)')
# print(censored.regression)
# 
# rb2p.plot <- ggplot(rb2p.table,aes(predicted.rb2p,measured.rb2p)) +
#     geom_point()  + scale_x_log10(lim=c(.52,18)) +
#     scale_y_log10(lim=c(.52,2.5),breaks=c(0.5,1,2)) + geom_abline(linetype='dashed') +
#     labs(y=expression(paste("Measured Whole Blood ",K[p])),
#     x=expression(paste("Predicted Whole Blood ",K[p]))) +
#     theme(axis.text=element_text(size=16),axis.title=element_text(size=16),
#     plot.title=element_text(size=18,hjust=0.5)) + ggtitle('(A)')
# print(rb2p.plot)

## ----summarytable, eval=execute.vignette--------------------------------------
# heatmap.table <- NULL
# for(this.cas in get_cheminfo(model='schmitt')){
#     parms <- parameterize_schmitt(
#       chem.cas=this.cas,
#       suppress.messages = TRUE)
#     pcs <- predict_partitioning_schmitt(
#       parameters=parms,
#       suppress.messages = TRUE)
#     heatmap.table <- cbind(heatmap.table,log10(unlist(pcs)[1:11]*parms$Funbound.plasma))
# }
# rownames(heatmap.table) <-  c('Adipose','Bone','Brain','Gut','Heart',
#                               'Kidney','Liver','Lung','Muscle','Skin','Spleen')
# colnames(heatmap.table) <- rep("",dim(heatmap.table)[2])

## ----summaryheatmap, eval=execute.vignette------------------------------------
# pal <- function (n, h = c(260, -328), c = 80, l = c(30, 100), power = 1.5,
#     fixup = TRUE, gamma = NULL, alpha = 1, ...)
# {
#     if (!is.null(gamma))
#         warning("'gamma' is deprecated and has no effect")
#     if (n < 1L)
#         return(character(0L))
#    h <- rep(h, length.out = 2L)
#     c <- c[1L]
#     l <- rep(l, length.out = 2L)
#     power <- rep(power, length.out = 2L)
#     rval <- seq(1, -1, length = n)
#     rval <- hex(polarLUV(L = l[2L] - diff(l) * abs(rval)^power[2L],
#         C = c * abs(rval)^power[1L], H = ifelse(rval > 0, h[1L],
#             h[2L])), fixup = fixup, ...)
#     if (!missing(alpha)) {
#         alpha <- pmax(pmin(alpha, 1), 0)
#         alpha <- format(as.hexmode(round(alpha * 255 + 1e-04)),
#             width = 2L, upper.case = TRUE)
#         rval <- paste(rval, alpha, sep = "")
#     }
#     return(rval)
# }
# 
# hclust.ave <- function(x) hclust(x, method="ward.D2")
# heatmap.2(heatmap.table,col=pal,trace="none", hclustfun=hclust.ave,
#           key.xlab=expression(paste("log10 ",K[p]," Value")),
#           key.ylab=expression(paste("Number of ",K[p])),
#           key.title="Partition Coefficient",xlab="Chemicals",cex.lab=2,margins=c(2,5))

## ----setup, include=FALSE, eval = TRUE----------------------------------------
knitr::opts_chunk$set(echo = TRUE, fig.width=6, fig.height=5)

## ----clear_memory, eval = TRUE------------------------------------------------
rm(list=ls()) 

## ----runchunks, eval = TRUE---------------------------------------------------
# Set whether or not the following chunks will be executed (run):
execute.vignette <- FALSE

## ----InitialPrep, eval = execute.vignette-------------------------------------
# library(data.table)
# library(magrittr)
# library(ggplot2)
# library(httk)
# library(httkexamples)

## ----MakeTable, eval = execute.vignette---------------------------------------
# armitage.dt <- copy(armitage_input)
# armitage.dt[,well_number:=384] %>%
#   .[,option.bottom:=TRUE] %>%
#   .[,option.plastic:=TRUE] %>%
#   .[,Tsys:=37] %>%
#   .[,Tref:=298.15] %>%
#   .[,FBSf:=0.1] %>%
#   .[,nomconc:=50]
# 
# # Make sure we have data for the chemical:
# armitage.dt <- subset(armitage.dt,casrn%in%get_cheminfo(model="armitage"))
# # These chemicals are missing water solubilities:
# armitage.dt <- subset(armitage.dt,!(casrn%in%c("71751-41-2","34590-94-8","141517-21-7")))
# 
# armitage.dt2 <- armitage_estimate_sarea(tcdata = armitage.dt)
# armitage_output1 <- armitage_eval(tcdata = armitage.dt2[,ac50:=50])
# armitage_output2 <- armitage_eval(tcdata = armitage.dt2[,ac50:=1])
# armitage_output3 <- armitage_eval(tcdata = armitage.dt2[,ac50:=0.001])
# 

## ----MakePlot, echo=TRUE, eval = execute.vignette-----------------------------
# armitage_output <- rbind(armitage_output1[,xfill:="50 \U00B5M"],
#                          armitage_output2[,xfill:="1 \U00B5M"],
#                          armitage_output3[,xfill:="1 nM"])
# armitage_output[,xfill:=factor(xfill,levels=c("50 \U00B5M","1 \U00B5M","1 nM"))]
# 
# ggplot(armitage_output) +
#   geom_point(aes(x=gkow,y=log10(ccells/MW*1e9),color=xfill),shape=1) +
#   labs(color=expression("AC"["50"]),x="log P", y = "log(ng chemical/g cells)") +
#   theme_bw()

---
title: "Kapraun et al. (2022): Generic Human Gestational Model"
author: "Dustin F. Kapraun, Mark Sfeir, Robert Pearce, Sarah Davidson, Annie Lumen, Andre Dallmann, Richard Judson, and John F. Wambaugh"
date: "`r Sys.Date()`"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{i) Kapraun (2022): Human Gestational Model}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---
*Please send questions to John.Wambaugh@UL.org*

from "Evaluation of a Rapid, Generic Human Gestational Dose Model"

Dustin F.Kapraun, Mark Sfeir, Robert Pearce, Sarah Davidson, Annie Lumen, 
Andre Dallmann, Richard Judson, John F.Wambaugh

Reproductive Toxicology, 2022

https://doi.org/10.1016/j.reprotox.2022.09.004


## Abstract

Chemical risk assessment considers potentially susceptible populations 
including pregnant women and developing fetuses. Humans encounter thousands of 
chemicals in their environments, few of which have been fully characterized in 
terms of internal human dosimetry and mode-of-action. Toxicokinetic (TK) 
information is needed to relate chemical exposure to potentially bioactive 
tissue concentrations. Observational data describing human gestational 
exposures are unavailable for most chemicals, but physiologically based TK 
(PBTK) models estimate such exposures. However, development of chemical-specific
PBTK models themselves requires considerable time and resources. As an 
alternative, generic PBTK approaches describe a standardized physiology and 
characterize chemicals with a set of standard physical and TK descriptors --
primarily plasma protein binding and hepatic clearance. Here we report and 
evaluate a generic PBTK model of a human mother and developing fetus. We used a
previously published set of formulas describing the major anatomical and 
physiological changes that occur during pregnancy to augment the High-Throughput
Toxicokinetics (httk) software package. We performed simulations to estimate the
ratio of concentrations in maternal and fetal plasma and compared these 
estimatesto literature in vivo measurements. We evaluated the model with 
literature in vivo time-course measurements of maternal plasma concentrations 
in pregnant and non-pregnant women. Finally, we demonstrated conceptual 
prioritization of chemicals measured in maternal serum based on predicted fetal
brain concentrations. This new generic model can be used for TK simulations of 
any of the 856 chemicals with existing human-specific in vitro data that were 
found to be within the domain of the model, as well as any new chemicals for 
which such data become available. With sufficient evaluation, this gestational 
model may allow for in vitro to in vivo extrapolation of point of departure 
doses relevant to reproductive and developmental toxicity.

## HTTK Version

This vignette was created with **httk** v2.1.0. Although we attempt to maintain 
backward compatibility, if you encounter issues with the latest release of 
**httk**
and cannot easily address the changes, historical versions of httk are 
available from: https://cran.r-project.org/src/contrib/Archive/httk/

## Prepare for session
R package **knitr** generates html and PDF documents from this RMarkdown file,
Each bit of code that follows is known as a "chunk". We start by telling 
**knitr** how we want our chunks to look.
```{r configure_knitr, eval = TRUE}
knitr::opts_chunk$set(collapse = TRUE, comment = '#>')
options(rmarkdown.html_vignette.check_title = FALSE)
```

### Clear the memory
It is a bad idea to let variables and other information from previous R
sessions float around, so we first remove everything in the R memory.
```{r clear_memory, eval = TRUE}
rm(list=ls()) 
```

### eval = execute.vignette
If you are using the RMarkdown version of this vignette (extension, .RMD) you
will be able to see that several chunks of code in this vignette
have the statement "eval = execute.vignette". The next chunk of code, by default,
sets execute.vignette = FALSE.  This means that the code is included (and necessary) but was
not run when the vignette was built. We do this because some steps require 
extensive computing time and the checks on CRAN limit how long we can spend
building the package. If you want this vignette to work, you must run all code,
either by cutting and pasting it into R. Or, if viewing the .RMD file, you can
either change execute.vignette to TRUE or press "play" (the green arrow) on
each chunk in RStudio.
```{r runchunks, eval = TRUE}
# Set whether or not the following chunks will be executed (run):
execute.vignette <- FALSE
```

### Load the relevant libraries
We use the command 'library()' to load various R packages for our analysis.
If you get the message "Error in library(X) : there is no package called 'X'"
then you will need to install that package: 

From the R command prompt:

install.packages("X")

Or, if using RStudio, look for 'Install Packages' under 'Tools' tab.

```{r load_packages, eval = execute.vignette}
#
#
# Setup
#
#
#library(readxl)
library(ggplot2)
library(httk)
library(httkexamples)
library(scales)
library(gridExtra)
library(cowplot)
```

### Prepare custom functions
```{r load_code, eval = execute.vignette}
scientific_10 <- function(x) {                                  
  out <- gsub("1e", "10^", scientific_format()(x))              
  out <- gsub("\\+","",out)                                     
  out <- gsub("10\\^01","10",out)                               
  out <- parse(text=gsub("10\\^00","1",out))                    
}  

RMSE <- function(x)
{
  mean(x$residuals^2)^(1/2)
}
```

# Number of chemicals

The number of chemicals with in vitro TK data ($Cl_{int}$ and $f_{up}$) that are
also non-volatile and non-PFAS can be found using:
```{r chem_numbers, eval=FALSE}
length(get_cheminfo(model="fetal_pbtk",suppress.messages=TRUE))
```

Data sets were curated from the literature to allow evaluation of the 
gestational PBTK model. In all cases chemical identities from the original 
publications were mapped onto DTXSID's from the CompTox Chemicals Dashboard 
(https://comptox.epa.gov/dashboard) [Williams et al., 2017]
(https://doi.org/10.1186/s13321-017-0247-6). Statistical testing for 
correlation between predictions and observations was performed using R 
function "lm" and p-values were calculated according to an F-distribution.

# Aylward cord-blood data 

[Aylward et al., 2014](http://dx.doi.org/10.1080/10937404.2014.884956) compiled measurements of the ratio of maternal to fetal cord blood chemical concentrations at birth for a range of chemicals with environmental routes of exposure, including bromodiphenyl ethers, fluorinated compounds, organochlorine pesticides, polyaromatic hydrocarbons, tobacco smoke components, and vitamins. The PBTK model does not have an explicit cord blood compartment, so the ratio between maternal and fetal venous plasma concentrations was used as a surrogate when making comparisons of model predictions to these data.. For each chemical three daily oral doses (every eight hours) total 1 mg/kg/day were simulated starting from the 13th week of gestation until full term (40 weeks). Simulations were made both with and without the correction to $f_{up}^f$.

## Load/format the data
```{r load_aylward_data, eval = execute.vignette}
#MFdata <- read_excel("Aylward-MatFet.xlsx")
MFdata <- as.data.frame(httk::aylward2014)

cat(paste("summarized data from over 100 studies covering ",
  length(unique(MFdata$DTXSID)[!(unique(MFdata$DTXSID)%in%c("","-"))]),
  " unique chemicals structures\n",sep=""))
  
# We don't want to exclude the volatiles and PFAS at this point:
MFdata.httk <- subset(MFdata,DTXSID %in% get_cheminfo(
  info="DTXSID",
  suppress.messages=TRUE))
MFdata.httk[MFdata.httk$Chemical.Category=="bromodiphenylethers",
  "Chemical.Category"] <- "Bromodiphenylethers"  
MFdata.httk[MFdata.httk$Chemical.Category=="organochlorine Pesticides",
  "Chemical.Category"] <- "Organochlorine Pesticides"  
  MFdata.httk[MFdata.httk$Chemical.Category=="polyaromatic hydrocarbons",
  "Chemical.Category"] <- "Polyaromatic Hydrocarbons"  

colnames(MFdata.httk)[colnames(MFdata.httk) == 
  "infant.maternal.conc...Central.tendency..calculate.j.k..or.report.paired.result."] <-
  "MFratio"
colnames(MFdata.httk)[colnames(MFdata.httk) == 
  "PREFERRED_NAME"] <-
  "Chemical"
colnames(MFdata.httk)[colnames(MFdata.httk) == 
  "details.on.matrix.comparison...e.g...cord.blood.lipid..maternal.serum.lipid..or.cord.blood.wet.weight..maternal.whole.blood.wet.weight"] <-
  "Matrix"

# Format the columns:
MFdata.httk$MFratio <- as.numeric(MFdata.httk$MFratio)
MFdata.httk$Chemical <- as.factor(MFdata.httk$Chemical)  
MFdata.httk$Matrix <- as.factor(MFdata.httk$Chemical)  
MFdata.httk$Chemical.Category <- as.factor(MFdata.httk$Chemical.Category)  

colnames(MFdata.httk)[15] <- "infant"
colnames(MFdata.httk)[16] <- "maternal"
colnames(MFdata.httk)[17] <- "obs.units"

MFdata.httk$infant <- suppressWarnings(as.numeric(MFdata.httk$infant))
MFdata.httk$maternal <- suppressWarnings(as.numeric(MFdata.httk$maternal))
MFdata.httk$AVERAGE_MASS <- as.numeric(MFdata.httk$AVERAGE_MASS)
```

## Convert the units:
```{r process_aylward_data, eval = execute.vignette}
convert1.units <- c("ng/ml","ng/mL","ug/L","ug/l","ng/mL serum","ng/g",
  "ng/g wet wt.","ppb")

MFdata.httk[MFdata.httk$obs.units%in%convert1.units,"infant"] <- 
  MFdata.httk[MFdata.httk$obs.units%in%convert1.units,"infant"] / # ng/ml = ug/L
  MFdata.httk[MFdata.httk$obs.units%in%convert1.units,"AVERAGE_MASS"]  # ug/L -> uM
MFdata.httk[MFdata.httk$obs.units%in%convert1.units,"maternal"] <- 
  MFdata.httk[MFdata.httk$obs.units%in%convert1.units,"maternal"] / # ng/ml = ug/L
  MFdata.httk[MFdata.httk$obs.units%in%convert1.units,"AVERAGE_MASS"]  # ug/L -> uM
MFdata.httk[MFdata.httk$obs.units%in%convert1.units,"obs.units"] <- "uM" 
  
convert2.units <- c("mg/L","ppm")

MFdata.httk[MFdata.httk$obs.units%in%convert2.units,"infant"] <- 
  MFdata.httk[MFdata.httk$obs.units%in%convert2.units,"infant"] * 1000 / # mg/L = ug/L
  MFdata.httk[MFdata.httk$obs.units%in%convert2.units,"AVERAGE_MASS"]  # ug/L -> uM
MFdata.httk[MFdata.httk$obs.units%in%convert2.units,"maternal"] <- 
  MFdata.httk[MFdata.httk$obs.units%in%convert2.units,"maternal"]* 1000 / # mg/L = ug/L
  MFdata.httk[MFdata.httk$obs.units%in%convert2.units,"AVERAGE_MASS"]  # ug/L -> uM
MFdata.httk[MFdata.httk$obs.units%in%convert2.units,"obs.units"] <- "uM" 
```


## Compare HTTK predictions with maternal:fetal observations from Aylward 2014

 Note that we can't do an absolute scale comparison (for example, fetal:fetal 
 or maternal:maternal) because we don't know the dose for the Aylward data but
 we assume that the maternal:fetal ratio is independent of dose and so we 
 use the plasma ratio at full term (40 weeks) resulting from a 1 mg/kg/day
 exposure rate starting in week 13.
 
```{r make_aylward_preds, eval = execute.vignette}
# Simulate starting from the 13th week of gestation until full term (40 weeks):
times <- sort(unique(c(seq(13 * 7, 40 * 7, 0.25),seq(278,280,.1))))

# For each chemical with maternal-fetal ratio data and HTTK in vitro data:  
for (this.id in unique(MFdata.httk$DTXSID))
{
  print(this.id)
  p <- parameterize_steadystate(dtxsid=this.id,
                        suppress.messages=TRUE)
  # skip chemicals where Fup is 0:  
  if (p$Funbound.plasma>1e-4)
  {

    # Load the chemical-specifc paramaters:
    p <- parameterize_fetal_pbtk(dtxsid=this.id,
                                                  fetal_fup_adjustment =TRUE,
                                                  suppress.messages=TRUE)
    # Skip chemicals where the 95% credible interval for Fup spans more than 0.1 to
    # 0.9 (that is, Fup is effectively unknown):
    if (!is.na(p$Funbound.plasma.dist))
    {
      if (as.numeric(strsplit(p$Funbound.plasma.dist,",")[[1]][3])>0.9 & 
          as.numeric(strsplit(p$Funbound.plasma.dist,",")[[1]][2])<0.11)
      {
        skip <- TRUE
      } else skip <- FALSE
    } else skip <- FALSE
    
    if (!skip)
    {
      # Solve the PBTK equations for the full simulation time assuming 1 total daily
      # dose of 1 mg/kg/day spread out over three evenly spaces exposures:
      out <- solve_fetal_pbtk(
        parameters=p,
        dose=0,
        times=times,
        daily.dose=1,
        doses.per.day=3,
        output.units = "uM",
        suppress.messages=TRUE)
      # Identify the concentrations from the final (279th) day:
      last.row <- which(out[,"time"]>279)
      last.row <- last.row[!duplicated(out[last.row,"time"])]
      # Average over the final day:
      MFdata.httk[MFdata.httk$DTXSID==this.id,"Mat.pred"] <- mean(out[last.row,"Cplasma"])
      MFdata.httk[MFdata.httk$DTXSID==this.id,"Fet.pred"] <- mean(out[last.row,"Cfplasma"])
      MFdata.httk[MFdata.httk$DTXSID==this.id,"MFratio.pred"] <- 
        mean(out[last.row,"Cplasma"])/mean(out[last.row,"Cfplasma"])
      
      # Repeat the analysis without the adjustment to fetal Fup:
      p <- parameterize_fetal_pbtk(dtxsid=this.id,
                                                    fetal_fup_adjustment =FALSE,
                                                    suppress.messages = TRUE)
      out <- solve_fetal_pbtk(
        parameters=p,
        dose=0,
        times=times,
        daily.dose=1,
        doses.per.day=3,
        output.units = "uM",
        maxsteps=1e7,
        suppress.messages = TRUE)
      
      last.row <- which(out[,"time"]>279) # The whole final day
      last.row <- last.row[!duplicated(out[last.row,"time"])]
      MFdata.httk[MFdata.httk$DTXSID==this.id,"Mat.pred.nofup"] <- mean(out[last.row,"Cplasma"])
      MFdata.httk[MFdata.httk$DTXSID==this.id,"Fet.pred.nofup"] <- mean(out[last.row,"Cfplasma"])
      MFdata.httk[MFdata.httk$DTXSID==this.id,"MFratio.pred.nofup"] <- 
        mean(out[last.row,"Cplasma"])/mean(out[last.row,"Cfplasma"])
    }
  }
}

# Something is wrong with cotinine:
MFdata.httk <- subset(MFdata.httk,Chemical!="Cotinine")

max.chem <- MFdata.httk[which(MFdata.httk$MFratio==max(MFdata.httk$MFratio)),]
min.chem <- MFdata.httk[which(MFdata.httk$MFratio==min(MFdata.httk$MFratio)),]
cat(paste("The minimum observed ratio was ",
  signif(min.chem[,"MFratio"],2),
  " for ",
  min.chem[,"Chemical"],
  " and the maximum was ",
  signif(max.chem[,"MFratio"],2),
  " for ",
  max.chem[,"Chemical"],
  ".\n",sep=""))


```  




## Aylward Ratio figures:
### Clean up repeated observations:
```{r cleanup_repeated_aylward_figure, eval = execute.vignette}
MFdata.main <- NULL
MFdata.outliers <- NULL
for (this.id in unique(MFdata.httk$DTXSID))
{
  this.subset <- subset(MFdata.httk,DTXSID==this.id)
  this.row <- this.subset[1,]
  this.row$N.obs <- dim(this.subset)[1]
  this.row$MFratio <- median(this.subset$MFratio)
  this.row$MFratio.Q25 <- quantile(this.subset$MFratio,0.25)
  this.row$MFratio.Q75 <- quantile(this.subset$MFratio,0.75)
  MFdata.main <- rbind(MFdata.main,this.row)
  this.subset <- subset(this.subset,
    MFratio<this.row$MFratio.Q25 |
    MFratio>this.row$MFratio.Q75)
  MFdata.outliers <- rbind(MFdata.outliers,this.subset) 
}
```

### Cord Blood Ratio Predictions without Fup Adjustement:
```{r aylward_figure_no_fup, eval = execute.vignette}
FigCa  <- ggplot(data=MFdata.main) +
  geom_segment(color="grey",aes(
    x=MFratio.pred.nofup,
    y=MFratio.Q25,
    xend=MFratio.pred.nofup,
    yend=MFratio.Q75))+    
  geom_point(aes(
    x=MFratio.pred.nofup,
    y=MFratio,
    shape=Chemical.Category,
    color=Chemical.Category),
    size=4)   +
  scale_shape_manual(values=c(15, 16,2, 23, 0, 1, 17, 5, 6))+ 
  geom_point(data=MFdata.outliers,aes(
    x=MFratio.pred.nofup,
    y=MFratio,
    shape=Chemical.Category,
    color=Chemical.Category),
    size=2)   +
  xlim(0,2) +
  ylim(0,3) +
#   geom_text(aes(x=AUC,y=Critical.concentration,label=Compound.abbrev,color=Chemical)) +
#   scale_y_log10(label=scientific_10) +
#,limits=c(10^-7,100)) +
#   scale_x_log10(label=scientific_10) +
#   ,limits=c(10^-7,100)) +
#    annotation_logticks() + 
  geom_abline(slope=1, intercept=0) + 
#    geom_abline(slope=1, intercept=1,linetype="dashed") + 
#    geom_abline(slope=1, intercept=-1,linetype="dashed") + 
  ylab(expression(paste(italic("In vivo")," Mat:Fet Plasma Ratio"))) + 
  xlab("Generic PBTK Predicted Ratio") +
#    scale_color_brewer(palette="Set2") + 
  theme_bw()  +
  theme(legend.position="bottom")+
  theme( text  = element_text(size=14))+ 
  theme(legend.text=element_text(size=10))+ 
  guides(color=guide_legend(title="Class",nrow=3,byrow=TRUE))+ 
  guides(shape=guide_legend(title="Class",nrow=3,byrow=TRUE))
    
print(FigCa)
```

### Generate text for results section:
```{r aylward_analysis_text, eval = execute.vignette}

cat(paste("In Figure 4 we compare predictions made with our high-throughput \
human gestational PBTK model with experimental observations on a per chemical \
basis wherever we had both in vitro HTTK data and in vivo observations (",
length(unique(MFdata.main$DTXSID)),
" chemicals).\n",sep=""))


repeats <- subset(MFdata.main,N.obs>1)

cat(paste("Multiple observations were available for ",
  dim(repeats)[1],
  " of the chemicals,\n",sep=""))


max.chem <- as.data.frame(repeats[which(repeats$MFratio==max(repeats$MFratio)),])
min.chem <- as.data.frame(repeats[which(repeats$MFratio==min(repeats$MFratio)),])

cat(paste("However, among the chemicals with repeated observations, the median \
observations only ranged from ",
  signif(min.chem[,"MFratio"],2),
  " for ",
  min.chem[,"Chemical"],
  " to ",
  signif(max.chem[,"MFratio"],2),
  " for ",
  max.chem[,"Chemical"],
  ".\n",sep=""))
  
max.chem <- as.data.frame(MFdata.main[which(MFdata.main$MFratio.pred==max(MFdata.main$MFratio.pred,na.rm=TRUE)),])
min.chem <- as.data.frame(MFdata.main[which(MFdata.main$MFratio.pred==min(MFdata.main$MFratio.pred,na.rm=TRUE)),])

cat(paste("The predictions for all chemicals ranged from ",
  signif(min.chem[,"MFratio.pred"],2),
  " for ",
  min.chem[,"Chemical"],
  " to ",
  signif(max.chem[,"MFratio.pred"],2),
  " for ",
  max.chem[,"Chemical"],
  ".\n",sep=""))
  
    

fit1 <- lm(data=MFdata.main,MFratio~MFratio.pred.nofup)
summary(fit1)
RMSE(fit1)

fit1sub <- lm(data=subset(MFdata.main,
  !(Chemical.Category %in% c(
    "Fluorinated compounds",
    "Polyaromatic Hydrocarbons"))),
  MFratio~MFratio.pred.nofup)
summary(fit1sub)
RMSE(fit1sub)

```


### Cord Blood Ratio Predictions with Fup Adjustement:
```{r aylward_figure_with_fup, eval = execute.vignette}
FigCb  <- ggplot(data=MFdata.main) +
  geom_segment(color="grey",aes(
    x=MFratio.pred,
    y=MFratio.Q25,
    xend=MFratio.pred,
    yend=MFratio.Q75))+    
  geom_point(aes(
    x=MFratio.pred,
    y=MFratio,
    shape=Chemical.Category,
    color=Chemical.Category),
    size=3)   +
  scale_shape_manual(values=c(15, 16,2, 23, 0, 1, 17, 5, 6))+ 
  geom_point(data=MFdata.outliers,aes(
    x=MFratio.pred,
    y=MFratio,
    shape=Chemical.Category,
    color=Chemical.Category),
    size=1)   +
  xlim(0,2) +
  ylim(0,3) +
#   geom_text(aes(x=AUC,y=Critical.concentration,label=Compound.abbrev,color=Chemical)) +
#   scale_y_log10(label=scientific_10) +
#,limits=c(10^-7,100)) +
#   scale_x_log10(label=scientific_10) +
#   ,limits=c(10^-7,100)) +
#    annotation_logticks() + 
  geom_abline(slope=1, intercept=0) + 
#    geom_abline(slope=1, intercept=1,linetype="dashed") + 
#    geom_abline(slope=1, intercept=-1,linetype="dashed") + 
  ylab(expression(paste(italic("In vivo")," Mat:Fet Plasma Ratio"))) + 
  xlab(expression(paste(italic("In vitro")," Predicted Ratio"))) +
#    scale_color_brewer(palette="Set2") + 
  theme_bw()  +
  theme(legend.position="bottom")+
  theme( text  = element_text(size=14))+ 
  theme(legend.text=element_text(size=10))+ 
  guides(color=guide_legend(title="Class",nrow=3,byrow=TRUE))+ 
  guides(shape=guide_legend(title="Class",nrow=3,byrow=TRUE))
    
print(FigCb)

```

### Examine performance when excluding certain chemical classes:
```{r voc_analysis, eval = execute.vignette}
# Mean logHenry's law constant for PAH's:
mean(subset(chem.physical_and_invitro.data,DTXSID%in%subset(MFdata.main,Chemical.Category=="Polyaromatic Hydrocarbons")$DTXSID)$logHenry)

nonvols <- subset(chem.physical_and_invitro.data,logHenry < -4.5)$DTXSID
fluoros <- chem.physical_and_invitro.data$DTXSID[regexpr("fluoro",tolower(chem.physical_and_invitro.data$Compound))!=-1]

fit2 <- lm(data=MFdata.main,MFratio~MFratio.pred)
summary(fit2)
RMSE(fit2)

fit2sub <- lm(data=subset(MFdata.main,
  !(Chemical.Category %in% c(
    "Fluorinated compounds",
    "Polyaromatic Hydrocarbons"))),
  MFratio~MFratio.pred)
summary(fit2sub)

RMSE(fit2sub)

cat(paste("When volatile and fluorinated chemicals are omitted only ",
  dim(subset(MFdata.main,
  !(Chemical.Category %in% c(
    "Fluorinated compounds",
    "Polyaromatic Hydrocarbons"))))[1],
  " evaluation chemicals remain, but the R2 is ",
  signif(summary(fit1sub)$adj.r.squared,2),
  " and the RMSE is ",
  signif(RMSE(fit1sub),2),
  " without the correction. When the fetal plasma fraction unbound correction is used, the predictivity decreases, slightly: R2 is ",
  signif(summary(fit2sub)$adj.r.squared,2),
  " and the RMSE is ",
  signif(RMSE(fit2sub),2),
  " for the non-volatile, non-fluorinated chemicals.\n",
  sep=""))
  
  

cat(paste("We compare the RMSE for our predictions to the standard deviation \
of the observations ",
  signif(sd(MFdata.main$MFratio)[1],2),
  " (",
  signif(sd(subset(MFdata.main,
  !(Chemical.Category %in% c(
    "Fluorinated compounds",
    "Polyaromatic Hydrocarbons")))$MFratio),2),
  " for non PAH or fluorinated compounds).\n",sep=""))

cat(paste("The average standard deviation for chemicals with repeated observations was ",
  signif(sd(subset(MFdata.main,N.obs>1)$MFratio)[1],2),
  " (",
  signif(sd(subset(MFdata.main,
  N.obs > 1 &
  !(Chemical.Category %in% c(
    "Fluorinated compounds",
    "Polyaromatic Hydrocarbons")))$MFratio),2),
  " for non PAH or fluorinated compounds).\n",sep=""))

fit3 <- lm(data=repeats,MFratio~MFratio.pred.nofup)
summary(fit3)
RMSE(fit3)

fit3sub <- lm(data=subset(MFdata.main, N.obs > 1 &
  !(Chemical.Category %in% c(
    "Fluorinated compounds",
    "Polyaromatic Hydrocarbons"))),
  MFratio~MFratio.pred.nofup)
summary(fit3sub)


fit4 <- lm(data=subset(MFdata.main,N.obs > 1),MFratio~MFratio.pred)
summary(fit4)
RMSE(fit4)

fit4sub <- lm(data=subset(MFdata.main, N.obs > 1 &
  !(Chemical.Category %in% c(
    "Fluorinated compounds",
    "Polyaromatic Hydrocarbons"))),
  MFratio~MFratio.pred)
summary(fit4sub)

cat(paste("Overall, we observed relatively poor correlation (R2 = ",
  signif(summary(fit1)$adj.r.squared,2),
  ", RMSE = ",
  signif(RMSE(fit1),2),
  ") without our fetal fup correction that was unchanged with that assumption (R2 = ",
  signif(summary(fit2)$adj.r.squared,2),
  ", RMSE = ",
  signif(RMSE(fit2),2),
  ").\n",sep=""))

repeats <-subset(MFdata.main,N.obs > 1)
cat(paste("The RMSE of the predictions for the ",
  dim(subset(repeats,!(Chemical.Category %in% c(
    "Fluorinated compounds",
    "Polyaromatic Hydrocarbons"))))[1],
  " non-PAH and non-fluorinated compounds with repeated observations is ",
  signif(RMSE(fit4sub),2),
  " with the fup correction and ",
  signif(RMSE(fit3sub),2),
  " without.\n",sep=""))

cat(paste("These values are close to the standard deviation of the mean but the p-value for the chemicals with repeated observations is ",
  signif(pf(
    summary(fit4sub)$fstatistic[1],
    summary(fit4sub)$fstatistic[2],
    summary(fit4sub)$fstatistic[3]),2),    
" indicating some value for the predictive model, albeit for only ",
dim(subset(repeats,!(Chemical.Category %in% c(
  "Fluorinated compounds",
  "Polyaromatic Hydrocarbons"))))[1],
 " chemicals",sep=""))
   


Fig4.table <- data.frame()
Fig4.table["Number of Chemicals","All Fig 4"] <- length(unique(MFdata.httk$DTXSID))
Fig4.table["Number of Observations","All Fig 4"] <- dim(MFdata.httk)[1]
Fig4.table["Observed Mean (Min - Max)","All Fig 4"] <- paste(
  signif(mean(MFdata.httk$MFratio),2)," (",
  signif(min(MFdata.httk$MFratio),2)," - ",
  signif(max(MFdata.httk$MFratio),2),")",sep="")
Fig4.table["Observed Standard Deviation","All Fig 4"] <- signif(sd(MFdata.httk$MFratio),2) 
Fig4.table["Predicted Mean (Min - Max)","All Fig 4"] <-  paste(
  signif(mean(MFdata.main$MFratio.pred,na.rm=TRUE),2)," (",
  signif(min(MFdata.main$MFratio.pred,na.rm=TRUE),2)," - ",
  signif(max(MFdata.main$MFratio.pred,na.rm=TRUE),2),")",sep="") 
Fig4.table["RMSE","All Fig 4"] <- signif(RMSE(fit2),2)
Fig4.table["R-squared","All Fig 4"] <- signif(summary(fit2)[["adj.r.squared"]],2)
Fig4.table["p-value","All Fig 4"] <- signif(summary(fit2)[["coefficients"]]["MFratio.pred",4],2)

MFdata.sub1 <- subset(MFdata.httk,
  !(Chemical.Category %in% c(
    "Fluorinated compounds",
    "Polyaromatic Hydrocarbons")))

Fig4.table["Number of Chemicals","No PFAS/PAH"] <- length(unique(MFdata.sub1$DTXSID))
Fig4.table["Number of Observations","No PFAS/PAH"] <- dim(MFdata.sub1)[1]
Fig4.table["Observed Mean (Min - Max)","No PFAS/PAH"] <- paste(
  signif(mean(MFdata.sub1$MFratio,na.rm=TRUE),2)," (",
  signif(min(MFdata.sub1$MFratio,na.rm=TRUE),2)," - ",
  signif(max(MFdata.sub1$MFratio,na.rm=TRUE),2),")",sep="")
Fig4.table["Observed Standard Deviation","No PFAS/PAH"] <- signif(sd(MFdata.sub1$MFratio),2) 

MFdata.sub2 <- subset(MFdata.main,
  !(Chemical.Category %in% c(
    "Fluorinated compounds",
    "Polyaromatic Hydrocarbons")))

Fig4.table["Predicted Mean (Min - Max)","No PFAS/PAH"] <-  paste(
  signif(mean(MFdata.sub2$MFratio.pred,na.rm=TRUE),2)," (",
  signif(min(MFdata.sub2$MFratio.pred,na.rm=TRUE),2)," - ",
  signif(max(MFdata.sub2$MFratio.pred,na.rm=TRUE),2),")",sep="") 
Fig4.table["RMSE","No PFAS/PAH"] <- signif(RMSE(fit2sub),2)
Fig4.table["R-squared","No PFAS/PAH"] <- signif(summary(fit2sub)[["adj.r.squared"]],2)
Fig4.table["p-value","No PFAS/PAH"] <- signif(summary(fit2sub)[["coefficients"]]["MFratio.pred",4],2)


MFdata.sub3 <- subset(MFdata.main,N.obs > 1 &
  !(Chemical.Category %in% c(
    "Fluorinated compounds",
    "Polyaromatic Hydrocarbons")))

Fig4.table["Number of Chemicals","Replicates Only"] <- length(unique(MFdata.sub3$DTXSID))
Fig4.table["Number of Observations","Replicates Only"] <- dim(MFdata.sub3)[1]
Fig4.table["Observed Mean (Min - Max)","Replicates Only"] <- paste(
  signif(mean(MFdata.sub3$MFratio),2)," (",
  signif(min(MFdata.sub3$MFratio),2)," - ",
  signif(max(MFdata.sub3$MFratio),2),")",sep="")
Fig4.table["Observed Standard Deviation","Replicates Only"] <- signif(sd(MFdata.sub3$MFratio),2) 

Fig4.table["Predicted Mean (Min - Max)","Replicates Only"] <-  paste(
  signif(mean(MFdata.sub3$MFratio.pred,na.rm=TRUE),2)," (",
  signif(min(MFdata.sub3$MFratio.pred,na.rm=TRUE),2)," - ",
  signif(max(MFdata.sub3$MFratio.pred,na.rm=TRUE),2),")",sep="") 
Fig4.table["RMSE","Replicates Only"] <- signif(RMSE(fit4sub),2)
Fig4.table["R-squared","Replicates Only"] <- signif(summary(fit4sub)[["adj.r.squared"]],2)
Fig4.table["p-value","Replicates Only"] <- signif(summary(fit4sub)[["coefficients"]]["MFratio.pred",4],2)

write.csv(Fig4.table[1:6,],file="Fig4Table.csv")
```





# Evaluation of Area Under the Curve Predictions

[Dallmann et al., 2018](http://dx.doi.org/10.1007/s40262-017-0594-5) includes descriptions of toxicokinetics summary statistics, including time-integrated plasma concentrations (area under the curve or AUC) for six drugs administered to a sample of subjects including both pregnant and non-pregnant women. Additional data from X and Y for two chemicals among the httk library were collected from the literature. 

```{r dallmann2018_data, eval = execute.vignette}
#TKstats <- as.data.frame(read_excel("MaternalFetalAUCData.xlsx"))
TKstats <- httk::pregnonpregaucs


ids <- unique(TKstats$DTXSID)
cat(paste(sum(ids %in% get_cheminfo(
  model="fetal_pbtk",
  info="dtxsid",
  suppress.messages=TRUE)),
          "chemicals for which the model fetal_pbtk can run that are in the Dallmann data set."))


TKstats.Cmax <- subset(TKstats,DTXSID!="" & Parameter=="Cmax")
TKstats <- subset(TKstats,DTXSID!="" & Parameter %in% c("AUCinf","AUClast"))

ids <- unique(TKstats$DTXSID)
cat(paste(sum(ids %in% get_cheminfo(
  model="fetal_pbtk",
  info="dtxsid",
  suppress.messages=TRUE)),
          "chemicals for which the model fetal_pbtk can run that have AUCs in the Dallmann data set."))


# Assumed body weight (kg) from Kapraun 2019
BW.nonpreg <- 61.103

#TKstats$Dose <- TKstats$Dose/BW
#TKstats$Dose.Units <- "mg/kg"
colnames(TKstats)[colnames(TKstats)=="Observed Pregnant"] <- "Observed.Pregnant"
colnames(TKstats)[colnames(TKstats)=="Observed Pregnant5"] <- "Observed.Pregnant5"
colnames(TKstats)[colnames(TKstats)=="Observed Non-Pregnant"] <- "Observed.Non.Pregnant"
colnames(TKstats)[colnames(TKstats)=="Observed Non-Pregnant2"] <- "Observed.Non.Pregnant2"
colnames(TKstats)[colnames(TKstats)=="Dose Route"] <- "Dose.Route"
```

## Predict AUC
The circumstances of the dosing varied slightly between drugs and pregnancy status required variation in simulated dose regimen as summarized in Table 12. The function solve_fetal_pbtk was used to determine the time-integrated plasma concentration (area under the curve, or AUC) for the mothers both when pregnant and non-pregnant.

```{r dallmann2018_preds, eval = execute.vignette}
for (this.id in unique(TKstats$DTXSID))
{
  if (any(regexpr("ng",TKstats[TKstats$DTXSID==this.id,"Dose Units"])!=-1))
  {
  }  
  if (this.id %in% get_cheminfo(
    info="DTXSID",
    model="fetal_pbtk",
    suppress.messages=TRUE))
  {
    this.subset <- subset(TKstats,DTXSID==this.id)
    p <- parameterize_pbtk(
      dtxsid=this.id,
      suppress.messages=TRUE)
    p$hematocrit <- 0.39412 # Kapraun 2019 (unitless)
    p$Rblood2plasma <- calc_rblood2plasma(
      parameters=p,
      suppress.messages=TRUE)
    p$BW <- BW.nonpreg 
    p$Qcardiacc <- 301.78 / p$BW^(3/4) # Kapraun 2019 (L/h/kg^3/4)
    for (this.route in unique(this.subset$Dose.Route))
    {
      this.route.subset <- subset(this.subset, Dose.Route==this.route)
      if (this.route.subset[1,"Gestational.Age.Weeks"] > 12)
      {
        this.dose <- this.route.subset$Dose
        # Non-pregnant PBPK:
        out.nonpreg <- solve_pbtk(
          parameters=p,
          times = seq(0, this.route.subset[1,"NonPreg.Duration.Days"],
                      this.route.subset[1,"NonPreg.Duration.Days"]/100),
          dose=this.dose/BW.nonpreg, # mg/kg
          daily.dose=NULL,
          iv.dose=(this.route=="iv"),
          output.units="uM",
          suppress.messages=TRUE)
        # Pregnant PBPK:
        BW.preg <- suppressWarnings(calc_maternal_bw(
          week=this.route.subset[1,"Gestational.Age.Weeks"]))
        out.preg <- solve_fetal_pbtk(
          dtxsid=this.id,
          times = seq(
            this.route.subset[1,"Gestational.Age.Weeks"]*7, 
            this.route.subset[1,"Gestational.Age.Weeks"]*7 + 
              this.route.subset[1,"Preg.Duration.Days"], 
            this.route.subset[1,"Preg.Duration.Days"]/100),
          dose=this.dose/BW.preg, # mg/kg
          iv.dose=(this.route=="iv"),
          daily.dose=NULL,
          output.units="uM",
          suppress.messages=TRUE)
        if (any(regexpr("AUC",this.subset$Parameter)!=-1))
        {
          TKstats[TKstats$DTXSID==this.id &
                    TKstats$Dose.Route == this.route &
                    regexpr("AUC",TKstats$Parameter)!=-1, 
                  "Predicted.Non.Pregnant.httk"] <- max(out.nonpreg[,"AUC"])*24 #uMdays->uMh                        
          TKstats[TKstats$DTXSID==this.id &
                    TKstats$Dose.Route == this.route &
                    regexpr("AUC",TKstats$Parameter)!=-1, 
                  "Predicted.Pregnant.httk"] <- max(out.preg[,"AUC"])*24 # uM days -> uM h 
        }
        if (any(regexpr("Cmax",this.subset$Parameter)!=-1))
        {
          TKstats[TKstats$DTXSID==this.id &
                    TKstats$Dose.Route == this.route &
                    regexpr("Cmax",TKstats$Parameter)!=-1, 
                  "Predicted.Non.Pregnant.httk"] <- max(out.nonpreg[,"Cplasma"])
          TKstats[TKstats$DTXSID==this.id &
                    TKstats$Dose.Route == this.route &
                    regexpr("Cmax",TKstats$Parameter)!=-1, 
                  "Predicted.Pregnant.httk"] <- max(out.preg[,"Cfplasma"])        
        }
      }
    }
  }
}

TKstats$Ratio.obs <- TKstats$Observed.Pregnant / TKstats$Observed.Non.Pregnant
TKstats$Ratio.httk <- TKstats$Predicted.Pregnant.httk / TKstats$Predicted.Non.Pregnant.httk
TKstats <- subset(TKstats, !is.na(TKstats$Ratio.httk))

write.csv(TKstats,file="Table-Dallmann2018.csv",row.names=FALSE)
```

## Generate AUC Predicted vs. Observed Figure
```{r dallmann2018_figure, eval = execute.vignette}
FigEa  <- ggplot(data=TKstats) +
  geom_point(aes(
    y=Observed.Non.Pregnant2,
    x=Predicted.Non.Pregnant.httk,
    shape=Dose.Route,
    alpha=Drug,
    fill=Drug),
    size=5)   +
  geom_abline(slope=1, intercept=0) +
  geom_abline(slope=1, intercept=1, linetype=3) + 
  geom_abline(slope=1, intercept=-1, linetype=3) + 
  scale_shape_manual(values=c(22,24))+ 
  xlab("httk Predicted (uM*h)") + 
  ylab("Observed") +
  scale_x_log10(#limits=c(10^-3,10^3),
    label=scientific_10) +
  scale_y_log10(#limits=c(10^-3,10^3),
    label=scientific_10) +
  ggtitle("Non-Pregnant") +
  theme_bw()  +
  theme(legend.position="none")+
  theme( text  = element_text(size=12)) + 
  annotate("text", x = 0.1, y = 1000, label = "A", fontface =2)
    
#print(FigEa)
cat(paste(
  "For the Dallman et al. (2018) data we observe an average-fold error (AFE)\n\ of",
  signif(mean(TKstats$Predicted.Non.Pregnant.httk/TKstats$Observed.Non.Pregnant2),2),
  "and a RMSE (log10-scale) of",
  signif((mean((log10(TKstats$Predicted.Non.Pregnant.httk)-log10(TKstats$Observed.Non.Pregnant2))^2))^(1/2),2),
  "for non-pregnant woman.\n"))

FigEb  <- ggplot(data=TKstats) +
  geom_point(aes(
    y=Observed.Pregnant5,
    x=Predicted.Pregnant.httk,
    shape=Dose.Route,
    alpha=Drug,
    fill=Drug),
    size=5)   +
      geom_abline(slope=1, intercept=0) +
  geom_abline(slope=1, intercept=1, linetype=3) + 
  geom_abline(slope=1, intercept=-1, linetype=3) +
  scale_shape_manual(values=c(22,24))+ 
  xlab("httk Predicted (uM*h)") + 
  ylab("Observed") +
  scale_x_log10(#limits=c(10^-5,10^3),
                label=scientific_10) +
  scale_y_log10(#limits=c(10^-5,10^3),
                label=scientific_10) +
  ggtitle("Pregnant")+
  theme_bw()  +
  theme(legend.position="none")+
  theme( text  = element_text(size=12)) + 
  annotate("text", x = 0.1, y = 300, label = "B", fontface =2)
    
#print(FigEb)
cat(paste(
  "We observe an AFE of",
  signif(mean(TKstats$Predicted.Pregnant.httk/TKstats$Observed.Pregnant5),2),
  "and a RMSE (log10-scale) of",
  signif((mean((log10(TKstats$Predicted.Pregnant.httk)-log10(TKstats$Observed.Pregnant5))^2))^(1/2),2),
  "for pregnant woman.\n"))



FigEc  <- ggplot(data=TKstats) +
  geom_point(aes(
    x=Predicted.Non.Pregnant.httk,
    y=Predicted.Pregnant.httk,
    shape=Dose.Route,
    alpha=Drug,
    fill=Drug),
    size=5)   +
      geom_abline(slope=1, intercept=0) +
  geom_abline(slope=1, intercept=1, linetype=3) + 
  geom_abline(slope=1, intercept=-1, linetype=3) +
  scale_shape_manual(values=c(22,24),name="Route")+ 
  ylab("httk Pregnant (uM*h)") + 
  xlab("httk Non-Pregnant (uM*h)") + 
  scale_x_log10(#limits=c(10^-1,10^2),
                label=scientific_10) +
  scale_y_log10(#limits=c(10^-1,10^2),
                label=scientific_10) +
  ggtitle("Model Comparison") +
  theme_bw()  +
  theme(legend.position="left")+
  theme( text  = element_text(size=12))+ 
  theme(legend.text=element_text(size=10))+
  guides(fill=guide_legend(ncol=2,override.aes=list(shape=21)),alpha=guide_legend(ncol=2),shape=guide_legend(ncol=2))
 print(FigEc)   
FigEc <- get_legend(FigEc)


FigEd  <- ggplot(data=subset(TKstats,!is.na(Ratio.httk))) +
  geom_point(aes(
    y=Ratio.obs,
    x=Ratio.httk,
    shape=Dose.Route,
    alpha=Drug,
    fill=Drug),
    size=5)   +
  scale_shape_manual(values=c(22,24))+ 
  xlab("httk Predicted") + 
  ylab("Observed") +
  scale_x_continuous(limits=c(0.25,3)) +
  scale_y_continuous(limits=c(0.25,3)) +
  geom_abline(slope=1, intercept=0) +
 geom_abline(slope=1, intercept=1, linetype=3) + 
  geom_abline(slope=1, intercept=-1, linetype=3) + 
  ggtitle("Ratio") +
  theme_bw()  +
  theme(legend.position="none")+
  theme( text  = element_text(size=12)) + 
  annotate("text", x = 0.5, y = 2.75, label = "C", fontface =2)
    
dev.new()
grid.arrange(FigEa,FigEb,FigEc,FigEd,nrow=2)

write.csv(subset(TKstats,
  !is.na(Ratio.httk)),
  file="DallmanTable.txt")
  
```

# Evaluation of Partition Coefficient Predictions

For each tissue, the partition coefficient (which describes the ratio of the concentration in the tissue to concentration of unbound chemical in the plasma at equilibrium) is a constant. We calculate each partition coefficient using the method of [Schmitt, 2008](http://dx.doi.org/10.1016/j.tiv.2007.09.010) as described by [Pearce et al., 2017](http://dx.doi.org/10.1007/s10928-017-9548-7). The partition coefficient for any given type of tissue (for example, liver tissue) depends on fraction unbound in plasma ($f_{up}^m$  or $f_{up}^f$), so in general these differ for mother and fetus.


[Curley et al., 1969](https://doi.org/10.1080/00039896.1969.10666901) compiled data on the concentration of a variety of pesticides in the cord blood of newborns and in the tissues of infants that were stillborn. 

```{r curley1969_data, eval = execute.vignette}
Curley <- as.data.frame(read_excel("Curley1969.xlsx"))
dim(Curley)
Curley.compounds <- Curley[1,4:13]
Curley <- Curley[4:47,]
colnames(Curley)[1] <- "Tissue"
colnames(Curley)[2] <- "N"
colnames(Curley)[3] <- "Stat"
```

The ratio of chemical concentration in tissue ($C_y^f$) vs. blood ($C_{venb}^f$) was related to the tissue-to-unbound-plasma concentration partition coefficients used in the PBTK model as
$$
	(C_y^f )/(C_{venb}^f  )=(C_y^f)/(R_{b:p}^f \times C_{plas}^f  )=(C_y^f \times f_{up}^f)/(R_{b:p}^f \times C_{up}^f)=(f_{up}^f)/(R_{b:p}^f) \times K_y^f
$$
where $C_{up}^f$ denotes the concentration of substance unbound in the fetal plasma.

```{r curley1969_calcpcs, eval = execute.vignette}
Curley.pcs <- NULL
cord.blood <- subset(Curley, Tissue == "Cord Blood") 
suppressWarnings(
for (this.tissue in unique(Curley$Tissue))
  if (this.tissue != "Cord Blood")
  {
    this.subset <- subset(Curley, Tissue == this.tissue)
    for (this.chemical in colnames(Curley)[4:13])
    {
      if (!is.na(as.numeric(subset(this.subset,Stat=="Mean")[,this.chemical])) &
        !is.na(as.numeric(subset(cord.blood,Stat=="Mean")[,this.chemical])))
      {
        this.row <- data.frame(
          Compound = Curley.compounds[,this.chemical],
          DTXSID = this.chemical,
          Tissue = this.tissue,
          PC = as.numeric(subset(this.subset,Stat=="Mean")[,this.chemical]) /
            as.numeric(subset(cord.blood,Stat=="Mean")[,this.chemical])
          )
        Curley.pcs <- rbind(Curley.pcs,this.row)
      } else if (!is.na((as.numeric(subset(this.subset,Stat=="Range")[,this.chemical]))) &
        !is.na((as.numeric(subset(cord.blood,Stat=="Mean")[,this.chemical]))))
      {
        this.row <- data.frame(
          Compound = Curley.compounds[,this.chemical],
          DTXSID = this.chemical,
          Tissue = this.tissue,
          PC = as.numeric(subset(this.subset,Stat=="Range")[,this.chemical]) /
            as.numeric(subset(cord.blood,Stat=="Mean")[,this.chemical])
          )
        Curley.pcs <- rbind(Curley.pcs,this.row)
      }
    }
  }
)
Curley.pcs[Curley.pcs$Tissue=="Lungs","Tissue"] <- "Lung"

pearce2017 <- read_excel("PC_Data.xlsx")
pearce2017 <- subset(pearce2017,DTXSID%in%Curley.pcs$DTXSID)
any(pearce2017$DTXSID%in%Curley.pcs$DTXSID)
print("None of the Curley chems were in the Pearce 2017 PC predictor evaluation.")
```

Partition coefficients were measured for tissues, including placenta, in vitro by [Csanady et al., 2002](http://dx.doi.org/10.1007/s00204-002-0339-5) for Bisphenol A and Diadzen. 

```{r csanady2002_pcs, eval = execute.vignette}
csanadybpa <- read_excel("Csanady2002.xlsx",sheet="Table 2")
csanadybpa$Compound <- "Bisphenol A"
csanadybpa$DTXSID <- "DTXSID7020182"
csanadybpa <- csanadybpa[,c("Compound","DTXSID","Tissue","Mean")]
colnames(csanadybpa) <- colnames(Curley.pcs)

csanadydaid <- read_excel("Csanady2002.xlsx",sheet="Table 3",skip=1)
csanadydaid$Compound <- "Daidzein"
csanadydaid$DTXSID <- "DTXSID9022310"
csanadydaid <- csanadydaid[,c("Compound","DTXSID","Tissue","Mean...6")]
colnames(csanadydaid) <- colnames(Curley.pcs)

Curley.pcs <- rbind(Curley.pcs,csanadybpa,csanadydaid)
Curley.pcs <- subset(Curley.pcs,Tissue!="Mammary gland")
```

Three of the chemicals studied by [Curley et al., 1969](https://doi.org/10.1080/00039896.1969.10666901) were modeled by [Weijs et al., 2013](http://dx.doi.org/10.1021/es400386a) using the same partition coefficients for mother and fetus. The values used represented "prior knowledge" summarizing the available literature.


```{r weijs2013_loadPCs, eval = execute.vignette}
weijstab3 <- read_excel("Weijs2013.xlsx",sheet="Table3",skip=1)
weijstab3 <- subset(weijstab3, !is.na(Compound) & !is.na(Tissue))
weijstab4 <- read_excel("Weijs2013.xlsx",sheet="Table4",skip=1)
weijstab4 <- subset(weijstab4, !is.na(Compound) & !is.na(Tissue))

for (this.compound in unique(weijstab3$Compound))
  for (this.tissue in unique(weijstab3$Tissue))
  {
    Curley.pcs[
      Curley.pcs$DTXSID==this.compound & Curley.pcs$Tissue==this.tissue,
      "Weijs2013"] <- weijstab3[weijstab3$Compound==this.compound &
                                  weijstab3$Tissue==this.tissue,"value"]
      
  }

for (this.compound in unique(weijstab4$Compound))
  for (this.tissue in unique(weijstab4$Tissue))
  {
    Curley.pcs[
      Curley.pcs$DTXSID==this.compound & Curley.pcs$Tissue==this.tissue,
      "Weijs2013"] <- weijstab4[weijstab4$Compound==this.compound &
                                  weijstab4$Tissue==this.tissue,"value"]
      
  }

write.csv(Curley.pcs,"PCs-table.csv",row.names=FALSE)

```

## Predict partition coefficients
```{r curley1969_makepreds, eval = execute.vignette}
Curley.pcs <- httk::fetalpcs
dtxsid.list <- get_cheminfo(
  info="DTXSID",
  model="fetal_pbtk",
  suppress.messages=TRUE)

suppressWarnings(load_sipes2017())
for (this.chemical in unique(Curley.pcs$DTXSID))
  if (this.chemical %in% dtxsid.list)
  {
    this.subset <- subset(Curley.pcs,DTXSID==this.chemical)
    p <- parameterize_fetal_pbtk(dtxsid=this.chemical,
      fetal_fup_adjustment = FALSE,
      suppress.messages=TRUE,
      minimum.Funbound.plasma = 1e-16)
    fetal.blood.pH <- 7.26   
    Fup <- p$Fraction_unbound_plasma_fetus
    fetal_schmitt_parms <- parameterize_schmitt(
      dtxsid=this.chemical,
      suppress.messages=TRUE,
      minimum.Funbound.plasma = 1e-16)
    fetal_schmitt_parms$plasma.pH <- fetal.blood.pH
    fetal_schmitt_parms$Funbound.plasma <- Fup
    Curley.pcs[Curley.pcs$DTXSID==this.chemical,"Fup"] <- Fup
    # httk gives tissue:fup (unbound chemical in plasma) PC's:
    fetal_pcs <- predict_partitioning_schmitt(
      parameters = fetal_schmitt_parms,
      suppress.messages=TRUE,
      model="fetal_pbtk",
      minimum.Funbound.plasma = 1e-16)
    fetal_pcs.nocal <- predict_partitioning_schmitt(
      parameters = fetal_schmitt_parms,
      regression=FALSE,
      suppress.messages=TRUE,
      model="fetal_pbtk",
      minimum.Funbound.plasma = 1e-16)
    out <- solve_fetal_pbtk(
      dtxsid = this.chemical,
      fetal_fup_adjustment =FALSE,
      suppress.messages=TRUE,
      minimum.Funbound.plasma = 1e-16)
    Rb2p <- out[dim(out)[1],"Rfblood2plasma"]
    Curley.pcs[Curley.pcs$DTXSID==this.chemical,"Rb2p"] <- Rb2p
    # Convert to tissue:blood PC's:
    for (this.tissue in this.subset$Tissue)
      if (tolower(this.tissue) %in% 
        unique(subset(tissue.data,Species=="Human")$Tissue))
      {
        Curley.pcs[Curley.pcs$DTXSID==this.chemical &
          Curley.pcs$Tissue == this.tissue, "HTTK.pred.t2up"] <-
          fetal_pcs[[paste("K",tolower(this.tissue),"2pu",sep="")]]
        Curley.pcs[Curley.pcs$DTXSID==this.chemical &
          Curley.pcs$Tissue == this.tissue, "HTTK.pred.nocal.t2up"] <-
          fetal_pcs.nocal[[paste("K",tolower(this.tissue),"2pu",sep="")]]
        Curley.pcs[Curley.pcs$DTXSID==this.chemical &
          Curley.pcs$Tissue == this.tissue, "HTTK.pred"] <-
          fetal_pcs[[paste("K",tolower(this.tissue),"2pu",sep="")]]*Fup/Rb2p
        Curley.pcs[Curley.pcs$DTXSID==this.chemical &
          Curley.pcs$Tissue == this.tissue, "HTTK.pred.nocal"] <-
          fetal_pcs.nocal[[paste("K",tolower(this.tissue),"2pu",sep="")]]*Fup/Rb2p
      } else {
       print(this.tissue)
      }  
  } else print(this.chemical)
reset_httk()

cat(paste(
  "For the two placental observations (",
  signif(subset(Curley.pcs,Compound=="Bisphenol A" & Tissue=="Placenta")[,"PC"],2),
  " for Bisphenol A and ",
  signif(subset(Curley.pcs,Compound=="Daidzein" & Tissue=="Placenta")[,"PC"],2),
  " for Diadzen) the predictions were ",
  signif(subset(Curley.pcs,Compound=="Bisphenol A" & Tissue=="Placenta")[,"HTTK.pred"],2),
  " and ",
  signif(subset(Curley.pcs,Compound=="Daidzein" & Tissue=="Placenta")[,"HTTK.pred"],2),
  ", respectively.\n",sep=""))


```

## Create Observed vs. Predicted Plot
### First indicate compound:
```{r curley1969_figure_compounds, eval = execute.vignette}
FigFa  <- ggplot(data=subset(Curley.pcs,!is.na(HTTK.pred.nocal))) +
  geom_point(size=2,aes(
    y=Weijs2013,
    x=HTTK.pred,    
    shape=Compound,
    color=Compound)) +
  geom_point(size=5,aes(
    y=PC,
    x=HTTK.pred,
    shape=Compound,
    color=Compound)) +
  geom_abline(slope=1, intercept=0, size=2) +
  geom_abline(slope=1, intercept=1, linetype=3, size=2) + 
  geom_abline(slope=1, intercept=-1, linetype=3, size=2) +
  scale_shape_manual(values=rep(c(15,16,17,18),4))+
  xlab("Predicted Tissue:Blood Partition Coefificent") + 
  ylab("Observed") +
  scale_x_log10(label=scientific_10,limits=c(10^-1,10^2)) +
  scale_y_log10(label=scientific_10,limits=c(10^-1,10^4)) +
  theme_bw()  +
  theme(legend.position="bottom")+
  theme( text  = element_text(size=28))+ 
  theme(legend.text=element_text(size=12))+ 
   theme(legend.title = element_blank())+
  guides(shape=guide_legend(nrow=3,byrow=TRUE))

print(FigFa)

fitFa <- lm(data=Curley.pcs,log10(PC)~log10(HTTK.pred))
RMSE(fitFa)
fitFb <- lm(data=Curley.pcs,log10(PC)~log10(HTTK.pred.nocal))
RMSE(fitFb)
```

### Then indicate tissues:
```{r curley1969_figure_tissues, eval = execute.vignette}
FigFb  <- ggplot(data=subset(Curley.pcs,!is.na(HTTK.pred))) +
  geom_point(size=2,aes(
    y=Weijs2013,
    x=HTTK.pred,
    shape=Tissue,
    color=Tissue)) +
  geom_point(size=5, aes(
    y=PC,
    x=HTTK.pred,
    shape=Tissue,
    color=Tissue))   +
  geom_abline(slope=1, intercept=0, size=2) +
  geom_abline(slope=1, intercept=1, linetype=3, size=2) + 
  geom_abline(slope=1, intercept=-1, linetype=3, size=2) +
  scale_shape_manual(values=rep(c(15,16,17,18),4))+
  xlab("Predicted Tissue:Blood Partition Coefificent") + 
  ylab("Observed") +
  scale_x_log10(label=scientific_10,limits=c(10^-1,10^2)) +
  scale_y_log10(label=scientific_10,limits=c(10^-1,10^4)) +
  theme_bw()  +
  theme(legend.position="bottom")+
  theme( text  = element_text(size=28))+ 
  theme(legend.text=element_text(size=20))+ 
   theme(legend.title = element_blank())+
  guides(shape=guide_legend(nrow=3,byrow=TRUE))

print(FigFb)
```

## Compare httk partition coefficients with PKsim:
```{r read_pksim_pcs, eval = execute.vignette}
pksim.pcs <- as.data.frame(read_excel("PartitionCoefficients.xlsx"))
dim(pksim.pcs)
for (this.id in unique(pksim.pcs$DTXSID))
{
  httk.PCs <- predict_partitioning_schmitt(dtxsid=this.id,
                                           suppress.messages = TRUE)
  p <- 
    parameterize_fetal_pbtk(dtxsid=this.id, 
    suppress.messages = TRUE)
  httk.PCs[["Kplacenta2pu"]] <- p[["Kplacenta2pu"]] 
  httk.PCs[["Fup"]] <- p[["Funbound.plasma"]]
  lapply(httk.PCs,as.numeric)
  this.subset <- subset(pksim.pcs,DTXSID==this.id)
  for (this.tissue in unique(this.subset$Tissue))
  {
    if (any(regexpr(tolower(this.tissue),names(httk.PCs))!=-1))
    {
      pksim.pcs[pksim.pcs$DTXSID==this.id & pksim.pcs$Tissue==this.tissue,
        "HTTK.pred"] <-     
        httk.PCs[regexpr(tolower(this.tissue),names(httk.PCs))!=-1][[1]]*
        httk.PCs[["Fup"]][[1]]         
    }
  }
}
colnames(pksim.pcs)[colnames(pksim.pcs) ==
                      "Tissue-to-plasma partition coefficient"] <- "PKSim.pred"
colnames(pksim.pcs)[colnames(pksim.pcs) ==
        "Method for calculating tissue-to-plasma partition coefficients"] <- 
  "Method"
pksim.pcs[,"Method"] <- as.factor(pksim.pcs[,"Method"])
pksim.pcs[,"Drug"] <- as.factor(pksim.pcs[,"Drug"])
pksim.pcs[,"Tissue"] <- as.factor(pksim.pcs[,"Tissue"])


pksim.pcs[,"PKSim.pred"] <- as.numeric(
  pksim.pcs[,"PKSim.pred"])

```
```{r compare_pksim_pcs, eval = execute.vignette}
pksim.pcs <- httk::pksim.pcs

pksim.fit1 <- lm(data=pksim.pcs,
                log10(PKSim.pred)~log10(HTTK.pred))
summary(pksim.fit1)

pksim.fit2 <- lm(data=pksim.pcs,
                log10(PKSim.pred)~log10(HTTK.pred)+
                  Drug+Tissue+Method)
summary(pksim.fit2)

```








# Chemical Prioritization on the Basis of Fetal Brain Concentration
```{r wang2018_loaddata, eval = execute.vignette}
#Wangchems <- read_excel("Wang2018.xlsx",sheet=3,skip=2)
Wangchems <- httk::wang2018
maternal.list <- Wangchems$CASRN[Wangchems$CASRN %in% 
  get_cheminfo(model="fetal_pbtk",
  suppress.messages=TRUE)]
nonvols <- subset(chem.physical_and_invitro.data,logHenry < -4.5)$CAS
nonfluoros <- chem.physical_and_invitro.data$CAS[
  regexpr("fluoro",tolower(chem.physical_and_invitro.data$Compound))==-1]
maternal.list <- maternal.list[maternal.list %in% intersect(nonvols,nonfluoros)]
```


For the plot we need a data frame with a column "Ratio.pred" broken down by the
different contributions to uncertainty being plotted (columne "Uncertainty").
We build this plot by making multiple versions of pred.table and concatonating
them together at the end.

## Make predictions for fetal:maternal plasma ratio using three daily doses from week 13 to full term
```{r wang2018_makepreds, eval = execute.vignette}

pred.table1 <- subset(get_cheminfo(
  info=c("Compound","CAS","DTXSID","logP","pka_accept","pka_donor"),
  model="fetal_pbtk"),
  CAS %in% maternal.list,
  suppress.messages=TRUE)
pred.table1$Compound <- gsub("\"","",pred.table1$Compound)    

for (this.cas in maternal.list)
{
  Fup <- subset(get_cheminfo(
    info="all",
    suppress.messages=TRUE),
    CAS==this.cas)$Human.Funbound.plasma
  # Check if Fup is provided as a distribution:
  if (regexpr(",",Fup)!=-1)
  {
    if (as.numeric(strsplit(Fup,",")[[1]][1])==0 |
      (as.numeric(strsplit(Fup,",")[[1]][3])>0.9 & 
      as.numeric(strsplit(Fup,",")[[1]][2])<0.11))
    {
      skip <- TRUE
    } else skip <- FALSE
    Fup.upper <- as.numeric(strsplit(Fup,",")[[1]][3])
    Fup <- as.numeric(strsplit(Fup,",")[[1]][1])
    # These results are actually from a Bayesian posterior, but we can approximate that
    # they are normally distributed about the median to estimate a standard deviation:
    Fup.sigma <- (Fup.upper - Fup)/1.96
  # If it's not a distribution use defaults (see Wambaugh et al. 2019)
  } else if (as.numeric(Fup)== 0) 
  {
    skip <- TRUE
  } else {
    skip <- FALSE
    Fup <- as.numeric(Fup)
    Fup.sigma <- Fup*0.4
    Fup.upper  <- min(1,(1+1.96*0.4)*Fup)
  }
  
  # Only run the simulation if we have the necessary parameters:
  if (!skip)
  { 
    print(this.cas)
    out <- solve_fetal_pbtk(
      chem.cas=this.cas,
      dose=0,
      daily.dose=1,
      doses.per.day=3,
      fetal_fup_adjustenment=TRUE,
      suppress.messages=TRUE)
    last.row <- which(out[,"time"]>279)
    last.row <- last.row[!duplicated(out[last.row,"time"])]
    pred.table1[pred.table1$CAS==this.cas,"fup"] <- signif(Fup,3)
    pred.table1[pred.table1$CAS==this.cas,"fup.sigma"] <- signif(Fup.sigma,3)
    pred.table1[pred.table1$CAS==this.cas,"fup.upper"] <- signif(Fup.upper,3)
    pred.table1[pred.table1$CAS==this.cas,"Ratio.pred"] <- 
      signif(mean(out[last.row,"Cfplasma"])/mean(out[last.row,"Cplasma"]),3)
  }
}
```


## Create final table holding all predictions for paper:
```{r brain_uncertainty_prop_table, eval = execute.vignette}
PC.table <- pred.table1
colnames(PC.table)[colnames(PC.table)=="Ratio.pred"] <- "R.plasma.FtoM"
pred.table1$Uncertainty <- "Predicted F:M Plasma Ratio"
```

### Error in fetal:maternal ratio (inverse of maternal:fetal ratio):
```{r Rfetmat_uncertainty, eval = execute.vignette}
pred.table3 <- pred.table1
pred.table3$Uncertainty <- "Plasma Error (Fig. 4)"
empirical.error <- RMSE(fit2sub)
for (this.cas in maternal.list)
{

  pred.table3[pred.table3$CAS==this.cas,"Ratio.pred"] <- signif(
    1/((1/pred.table1[pred.table3$CAS==this.cas,"Ratio.pred"])*
         (1-1.96*empirical.error)), 3)
}
# Update final table for paper:
PC.table$RMSE <- signif(RMSE(fit2sub),3)
PC.table$R.plasma.FtoM.upper <- pred.table3$Ratio.pred
```

### brain:plasma partitioning
```{r Rfetbrain, eval = execute.vignette}
pred.table4 <- pred.table1
pred.table4$Uncertainty <- "Fetal Brain Partitioning"
for (this.cas in maternal.list)
{
  print(this.cas)
  p <- parameterize_fetal_pbtk(chem.cas=this.cas,
      fetal_fup_adjustment=TRUE,
      suppress.messages=TRUE)
  Kbrain2pu <- p$Kfbrain2pu
  fup <- pred.table4[pred.table4$CAS==this.cas,"fup"]
  pred.table4[pred.table4$CAS==this.cas,"Ratio.pred"] <- signif(
     PC.table[PC.table$CAS==this.cas,"R.plasma.FtoM"]*
    Kbrain2pu * fup, 3)
  PC.table[PC.table$CAS==this.cas,"Kbrain2pu"] <- Kbrain2pu
  PC.table[PC.table$CAS==this.cas,"R.brain.FtoM"] <- 
    pred.table4[pred.table4$CAS==this.cas,"Ratio.pred"]
}
```

### brain:plasma uncertainty partitioning
```{r Rfetbrain_uncertainty, eval = execute.vignette}

pred.table5 <- pred.table1
pred.table5$Uncertainty <- "Brain Partitioning Error (Pearce et al., 2017)"
for (this.cas in maternal.list)
{                                             
  p <- parameterize_fetal_pbtk(chem.cas=this.cas,
      fetal_fup_adjustment=TRUE,
      suppress.messages=TRUE)
  Kbrain2pu <- p$Kfbrain2pu

  fup <- pred.table5[pred.table5$CAS==this.cas,"fup"]
  sigma.fup <- pred.table5[pred.table5$CAS==this.cas,"fup.sigma"]
  Rmatfet <- 1/PC.table[PC.table$CAS==this.cas,"R.plasma.FtoM"]
  Rbrain2matblood <- Kbrain2pu * fup / Rmatfet

# From Pearce et al. (2017) PC paper:
  sigma.logKbrain <- 0.647
  Kbrain2pu.upper <- signif(10^(log10(Kbrain2pu)+1.96*sigma.logKbrain),3)

  error.Rmatfet <- PC.table[PC.table$CAS==this.cas,"RMSE"]
  sigma.Rbrain2matblood <- Rbrain2matblood * 
    (log(10)^2*sigma.logKbrain^2 +
    sigma.fup^2/fup^2 +
    error.Rmatfet^2/Rmatfet^2)^(1/2)
  Rbrain2matblood.upper <- Rbrain2matblood * 
    (1 + 1.96*(log(10)^2*sigma.logKbrain^2 +
    sigma.fup^2/fup^2 +
    error.Rmatfet^2/Rmatfet^2)^(1/2))
  pred.table5[pred.table5$CAS==this.cas,"Ratio.pred"] <- 
    signif(Rbrain2matblood.upper,3)
  PC.table[PC.table$CAS==this.cas,"sigma.logKbrain"] <- 
    signif(sigma.logKbrain, 3)
  PC.table[PC.table$CAS==this.cas,"Kbrain2pu.upper"] <- 
    signif(Kbrain2pu.upper, 3)
  PC.table[PC.table$CAS==this.cas,"sigma.Rbrain2matblood"] <- 
    signif(sigma.Rbrain2matblood, 3)
  PC.table[PC.table$CAS==this.cas,"R.brain.FtoM.upper"] <- 
    pred.table5[pred.table5$CAS==this.cas,"Ratio.pred"]
}
```

### Combine different ratio predicitons together for figure
```{r Wang_Uncertainty_Propagation, eval = execute.vignette}

pred.levels <- pred.table5$Compound[order(pred.table5$Ratio.pred)]

pred.table <- rbind(
  pred.table1,
#  pred.table2,
  pred.table3,
  pred.table4,
  pred.table5)
pred.table$Compound <- factor(pred.table$Compound,
  levels = pred.levels)
  
pred.table$Uncertainty <- factor(pred.table$Uncertainty, 
  levels = c(pred.table1[1,"Uncertainty"],
#    pred.table2[1,"Uncertainty"],
    pred.table3[1,"Uncertainty"],
    pred.table4[1,"Uncertainty"],
    pred.table5[1,"Uncertainty"]))
```

## Make prioritization figure:
```{r wang2018_figure, eval = execute.vignette}
#Wang 2018 confirmed 6 chemical identities:
confirmed.chemicals <- c(
  "2,4-Di-tert-butylphenol",
  "2,4-Dinitrophenol",
  "Pyrocatechol",
  "2'-Hydroxyacetophenone",
  "3,5-Di-tert-butylsalicylic acid",
  "4-Hydroxycoumarin"
  )
confirmed.chemicals <- c(
  "96-76-4",
  "19715-19-6",
  "51-28-5",
  "120-80-9",
  "118-93-4",
  "1076-38-6")


FigG  <- ggplot(data=pred.table) +
  geom_point(aes(
    x=Ratio.pred,
    y=Compound,
    color = Uncertainty,
    shape = Uncertainty),
    size=3)   +
    scale_shape_manual(values=c(15, 16,2, 23, 0, 1, 17, 5, 6))+ 
  scale_x_log10(limits=c(10^-2,10^3),label=scientific_10)+
  ylab(expression(paste(
    "Chemicals Found in Maternal Plasma by Wang   ",italic("et al.")," (2018)"))) + 
  xlab("Predicted Ratio to Maternal Plasma") +
  theme_bw()  +
#  theme(legend.position="bottom")+
  theme( text  = element_text(size=14))+ 
  theme(legend.text=element_text(size=10))#+ 
 # guides(color=guide_legend(nrow=4,byrow=TRUE))+ 
  #guides(shape=guide_legend(nrow=4,byrow=TRUE))
  #+
 # theme(legend.justification = c(0, 0), legend.position = c(0, 0))
    
print(FigG)
```

## Look at ionization state:
```{r wang2018_details, eval = execute.vignette}

for (this.col in 7:14)
  PC.table[,this.col] <- signif(PC.table[,this.col],3)

PC.table <- PC.table[order(PC.table$R.brain.FtoM.upper,decreasing=TRUE),]

for (this.row in 1:dim(PC.table)[1])
{
  out <- calc_ionization(
    pH=7.26,
    pKa_Donor=PC.table[this.row,"pKa_Donor"],
    pKa_Accept=PC.table[this.row,"pKa_Accept"])
  if (out$fraction_neutral>0.9) PC.table[this.row,"Charge_726"] <- "Neutral"
  else if (out$fraction_positive>0.1) PC.table[this.row,"Charge_726"] <- 
    paste(signif(out$fraction_positive*100,2),"% Positive",sep="")
  else if (out$fraction_negative>0.1) PC.table[this.row,"Charge_726"] <- 
    paste(signif(out$fraction_negative*100,2),"% Negative",sep="")
  else if (out$fraction_zwitter>0.1) PC.table[this.row,"Charge_726"] <- 
    paste(signif(out$fraction_zwitter*100,2),"% Zwitterion",sep="")
}

PC.table <- PC.table[,c(
  "Compound",
  "CAS",
  "DTXSID",
  "logP",
  "Charge_726",
  "R.plasma.FtoM",
  "RMSE",
  "R.plasma.FtoM.upper",
  "Kbrain2pu",
  "fup",
  "R.brain.FtoM",
  "Kbrain2pu.upper",
  "R.brain.FtoM.upper")]

write.csv(PC.table,
  file="WangTable.txt",
  row.names=FALSE)   
```

## Evaluate any value added by PBPK model over just using partition coefficients:
```{r impact_of_model, eval = execute.vignette}
MFbrainfit <- lm(R.brain.FtoM.upper~Kbrain2pu.upper,data=PC.table)
summary(MFbrainfit)

cat(paste("As expected, the predicted fetal brain to maternal blood ratio was strongly correlated with the predicted brain partition coefficient (R2 = ",
  signif(summary(MFbrainfit)$adj.r.square,2),
  ", p-value ",
  signif(summary(MFbrainfit)$coefficients[2,4],2),
  "). However, the PBTK simulation impacted the plasma and tissue concentrations such that ",
  dim(subset(PC.table, rank(R.brain.FtoM.upper) <  rank(Kbrain2pu.upper)))[1],
  " chemicals were ranked higher than they would have been using partitioning alone.",
  sep=""))
```

# Repeat analysis without fetal protein binding change:

## Make predictions for fetal:maternal plasma ratio using three daily doses from week 13 to full term
```{r wang2018_makepreds_nofup, eval = execute.vignette}

pred.table1.nofup <- subset(get_cheminfo(
  info=c("Compound","CAS","DTXSID","logP","pka_accept","pka_donor"),
  model="fetal_pbtk",
  suppress.messages=TRUE),
  CAS %in% maternal.list)
pred.table1.nofup$Compound <- gsub("\"","",pred.table1.nofup$Compound)    

for (this.cas in maternal.list)
{
  Fup <- subset(get_cheminfo(
    info="all",
    suppress.messages=TRUE),
    CAS==this.cas)$Human.Funbound.plasma
  # Check if Fup is provided as a distribution:
  if (regexpr(",",Fup)!=-1)
  {
    if (as.numeric(strsplit(Fup,",")[[1]][1])==0 |
      (as.numeric(strsplit(Fup,",")[[1]][3])>0.9 & 
      as.numeric(strsplit(Fup,",")[[1]][2])<0.11))
    {
      skip <- TRUE
    } else skip <- FALSE
    Fup.upper <- as.numeric(strsplit(Fup,",")[[1]][3])
    Fup <- as.numeric(strsplit(Fup,",")[[1]][1])
    # These results are actually from a Bayesian posterior, but we can approximate that
    # they are normally distributed about the median to estimate a standard deviation:
    Fup.sigma <- (Fup.upper - Fup)/1.96
  # If it's not a distribution use defaults (see Wambaugh et al. 2019)
  } else if (as.numeric(Fup)== 0) 
  {
    skip <- TRUE
  } else {
    skip <- FALSE
    Fup <- as.numeric(Fup)
    Fup.sigma <- Fup*0.4
    Fup.upper  <- min(1,(1+1.96*0.4)*Fup)
  }
  
  # Only run the simulation if we have the necessary parameters:
  if (!skip)
  {  
    out <- solve_fetal_pbtk(
      chem.cas=this.cas,
      dose=0,
      daily.dose=1,
      doses.per.day=3,
      fetal_fup_adjustenment=FALSE,
      suppress.messages=TRUE)
    last.row <- which(out[,"time"]>279)
    last.row <- last.row[!duplicated(out[last.row,"time"])]
    pred.table1.nofup[pred.table1.nofup$CAS==this.cas,"fup"] <- signif(Fup,3)
    pred.table1.nofup[pred.table1.nofup$CAS==this.cas,"fup.sigma"] <- signif(Fup.sigma,3)
    pred.table1.nofup[pred.table1.nofup$CAS==this.cas,"fup.upper"] <- signif(Fup.upper,3)
    pred.table1.nofup[pred.table1.nofup$CAS==this.cas,"Ratio.pred"] <- 
      signif(mean(out[last.row,"Cfplasma"])/mean(out[last.row,"Cplasma"]),3)
  }
}
```


## Create final table holding all predictions for paper:
```{r brain_uncertainty_prop_table_nofup, eval = execute.vignette}
PC.table.nofup <- pred.table1.nofup
colnames(PC.table.nofup)[colnames(PC.table.nofup)=="Ratio.pred"] <- "R.plasma.FtoM"
pred.table1.nofup$Uncertainty <- "Predicted F:M Plasma Ratio"
```

### Error in fetal:maternal ratio (inverse of maternal:fetal ratio):
```{r Rfetmat_uncertainty_nofup, eval = execute.vignette}
pred.table3.nofup <- pred.table1.nofup
pred.table3.nofup$Uncertainty <- "Plasma Error (Fig. 4)"
empirical.error <- RMSE(fit2sub)
for (this.cas in maternal.list)
{

  pred.table3.nofup[pred.table3.nofup$CAS==this.cas,"Ratio.pred"] <- signif(
    1/((1/pred.table1.nofup[pred.table3.nofup$CAS==this.cas,"Ratio.pred"])*
         (1-1.96*empirical.error)), 3)
}
# Update final table for paper:
PC.table.nofup$RMSE <- signif(RMSE(fit2sub),3)
PC.table.nofup$R.plasma.FtoM.upper <- pred.table3.nofup$Ratio.pred
```

### brain:plasma partitioning
```{r Rfetbrain_nofup, eval = execute.vignette}
pred.table4.nofup <- pred.table1.nofup
pred.table4.nofup$Uncertainty <- "Fetal Brain Partitioning"
for (this.cas in maternal.list)
{
  p <- parameterize_fetal_pbtk(chem.cas=this.cas,
      fetal_fup_adjustment=FALSE,
      suppress.messages=TRUE)
  Kbrain2pu <- p$Kfbrain2pu
  fup <- pred.table4.nofup[pred.table4.nofup$CAS==this.cas,"fup"]
  pred.table4.nofup[pred.table4.nofup$CAS==this.cas,"Ratio.pred"] <- signif(
     PC.table.nofup[PC.table.nofup$CAS==this.cas,"R.plasma.FtoM"]*
    Kbrain2pu * fup, 3)
  PC.table.nofup[PC.table.nofup$CAS==this.cas,"Kbrain2pu"] <- Kbrain2pu
  PC.table.nofup[PC.table.nofup$CAS==this.cas,"R.brain.FtoM"] <- 
    pred.table4.nofup[pred.table4.nofup$CAS==this.cas,"Ratio.pred"]
}
```

### brain:plasma uncertainty partitioning
```{r Rfetbrain_uncertainty_nofup, eval = execute.vignette}

pred.table5.nofup <- pred.table1.nofup
pred.table5.nofup$Uncertainty <- "Brain Partitioning Error (Pearce et al., 2017)"
for (this.cas in maternal.list)
{                                             
  p <- parameterize_fetal_pbtk(chem.cas=this.cas,
      fetal_fup_adjustment=FALSE,
      suppress.messages=TRUE)
  Kbrain2pu <- p$Kfbrain2pu

  fup <- pred.table5.nofup[pred.table5.nofup$CAS==this.cas,"fup"]
  sigma.fup <- pred.table5.nofup[pred.table5.nofup$CAS==this.cas,"fup.sigma"]
  Rmatfet <- 1/PC.table[PC.table.nofup$CAS==this.cas,"R.plasma.FtoM"]
  Rbrain2matblood <- Kbrain2pu * fup / Rmatfet

# From Pearce et al. (2017) PC paper:
  sigma.logKbrain <- 0.647
  Kbrain2pu.upper <- signif(10^(log10(Kbrain2pu)+1.96*sigma.logKbrain),3)

  error.Rmatfet <- PC.table.nofup [PC.table.nofup $CAS==this.cas,"RMSE"]
  sigma.Rbrain2matblood <- Rbrain2matblood * 
    (log(10)^2*sigma.logKbrain^2 +
    sigma.fup^2/fup^2 +
    error.Rmatfet^2/Rmatfet^2)^(1/2)
  Rbrain2matblood.upper <- Rbrain2matblood * 
    (1 + 1.96*(log(10)^2*sigma.logKbrain^2 +
    sigma.fup^2/fup^2 +
    error.Rmatfet^2/Rmatfet^2)^(1/2))
  pred.table5.nofup [pred.table5.nofup $CAS==this.cas,"Ratio.pred"] <- 
    signif(Rbrain2matblood.upper,3)
  PC.table.nofup [PC.table.nofup $CAS==this.cas,"sigma.logKbrain"] <- 
    signif(sigma.logKbrain, 3)
  PC.table.nofup [PC.table.nofup $CAS==this.cas,"Kbrain2pu.upper"] <- 
    signif(Kbrain2pu.upper, 3)
  PC.table.nofup [PC.table.nofup $CAS==this.cas,"sigma.Rbrain2matblood"] <- 
    signif(sigma.Rbrain2matblood, 3)
  PC.table.nofup [PC.table.nofup $CAS==this.cas,"R.brain.FtoM.upper"] <- 
    pred.table5.nofup [pred.table5.nofup $CAS==this.cas,"Ratio.pred"]
}
```


```{r compare_fup_correction_case_study,eval=FALSE}
case.study.fup.correct.table <- merge(PC.table,PC.table.nofup,by=c("Compound","CAS","DTXSID"))

MFbrainfit.fup <- lm(R.brain.FtoM.upper.x~R.brain.FtoM.upper.y,
                     data=case.study.fup.correct.table)
summary(MFbrainfit.fup)

cat(paste("The predictions for fetal brain to maternal blood ratio with or without the fetal plasma binding correction (Eqn. 1) were strongly correlated (R2 = ",
  signif(summary(MFbrainfit.fup)$adj.r.square,2),
  "). There were ",
  dim(subset(case.study.fup.correct.table, 
             rank(R.brain.FtoM.upper.x) > rank(R.brain.FtoM.upper.y)))[1],
  " chemicals that were ranked higher with the correction than without, with an average increase of ",
  signif(mean(
    case.study.fup.correct.table$R.brain.FtoM.upper.y /
      case.study.fup.correct.table$R.brain.FtoM.upper.x),2),
  " times when the plasma binding change was included.\n",
  sep=""))

```







The next two figures take a long time to generate and so are disabled by default.

# Protein Binding Figures

The fetal fraction unbound (f_{up}^f i) is calculated from the maternal fraction unbound and the serum protein concentration ratio in infants vs. mothers based on Equation 6 of [McNamara et al., 2019](http://dx.doi.org/10.1208/ps040104),

$$
	f_{up}^f =(f_{up}^m )/(f_{up}^m +(P^f /P^m  )*(1-f_{up}^m  ) )
$$

in which the maternal fraction unbound, $f_{up}^m$, is assumed to be equal to 
the in vitro measured value for fraction unbound in plasma, and the ratio of 
protein concentrations $P^f /P^m$ depends on the identity of the dominant 
binding protein for the chemical (assumed to be either albumin or AAG). Lacking 
data to model the gestational kinetics of albumin and AAG concentrations, we 
used the concentrations at birth ([McNamara et al., 2019]
(http://dx.doi.org/10.1208/ps040104)) to calculate a constant fetal $f_{up}$, 
using $P^f/P^m  =0.777$ for albumin and $P^f/P^m = 0.456$ for AAG 
([McNamara et al., 2019](http://dx.doi.org/10.1208/ps040104)). We determine the 
charge state of a compound separately for maternal and fetal plasma as a 
function of plasma pH (7.38 for maternal and 7.28 for fetal ([K.H. Lee, 1972]
(http://dx.doi.org/10.1136/pgmj.48.561.405)) and chemical-specific predictions 
for ionization affinity (that is, pKa ([Strope et al., 2018]
(http://dx.doi.org/10.1016/j.scitotenv.2017.09.033)) using the "httk" function 
"calc_ionization" ([Pearce et al.,  2017]
(http://dx.doi.org/10.1007/s10928-017-9548-7)). If the fraction of a chemical 
that is predicted to be in positive ionic form is greater than 50%, we treat 
the chemical as a base (which is in its conjugate acid form) and use only the 
maternal-to-infant ratio of AAG concentrations. Otherwise, we assume the 
chemical is neutral or an acid and use the ratio of albumin concentrations. 

```{r fup_table, eval = execute.vignette}
fup.table <- NULL
all.chems <- get_cheminfo(
  model="fetal_pbtk",
  info="all",
  suppress.messages=TRUE) 
# Get rid of median fup 0:
all.chems <- subset(all.chems,
  as.numeric(unlist(lapply(strsplit(
    all.chems$Human.Funbound.plasma,","),function(x) x[[1]])))!=0)
for (this.chem in all.chems[,"CAS"])
{
  temp <- parameterize_fetal_pbtk(chem.cas=this.chem,suppress.messages = TRUE)
  state <- calc_ionization(
      pH=7.26,
      pKa_Donor=temp$pKa_Donor,
      pKa_Accept=temp$pKa_Accept)
  if (state$fraction_positive > 0.5) this.charge <- "Positive"
  else if (state$fraction_negative > 0.5) this.charge <- "Negative"
  else this.charge <- "Neutral"
  this.row <- data.frame(DTXSID=all.chems[all.chems[,"CAS"]==this.chem,"DTXSID"],
    Compound=all.chems[all.chems[,"CAS"]==this.chem,"Compound"],
    CAS=this.chem,
    Fup.Mat.Pred = temp$Funbound.plasma,
    Fup.Neo.Pred = temp$Fraction_unbound_plasma_fetus,
    Charge = this.charge
    )
  fup.table <- rbind(fup.table,this.row)
}

fup.table[fup.table$Charge=="Positive","Charge"] <- paste("Positive (n=",
  sum(fup.table$Charge=="Positive"),
  ")",sep="")
fup.table[fup.table$Charge=="Negative","Charge"] <- paste("Negative (n=",
  sum(fup.table$Charge=="Negative"),
  ")",sep="")
fup.table[fup.table$Charge=="Neutral","Charge"] <- paste("Neutral (n=",
  sum(fup.table$Charge=="Neutral"),
  ")",sep="")
```  

## Plot the fetal protein binding changes predicted:
```{r fup_figure, eval = execute.vignette}
FigA  <- ggplot(data=fup.table) +
  geom_point(alpha=0.25, aes(
    x=Fup.Mat.Pred,
    y=Fup.Neo.Pred,
    shape=Charge,
    color=Charge),
    size=3)   +
  geom_abline(slope=1, intercept=0) + 
  ylab(expression(paste("Adjusted Neonate ",f[up]))) + 
  xlab(expression(paste(italic("In vitro")," Measured Adult ",f[up]))) +
   scale_x_log10(label=scientific_10) +
   scale_y_log10(label=scientific_10) +
  theme_bw()  +
  theme( text  = element_text(size=14)) 
    
print(FigA) 
```  

## Maternal-Fetal Predictions across HTTK Chemical Library:
```{r MFratio_allhttk_preds, eval = execute.vignette}
times <- sort(unique(c(seq(13 * 7, 40 * 7, 0.25),seq(278,280,.1))))
  
MFratio.pred <- NULL
all.chems <- get_cheminfo(
  model="fetal_pbtk", 
  info=c("Compound","DTXSID","CAS","Funbound.plasma"),
  suppress.messages=TRUE)
for (this.cas in all.chems$CAS)
  if ((this.cas %in% nonvols) & 
    !(this.cas %in% fluoros))
{
  this.id <- all.chems[all.chems$CAS==this.cas,"DTXSID"]
  Fup <- subset(all.chems,DTXSID==this.id)$Human.Funbound.plasma 
  if (regexpr(",",Fup)!=-1)
  {
    if (as.numeric(strsplit(Fup,",")[[1]][1])==0 |
      (as.numeric(strsplit(Fup,",")[[1]][3])>0.9 & 
      as.numeric(strsplit(Fup,",")[[1]][2])<0.1))
    {
      skip <- TRUE
    } else skip <- FALSE
  } else if (Fup== 0) 
  {
    skip <- TRUE
  } else skip <- FALSE
  
  if (!skip)
  {  
    p <- parameterize_fetal_pbtk(dtxsid=this.id,
    fetal_fup_adjustment =TRUE,
    suppress.messages=TRUE)
    out <- solve_fetal_pbtk(
      parameters=p,
      dose=0,
      times=times,
      daily.dose=1,
      doses.per.day=3,
      output.units = "uM",
      suppress.messages=TRUE)
    last.row <- which(out[,"time"]>279)
    last.row <- last.row[!duplicated(out[last.row,"time"])]
    new.row <- data.frame(
      Chemical = all.chems[all.chems$DTXSID==this.id,"Compound"],
      DTXSID = this.id,
      Mat.pred = mean(out[last.row,"Cplasma"]),
      Fet.pred = mean(out[last.row,"Cfplasma"]),
      MFratio.pred = mean(out[last.row,"Cplasma"])/mean(out[last.row,"Cfplasma"])
      )
    MFratio.pred <- rbind(MFratio.pred,new.row)
  }
  }
```

## Histogram of maternal-fetal ratio
```{r MFratio_allhttk_figure, eval = execute.vignette}
FigD <- ggplot(data=MFratio.pred)+
   geom_histogram(binwidth = 0.05,fill="Red",aes(MFratio.pred))+ 
  xlab("Maternal:Fetal Plasma Concentration Ratio") +
  ylab("Number of chemicals")+
    theme_bw()+
    theme( text  = element_text(size=14))
    

print(FigD)
```

## Statistics on maternal-fetal ratio for full HTTK library
```{r MFratio_allhttk_stats, eval = execute.vignette}
max.chem <- MFratio.pred[which(
  MFratio.pred$MFratio.pred==max(MFratio.pred$MFratio.pred,na.rm=TRUE)),]
min.chem <- MFratio.pred[which(
  MFratio.pred$MFratio.pred==min(MFratio.pred$MFratio.pred,na.rm=TRUE)),]
cat(paste("In Figure X we examine the ratios predicted for the ",
  dim(MFratio.pred)[1],
  " appropriate (non-volatile or PFAS) chemicals with measured HTTK data.\n",
  sep=""))


cat(paste("We observe a median ratio of ",
  signif(median(MFratio.pred$MFratio.pred,na.rm=TRUE),3),
  ", with values ranging from ",
  signif(min.chem[,"MFratio.pred"],3),
  " for ",
  min.chem[,"DTXSID"],
  " to ",
  signif(max.chem[,"MFratio.pred"],3),
  " for ",
  max.chem[,"DTXSID"],
  ".\n",sep=""))
  
# Check out phys-chem > 1.6, < 1:
highratio <- subset(chem.physical_and_invitro.data,DTXSID%in%subset(MFratio.pred,MFratio.pred>1.6)$DTXSID)

cat(paste("There are",
  dim(highratio)[1],
  "chemicals with ratios greater than 1.6, indicating a tendency to have higher concentrations"))

# all highly bound
highratio$Compound
suppressWarnings(apply(highratio,2,function(x) mean(as.numeric(x),na.rm=TRUE)))


lowratio <- subset(chem.physical_and_invitro.data,DTXSID%in%subset(MFratio.pred,MFratio.pred<0.9)$DTXSID)
# No obvious pattern
```
## Examine Maternal-Fetal ratio Predictions without fetaul Fup correction:
```{r MFratio_allhttk_preds_nofup, eval = execute.vignette}
times <- sort(unique(c(seq(13 * 7, 40 * 7, 0.25),seq(278,280,.1))))
  
MFratio.pred.nofup <- NULL
all.chems <- get_cheminfo(
  model="fetal_pbtk", 
  info=c("Compound","DTXSID","CAS","Funbound.plasma"),
  suppress.messages=TRUE)
for (this.cas in all.chems$CAS)
  if ((this.cas %in% nonvols) & 
    !(this.cas %in% fluoros))
{
  this.id <- all.chems[all.chems$CAS==this.cas,"DTXSID"]
  Fup <- subset(all.chems,DTXSID==this.id)$Human.Funbound.plasma 
  if (regexpr(",",Fup)!=-1)
  {
    if (as.numeric(strsplit(Fup,",")[[1]][1])==0 |
      (as.numeric(strsplit(Fup,",")[[1]][3])>0.9 & 
      as.numeric(strsplit(Fup,",")[[1]][2])<0.1))
    {
      skip <- TRUE
    } else skip <- FALSE
  } else if (Fup== 0) 
  {
    skip <- TRUE
  } else skip <- FALSE
  
  if (!skip)
  {  
    p <- parameterize_fetal_pbtk(dtxsid=this.id,
    fetal_fup_adjustment =FALSE,
    suppress.messages=TRUE))
    out <- suppressWarnings(solve_fetal_pbtk(
      parameters=p,
      dose=0,
      times=times,
      daily.dose=1,
      doses.per.day=3,
      output.units = "uM",
      suppress.messages=TRUE)
    last.row <- which(out[,"time"]>279)
    last.row <- last.row[!duplicated(out[last.row,"time"])]
    new.row <- data.frame(
      Chemical = all.chems[all.chems$DTXSID==this.id,"Compound"],
      DTXSID = this.id,
      Mat.pred = mean(out[last.row,"Cplasma"]),
      Fet.pred = mean(out[last.row,"Cfplasma"]),
      MFratio.pred = mean(out[last.row,"Cplasma"])/mean(out[last.row,"Cfplasma"])
      )
    MFratio.pred.nofup <- rbind(MFratio.pred.nofup,new.row)
  }
  }
```
## Supplemental Histogram of maternal-fetal ratio without Fup correction
```{r MFratio_allhttk_figure_nofup, eval = execute.vignette}
FigSupD <- ggplot(data=MFratio.pred.nofup)+
   geom_histogram(binwidth = 0.05,fill="Red",aes(MFratio.pred))+ 
  xlab("Maternal:Fetal Plasma Concentration Ratio (No Fup Corr.)") +
  ylab("Number of chemicals")+
    theme_bw()+
    theme( text  = element_text(size=14))
    

print(FigSupD)
```
## Statistics on maternal-fetal ratio for full HTTK library without Fup correction
```{r MFratio_allhttk_stats_nofup, eval = execute.vignette}
max.chem <- MFratio.pred.nofup[which(
  MFratio.pred.nofup$MFratio.pred==max(MFratio.pred.nofup$MFratio.pred,na.rm=TRUE)),]
min.chem <- MFratio.pred.nofup[which(
  MFratio.pred.nofup$MFratio.pred==min(MFratio.pred.nofup$MFratio.pred,na.rm=TRUE)),]
cat(paste("In Figure X we examine the ratios predicted for the ",
  dim(MFratio.pred)[1],
  " appropriate (non-volatile or PFAS) chemicals with measured HTTK data.\n",
  sep=""))


cat(paste("We observe a median ratio of ",
  signif(median(MFratio.pred.nofup$MFratio.pred,na.rm=TRUE),3),
  ", with values ranging from ",
  signif(min.chem[,"MFratio.pred"],3),
  " for ",
  min.chem[,"DTXSID"],
  " to ",
  signif(max.chem[,"MFratio.pred"],3),
  " for ",
  max.chem[,"DTXSID"],
  ".\n",sep=""))
  
# Check out phys-chem > 1.6, < 1:
highratio <- subset(chem.physical_and_invitro.data,DTXSID%in%subset(MFratio.pred.nofup,MFratio.pred>1.6)$DTXSID)

cat(paste("There are",
  dim(highratio)[1],
  "chemicals with ratios greater than 1.6, indicating a tendency to have higher concentrations"))

# all highly bound
highratio$Compound
suppressWarnings(apply(highratio,2,function(x) mean(as.numeric(x),na.rm=2)))


lowratio <- subset(chem.physical_and_invitro.data,DTXSID%in%subset(MFratio.pred.nofup,MFratio.pred<0.9)$DTXSID)
# No obvious pattern
```

# Code used to create data distributed with vignette
```{r create_distributable_data, eval = execute.vignette}
aylward2014 <-MFdata
pregnonpregaucs <- TKstats
fetalpcs <- Curley.pcs
wang2018 <- Wangchems

save(aylward2014,pregnonpregaucs,fetalpcs,wang2018,pksim.pcs,
     file="Kapraun2022Vignette.RData",version=2)
```

---
title: "Linakis et al. (2020): High Throughput Inhalation Model"
author: "Matt Linakis"
date: "January 30, 2020"
output: rmarkdown::html_vignette
highlight: tango
vignette: >
 %\VignetteIndexEntry{h) Linakis (2020): High Throughput Inhalation Model}
 %\VignetteEngine{knitr::rmarkdown}
 %\VignetteEncoding{UTF-8}
---
*Please send questions to mlinak01@gmail.com or John.Wambaugh@UL.org*

from "Development and evaluation of a high throughput inhalation model for 
organic chemicals"

Matthew W. Linakis, Risa R. Sayre, Robert G. Pearce, Mark A. Sfeir, 
Nisha S. Sipes, Heather A. Pangburn, Jeffery M. Gearhart, and John F. Wambaugh 

Journal of Exposure Science & Environmental Epidemiology volume 30, 
pages 866–877 (2020)

https://doi.org/10.1038/s41370-020-0238-y

## Abstract

Currently it is difficult to prospectively estimate human toxicokinetics 
(particularly for novel chemicals) in a high-throughput manner. The R software 
package httk has been developed, in part, to address this deficiency, and the 
aim of this investigation was to develop a generalized inhalation model for httk. 
The structure of the inhalation model was developed from two previously published 
physiologically-based models from Jongeneelen et al. (2011) and Clewell et al. 
(2001) while calculated physicochemical data was obtained from EPA's CompTox 
Chemicals Dashboard. In total, 142 exposure scenarios across 41 volatile organic 
chemicals were modeled and compared to published data. The slope of the regression 
line of best fit between log-transformed simulated and observed combined measured 
plasma and blood concentrations was 0.59 with an r2= 0.54 and a Root Mean Square 
Error (RMSE) of direct comparison between the log-transformed simulated and 
observed values of 0.87. Approximately 3.6% (n = 73) of the data points analyzed 
were > 2 orders of magnitude different than expected. The volatile organic 
chemicals examined in this investigation represent small, generally lipophilic 
molecules. Ultimately this paper details a generalized inhalation component that 
integrates with the httk physiologically-based toxicokinetic model to provide 
high-throughput estimates of inhalation chemical exposures.

## HTTK Version

This vignette was created with **httk** v2.0.0. Although we attempt to maintain 
backward compatibility, if you encounter issues with the latest release of 
**httk**
and cannot easily address the changes, historical versions of httk are 
available from: https://cran.r-project.org/src/contrib/Archive/httk/

## Prepare for session
R package **knitr** generates html and PDF documents from this RMarkdown file,
Each bit of code that follows is known as a "chunk". We start by telling 
**knitr** how we want our chunks to look.
```{r configure_knitr, eval = TRUE}
knitr::opts_chunk$set(echo = TRUE, fig.width=5, fig.height=4)
```

### Clear the memory
It is a bad idea to let variables and other information from previous R
sessions float around, so we first remove everything in the R memory.
```{r clear_memory, eval = TRUE}
rm(list=ls()) 
```

### eval = execute.vignette
If you are using the RMarkdown version of this vignette (extension, .RMD) you
will be able to see that several chunks of code in this vignette
have the statement "eval = execute.vignette". The next chunk of code, by default,
sets execute.vignette = FALSE.  This means that the code is included (and necessary) but was
not run when the vignette was built. We do this because some steps require 
extensive computing time and the checks on CRAN limit how long we can spend
building the package. If you want this vignette to work, you must run all code,
either by cutting and pasting it into R. Or, if viewing the .RMD file, you can
either change execute.vignette to TRUE or press "play" (the green arrow) on
each chunk in RStudio.
```{r runchunks, eval = TRUE}
# Set whether or not the following chunks will be executed (run):
execute.vignette <- FALSE
```

### Load the relevant libraries
We use the command 'library()' to load various R packages for our analysis.
If you get the message "Error in library(X) : there is no package called 'X'"
then you will need to install that package: 

From the R command prompt:

install.packages("X")

Or, if using RStudio, look for 'Install Packages' under 'Tools' tab.
```{r setup, eval = execute.vignette}
knitr::opts_chunk$set(echo = TRUE, fig.width=5, fig.height=4)
library(httk)
library(httkexamples)
library(ggplot2)
library(gridExtra)
library(cowplot)
library(ggrepel)
library(dplyr)
library(stringr)
library(forcats)
library(smatr)
library(scales)

# Path to working director:
LOC.WD <- tempdir()
```
### Get metabolism and concentration data 

The table httk::concentration_data_Linakis2020 contains CvTdb data 
(Sayre, et al. 2020) for inhalation exposure. The units of all measurements have
been converted to uM concentrations.

```{r data, eval = execute.vignette}
met_data <- httkexamples::metabolism_data_Linakis2020
conc_data <- httkexamples::concentration_data_Linakis2020
#conc_data <- subset(concentration_data_Linakis2020, !(SAMPLING_MATRIX %in%
#                      c("EEB","MEB","EB")))
#conc_data <- concentration_data_Linakis2020
#  subset(concentration_data_Linakis2020, !(SOURCE_CVT %in% c(
#  "11453305")))
conc_data[,"DOSE_U"] <- ifelse(conc_data[,"DOSE_U"] == "ppm",
                               yes = "ppmv",
                               conc_data[,"DOSE_U"]) 
conc_data[,"ORIG_CONC_U"] <- ifelse(conc_data[,"ORIG_CONC_U"] == "ppm",
                                    yes = "ppmv",
                                    conc_data[,"ORIG_CONC_U"]) 
# Not sure what to do with percent:
conc_data <- subset(conc_data,toupper(ORIG_CONC_U) != "PERCENT")
# Rename this column:
colnames(conc_data)[colnames(conc_data)=="ORIG_CONC_U"] <- "CONC_U"
conc_data$ORIGINAL_CONC_U <- conc_data$CONC_U
conc_data$ORIGINAL_CONC <- conc_data$CONCENTRATION
# Maybe Linakis et al translated all concentrations to uM?
conc_data$CONC_U <- "uM"
```

Sets the units based on the sampling matrix (gas/liquid):
  BL : blood
  EEB : end-exhaled breath
  MEB : mixed exhaled breath
  VBL : venous blood
  ABL : arterial blood
  EB : unspecified exhaled breath sample (assumed to be EEB)
  PL: plasma
  +W with work/exercise
    
Normalize units for gaseous samples to ppmv:
```{r convert_to_ppmweight, eval = FALSE}
gas.media <- c("EB","MEB","EEB","EB (+W)")
gas.units <- unique(subset(conc_data,
  SAMPLING_MATRIX %in% gas.media)$CONC_U)
target.unit <- "ppmv"
for (this.unit in gas.units)
  if (this.unit != target.unit)
  {
    these.chems <- unique(subset(conc_data,
      SAMPLING_MATRIX %in% gas.media &
      CONC_U==this.unit)$DTXSID)    
    for (this.chem in these.chems)  
    {
      this.factor <- convert_units(
        input.units=this.unit, 
        output.units=target.unit, 
        dtxsid=this.chem, state="gas")
      print(paste("Use",this.factor,"to convert",this.unit,"to",target.unit))
      
      # Scale the observation    
      conc_data[conc_data$DTXSID==this.chem &
                  conc_data$SAMPLING_MATRIX %in% gas.media &
                  conc_data$CONC_U==this.unit,"CONCENTRATION"] <-
        this.factor * conc_data[
          conc_data$DTXSID==this.chem &
            conc_data$SAMPLING_MATRIX %in% gas.media &
            conc_data$CONC_U==this.unit,"CONCENTRATION"]
      # Change the reported unit
      conc_data[conc_data$DTXSID==this.chem &
                  conc_data$SAMPLING_MATRIX %in% gas.media &
                  conc_data$CONC_U==this.unit,"CONC_U"] <-
        target.unit

    }
  }
```

Normalize the units for tissue samples to uM:
```{r normalize_other_units, eval = FALSE}
tissue.media <- c("VBL","BL","ABL","PL","BL (+W)")
tissue.units <- unique(subset(conc_data,
  SAMPLING_MATRIX %in% tissue.media)$CONC_U)
target.unit <- "uM"
for (this.unit in tissue.units)
  if (this.unit != target.unit)
  {
    these.chems <- unique(subset(conc_data,
      SAMPLING_MATRIX %in% tissue.media &
      CONC_U==this.unit)$DTXSID)    
    for (this.chem in these.chems)  
    {
      this.factor <- try(convert_units(
        input.units=this.unit, 
        output.units=target.unit, 
        dtxsid=this.chem))
      print(paste("Use",this.factor,"to convert",this.unit,"to",target.unit))
      
      # Scale the observation    
      conc_data[conc_data$DTXSID==this.chem &
                  conc_data$SAMPLING_MATRIX %in% tissue.media &
                  conc_data$CONC_U==this.unit,"CONCENTRATION"] <-
        this.factor * conc_data[
          conc_data$DTXSID==this.chem &
            conc_data$SAMPLING_MATRIX %in% tissue.media &
            conc_data$CONC_U==this.unit,"CONCENTRATION"]
      # Change the reported unit
      conc_data[conc_data$DTXSID==this.chem &
                  conc_data$SAMPLING_MATRIX %in% tissue.media &
                  conc_data$CONC_U==this.unit,"CONC_U"] <-
        target.unit

    }
  }
```

## ANALYSIS

Identify chemicals currently in our metabolism data that we don't have good
concentration/time data for and remove them from our training dataset

### Data summary for chemical properties
```{r summary, eval = execute.vignette}
# Small molecule chemicals
summary(met_data$AVERAGE_MASS)
# Generally more lipophilic chemicals
summary(met_data$OCTANOL_WATER_PARTITION_LOGP_OPERA_PRED)
# Unsurprisingly then, the chemicals are generally less water-soluble
summary(met_data$WATER_SOLUBILITY_MOL.L_OPERA_PRED)
# ~60% of samples in humans
table(conc_data$CONC_SPECIES)/nrow(conc_data)*100
# ~72% of samples are from blood
table(conc_data$SAMPLING_MATRIX)/nrow(conc_data)*100
```

### Exposure scenarios
```{r scenarios, eval = execute.vignette}
# Create a dataframe with 1 row for each unique external exposure scenario
unique_scenarios <- conc_data[with(conc_data,                             
  order(PREFERRED_NAME,
        CONC_SPECIES,
        SAMPLING_MATRIX,
        as.numeric(as.character(DOSE)),EXP_LENGTH,-TIME)),] %>%
  distinct(DTXSID,DOSE,DOSE_U,EXP_LENGTH,CONC_SPECIES,SAMPLING_MATRIX, .keep_all = TRUE)
```

### Observations and Predictions
Create a list of dataframes of observed and predicted concentrations
for each unique external exposure scenario (corresponding to 142 studies)
```{r runmodel, eval = execute.vignette}
# Store the output of each simulation:
simlist <- list()
# Store the Cvt data relevant to each simulation
obslist <- list()
# Conduct one simulation for each unique combination of chemical, species, dose:
for (i in 1:nrow(unique_scenarios))
  if (unique_scenarios$CASRN[i] %in% get_cheminfo(model="gas_pbtk",
                                                  suppress.messages = TRUE))
{
  # Identify relevant Cvt data:
    relconc <- subset(conc_data,conc_data$DTXSID == unique_scenarios$DTXSID[i] & 
      conc_data$DOSE == unique_scenarios$DOSE[i] & 
      conc_data$EXP_LENGTH == unique_scenarios$EXP_LENGTH[i] & 
      conc_data$CONC_SPECIES == unique_scenarios$CONC_SPECIES[i] & 
      conc_data$SAMPLING_MATRIX == unique_scenarios$SAMPLING_MATRIX[i])
    obslist[[i]] <- relconc
#
#
#
#
#
# THE FOLLOWING CODE RUNS solve_gas_pbtk FOR EACH SCENARIO 
# (UNIQUE COMBINATION OF CHEMICAL, SPECIES, DOSE, ETC.)
#
#
#
#
#
    solver.out <- try(suppressWarnings(as.data.frame(solve_gas_pbtk(
        chem.cas = unique_scenarios$CASRN[i], 
        days = signif(max(obslist[[i]]$TIME)+0.25,2), 
# Make sure we get predicted conc's at the observed times (in days):
        times=sort(unique(c(0, # Start time
                            1e-3, # Small time after time zero
                            signif(obslist[[i]]$TIME,4), # Times with CvT observations 
                            signif(unique_scenarios$EXP_LENGTH[i],4) # When the exposure stops
                   ))), # days
        tsteps = 4,
        exp.conc = as.numeric(unique_scenarios$DOSE[i]), # SED (06-22-2021) think this is ppmv for all scenarios
        input.units = unique_scenarios$DOSE_U[i], # specify the units for exp.conc (ppmv)
        output.units="uM",
        exp.duration = signif(unique_scenarios$EXP_LENGTH[i],4)*24, # solve_gas_pbtk expects hourse 
        period = 0, # simulate single dose
        species = as.character(unique_scenarios$CONC_SPECIES[i]),
        monitor.vars = c(
          "Cven", 
          "Clung", 
          "Cart", 
          "Cplasma", 
          "Calvppmv", 
          "Cendexhppmv", 
          "Cmixexhppmv", 
          "Calv", 
          "Cendexh", 
          "Cmixexh", 
          "Cmuc", 
          "AUC"),
        vmax.km = FALSE,
        suppress.messages = TRUE,
        hmin=1e-12#,
       # method="rk4"
   ))))
#
#
#
#
#
#
#
#
#
#
    if (class(solver.out) %in% "try-error") 
      solver.out <- data.frame(time=NA,Conc=NA)
    
 #   print(solver.out)
# Get the blood:plasma ratio:
    this.Rb2p <- suppressWarnings(available_rblood2plasma(
      chem.cas=unique_scenarios$CASRN[i],
      species=as.character(unique_scenarios$CONC_SPECIES[i])))
    solver.out$Rb2p <- this.Rb2p
    
    # The column simconc holds the appropriate prediction for the sampling matrix
    # BL : blood
    # EEB : end-exhaled breath
    # MEB : mixed exhaled breath
    # VBL : venous blood
    # ABL : arterial blood
    # EB : unspecified exhaled breath sample (assumed to be EEB)
    # PL: plasma
    # +W with work/exercise
    #
    # The model outputs are provided in the following units:
	  # uM: Cven, Clung, Cart, Cplasma, Calv, Cendexh, Cmixexh, Cmuc
	  # ppmv: Calvppmv, Cendexhppmv, Cmixexhppmv
	  # uM*days: AUC
    if (unique_scenarios$SAMPLING_MATRIX[i] == "VBL" | 
      unique_scenarios$SAMPLING_MATRIX[i] == "BL" | 
      unique_scenarios$SAMPLING_MATRIX[i] == "BL (+W)")
    {
      solver.out$simconc <- solver.out$Cven*this.Rb2p
      solver.out$unit <- "uM"
    } else if (unique_scenarios$SAMPLING_MATRIX[i] == "ABL") {
      solver.out$simconc <- solver.out$Cart*this.Rb2p
      solver.out$unit <- "uM"
    } else if (unique_scenarios$SAMPLING_MATRIX[i] == "EB" |
      unique_scenarios$SAMPLING_MATRIX[i] == "EEB" | 
      unique_scenarios$SAMPLING_MATRIX[i] == "EB (+W)")
    {
      solver.out$simconc <- solver.out$Cendexh # uM
      solver.out$unit <- "uM"
    } else if (unique_scenarios$SAMPLING_MATRIX[i] == "MEB") {
        solver.out$simconc <- solver.out$Cmixexh # uM
        solver.out$unit <- "uM"
    } else if (unique_scenarios$SAMPLING_MATRIX[i] == "PL") {
      solver.out$simconc <- solver.out$Cplasma
      solver.out$unit <- "uM"
    } else {
      solver.out$simconc <- NA
      solver.out$unit <- NA
    }
    simlist[[i]] <- solver.out
}
```


Create a predicted vs. observed plot for each study:
```{r Makestudyplots, eval = execute.vignette}
cvtlist <- list()
for(i in 1:nrow(unique_scenarios))
{
    plot.data <- simlist[[i]]
    relconc <- obslist[[i]]

    if (!is.null(plot.data))
    {
#Right now this is only calculating real concentrations according to mg/L in blood
    cvtlist[[i]] <- ggplot(data=plot.data, aes(time*24, simconc)) + 
      geom_line() + 
      xlab("Time (h)") + 
      ylab(paste0("Simulated ", 
        unique_scenarios$SAMPLING_MATRIX[i], 
        "\nConcentration (" , 
        solver.out$unit, ")")) + 
      ggtitle(paste0(
        unique_scenarios$PREFERRED_NAME[i],
        " (", 
        unique_scenarios$CONC_SPECIES[i], 
        ", ",
        round(as.numeric(unique_scenarios$DOSE[i]), digits = 2),
        unique_scenarios$DOSE_U[i], 
        " for ",
        round(unique_scenarios$EXP_LENGTH[i]*24, digits = 2),
        "h in ", 
        unique_scenarios$SAMPLING_MATRIX[i], ")")) + 
      geom_point(data = relconc, aes(TIME*24,CONCENTRATION)) + 
      theme(plot.title = element_text(face = 'bold', size = 20),
        axis.title.x = element_text(face = 'bold', size = 20), 
        axis.text.x = element_text(size=16), 
        axis.title.y = element_text(face = 'bold', size = 20), 
        axis.text.y = element_text(size = 16),
        legend.title = element_text(face = 'bold', size = 16),
        legend.text = element_text(face = 'bold',size = 14))+
      theme_bw() 
    }
}
```

Create a list to hold the combined observations and predictions for each scenario:
```{r init_dataset, eval = execute.vignette}
# Creation of simulated vs. observed concentration dataset
unique_scenarios$RSQD <- 0
unique_scenarios$RMSE <- 0
unique_scenarios$AIC <- 0
simobslist <- list()
obvpredlist <- list()
```

Merge the simulations and observations on the basis of simulation time:
```{r merge_datasets, eval = execute.vignette}
for(i in 1:length(simlist))
{
  obsdata <- as.data.frame(obslist[[i]])
  simdata <- as.data.frame(simlist[[i]])
# skips over anything for which there was no observed data or 
# insufficient information to run simulation:
  if (!is.null(simdata) & 
      !is.null(obsdata) &
      dim(simdata)[1]>1)
  { 
# Make sure we are looking at consistent time points:
    simobscomb <- simdata[simdata$time %in% signif(obsdata$TIME,4),]
    obsdata <- subset(obsdata,signif(TIME,4) %in% simobscomb$time)
# Merge with obsdata
    colnames(obsdata)[colnames(obsdata) ==
      "TIME"] <- 
      "obstime"
# Round to match sim time:
    obsdata$time <- signif(obsdata$obstime,4)
    colnames(obsdata)[colnames(obsdata) ==
      "CONCENTRATION"] <- 
      "obsconc"
    colnames(obsdata)[colnames(obsdata) ==
      "PREFERRED_NAME"] <- 
      "chem"
    colnames(obsdata)[colnames(obsdata) ==
      "DOSE"] <- 
      "dose"
    colnames(obsdata)[colnames(obsdata) ==
      "EXP_LENGTH"] <- 
      "explen"
    colnames(obsdata)[colnames(obsdata) ==
      "CONC_SPECIES"] <- 
      "species"
    colnames(obsdata)[colnames(obsdata) ==
      "SAMPLING_MATRIX"] <- 
      "matrix"
    colnames(obsdata)[colnames(obsdata) ==
      "AVERAGE_MASS"] <- 
      "mw"
    colnames(obsdata)[colnames(obsdata) ==
      "CONC_U"] <- 
      "CONC_U"
    simobscomb <- suppressWarnings(merge(obsdata[,c(
      "time",
      "obstime",
      "obsconc",
      "chem",
      "dose",
      "explen",
      "species",
      "matrix",
      "mw",
      "CONC_U",
      "ORIGINAL_CONC_U"
      )], simobscomb, by="time", all.x=TRUE))

# Merge with met_data
    this.met_data <- subset(met_data,
      PREFERRED_NAME == simobscomb[1,"chem"] &
      SPECIES == simobscomb[1,"species"])
    colnames(this.met_data)[colnames(this.met_data)=="CHEM_CLASS"] <-
      "chemclass"
    colnames(this.met_data)[colnames(this.met_data) ==
      "OCTANOL_WATER_PARTITION_LOGP_OPERA_PRED"] <-
      "logp"
    colnames(this.met_data)[colnames(this.met_data) ==
      "WATER_SOLUBILITY_MOL.L_OPERA_PRED"] <-
      "sol"
    colnames(this.met_data)[colnames(this.met_data) ==
      "HENRYS_LAW_ATM.M3.MOLE_OPERA_PRED"] <-
      "henry"
    colnames(this.met_data)[colnames(this.met_data) ==
      "VMAX"] <-
      "vmax"
    colnames(this.met_data)[colnames(this.met_data) ==
      "KM"] <-
      "km"
    simobscomb <- suppressWarnings(cbind(simobscomb,this.met_data[c(
      "chemclass",
      "logp",
      "sol",
      "henry",
      "vmax",
      "km")]))
    simobslist[[i]] <- simobscomb
  }
}
```

Identify which quartile each observation occurred in with respect to the latest (maximum)
observed time
```{r time_quartile, eval = execute.vignette}
for(i in 1:length(simobslist))
  if (!is.null(simobslist[[i]]))
  {
    simobscomb <- simobslist[[i]]
    for (j in 1:nrow(simobscomb))
    { 
      max.time <- max(simobscomb$time,na.rm=TRUE)
      if (is.na(max.time)) simobscomb$tquart <- NA
      else if (max.time == 0) simobscomb$tquart <- "1"
      else if (!is.na(simobscomb$time[j])) 
      {
        simobscomb$tquart[j] <- as.character(1 +
          floor(simobscomb$time[j]/max.time/0.25))
        simobscomb$tquart[simobscomb$tquart=="5"] <-
          "4"
      } else simobscomb$tquart[j] >- NA
    }
    simobslist[[i]] <- simobscomb
  }
```

Calculate the area under the curve (AUC)
```{r calc_AUC, eval = execute.vignette}
for(i in 1:length(simobslist))
  if (!is.null(simobslist[[i]]))
  {
    simobscomb <- simobslist[[i]]
# Calculat the AUC with the trapezoidal rule:    
    if (nrow(simobscomb)>1) 
    {
      for (k in 2:max(nrow(simobscomb)-1,2,na.rm=TRUE))
      {
        simobscomb$obsAUCtrap[1] <- 0
        simobscomb$simAUCtrap[1] <- 0
        if (min(simobscomb$time) <= (simobscomb$explen[1]*1.03) & 
            nrow(simobscomb) >=2)
        {
          simobscomb$obsAUCtrap[k] <- simobscomb$obsAUCtrap[k-1] + 
            0.5*(simobscomb$time[k] - simobscomb$time[k-1]) * 
            (simobscomb$obsconc[k] + simobscomb$obsconc[k-1])
          simobscomb$simAUCtrap[k] <- simobscomb$simAUCtrap[k-1] + 
            0.5*(simobscomb$time[k]-simobscomb$time[k-1]) * 
            (simobscomb$simconc[k] + simobscomb$simconc[k-1])
        } else {
          simobscomb$obsAUCtrap <- 0
          simobscomb$simAUCtrap <- 0
        }
      }
    } else {
      simobscomb$obsAUCtrap <- 0
      simobscomb$simAUCtrap <- 0
    }
    simobscomb$AUCobs <- max(simobscomb$obsAUCtrap)
    simobscomb$AUCsim <- max(simobscomb$simAUCtrap)
    simobscomb$calcAUC <- max(simobscomb$AUC)
    if (min(simobscomb$time) <= simobscomb$explen[1]*1.03)
    {
      simobscomb$Cmaxobs <- max(simobscomb$obsconc)
      simobscomb$Cmaxsim <- max(simobscomb$simconc)
    } else {
      simobscomb$Cmaxobs <- 0
      simobscomb$Cmaxsim <- 0
    }
    simobslist[[i]] <- simobscomb
  }
```

Calculate performance statistics
```{r calc_error, eval = execute.vignette}
for(i in 1:length(simobslist))
  if (!is.null(simobslist[[i]]))
  {
    simobscomb <- simobslist[[i]]
    unique_scenarios$RSQD[i] <- 1 - (
      sum((simobscomb$obsconc - simobscomb$simconc)^2) / 
      sum((simobscomb$obsconc-mean(simobscomb$obsconc))^2)
      )
    unique_scenarios$RMSE[i] <- 
      sqrt(mean((simobscomb$simconc - simobscomb$obsconc)^2))
    unique_scenarios$AIC[i] <- 
      nrow(simobscomb)*(
        log(2*pi) + 1 +
        log((sum((simobscomb$obsconc-simobscomb$simconc)^2) /
          nrow(simobscomb)))
      ) + ((44+1)*2) #44 is the number of parameters from inhalation_inits.R
    simobslist[[i]] <- simobscomb
  }
```

Combine individual studies into single table
```{r combine_studies, eval = execute.vignette}
obsvpredlist <- list()
for(i in 1:length(simobslist))
  if (!is.null(simobslist[[i]]))
  {
    simobscomb <- simobslist[[i]]
    obsvpredlist[[i]] <- ggplot(simobscomb, aes(x = simconc, y = obsconc)) + 
      geom_point() + 
      geom_abline() + 
      xlab("Simulated Concentrations (uM)") + 
      ylab("Observed Concentrations (uM)") + 
      ggtitle(paste0(
        unique_scenarios$PREFERRED_NAME[i],
        " (", 
        unique_scenarios$CONC_SPECIES[i],
        ", ",
        round(as.numeric(unique_scenarios$DOSE[i]), digits = 2),
        unique_scenarios$DOSE_U[i], 
        " for ",
        round(unique_scenarios$EXP_LENGTH[i]*24, digits = 2),
        "h in ", 
        unique_scenarios$SAMPLING_MATRIX[i], ")")) + 
      theme_bw() + 
      theme(plot.title = element_text(face = 'bold', size = 20),
        axis.title.x = element_text(face = 'bold', size = 20), 
        axis.text.x = element_text(size=16), 
        axis.title.y = element_text(face = 'bold', size = 20), 
        axis.text.y = element_text(size = 16),
        legend.title = element_text(face = 'bold', size = 16),
        legend.text = element_text(face = 'bold',size = 14))
  }
```


### Write out the study-level figures:

```{r obsvspredplots, eval = execute.vignette}
# Create pdfs of observed vs. predicted concentration plots
pdf(paste0(LOC.WD,"obvpredplots.pdf"), width = 10, height = 10)
for (i in 1:length(obsvpredlist)) {
  print(obsvpredlist[[i]])
}
dev.off()
```

### Finish simulated concentration/time plots
```{r annotate_study_stats, eval = execute.vignette}
for (i in 1:length(cvtlist))
  if (!is.null(cvtlist[[i]]))
{
  cvtlist[[i]] <- cvtlist[[i]] + 
    geom_text(
      x = Inf, 
      y = Inf, 
      hjust = 1.3, 
      vjust = 1.3, 
#      size = 6, 
      label = paste0(
        "RMSE: ", 
        round(unique_scenarios$RMSE[i],digits = 2),
        "\nAIC: ", 
        round(unique_scenarios$AIC[i],digits = 2)))# + 
#    theme(
#      plot.title = element_text(face = 'bold', size = 15),
#      axis.title.x = element_text(face = 'bold', size = 20), 
#      axis.text.x = element_text(size=16), 
#      axis.title.y = element_text(face = 'bold', size = 20), 
#      axis.text.y = element_text(size = 16),
#      legend.title = element_text(face = 'bold', size = 16),
#      legend.text = element_text(face = 'bold',size = 14))
}
```

```{r cvtplots, eval = execute.vignette}
# Create pdfs of simulated concentration-time plots against observed c-t values
pdf(paste0(LOC.WD,"simdataplots.pdf"))
for (i in 1:length(cvtlist)) {
  print(cvtlist[[i]])
}
dev.off()
```

Combine obs. vs. pred. into single table:
```{r combine_obs_vs_pred, eval = execute.vignette}
simobsfull <- do.call("rbind",simobslist)
simobsfullrat <- subset(simobsfull, simobsfull$species == "Rat")
simobsfullhum <- subset(simobsfull, simobsfull$species == "Human")
unique_scenarios <- subset(unique_scenarios,!is.na(unique_scenarios$RSQD))
```

The observations in simobsfull are in both uM and ppmv -- standardize to uM
```{r Standardize Units, eval = FALSE}
these.chems <- unique(subset(simobsfull,unit=="ppmv")$chem)
for (this.chem in these.chems)
{
  # Use HTTK unit conversion:
  this.factor <- convert_units(
    input.units="ppmv", output.units="um", chem.name=this.chem, state="gas")
      
  # Scale the observation    
  simobsfull[simobsfull$chem==this.chem & 
              simobsfull$unit=="ppmv","obsconc"] <-
    this.factor * simobsfull[
      simobsfull$chem==this.chem & 
        simobsfull$unit=="ppmv","obsconc"]
  # Scale the prediction    
  simobsfull[simobsfull$chem==this.chem & 
              simobsfull$unit=="ppmv","simconc"] <-
    this.factor * simobsfull[
      simobsfull$chem==this.chem & 
        simobsfull$unit=="ppmv","simconc"]
  # Change the reported unit
  simobsfull[simobsfull$chem==this.chem & 
              simobsfull$unit=="ppmv","unit"] <-
    "uM"
}
```


### Regressions
Other analytics including linear regression on overall concentration vs. time observed vs. predicted
```{r regression, eval = execute.vignette}
table(unique_scenarios$CONC_SPECIES)
nrow(simobsfull) - nrow(simobsfull[
  !is.na(simobsfull$simconc) & 
  simobsfull$simconc > 0 & 
  simobsfull$obsconc > 0,])
pmiss <- (nrow(simobsfull) - 
  nrow(simobsfull[
    !is.na(simobsfull$simconc) & 
    simobsfull$simconc > 0 & 
    simobsfull$obsconc > 0,])) /
  nrow(simobsfull) * 100
missdata <- (simobsfull[
  is.na(simobsfull$simconc) | 
  simobsfull$simconc <= 0 | 
  simobsfull$obsconc <= 0,])
t0df <- simobsfull[simobsfull$obstime == 0,]
lmall <- lm(
#log transforms:
  log10(simobsfull$obsconc[
    !is.na(simobsfull$simconc) & 
    simobsfull$simconc > 0 & 
    simobsfull$obsconc > 0]) ~ 
#log transforms:
  log10(simobsfull$simconc[
    !is.na(simobsfull$simconc) & 
    simobsfull$simconc > 0 & 
    simobsfull$obsconc > 0])) 
#Linear binned 1
lmsub1 <- lm(
  simobsfull$obsconc[
    !is.na(simobsfull$simconc) & 
    simobsfull$simconc > 0 & 
    simobsfull$obsconc < 0.1] ~ 
  simobsfull$simconc[
    !is.na(simobsfull$simconc) & 
    simobsfull$simconc > 0 & 
    simobsfull$obsconc < 0.1])
#Linear binned 2
lmsub2 <- lm(
  simobsfull$obsconc[
    !is.na(simobsfull$simconc) & 
    simobsfull$simconc > 0 & 
    simobsfull$obsconc >= 0.1 & 
    simobsfull$obsconc < 10] ~ 
  simobsfull$simconc[
    !is.na(simobsfull$simconc) & 
    simobsfull$simconc > 0 & 
    simobsfull$obsconc >= 0.1 & 
    simobsfull$obsconc < 10]) 
#Linear binned 3
lmsub3 <- lm(
  simobsfull$obsconc[
    !is.na(simobsfull$simconc) & 
    simobsfull$simconc > 0 & 
    simobsfull$obsconc >= 10] ~ 
  simobsfull$simconc[
    !is.na(simobsfull$simconc) & 
    simobsfull$simconc > 0 & 
    simobsfull$obsconc >= 10]) 
lmrat <- lm(
  log10(simobsfullrat$obsconc[
    !is.na(simobsfullrat$simconc) & 
    simobsfullrat$simconc > 0 & 
    simobsfullrat$obsconc > 0]) ~ 
  log10(simobsfullrat$simconc[
    !is.na(simobsfullrat$simconc) & 
    simobsfullrat$simconc > 0 & 
    simobsfullrat$obsconc > 0]))
unique(simobsfullrat$chem)
lmhum <- lm(
  log10(simobsfullhum$obsconc[
    !is.na(simobsfullhum$simconc) & 
    simobsfullhum$simconc > 0 & 
    simobsfullhum$obsconc > 0]) ~ 
  log10(simobsfullhum$simconc[
    !is.na(simobsfullhum$simconc) & 
    simobsfullhum$simconc > 0 & 
    simobsfullhum$obsconc > 0]))
unique(simobsfullhum$chem)
concregslope <- summary(lmall)$coef[2,1]
concregr2 <- summary(lmall)$r.squared
concregrmse <- sqrt(mean(lmall$residuals^2))
totalrmse <- sqrt(mean((
  log10(simobsfull$simconc[
    !is.na(simobsfull$simconc) & 
    simobsfull$simconc > 0 & 
    simobsfull$obsconc > 0]) - 
  log10(simobsfull$obsconc[
    !is.na(simobsfull$simconc) & 
    simobsfull$simconc > 0 & 
    simobsfull$obsconc > 0]))^2, 
   na.rm = TRUE))
totalmae <- mean(abs(
  log10(simobsfull$simconc[
    !is.na(simobsfull$simconc) & 
    simobsfull$simconc > 0 & 
    simobsfull$obsconc > 0]) - 
  log10(simobsfull$obsconc[
    !is.na(simobsfull$simconc) & 
    simobsfull$simconc > 0 & 
    simobsfull$obsconc > 0])), 
  na.rm = TRUE)
totalaic <- nrow(
  simobsfull[
    !is.na(simobsfull$simconc) & 
    simobsfull$simconc >0 & 
    simobsfull$obsconc > 
    0,]) *
  (log(2*pi) + 
     1 +
     log((sum(
       (simobsfull$obsconc[
         !is.na(simobsfull$simconc) & 
         simobsfull$simconc > 0 & 
         simobsfull$obsconc > 0] - 
       simobsfull$simconc[
         !is.na(simobsfull$simconc) & 
         simobsfull$simconc > 0 & 
         simobsfull$obsconc > 0])^2,
       na.rm=TRUE) / 
     nrow(simobsfull[
       !is.na(simobsfull$simconc) & 
       simobsfull$simconc > 0 & 
       simobsfull$obsconc > 0,])))) + 
  ((44+1)*2) #44 is the number of parameters from inhalation_inits.R
mispred <- table(abs(
  log10(simobsfull$simconc) -
  log10(simobsfull$obsconc))>2 & 
  simobsfull$simconc>0)
mispred[2]
mispred[2] / nrow(simobsfull[
  !is.na(simobsfull$simconc) & 
    simobsfull$simconc >0 & 
    simobsfull$obsconc > 0,])*100
overpred <- table(
  log10(simobsfull$simconc) -
  log10(simobsfull$obsconc)>2 & 
  simobsfull$simconc>0)
overpred[2]
overpred[2] / nrow(simobsfull[
  !is.na(simobsfull$simconc) & 
  simobsfull$simconc >0 & 
  simobsfull$obsconc > 0,])*100
underpred <- table(
  log10(simobsfull$obsconc) - 
  log10(simobsfull$simconc)>2 & 
  simobsfull$simconc>0)
underpred[2]
underpred[2] / nrow(simobsfull[
  !is.na(simobsfull$simconc) & 
  simobsfull$simconc >0 & 
  simobsfull$obsconc > 0,])*100
mispredhalf <- table(abs(
  log10(simobsfull$simconc) -
  log10(simobsfull$obsconc))>0.5 & 
  simobsfull$simconc>0)
mispredhalf[2]
mispredhalf[2] / nrow(simobsfull[
  !is.na(simobsfull$simconc) & 
  simobsfull$simconc >0 & 
  simobsfull$obsconc > 0,])*100
overpredhalf <- table(
  log10(simobsfull$simconc) - 
  log10(simobsfull$obsconc)>0.5 & 
  simobsfull$simconc>0)
overpredhalf[2]
overpredhalf[2] / nrow(simobsfull[
  !is.na(simobsfull$simconc) & 
  simobsfull$simconc >0 & 
  simobsfull$obsconc > 0,])*100
underpredhalf <- table(
  log10(simobsfull$obsconc) - 
  log10(simobsfull$simconc)>0.5 & 
  simobsfull$simconc>0)
underpredhalf[2]
underpredhalf[2] / nrow(simobsfull[
  !is.na(simobsfull$simconc) & 
  simobsfull$simconc > 0 & 
  simobsfull$obsconc > 0,])*100
chemunderpred <- subset(simobsfull,
  log10(simobsfull$simconc) -
  log10(simobsfull$obsconc) < 0 & 
  simobsfull$simconc > 0)
table(chemunderpred$chemclass) / table(simobsfull$chemclass)*100
```
## TABLE AND PLOT GENERATION

### Figure 2: overall observed vs. predicted plot
```{r obspredFig2, eval = execute.vignette}
fig2 <- ggplot(
  data = simobsfull[
    simobsfull$simconc > 0 & 
    simobsfull$obsconc > 0,], 
  aes(x = log10(simconc), y = log10(obsconc))) + 
  geom_point(
    color = ifelse(
      abs(
        log10(simobsfull[
          simobsfull$simconc > 0 & 
          simobsfull$obsconc > 0,]$simconc) -
        log10(simobsfull[
          simobsfull$simconc > 0 & 
          simobsfull$obsconc > 0,]$obsconc)) >2,
      'red',
      'black')) + 
  geom_abline() + 
  xlab("Log(Simulated Concentrations)") + 
  ylab("Log(Observed Concentrations)") + 
  theme_bw() + 
  geom_smooth(method = 'lm',se = FALSE, aes(color = 'Overall')) + 
  geom_smooth(method = 'lm', se = FALSE, aes(color = species)) + 
  geom_text(
    x = Inf, 
    y = -Inf, 
    hjust = 1.05, 
    vjust = -0.15, 
    size = 8, 
    label = paste0(
  #    "Regression slope: ", 
#      round(summary(lmall)$coef[2,1],digits = 2),
      "\nRegression R^2: ", 
      round(summary(lmall)$r.squared,digits = 2),
      "\nRegression RMSE: ", 
      round(sqrt(mean(lmall$residuals^2)),digits = 2),
      "\nRMSE (Identity): ", 
      round(totalrmse,digits = 2)
 #     "\n% Missing:", 
#      round(pmiss, digits = 2), "%")
    )) + 
  #geom_text(
  #  data = simobsfull[
  #    abs(log10(simobsfull$simconc) - log10(simobsfull$obsconc))>7 & 
  #    simobsfull$simconc>0 & simobsfull$obsconc > 0,], 
  #  aes(label = paste(chem,species,matrix)),
   ## fontface = 'bold',
  #  check_overlap = TRUE,
#    size = 3.5, 
  #  hjust = 0.5, 
  #  vjust = -0.8) + 
  scale_color_discrete(name = 'Species', breaks = c("Overall","Human","Rat")) +
  theme(
    plot.title = element_text(face = 'bold', size = 15),
    axis.title.x = element_text(face = 'bold', size = 30), 
    axis.text.x = element_text(size=16), 
    axis.title.y = element_text(face = 'bold', size = 30), 
    axis.text.y = element_text(size = 16),
    legend.title = element_text(face = 'bold', size = 24),
    legend.text = element_text(face = 'bold',size = 24))
fig2 #Display plot in R
```


```{r make_how_to_add_models_version, eval=execute.vignette}
font.size.large <- 10
font.size.small <- 8

figaddmodels <- ggplot(
  data = simobsfull[
    simobsfull$simconc > 0 & 
    simobsfull$obsconc > 0,], 
  aes(x = simconc, y = obsconc)) + 
  geom_point(
    color = ifelse(
      abs(
        log10(simobsfull[
          simobsfull$simconc > 0 & 
          simobsfull$obsconc > 0,]$simconc) -
        log10(simobsfull[
          simobsfull$simconc > 0 & 
          simobsfull$obsconc > 0,]$obsconc)) >2,
      'red',
      'black'),alpha=0.15) + 
  geom_abline() + 
  scale_y_log10(label=label_log(), limits=c(1e-4,1e4))+
  scale_x_log10(label=label_log(), limits=c(1e-4,1e4))+
  xlab("Simulated Concentrations") + 
  ylab("Observed Concentrations") + 
  theme_bw() + 
  geom_smooth(method = 'lm',se = FALSE, aes(color = 'Overall', linetype="Overall")) + 
  geom_smooth(method = 'lm', se = FALSE, aes(color = species, linetype = species)) + 
  geom_text(
    x = 2, 
    y = -1, 
    size = 4, 
    label = paste0("RMSLE: ",
            round(totalrmse,digits = 2)
            )) + 
  scale_color_discrete(name = 'Species', breaks = c("Overall","Human","Rat")) +
  scale_linetype_discrete(name = 'Species', breaks = c("Overall","Human","Rat")) +
  theme(
    plot.title = element_text(face = 'bold', size = font.size.small),
    axis.title.x = element_text(face = 'bold', size = font.size.large), 
    axis.text.x = element_text(size=font.size.small), 
    axis.title.y = element_text(face = 'bold', size = font.size.large), 
    axis.text.y = element_text(size = font.size.small),
    legend.title = element_text(face = 'bold', size = font.size.large),
    legend.text = element_text(face = 'bold',size = font.size.large)) 
print(figaddmodels)
ggsave(paste0(LOC.WD,"AddModelsFig1.tiff"), width=6, height=4, dpi=300)

counts <- simobsfull[,c("chem","dose","explen","species")]
counts <- subset(counts,!duplicated(counts))
paste(length(unique(counts$chem)),
      "chemicals across",dim(counts)[1],
      "experimental conditions in",
      length(unique(counts$species)),"species.")
```

```{r write_figure2, eval = FALSE}
pdf(paste0(LOC.WD,"Figure2.pdf"), width = 10, height = 10)
print(fig2)
dev.off()
```

### Create and read out plots of overall cvt, cmax, and auc observed vs. pred
```{r calculations, eval = execute.vignette}
# Create data and run calculations for populating plots
cmaxfull <- subset(simobsfull, !duplicated(simobsfull$AUCobs) & simobsfull$Cmaxobs != 0)
cmaxobs <- cmaxfull$Cmaxobs
cmaxsim <- cmaxfull$Cmaxsim
cmaxobs <- cmaxobs[!is.nan(cmaxsim)]
cmaxsim <- cmaxsim[!is.nan(cmaxsim)]
cmaxsim[!is.finite(log10(cmaxsim))] <- NA
cmaxlm <- lm(log10(cmaxobs)~log10(cmaxsim), na.action = na.exclude)
cmaxvcbkg <- subset(cmaxfull, 
  paste(
    cmaxfull$chem, 
    cmaxfull$dose, 
    cmaxfull$explen, 
    cmaxfull$species, 
    cmaxfull$matrix) %in% 
  paste(
    t0df$chem, 
    t0df$dose, 
    t0df$explen, 
    t0df$species,
    t0df$matrix))
cmaxvcbkg$cmaxcbkgratio <- cmaxvcbkg$Cmaxobs / cmaxvcbkg$obsconc
cmaxvcbkg$adjustedCmaxsim <- cmaxvcbkg$Cmaxsim - cmaxvcbkg$obsconc
aucfull <-subset(simobsfull, 
  !duplicated(simobsfull$AUCobs) & 
  simobsfull$AUCobs != 0)
aucobs <- aucfull$AUCobs
aucsim <- aucfull$AUCsim
aucobs <- aucobs[!is.nan(aucsim)]
aucsim <- aucsim[!is.nan(aucsim)]
aucsim[!is.finite(log10(aucsim))] <- NA
auclm <- lm(log10(aucobs)~log10(aucsim), na.action = na.exclude)
cmaxslope <- summary(cmaxlm)$coef[2,1]
cmaxrsq <- summary(cmaxlm)$r.squared
totalrmsecmax <- sqrt(mean((log10(cmaxfull$Cmaxsim) - 
  log10(cmaxfull$Cmaxobs))^2, na.rm = TRUE))
cmaxmiss <- nrow(cmaxfull[
  abs(log10(cmaxfull$Cmaxsim) - 
  log10(cmaxfull$Cmaxobs)) > 1,])
cmaxmissp <- nrow(cmaxfull[
  abs(log10(cmaxfull$Cmaxsim) - 
  log10(cmaxfull$Cmaxobs)) > 1,]) /
  nrow(cmaxfull) * 100
cmaxmisschem <- table(cmaxfull[
  abs(log10(cmaxfull$Cmaxsim) - 
  log10(cmaxfull$Cmaxobs)) > 1,]$chem)
aucslope <- summary(auclm)$coef[2,1]
aucrsq <- summary(auclm)$r.squared
totalrmseauc <- sqrt(mean((
  log10(aucfull$AUCsim) - 
  log10(aucfull$AUCobs))^2, na.rm = TRUE))
aucmiss <- nrow(aucfull[
  abs(log10(aucfull$AUCsim) - 
  log10(aucfull$AUCobs)) > 1,])
aucmissp <- nrow(aucfull[
  abs(log10(aucfull$AUCsim) - 
  log10(aucfull$AUCobs)) > 1,]) / 
  nrow(aucfull) * 100
aucmisschem <- table(aucfull[
  abs(log10(aucfull$AUCsim) - 
  log10(aucfull$AUCobs)) > 1,]$chem)
```

### Figure 4: Cmax and AUC observed vs. Predicted Values
```{r Fig4plot, eval = execute.vignette}
cmaxp <- ggplot(data = cmaxfull, aes(x = log10(Cmaxsim), y = log10(Cmaxobs))) +
  geom_point(color = 
    ifelse(abs(log10(cmaxfull$Cmaxsim)  -log10(cmaxfull$Cmaxobs))>=2, "red","black"))  +
  geom_abline()  + 
  xlab("Log(Simulated Max Concentration)") + 
  ylab("Log(Observed Max Concentration)") + 
  theme_bw() + 
  geom_smooth(method = 'lm', se = FALSE, aes(color = 'Overall')) + 
  geom_smooth(method = 'lm', se = FALSE, aes(color = species)) +
  geom_text(x = Inf, 
    y = -Inf, 
    hjust = 1.05, 
    vjust = -0.15, 
#    size = 6, 
    label = paste0("Regression slope: ", 
      round(summary(cmaxlm)$coef[2,1],digits = 2),
      "\nRegression R^2: ", 
      round(summary(cmaxlm)$r.squared,digits = 2))) +
  geom_text_repel(
    data = cmaxfull[
      (log10(cmaxfull$Cmaxsim)-log10(cmaxfull$Cmaxobs))>=2 & 
      log10(cmaxfull$Cmaxsim) > 2,], 
    aes(label = paste(chem,species,matrix)), 
    force = 2, 
 #   size = 5.3, 
    fontface = 'bold', 
    color = 'black', 
    hjust = -0.05, 
    vjust = 0.5) + 
  scale_y_continuous(lim = c (-1,5)) + 
  scale_x_continuous(lim = c(-1,5)) + 
  geom_text_repel(
    data = cmaxfull[
      (log10(cmaxfull$Cmaxsim)-log10(cmaxfull$Cmaxobs))>=2 &
      log10(cmaxfull$Cmaxsim) <= 2,], 
    aes(label = paste(chem,species,matrix)), 
    nudge_x = 0.0,
    nudge_y = -0.2, 
    force = 2, 
#    size = 5.3, 
    fontface = 'bold', 
    color = 'black', 
    hjust = -0.05, 
    vjust = 0.5) + 
  geom_text(
    data = cmaxfull[
      (log10(cmaxfull$Cmaxsim)-log10(cmaxfull$Cmaxobs))<=-2,], 
    aes(label = paste(chem,species,matrix)), 
#    size = 5.3, 
    fontface = 'bold', 
    color = 'black', 
    hjust = 0.5, 
    vjust = -0.7) + 
  scale_color_discrete(
    name = 'Species', 
    breaks = c("Overall","Human","Rat")) #+ 
#  theme(plot.title = element_text(face = 'bold', size = 10),
#    axis.title.x = element_text(face = 'bold', size = 10), 
#    axis.text.x = element_text(size=8), 
#    axis.title.y = element_text(face = 'bold', size = 10), 
#    axis.text.y = element_text(size = 8),
#    legend.title = element_text(face = 'bold', size = 8),
#    legend.text = element_text(face = 'bold',size = 8))
cmaxp
aucp <- ggplot(
  data = aucfull, 
  aes(x = log10(AUCsim), y = log10(AUCobs))) + 
  geom_point(color = 
    ifelse(abs(log10(aucfull$AUCsim)-log10(aucfull$AUCobs))>=2, "red","black"))  +
  geom_abline()  + 
  xlab("Log(Simulated AUC)") + 
  ylab("Log(Observed AUC)") + 
  theme_bw() + 
  geom_smooth(method = 'lm', se = FALSE, aes(color = "Overall")) + 
  geom_smooth(method = 'lm', se = FALSE, aes(color = species)) + 
  geom_text(
    x = Inf, 
    y = -Inf, 
    hjust = 1.05, 
    vjust = -0.15, 
#    size = 6, 
    label = paste0(
      "Regression slope: ", 
      round(summary(auclm)$coef[2,1],digits = 2),
      "\nRegression R^2: ", 
      round(summary(auclm)$r.squared,digits = 2))) + 
  geom_text_repel(
    data = aucfull[(log10(aucfull$AUCsim)-log10(aucfull$AUCobs))>=2,], 
    aes(label = paste(chem,species,matrix)), 
#    size = 5.3, 
    fontface = 'bold', 
    color = 'black', 
    hjust = -0.05, 
    vjust = 0.5) + 
  scale_y_continuous(lim = c (-2,4)) + 
  scale_x_continuous(lim = c(-2,4)) + 
  geom_text(
    data = aucfull[(log10(aucfull$AUCsim)-log10(aucfull$AUCobs))<=-2,], 
    aes(label = paste(chem,species,matrix)), 
#    size = 5.3, 
    fontface = 'bold', 
    color = 'black', 
    hjust = 0.5, 
    vjust = -0.8) + 
  scale_color_discrete(name = 'Species', breaks = c("Overall","Human","Rat")) #+
#  theme(
#    plot.title = element_text(face = 'bold', size = 15),
#    axis.title.x = element_text(face = 'bold', size = 20), 
#    axis.text.x = element_text(size=16), 
#    axis.title.y = element_text(face = 'bold', size = 20), 
#    axis.text.y = element_text(size = 16),
#    legend.title = element_text(face = 'bold', size = 16),
#    legend.text = element_text(face = 'bold',size = 14))
aucp
```

```{r write_figure4, eval = execute.vignette}
pdf(paste0(LOC.WD,"Figure4.pdf"), width = 20, height = 10)
plot_grid(cmaxp,aucp,nrow = 1, labels = c('A','B'), label_size = 30)
dev.off()
```

### Figure 3: Separation by chemical class
```{r Fig3plot, eval = execute.vignette}
simobsfull$aggscen <- as.factor(paste(simobsfull$chem, 
  simobsfull$species, 
  simobsfull$matrix))
chem.lm <- lm(
  log10(simconc) - log10(obsconc) ~ 
  aggscen, 
  data = simobsfull[simobsfull$simconc >0 & simobsfull$obsconc > 0,])
chem.res <- resid(chem.lm)
# Number of observations per chemical class
numpt <- simobsfull[simobsfull$simconc >0 & simobsfull$obsconc > 0,] %>%
  group_by(chemclass) %>% summarize(n = paste("n =", length(simconc))) 
fig3 <- ggplot(
  data = simobsfull[simobsfull$simconc >0 & simobsfull$obsconc > 0,], 
  aes(x = aggscen, y = log10(simconc)-log10(obsconc), fill = chemclass)) +
  geom_boxplot() +
  geom_hline(yintercept = 0) +
  geom_hline(yintercept = 2, linetype = 2)+
  geom_hline(yintercept = -2, linetype = 2)+
  xlab("Exposure Scenario") +
  ylab("Log(Simulated Concentration)-\nLog(Observed Concentration)\n") +
  facet_wrap(vars(chemclass), scales = 'free_x', nrow = 1) + #35 by 12 for poster
  theme_bw() +
  geom_text(
    data = numpt, 
    aes(x = Inf, y = -Inf, hjust = 1.05, vjust = -0.5, label = n), 
    size = 10, 
    colour = 'black', 
    inherit.aes = FALSE, 
    parse = FALSE) +
  theme(
    axis.text.x = element_text(angle = 90, hjust = 1,vjust=0.5,size = 20, face = 'bold'),
    strip.text.x = element_text(face = 'bold', size = 24), 
    legend.position = 'none', 
    axis.title.x = element_text(face = 'bold', size = 30), 
    axis.title.y = element_text(face = 'bold', size = 30), 
    axis.text.y = element_text(face = 'bold',size = 25, color = 'black'))
fig3
```

```{r write_figure3, eval = execute.vignette}
pdf(paste0(LOC.WD,"Figure3.pdf"), width = 40, height = 13)
print(fig3)
dev.off()
```

### Figures S1A-S1D: Separation by time quartile and physicochemical properties
```{r FigS1, eval = execute.vignette}
figs1a <- ggplot(
    data = simobsfull[simobsfull$simconc >0 & simobsfull$obsconc > 0,], 
    aes(x = tquart, y = log10(simconc)-log10(obsconc))) +
  geom_boxplot()+
  geom_hline(yintercept = 0)+
  geom_hline(yintercept = 2, linetype = 2)+
  geom_hline(yintercept = -2, linetype = 2)+
  xlab("\nTime Quartile\n") +
  ylab("Log(Simulated Concentration)-\nLog(Observed Concentration)\n") +
  theme_bw()+
  theme(
    axis.text.x = element_text(size = 20, face = 'bold'), 
    strip.text.x = element_text(face = 'bold', size = 20), 
    legend.position = 'none', 
    axis.title.x = element_text(face = 'bold', size = 20), 
    axis.title.y = element_text(face = 'bold', size = 20), 
    axis.text.y = element_text(size = 20, face = 'bold'))
figs1a
figs1b <- ggplot(
    data = simobsfull[simobsfull$simconc >0 & simobsfull$obsconc > 0,], 
    aes(x = mw, y = log10(simconc)-log10(obsconc))) +
  geom_point()+
  geom_hline(yintercept = 0)+
  geom_hline(yintercept = 2, linetype = 2)+
  geom_hline(yintercept = -2, linetype = 2)+
  xlab("\nMolecular Weight (g/mol)\n") +
  ylab("\nLog(Simulated Concentration)-\nLog(Observed Concentration)\n") +
  theme_bw()+
  theme(
    axis.text.x = element_text(size = 20, face = 'bold'), 
    strip.text.x = element_text(face = 'bold', size = 20), 
    legend.position = 'none', 
    axis.title.x = element_text(face = 'bold', size = 20), 
    axis.title.y = element_text(face = 'bold', size = 20), 
    axis.text.y = element_text(size = 20, face = 'bold'))
figs1b
figs1c <- ggplot(
    data = simobsfull[simobsfull$simconc >0 & simobsfull$obsconc > 0,], 
    aes(x = logp, y = log10(simconc)-log10(obsconc))) +
  geom_point()+
  geom_hline(yintercept = 0)+
  geom_hline(yintercept = 2, linetype = 2)+
  geom_hline(yintercept = -2, linetype = 2)+
  xlab("\nLog P") +
  ylab("Log(Simulated Concentration)-\nLog(Observed Concentration)\n") +
  theme_bw() +
  theme(
    axis.text.x = element_text(size = 20, face = 'bold'), 
    strip.text.x = element_text(face = 'bold', size = 20), 
    legend.position = 'none', 
    axis.title.x = element_text(face = 'bold', size = 20), 
    axis.title.y = element_text(face = 'bold', size = 20), 
    axis.text.y = element_text(size = 20, face = 'bold'))
figs1c
figs1d <- ggplot(
    data = simobsfull[simobsfull$simconc >0 & simobsfull$obsconc > 0,], 
    aes(x = sol, y = log10(simconc)-log10(obsconc))) +
  geom_point()+
  geom_hline(yintercept = 0)+
  geom_hline(yintercept = 2, linetype = 2)+
  geom_hline(yintercept = -2, linetype = 2)+
  xlab("\nSolubility (mol/L)") +
  ylab("\nLog(Simulated Concentration)-\nLog(Observed Concentration)\n") +
  scale_x_log10()+
  theme_bw() +
  theme(
    axis.text.x = element_text(size = 20, face = 'bold'), 
    strip.text.x = element_text(face = 'bold', size = 20), 
    legend.position = 'none', 
    axis.title.x = element_text(face = 'bold', size = 20), 
    axis.title.y = element_text(face = 'bold', size = 20), 
    axis.text.y = element_text(size = 20, face = 'bold'))
figs1d
```

```{r write_figures1, eval = execute.vignette}
pdf(paste0(LOC.WD,"FigureS1.pdf"), width = 20, height = 20)
plot_grid(figs1a,figs1b,figs1c,figs1d,nrow = 2, labels = c('A','B','C','D'), label_size = 30)
dev.off()
```

### Supplemental Table 2: Leave-one-out Chemical Sensitivity Analysis
```{r SupTable2, eval = execute.vignette}
senschem <- list()
sensslope <- list()
sensrsq <- list()
sensregrmse <- list()
senstotalrmse <- list()
senspmiss <- list()
senscmaxslope <- list()
senscmaxrsq <- list()
senstotalrmsecmax <- list()
sensaucslope <- list()
sensaucrsq <- list()
senstotalrmseauc <- list()
for (i in 1:nrow(simobsfull))
{
  simobsfullsens <- subset(simobsfull,simobsfull$chem != simobsfull$chem[i])
  senschem[i] <- as.character(simobsfull$chem[i])
  senslm <- lm(
    log10(simobsfullsens$obsconc[
      !is.na(simobsfullsens$simconc) & 
      simobsfullsens$simconc > 0 & 
      simobsfullsens$obsconc > 0]) ~ 
    log10(simobsfullsens$simconc[
      !is.na(simobsfullsens$simconc) & 
      simobsfullsens$simconc >0 & 
      simobsfullsens$obsconc > 0]))
  sensslope[i] <- round(summary(senslm)$coef[2,1],digits = 2)
  sensrsq[i] <- round(summary(senslm)$r.squared,digits = 2)
  sensregrmse[i] <- round(sqrt(mean(senslm$residuals^2)),digits = 2)
  senstotalrmse[i] <- round(sqrt(mean((
    log10(simobsfullsens$simconc[
      !is.na(simobsfullsens$simconc) & 
      simobsfullsens$simconc >0 & 
      simobsfullsens$obsconc > 0]) -   
    log10(simobsfullsens$obsconc[
      !is.na(simobsfullsens$simconc) & 
        simobsfullsens$simconc >0 & 
        simobsfullsens$obsconc > 0]))^2, 
    na.rm = TRUE)), digits = 2)
  senspmiss[i] <- round((nrow(simobsfullsens) - 
    nrow(simobsfullsens[
      !is.na(simobsfullsens$simconc) & 
      simobsfullsens$simconc >0 & 
      simobsfullsens$obsconc > 0,])) / nrow(simobsfullsens) * 100, 
    digits = 2)
  senscmaxfull <- subset(simobsfullsens, !duplicated(simobsfullsens$Cmaxobs))
  senscmaxlm <- lm(
    log10(senscmaxfull$Cmaxobs[senscmaxfull$Cmaxobs>0]) ~
    log10(senscmaxfull$Cmaxsim[senscmaxfull$Cmaxobs>0]), 
    na.action = na.exclude)
  sensaucfull <-subset(simobsfullsens, !duplicated(simobsfullsens$AUCobs))
  sensauclm <- lm(
    log10(aucfull$AUCobs[aucfull$AUCobs>0]) ~
    log10(aucfull$AUCsim[aucfull$AUCobs>0]), 
    na.action = na.exclude)
  senscmaxslope[i] <- round(summary(senscmaxlm)$coef[2,1],digits = 2)
  senscmaxrsq[i] <- round(summary(senscmaxlm)$r.squared,digits = 2)
  senstotalrmsecmax[i] <- sqrt(mean((log10(senscmaxfull$Cmaxsim[senscmaxfull$Cmaxobs>0]) - log10(senscmaxfull$Cmaxobs[senscmaxfull$Cmaxobs>0]))^2, na.rm = TRUE))
  sensaucslope[i] <- round(summary(sensauclm)$coef[2,1],digits = 2)
  sensaucrsq[i] <- round(summary(sensauclm)$r.squared,digits = 2)
  senstotalrmseauc[i] <- sqrt(mean((log10(sensaucfull$AUCsim[sensaucfull$AUCobs>0]) - log10(sensaucfull$AUCobs[sensaucfull$AUCobs>0]))^2, na.rm = TRUE))
}
sensitivitydf <- data.frame(Chemical <- as.character(senschem),
                            sensSlope <- as.numeric(sensslope),
                            sensRsq <- as.numeric(sensrsq),
                            sensRegrmse <- as.numeric(sensregrmse),
                            sensTotrmse <- as.numeric(senstotalrmse),
                            sensPmiss <- as.numeric(senspmiss),
                            sensCmaxslope <- as.numeric(senscmaxslope),
                            sensCmaxrsq <- as.numeric(senscmaxrsq),
                            sensCmaxrmse <- as.numeric(senstotalrmsecmax),
                            sensAUCslope <- as.numeric(sensaucslope),
                            sensAUCrsq <- as.numeric(sensaucrsq),
                            sensAUCrmse <- as.numeric(senstotalrmseauc),
                            stringsAsFactors=FALSE)
sensitivitydf <- subset(sensitivitydf,!duplicated(sensitivitydf$Chemical....as.character.senschem.))
names(sensitivitydf) <- c('Chemical Dropped','Regression Slope','Regression R^2','Regression RMSE','Orthogonal RMSE', 'Percent Data Censored','Cmax Regression Slope','Cmax Regression R^2','Cmax Orthogonal RMSE','AUC Regression Slope','AUC Regression R^2','AUC Orthogonal RMSE')
notdropped <- c('None',concregslope,concregr2,concregrmse,totalrmse,pmiss,cmaxslope,cmaxrsq,totalrmsecmax,aucslope,aucrsq,totalrmseauc)
sensitivitydf <- rbind(notdropped, sensitivitydf)
sensitivitydf[,-1] <- sapply(sensitivitydf[,-1],as.numeric)
sensitivitydf[,-1] <- round(sensitivitydf[,-1],2)
  # Clean up and write file
rm(chem.lm, obvpredplot, p, pdata1, plot.data, plots, relconc, sensaucfull, sensauclm, sensaucrsq, sensaucslope, senschem, senscmaxfull, senscmaxlm, senscmaxrsq, senscmaxslope, senslm, senspmiss, sensregrmse, sensrsq, sensslope, senstotalrmse, senstotalrmseauc, senstotalrmsecmax, solve, AUCrmse, AUCrsq, AUCslope, chem.res, Chemical, Cmaxrmse, Cmaxrsq, Cmaxslope, colors, count, i, j, k, met_col, name, name1, Pmiss, Regrmse, Rsq, Slope, rem, Totrmse)

write.csv(sensitivitydf, paste0(LOC.WD,'supptab2.csv'),row.names = FALSE)
```

### Supplemental Table 1
```{r SupTable1, eval = execute.vignette}
supptab1 <- subset(unique_scenarios, !duplicated(unique_scenarios$PREFERRED_NAME) | !duplicated(unique_scenarios$SOURCE_CVT) | !duplicated(unique_scenarios$CONC_SPECIES))
for(i in 1:nrow(supptab1)){
  tryCatch({
    supptab1$Metabolism_Source[i] <- met_data$SOURCE_MET[met_data$DTXSID %in% supptab1$DTXSID[i] & met_data$SPECIES %in% supptab1$CONC_SPECIES[i]]
    supptab1$Log_P[i] <- met_data$OCTANOL_WATER_PARTITION_LOGP_OPERA_PRED[met_data$DTXSID %in% supptab1$DTXSID[i]& met_data$SPECIES %in% supptab1$CONC_SPECIES[i]]
    supptab1$Solubility[i] <- met_data$WATER_SOLUBILITY_MOL.L_OPERA_PRED[met_data$DTXSID %in% supptab1$DTXSID[i]& met_data$SPECIES %in% supptab1$CONC_SPECIES[i]]
    supptab1$Blood_Air_Partition_Coefficient[i] <- met_data$CALC_PBA[met_data$DTXSID %in% supptab1$DTXSID[i]& met_data$SPECIES %in% supptab1$CONC_SPECIES[i]]
    supptab1$Chem_Class[i] <- met_data$CHEM_CLASS[met_data$DTXSID %in% supptab1$DTXSID[i] & met_data$SPECIES %in% supptab1$CONC_SPECIES[i]]
    supptab1$Species[i] <- met_data$SPECIES[met_data$DTXSID %in% supptab1$DTXSID[i] & met_data$SPECIES %in% supptab1$CONC_SPECIES[i]]
    supptab1$Vmax[i] <- met_data$VMAX[met_data$DTXSID %in% supptab1$DTXSID[i] & met_data$SPECIES %in% supptab1$CONC_SPECIES[i]]
    supptab1$Km[i] <- met_data$KM[met_data$DTXSID %in% supptab1$DTXSID[i] & met_data$SPECIES %in% supptab1$CONC_SPECIES[i]]
  }, error = function(e){})
}
supptab1 <- supptab1[c('PREFERRED_NAME','DTXSID','CASRN','Chem_Class','AVERAGE_MASS','Log_P','Solubility','Blood_Air_Partition_Coefficient','Species','Vmax','Km','Metabolism_Source','SOURCE_CVT')]
names(supptab1) <- c('Chemical','DTXSID','CASRN','CAMEO Chemical Class','Molecular Weight (g/mol)','Log P','Solubility (mol/L)','Blood Air Partition Coefficient','Available Species Data','Vmax (pmol/min/10^6 cells)','KM (uM)','Metabolism Data Source','Concentration-Time Data Source')
write.csv(supptab1, paste0(LOC.WD,"supptab1.csv"), row.names = FALSE)
```

---
title: "Honda et al. (2019): Updated Armitage et al. (2014) Model"
author: "Gregory S. Honda"
date: "July 13, 2018"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{f) Honda (2019): Updated Armitage et al. (2014) Model}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---
*Please send questions to John.Wambaugh@UL.org*

from "Using the concordance of *in vitro* and *in vivo* data to evaluate extrapolation assumptions"

Gregory S. Honda, Robert G. Pearce, Ly L. Pham, R. W. Setzer, Barbara A. Wetmore,
Nisha S. Sipes, Jon Gilbert, Briana Franz, Russell S. Thomas, John F. Wambaugh 

PLoS ONE 14(5): e0217564.

https://doi.org/10.1371/journal.pone.0217564

The authors thank James Armitage for providing a revised version of his model (
https://doi.org/10.1021/es501955g). 

## Abstract
Linking *in vitro* bioactivity and *in vivo* toxicity on a dose basis enables the 
use of high-throughput in vitro assays as an alternative to traditional animal 
studies. In this study, we evaluated assumptions in the use of a 
high-throughput, physiologically based toxicokinetic (PBTK) model to relate 
*in vitro* bioactivity and rat *in vivo* toxicity data. The fraction unbound in 
plasma ($f_{up}$) and intrinsic hepatic clearance ($Cl_{int}$) were measured for rats 
(for 67 and 77 chemicals, respectively), combined with fup and $Cl_{int}$ 
literature data for 97 chemicals, and incorporated in the PBTK model. Of 
these chemicals, 84 had corresponding *in vitro* ToxCast bioactivity data and 
*in vivo* toxicity data. For each possible comparison of *in vitro* and *in vivo* 
endpoint, the concordance between the *in vivo* and *in vitro* data was evaluated 
by a regression analysis. For a base set of assumptions, the PBTK results 
were more frequently better associated than either the results from a 
"random" model parameterization or direct comparison of the "untransformed" 
values of $AC_{50}$ and dose (performed best in 51%, 28%, and 21% of cases, 
respectively). We also investigated several assumptions in the application 
of PBTK for *in vitro-in vivo* extrapolation (IVIVE), including clearance and 
internal dose selection. One of 
the better assumptions sets-restrictive clearance and comparing free *in vivo*
venous plasma concentration with free *in vitro* concentration-outperformed 
the random and untransformed results in 71% of the *in vitro-in vivo* endpoint 
comparisons. These results demonstrate that applying PBTK improves our 
ability to observe the association between *in vitro* bioactivity and *in vivo* 
toxicity data in general. This suggests that potency values from *in vitro* 
screening should be transformed using IVIVE 
to build potentially better machine learning and other statistical models 
for predicting in vivo toxicity in humans.

## HTTK Version

This vignette was created with **httk** v1.9. Although we attempt to maintain 
backward compatibility, if you encounter issues with the latest release of 
**httk**
and cannot easily address the changes, historical versions of httk are 
available from: https://cran.r-project.org/src/contrib/Archive/httk/

## Prepare for session
R package **knitr** generates html and PDF documents from this RMarkdown file,
Each bit of code that follows is known as a "chunk". We start by telling 
**knitr** how we want our chunks to look.
```{r setup, include=FALSE, eval = TRUE}
knitr::opts_chunk$set(echo = TRUE, fig.width=6, fig.height=5)
```

### Clear the memory
It is a bad idea to let variables and other information from previous R
sessions float around, so we first remove everything in the R memory.
```{r clear_memory, eval = TRUE}
rm(list=ls()) 
```

### eval = execute.vignette
If you are using the RMarkdown version of this vignette (extension, .RMD) you
will be able to see that several chunks of code in this vignette
have the statement "eval = execute.vignette". The next chunk of code, by default,
sets execute.vignette = FALSE.  This means that the code is included (and necessary) but was
not run when the vignette was built. We do this because some steps require 
extensive computing time and the checks on CRAN limit how long we can spend
building the package. If you want this vignette to work, you must run all code,
either by cutting and pasting it into R. Or, if viewing the .RMD file, you can
either change execute.vignette to TRUE or press "play" (the green arrow) on
each chunk in RStudio.
```{r runchunks, eval = TRUE}
# Set whether or not the following chunks will be executed (run):
execute.vignette <- FALSE
```

### Load the relevant libraries
If you get the message "Error in library(X) : there is no package called 'X'"
then you will need to install that package: 

From the R command prompt:

install.packages("X")

Or, if using RStudio, look for 'Install Packages' under 'Tools' tab.
```{r InitialPrep, eval = execute.vignette}
library(data.table)
library(magrittr)
library(ggplot2)
library(httk)
library(httkexamples)
```

## Updated Armitage 2014 Top Panel Figure 3

This produces an updated version of the top panel of Figure 3 from the paper 
[Armitage, 2014](https://doi.org/10.1021/es501955g)


```{r MakeTable, eval = execute.vignette}
armitage.dt <- copy(armitage_input)
armitage.dt[,well_number:=384] %>% 
  .[,option.bottom:=TRUE] %>% 
  .[,option.plastic:=TRUE] %>% 
  .[,Tsys:=37] %>% 
  .[,Tref:=298.15] %>% 
  .[,FBSf:=0.1] %>% 
  .[,nomconc:=50]

# Make sure we have data for the chemical:
armitage.dt <- subset(armitage.dt,casrn%in%get_cheminfo(model="armitage"))
# These chemicals are missing water solubilities:
armitage.dt <- subset(armitage.dt,!(casrn%in%c("71751-41-2","34590-94-8","141517-21-7")))

armitage.dt2 <- armitage_estimate_sarea(tcdata = armitage.dt)
armitage_output1 <- armitage_eval(tcdata = armitage.dt2[,ac50:=50])
armitage_output2 <- armitage_eval(tcdata = armitage.dt2[,ac50:=1])
armitage_output3 <- armitage_eval(tcdata = armitage.dt2[,ac50:=0.001])

```

## Plot results

```{r MakePlot, echo=TRUE, eval = execute.vignette}
armitage_output <- rbind(armitage_output1[,xfill:="50 \U00B5M"],
                         armitage_output2[,xfill:="1 \U00B5M"],
                         armitage_output3[,xfill:="1 nM"])
armitage_output[,xfill:=factor(xfill,levels=c("50 \U00B5M","1 \U00B5M","1 nM"))]

ggplot(armitage_output) +
  geom_point(aes(x=gkow,y=log10(ccells/MW*1e9),color=xfill),shape=1) +
  labs(color=expression("AC"["50"]),x="log P", y = "log(ng chemical/g cells)") +
  theme_bw()
```

---
title: "Pearce et al. (2017): Updated v79i04.R Examples"
author: "Robert G Pearce, R Woodrow Setzer, Cory L Strope, Nisha S Sipes, and John F Wambaugh"
date: "`r Sys.Date()`"
output: rmarkdown::html_vignette
highlight: tango
vignette: >
  %\VignetteIndexEntry{a) Pearce (2017): HTTK Basics}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---
from "httk: R Package for High-Throughput Toxicokinetics"

Robert G Pearce, R Woodrow Setzer, Cory L Strope, Nisha S Sipes, and John F Wambaugh

Journal of Statistical Software 2017 Jul 17; 79(4): 1-26.

https://doi.org/10.18637/jss.v079.i04

*Please send questions to John.Wambaugh@UL.org*

## Abstract

Thousands of chemicals have been profiled by high-throughput screening programs 
such as ToxCast and Tox21; these chemicals are tested in part because most of 
them have limited or no data on hazard, exposure, or toxicokinetics. 
Toxicokinetic models aid in predicting tissue concentrations resulting from 
chemical exposure, and a "reverse dosimetry" approach can be used to predict 
exposure doses sufficient to cause tissue concentrations that have been 
identified as bioactive by high-throughput screening. We have created four 
toxicokinetic models within the R software package **httk**. These models are 
designed to be parameterized using high-throughput *in vitro* data (plasma 
protein binding and hepatic clearance), as well as structure-derived 
physicochemical properties and species-specific physiological data. The package 
contains tools for Monte Carlo sampling and reverse dosimetry along with 
functions for the analysis of concentration vs. time simulations. The package 
can currently use human *in vitro* data to make predictions for 553 chemicals in 
humans, rats, mice, dogs, and rabbits, including 94 pharmaceuticals and 415 
ToxCast chemicals. For 67 of these chemicals, the package includes rat-specific 
*in vitro* data. This package is structured to be augmented with additional 
chemical data as they become available. Package **httk** enables the inclusion of 
toxicokinetics in the statistical analysis of chemicals undergoing
high-throughput screening.

This vignette was created from the 
[R replication code v79i04.R](https://www.jstatsoft.org/index.php/jss/article/view/v079i04/3500) 
for the 
[2017 paper that introduced **httk**](https://doi.org/10.18637/jss.v079.i04).

## HTTK Version

The 
[R replication code v79i04.R](https://www.jstatsoft.org/index.php/jss/article/view/v079i04/3500) 
was created with **httk** v1.7. It was 
updated to a vignette using **httk** v2.2.2 in 2022. Although we attempt to 
maintain 
backward compatibility, if you encounter issues with the latest release of 
**httk**
and cannot easily address the changes, historical versions of **httk** are 
available from: https://cran.r-project.org/src/contrib/Archive/httk/

## Prepare R to run the vignette
R package **knitr** generates html and PDF documents from this RMarkdown file,
Each bit of code that follows is known as a "chunk". We start by telling 
**knitr** how we want our chunks to look.
```{r configure_knitr, eval = TRUE}
knitr::opts_chunk$set(collapse = TRUE, comment = '#>')
options(rmarkdown.html_vignette.check_title = FALSE)
```

### Clear the memory
It is a bad idea to let variables and other information from previous R
sessions float around, so we first remove everything in the R memory.
```{r clear_memory, eval = TRUE}
rm(list=ls()) 
```

### eval = execute.vignette
If you are using the RMarkdown version of this vignette (extension, .RMD) you
will be able to see that several chunks of code in this vignette
have the statement "eval = execute.vignette". The next chunk of code, by default,
sets execute.vignette = TRUE.  If execute.vignette = FALSE that would mean that the code is included (and necessary) but was
not run when the vignette was built.
```{r runchunks, eval = TRUE}
# Set whether or not the following chunks will be executed (run):
execute.vignette <- TRUE
```

### Load the relevant libraries
We use the command 'library()' to load various R packages for our analysis.
If you get the message "Error in library(X) : there is no package called 'X'"
then you will need to install that package: 

From the R command prompt:

install.packages("X")

Or, if using RStudio, look for 'Install Packages' under 'Tools' tab.
```{r load_packages, eval = execute.vignette}
library(ggplot2)
library(httk)
```

Check what version of **httk** is installed:

```{r version_check, eval = execute.vignette}
packageVersion("httk")
```

### Control run speed
To speed up how fast these examples run, we only simulate every $N^{th}$ chemical
(currently 100) -- to get all chemicals with data set SKIP.CHEMS to 1:
```{r chemical_thining, eval = execute.vignette}
NUM.CHEMS <- length(get_cheminfo(model="pbtk", suppress.messages = TRUE))
SKIP.CHEMS <- 100
```

Similarly, portions of this vignette use Monte Carlo sampling to simulate variability and
propagate uncertainty. The more samples that are used, the more stable the 
results are (that is, the less likely they are to change if a different random
sequence is used). However, the more samples that are used, the longer it takes
to run. So, to speed up how fast these examples run, we specify here that we
only want to use 25 samples, even though the actual **httk** default is 1000.
Increase this number to get more stable (and accurate) results:
```{r MC_samples, eval = execute.vignette}
NSAMP <- 10
```

# Examples
To get a list of parameters for the pbtk model of Triclosan in a rat:
```{r rat_pbtk_parameters, eval = execute.vignette}
parameters <- try(parameterize_pbtk(chem.name = "triclosan", 
                                    species = "rat"))
```
We do not have a full set of *in vitro* parameters for rat for Triclosan,
so we fill in the *in vitro* measured values with human-derived measurements and 
use rat physiological parameters by setting "default.to.human = TRUE":
```{r rat_pbtk_parameters2, eval = execute.vignette}
parameters <- parameterize_pbtk(chem.name = "triclosan", 
                                species = "rat", 
                                default.to.human = TRUE)
```

To change the $f_{up}$ in the previous parameters list to 0.001 from the
human value of 0.003044 and use it in a simulation of the PBTK model for
a single dose of 1 mg/kg BW of Triclosan in a rat:
```{r use)pbtk_parameters, eval = execute.vignette}
parameters["Funbound.plasma"] <- 0.001
out <- solve_pbtk(parameters = parameters, suppress.messages = TRUE)
```


## Making a table

In the example below, setting model to "pbtk"
in "get_cheminfo" removes the chemicals from the list with $f_{up}$ below
the limit of detection which have been set to zero because the
model uses partition coefficients that are calculated with
$f_{up}$. However, we could include all chemicals that work with the
models without partition coefficients by using the default option of
"3compartmentss" or setting exclude.fup.zero to false, and $f_{up}$
would then automatically be set to 0.005.

First we make up a list of chemicals with both literature $C_{ss}$ values and HTTK data for making new $C_{ss}$ predictions:
```{r select_Chemicals, eval = execute.vignette}
chem.list <- intersect(get_cheminfo(model = "pbtk", 
                                    suppress.messages = TRUE)[seq(
                                      1, NUM.CHEMS, SKIP.CHEMS)],
                       get_wetmore_cheminfo())
```

Then we initialize a NULL table and build it up one row at a time:
```{r make_Css_table, eval = execute.vignette}
css.table <- NULL
for (this.cas in chem.list)
{
    ids <- get_chem_id(chem.cas=this.cas)
    this.row <- data.frame(Compound=ids$chem.name,
                              DTXSID=ids$dtxsid,
                              CAS=this.cas)
    this.row <- cbind(this.row,
                      as.data.frame(calc_analytic_css(chem.cas = this.cas,
                                                      model = "pbtk",
                                                      output.units = "uM",
                                                      suppress.messages=TRUE)))
    this.row <- cbind(this.row,
                      as.data.frame(get_wetmore_css(chem.cas = this.cas,
                                                    which.quantile = 0.50,
                                                    output.units = "uM",
                                                    suppress.messages=TRUE)))
    this.row <- cbind(this.row,
                        as.data.frame(calc_mc_css(chem.cas = this.cas,
                                                  which.quantile = 0.50,
                                                  output.units = "uM",
                                                  samples = NSAMP,
                                                  suppress.messages=TRUE)))
    css.table <- rbind(css.table, this.row)
}
colnames(css.table) <- c("Compound","DTXSID","CAS", "PBTK", "Wetmore", "MC")
```

Now display the table and plot two columns against each other:
```{r display_Css_table, eval = execute.vignette}
knitr::kable(css.table, caption = "Literature and HTTK Plasma Css", 
             floating.environment="sidewaystable",
             row.names=FALSE,
             digits=3)
litvshttkcss <- ggplot(css.table, aes(Wetmore, MC)) +
    geom_point() + geom_abline() +
    scale_x_log10() + scale_y_log10() +
    xlab(bquote("Literature"~C[ss]~"("*mu*"M)")) +
    ylab(bquote("HTTK"~C[ss]~"("*mu*"M)")) +
    theme(axis.text = element_text(size = 16),
          axis.title = element_text(size = 16))
print(litvshttkcss)
```

## Plotting example

To see how $C_{ss}$ resulting from discrete dosing deviates from the
average steady state concentration, we can make a plot with **ggplot2**
that includes a horizontal line through the $y$-axis at the predicted
$C_{ss}$ for oral infusion dosing (Figure 2 in Pearce et al., 2017).
```{r plot_examples, eval = execute.vignette}
out <- solve_pbtk(chem.name = "Bisphenol A", 
                  days = 50, 
                  doses.per.day = 3,
                  daily.dose=1,
                  output.units = "uM")
plot.data <- as.data.frame(out)

css <- calc_analytic_css(chem.name = "Bisphenol A",
                  output.units = "uM")

c.vs.t <- ggplot(plot.data, aes(time, Cplasma)) +
    geom_line() + geom_hline(yintercept = css) +
    ylab(bquote("Plasma Concentration ("*mu*"M)")) +
    xlab("Day") +
    theme(axis.text = element_text(size = 16),
          axis.title = element_text(size = 16),
          plot.title = element_text(size = 17, hjust=0.5)) +
    ggtitle("Bisphenol A")
print(c.vs.t)
```

### Suppressing Messages
Note that since *in vitro-in vivo* extrapolation (IVIVE) is built upon
many, many assumptions, *httk** attempts to give many warning messages 
by default. These messages do not usually mean something is wrong, but 
are rather intended to make the user aware of the assumptions involved.
However, they quickly grow annoying and can be turned off with the
"suppress.messages=TRUE" argument. Proceed with caution...

```{r suppress_messages, eval = execute.vignette}
out <- solve_pbtk(chem.name = "Bisphenol A", 
                  days = 50, 
                  doses.per.day = 3,
                  daily.dose=1,
                  output.units = "uM",
                  suppress.messages = TRUE)

css <- calc_analytic_css(chem.name = "Bisphenol A",
                  output.units = "uM",
                  suppress.messages = TRUE)
```


## TK Study Summary Statistics
"calc_tk_stats" allows summary TK statistics to be calculated for a specific
study design (including dose regiment, duration, and species).
The following code calculates the peak plasma concentration for all chemicals in 
**httk** simulated for 10 days at 1 mg/kg BW/day with 3 doses per day.
Note that the function "calc_stats" was renamed "calc_tk_stats" in a later release
of **httk**.
```{r stats_example1, eval = FALSE}
all.peak.stats <- calc_stats(days = 10, doses.per.day = 3, stats = "peak")
```
The same function can be used for a single chemical. For example, 
the AUC, peak, and mean for a single 1 mg dose of Triclosan over 10
day:
```{r stats_example2, eval = execute.vignette}
triclosan.stats <- calc_stats(days = 10, chem.name = "triclosan")
```

## Steady-state Plasma Concentration
Below are examples of two functions,comparing the medians of
the Wetmore data in humans for 1 mg/kg BW/day of Bisphenol A with
the "calc_mc_css" simulation with probability distributions
containing a third of the standard deviation, half the limit of
detection for $f_{up}$, and the same number of samples of the
parameters used in [Wetmore et al. (2012)](https://doi.org/10.1093/toxsci/kfr254). 

We use make use of the default
Monte Carlo sampler by setting argument "httkpop=FALSE" to turn off
httk-pop ([Ring et al., 2017](https://doi.org/10.1016/j.envint.2017.06.004)) and 
"invitrouv=FALSE" to turn off uncertainty/variability
for the *in vitro* parameters ([Wambaugh et al., 2019](https://doi.org/10.1093/toxsci/kfz205)). 

Note that the function "get_wetmore_css" was renamed "get_lit_css" in a later release
of **httk**.
```{r css_examples, eval = execute.vignette}
get_wetmore_css(chem.cas = "80-05-7", daily.dose = 1,
                which.quantile = 0.5, output.units = "uM")

set.seed(654321)
calc_mc_css(chem.cas = "80-05-7", 
            daily.dose = 1, 
            which.quantile = 0.5,
            censored.params = list(
              Funbound.plasma = list(cv = 0.1, lod = 0.005)),
            vary.params = list(
              BW = 0.15, 
              Vliverc = 0.15, 
              Qgfrc = 0.15,
              Qtotal.liverc = 0.15, 
              million.cells.per.gliver = 0.15,
              Clint = 0.15),
            output.units = "uM", 
            samples = NSAMP,
            httkpop=FALSE,
            invitrouv=FALSE,
            suppress.messages = TRUE)
```

### Using more sophisticated Monte Carlo

**httk** uses Monte Carlo to simulate population variability and propagate 
parameter uncertainty. The algorithm for population variability, "httk-pop" 
[(Ring et al., 2017)](https://doi.org/10.1016/j.envint.2017.06.004) 
simulates population variability in TK by
predicting distributions of physiological parameters based on
distributions of demographic and biometric quantities from the
National Health and Nutrition Examination Survey (NHANES),
conducted by the U.S. Centers for Disease Control and Prevention
(CDC). MEthods for propagating uncertainty in *in vitro* measurements were
described by [Wambaugh et al. (2019)](https://doi.org/10.1093/toxsci/kfz205).

Both httk-pop and *in vitro* uncertainty/variability simulation, are on by default:
```{r css_examples2, eval = execute.vignette}
set.seed(654321)
calc_mc_css(chem.cas = "80-05-7", 
            daily.dose = 1, 
            which.quantile = 0.5,
            output.units = "uM", 
            samples = NSAMP,
            suppress.messages = TRUE)
```

### Controlling the random number generator

Any of the Monte Carlo functions in **httk**, often indicated by the 
inclusion of "mc" in the function name, make use of random draws from
distributions to simulate uncertainty and variability. The random number
generator in any computer is actually a pseudo-random number generator
that creates a sequence of nearly uncorrelated numbers, but that sequence
can be recreated at any time if we set a random number generator "seed".
In R we control the seed with the function "set.seed", which allows us
to get the same Monte Carlo output again and again (and in many cases
on different computers). The seed can take any value, and if you use the
same seed followed by the same functions called in the same order with the
same arguments, you will get the same answer again and again:
```{r set_seed_example, eval = execute.vignette}
# Random number generator seed 1:
set.seed(654321)
calc_mc_css(chem.cas = "80-05-7", 
            daily.dose = 1, 
            which.quantile = 0.5,
            output.units = "uM", 
            samples = NSAMP,
            suppress.messages = TRUE)

# Continuing to draw random numbers without resetting the seed:
calc_mc_css(chem.cas = "80-05-7", 
            daily.dose = 1, 
            which.quantile = 0.5,
            output.units = "uM", 
            samples = NSAMP,
            suppress.messages = TRUE)

# Random number generator seed 2:
set.seed(123456)
calc_mc_css(chem.cas = "80-05-7", 
            daily.dose = 1, 
            which.quantile = 0.5,
            output.units = "uM", 
            samples = NSAMP,
            suppress.messages = TRUE)

# Continuing to draw random numbers without resetting the seed:
calc_mc_css(chem.cas = "80-05-7", 
            daily.dose = 1, 
            which.quantile = 0.5,
            output.units = "uM", 
            samples = NSAMP,
            suppress.messages = TRUE)

# Random number generator seed 2 gives the same answer as it did above:
set.seed(123456)
calc_mc_css(chem.cas = "80-05-7", 
            daily.dose = 1, 
            which.quantile = 0.5,
            output.units = "uM", 
            samples = NSAMP,
            suppress.messages = TRUE)

# Random number generator seed 1 gives the same answer as it did above:
set.seed(654321)
calc_mc_css(chem.cas = "80-05-7", 
            daily.dose = 1, 
            which.quantile = 0.5,
            output.units = "uM", 
            samples = NSAMP,
            suppress.messages = TRUE)
```


## IVIVE with HTTK

Simple "reverse dosimetry" *in vitro-in vivo* extrapolation (IVIVE) determines
an administered equivalent dose (AED) by taking an *in vitro* concentration $C_{\text{in vitro}}$
(50 uM in the example below) and dividing it by the steady-state plasma 
concentration $C_{ss}$ produced by a dose rate of 1 mg/kg bw/day:

$$ AED = \frac{C_{\text{in vitro}}}{C_{ss}}$$

We can also calculate the AED using literature values or sampling with **httk**:
```{r literature_oral_equivalent_example, eval = execute.vignette}
get_wetmore_oral_equiv(50, chem.cas = "80-05-7")
set.seed(654321)
calc_mc_oral_equiv(50, chem.cas = "80-05-7", samples = NSAMP)
```

### Monte Carlo Simulation of $C_{ss}$
We can perform a Monte Carlo simulation on Zoxamide with the
model pbtk with the same limit of detection and coefficients of
variation (cv).
Note, the function "monte_carlo" was replaced with a similar function 
"calc_mc_tk" for simulation concentration timecourses, while arguments were
added to "calc_mc_css" that allowed the functionality seen in the 2017 paper.
Separately, a new function
"monte_carlo" was created to complement "httkpop_mc" and "invitro_mc" as
part of "create_mc_samples". "monte_carlo" varies parameters according to
a normal distribution with given mean and coefficient of variation or according
to a censored distribution with an additional limit of detection parameter.
Note that we again turn off httkpop and invitrouv to replicate the 2017 version
of Monte Carlo.

First we create a list of parameters and then assign a coefficient of variation
to each parameter we wish to vary:
```{r monte_carlo_css_example_1, eval = execute.vignette}
vary.params <- NULL
params <- parameterize_pbtk(chem.name = "Zoxamide")
for (this.param in names(subset(params, names(params) != "Funbound.plasma")))
  # Only want to vary numerical parameters:
  if (is.numeric(params[[this.param]])) 
      vary.params[this.param] <- 0.2
```

We can draw $f_{up}$ from a censored distribution with a limit of dextion (LOD)
of 0.01:
```{r monte_carlo_css_example_2, eval = execute.vignette}
censored.params <- list(Funbound.plasma = list(cv = 0.2, lod = 0.01))
```
### Solve the full TK time-course
```{r monte_carlo_css_example_3, eval = execute.vignette}
set.seed(1)
out <- calc_mc_tk(parameters=params, 
                  vary.params = vary.params,
                  censored.params = censored.params,
                  return.samples = TRUE, 
                  model = "pbtk",
                  suppress.messages = TRUE,
                  httkpop = FALSE,
                  invitrouv = FALSE,
                  samples = NSAMP,
                  solvemodel.arg.list = list(times = seq(0,0.5,0.025))
                  )
```

Make a table of concentration vs. time with confidence intervals:
```{r monte_carlo_css_example_4, eval = execute.vignette}
zoxtable <- cbind(out[["means"]][,"time"],
                  out[["means"]][,"Cplasma"],
                  out[["means"]][,"Cplasma"] - 1.96*out[["sds"]][,"Cplasma"],
                  out[["means"]][,"Cplasma"] + 1.96*out[["sds"]][,"Cplasma"])
colnames(zoxtable) <- c("time","Cplasma","lcl","ucl")
knitr::kable(zoxtable, caption = "Zoxamide plasma concentration vs. time",
             floating.environment="sidewaystable")
```

Plot Monte Carlo analysis of concentration vs. time:
```{r monte_carlo_css_example_5, eval = execute.vignette}
zoxamide1 <- ggplot(as.data.frame(zoxtable), aes(x=time,y=Cplasma)) +
    geom_line(color = "dark blue",linewidth=2) +
      geom_ribbon(aes(ymin=lcl, ymax=ucl), alpha = 0.3,
                  fill = "light blue", color="black", linetype="dotted")+
    ylab("Plasma concentration") +
    xlab("Time (days)") +
    theme(axis.text = element_text(size = 16),
          axis.title = element_text(size = 16))
print(zoxamide1)
```

### Examine $C_{ss}$
```{r monte_carlo_css_example_6, eval = execute.vignette}
out <- calc_mc_css(parameters=params, 
                  vary.params = vary.params,
                  censored.params = censored.params,
                  return.samples = TRUE, 
                  model = "pbtk",
                  suppress.messages = TRUE,
                  httkpop = FALSE,
                  samples = NSAMP,
                  invitrouv = FALSE)

zoxamide2 <- ggplot(as.data.frame(out), aes(out)) +
    geom_histogram(fill = "blue", binwidth = 1/6) +
    scale_x_log10() + ylab("Number of Samples") +
    xlab(bquote(C[ss]~"("*mu*"M)")) +
    theme(axis.text = element_text(size = 16),
          axis.title = element_text(size = 16))
print(zoxamide2)
```

## Adding a tissue
The **httk** package contains a data.frame called tissue.data that describes the
composition of various tissues in terms of the 
[Schmitt (2008)](https://doi.org/10.1016/j.tiv.2007.09.010) 
mechanistic model for deriving tissue:plasma partition coefficients. Once described,
these tissues are available for use as compartments in new models or to be lumped
into the rest of body in existing models (using function "lump_tissues"). We can add 
a new tissue (for example, mammary) to the tissue data by replicating the data
from another tissue and adjusting as appropriate.
```{r add_a_tissue, eval = execute.vignette}
new.tissue <- subset(tissue.data,Tissue == "adipose" & Species =="Human")
new.tissue[, "Tissue"] <- "mammary"
new.tissue[new.tissue$variable=="Vol (L/kg)","value"] <- 
  320/1000/60 # Itsukage et al. (2017) PMID: 29308107
new.tissue[new.tissue$variable %in% c('Flow (mL/min/kg^(3/4))'),'value'] <-
# We'll arbitrarily set flow to a tenth of total adipose:
  new.tissue[new.tissue$variable %in% c('Flow (mL/min/kg^(3/4))'),'value']/10
tissue.data <- rbind(tissue.data, new.tissue)
knitr::kable(subset(tissue.data,Tissue=="mammary"), 
             caption = "Approximate Mamary Tissue Parameters", 
             floating.environment="sidewaystable",
             row.names=FALSE,
             digits=3)
```
If we thought this tissue had been included in the rest of body total
previously we could consider removing it from those volumes and flows, but
we won't do that here (Note eval=FALSE):
```{r add_a_tissue2, eval = FALSE}
# If we thought this tissue was included in the rest of the bod
tissue.data[tissue.data$Tissue == "rest", 'value'] <-
  tissue.data[tissue.data$Tissue == "rest", 'value'] -
  new.tissue[new.tissue$variable %in% c(
    'Vol (L/kg)',
    'Flow (mL/min/kg^(3/4))'),
    'value']
```
To generate the parameters for a model with kidneys, thyroid, brain, 
breast, liver compartment combining the liver and gut, and a rest of body
compartment:
```{r add_a_tissue3, eval = execute.vignette}
compartments <- list(liver = c("liver", "gut"), kidney = "kidney",
                     breast = "mammary", brain = "brain",
                     thyroid = "thyroid")
tissues.to.include <- unique(tissue.data$Tissue)
tissues.to.include <- tissues.to.include[!(tissues.to.include=="placenta")]
Kp <- predict_partitioning_schmitt(
  chem.name = "Nicotine", 
  tissues = tissues.to.include,
  suppress.messages = TRUE)
lumped.params <- lump_tissues(Kp, tissuelist=compartments)
knitr::kable(as.data.frame(lumped.params), 
             caption = "PCs, Volumes, and Flows for Lumped Tissues", 
             floating.environment="sidewaystable",
             row.names=FALSE,
             digits=3)
```

## Adding a species
The **httk** package contains a data.frame called physiology.data that describes 
the species-specific aspects of physiology necessary to parameterize a PBTK 
model. We can add a new species (for example, wolverines) to the physiology.data by 
replicating the data from another species and adjusting as appropriate.

```{r add_a_species1, eval = execute.vignette}
new.species <- physiology.data[,"Rabbit"]
names(new.species) <- physiology.data[,"Parameter"]
rabbit.BW <- new.species["Average BW"] 
new.species["Average BW"] <- 31.2 # Rausch and Pearson (1972) https://doi.org/10.2307/3799057
new.species["Average Body Temperature"] <- 38.5 # Thiel et al. (2019) https://doi.org/10.1186/s12983-019-0319-8

physiology.data <- cbind(physiology.data, new.species)
colnames(physiology.data)[length(colnames(physiology.data))] <- "Wolverine"

knitr::kable(physiology.data[,c("Parameter","Units","Wolverine")], 
             caption = "Approximate Wolverine Physiological Parameters", 
             floating.environment="sidewaystable",
             row.names=FALSE,
             digits=3)
```

The tissue volumes and flows are stored separately in tissue.data. Physiological parameters are in the table physiology.data.
```{r add_a_species2, eval = execute.vignette}
new.tissue.data <- subset(tissue.data,Species=="Rabbit")
new.tissue.data$Species <- "Wolverine"

tissue.data <- rbind(tissue.data,new.tissue.data)

new.physiology.data <- physiology.data[,"Rabbit"]
physiology.data <- rbind(physiology.data, new.physiology.data)
colnames(physiology.data)[length(colnames(physiology.data))] <- "Wolverine"
```

Now we can make predictions for wolverines!
```{r add_a_species3, eval = execute.vignette}
calc_mc_css(chem.cas="80-05-7",species="wolverine",
            parameterize.args.list =list(default.to.human=TRUE),
            suppress.messages=TRUE,
            samples = NSAMP)
```

## Export functions

Jarnac [(Sauro and Fell 2000)](http://academic.sun.ac.za/natural/biochem/btk/book/Sauro.pdf) 
and SBML [(Hucka et al. 2003)](https://doi.org/10.1093/bioinformatics/btg015) are commonly used languages for
systems biology models of cellular and physiological processes. In the event that a modeler
wishes to couple such a model to a toxicokinetic model, we provide functions to export
model equations and chemical-specific parameters to these languages. The two functions,
"export_pbtk_sbml" and "export_pbtk_jarnac", have the same arguments and only differ in
the file extension names (.xml and .jan) entered into the filename argument. Both use liters
as the units for volume, but the amounts are unitless and to be determined by the user. If
we suppose that we enter an initial amount of 1 mg in the gut lumen, then all the other
compartments will contain amounts in mg. 

Below is a call of an export function for a dose
of 1 given to a rat:

```{r export, eval = FALSE}
export_pbtk_sbml(chem.name = "Bisphenol A", species = "Rat",
                 initial.amounts = list(Agutlumen = 1),
                 filename = "PBTKmodel.xml")
```

## Days to steady state histogram

Creating histograms can allow us to visualize how a given value varies across 
all the chemicals
contained within the package. To create a histogram using **ggplot2** of the 
number of days to
steady state, we must first set up a for loop with "get_cheminfo" and "calc_css" 
to generate a
vector containing the data. Vectors containing the average and maximum concentrations at
steady state are also generated in this example, avg and max. The data contained 
in the days
vector are then plotted as a histogram (Pearce et al., (2017) Figure 3). We can 
just as easily create a histogram
containing the average or maximum steady state concentrations by substituting 
avg or max
for days.

```{r figure3, eval = execute.vignette}
css.data <- data.frame()
chem.list <- get_cheminfo(model='pbtk', suppress.messages = TRUE)[seq(
  1, NUM.CHEMS, SKIP.CHEMS)]
for (this.cas in chem.list) {
    css.info <- calc_css(chem.cas = this.cas,
                         doses.per.day = 1,
                         model="pbtk",
                         suppress.messages = TRUE)
    css.data[this.cas,"days"] <- css.info[["the.day"]]
    css.data[this.cas,"avg"] <- css.info[["avg"]]
    css.data[this.cas,"max"] <- css.info[["max"]]
}

hist <- ggplot(css.data, aes(days+0.1)) +
    geom_histogram(fill = "blue", bins=5) +
    scale_x_log10() + ylab("Number of Chemicals") + xlab("Days") +
    theme(axis.text = element_text(size = 16),
          axis.title = element_text(size = 16))
print(hist)
```


## Average vs. maximum concentration

We can compare the average and maximum concentrations at steady state using the average
and maximum concentration at steady state vectors, avg and max, from the 
previous example.
The vectors are bound into a data frame and plotted with a line through the 
origin with a
slope of 1 (Pearce et al. (2017) Figure 4).


```{r figure4, eval = execute.vignette}
avg.vs.max <- ggplot(css.data, aes(avg, max)) +
    geom_point() + geom_abline() +
    scale_x_log10() + scale_y_log10() +
    xlab(bquote("Avg. Conc. at Steady State ("*mu*"M)")) +
    ylab(bquote("Max. Conc. at Steady State ("*mu*"M)")) +
    theme(axis.text = element_text(size = 16),
          axis.title = element_text(size = 16))
print(avg.vs.max)
```

---
title: "Meade (submitted): High Throughput Dermal Exposure Model"
author: "Annabel Meade, Celia Schacht, Alex George"
date: "`r Sys.Date()`"
output: rmarkdown::html_vignette
vignette: >
 %\VignetteIndexEntry{l) Meade (Submitted): High Throughput Dermal Exposure Model}
 %\VignetteEngine{knitr::rmarkdown}
 %\VignetteEncoding{UTF-8}
---
*Please send questions to John.Wambaugh@UL.org or aemeade7@gmail.com*

from "Development and analysis of high throughput physiologically based pharmacokinetic/toxicokinetic (PBPK/TK) dermal exposure model"

Annabel E. Meade, Celia M.Schacht, Marina V Evans, Alex George, Rachael Cogbill, Risa R. Sayre, and  John F. Wambaugh

## Abstract
Dermal absorption of chemicals represents an important route of exposure in pharmaceutical, occupational, and environmental settings. There are thousands of chemicals in use with little or no toxicity or toxicokinetic data, and dermal absorption data are lacking, unsurprisingly, for many of these chemicals. One alternative is to estimate human toxicokinetics using high-throughput methods. Accordingly, the aim of this study was to develop a generalized physiologically based pharmacokinetic/toxicokinetic (PBPK/TK) dermal exposure model for the R package httk. For dermal exposures this model can be used in a high-throughput manner to estimate human blood and tissue concentrations and estimate risk for many chemicals. The structure of the dermal PBPK/TK model was based on Campbell, Clewell, Gentry, Anderson, and Clewell, Computational Toxicology, 929, 439 (2012). Chemical-specific metabolism and protein binding data were obtained from the literature as collected by R package httk. The physiochemical property data needed for the model were obtained from the EPA CompTox Chemicals Dashboard. Here we have compared two different in vitro methods for estimating chemical-specific and vehicle-specific permeability in the skin: 1) Potts-Guy [Potts and Guy, Pharm Res, 9, 663 (1992)] and 2) Surrey [Chen, Han, Saib, and Lian, Pharm Res, 32, 1779 (2015)]. The model was constructed to allow comparison of dermal, oral, and intravenous exposures. Over 26 exposure scenarios across 13 chemicals were modeled and compared to published concentration-time in vivo data from the EPA CvT database [Sayre, Wambaugh, and Grulke, Scientific Data, 7, 122 (2020)]. Of these 13 chemicals, four are pharmaceuticals while the other 9 are occupationally or environmentally relevant, 9 of the 13 are lipophilic (log of the octanol to water partition coefficient, logP > 2), three of the 13 have low water solubility (< 10 mg/L), four of the 13 have high water solubility (> 1,000 mg/L), and eight of the 13 are considered volatile. The Root Mean Squared Log10 Error (RMSLE) between log-transformed simulated and observed concentrations was calculated to determine how well the model captures the behavior of this data when using the methods for dermal permeability. Based on these results, the Potts-Guy methods slightly out-perform the Surrey method of calculating dermal permeability for more volatile chemicals and the vehicle is a large factor in method success, where Potts-Guy/octanol and Surrey/water combinations generated the best fits. We also found that exhalation is an important route of excretion for volatiles, in particular. The views expressed in this abstract are those of the authors and do not necessarily represent the views or the policies of the U.S. Environmental Protection Agency.

## HTTK Version

This vignette was created with **httk** v2.3.3. Although we attempt to maintain backward compatibility, if you encounter issues with the latest release of **httk** and cannot easily address the changes, historical versions of httk are available from: https://cran.r-project.org/src/contrib/Archive/httk/

## Table of Contents (added by AG 01/02/2024)
Prepare for session
Result 1: Model Verification Usint *In Vivo* Data
  Step One: Load Data
  Display which chemicals are being looked at 
  Step Two: Clean and Format Data
  
  

## Prepare for session
```{r configure_knitr, eval = TRUE, echo=FALSE}
knitr::opts_chunk$set(echo = TRUE, collapse = TRUE, comment = '#>')
knitr::opts_chunk$set(echo = TRUE,out.width=700, fig.align='center') #figure out.width=700px
options(rmarkdown.html_vignette.check_title = FALSE)

# Clear memory
rm(list=ls()) 

# Useful function
`%!in%`<- Negate(`%in%`)
```


### eval = FALSE
If you are using the RMarkdown version of this vignette (has the file extension .RMD) you will be able to see that several chunks of code in this vignette have the statement `eval = FALSE`. The next chunk of code, by default, sets `run.simulations = FALSE`.  This means that the code is included (and necessary) but was not run when the vignette was built. We do this because some steps require  extensive computing time and CRAN has limits how long we can spend building the package. If you want this vignette to work, you must run all code, either by cutting and pasting it into R. Or, open the .RMD file in RStudio and either change run.simulations to TRUE or press "play" (the green arrow) on each chunk in RStudio.

We set a variable `run.simulations`. This will run simulations and regenerate data files. If this is set to `TRUE`, make sure you have the following data file: 

* R_CvT_Database/CvT_all_tables_2202-08-17.Rdata: CvT data inside the [CvTdb](https://doi.org/10.1038%2Fs41597-020-0455-1)
* R_CvT_Database/CvT_all_tables_2202-09-14_noSQL.Rdata: CvT data outside the [CvTdb](https://doi.org/10.1038%2Fs41597-020-0455-1) which had to be curated and loaded manually.
* CCD-Batch-Search_2022-11-29_07_06_35.xlsx: Excel file loaded from CompTox Dashboard for thirteen chemicals of interest.
#Note - also need file invitrodb_3_5_mc5.Rdata - downloaded ToxCast data. AG 12/7/2023

and if `run.simulations = FALSE`, make sure to have the following files in your working directory:

* *`r paste0("meade2023_",format(Sys.time(), "%b_%d_%Y"),".Rdata")`*: 
  + *concentration_data_meade2023*: concentration vs time and dosing data
 +  *conc_predictions_meade2023fDF* : simulations with and without exhalation included in the model, joined with concentration data.
  + *supptab1_meade2023*: Supplementary Table 1 which contains chemical data used for each of the simulated 13 chemicals saved in your working directory.
  + *ivive_meade2023* : IVIVE information for part 2 (if run.simulations.2 = FALSE)
  


```{r runchunks, eval = TRUE}
# Set whether or not the following chunks will be executed (run):
run.simulations <- FALSE # Change FALSE to TRUE here to make the vignette work
make.plots <- FALSE # change to TRUE to make the plots
run.simulations.2 <- FALSE #for second part of vignette
make.plots.2 <- FALSE # change to TRUE to make the plots
```

### Set working directory and install packages
Here, we set our working directory (the location of this file and the necessary data files) and load necessary packages. **Please reset your working directory below to `loc.wd` or the code will produce an error.**

We also set the location of the R package `httk` using the name `loc.httk` so that we can run the functions `modelinfo_dermal.R` and `modelinfo_dermal_1subcomp.R` file later in the code. Note that if you have `run.simulations = FALSE`, the variable `loc.httk` is not used, so you do not need to provide or change it.
```{r setup, eval = TRUE}
# Set working directory
loc.wd <- tempdir()
#loc.wd <- "C:/Users/jwambaug/OneDrive - Environmental Protection Agency (EPA)/Profile/Documents/Research Projects/DermalTK/vingette"
#loc.wd <- "/Users/ameade/Library/CloudStorage/GoogleDrive-aemeade7@gmail.com/My Drive/EPA/HTTK-Dermal/HTTK-Dermal-Vignette"

#loc.wd = "C:/Users/cschacht/OneDrive - Environmental Protection Agency (EPA)/Profile/Documents/CCTE_2023_2024/dermal/thisone"

# Set location of httk package
#loc.httk <- "C:/Users/jwambaug/git/httk-dev/httk"


# Load packages
packages <- c("httk","httkexamples","dplyr",
              "tidyverse","xlsx","Metrics", #for data manipulation
              "ggplot2","ggforce","ggpubr","ggrepel","viridis", #for plotting
              "knitr", "ggpubr","grid","ggh4x","readr","ggforce","knitr","tidyr",
              "stringr","pracma") #to make pretty visual tables

sapply(packages, require, character.only=TRUE)

# Make sure we're using a clean version of the httk chemical library:
#reset_httk()
```
# Result 1: Model Verification using *In Vivo* Data

First, we want to verify our model by testing it against *in vivo* data from literature.

## Step One: Load Data
We have some data which is taken from the CvT Database ([Sayre, Wambaugh, and Grulke, 2020](https://doi.org/10.1038%2Fs41597-020-0455-1)) and some data which has been prepared for the database but is not yet added to the Database, denoted as `noSQL` since it is not yet in the SQL space. The CvT Database contains structured data in the form of separate datasets linked with foreign keys ("fk"). Below is the entity-relationship for each of the databases. 

To learn more about where these datasets come from, please see `R_CvT_Database` folder, which contains files used to generate the data below.


```{r 1_load_data, eval = FALSE}
# Load CvT table database
load(paste0(loc.wd,"/R_CvT_Database/CvT_all_tables_2022-08-17.Rdata")) #Necessary file that is not included yet
  # Load CvT data that is not yet in CvT database (Annabel did this)
load(paste0(loc.wd,"/R_CvT_Database/CvT_all_tables_2023-07-05_noSQL.Rdata")) #Necessary file that is not included yet

  #Add cumulative_amount column in SQL DB_series (we don't use any cumulative amounts from SQL data in final results)
  DB_series <- DB_series %>% mutate(cumulative_amount=NA)

# Bind data sets from database and noSQL collection.
DB_documents_noSQL<-DB_documents_noSQL[colnames(DB_documents_noSQL) %in% colnames(DB_documents)] #Keep only columns from DB_documents_noSQL that are also found in DB_documents
DB_documents <- rbind(DB_documents,DB_documents_noSQL)
DB_studies_noSQL<-DB_studies_noSQL[colnames(DB_studies_noSQL) %in% colnames(DB_studies)]
DB_studies <- rbind(DB_studies,DB_studies_noSQL)
DB_chemicals <- rbind(DB_chemicals,DB_chemicals_noSQL)
DB_subjects <- rbind(DB_subjects,DB_subjects_noSQL)
DB_series <- rbind(DB_series,DB_series_noSQL)
DB_conc_time_values_noSQL<-DB_conc_time_values_noSQL[colnames(DB_conc_time_values_noSQL) %in% colnames(DB_conc_time_values)]
DB_conc_time_values <- rbind(DB_conc_time_values,DB_conc_time_values_noSQL)
```

Next, we need to clean the data and filter out `NA` results. First, we join the needed data sets using their foreign keys.
* `DB_conc_time_values`
* `DB_series`
* `DB_studies`
* `DB_subjects`
* `DB_documents`: Note that only the PubMed ID (PMID) of each extraction article is saved from this data set.

Next, we remove columns that are duplicated in each data set and are not used here. These columns in each data set, listed below, tell the user who created and updated the SQL files and additional comments by the data curator or article author.
* `created_by`
* `updated_by`
* `rec_update_dt`
* `rec_created_dt`
* `curator_comment`
* `author_comment` ( not in `DB_conc_time_values` or `DB_subjects`)
We also remove any data that:
* does not have a defined DTXSID for the chemical
* does not have a recorded concentration
* does not have a defined recorded medium (e.g., plasma, blood, urine, etc.) 
* where the analyte measured does not match the test substance used to dose the individual

Finally, after cleaning this data set, called `df.full`, we filter so that we only have data for chemicals that have dermal data. Our final data set is called `df`.
```{r 1_filter_data, eval = FALSE}
# Join necessary DBs: conc_time_values, series, studies, subjects
df.full <- DB_conc_time_values %>% 
  left_join(DB_series,by=c("fk_series_id"="id")) %>%
  left_join(DB_studies,by=c("fk_study_id"="id")) %>%
  left_join(DB_subjects,by=c("fk_subject_id"="id")) %>%
  left_join(DB_documents[,c("id","pmid")],by=c("fk_extraction_document_id" = "id")) %>%
  dplyr::rename(extraction_document_pmid=pmid) %>%
  select(!(ends_with(".x") | ends_with(".y"))) %>%
  filter(!is.na(test_substance_dtxsid)) %>% #remove series w/o defined chemicals (Changed from study to series AG)
  filter( !is.na(conc)) %>% #filter out NA data
  filter(!is.na(conc_medium_normalized)) %>% #remove series w/o defined medium (i.e., plasma, blood, urine, etc.)
  filter(test_substance_dtxsid==analyte_dtxsid | is.na(analyte_dtxsid)) #analyte (measured substance) and test substance must be the same

df.full <- distinct(df.full)

# Remove empty cells
df.full <- type_convert(df.full)
df.full <- df.full %>% filter(!is.na(conc))

# Get list of chemicals that have dermal data
df.dermal <- df.full %>% filter(administration_route_normalized=="dermal")
dermal_dtxsid <- unique(df.dermal$test_substance_dtxsid)

# Only keep data for chemicals that have dermal data
df <- df.full %>% filter(test_substance_dtxsid %in% dermal_dtxsid) 
```

```{r load_CvT_data, eval = run.simulations}
df <- httkexamples::dermalCvT2025
```


## Display which chemicals are being looked at
```{r summarize_cvt, eval=run.simulations}
table <- df %>% mutate(Chemical = get_chem_id(dtxsid=test_substance_dtxsid)$chem.name) %>% dplyr::count(Chemical,test_substance_dtxsid,extraction_document_pmid,sort=F) %>% dplyr::rename(Number.of.Data.Points = n)
row.names(table) <- 1:nrow(table)
knitr::kable(table, row.names=TRUE,caption="List of chemicals with dermal data before cleaning data.")
dir.create(normalizePath(paste0(loc.wd,"/tables")))
write.table(table,
            file=normalizePath(paste0(loc.wd,"/tables/ChemicalswDermalData.txt")),
            col.names=TRUE,
            row.names=FALSE,
            quote=FALSE,
            sep="\t")
```

Next, We look at several chemical factors with respect to our data. Thus, we ran a batch search of the 13 chemicals in our study in the CompTox Dashboard and now load information about these chemicals (Boiling point, Volatility, etc.) and save this as 'supptab1_meade2023'. 
```{r 1_supptable, eval=FALSE}
# Load chemical info
supptab1_meade2023 <- read.xlsx(file=paste0(loc.wd,"/CCD-Batch-Search_2022-11-29_07_06_35.xlsx"),
                                sheetName="Main Data") #A separate download was needed for this file AG 12/6/23

# Rename chemical properties and change units
supptab1_meade2023 <- supptab1_meade2023 %>% mutate(Water.Solubility.mg.L = WATER_SOLUBILITY_MOL.L_OPERA_PRED*AVERAGE_MASS*1000,
                                                    Vapor.Pressure.mmHg = VAPOR_PRESSURE_MMHG_OPERA_PRED,
                                                    Boiling.Point.C = BOILING_POINT_DEGC_OPERA_PRED,
                                                    logP = OCTANOL_WATER_PARTITION_LOGP_OPERA_PRED,
                                                    MW = AVERAGE_MASS,
) %>%
  select(c(PREFERRED_NAME,DTXSID,Water.Solubility.mg.L,Vapor.Pressure.mmHg,Boiling.Point.C,logP,MW))

# Add column for "Volatility
supptab1_meade2023 <- supptab1_meade2023 %>% mutate(Volatility = ifelse(Boiling.Point.C<=75,"Very Volatile",
                                                                        ifelse(Boiling.Point.C>400,"Not Volatile",
                                                                               ifelse((Boiling.Point.C>=250)&(Boiling.Point.C<=400),"Semi-Volatile","Volatile"))),
                                                    # Rename long chemicals to nick-names
                                                    PREFERRED_NAME = ifelse(PREFERRED_NAME=="Methyl tert-butyl ether","MBTE",PREFERRED_NAME),
                                                    PREFERRED_NAME = ifelse(PREFERRED_NAME=="3,3',5,5'-Tetrabromobisphenol A","Bromdian",PREFERRED_NAME),
                                                    PREFERRED_NAME = ifelse(PREFERRED_NAME=="4,4'-Sulfonyldiphenol","Bisphenol S",PREFERRED_NAME),
                                                    PREFERRED_NAME = ifelse(PREFERRED_NAME=="Dichloromethane","DCM",PREFERRED_NAME),
                                                    PREFERRED_NAME = ifelse(PREFERRED_NAME=="Tetrachloroethylene","PERC/TCE",PREFERRED_NAME),
                                                    PREFERRED_NAME = ifelse(PREFERRED_NAME=="1-Methylbenzene","Toluene",PREFERRED_NAME))

supptab1_meade2023$Volatility <- factor(supptab1_meade2023$Volatility, levels=c("Not Volatile","Semi-Volatile","Volatile","Very Volatile"))
#save chemical dataframe
save(supptab1_meade2023,file=noramlizePath(paste0(loc.wd,"/meade2023_",format(Sys.time(), "%b_%d_%Y"),".Rdata")))

supptab1_meade2023[,c(3:7)]=signif(supptab1_meade2023[,c(3:7)],3)
knitr::kable(supptab1_meade2023, 
             #row.names=TRUE,
             caption="Chemical properties",
             floating.environment="sidewaystable",
             align="c")
write.table(supptab1_meade2023,
            file=paste0(loc.wd,"/tables/ChemicalProperties.txt"),
            col.names=TRUE,
            row.names=FALSE,
            quote=FALSE,
            sep="\t")

```
```{r load_suptable, eval=run.simulations}
supptab1_meade2023 <- httkexamples::meade2025
supptab1_meade2023[,c(3:7)]=signif(supptab1_meade2023[,c(3:7)],3)
```


## Step Two: Clean and Format Data

Next we clean the data by looking only at data that can be simulated using the httk dermal model. First, we load the most recent QSAR in *silico data* ([Dawson et al., 2021](https://doi.org/10.1021/acs.est.1c05924)) from `httk`. #Add a statement about why QSAR values are needed - there are many chemicals for which httk does not have experimentally derived Clint and Fup. - AG 01/01/2024

```{r 1_load_QSAR, eval=run.simulations}
load_dawson2021() #get QSAR data, overwrite for p-values greater than 0.05
```



Next, we only load data for routes `iv`, `oral`, and of course `dermal`. We also must remove the chemicals: dibromomethane, halothane, and isoflurane, because these chemicals do not have *in silico* or *in vitro* data to inform necessary parameters for the httk dermal model.

```{r 1_clean_data, eval=run.simulations}
# Select route (dermal/iv/oral)
route.ls = c("iv","dermal","oral")

# Reduce data based on available in vitro data
# df.reduced <- df %>% filter(administration_route_normalized %in% route.ls) %>% #only iv, oral, dermal routes
#   filter(test_substance_dtxsid %!in% c("DTXSID4021557","DTXSID4025371","DTXSID3020752")) #no metabolism data for: dibromomethane, halothane, isoflurane
df.reduced <- df %>% filter(administration_route_normalized %in% route.ls) %>% #only iv, oral, dermal routes
  filter(!(test_substance_dtxsid %in% c("DTXSID4021557","DTXSID4025371","DTXSID3020752"))) #no metabolism data for: dibromomethane, halothane, isoflurane

df.reduced <- type_convert(df.reduced) #change dose_level_normalized to numeric 

#Join df.reduced with the Volatility/chemical info from supptab1_meade2023
df.reduced = df.reduced %>% left_join(supptab1_meade2023,by=c("test_substance_dtxsid"="DTXSID"))

df.reduced=subset(df.reduced, !(conc_medium_normalized %in%c("feces","urine")))
# Display which chemicals are being looked at
table <- df.reduced %>% 
  mutate(Chemical = get_chem_id(dtxsid=test_substance_dtxsid)$chem.name) %>% 
  dplyr::count(Chemical,test_substance_dtxsid,extraction_document_pmid,conc_medium_normalized,sort=F) %>% 
  dplyr::rename("Number.of.Data.Points" = n)
row.names(table) <- 1:nrow(table)
knitr::kable(table, 
             row.names=TRUE,
             caption="List of chemicals with dermal data after cleaning data.")
write.table(table,
            file=paste0(loc.wd,"/tables/ChemicalswDermalDataCleaned.txt"),
            col.names=TRUE,
            row.names=FALSE,
            quote=FALSE,
            sep="\t")
```
Next, we clean up the data so we can match experimental conditions to simulation conditions. We start by normalizing concentration and concentration units (where concentration refers to the experimental concentration vs. time data)

```{r conc_cleanup, eval=run.simulations}
# Set dummy column for Concentration units 
df.reduced$conc_normalized = NA
df.reduced$conc_units_normalized = df.reduced$conc_units_original

allset = which(df.reduced$conc_units_original %in% c("ug/mL","ug/g","mg/kg", "mcg/mL","mg/L"))
df.reduced$conc_units_normalized[allset]="mg/L"; df.reduced$conc_normalized[allset]=df.reduced$conc_original[allset]

ngml = which(df.reduced$conc_units_original=="ng/ml");df.reduced$conc_normalized[ngml]=  df.reduced$conc_original[ngml]*0.001
df.reduced$conc_units_normalized[ngml]="mg/L"

ngl = which(df.reduced$conc_units_original=="ng/l");df.reduced$conc_normalized[ngl]=  df.reduced$conc_original[ngl]*1e-06
df.reduced$conc_units_normalized[ngl]="mg/L"

molunts = which(df.reduced$conc_units_original %in% c("uM","nmol/L","umol/L"))
dtx=unique(df.reduced[molunts,c("test_substance_dtxsid","conc_units_original")])
dtx$mw = get_physchem_param(param="MW", dtxsid=dtx$test_substance_dtxsid)

for(z in 1:dim(dtx)[1]){
  these.rows=which(df.reduced$test_substance_dtxsid==dtx$test_substance_dtxsid[z] & df.reduced$conc_units_original==dtx$conc_units_original[z])
  conversion_val = convert_units(input.units = dtx$conc_units_original[z],output.units = "mg/L",dtxsid=dtx$test_substance_dtxsid[z])
  df.reduced[these.rows,"conc_normalized"] = df.reduced[these.rows,"conc_original"] * conversion_val
  df.reduced$conc_units_normalized[these.rows] = "mg/L"
}

perc.dose=which(df.reduced$conc_units_original %in%c("% dose", "% dose/h"))
df.reduced[perc.dose, "conc_normalized"]=df.reduced[perc.dose, "conc_original"]*df.reduced[perc.dose, "dose_level_original"]
#df.reduced[perc.dose,"conc_units_normalized"]=df.reduced[perc.dose,"dose_level_original_units"]
df.reduced[perc.dose,"conc_units_normalized"]="mg/L"                                                                                       
# ppbv
ppbv = which(df.reduced$conc_units_original=="ppbv")
df.reduced[ppbv, "conc_normalized"] = convert_units(input.units = "ppbv",output.units = "mg/L",dtxsid=unique(df.reduced$analyte_dtxsid[ppbv]),state="gas") * df.reduced[ppbv, "conc_original"]
df.reduced$conc_units_normalized[ppbv] = "mg/L"


```


We also convert the dose units from the database to be in amounts (not concentrations) using the vehicle volumes. After doing this, all unique dosing scenarios are listed in a table.

```{r 1_convert_dose_units, eval=run.simulations}
# Convert ug/mL to mg
df.reduced <- df.reduced %>% 
  separate(dose_volume,
           into=c("dose_volume","dose_volume_units"),
           sep=" ") %>% #separate dose volume into number and units, units either NA or ml/mL
  mutate(dose_volume=as.numeric(dose_volume)) %>%
  mutate(dose_level_new = 
           ifelse(tolower(dose_level_original_units)=="ug/ml",
                  dose_level_original*dose_volume/1e+3, # ug >- mg, vol in mL
                  dose_level_original), #convert ug/ml to mg
         dose_level_new_units = 
           ifelse(tolower(dose_level_original_units)=="ug/ml",
                  "mg",
                  dose_level_original_units))


# Convert ppm units to mg/L (assuming ppm is in air) - add MW to dataframe to do this
df.reduced <- df.reduced %>% 
  left_join(chem.physical_and_invitro.data[,c("DTXSID","MW")], 
            by=c("test_substance_dtxsid"="DTXSID"))
df.reduced$MW.y=NULL
colnames(df.reduced)=gsub("MW.x","MW",colnames(df.reduced)) #fix MW 
df.reduced  = df.reduced %>% #
  mutate(MW = as.numeric(MW)) %>%
  group_by(test_substance_dtxsid) %>%
  mutate(dose_level_new = 
           ifelse(dose_level_original_units=="ppm" ,
                  dose_level_new *
                    convert_units(input.units="ppmw", #?? whatever
                                  output.units = "mg/l",
                                  MW = unique(MW)),
                  dose_level_new),
         # dose_level_new = 
         #   ifelse(dose_level_original_units=="ppm" & administration_route_original!="dermal vapor",
         #          dose_level_new *
         #            convert_units(input.units="ppmw", #?? whatever
         #                          output.units = "mg/l",
         #                          MW = unique(MW), state="liquid"),
         #          dose_level_new),
         dose_level_new_units = 
           ifelse(tolower(dose_level_original_units)=="ppm",
                  "mg/L",
                  dose_level_new_units))
df.reduced$dose_level_new_units[which(df.reduced$dose_level_new_units=="ppm")]="mg/L"

# Set normalized vehicle
df.reduced <- df.reduced %>% 
  mutate(dose_vehicle_normalized = 
           ifelse(grepl("corn oil",dose_vehicle) | 
                    grepl("ethanol",dose_vehicle),"octanol", 
                  ifelse(!is.na(dose_vehicle) & 
                           !grepl("Cookie",dose_vehicle),
                         "water",
                         NA)))

# Remove added chemical MW column for now
df.reduced <- df.reduced %>% select(!MW)

# Display dosing scenarios
table <- df.reduced %>% 
  mutate(dose_level_original=signif(dose_level_original,3),
         dose_level_new = signif(dose_level_new,3),
         Chemical = get_chem_id(dtxsid=test_substance_dtxsid)$chem.name) %>% 
  count(Chemical,dose_level_original,
        dose_level_original_units,
        dose_level_new,
        dose_level_new_units,
        dose_volume,
        dose_volume_units,
        dose_vehicle,
        dose_vehicle_normalized,
        dermal_applied_area,
        dermal_applied_area_units,sort=F) %>% 
  rename("Number.of.Data.Points" = n)
row.names(table) <- 1:nrow(table)
knitr::kable(table, 
             #row.names=TRUE,
             caption="Dosing Scenarios in CvT Data",
             floating.environment="sidewaystable",
             align="c")
```


## Display which chemicals are being looked at
```{r summarize_cvt2, eval=run.simulations}
table <- df %>% mutate(Chemical = get_chem_id(dtxsid=test_substance_dtxsid)$chem.name) %>% dplyr::count(Chemical,test_substance_dtxsid,extraction_document_pmid,sort=F) %>% dplyr::rename(Number.of.Data.Points = n)
row.names(table) <- 1:nrow(table)
knitr::kable(table, row.names=TRUE,caption="List of chemicals with dermal data before cleaning data.")
```


Now, update certain experimental parameters. If body weight is not reported, set it as the population mean,
calculate skin area, and specify the model output name that corresponds to each medium. Also, we need to extract dose duration information for explicit values for the length of duration and the length of duration units (in hours, making conversions when necessary).
```{r 1_updateparms, eval=run.simulations}
df.new=df.reduced

df.new$species = tolower(df.new$species)
# get dose duration in numbers and time units
df.new$dose_duration_num = as.numeric(str_extract(df.new$dose_duration, "[0-9]+"))
df.new$dose_duration_units = str_extract(df.new$dose_duration, "[aA-zZ]+")
df.cases <- df.new %>% mutate(BW = ifelse(!is.na(weight_kg),weight_kg,
                                                    case_when(
                                                      species=="rat" ~ 0.4,
                                                      species=="human" ~ 70,
                                                      species=="mouse" ~ 0.025,
                                                      species=="rabbit" ~ 1.6
                                                    )),
                                        # Set human default height to 175 cm if not listed
                                        height_cm = ifelse(species=="human" & is.na(height_cm),175,height_cm),
                                        totalSA = case_when( 
                                          species=="rat" ~ 9.83*(BW*1000)^(2/3), # formula from Gouma et al., 2012, 195-240grams
                                          species=="human" ~ sqrt(height_cm * BW/3600) * 100^2,
                                          species=="mouse" ~ 9.83*(BW*1000)^(2/3),
                                          species=="rabbit" ~ 100*11*(BW)^(2/3)  # formula from Tadashi et al., 2018
                                        ),
                                        #Assume Fskin_exposed = 10% if not stated
                                        Fskin_exposed = ifelse(!is.na(dermal_applied_area),dermal_applied_area/totalSA,0.1),
                                        #Infinite Dose if dosing units are concentration mg/l AJG 4/13/24: Double check that mg/l are listed in the correct places in the previous chunk.
                                        InfiniteDose = ifelse(dose_level_new_units=="mg/L",1,0), # omg
    
                                        Vvehicle = ifelse(tolower(dose_volume_units)=="ml",dose_volume/1e3,dose_volume),
                                        #Standardize time units for dose duration AJG 5/7/24
                                        dose_duration_units = case_when(
                                          dose_duration_units %in% c("hr","h","hour","hrs","hours") ~ "hours",
                                          dose_duration_units %in% c("min","m","minute","minutes","mins") ~ "mins",
                                          dose_duration_units %in% c("day","d","days") ~ "days"
                                        ),
                              dose_duration_num2 = ifelse(dose_duration_units=="mins", dose_duration_num/60, dose_duration_num),
                              dose_duration_units2 = ifelse(dose_duration_units=="mins", "hours", dose_duration_units)
                              
                              
)
# remove experiments where conc_medium_normalized = feces and set observation to collect
df.cases = subset(df.cases, !(conc_medium_normalized %in%c("urine","feces")))
df.cases = df.cases%>%
  mutate(conc_medium_obs = recode(conc_medium_normalized,
                                  "blood"="Cven",
                                  "liver"="Cliver",
                                  "lung"="Clung",
                                  "kidney"="Ckidney",
                                  "plasma"="Cplasma",
                                  "serum"="Cplasma",
                                  "expired air" = "Aexhaled"
  ))


# Display dosing scenarios
table <- df.cases %>% 
  mutate(dose_level_original=signif(dose_level_original,3),
         dose_level_new = signif(dose_level_new,3),
         Chemical = get_chem_id(dtxsid=test_substance_dtxsid)$chem.name) %>% 
  count(Chemical, species,dose_level_original,
        dose_level_original_units,
        dose_level_new,
        dose_level_new_units,
        dose_volume,
        dose_volume_units,
        dose_vehicle,
        dose_vehicle_normalized,
        dose_duration_num2,
        dermal_applied_area,
        dermal_applied_area_units,
        extraction_document_pmid,sort=F)
row.names(table) <- 1:nrow(table)
knitr::kable(table, 
             #row.names=TRUE,
             caption="Dosing Scenarios in CvT Data",
             floating.environment="sidewaystable",
             align="c")
write.table(table,
            file=paste0(loc.wd,"/tables/CvTdbDosingScenarios.txt"),
            col.names=TRUE,
            row.names=FALSE,
            quote=FALSE,
            sep="\t")  

```


Finally, we clarify exhalation (depending on chemical volatility) and set vehicle volume parameters and save the entire cleaned datasheet as concentration_data_meade2023.

```{r 1_mergetable, eval=run.simulations}
df.cases_new = df.cases
df.cases_new$Kvehicle2water = df.cases_new$dose_vehicle_normalized # set this parameter
df.cases_new =  df.cases_new %>% mutate(
  administration_route_normalized = case_when(
    administration_route_normalized == "oral" ~ "Oral",
    administration_route_normalized == "iv" ~ "IV",
    administration_route_normalized == "dermal" ~ "Dermal"
  ),
    #Add exhalation for volatile compounds
    Exhalation = case_when(
      levels(Volatility)[Volatility] == "Very Volatile" ~ TRUE,
      levels(Volatility)[Volatility] == "Volatile" ~ TRUE, 
      levels(Volatility)[Volatility] == "Semi-Volatile" ~ TRUE,
      levels(Volatility)[Volatility] == "Not Volatile" ~ FALSE
    ),
    # Set default vehicle volume when it is unknown. Assume a uniform 1 mm layer of vehicle on skin. Then there is 0.0001 L vehicle per cm^2 of exposed skin. For cases with non-dermal routes of exposure, these values are NA.
    Vvehicle = case_when(
      administration_route_normalized=="Dermal" ~ ifelse(!is.na(Vvehicle), Vvehicle, Fskin_exposed*totalSA*0.0001),
      administration_route_normalized=="Oral" ~ NA,
      administration_route_normalized=="IV" ~ NA)
   
)

# save what we want
concentration_data_meade2023 = df.cases_new
```
```{r resavedata, eval=FALSE}
cgwtools::resave(concentration_data_meade2023,
                 file=normalizePath(paste0(loc.wd,
                                           "meade2023_",
                                           format(Sys.time(),
                                           "%b_%d_%Y"),".Rdata")))

```



## Step Three: Simulate Data

Now, we will simulate the *in vivo* concentration vs time data using the httk dermal model. Using `concentration_data_meade2023`, which is clean and filtered above, we create a new data set called `df.simulations` which will contain simulation data. We simulate 6 different dermal scenarios:
* Potts-Guy, vehicle=octanol
* Potts-Guy, vehicle=water
* Surrey, vehicle=octanol 
* Surrey, vehicle=water
* 2 Compartment, vehicle=octanol
* 2 Compartment, vehicle=water


### Simulation Set-Up
Specify the units we want returned and set up simulation data.
```{r 1_simsetup, eval=run.simulations}

# Set output units for dermal model to be same as data
output.units.original <- c( "Agut"="mg", "Agutlumen"="mg", "Aliver"="mg", "Aven"="mg", "Alung"="mg", "Arest"="mg", "Akidney"="mg", "Atubules"="mg", "Ametabolized"="mg", "Avehicle"="mg", "Ain"="mg",  
                            "Cgut"="mg/L", "Cliver"="mg/L", "Cven"="mg/L", "Clung"="mg/L", "Cart"="mg/L", "Crest"="mg/L", "Ckidney"="mg/L", "Cplasma"="mg/L", "Cvehicle"="mg/L", "Cvehicle_infinite"="mg/L")

df.simulation = concentration_data_meade2023



# Find experiments with unique dosing regimes/species/etc and average those that had multiple time points
# for the same type of experiment. Rename each experiment with new_id.
keep.cols=c("PREFERRED_NAME","test_substance_dtxsid", "conc_medium_obs", "conc_medium_normalized", "administration_route_normalized", "species", "BW", "dose_level_new", "dose_level_new_units","totalSA","Vvehicle","InfiniteDose","dose_duration_num2","dose_duration_units2","Fskin_exposed","Exhalation","dose_vehicle_normalized","Water.Solubility.mg.L", "Vapor.Pressure.mmHg","Boiling.Point.C","logP", "Volatility", "Kvehicle2water")
df.simulation_red=data.frame(df.simulation%>%group_by(across(all_of(c("time_hr",keep.cols) )))%>%
  summarize(conc_normalized=mean(conc_normalized),.groups="drop")%>%group_by(across(all_of(keep.cols)))%>% arrange(time_hr)%>% mutate(new_id=cur_group_id())%>%
  ungroup())

df.simulation_red2=df.simulation_red%>%mutate(across(c(dose_duration_num2,dose_duration_units2,Vvehicle),~ifelse(is.na(.x),list(NULL),.x)))
```


### Simulations: Nested For Loops


We have nested for loops to account for each aspect of the data that needs to be simulated. Each ID number (or "new_id") in df.simulation_red2 corresponds to a single experiment (or experiment with averaged concentration data if the subject species, dose, route, etc. was the same), where we have defined the necessary variables:  species, chemical, dose, dose duration (when applicable), whether or not an Infinite dose is applicable, route of exposure, the collected medium/tissue being sampled (i.e., plasma, blood, liver) and subject parameters such as body mass (kg) and surface area of skin. Thus, we run through each unique ID and first parameterize the model using parameterize_dermal_pbtk() and then solve the model using solve_dermal_pbtk(). For each ID, we simulate each permeability method (Surrey and Potts-Guy); for each ID/permeability method, we simulate either a water or octanol vehicle; then for each combination, we simulate the model both with and without exhalation. Note that some experimental data indicate the vehicle used, but we still test both vehicles for simulation to compare. Likewise, we calculated volatility for each chemical (which indicate whether or not exhalation actually occurs), but we still generate for all options. Note that solve_dermal_pbtk() can handle IV or oral exposure by setting the "route" input variable. Each model output is saved to a list called conc_predictions_meade2023LIST. Then this list is converted to a data frame.


```{r 1_simulations,eval=run.simulations}
df.run.sims = df.simulation_red2
fkID = unique(df.run.sims$new_id)
method.perm = c("Potts-Guy", "UK-Surrey")# for
Kvehicle2water=c("octanol","water") # for
exhalation_for_simulation = c("TRUE","FALSE")


conc_predictions_meade2023LIST=list()


for (include.e in exhalation_for_simulation){
  for(i in 1:length(fkID)){
    for(mp in 1:length(method.perm)){
      for(k in 1:length(Kvehicle2water)){
        sub.df = subset(df.run.sims, new_id == fkID[i])
        specs = unique(sub.df[,c("test_substance_dtxsid","conc_medium_obs","administration_route_normalized",
                                 "species","BW","dose_level_new","dose_level_new_units",
                                 "totalSA","Vvehicle","InfiniteDose","dose_duration_num2","dose_duration_units2",
                                "Fskin_exposed","Exhalation")])
        # check for experiments with only 1 timepoint and reset sub.df
        if(length(sub.df$time_hr)==1){
            sub.df=rbind(sub.df, sub.df[rep(1,1),])
            sub.df[1,c("conc_normalized","time_hr")]=0
        }
      
        parms = parameterize_dermal_pbtk(dtxsid = specs$test_substance_dtxsid,
                                 species = specs$species,
                                 totalSA = specs$totalSA,
                                 default.to.human=T,
                                 Kvehicle2water = Kvehicle2water[k],
                                 InfiniteDose = specs$InfiniteDose,
                                 method.permeability = method.perm[mp],
                                 
                                 model.type="dermal_1subcomp",
                                 clint.pvalue.threshold = Inf,
                                 suppress.messages = T
                                 )
        parms$BW = specs$BW
        parms$Fskin_exposed = specs$Fskin_exposed
      
        # Remove exhalation or keep exhalation (except for collected air which is )
        if(include.e == FALSE) {parms$Qalvc = 0}
        
        if(unique(sub.df$PREFERRED_NAME!="DCM"))
          { # tolerance is bad for DCM, so set tolerance to default values for all other compounds.
           rtol=1e-5; atol=1e-5
        }else{
           rtol=1e-4; atol=1e-4
        }
        
    
        sub.df=sub.df[order(sub.df$time_hr),]
        timey = unique(c(0,sub.df$time_hr)) #time in hours
        gc() # garbage collection (memory)
        ok=data.frame(solve_dermal_pbtk(parameters = parms,
                        times = timey/24, #convert to days
                         route = tolower(specs$administration_route_normalized),
                         model.type="dermal_1subcomp",
                         plot = FALSE,
                         output.units = output.units.original,
                         washoff = TRUE,
                         input.units = specs$dose_level_new_units,
                         initial.dose=specs$dose_level_new,
                         dose.duration = unlist(specs$dose_duration_num2),
                         dose.duration.units = unlist(specs$dose_duration_units2),
                         Vvehicle = unlist(specs$Vvehicle),
                        #dosing.dermal = dosing.dermal,
                         Kvehicle2water = Kvehicle2water[k],
                         suppress.messages = TRUE,
                        atol = atol, rtol= rtol,
                        method="lsoda"
                         ))
         # extract only times we need
          ok.time = subset(ok, time%in%c(ok$time[!(is.na(match(ok$time, sub.df$time_hr/24)))]))
          sub.df$Prediction = ok.time[,c(specs$conc_medium_obs)]
          sub.df$exhalation_for_simulation = include.e
          
          # specify vehicle and perm. method and vehicle if dermal
          if(specs$administration_route_normalized != "Dermal"){
            sub.df$method.perm = NA
            sub.df$Kvehicle2water = NA
            sub.df$method.name = specs$administration_route_normalized
          }else{
            sub.df$method.perm = method.perm[mp]
            sub.df$Kvehicle2water = Kvehicle2water[k]
            sub.df$method.name = paste(method.perm[mp], "- vehicle = ", Kvehicle2water[k])
          }

        conc_predictions_meade2023LIST[[paste0(fkID[i],".",Kvehicle2water[k],".",method.perm[mp],".exh",include.e)]]= sub.df
      }
    }
  }
}
#Bind data together to create a dataframe and organize some columns
 conc_predictions_meade2023DF = do.call(rbind, conc_predictions_meade2023LIST) 
 rownames(conc_predictions_meade2023DF)=NULL



 #cgwtools::resave(conc_predictions_meade2023DF, conc_predictions_meade2023LIST, file=paste0(loc.wd,"/meade2023_",format(Sys.time(), "%b_%d_%Y"),".Rdata"))

```

Now, if run.simulations = FALSE, we must load data. This load supptab1_meade2023, concentration_data_meade2023, conc_predictions_meade2023DF, conc_predictions_meade2023LIST.
```{r load_data, eval=FALSE}
# load(paste0(loc.wd, "/meade2023_Jun_13_2025.Rdata"))
load(paste0(loc.wd, "/meade2023_Sep_02_2025.Rdata"))
```

## Step Four: Calculate Root Mean Squared Log10 Errors (RMSLE)
Now, we want to get the RMSLE for each chemical, comparing the model to the data. Let us group by
chemical, method, and whether or not we include exhalation.
```{r 1_prepareData, eval = make.plots}
conc_predictions_meade2023DF$method.perm = gsub( "UK-Surrey","Surrey", conc_predictions_meade2023DF$method.perm)
conc_predictions_meade2023DF$method.name = gsub( "UK-Surrey","Surrey", conc_predictions_meade2023DF$method.name)
df.sim = conc_predictions_meade2023DF
# Convert aexhaled air from mg to mg/l (assume a room of x liters, for humans - humans 
# the only species in these exhaled experiments)
df.sim[which(df.sim$conc_medium_obs=="Aexhaled"),"Prediction"]=df.sim[which(df.sim$conc_medium_obs=="Aexhaled"),"Prediction"]/10000

df.sim$conc_normalized[which(df.sim$conc_normalized==0)]=1e-10
df.sim$Prediction[which(df.sim$Prediction==0)]=1e-10
df.sim.rmsle=df.sim %>% group_by(PREFERRED_NAME, method.name, exhalation_for_simulation)%>%
  mutate(cmax_obs = max(conc_normalized), cmax_pred=max(Prediction)) %>%
  mutate(RMSLE = rmse(log10(conc_normalized),log10(Prediction)),
    Cmax_RMSLE = rmse(log10(cmax_obs), log10(cmax_pred)))


# Linear fit
ddf.sim.rmsle <- df.sim.rmsle %>% group_by(method.name) %>% do(
  {
    Adjusted.R2 = summary(lm(log10(Prediction) ~ log10(conc_normalized),data=.))$adj.r.squared
    Coefficient = lm(log10(Prediction) ~ log10(conc_normalized),data=.)$coefficients[2]
    Intercept = lm(log10(Prediction) ~ log10(conc_normalized),data=.)$coefficients[1]
    Residuals = lm(log10(Prediction) ~ log10(conc_normalized),data=.)$residuals
    Fitted.Values = lm(log10(Prediction) ~ log10(conc_normalized),data=.)$fitted.values
    data.frame(.,Adjusted.R2,Coefficient,Intercept,Residuals,Fitted.Values)
  }
)

```


## Step Five: Plot Simulations

Let us compare the RMSLE and the volatility (i.e., boiling point) for each compound (assuming exhalation).

```{r 1_plot3, eval = make.plots, fig.height=10, fig.width=20}
# Plot RMSLE vs Boiling Point

data = subset(df.sim.rmsle, exhalation_for_simulation==TRUE)

data=data%>%group_by(PREFERRED_NAME, Boiling.Point.C,method.name)%>%
  summarize(Chemical.cmax.RMSLE = rmse(log10(cmax_obs),log10(cmax_pred)),
    Chemical.RMSLE=rmse(log10(conc_normalized),log10(Prediction)))

data.rect = data.frame(xmin=c(0,75,250,400),
                       xmax=c(75,250,400,Inf),
                       ymin=rep(-Inf,4),
                       ymax=rep(Inf,4),
                       Volatility=c("Very Volatile",
                                    "Volatile",
                                    "Semi-Volatile",
                                    "Not Volatile"))
data.rect$Volatility <- factor(data.rect$Volatility, levels=data.rect$Volatility)
viridis.colors <- viridis(4)
plot <- ggplot(data=data,aes(x=`Boiling.Point.C`,y=Chemical.RMSLE)) +
  geom_point()+
  geom_smooth(method="lm",formula='y~x') +
  geom_text_repel(data=data,aes(x=`Boiling.Point.C`,y=Chemical.RMSLE,label=PREFERRED_NAME),
                  max.overlaps=Inf)+
  facet_wrap(~method.name,scales="free") +
  #scale_x_log10() +
  geom_rect(data=data.rect,
            aes(xmin=xmin,xmax=xmax,ymin=ymin,ymax=ymax,fill=Volatility),
            alpha=0.5,
            inherit.aes=FALSE) +
  scale_fill_manual(values=c(`Not Volatile`=viridis.colors[1],
                             `Semi-Volatile`=viridis.colors[2],
                             `Volatile`=viridis.colors[3],
                             `Very Volatile`=viridis.colors[4]))+

  labs(y="RMSLE",title="Boiling Point vs. RMSLE",x="Boiling Point (C)")+
  theme_bw() +
  theme(text=element_text(size=33),
        plot.title=element_text(hjust=0.5),
        legend.position="bottom")
plot
ggsave(paste(loc.wd, "/Figures_August2025/BPvsRMSLE_suppl.png",sep=""),
       width = 20, height = 10, units = "in")

plot2 <- ggplot(data=data,aes(x=`Boiling.Point.C`,y=Chemical.cmax.RMSLE)) +
  geom_point()+
  geom_smooth(method="lm",formula='y~x') +
  geom_text_repel(data=data,aes(x=`Boiling.Point.C`,y=Chemical.cmax.RMSLE,label=PREFERRED_NAME),
                  max.overlaps=Inf)+
  facet_wrap(~method.name,scales="free") +
  #scale_x_log10() +
  geom_rect(data=data.rect,
            aes(xmin=xmin,xmax=xmax,ymin=ymin,ymax=ymax,fill=Volatility),
            alpha=0.5,
            inherit.aes=FALSE) +
  scale_fill_manual(values=c(`Not Volatile`=viridis.colors[1],
                             `Semi-Volatile`=viridis.colors[2],
                             `Volatile`=viridis.colors[3],
                             `Very Volatile`=viridis.colors[4]))+

  labs(y="RMSLE",title="Boiling Point vs. Cmax RMSLE",x="Boiling Point (C)")+
  theme_bw() +
  theme(text=element_text(size=33),
        plot.title=element_text(hjust=0.5),
        legend.position="bottom")
#annotate_figure(plot2,top=text_grob("Boiling Point vs RMSLE",size=40,face="bold"))
ggsave(paste(loc.wd, "/Figures_August2025/BPvsRMSLE_cmax_suppl.png",sep=""),
       width = 20, height = 10, units = "in")


```
Now, we compare simulations with exhalation to those without exhalation (as a function of boiling point).

```{r 1_exhalation_rmsle_plot,  eval=make.plots, fig.height=10, fig.width=30}
df.exh.compare=df.sim.rmsle

Exh = data.frame(df.exh.compare %>% group_by(PREFERRED_NAME,method.name, Boiling.Point.C)%>%
  arrange(exhalation_for_simulation) %>%
  summarize(Cmax=Cmax_RMSLE[exhalation_for_simulation==FALSE]-Cmax_RMSLE[exhalation_for_simulation==TRUE], Full_time_course = RMSLE[exhalation_for_simulation==FALSE]-RMSLE[exhalation_for_simulation==TRUE]))

Exh$method.name= sub(" - ", " -\n", Exh$method.name)



#stack data
stackExh = data.frame(Exh %>%
  pivot_longer(cols = c("Cmax", "Full_time_course"), 
               names_to = "ind", 
               values_to = "values"))

data.text = unique(stackExh[,c("Boiling.Point.C","values","PREFERRED_NAME","ind","method.name")])
data.rect = data.frame(xmin=c(0,75,250,400),
                       xmax=c(75,250,400,Inf),
                       ymin=rep(-Inf,4),
                       ymax=rep(Inf,4),
                       Volatility=c("Very Volatile",
                                    "Volatile",
                                    "Semi-Volatile",
                                    "Not Volatile"))
data.rect$Volatility <- factor(data.rect$Volatility, 
                               levels=data.rect$Volatility)
viridis.colors <- viridis(4)

# rename labels for facets
# labeller=labeller(ind = c(Cmax="Cmax",
#               Full_time_course = "Full time-course"))

plot <- ggplot(data=stackExh,aes(x=Boiling.Point.C,y=values)) +
  geom_point()+ #geom_line()+
  theme_bw()+
  geom_smooth(method='lm') +
  facet_grid(ind~method.name, scales="free", labeller=labeller(ind = c(Cmax="Cmax",
              Full_time_course = "Full time-course")))+
  geom_rect(data=data.rect,
            aes(xmin=xmin,xmax=xmax,ymin=ymin,ymax=ymax,fill=Volatility),
            alpha=0.5,
            inherit.aes=FALSE) +
  scale_fill_manual(values=c(`Not Volatile`=viridis.colors[1],
                             `Semi-Volatile`=viridis.colors[2],
                             `Volatile`=viridis.colors[3],
                             `Very Volatile`=viridis.colors[4]))+
  geom_text_repel(data=data.text,aes(x=Boiling.Point.C,y=values,label=PREFERRED_NAME),
                  max.overlaps=Inf)+
  #facet_grid(cols=vars(Route.or.Method.if.Dermal), rows=vars(RMSLE.Type),scales="free_y")+
  #scale_x_log10() +
  geom_hline(aes(yintercept=0)) +
  labs(y=expression(Delta~"RMSLE"),x="Boiling Point (C)",title="Change in RMSLE when Exhalation is Added")+
  scale_color_brewer(type="qual",palette="Paired") +
  theme(axis.text.x = element_text(angle=45,vjust=1,hjust=1),
        plot.title=element_text(hjust=0.5),
        text=element_text(size=30),
        legend.position="bottom")
plot

ggsave(paste(loc.wd, "/Figures_August2025/BP_RMSLE_Exhalation_main.png",sep=""),
       width = 20, height = 10, units = "in")

# P-values for regression lines
stackExhStats = stackExh%>% group_by(ind, method.name) %>%
  summarize(model = list(lm(values~Boiling.Point.C, data=cur_data())),
            .groups="drop")%>%
  rowwise()%>%
  mutate(msummary=list(summary(model)),
         rsquared=msummary$r.squared,
         p_val= pf(msummary$fstatistic[1], msummary$fstatistic[2], msummary$fstatistic[3], lower.tail=FALSE)
        )%>%select(ind,method.name,rsquared,p_val)

```

Now, let's generate CvT plots for each chemical and color by whether or not exhalation was included.
```{r cvt_plot_by_exh, eval =make.plots, fig.height=3, fig.width=3 }
df.sim2 = df.sim.rmsle

chem = unique(df.sim2$PREFERRED_NAME)

for(chx in 1:length(chem)){
  each.chem = subset(df.sim2, PREFERRED_NAME==chem[chx])
  #each.chem$dose = paste(each.chem$dose_level_new, each.chem$dose_level_new_units)
  each.chem$dose=paste(each.chem$dose_level_new, each.chem$dose_level_new_units)
  # each.chem$dose = factor(each.chem$dose,
  #                         levels=unique(each.chem$dose)[order(unique(each.chem$dose_level_new))])
  
  each.chem$method.name= sub(" - ", " -\n", each.chem$method.name)
  each.chem$subject=paste(each.chem$species, "BW",each.chem$BW, "kg")
  
  
 ggplot(each.chem)+
    geom_point(data=each.chem, aes(x=time_hr, y=conc_normalized,colour=dose))+
    geom_line(data=each.chem, aes(x=time_hr, y=Prediction,colour=dose,linetype=exhalation_for_simulation),linewidth=1)+
    labs(title=paste(chem[chx], "\n Log-transformed Concentrations v time"), x=" Time (hr)", y="Log Concentrations (mg/L)", colour="")+
    facet_nested(~conc_medium_normalized+method.name,scales="free")+
   scale_y_log10() +
     theme(legend.position = "bottom")
    

  ggsave(paste(loc.wd, "/Figures_August2025/cvt_eachchem_by_exhalation_suppl", unique(each.chem$test_substance_dtxsid),".png",sep=""),
         width = 8, height = 6, units = "in")
}
  
```


Now plot the data in Predicted vs Observed (PvO) plots for each of the 13 chemicals. First, we extract only simulated results that match the correct exhalation conditions by finding simulations where exhalation_for_simulations = T if Exhalation (which was calculated from volatility parameters), is TRUE and FALSE if FALSE.
```{r 1_plot1,eval =make.plots, fig.height=3, fig.width=3}
df.new = subset(df.sim.rmsle, exhalation_for_simulation==Exhalation)

chem = unique(df.new$PREFERRED_NAME)

for(chx in 1:length(chem)){
  each.chem = subset(df.new, PREFERRED_NAME==chem[chx])
  #each.chem$dose = paste(each.chem$dose_level_new, each.chem$dose_level_new_units)
  each.chem$dose=paste(each.chem$dose_level_new, each.chem$dose_level_new_units)
  each.chem$dose = factor(each.chem$dose,
                          levels=unique(each.chem$dose)[order(unique(each.chem$dose_level_new))])
  
  each.chem$method.name= sub(" - ", " -\n", each.chem$method.name)
  each.chem$subject=paste(each.chem$species, "BW",each.chem$BW, "kg")
  
  ggplot(each.chem, aes(x=conc_normalized,y=Prediction))+
    geom_point(aes(colour=dose,shape=conc_medium_normalized))+
    labs(title=paste(chem[chx], "\n Log-transformed Concentrations"), x="Observed Concentrations (mg/L)", x="Predicted Concentrations (mg/L)", colour="", shape="")+
    #facet_wrap(~dose,scales="free")+
    facet_wrap(~method.name,scales="free")+
    geom_smooth(method='lm',formula='y~x',colour="black")+
     geom_abline(linetype=2)+
     #geom_smooth(aes(color=method.name),method='lm',formula='y~x')+
          scale_x_log10() +
    scale_y_log10() +
    theme_bw() + theme(text=element_text(size=11),
                       strip.text=element_text(size=13))
    #theme(legend.position = "bottom")

  ggsave(paste(loc.wd, "/Figures_August2025/pvo_bydose_suppl", unique(each.chem$test_substance_dtxsid),".png",sep=""),
         width = 6, height = 6, units = "in")
  
  
}


# Linear fit for these.
linear.fit.new <- df.new %>% group_by(method.name) %>% do(
  {
    Adjusted.R2 = summary(lm(log10(Prediction) ~ log10(conc_normalized),data=.))$adj.r.squared
    Coefficient = lm(log10(Prediction) ~ log10(conc_normalized),data=.)$coefficients[2]
    Intercept = lm(log10(Prediction) ~ log10(conc_normalized),data=.)$coefficients[1]
    Residuals = lm(log10(Prediction) ~ log10(conc_normalized),data=.)$residuals
    Fitted.Values = lm(log10(Prediction) ~ log10(conc_normalized),data=.)$fitted.values
    data.frame(.,Adjusted.R2,Coefficient,Intercept,Residuals,Fitted.Values)
  }
)
# RMSLE grouped by method type
rmsle.all = df.new%>%group_by(method.name)%>%
  summarize(  Adjusted.R2 = summary(lm(log10(Prediction) ~ log10(conc_normalized)))$adj.r.squared,
              RMSLE_total =rmse(log10(Prediction),log10(conc_normalized)),
                CMAX_RMSLE_total =rmse(log10(cmax_pred) ,log10(cmax_obs)    )
              
              )

```



now plot log-transformed predicted vs. observed values and group by permeability method, vehicle (or route of exposure), and tested tissue.

```{r 1_plot6, eval=make.plots, fig.height=10, fig.width=20}
df.new = subset(df.sim, exhalation_for_simulation==Exhalation)
df.sim.rmsle2=df.new %>% group_by(PREFERRED_NAME, method.name)%>%
  mutate(cmax_obs = max(conc_normalized), cmax_pred=max(Prediction)) %>%
  mutate(RMSLE = rmse(log10(conc_normalized),log10(Prediction)),
    Cmax_RMSLE = rmse(log10(cmax_obs), log10(cmax_pred)))


col=c("#440154ff","indianred","#2d708eff","steelblue1","#7ad151ff","#fde725ff")
plot.pvo=ggplot(df.sim.rmsle2, aes(x=conc_normalized, y=Prediction))+
  geom_point(aes( colour=method.name,shape=PREFERRED_NAME), alpha=1,size=2)+
    labs(title=paste0("(A) Concentrations"),
       y = "Simulated (mg/L)", x="Observed (mg/L)",
       color="Route or\n Method",shape="Chemical")+
    scale_shape_manual(values=1: length(unique(df.sim.rmsle2$PREFERRED_NAME)))+
    geom_smooth(aes(colour=method.name),method="lm",se=F)+
  #scale_color_brewer(type="qual",palette="Paired",direction=-1) +
  scale_colour_manual(values=col)+
  theme_bw() + 
  scale_x_log10() + scale_y_log10() +
  geom_abline(lty="dashed") +
  #coord_fixed(xlim=lims,ylim=lims) +
  theme(plot.title=element_text(hjust=0.5),
        text=element_text(size=30))


noiv=subset(df.sim.rmsle2,!(method.name%in%"IV"))
plot.cmax = ggplot(noiv, aes(x=cmax_obs, y=cmax_pred))+
  geom_point(aes( colour=method.name,shape=PREFERRED_NAME), alpha=1,size=2)+
    labs(title=paste0("(B) Max Concentrations"),
       y = "Simulated (mg/L)", x="Observed (mg/L)",
       color="Route or\n Method", shape="Chemical")+
  #scale_color_brewer(type="qual",palette="Paired",direction=-1) +
   scale_colour_manual(values=col[-1])+
     scale_shape_manual(values=1: length(unique(noiv$PREFERRED_NAME)))+
  theme_bw() + 
  scale_x_log10() + scale_y_log10() +
  geom_abline(lty="dashed") +
  #coord_fixed(xlim=lims,ylim=lims) +
  theme(plot.title=element_text(hjust=0.5),
        text=element_text(size=30))


ggarrange(plot.pvo, plot.cmax, common.legend=T,legend="right")
ggsave(paste(loc.wd, "/Figures_Sep2025/PvO_main.png",sep=""),
       width = 20, height = 10, units = "in",dpi=300)
  
 
method.rmsle.only=df.new %>% group_by(PREFERRED_NAME, method.name)%>%
    mutate(cmax_obs = max(conc_normalized), cmax_pred=max(Prediction)) %>%
    summarize(RMSLE = rmse(log10(conc_normalized),log10(Prediction)),
           Cmax_RMSLE = rmse(log10(cmax_obs), log10(cmax_pred))) %>%group_by(method.name)%>%summarize(mean(Cmax_RMSLE),
                                                                                                      mean(RMSLE))
#COMPARE AUCs
#library("pracma")

df.sim.derm=subset(df.sim.rmsle2,administration_route_normalized=="Dermal")
auc.df=df.sim.derm %>% group_by(PREFERRED_NAME, method.name,conc_medium_normalized,dose_level_new)%>%
mutate(auc_observed=trapz(time_hr,conc_normalized), auc_pred=trapz(time_hr,Prediction))
auc.df=data.frame(auc.df)

auc.pvo=ggplot(auc.df, aes(x=auc_observed, y=auc_pred))+
  geom_point(aes( colour=method.name,shape=PREFERRED_NAME), alpha=1,size=2)+
  labs(title="Dermal AUCs - Observed vs. Predicted",
       y = "Simulated (AUC mg/L-h)", x="Observed (AUC mg/L-h)",
       color="Route or\n Method",shape="Chemical")+
  scale_shape_manual(values=1: length(unique(df.sim.rmsle2$PREFERRED_NAME)))+
  geom_smooth(aes(colour=method.name),method="lm",se=F)+
  #scale_color_brewer(type="qual",palette="Paired",direction=-1) +
  scale_colour_manual(values=col)+
  theme_bw() +
  scale_x_log10() + scale_y_log10() +
  geom_abline(lty="dashed") +
  #coord_fixed(xlim=lims,ylim=lims) +
  theme(plot.title=element_text(hjust=0.5),
        text=element_text(size=30))
ggsave(paste(loc.wd, "/Figures_Sep2025/PvO_AUC.png",sep=""),
       width = 16, height = 10, units = "in",dpi=300)

```



Now let's plot a heat map of the RMSLE and Cmax RMSLE. We will subset the dataframe to only plot the simulations appropriate for exhalation (that is, for a volatile chemical where Exhalation = TRUE, we will extract the solutions when exhalation_for_simulation = TRUE).We will also make note of the experiments for which a dosing vehicle was specified (water or octanol). For dermal, we will plot the results using both permeability methods and both vehicle methods, but will mark boxes over the cases where the vehicle matched to the simulated vehicle. We also want to plot the chemicals in order of volatility (based on boiling point).


```{r 1_exhalation_correct, eval=make.plots}
# Extract correct exhalation

# df = conc_predictions_meade2023DF
# df$conc_normalized[which(df$conc_normalized==0)]=1e-10
# df$Prediction[which(df$Prediction==0)]=1e-10
df=df.sim
dfmatchE =  subset(df, exhalation_for_simulation==Exhalation)
# order chemicals by volatility
vol.chem = unique(dfmatchE[,c("PREFERRED_NAME","Boiling.Point.C")])
vol.chem2=vol.chem[order(vol.chem$Boiling.Point.C,decreasing=F),]

#also want to extract table to identify  experiments that actually did list the vehicle as either water or octanol (or similar)
dfmatchE2 = data.frame(dfmatchE%>%group_by(PREFERRED_NAME,method.name,dose_vehicle_normalized,Kvehicle2water,administration_route_normalized)%>%
      mutate(cmax_obs = max(conc_normalized), cmax_pred=max(Prediction)) %>%
  summarize(Cmax_RMSLE = rmse(log10(cmax_obs),log10(cmax_pred)),
         RMSLE = rmse(log10(conc_normalized),log10(Prediction))))

# Reorganize the columns so RMSLE values can be grouped by Cmax or total RMSLE and then take average RMSLE values of oral or iv values so we have one per chemical
dfmatchE3 = data.frame(dfmatchE2 %>%
  pivot_longer(cols = c("Cmax_RMSLE", "RMSLE"), 
               names_to = "ind", 
               values_to = "value") %>% group_by(PREFERRED_NAME,ind,administration_route_normalized) %>%
    mutate(value = if_else(administration_route_normalized !="Dermal", mean(value[administration_route_normalized !="Dermal"]), value)
           ))

# Make PREFERRED_NAME a factor and set the levels to match those from the volatility order.
dfmatchE3$PREFERRED_NAME = factor(dfmatchE3$PREFERRED_NAME, 
                                              levels=vol.chem2$PREFERRED_NAME)



```

Generate the plot.

```{r 1_heatmap, eval=make.plots, fig.height=8, fig.width=11}
dfmatchE4=dfmatchE3[-which(dfmatchE3$method.name=="IV" & dfmatchE3$ind=="Cmax_RMSLE"),] # remove IV CMax
ggplot(dfmatchE4, aes(y=PREFERRED_NAME, x=method.name))+
  geom_tile(aes(fill=value))+
  #geom_tile(aes(fill=Chemical.Cmax.RMSLE.NE))+
  facet_wrap(~ind)+
  theme(axis.text.x = element_text(angle = 90, vjust = 0.5, hjust=1))+
  scale_fill_viridis()+
  geom_text(aes(label=round(value,2)),colour="white",size=4)+
  labs(title="",
       x="Route or\n Method",
       fill="RMSLE",y="Chemical")+
  theme_bw() +
  theme(axis.text.x=element_text(angle=45,vjust=1,hjust=1),
        axis.text.y=element_text(angle=45,vjust=1.05,hjust=0.9),
        plot.title=element_text(hjust=0.5),
        text=element_text(size=20))+
  geom_tile(data=subset(dfmatchE3, dose_vehicle_normalized==Kvehicle2water & administration_route_normalized=="Dermal"),aes(y=PREFERRED_NAME, x=method.name),
            size=1.5,fill=NA,colour="red" )
ggsave(paste(loc.wd,"/Figures_August2025/RMSLE_compare_main_september.png",sep=""),width=11,height=8,units="in")

```

# Results 2: IVIVE

Now, we perform *in vitro* to *in vivo* extrapolation using the dermal model to obtain some occupational hazardous levels.

## Step One: Load Data

First we load [ToxCast Data](https://www.epa.gov/comptox-tools/exploring-toxcast-data) data from the [EPA-ORD-CCTE Clowder](https://clowder.edap-cluster.com/spaces/62bb560ee4b07abf29f88fef). Some of the variables in this dataset of importance include:

* `hitc`: if `hitc=1` there was a statistically significant systematic conc-response observed, and if `hitc=0` there was no statistically significant
* `mc6_flags`: features of the hit that might be of interest
* `modl` type of conc-response model selected (using AIC)
  + `"cnst"`: no concentration response (constant)
  + `"hill"`: Hill equation
  +`"gnls"`: Gain-loss model, product of an increasing and decreasing Hill equations, often interpreted as being caused by cytotoxicity
* `model_ga`: log10 uM concentration at which the chemical caused 50% activity (i.e., chemical-assay "potency" or "AC50")
* `spid`: sample id, since each chemical might have multiple assays with hits or have been run multiple times (experimental replicates)


```{r 2_load_data, eval=FALSE}
# Load in vitro data
load("invitrodb_3_5_mc5.Rdata")
```

```{r 2_load_insilicohttk, eval=run.simulations.2}
# Get chemicals of interest 
load_sipes2017(overwrite=F)
```

## Step Two: Load Chemical Data

```{r 2_load_chem_data, eval=FALSE}
# Using list, download chem info from CompTox Dashboard for chem.list chemicals, and load.
df.chem <- read_excel(
  "C:/Users/WambaughJohn/Downloads/CCD-Batch-Search_2023-03-08_12_23_25.xlsx",
  sheet=2)
df.chem <- as.data.frame(df.chem)
# %>%filter(!is.na(BOILING_POINT_DEGC_OPERA_PRED))
df.chem <- type_convert(df.chem,na="N/A")
df.chem <- type_convert(df.chem,na="N/A")
```

## Step Three: Clean Data (Only Non-Volatiles and a few of the Semi-Volatiles from the validation study)

```{r 2_clean_data, eval=FALSE}
#Get list of chemicals that can run in dermal model:
chem.list <- get_cheminfo(info="DTXSID",species="Human",model="dermal_1subcomp")
write.table(chem.list,
            file=paste0(loc.wd,"/tables/ChemicalList.txt"),
            col.names=TRUE,
            row.names=FALSE,
            quote=FALSE,
            sep="\t")

# Take out volatile chemicals
chems.from.invivo <- c("DTXSID0020232",
                       "DTXSID6022923",
                       "DTXSID8024151",
                       "DTXSID3022409",
                       "DTXSID1026081")
df.chem <- df.chem %>% filter(!is.na(BOILING_POINT_DEGC_OPERA_PRED))%>% 
  filter((BOILING_POINT_DEGC_OPERA_PRED >= 400) | (DTXSID %in% chems.from.invivo))
chem.list <- df.chem$DTXSID

#get sample to test code with
set.seed(100)
#chem.list <- sample(chem.list,50)
```
```{r load_chem_list, eval=run.simulations.2}
chem.list <- httkexamples::dermal.nonvolatilechems
```

```{r subset_toxcast_data, eval=FALSE}
toxcast.dermal <- mc5 %>% subset(dsstox_substance_id %in% chem.list) 
```
## Step Four: Compute Q10.AC50 (and other parameters of interest)


```{r, 2_conc_of_interest, eval=FALSE}
# CONCENTRATIONS OF INTEREST - https://doi.org/10.1093/bioinformatics/btw680 ----------------
toxcast.table <- NULL
old.time <- Sys.time()
num.chem <- length(chem.list)
for(k.chem in 1:num.chem){ #for each chemical
  this.id <- chem.list[k.chem]
  # Modulus operator
  if(k.chem %% 100==0){
    new.time <- difftime(Sys.time(), old.time,units="secs")
    cat(paste0("Run ", k.chem,":",round(new.time)," secs \n"))
  }
  toxcast.dermal.chem <- subset(toxcast.dermal, dsstox_substance_id == this.id) #subset over chemical
  toxcast.dermal.chem.hits <- subset(toxcast.dermal.chem, hitc==1) #only look at hits
  if(dim(toxcast.dermal.chem.hits)[1]>0){ #if there were any hits
    this.row <- data.frame(Chemical = as.character(toxcast.dermal.chem.hits[1,"chnm"]),
                           DTXSID = this.id,
                           Total.Assays = dim(toxcast.dermal.chem)[1],
                           Unique.Assays = length(unique(toxcast.dermal.chem$aeid)),
                           Total.Hits = dim(toxcast.dermal.chem.hits)[1],
                           Unique.Hits = length(unique(toxcast.dermal.chem.hits$aeid)),
                           Low.AC50 = min(toxcast.dermal.chem.hits$modl_ga),
                           Low.AC10 = min(toxcast.dermal.chem.hits$modl_ac10),
                           Low.ACC = min(toxcast.dermal.chem.hits$modl_acc),
                           Q10.AC50 = quantile(toxcast.dermal.chem.hits$modl_ga,probs=0.1),
                           Q10.AC10 = quantile(toxcast.dermal.chem.hits$modl_ac10,probs=0.1),
                           Q10.ACC = quantile(toxcast.dermal.chem.hits$modl_acc,probs=0.1),
                           Med.AC50 = quantile(toxcast.dermal.chem.hits$modl_ga,probs=0.5),
                           Med.AC10 = quantile(toxcast.dermal.chem.hits$modl_ac10,probs=0.5),
                           Med.ACC = quantile(toxcast.dermal.chem.hits$modl_acc,probs=0.5),
                           Q90.AC50 = quantile(toxcast.dermal.chem.hits$modl_ga,probs=0.9),
                           Q90.AC10 = quantile(toxcast.dermal.chem.hits$modl_ac10,probs=0.9),
                           Q90.ACC = quantile(toxcast.dermal.chem.hits$modl_acc,probs=0.9)
                           )
    toxcast.table <- rbind(toxcast.table, this.row)
  }
}
rownames(toxcast.table) <- seq(1,dim(toxcast.table)[1]) # set rownames to be sequential numbers
```

```{r load_toxcast, eval=run.simulations.2}
toxcast.table <- httkexamples::dermal.toxcast
#View table
knitr::kable(head(toxcast.table[,1:6]), caption = "Summarized ToxCast Data",
             floating.environment="sidewaystable")
write.table(toxcast.table,
            file=paste0(loc.wd,"/tables/ToxCastSummaryTable.txt"),
            col.names=TRUE,
            row.names=FALSE,
            quote=FALSE,
            sep="\t")
```


## Step Five: Conduct *In Vitro* to *In Vivo* Extrapolation

```{r 2_equivalant_dose, eval=run.simulations.2}

# Get Cmax = max(Cplasma) from dermal model for each chemical in toxcast table
old.time <- Sys.time()
include.these=which(toxcast.table$DTXSID %in% get_cheminfo(info="dtxsid", suppress.messages=T))
toxcast.table2 = subset(toxcast.table,DTXSID %in% toxcast.table$DTXSID[include.these])

atol <- rtol <- 1e-5

num.chem <- length(toxcast.table2$DTXSID)
plot.each=F
# Set Dermal Solutions
method.ls <- c("Potts-Guy","UK-Surrey")
toxcast.ls=list()
for(k.chem in 1:num.chem){
  this.id = toxcast.table2$DTXSID[k.chem]
  suppress.messages = TRUE

    for(k.method in 1:2){
      this.method <- method.ls[k.method]; 
    #  if (this.method=="2-Compartment") this.method.input <- "NULL"
      this.model.type <-"dermal_1subcomp"
      end.time=0
      parms=parameterize_dermal_pbtk(dtxsid=this.id, 
                                     model.type = this.model.type,
                                     method.permeability = this.method,
                                     clint.pvalue.threshold=Inf,
                                     suppress.messages=TRUE,
                                     Kvehicle2water = 1,
                                     species="Human",
                                     default.to.human = T)
      parms$InfiniteDose=1
      #if(end.time<2){ #make sure solver finishes
        out=try( solve_dermal_pbtk(parameters=parms,
                                     model.type=this.model.type,
                                     method.permeability=this.method,
                                     #Kvehicle2water=1, #vehicle is water
                                     days=5,
                                     initial.dose = 1,
                                     input.units = "ppm",
                                     dose.duration=8,
                                     dose.duration.units="hr",
                                     washoff=T,
                                    # InfiniteDose=T,
                                     atol = atol, rtol= rtol,
                                     method="lsoda",
                                     suppress.messages=suppress.messages) )#put SA for hands!!!
         if (is(out,"try-error")){
           Cmax=0
           browser()
         }
       
        else{end.time <- out[nrow(out),"time"]
        

      Cmax <- max(out[,"Cplasma"])
   
        }
       toxcast.ls[[paste0(k.chem,".",this.method)]]=cbind(toxcast.table2[toxcast.table2$DTXSID==this.id,],Cmax=Cmax,Permeability = this.method)
    }
  
}

toxcast2.all=do.call(rbind,toxcast.ls)

#     # Calculate the EquivDose in units same as input.units (ppm)
toxcast2.all$EquivDose = signif(10^toxcast2.all$Q10.AC50 /
                                  toxcast2.all$Cmax,
                                4)
# Edit data
toxcast3=toxcast2.all%>%
  rename(`Permeability Type` = Permeability,
         `Equivalent Dose`=EquivDose)%>%
  mutate(Chemical = ifelse(Chemical=="Methyl tert-butyl ether","MTBE",Chemical),
         Chemical = ifelse(Chemical=="3,3',5,5'-Tetrabromobisphenol A","Bromdian",Chemical),
         Chemical = ifelse(Chemical=="4,4'-Sulfonyldiphenol","Bisphenol S",Chemical),
         Chemical = ifelse(Chemical=="Dichloromethane","DCM",Chemical),
         Chemical = ifelse(Chemical=="Tetrachloroethylene","PERC/TCE",Chemical),
         Chemical = ifelse(Chemical=="1-Methylbenzene","Toluene",Chemical))

# Remove unused columns
ivive_meade2023 <- toxcast3 %>% select(Chemical,DTXSID,`Permeability Type`,`Equivalent Dose`,Cmax)

```


```{r add_water_solubility, eval=run.simulations.2}
chem.props <- subset(chem.physical_and_invitro.data,
                     DTXSID %in% ivive_meade2023$DTXSID)[
                       ,c("DTXSID","MW","logWSol")]


ivive_meade2023 <- merge(ivive_meade2023,
                         all.x = TRUE,
                         chem.props,
                         by="DTXSID")
ivive_meade2023 <- within(ivive_meade2023, 
                          WS.ppm <- 
signif(MW*10^logWSol*1.001142303,4))
```
# Save data
```{r resave, eval=FALSE} 
cgwtools::resave(ivive_meade2023,
                  file=paste0(
                    loc.wd,
                    "/meade2023_",
                    format(Sys.time(), "%b_%d_%Y"),
                    ".Rdata"))
```

```{r 2_load_without_running, eval = FALSE}
# load file with ivive_meade2023
load("meade2023_Sep_02_2025.Rdata")
```


## Step Six: Plot Results

```{r identify_potent, eval=make.plots.2}
# Modify for plotting
ivive_meade2023$`Permeability Type` = gsub("UK-Surrey","Surrey",ivive_meade2023$`Permeability Type`)
ivive_meade2023[ivive_meade2023==Inf] = 1e15
write.table(subset(ivive_meade2023,
                   ivive_meade2023[,"Equivalent Dose"] < 
                     ivive_meade2023[,"WS.ppm"]),
            file=paste0(loc.wd,"/tables/IVIVEAchievable.txt"),
            col.names=TRUE,
            row.names=FALSE,
            quote=FALSE,
            sep="\t")       
ivive_meade2023$`Equivalent Dose` <- log10(ivive_meade2023$`Equivalent Dose`)
ivive_meade2023$`Permeability Type` = paste0("Permeability Method is ",ivive_meade2023$`Permeability Type`)
write.table(ivive_meade2023,
            file=paste0(loc.wd,"/tables/IVIVEResults.txt"),
            col.names=TRUE,
            row.names=FALSE,
            quote=FALSE,
            sep="\t")
```

```{r 2_plot1,fig.width=20,fig.height=12, eval=make.plots.2}
# Plot Histogram
data = ivive_meade2023 %>% group_by(`Permeability Type`) %>% mutate(Mean = mean(`Equivalent Dose`,na.rm=TRUE)) %>% mutate(Median = median(`Equivalent Dose`,na.rm=TRUE))
AED.labels <- c("Needs Protection (AED caused by <1ppm)",
                "AED Possibly Acheivable",
                "\"Safe\" (Unachievable AED)",
                "No Dermal Penetration")

# Shaded rectangles with cutoff at 10,000 ppm:
data.rect.1e4ppm = data.frame(xmin=c(-Inf,0,4,12),
                       xmax=c(0,4,12,Inf),
                       ymin=rep(-Inf,4),
                       ymax=rep(Inf,4),
                       Bioactivity=AED.labels)
# Shaded rectangles with cutoff at 1,000,000 ppm:
data.rect.1e6ppm = data.frame(xmin=c(-Inf,0,6,12),
                       xmax=c(0,6,12,Inf),
                       ymin=rep(-Inf,4),
                       ymax=rep(Inf,4),
                       Bioactivity=AED.labels)
data.rect.1e4ppm$Bioactivity <- factor(data.rect.1e4ppm$Bioactivity, 
                                       levels=data.rect.1e4ppm$Bioactivity)
data.rect.1e6ppm$Bioactivity <- factor(data.rect.1e6ppm$Bioactivity, 
                                       levels=data.rect.1e6ppm$Bioactivity)

data.med = unique(data[,c("Permeability Type","Mean","Median")]) %>% pivot_longer(cols=c("Mean","Median"),names_to="Statistic",values_to="Statistic.Value")
viridis.colors <- viridisLite::viridis(4)
plot <- ggplot(data,aes(x=`Equivalent Dose`)) +
  geom_histogram(na.rm=TRUE,alpha=0.5,position="identity") +
  geom_freqpoly(na.rm=TRUE) +
  geom_vline(data = data.med, aes(xintercept=Statistic.Value,linetype=Statistic)) +
  geom_rect(data=data.rect.1e4ppm,
            aes(xmin=xmin,xmax=xmax,ymin=ymin,ymax=ymax,fill=Bioactivity),
            alpha=0.5,
            inherit.aes=FALSE) +
  #scale_x_log10() + 
  scale_fill_manual(values=setNames(viridis.colors[4:1], AED.labels))+
  labs(title=paste0("Distribution of concentrations causing AED\nfor hands submerged for 8 hours a day\nfor five days"),
       y = "Number of Chemicals", x="Log10 of Administrered Equivalent Doses (AEDs) ppm in water") +
  facet_col(vars(`Permeability Type`),scales="fixed") +
  theme_bw() +
  theme(plot.title=element_text(hjust=0.5))
plot  
ggsave(paste(loc.wd, "/Figures_August2025/histogram2.png",sep=""),
       width = 20, height = 12, units = "cm")
```


```{r 2_dataprep_for_plot2, fig.width=15, fig.height=10,eval=make.plots.2}

# WATER SOLUBILITY
ivive_meade2023 <- 
  ivive_meade2023 %>% 
  mutate(WSol = case_when( ((MW*10^logWSol)>=10) ~ "Water Soluble (WSol>10g/L)",
                           ((MW*10^logWSol)<10) ~ "Not Soluble"
                           ))
#ivive_meade2023ALL <- ivive_meade2023WS; ivive_meade2023ALL$WSol = "Non-Water Soluble"
ivive_meade2023WS <- ivive_meade2023 %>% filter(WSol=="Water Soluble (WSol>10g/L)")
ivive_meade2023NonWS <- ivive_meade2023 %>% filter(WSol=="Not Soluble")
# Different bands for soluble/non-soluble:
data.rect.1e4ppm$WSol <- "Not Soluble"
data.rect.1e6ppm$WSol <- "Water Soluble (WSol>10g/L)"
data.rect <- rbind(data.rect.1e4ppm,data.rect.1e6ppm)
data.rect[,"Permeability Type"] <- "Permeability Method is Potts-Guy"
data.rect2 <- data.rect
data.rect2[,"Permeability Type"] <- "Permeability Method is Surrey"
data.rect <- rbind(data.rect,data.rect2)

ivive_meade2023 <- rbind(ivive_meade2023NonWS,ivive_meade2023WS)
data = ivive_meade2023 %>% group_by(`Permeability Type`,`WSol`) %>% mutate(Mean = mean(`Equivalent Dose`,na.rm=TRUE)) %>% mutate(Median = median(`Equivalent Dose`,na.rm=TRUE))
data.med = unique(data[,c("Permeability Type","WSol","Mean","Median")]) %>% pivot_longer(cols=c("Mean","Median"),names_to="Statistic",values_to="Statistic.Value")
```

```{r 2_plot2, fig.width=15, fig.height=10,eval=make.plots.2}
chem.to.label <-  c("DTXSID0020232",
                  # "DTXSID6022923",
                  # "DTXSID8024151",
                   "DTXSID3022409",
                   "DTXSID1026081", "DTXSID9048699",
                   "DTXSID0022858","DTXSID1037","DTXSID0023163",
                   "DTXSID5024845" )
data.text = data %>% filter(DTXSID %in% chem.to.label)
#PLOT WS
plot <- ggplot(data) +
  geom_rect(data=data.rect,
            aes(xmin=xmin,xmax=xmax,ymin=ymin,ymax=ymax,fill=Bioactivity),
            alpha=0.5#,
            #inherit.aes=FALSE
            ) +
  geom_histogram(na.rm=TRUE,alpha=0.5,position="identity",aes(x=`Equivalent Dose`)) +
  geom_freqpoly(na.rm=TRUE,aes(x=`Equivalent Dose`)) +
  geom_vline(data = data.med, aes(xintercept=Statistic.Value,linetype=Statistic)) +
#  geom_point(data=data.text,aes(x=`Equivalent Dose`,y=0),size=2) + 
#  geom_text_repel(data=data.text,aes(x=`Equivalent Dose`,y=0,label=Chemical),
#                  max.overlaps=14,
#                  hjust = "right",nudge_x=-1,nudge_y=0.2)+
  scale_fill_manual(values=setNames(viridis.colors[4:1], AED.labels))+
  #ylim(0,135)+
  #geom_text(x=) +
  labs(title=paste0("Distribution of concentrations causing AED\nfor hands submerged for 8 hours a day\nfor five days"),
       y = "Number of Chemicals", x="Log10 of Needed Concentration (ppm) in water") +
  facet_wrap(vars(`Permeability Type`,`WSol`),scales="free_y",ncol=2) +
  theme_bw() +
  theme(plot.title=element_text(hjust=0.5),
        text=element_text(size=20))
plot  
ggsave(paste(loc.wd, "/Figures_August2025/histogram_all_main.png",sep=""),
       width = 15, height = 10, units = "in")

```

Include a table with the equivalent doses, grouped by permeability method
```{r finallist2, eval=FALSE}
data2=data[order(data$`Equivalent Dose`),]
data2$`Equivalent Dose`= exp(data2$`Equivalent Dose`)
data3=data.frame(data2%>%group_by(Chemical,DTXSID, `Permeability Type`,WSol,logWSol)%>%
  mutate(row=row_number())%>%
  ungroup() %>%
pivot_wider(id_cols=c(Chemical, DTXSID, row, WSol,logWSol),
  names_from = `Permeability Type`,
                    values_from = c(`Equivalent Dose`),
                    names_sep=""))
data4=data3[,-3]
data4=data4[order(data4$Permeability.Method.is.Surrey),]



```

Also, calculate permeability for each method for humans
```{r finallist, eval=FALSE}
pmat=list()
pm=c("UK-Surrey","Potts-Guy")
kw=c("water","octanol")
for(i in 1:length(supptab1_meade2023$DTXSID)){
  for(m in 1:2){ #each method
    for(k in 1:2){ # each vehicle
  p=parameterize_dermal_pbtk(dtxsid=supptab1_meade2023$DTXSID[i],
                             method.permeability =pm[m] ,species="Human",
                             Kvehicle2water = kw[k])
  pmat[[paste(i,".",m,".",k)]]=cbind(p$P, pm[m], kw[k],p$MW, supptab1_meade2023$DTXSID[i])
  
  }
  }
}

pmat2=do.call(rbind,pmat)
colnames(pmat2)=c("Perm", "Method","Vehicle","MW","DTXSID")
pmat2=data.frame(pmat2)
pmat2$Method=gsub("UK-Surrey","Surrey",pmat2$Method)
pmat2$Vehicle=paste("Vehicle is", pmat2$Vehicle)

pmat3=merge(pmat2,supptab1_meade2023, by="DTXSID")


ggplot(pmat3,aes(x=as.numeric(MW.x),y=as.numeric(Perm)))+
  geom_point()+
  facet_grid(Method~Vehicle,scales="free")+
  labs(x="MW",y="Kp - Permeability")
ggsave(paste(loc.wd, "/Figures_August2025/MWvPerm.png",sep=""),
       width = 4, height = 3.5, units = "in")

ggplot(pmat3,aes(x=as.numeric(logP),y=as.numeric(Perm)))+
  geom_point()+
  facet_grid(Method~Vehicle,scales="free")+
  labs(x="log(Kow)",y="Kp- Permeability")
ggsave(paste(loc.wd, "/Figures_August2025/logKowvPerm.png",sep=""),
       width = 4, height = 3.5, units = "in")


```

```{r save_workspace, eval=make.plots.2}
save.image(paste0(loc.wd,
                      "MeadeWorkspace",
                      Sys.Date(),
                      ".RData"))
```

```{r PCA_data, eval=make.plots.2}
cvt.chems <- sort(unique(conc_predictions_meade2023DF$test_substance_dtxsid))
ivive.chems <- sort(unique(ivive_meade2023$DTXSID))
all.chems <- sort(unique(c(cvt.chems,ivive.chems)))
all.chems <- all.chems[all.chems %in% get_cheminfo(info="dtxsid",
                                                   model="dermal_1subcomp",
                                                   suppress.messages=TRUE)]
any(cvt.chems %in% ivive.chems)
length(cvt.chems)
length(ivive.chems)
chem.props <- subset(chem.physical_and_invitro.data, DTXSID %in% all.chems)
rownames(chem.props) <- chem.props$DTXSID
chem.props <- chem.props[,c("logHenry","logP","logPwa","logWSol","MP","MW")]
for (this.chem in rownames(chem.props))
{
  p <- parameterize_dermal_pbtk(dtxsid=this.chem,
                                suppress.messages=TRUE)
  chem.props[this.chem,c("Rblood2plasma",
                         "MA",
                         "Kskin2pu",
                         "Kskin2vehicle",
                         "Kblood2air",
                         "Funbound.plasma",
                         "Fabsgut",
                         "Clint")] <- p[
                           c("Rblood2plasma",
                             "MA",
                             "Kskin2pu",
                             "Kskin2vehicle",
                             "Kblood2air",
                             "Funbound.plasma",
                             "Fabsgut",
                             "Clint")]
}
```
```{r PCA_table, eval=make.plots.2}
#library(plotly)
#library(stats)
chem.props2 <- chem.props#[,!(colnames(chem.props) %in% "MW")]
chem.props2$MW <- log10(chem.props2$MW)
chem.props2$Kblood2air <- log10(chem.props2$Kblood2air)
chem.props2$MA <- log10(chem.props2$MA)
chem.props2$MP <- log10(chem.props2$MP+273)
chem.props2$Kskin2pu <- log10(chem.props2$Kskin2pu)
chem.props2$Kskin2vehicle <- log10(chem.props2$Kskin2vehicle)
chem.props2$Rblood2plasma <- log10(chem.props2$Rblood2plasma)
chem.props2$Clint <- log10(chem.props2$Clint)
chem.props2$Clint[is.infinite((chem.props2$Clint))] <- -3
chem.props2 <- chem.props2[apply(chem.props2,
                                 1,
                                 function(x) all(!is.na(x))), ]
chem.props2 <- apply(chem.props2,
                     2,
                     function(x) (x - mean(x)/sd(x)))
prin_comp <- prcomp(chem.props2)
explained_variance_ratio <- summary(prin_comp)[["importance"]]['Proportion of Variance',]
chem.props.pca <- as.data.frame(chem.props2 %*% prin_comp$rotation)
chem.props.pca$CvT <- "None"
chem.props.pca[rownames(chem.props.pca) %in% cvt.chems,"CvT"] <- "CvT"
chem.props.pca$IVIVE <- "None"
chem.props.pca[rownames(chem.props.pca) %in% ivive.chems,"IVIVE"] <- "IVIVE"

pca.fig <- ggplot(data=chem.props.pca) +
   geom_point(data=subset(chem.props.pca,CvT=="CvT"),
size=3,
    aes(
    x=PC1,
    y=PC2,
    shape=IVIVE,
    color=CvT))+
 geom_point(alpha=0.2,size=3,
    aes(
    x=PC1,
    y=PC2,
    color=CvT,
    shape=IVIVE))#+
   # xlim(-1300,200)+
    #ylim(-75,25)

print(pca.fig)
ggsave(paste(loc.wd, "/Figures_August2025/pca.png",sep=""),
       width = 4, height = 3.5, units = "in")
```

---
title: "Frank et al. (2018): Neuronal Network IVIVE"
author: "John F. Wambaugh"
date: "September 25, 2019"
output: rmarkdown::html_vignette
highlight: tango
vignette: >
  %\VignetteIndexEntry{e) Frank (2018): Neuronal Network IVIVE}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---
*Please send questions to John.Wambaugh@UL.org*

from "Defining toxicological tipping points in neuronal network development"

Christopher L. Frank, Jasmine P. Brown, Kathleen Wallace, John F. Wambaugh, Imran Shah, and Timothy J. Shafer

Toxicology and Applied Pharmacology 354 (2018) 81-93

https://doi.org/10.1016/j.taap.2018.01.017

## Abstract
Measuring electrical activity of neural networks by microelectrode array (MEA) 
has recently 
shown promise for screening level assessments of chemical toxicity on network 
development 
and function. Important aspects of interneuronal communication can be quantified 
from a 
single MEA recording, including individual firing rates, coordinated bursting, 
and measures 
of network synchrony, providing rich datasets to evaluate chemical effects. 
Further, 
multiple recordings can be made from the same network, including during the 
formation of 
these networks *in vitro*. The ability to perform multiple recording sessions 
over the in 
vitro development of network activity may provide further insight into 
developmental 
effects of neurotoxicants. In the current study, a recently described MEA-based 
screen of 
86 compounds in primary rat cortical cultures over 12 days in vitro was 
revisited to 
establish a framework that integrates all available primary measures of 
electrical 
activity from MEA recordings into a composite metric for deviation from normal 
activity 
(total scalar perturbation). Examining scalar perturbations over time and 
increasing 
concentration of compound allowed for definition of critical concentrations or 
"tipping 
points" at which the neural networks switched from recovery to non-recovery 
trajectories
for 42 compounds. These tipping point concentrations occurred at predominantly 
lower 
concentrations than those causing overt cell viability loss or disrupting 
individual 
network parameters, suggesting tipping points may be a more sensitive measure 
of network 
functional loss. Comparing tipping points for six compounds with plasma 
concentrations 
known to cause developmental neurotoxicity *in vivo* demonstrated strong 
concordance and
suggests there is potential for using tipping points for chemical 
prioritization.

## HTTK Version

This vignette was created with **httk** v1.8. Although we attempt to maintain 
backward compatibility, if you encounter issues with the latest release of 
**httk**
and cannot easily address the changes, historical versions of httk are 
available from: https://cran.r-project.org/src/contrib/Archive/httk/

## Prepare for session
R package **knitr** generates html and PDF documents from this RMarkdown file,
Each bit of code that follows is known as a "chunk". We start by telling 
**knitr** how we want our chunks to look.
```{r knitrPrep, include=FALSE, eval = TRUE}
knitr::opts_chunk$set(echo = TRUE, fig.width=5, fig.height=4)
```

### Clear the memory
It is a bad idea to let variables and other information from previous R
sessions float around, so we first remove everything in the R memory.
```{r clear_memory, eval = TRUE}
rm(list=ls()) 
```

### eval = execute.vignette
If you are using the RMarkdown version of this vignette (extension, .RMD) you
will be able to see that several chunks of code in this vignette
have the statement "eval = execute.vignette". The next chunk of code, by default,
sets execute.vignette = FALSE.  This means that the code is included (and necessary) but was
not run when the vignette was built. We do this because some steps require 
extensive computing time and the checks on CRAN limit how long we can spend
building the package. If you want this vignette to work, you must run all code,
either by cutting and pasting it into R. Or, if viewing the .RMD file, you can
either change execute.vignette to TRUE or press "play" (the green arrow) on
each chunk in RStudio.
```{r runchunks, eval = TRUE}
# Set whether or not the following chunks will be executed (run):
execute.vignette <- FALSE
```

### Load the relevant libraries
We use the command 'library()' to load various R packages for our analysis.
If you get the message "Error in library(X) : there is no package called 'X'"
then you will need to install that package: 

From the R command prompt:

install.packages("X")

Or, if using RStudio, look for 'Install Packages' under 'Tools' tab.

```{r setup, eval = execute.vignette}
library(httk)
library(ggplot2)
library(scales)
library(httkexamples)
```

### Load the data
```{r Frank2018data, eval = execute.vignette}
chem.table <- httkexamples::Frank2018invivo
```

## Use HTTK to perform IVIVE
### This loops through each study design in the table and runs solve_pbtk:
```{R ivive.loop, eval = execute.vignette}
for (this.row in 1:dim(chem.table)[1])
{
  this.cas <- chem.table[this.row,"Substance_CASRN"]
  if (tolower(chem.table[this.row,"Species"])=="rodent") 
  {  
    this.species <- "rat"
  } else if (tolower(chem.table[this.row,"Species"])=="rat") 
  {
    this.species <- "rat"
  } else if (tolower(chem.table[this.row,"Species"])=="human")
  {
    this.species <- "human"
  }
  else if (tolower(chem.table[this.row,"Species"])=="mouse") 
  {
    this.species <- "mouse"
  }
  else browser()
  if (chem.table[this.row,"Route"] %in% c("i.p.","s.c.","i.m.")) iv.dose =TRUE
  else if (chem.table[this.row,"Route"]=="oral") iv.dose = F
  else browser()
  this.dose <- chem.table[this.row,"Dose"]
  this.days <- chem.table[this.row,"Days"]
# Make sure the dose units are in mg/kg body weight:
  if (regexpr("ug",chem.table[this.row,"Dose.Units"])!=-1) 
  {
    this.dose <- this.dose/1000
  }
  if (regexpr("/kg",chem.table[this.row,"Dose.Units"])==-1) 
  {
    this.dose <- this.dose/0.25
  }
# Here we run the HTTK PBPK Model:
  out <- suppressWarnings(solve_pbtk(chem.cas=this.cas,
           dose=this.dose,
           species=this.species,
# This was used in 2017 but I don't agree with it anymore:
#           restrictive.clearance=FALSE,
           days=this.days,
           iv.dose=iv.dose,
           default.to.human=TRUE))

# Record the Cmax and the AUC:
  chem.table[this.row,"Cmax"] <- max(out[,"Cplasma"])
  chem.table[this.row,"AUC"] <- max(out[,"AUC"])
}
```
## Make the plot
Comparison between predicted plasma levels for critical
concentrations and in vivo estimates from the httk model. For
those chemicals with 1) in vitro predicted critical concentrations,
2) in vivo studies indicating neurological effect, and 3)
available toxicokinetic data the time-integrated plasma concentration
(area under the curve or AUC) was predicted for the
LOEL associated with each chemical-specific study. The chemical-
specific prediction is indicated by the first four letters of
each chemicals name. There were two available studies for each
chemical. The identity ("perfect predictor") line is indicated by
a solid black line, while the dashed lines indicate ten-fold above
and below perfect prediction. Because all in vitro treatments
were exposed for the same amount of time, the relationship
between nominal in vitro concentration and time-integrated
concentration is a constant.
```{R Frank2018.Fig6, eval = execute.vignette}
Fig.AUC <- ggplot(data=chem.table) +
  geom_segment(color="grey",aes(x=AUC,y=Lower.95..CI,xend=AUC,yend=Higher.95..CI))+    
#  geom_point(aes(x=AUC,y=Critical.concentration,color="Chemical"))+ 
   geom_text(aes(x=AUC,y=Critical.concentration,label=Compound.abbrev,color=Chemical)) +
   scale_y_log10(label=label_log(),limits=c(10^-7,100)) +
   scale_x_log10(label=label_log(),limits=c(10^-7,100)) +
    annotation_logticks() + 
    geom_abline(slope=1, intercept=0) + 
    geom_abline(slope=1, intercept=1,linetype="dashed") + 
    geom_abline(slope=1, intercept=-1,linetype="dashed") + 
    xlab(expression(paste(italic("In vivo")," AUC estimated with HTTK (uM*day)"))) + 
    ylab(expression(paste(italic("In vitro")," predicted Critical Conc. (uM)"))) +
    scale_color_brewer(palette="Set2") + 
    theme_bw()  +
    theme(legend.position="bottom")
    
print(Fig.AUC)
```

---
title: "Ring et al. (2017) HTTK-Pop: Generating subpopulations"
author: "Caroline Ring"
date: "`r Sys.Date()`"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{b) Ring (2017) HTTK-Pop: Generating subpopulations}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---
*Please send questions to ring.caroline@epa.gov*

from "Identifying populations sensitive to environmental chemicals by simulating toxicokinetic variability"

Caroline L.Ring, Robert G.Pearce, R. Woodrow Setzer, Barbara A.Wetmore, and 
John F.Wambaugh

Environment International, Volume 106, September 2017, Pages 105-118

https://doi.org/10.1016/j.envint.2017.06.004

## Abstract
The thousands of chemicals present in the environment ([USGAO, 2013](https://www.gao.gov/products/gao-13-249)) must be triaged to identify priority chemicals for human health risk research. Most chemicals have little of the toxicokinetic (TK) data that are necessary for relating exposures to tissue concentrations that are believed to be toxic. Ongoing efforts have collected limited, in vitro TK data for a few hundred chemicals. These data have been combined with biomonitoring data to estimate an approximate margin between potential hazard and exposure. The most “at risk” 95th percentile of adults have been identified from simulated populations that are generated either using standard “average” adult human parameters or very specific cohorts such as Northern Europeans. To better reflect the modern U.S. population, we developed a population simulation using physiologies based on distributions of demographic and anthropometric quantities from the most recent U.S. Centers for Disease Control and Prevention National Health and Nutrition Examination Survey (NHANES) data. This allowed incorporation of inter-individual variability, including variability across relevant demographic subgroups. Variability was analyzed with a Monte Carlo approach that accounted for the correlation structure in physiological parameters. To identify portions of the U.S. population that are more at risk for specific chemicals, physiologic variability was incorporated within an open-source high-throughput (HT) TK modeling framework. We prioritized 50 chemicals based on estimates of both potential hazard and exposure. Potential hazard was estimated from in vitro HT screening assays (i.e., the Tox21 and ToxCast programs). Bioactive in vitro concentrations were extrapolated to doses that produce equivalent concentrations in body tissues using a reverse dosimetry approach in which generic TK models are parameterized with: 1) chemical-specific parameters derived from in vitro measurements and predicted from chemical structure; and 2) with physiological parameters for a virtual population. For risk-based prioritization of chemicals, predicted bioactive equivalent doses were compared to demographic-specific inferences of exposure rates that were based on NHANES urinary analyte biomonitoring data. The inclusion of NHANES-derived inter-individual variability decreased predicted bioactive equivalent doses by 12% on average for the total population when compared to previous methods. However, for some combinations of chemical and demographic groups the margin was reduced by as much as three quarters. This TK modeling framework allows targeted risk prioritization of chemicals for demographic groups of interest, including potentially sensitive life stages and subpopulations.

This vignette provides the code used to generate the virtual populations for the ten subpopulations of interest, plus a non-obese adult subpopulation.

## HTTK Version

This vignette was created with **httk** v1.5. Although we attempt to maintain 
backward compatibility, if you encounter issues with the latest release of 
**httk**
and cannot easily address the changes, historical versions of httk are 
available from: https://cran.r-project.org/src/contrib/Archive/httk/

## Prepare for session
R package **knitr** generates html and PDF documents from this RMarkdown file,
Each bit of code that follows is known as a "chunk". We start by telling 
**knitr** how we want our chunks to look.
```{r, include=FALSE}
knitr::opts_chunk$set(collapse = TRUE, comment = '#>')
```

### Clear the memory
It is a bad idea to let variables and other information from previous R
sessions float around, so we first remove everything in the R memory.
```{r clear_memory, eval = TRUE}
rm(list=ls()) 
```


### eval = execute.vignette
If you are using the RMarkdown version of this vignette (extension, .RMD) you
will be able to see that several chunks of code in this vignette
have the statement "eval = execute.vignette". The next chunk of code, by default,
sets execute.vignette = FALSE.  This means that the code is included (and necessary) but was
not run when the vignette was built. We do this because some steps require 
extensive computing time and the checks on CRAN limit how long we can spend
building the package. If you want this vignette to work, you must run all code,
either by cutting and pasting it into R. Or, if viewing the .RMD file, you can
either change execute.vignette to TRUE or press "play" (the green arrow) on
each chunk in RStudio.
```{r runchunks, eval = TRUE}
# Set whether or not the following chunks will be executed (run):
execute.vignette <- FALSE
```

### Load the relevant libraries
To use the code in this vignette, you'll first need to load a few packages.
If you get the message "Error in library(X) : there is no package called 'X'"
then you will need to install that package: 

From the R command prompt:

install.packages("X")

Or, if using RStudio, look for 'Install Packages' under 'Tools' tab.
```{r load_packages, eval = execute.vignette}
library("httk")
library("data.table")
```

Because we'll be writing some files (and then reading them in other vignettes),
be aware of where your current working directory is -- the files will be written there.
# Set up subpopulation specs
Here, we set the number of individuals in each virtual population (1000). We also specify a list of names for the virtual populations. Then we specify corresponding lists of gender, age limits, and BMI categories. HTTK-Pop default values will be used for other population specifications (e.g. race/ethnicity, kidney function categories).
```{r subpop_specs, eval = execute.vignette}
nsamp<-1000
#List subpop names
ExpoCast.group<-list("Total",
                     "Age.6.11",
                     "Age.12.19",
                     "Age.20.65",
                     "Age.GT65",
                     "BMIgt30",
                     "BMIle30",
                     "Females",
                     "Males",
                     "ReproAgeFemale",
                     "Age.20.50.nonobese")
#List subpop gender specifications
gendernum <- c(rep(list(NULL),7), 
               list(list(Male=0, Female=1000)), 
               list(list(Male=1000, Female=0)), 
               list(list(Male=0, Female=1000)), 
               list(NULL))
#List subpop age limits in years
agelim<-c(list(c(0,79),
               c(6,11),
               c(12,19),
               c(20,65),
               c(66,79)),
          rep(list(c(0,79)),4),
          list(c(16,49)),
          list(c(20,50)))
#List subpop weight categories
bmi_category <- c(rep(list(c('Underweight', 
                             'Normal',
                             'Overweight',
                             'Obese')),
                      5),
                  list('Obese', c('Underweight','Normal', 'Overweight')),
                  rep(list(c('Underweight', 
                             'Normal',
                             'Overweight',
                             'Obese')),
                      3),
                  list(c('Underweight', 'Normal', 'Overweight')))
```

## Generate populations
First, define the loop body as a function; then use `parallel::clusterMap` to parallelize it. Warning: This might take a couple of minutes to run.
```{r generate_parallel, eval = execute.vignette}
tmpfun <- function(gendernum, agelim, bmi_category, ExpoCast_grp,
                   nsamp, method){
  result <- tryCatch({
                     pops <- httk::httkpop_generate(
                  method=method,
                  nsamp = nsamp,
                  gendernum = gendernum,
                  agelim_years = agelim,
                  weight_category = bmi_category)
                  
                  filepart <- switch(method,
                                     'virtual individuals' = 'vi',
                                     'direct resampling' = 'dr')
saveRDS(object=pops,
          file=paste0(paste('data/httkpop',
                      filepart, ExpoCast_grp, 
                      sep='_'),
                      '.Rdata'))
return(getwd())
}, error = function(err){
  print(paste('Error occurred:', err))
  return(1)
})
}

cluster <- parallel::makeCluster(2, # Reduced from 40 to 2 cores 
                       outfile='subpopulations_parallel_out.txt')

evalout <- parallel::clusterEvalQ(cl=cluster,
             {library(data.table)
              library(httk)})
parallel::clusterExport(cl = cluster,
              varlist = 'tmpfun')
#Set seeds on all workers for reproducibility
parallel::clusterSetRNGStream(cluster, 
                              010180)
out_vi <- parallel::clusterMap(cl=cluster,
                  fun = tmpfun,
                  gendernum=gendernum,
                  agelim=agelim,
                  bmi_category=bmi_category,
                  ExpoCast_grp = ExpoCast.group,
                  MoreArgs = list(nsamp = nsamp,
                                  method = 'virtual individuals'))
out_dr <- parallel::clusterMap(cl=cluster,
                  fun = tmpfun,
                  gendernum=gendernum,
                  agelim=agelim,
                  bmi_category=bmi_category,
                  ExpoCast_grp = ExpoCast.group,
                  MoreArgs = list(nsamp = nsamp,
                                  method = 'direct resampling'))
parallel::stopCluster(cluster)
```

---
title: "Truong et al. (2025): Full Human Gestational IVIVE"
author: "Kimberly T.Truong, John F. Wambaugh, Dustin F. Kapraun, Sarah E. Davidson-Fritz, Stephanie Eytcheson, Richard Judson, Katie Paul-Friedman"
date:  "`r Sys.Date()`"
output: rmarkdown::html_vignette
vignette: > 
  %\VignetteIndexEntry{j) Truong (2025) Full Human Gestational IVIVE}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---
*Please send questions to John.Wambaugh@UL.org*

from "Interpretation of thyroid-relevant bioactivity data for comparison to 
in vivo exposures: A prioritization approach for putative chemical inhibitors 
of in vitro deiodinase activity"

Kimberly T Truong, John F Wambaugh, Dustin F Kapraun, Sarah E Davidson-Fritz,
Stephanie Eytcheson, Richard S Judson, and Katie Paul Friedman

Toxicological Sciences, 2025

## Overview

In this vignette, we show how to use the full human gestational model from **httk** to perform *in vitro-in vivo* extrapolation (IVIVE) on a relevant *in vitro* bioactivity dataset. Briefly, this demonstrates how to take thyroid-related *in vitro* bioactivity data from ToxCast, perform IVIVE using the 3-compartment steady state model and the full human pregnancy model within **httk**, and compare it with the latest exposure estimates from ExpoCast as a method of prioritization. This is detailed in Truong et al. 2025 (in review). 

Truong et al. 2025 describes a prioritization workflow for thyroid-related bioactivity data related to deiodinase inhibition by applying the full human gestational model to compute administered equivalent doses (AEDs) and bioactivity-to-exposure ratios (BERs) by integrating SEEM3 ExpoCast predictions. See Figure 1 for an overview of the workflow. 

This vignette reproduces Figures 9 and 10 from Truong et al. 2025.

## HTTK Version 
This vignette was created with **httk** v2.6.0 which includes new model functionality (see **Simulate full-term human pregnancy model**).

```{r configure-knitr, include = FALSE}
knitr::opts_chunk$set(collapse = TRUE, comment = '#>')
options(rmarkdown.html_vignette.check_title = FALSE)
```

```{r clear-memory, eval = TRUE}
rm(list = ls())
```

### eval = execute.vignette
Several chunks of code in this vignette have "eval = execute.vignette" and we set execute.vignette to be FALSE, by default. We do this to include all the code that was necessary to produce the figures but was not run when the vignette was built since some of these chunks take a considerable amount of time and the checks on CRAN limit how long we can spend
building the package. You can still reproduce the end figures knitting the .Rmd file, since all the necessary and minimal data objects have been stored in *httk*. If you want to rerun the whole workflow on your own, you must rerun all code from top to bottom, either by changing execute.vignette to TRUE or clicking on the "green arrow" in RStudio. 

```{r}
execute.vignette <- FALSE
```

## Data Import 
We need to load in the processed *in vitro* bioactivity data. This is stored within *httk* and can be accessed by `httk::thyroid.ac50s`. From the R command prompt,
`?thyroid.ac50s` for more details. 

```{r invitro-data, eval = execute.vignette}
ac50.dt <- httk::thyroid.ac50s

```

### Load libraries 
```{r libraries, message = FALSE, eval = execute.vignette}
library(httk)
library(data.table)
library(dplyr)
library(openxlsx)
library(ggpubr)
library(cowplot)
library(ggrepel)
library(latex2exp)
library(viridis)
library(scales)
library(ggstar)
```

# IVIVE using 3-compartment steady state model

## Examine Chemicals
Only 50 chemicals have experimental toxicokinetic (TK) parameters sufficient for *httk*. 
```{r exp-TK-chems, warning = FALSE, eval = execute.vignette}
# how many chems had experimental TK params?
human.data.pre <- subset(get_cheminfo(info = 'all', species = 'Human', 
                                      model = '3compartmentss'), 
                         DTXSID %in% ac50.dt$dsstox_substance_id)  

nrow(human.data.pre)

```

### In silico predictions of TK parameters
We need to supplement these with *in silico* predictions of TK parameters.
```{r insilico-preds, message=FALSE, warning=FALSE, eval = execute.vignette}
# predict Clint/fup values for missing chems 
# this loads new chem.physical_and_invitro.data table into the global env 
load_dawson2021() # most data for ToxCast chems
load_sipes2017() # most data for pharma compounds 
load_pradeep2020() # best ML method for in silico prediction 

```

### Examine missing chemicals 
```{r missing-chems, warning = FALSE, eval = execute.vignette}
human.httk.dt <- subset(ac50.dt, dsstox_substance_id %in% get_cheminfo(info = 'DTXSID', 
                                                                       species = 'Human', 
                                                                       model = '3compartmentss', 
                                                                       physchem.exclude = FALSE,  
                                                                       median.only = TRUE))

missing.dtxsids <- setdiff(ac50.dt$dsstox_substance_id, human.httk.dt$dsstox_substance_id)

View(ac50.dt[dsstox_substance_id %in% missing.dtxsids])

```

## Predicting AEDs based on Css50 (in plasma)
There are two ways to compute an oral AED in *httk*:  
1. compute a steady-state plasma concentration via `calc_mc_css` and then:
$$ 
AED = \frac{AC_{50}}{CSS_{50}}
$$
2. use `calc_mc_oral_equiv` passing the AC50 to the `conc` argument and specifying `which.quantile = c(0.5)`.  

```{r 3compss-aeds, warning = FALSE, message = FALSE, eval = execute.vignette}

for (i in 1:nrow(human.httk.dt)) {
  
  message('Calculating for chemical: ', human.httk.dt$chnm[i], '\n')
  set.seed(123)
  out <- calc_mc_css(dtxsid = human.httk.dt$dsstox_substance_id[i], 
                     species = 'Human', 
                     daily.dose = 1, 
                     which.quantile = c(0.5, 0.95), 
                     model = '3compartmentss', 
                     output.units = 'uM', 
                     parameterize.args.list=list(physchem.exclude=FALSE), 
                     suppress.messages = TRUE)
  
  human.httk.dt$mc.css50[i] <- out["50%"]

  set.seed(123)
  oralequiv.out <- calc_mc_oral_equiv(conc = human.httk.dt$min_ac50[i],
                                      dtxsid = human.httk.dt$dsstox_substance_id[i], 
                                      species = 'Human',
                                      which.quantile = c(0.5, 0.95),
                                      input.units = 'uM',
                                      output.units = 'mgpkgpday',
                                      model = '3compartmentss',
                                      restrictive.clearance = TRUE,
                                      parameterize.args.list=list(physchem.exclude=FALSE),
                                      suppress.messages = TRUE)
  
   human.httk.dt$oral_equiv50[i] <- oralequiv.out["50%"]
}                                                                

human.httk.dt[, calc.aed50 := min_ac50/mc.css50]
human.httk.dt[, fold_diff50 := log10(oral_equiv50/calc.aed50)]

```

## Load ExpoCast predictions (SEEM3)
```{r seem3, eval = execute.vignette}

# let's use the aed values from the division 
human.httk.dt2 <- human.httk.dt[, c('dsstox_substance_id', 'chnm', 
                                    'DIO1', 'DIO2', 'DIO3', 'IYD', 'min_ac50', 
                                    'mc.css50', 'calc.aed50')]

SEEM <- httk::truong25.seem3

# integrate SEEM3 predictions with merge
human.httk.dt2.seem3 <- merge.data.table(human.httk.dt2, 
                                         SEEM[, c("dsstox_substance_id", "seem3", "seem3.u95")], 
                                         by = c("dsstox_substance_id"), 
                                         all.x = TRUE)

human.httk.dt2.seem3[, plasmaBER50 := calc.aed50/seem3.u95]
human.httk.dt2.seem3[, log.pBER50 := log10(plasmaBER50)]

ivive.moe.tb <- human.httk.dt2.seem3
setnames(ivive.moe.tb, "dsstox_substance_id", "dtxsid")

```

# IVIVE using the Full Human Gestational Model

### Compute half-lives
```{r half-lives, warning = FALSE, eval = execute.vignette}
for (i in 1:nrow(ivive.moe.tb)) {
  ivive.moe.tb$half.life[i] <- calc_half_life(dtxsid = ivive.moe.tb$dtxsid[i], # t1/2 in hours 
                                              physchem.exclude = FALSE) 
  ivive.moe.tb$half.life.days[i] <- ivive.moe.tb$half.life[i]/24 # in days
}

```

## Simulate full-term human pregnancy model 
```{r fullpreg-sim, message = FALSE, warning = FALSE, eval = execute.vignette}

# tissues where DIO enzymes live 
impacted_tissues <- c('Cliver', 'Cthyroid', 'Cfliver', 'Cfbrain', 'Cfthyroid', 
                      'Cplacenta', 'Cconceptus', 'Cplasma')
targets <- c('DIO1', 'DIO2', 'DIO3', 'IYD')

# max conc in every tissue for every chemical
Cmax.tissues <- data.frame(matrix(NA, ncol = length(impacted_tissues) + 1, 
                                  nrow = nrow(ivive.moe.tb), 
                                  dimnames = list(NULL, c('dtxsid', impacted_tissues))))

for(i in 1:nrow(ivive.moe.tb)) {
  
  sol.out <- solve_full_pregnancy(dtxsid = ivive.moe.tb$dtxsid[i],
                            daily.dose = 1, 
                            doses.per.day = 1,
                            time.course = seq(0, 40*7, 1/24), # view solution by hour
                            track.vars = impacted_tissues, 
                            physchem.exclude = FALSE)

  
  # get max of every column re: compt 
  Cmax.tissues[i, impacted_tissues] <- apply(sol.out[, impacted_tissues], 2, max, na.rm = T)
  Cmax.tissues[i, 'dtxsid'] <- ivive.moe.tb$dtxsid[i]
  
}

```

## Calculate AEDs by Target and Tissue
```{r preg-aeds, eval = execute.vignette}
tissue.aeds <- list()

# tissues specific for each target 
tissue_list <- list(DIO1 = c('Cliver', 'Cfliver', 'Cthyroid', 'Cfthyroid', 'Cconceptus'), 
                    DIO2 = c('Cthyroid', 'Cfthyroid', 'Cfbrain', 'Cconceptus'), 
                    DIO3 = c('Cthyroid', 'Cfthyroid', 'Cfbrain', 'Cplacenta', 'Cconceptus'), 
                    IYD = c('Cthyroid', 'Cfthyroid', 'Cconceptus'))

for (i in names(tissue_list)) {
  active.chem.ind <- which(!is.na(ivive.moe.tb[, ..i]))
  n.chems <- length(active.chem.ind)
  
  empty.mat <- matrix(NA, nrow = n.chems, ncol = length(tissue_list[[i]]) + 1)
  df.target <- data.frame(empty.mat)
  colnames(df.target) <- c('dtxsid', tissue_list[[i]])
 
  df.target[, 2: (length(tissue_list[[i]])+1) ] <- mapply(function(x,y) x/y, ivive.moe.tb[active.chem.ind, ..i], Cmax.tissues[active.chem.ind, tissue_list[[i]]])
  
  df.target$dtxsid <- ivive.moe.tb$dtxsid[active.chem.ind]
  tissue.aeds[[i]] <- df.target
}

```

## Figure 9: Priority Chemicals based on maternal-fetal BERs

```{r fig9-wrangling, eval = execute.vignette}
impacted_tissues <- c('Cliver', 'Cthyroid', 'Cfliver', 'Cfbrain', 'Cfthyroid', 
                      'Cplacenta', 'Cconceptus', 'Cplasma')

get_ber_data <- function(name, df) {
  
  df$exposure <- ivive.moe.tb$seem3.u95[match(df$dtxsid, ivive.moe.tb$dtxsid)]
  df.m <- df %>% select(-exposure) %>%
    reshape2::melt(id.vars = c('dtxsid'), 
                   variable.name = 'compt', value.name = 'aed')
  df.m$exposure <- ivive.moe.tb$seem3.u95[match(df.m$dtxsid, ivive.moe.tb$dtxsid)]
  df.m$ber = df.m$aed/df.m$exposure
  df.m2 <- df.m %>% 
    select(-exposure) %>%
    reshape2::melt(id.vars = c('dtxsid', 'compt', 'ber'))
  
  # add melted ExpoCast data as rows for each unique chem 
  expocast.dat <- df %>% select(dtxsid, exposure) %>% 
    reshape2::melt(id.vars = c('dtxsid'))
  
  df.m2 <- bind_rows(df.m2, expocast.dat)
  df.m2$value <- log10(df.m2$value)
  df.m2$ber <- log10(df.m2$ber)
  df.m2$chnm <- ivive.moe.tb$chnm[match(df.m2$dtxsid, ivive.moe.tb$dtxsid)]
  df.m2$enzyme <- name
  return(df.m2)
}

new.list <- Map(get_ber_data, names(tissue.aeds), tissue.aeds)
ggdata = bind_rows(new.list) 
setDT(ggdata)

# order chemicals within each enzyme group by the most sensitive tissue/lifestage BER
ggdata[, min_ber := min(ber, na.rm = TRUE), keyby = .(enzyme, dtxsid)]
ggdata <- ggdata[order(min_ber), .SD, keyby = .(enzyme)]

# exposure values are dependent on dtxsid not httk compt 
ggdata[variable == 'exposure', compt := 'exposure']

# make a deep copy or else it will be modified by reference 
tissue.bers <- copy(ggdata)

# round all numerical values including BERs to 2 sigfigs 
num.cols <- c("value", "ber", "min_ber")
tissue.bers[, c(num.cols) := lapply(.SD, signif, digits = 2), .SDcols = num.cols]

```

```{r fig9-plt, eval = execute.vignette}
min_val <- tissue.bers[min_ber <= 3, min(value), by = enzyme][, min(V1)]
max_val <- tissue.bers[min_ber <= 3, max(value), by = enzyme][, max(V1)]
ylims <- c(min_val, max_val)

# generate a set of 3 viridis colors for lifestage 
# yellow represents neither maternal or fetal, i.e., conceptus
my_viridis_colors <- viridis(n = 3)

listgg <- list()
for(k in names(tissue.aeds)) {
  
  aeds <- tissue.bers[enzyme == k & ber <= 3]
  chems <- tissue.bers[enzyme == k & ber <= 3, dtxsid]
  exposures <- tissue.bers[enzyme == k & variable == "exposure" & dtxsid %in% chems]
  
  listgg[[k]] <- ggplot(data = rbind(aeds,exposures), 
                        mapping = aes(x = reorder(chnm, -min_ber), 
                                      y = value)) +
    geom_star(aes(starshape = compt, fill = compt, color = compt), 
              alpha = 0.65, size = 1.25, # default: 1.5
              starstroke = 0.25, # default: 0.5
              show.legend = T) +
    scale_y_continuous(breaks = seq(ylims[1], ylims[2], 1),
                       limits = ylims) +
    scale_starshape_manual(name = "Compartment corresponding to AED \n or Exposure", 
                       labels = c("maternal liver", "fetal liver", 
                                  "maternal thyroid", "fetal thyroid", 
                                  "conceptus", 
                                  "fetal brain", 
                                  "placenta", "exposure"),
                       values = c('Cfbrain' = 15,
                                  'exposure' = 28, 
                                  'Cliver' = 11,
                                  'Cfliver' = 11, 
                                  'Cplacenta' = 13, 
                                  'Cthyroid' = 1,
                                  'Cfthyroid' = 1, 
                                  'Cconceptus' = 23), 
                       drop = F) + # this makes sure all levels of a factor are displayed even if unused 
    scale_fill_manual(name = "Compartment corresponding to AED \n or Exposure", 
                       labels = c("maternal liver", "fetal liver", 
                                  "maternal thyroid", "fetal thyroid", 
                                  "conceptus", 
                                  "fetal brain", 
                                  "placenta", "exposure"),
                       values = c('Cfbrain' = my_viridis_colors[2],
                                  'exposure' = 'dimgrey', 
                                  'Cliver' = my_viridis_colors[1],
                                  'Cfliver' = my_viridis_colors[2], 
                                  'Cplacenta' = '#990066', 
                                  'Cthyroid' = my_viridis_colors[1],
                                  'Cfthyroid' = my_viridis_colors[2], 
                                  'Cconceptus' = '#73D055FF'), 
                       drop = F) +
     scale_color_manual(name = "Compartment corresponding to AED \n or Exposure",
                       labels = c("maternal liver", "fetal liver",
                                  "maternal thyroid", "fetal thyroid",
                                  "conceptus",
                                  "fetal brain",
                                  "placenta", "exposure"),
                       values = c('Cfbrain' = my_viridis_colors[2],
                                  'exposure' = 'dimgrey',
                                  'Cliver' = my_viridis_colors[1],
                                  'Cfliver' = my_viridis_colors[2],
                                  'Cplacenta' = '#990066',
                                  'Cthyroid' = my_viridis_colors[1],
                                  'Cfthyroid' = my_viridis_colors[2],
                                  'Cconceptus' = '#73D055FF'),
                       drop = F) +
    labs(x = 'Chemical', y = 'Oral AED or Exposure (log10 mg/kg-bw/day)', title = k) +
    theme_bw() +
    theme(legend.position = "none", 
          plot.title = element_text(size = 8, face = "bold"), 
          plot.margin = unit(c(0.1,0.1,0.1,0.1), "cm"),
          axis.title = element_text(size = 6), 
          axis.text.y = element_text(size = 5), 
          axis.text.x = element_text(size = 6),
          legend.text = element_text(size = 6), 
          legend.title = element_text(size = 6, hjust = 0.5))+
    coord_flip()
}

# remove extra axis labels 
listgg$IYD <- listgg$IYD + labs(x = '', y = '')
listgg$DIO3 <- listgg$DIO3 + 
  labs(x = '') 
listgg$DIO1 <- listgg$DIO1 + labs(y = '')

# arrange DIO1 and DIO2 with equal sizes since they have ~20 chems each (21 vs 24)
pcol1 <- plot_grid(listgg$DIO1, listgg$DIO2, 
                  align = "hv", nrow = 2, 
                  rel_heights = c(1,1.1))

# make DIO3 3x taller than IYD (44 chems vs 4)
pcol2 <- plot_grid(listgg$IYD, listgg$DIO3, 
                   align = "hv", nrow = 2, 
                   rel_heights = c(1,3))

# combine two columns of plots
prow <- plot_grid(pcol1, pcol2, 
                    align = "h", ncol = 2, 
                    rel_widths = c(1,1))

# extract legend from one of the plots
grobs <- ggplotGrob(
  listgg$DIO2 + 
  guides(
    starshape = guide_legend(ncol = 2, byrow = F, 
                             keyheight = unit(0.25, "cm")), 
    fill = guide_legend(ncol = 2, byrow = F, 
                        keyheight = unit(0.25, "cm")), 
    color = guide_legend(ncol = 2, byrow = F, 
                         keyheight = unit(0.25, "cm")),
  ) +
  theme(legend.position = "bottom")
  )$grobs
legend2 <- grobs[[which(sapply(grobs, function(x) x$name) == "guide-box")]]

# add the legend underneath the plots; make it 10% of the height of the combined plots
fig9 <- plot_grid(prow, legend2, 
          nrow = 2, rel_heights = c(0.88,0.12)) +
   theme(plot.background = element_rect(fill = "white", color = "white"))

# ggsave(plot = fig9,
#        units = "mm",
#        dpi = 300,
#        width = 190, height = 150,
#        device = "png",
#        filename = "./figures/preg_prioritization_by_BER.png")

```

# Comparing IVIVE models based on BER prioritization 

## Table 8
```{r table-8, warning = FALSE, eval = execute.vignette}
targets <- c('DIO1', 'DIO2', 'DIO3', 'IYD')

# DATA WRANGLING
tissue.bers[min_ber == ber, most_sensitive_tissue := compt]

# table matching order of chemicals in enzyme subplots with all calculated BERs
# every enzyme x chem x min BER constitutes a row 
minber.by.chem <- tissue.bers[!is.na(most_sensitive_tissue), 
                       .(chnm, min_ber, most_sensitive_tissue), by = .(enzyme, dtxsid)]

# check if there are multiple most-sensitive tissues per chem in each enzyme group 
minber.by.chem[, if(.N > 1) .SD, by = .(enzyme, dtxsid)][, length(unique(dtxsid))] #70 chems

# collapse multiple most-sensitive tissues per chem in each enzyme group
min.ber.reduced <- minber.by.chem[, most_sensitive_compts := paste(most_sensitive_tissue, collapse = ", "), by = .(enzyme, dtxsid)][, .(chnm, min_ber, most_sensitive_compts), by = .(enzyme, dtxsid)]
min.ber.reduced <- unique(min.ber.reduced)

# min BER matrix
min.ber.mat <- data.table::dcast(min.ber.reduced[, 1:4], 
                     dtxsid + chnm ~ enzyme, value.var = c('min_ber'))
min.ber.mat[, min_across_enzyme := pmin(DIO1, DIO2, DIO3, IYD, na.rm = T)]
min.ber.mat <- min.ber.mat[order(min_across_enzyme)]

# find the target corresponding to the min_across_enzyme
min.ber.mat[, enzyme := mapply(function(x) targets[x], apply(min.ber.mat[, targets, with = FALSE], 1, which.min))]

# merge data on most sensitive tissues reflecting min BER 
new.ranking.tissues <- merge.data.table(min.ber.mat, 
                                 minber.by.chem[, .(dtxsid, chnm, enzyme, min_ber, most_sensitive_tissue)], 
                                 by = c('dtxsid', 'chnm', 'enzyme'), 
                                 all.x = TRUE)
setnames(new.ranking.tissues, old = 'enzyme', new = 'target_min')

# round all BERs to 2 sigfigs for easy table viewing 
ranked.by.plasma <- ivive.moe.tb[, lmoe50 := signif(log.pBER50, digits = 2)][order(lmoe50)]

final.new.ranking <- new.ranking.tissues[, -c("target_min", "min_ber")]
final.new.ranking <- final.new.ranking[order(min_across_enzyme)]

# comparing tissue BERs from full preg model with plasma BERs from 3compss model 
plasma.tissue.bers <- merge.data.table(ranked.by.plasma[, c('dtxsid', 'chnm', 'lmoe50')], 
                           final.new.ranking[, -c('chnm')], 
                           by = c('dtxsid'))

setnames(plasma.tissue.bers, old = colnames(plasma.tissue.bers)[3:8], 
         new = c('plasma_BER50', 'DIO1_BER', 'DIO2_BER', 'DIO3_BER', 'IYD_BER', 'min_BER'))

plasma.tissue.bers <- plasma.tissue.bers[order(min_BER)]

```

## Figure 10: Understanding and Interpreting Maternal-Fetal BERs
```{r fig10, eval = execute.vignette}
# merge min BER with plasma BER for each chem with unique row for each chem
# ignoring multiple sensitive tissues
ber.comp <- merge.data.table(ranked.by.plasma[, c('dtxsid', 'chnm', 'lmoe50')], 
                             min.ber.mat[, -c("chnm")], 
                             by = c("dtxsid"))

setnames(ber.comp, old = colnames(ber.comp)[3:8], 
         new = c('plasma_BER50', 'DIO1_BER', 'DIO2_BER', 'DIO3_BER', 'IYD_BER', 'min_BER'))

max_ber <- max(ber.comp[, c('plasma_BER50', 'min_BER')], na.rm = T)
min_ber <- min(ber.comp[, c('plasma_BER50', 'min_BER')], na.rm = T)
ber.lims <- c(floor(min_ber), ceiling(max_ber))

# chems with labels 
chem.labels <- ber.comp[min_BER < 0][order(min_BER)][1:6, chnm]

# theme for the next 2 figures 
my_theme <- theme_bw() +
  theme(axis.title = element_text(size = 8, face = "bold"), 
        axis.text = element_text(size = 7))
  
preg.vs.nonpreg.pp <- ggplot(data = ber.comp, aes(x = plasma_BER50, y = min_BER)) +
  geom_point(alpha = 0.75, size = 1, 
             show.legend = T) +
  geom_abline(slope = 1, linewidth = 0.5, linetype = 'solid', color = "#666666") +
  geom_abline(aes(slope = 1, intercept = 1), linetype = 'longdash', color = 'grey', linewidth = 0.5) + # default linesize = 1
  geom_abline(aes(slope = 1, intercept = -1), linetype = 'longdash', color = 'grey', linewidth = 0.5) +
  geom_label_repel(aes(label = chnm),
                   data = ber.comp[chnm %in% chem.labels],
                   max.overlaps = Inf, 
                   force = 50, 
                   size = 2, 
                   label.padding = 0.1, 
                   label.size = 0.1, 
                   label.r = 0.08, 
                   segment.size = 0.2, 
                   min.segment.length = 0) +
  my_theme +
  scale_x_continuous(breaks = seq(ber.lims[1], ber.lims[2], 1), 
                     limits = ber.lims) +
  scale_y_continuous(breaks = seq(ber.lims[1], ber.lims[2], 1), 
                     limits = ber.lims) +
  labs(x = 'plasma BER using 3compss model', y = 'min BER across DIO/IYD targets and tissues')

# how many chems to the right of y = x?
ber.comp[plasma_BER50 > min_BER, .N] #89 chems 

# plot SEEM3 uncertainty
ivive.moe.tb$uncertainty = log10(ivive.moe.tb$seem3.u95/ivive.moe.tb$seem3)
ber.comp$uncertainty <- ivive.moe.tb$uncertainty[match(ber.comp$dtxsid, ivive.moe.tb$dtxsid)]

min.min.ber <- min(ber.comp$min_BER)
max.min.ber <- max(ber.comp$min_BER)
min.ber.lims <- c(floor(min.min.ber), ceiling(max.min.ber))
max.uncertainty <- max(ber.comp$uncertainty)

seem3pp <- ggplot(data = ber.comp, 
       mapping = aes(x = min_BER, 
                     y = uncertainty)) +
  geom_point(size = 1, alpha = 0.8) +
  geom_label_repel(aes(label = chnm),
                   data = subset(ber.comp, chnm %in% chem.labels), 
                   max.overlaps = Inf, 
                   force = 75,
                   size = 2, 
                   label.padding = 0.1, 
                   label.size = 0.1, 
                   label.r = 0.08, 
                   segment.size = 0.2, 
                   min.segment.length = 0) +
  my_theme +
  scale_x_continuous(breaks = seq(min.ber.lims[1], min.ber.lims[2], 1), 
                     limits = min.ber.lims) +
  scale_y_continuous(breaks = seq(0, ceiling(max.uncertainty), 1), 
                     limits = c(0, ceiling(max.uncertainty))) +
  labs(x = 'min BER by Chemical', y = TeX(r'($log_{10}ExpoCast_{u95} - log_{10}ExpoCast_{med}$)'))

median(ber.comp$min_BER)
#> [1] 2.9

fig10 <- plot_grid(preg.vs.nonpreg.pp, seem3pp, 
          labels = "AUTO", label_size = 10)

# ggsave(plot = fig10,
#        units = "mm",
#        dpi = 300,
#        width = 190, height = 100,
#        device = "png",
#        filename = "./figures/BER_uncertainty.png")

```

# Code used to create data distributed with vignette
```{r create_distributable_data, eval = FALSE}
thyroid.ac50s <- ac50.dt
truong25.seem3 <- SEEM

save(thyroid.ac50s, truong25.seem3,
     file="./httk/Truong2025Vignette.RData")
```

---
title: "Pearce et al. (2017): Evaluation of Tissue Partitioning"
author: "Robert Pearce"
date: "April 30, 2023"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{c) Pearce (2017): Evaluation of Tissue Partitioning}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---
*Please send questions to John.Wambaugh@UL.org*

from "Evaluation and calibration of high-throughput predictions of chemical 
distribution to tissues"

Robert G. Pearce, R. Woodrow Setzer, Jimena L. Davis,and John F. Wambaugh 

Journal of Pharmacokinetics and Pharmacodynamics volume 44, pages549–565 (2017)

https://doi.org/10.1007/s10928-017-9548-7

## Abstract

Toxicokinetics (TK) provides critical information for integrating chemical 
toxicity and exposure assessments in order to determine potential chemical risk 
(i.e., the margin between toxic doses and plausible exposures). For thousands of 
chemicals that are present in our environment, in vivo TK data are lacking. The 
publicly available R package “httk” (version 1.8, named for “high throughput 
TK”) draws from a database of in vitro data and physico-chemical properties in 
order to run physiologically-based TK (PBTK) models for 553 compounds. The PBTK 
model parameters include tissue:plasma partition coefficients (Kp) which the 
httk software predicts using the model of Schmitt 
(Toxicol In Vitro 22 (2):457–467, 2008). In this paper we evaluated and modified 
httk predictions, and quantified confidence using in vivo literature data. We 
used 964 rat Kp measured by in vivo experiments for 143 compounds. Initially, 
predicted Kp were significantly larger than measured Kp for many lipophilic 
compounds (log10 octanol:water partition coefficient > 3). Hence the approach 
for predicting Kp was revised to account for possible deficiencies in the in 
vitro protein binding assay, and the method for predicting membrane affinity 
was revised. These changes yielded improvements ranging from a factor of 10 to 
nearly a factor of 10,000 for 83 Kp across 23 compounds with only 3 Kp worsening 
by more than a factor of 10. The vast majority (92%) of Kp were predicted within 
a factor of 10 of the measured value (overall root mean squared error of 0.59 on 
log10-transformed scale). After applying the adjustments, regressions were
performed to calibrate and evaluate the predictions for 12 tissues. Predictions 
for some tissues (e.g., spleen, bone, gut, lung) were observed to be better 
than predictions for other tissues (e.g., skin, brain, fat), indicating that 
confidence in the application of in silico tools to predict chemical 
partitioning varies depending upon the tissues involved. Our calibrated model 
was then evaluated using a second data set of human in vivo measurements of 
volume of distribution (Vss) for 498 compounds reviewed by Obach et al. (Drug 
Metab Dispos 36(7):1385–1405, 2008). We found that calibration of the model 
improved performance: a regression of the measured values as a function of the 
predictions has a slope of 1.03, intercept of − 0.04, and R2 of 0.43. Through 
careful evaluation of predictive methods for chemical partitioning into tissues, 
we have improved and calibrated these methods and quantified confidence for TK 
predictions in humans and rats.

## HTTK Version

This vignette was created with **httk** v1.6. It was updated to httk v2.2.3 in
April of 2023. Although we attempt to maintain 
backward compatibility, if you encounter issues with the latest release of 
**httk**
and cannot easily address the changes, historical versions of httk are 
available from: https://cran.r-project.org/src/contrib/Archive/httk/

## Prepare for session
R package **knitr** generates html and PDF documents from this RMarkdown file,
Each bit of code that follows is known as a "chunk". We start by telling 
**knitr** how we want our chunks to look.
```{r knitrPrep, include=FALSE, eval = TRUE}
knitr::opts_chunk$set(echo = TRUE, fig.width=5, fig.height=4)
```

### Clear the memory
It is a bad idea to let variables and other information from previous R
sessions float around, so we first remove everything in the R memory.
```{r clear_memory, eval = TRUE}
rm(list=ls()) 
```

### eval = execute.vignette
If you are using the RMarkdown version of this vignette (extension, .RMD) you
will be able to see that several chunks of code in this vignette
have the statement "eval = execute.vignette". The next chunk of code, by default,
sets execute.vignette = FALSE.  This means that the code is included (and necessary) but was
not run when the vignette was built. We do this because some steps require 
extensive computing time and the checks on CRAN limit how long we can spend
building the package. If you want this vignette to work, you must run all code,
either by cutting and pasting it into R. Or, if viewing the .RMD file, you can
either change execute.vignette to TRUE or press "play" (the green arrow) on
each chunk in RStudio.
```{r runchunks, eval = TRUE}
# Set whether or not the following chunks will be executed (run):
execute.vignette <- FALSE
```

### Load the relevant libraries
We use the command 'library()' to load various R packages for our analysis.
If you get the message "Error in library(X) : there is no package called 'X'"
then you will need to install that package: 

From the R command prompt:

install.packages("X")

Or, if using RStudio, look for 'Install Packages' under 'Tools' tab.

```{r load_libraries, eval=execute.vignette}
library(httk)
library(gdata)
library(ggplot2)
library(viridis)
library(censReg)
library(gmodels)
library(gplots)
library(scales)
library(colorspace)
library(gridExtra)
```

We first filter the measured rat Kp data, pc.data. Then the old and new Kp 
predictions are made, along with error and improvement measures, 
and these are all consolidated into a table for analysis and plotting. Note 
that the final table contains log10-transformed values and error 
and improvements derived from subtracting these values. Only relevant rat 
values are used. Compounds with Funbound.plasma and partition 
coefficients of zero are removed as well as compounds with approximated 
Funbound.plasma values.

```{r setuppctable, eval=execute.vignette}
pc.table <- NULL
pc.data <- subset(pc.data,fu != 0 & Exp_PC != 0 & Tissue %in% c("Adipose","Bone","Brain","Gut",
    "Heart","Kidney","Liver","Lung","Muscle","Skin","Spleen","Blood Cells") & 
    tolower(Species) == 'rat' & !CAS %in% c('10457-90-6','5786-21-0','17617-23-1','69-23-8','2898-12-6',
    '57562-99-9','59-99-4','2955-38-6','155-97-5','41903-57-5','58-55-9','77-32-7','59-05-2','60-54-8'))
cas.list <- get_cheminfo(model='schmitt',species='rat',suppress.messages=TRUE)
cas.list <-  cas.list[cas.list %in% pc.data[,'CAS']]
ma.data.list <- subset(chem.physical_and_invitro.data,!is.na(logMA))[,'CAS']
for(this.cas in cas.list){
  parameters <- parameterize_schmitt(
    chem.cas=this.cas,
    species='rat',
    suppress.messages=TRUE)
  init.parameters <- parameters
  charge <- calc_ionization(
    chem.cas=this.cas,
    pH=7.4)$fraction_charged
  if(!this.cas %in% ma.data.list){
    init.parameters$MA <- 10^(0.999831 - 0.016578*38.7 + 0.881721 * log10(parameters$Pow))
  }
  pcs <- predict_partitioning_schmitt(
    parameters=parameters,
    species='rat',
    regression=FALSE,
    suppress.messages=TRUE
    )
  init.pcs <- predict_partitioning_schmitt(
    parameters=init.parameters,
    species='rat',
    regression=FALSE,
    suppress.messages=TRUE)
  for(this.tissue in subset(pc.data,CAS==this.cas)[,'Tissue']){
    if(this.tissue == 'Blood Cells') this.pc <- 'rbc'
    else this.pc <- this.tissue
        pc.table <- rbind(pc.table,
                      cbind(
                        as.data.frame(this.cas),
                        as.data.frame(this.tissue),
                        as.data.frame(log10(
                          init.pcs[[which(substr(names(init.pcs),
                            2,
                            nchar(names(init.pcs))-3) == 
                            tolower(this.pc))]] * 
                          init.parameters$Funbound.plasma)),
                        as.data.frame(log10(
                          pcs[[which(substr(names(pcs),
                            2,
                            nchar(names(pcs))-3) == 
                            tolower(this.pc))]] *
                          parameters$unadjusted.Funbound.plasma)),
                        as.data.frame(log10(
                          init.pcs[[which(substr(names(init.pcs),
                            2,
                            nchar(names(init.pcs))-3) == 
                            tolower(this.pc))]] *
                          init.parameters$unadjusted.Funbound.plasma)),
                        as.data.frame(log10(
                          pcs[[which(substr(names(pcs),
                            2,
                            nchar(names(pcs))-3) == tolower(this.pc))]] * 
                            parameters$Funbound.plasma)),
                        as.data.frame(log10(
                          subset(pc.data,
                            CAS==this.cas & Tissue==this.tissue)[,'Exp_PC'])),
                        as.data.frame(subset(pc.data,
                          CAS==this.cas & Tissue==this.tissue)[,'LogP']),
                        as.data.frame(charge),
                        as.data.frame(as.character(subset(pc.data,
                          CAS == this.cas)[1,'A.B.N'])),
                        as.data.frame(subset(pc.data, 
                          CAS == this.cas)[1,'fu'])))
  }
}
colnames(pc.table) <- c('CAS','Tissue',
                        'fup.correction',
                        'ma.correction',
                        'init.Predicted',
                        'Predicted',
                        'Experimental',
                        'logP',
                        'charge',
                        'type',
                        'fup')
init.error <- pc.table[,'Experimental'] - pc.table[,'init.Predicted']
fup.error <- pc.table[,'Experimental'] - pc.table[,'fup.correction']
ma.error <- pc.table[,'Experimental'] - pc.table[,'ma.correction']
final.error <- pc.table[,'Experimental'] - pc.table[,'Predicted']
fup.improvement <- abs(init.error) - abs(fup.error)
ma.improvement <- abs(init.error) - abs(ma.error)
final.improvement <- abs(init.error) - abs(final.error)
pc.table <- cbind(pc.table,fup.improvement,ma.improvement, final.improvement,
                  final.error,init.error,ma.error,fup.error)
```

```{r KpFigures, eval=execute.vignette}
init.plot <- ggplot() + 
  geom_point(data=pc.table,aes(10^(init.Predicted),10^(Experimental))) +
  geom_abline() + 
  labs(y=expression(paste("Measured ",K[p])), 
       x=expression(paste("Predicted ",K[p]))) +
  theme(axis.text=element_text(size=16),axis.title=element_text(size=16),
    plot.title=element_text(size=18,hjust = 0.5)) + 
  scale_x_log10(label=label_log(),limits=c(0.01,10^4.5)) +
  scale_y_log10(label=label_log(),limits=c(0.01,10^4.5)) + 
  ggtitle('(A)')
print(init.plot)
init.stats <- summary(lm(Experimental ~ init.Predicted, 
                         data=pc.table))

final.plot <- ggplot() + 
  geom_point(data=pc.table,aes(10^(Predicted),10^(Experimental))) +
  geom_abline() + 
  labs(y=expression(paste("Measured ",K[p])),
       x=expression(paste("Predicted ",K[p]))) +
  theme(axis.text=element_text(size=16),axis.title=element_text(size=16),
    plot.title=element_text(size=18,hjust=0.5)) +
  scale_x_log10(label=label_log(),limits=c(0.01,10^4.5)) +
  scale_y_log10(label=label_log(),limits=c(0.01,10^4.5)) + 
  ggtitle('(B)')
print(final.plot)
final.stats <- summary(lm(Experimental ~ Predicted, 
                          data=pc.table))

fup.change.plot <-  ggplot() +
  geom_point(data=pc.table[order(pc.table[,'fup.improvement'],decreasing=F),],
    aes(10^(fup.correction),10^(Experimental),color=fup.improvement)) + 
  geom_abline() +
  labs(y=expression(paste("Measured ",K[p])),
       x=expression(paste("Predicted ",K[p])),color='Improvement') +
  theme(axis.text=element_text(size=16),axis.title=element_text(size=16)) +
  scale_x_log10(label=label_log(),limits=c(0.01,10^4.5)) + 
  scale_y_log10(label=label_log(),limits=c(0.01,10^4.5)) +
  scale_color_viridis(direction=-1,option='inferno')
print(fup.change.plot)
fup.stats <- summary(lm(Experimental ~ fup.correction, 
                     data=pc.table))

ma.subset <- subset(pc.table,!CAS %in% ma.data.list)
ma.change.plot <- ggplot() +
    geom_point(data=ma.subset[order(ma.subset[,'ma.improvement']
      ,decreasing=F),], 
      aes(10^(ma.correction),10^(Experimental),color=ma.improvement)) + 
    geom_abline() +
    labs(y=expression(paste("Measured ",K[p])),
      x=expression(paste("Predicted ",K[p])),color='Improvement') +
    theme(axis.text=element_text(size=16),axis.title=element_text(size=16)) +
    scale_x_log10(label=label_log(),limits=c(0.01,10^4.5)) + 
    scale_y_log10(label=label_log(),limits=c(0.01,10^4.5)) +
    scale_color_viridis(direction=-1,option='inferno')
print(ma.change.plot)
ma.stats <- summary(lm(Experimental ~ ma.correction, 
                    data=ma.subset))

fup.table <- data.frame(Test=c("Initial Tissue PC Accuracy","Fup Lipid Correction","Membrane Affinity","Final"),
                           RSquared = signif(c(init.stats$adj.r.squared,
                                         fup.stats$adj.r.squared,
                                         ma.stats$adj.r.squared,
                                         final.stats$adj.r.squared),3),
                           RMSLE = signif(c(mean(init.stats$residuals^2,na.rm=TRUE)^(1/2),
                                     mean(fup.stats$residuals^2,na.rm=TRUE)^(1/2),
                                     mean(ma.stats$residuals^2,na.rm=TRUE)^(1/2),
                                     mean(final.stats$residuals^2,na.rm=TRUE)^(1/2)),3)
                          )
knitr::kable(fup.table)
```
Now we calculate and plot the regressions for all tissues, together with their 95% confidence intervals.

```{r performPCregressions, eval=execute.vignette}
regressions <- NULL

for(tissue in as.character(unique(pc.table[,'Tissue']))){
  fit <- lm(Experimental ~ Predicted ,data=subset(pc.table,Tissue==tissue))
  smry <- summary(fit)
  est <- estimable(fit, cm=diag(2), beta0=c(0,1), joint.test=TRUE)
  regressions <- rbind(regressions,cbind(tissue,as.data.frame(fit$coefficients[['(Intercept)']]),
      as.data.frame(fit$coefficients[['Predicted']]),
      as.data.frame(smry$coefficients[['Predicted','Pr(>|t|)']]),
      as.data.frame(smry$sigma),as.data.frame(smry$r.squared),
      as.data.frame(smry[[11]][1,1]),as.data.frame(smry[[11]][2,2]),
      as.data.frame(smry[[11]][1,2]),as.data.frame(smry$df[2]),as.data.frame(est[[3]])))
}
colnames(regressions) <- c('Tissue','Intercept','Slope','P-value','SE','R-squared',
                           'Int Var','Slp Var','Cov','df','estimable')

for (this.col in 2:10) regressions[,this.col] <- signif(regressions[,this.col], 3)
regressions <- regressions[order(regressions[,1]),]

knitr::kable(regressions, caption = "Table 1: The regressions for each tissue, after fup and membrane affinity adjustments, of the log10-transformed measured Kp regressed on
predicted Kp")

write.table(regressions,
            file=paste0("Pearce2017PCCalibration=",Sys.Date(),".txt"),
            sep="/t",
            row.names=FALSE)
```

```{r PCRegressionFigure, eval=execute.vignette}
x.cf <- seq(-2,3.5,.01)
for(tissue in  as.character(unique(pc.table[,'Tissue'])))
{
  conf <- qt(0.975,df=subset(regressions,Tissue==tissue)[['df']]+1) *
      subset(regressions,Tissue==tissue)[['SE']] *
      sqrt(subset(regressions,Tissue==tissue)[['Int Var']] +
      x.cf^2 * subset(regressions,Tissue==tissue)[['Slp Var']] +
      2 * x.cf * subset(regressions,Tissue==tissue)[['Cov']] + 1)
  line <- subset(regressions,Tissue==tissue)[['Intercept']] +
      x.cf * subset(regressions,Tissue==tissue)[['Slope']]
  y.cf <- line + conf
  y.ncf <- line - conf

  cf <- cbind(as.data.frame(x.cf),as.data.frame(y.cf),as.data.frame(y.ncf))
  if(tissue == 'Blood Cells'){
    eval(parse(text= paste('Blood <- ggplot() + 
                               geom_abline(linetype = "dashed") +
                               geom_point(data=subset(pc.table,Tissue == \'',tissue,'\'),aes(10^(Predicted),
                               10^(Experimental)))  +  theme(axis.text=element_text(size=14),
                               axis.title=element_text(size=14),plot.title=element_text(size=14)) +
                               scale_x_log10(label=label_log(),limits=c(0.01,1000)) + 
                               scale_y_log10(label=label_log(),limits=c(0.01,1000)) +
                               ylab(ifelse(tissue=="Brain",expression(paste("Inferred ",K[p])),"")) +
                               xlab(ifelse(tissue=="Skin", expression(paste("Predicted ",K[p])),"")) +
                               geom_line(data=cf,aes(10^(x.cf),10^(y.cf))) +
                               geom_line(data=cf,aes(10^(x.cf),10^(y.ncf))) +
                               geom_abline(intercept=subset(regressions,Tissue==tissue)[[\'Intercept\']],
                               slope=subset(regressions,Tissue==tissue)[[\'Slope\']]) +
                               ggtitle(\'Red Blood Cells\')',sep='')))
  }else{
    eval(parse(text= paste(tissue,' <- ggplot() + labs(y=expression(paste("Measured ",K[p]))
                               ,x=expression(paste("Predicted ",K[p]))) + geom_abline(linetype = "dashed") +
                               geom_point(data=subset(pc.table,Tissue == \'',tissue,'\'),
                               aes(10^(Predicted),10^(Experimental))) + theme(axis.text=element_text(size=14),
                               axis.title=element_text(size=14),plot.title=element_text(size=14)) +
                               scale_x_log10(label=label_log(),limits=c(0.01,1000)) + 
                               scale_y_log10(label=label_log(),limits=c(0.01,1000)) +
                               ylab(ifelse(tissue=="Brain",expression(paste("Inferred ",K[p])),"")) +
                               xlab(ifelse(tissue=="Skin", expression(paste("Predicted ",K[p])),"")) + 
                               geom_line(data=cf,aes(10^(x.cf),10^(y.cf))) +
                               geom_line(data=cf,aes(10^(x.cf),10^(y.ncf))) +
                               geom_abline(intercept=subset(regressions,Tissue==tissue)[[\'Intercept\']],
                               slope=subset(regressions,Tissue==tissue)[[\'Slope\']]) +
                               ggtitle(\'',tissue,'\')',sep='')))
  }
}

grid.arrange(Adipose, Blood, Bone, Brain, Gut, Heart, Kidney, Liver, Lung, Muscle, Skin, Spleen, nrow=4)
```
In vivo volume of distribution data are compared with the predictions, and 
errors are calculated.  Regressions and improvements are calculated and plotted.

```{r Vdevalaution, eval=execute.vignette}
obach <- subset(Obach2008,CAS %in% get_cheminfo(model='schmitt'))
vd.table <- NULL

for(this.cas in obach[,'CAS']){
  parameters <- parameterize_schmitt(
    chem.cas=this.cas,
    suppress.messages=TRUE)
  init.parameters <- parameters
  if(!this.cas %in% ma.data.list){
    init.parameters$MA <- 10^(0.999831 - 0.016578*37 + 0.881721 * log10(parameters$Pow))
  }
  pcs <- predict_partitioning_schmitt(
    parameters=parameters,
    regression=FALSE,
    suppress.messages=TRUE)
  init.pcs <- predict_partitioning_schmitt(
    parameters=init.parameters,
    regression=FALSE,
    suppress.messages=TRUE)
  reg.pcs <- predict_partitioning_schmitt(
    parameters=parameters,
    regression=TRUE,
    suppress.messages=TRUE)
  vdist <- calc_vdist(
    parameters=c(pcs,Funbound.plasma=parameters$Funbound.plasma),
    suppress.messages=TRUE)
  init.vdist <- calc_vdist(
    parameters=c(
      init.pcs,
      Funbound.plasma=parameters$unadjusted.Funbound.plasma),
    suppress.messages = TRUE)
  reg.vdist <- calc_vdist(
    parameters=c(reg.pcs,Funbound.plasma=parameters$Funbound.plasma),
    suppress.messages = TRUE)
  vd.table <- rbind(
    vd.table,
    cbind(as.data.frame(this.cas),as.data.frame(log10(init.vdist)),
    as.data.frame(log10(vdist)),as.data.frame(log10(reg.vdist)),
    as.data.frame(log10(subset(obach,CAS==this.cas)[['VDss (L/kg)']]))))
}
colnames(vd.table) <- c(
  'CAS',
  'init.vdist',
  'corrected.vdist',
  'calibrated.vdist',
  'Experimental')
init.error <- vd.table[,'Experimental'] - vd.table[,'init.vdist']
correction.error <- vd.table[,'Experimental'] - vd.table[,'corrected.vdist']
calibration.error <- vd.table[,'Experimental'] - vd.table[,'calibrated.vdist']
correction.improvement <- abs(init.error) - abs(correction.error)
calibration.improvement <- abs(correction.error) - abs(calibration.error)
vd.table <- cbind(vd.table,correction.improvement,calibration.improvement,
                  init.error,correction.error,calibration.error)
```

```{r VdistRegressions, eval=execute.vignette}
fit <- lm(Experimental ~ calibrated.vdist,data=vd.table)
smry <- summary(fit)
calibrated.reg <- cbind(as.data.frame(fit$coefficients['(Intercept)']),
                        as.data.frame(fit$coefficients['calibrated.vdist']),
                        as.data.frame(smry$coefficients['calibrated.vdist','Pr(>|t|)']),
                        as.data.frame(smry$sigma),as.data.frame(smry$r.squared))
fit <- lm(Experimental ~ init.vdist,data=vd.table)
smry <- summary(fit)
init.reg <- cbind(as.data.frame(fit$coefficients['(Intercept)']),
                  as.data.frame(fit$coefficients['init.vdist']),
                  as.data.frame(smry$coefficients['init.vdist','Pr(>|t|)']),
                  as.data.frame(smry$sigma),as.data.frame(smry$r.squared))
fit <- lm(Experimental ~ corrected.vdist,data=vd.table)
smry <- summary(fit)
corrected.reg <- cbind(as.data.frame(fit$coefficients['(Intercept)']),
                       as.data.frame(fit$coefficients['corrected.vdist']),
                       as.data.frame(smry$coefficients['corrected.vdist','Pr(>|t|)']),
                       as.data.frame(smry$sigma),as.data.frame(smry$r.squared))
colnames(init.reg) <- colnames(corrected.reg) <-
colnames(calibrated.reg) <- c('Intercept','Slope','P-value','Std Err','R-squared')
```

```{r VdistPlots, eval=execute.vignette}
init.vd.plot <- ggplot(vd.table,aes(10^(init.vdist),10^(Experimental))) + geom_point() +
    geom_abline(intercept = init.reg[['Intercept']], slope = init.reg[["Slope"]]) +
    geom_abline(linetype = "dashed") + xlab("Predicted Volume of Distribution") +
    ylab("Measured Volume of Distribution") + theme(axis.text=element_text(size=16),
    axis.title=element_text(size=16),plot.title=element_text(size=18,hjust = 0.5)) +
    scale_x_log10(label=label_log(),limits=c(10^(-1.5),10^(8.5))) + 
    scale_y_log10(label=label_log(),limits=c(10^(-1.5),10^(8.5))) +
    ggtitle('(A)')
print(init.vd.plot)

correction.plot <- ggplot() +
    geom_point(data=vd.table[order(vd.table[,'correction.improvement'],decreasing=F),],
    aes(10^(corrected.vdist),10^(Experimental),color=correction.improvement)) +
    geom_abline(intercept = corrected.reg[['Intercept']],slope = corrected.reg[["Slope"]]) +
    geom_abline(linetype = "dashed") + xlab("Predicted Volume of Distribution") +
    ylab("Measured Volume of Distribution") + theme(legend.position = c(.95, .95),
    legend.justification = c("right", "top"),legend.box.just = "right",
    legend.margin = margin(6, 6, 6, 6),axis.text=element_text(size=16),
    axis.title=element_text(size=16),plot.title=element_text(size=18,hjust = 0.5)) +
    scale_x_log10(limits=c(10^(-1.5),10^(3))) + scale_y_log10(limits=c(10^(-1.5),10^(3))) +
    ggtitle('(B)') + scale_color_viridis(direction=-1,option='inferno')
print(correction.plot)

calibration.plot <- ggplot() +
    geom_point(data=vd.table[order(vd.table[,'calibration.improvement'],decreasing=F),],
    aes(10^(calibrated.vdist),10^(Experimental),color=calibration.improvement)) +
    geom_abline(intercept = calibrated.reg[['Intercept']],slope = calibrated.reg[["Slope"]]) +
    geom_abline(linetype = "dashed") + xlab("Predicted Volume of Distribution") +
    ylab("Measured Volume of Distribution") + theme(legend.position = c(.95, .95),
    legend.justification = c("right", "top"),legend.box.just = "right",
    legend.margin = margin(6, 6, 6, 6),axis.text=element_text(size=16),
    axis.title=element_text(size=16),plot.title=element_text(size=18,hjust = 0.5)) +
    scale_x_log10(limits=c(10^(-1.5),10^(3))) + scale_y_log10(limits=c(10^(-1.5),10^(3))) +
    ggtitle('(C)') + scale_color_viridis(direction=-1,option='inferno')
print(calibration.plot)
```

Now we pull in the in vivo blood to plasma ratios, use these to calculate the 
inferred red blood cell to plasma ratios, and then make predictions for these 
values.
A censored regressions is performed, and predictions are plotted against errors.

```{r bloodtoplasmaevaluation, eval=execute.vignette}
rb2p.data <- subset(chem.physical_and_invitro.data,!is.na(Human.Rblood2plasma))
measured.rb2p <- NULL
measured.krbc <- NULL
predicted.rb2p <- NULL
predicted.krbc <- NULL
cas <- NULL
charge <- NULL
fup <- NULL
logP <- NULL
pka_donor <- NULL
pka_accept <- NULL
for(this.cas in rb2p.data[rb2p.data[,'CAS'] %in% 
  get_cheminfo(model='schmitt', suppress.messages = TRUE),'CAS'])
{
  rb2p <- get_rblood2plasma(chem.cas=this.cas)
  krbc <- (rb2p + .44 - 1) / 0.44
  measured.rb2p <- c(measured.rb2p,rb2p)
  measured.krbc <- c(measured.krbc,krbc)
  parameters <- parameterize_schmitt(
    chem.cas=this.cas,
    suppress.messages = TRUE)
  pcs <- predict_partitioning_schmitt(
    parameters=parameters,
    suppress.messages=TRUE)
  predicted.krbc <- c(predicted.krbc,pcs[['Krbc2pu']] * parameters$Funbound.plasma)
  cas <- c(cas,this.cas)
  charge <- c(charge,calc_ionization(chem.cas=this.cas,pH=7.4)$fraction_charged)
  fup <- c(fup,parameters$unadjusted.Funbound.plasma)
  logP <-  c(logP,log10(parameters$Pow))
  pka_donor <- c(pka_donor,paste(parameters$pKa_Donor,collapse=','))
  pka_accept <- c(pka_accept,paste(parameters$pKa_Accept,collapse=','))
}
predicted.rb2p <-  1 - 0.44 + 0.44 * predicted.krbc
rb2p.table <- cbind(as.data.frame(cas),as.data.frame(predicted.rb2p),as.data.frame(measured.rb2p))
colnames(rb2p.table) <- c('cas','predicted.rb2p','measured.rb2p')
error <- log10(rb2p.table[,'measured.rb2p']) - log10(rb2p.table[,'predicted.rb2p'])
rb2p.table <- cbind(rb2p.table,error,charge,fup,logP)

error <- log10(measured.krbc) -  log10(predicted.krbc)
krbc.table <- cbind(as.data.frame(cas),as.data.frame(predicted.krbc),as.data.frame(measured.krbc),
                    as.data.frame(error),charge,fup,logP,pka_donor,pka_accept)
```

```{r RBCStats, eval=execute.vignette}
pdta <- data.frame(x = predicted.krbc,
                   y = measured.krbc)
pdta$y[pdta$y <= 0.1] <- 0.1
pdta$Censoring <- factor(c("Not Censored","Censored")[as.numeric(pdta$y <= 0.1) + 1])
y <- measured.krbc
x <- cbind(rep(1, length(y)),-1 * log10(predicted.krbc))
colnames(x) <- c("Intercept","Predicted")
cc <- as.numeric(y <= 0.1)
y[y < 0.1] <- 0.1
y <- -log10(y)

out <- censReg(y~x, data = pdta, left=0.1)
out$betas <- out$estimate
```

```{r RBCFigure, eval=execute.vignette}
censored.regression <- ggplot() +
    geom_point(data=pdta,aes(x=x,y=y, color=Censoring)) +
    scale_x_log10(limits=c(.0009,40)) + scale_y_log10(limits=c(.1,4),breaks=c(.1,.5,2.5)) +
    labs(y=expression(paste("Inferred ",K[p])),x=expression(paste("Predicted ",K[p]))) +
    geom_abline(intercept=0, slope=1, linetype='dashed') +
    theme(axis.text=element_text(size=16),axis.title=element_text(size=16),
    plot.title=element_text(size=18,hjust=0.5),legend.position = c(0.11, .8)) +
    geom_abline(slope=out$betas[2],intercept=-out$betas[1]) + ggtitle('(B)')
print(censored.regression)

rb2p.plot <- ggplot(rb2p.table,aes(predicted.rb2p,measured.rb2p)) +
    geom_point()  + scale_x_log10(lim=c(.52,18)) + 
    scale_y_log10(lim=c(.52,2.5),breaks=c(0.5,1,2)) + geom_abline(linetype='dashed') +
    labs(y=expression(paste("Measured Whole Blood ",K[p])),
    x=expression(paste("Predicted Whole Blood ",K[p]))) +
    theme(axis.text=element_text(size=16),axis.title=element_text(size=16),
    plot.title=element_text(size=18,hjust=0.5)) + ggtitle('(A)')
print(rb2p.plot)
```

Lastly, we make the heatmap.
```{r summarytable, eval=execute.vignette}
heatmap.table <- NULL
for(this.cas in get_cheminfo(model='schmitt')){
    parms <- parameterize_schmitt(
      chem.cas=this.cas,
      suppress.messages = TRUE)
    pcs <- predict_partitioning_schmitt(
      parameters=parms, 
      suppress.messages = TRUE)
    heatmap.table <- cbind(heatmap.table,log10(unlist(pcs)[1:11]*parms$Funbound.plasma))
}
rownames(heatmap.table) <-  c('Adipose','Bone','Brain','Gut','Heart',
                              'Kidney','Liver','Lung','Muscle','Skin','Spleen')
colnames(heatmap.table) <- rep("",dim(heatmap.table)[2])
```

```{r summaryheatmap, eval=execute.vignette}
pal <- function (n, h = c(260, -328), c = 80, l = c(30, 100), power = 1.5,
    fixup = TRUE, gamma = NULL, alpha = 1, ...)
{
    if (!is.null(gamma))
        warning("'gamma' is deprecated and has no effect")
    if (n < 1L)
        return(character(0L))
   h <- rep(h, length.out = 2L)
    c <- c[1L]
    l <- rep(l, length.out = 2L)
    power <- rep(power, length.out = 2L)
    rval <- seq(1, -1, length = n)
    rval <- hex(polarLUV(L = l[2L] - diff(l) * abs(rval)^power[2L],
        C = c * abs(rval)^power[1L], H = ifelse(rval > 0, h[1L],
            h[2L])), fixup = fixup, ...)
    if (!missing(alpha)) {
        alpha <- pmax(pmin(alpha, 1), 0)
        alpha <- format(as.hexmode(round(alpha * 255 + 1e-04)),
            width = 2L, upper.case = TRUE)
        rval <- paste(rval, alpha, sep = "")
    }
    return(rval)
}

hclust.ave <- function(x) hclust(x, method="ward.D2")
heatmap.2(heatmap.table,col=pal,trace="none", hclustfun=hclust.ave,
          key.xlab=expression(paste("log10 ",K[p]," Value")),
          key.ylab=expression(paste("Number of ",K[p])),
          key.title="Partition Coefficient",xlab="Chemicals",cex.lab=2,margins=c(2,5))
```

---
title: "Wambaugh et al. (2019): Uncertainty Monte Carlo"
author: "John F. Wambaugh"
date: "`r Sys.Date()`"
output: rmarkdown::html_vignette
highlight: tango
vignette: >
  %\VignetteIndexEntry{g) Wambaugh (2019): Uncertainty Monte Carlo}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

*Please send questions to John.Wambaugh@UL.org*
 
This vignette provides the code used to generate the figures in Wambaugh et al. (2019) 
"Assessing Toxicokinetic Uncertainty and Variability in Risk Prioritization." 

John F Wambaugh, Barbara A Wetmore, Caroline L Ring, Chantel I Nicolas, 
Robert G Pearce, Gregory S Honda, Roger Dinallo, Derek Angus, Jon Gilbert, 
Teresa Sierra, Akshay Badrinarayanan, Bradley Snodgrass, Adam Brockman, 
Chris Strock, R Woodrow Setzer, Russell S Thomas

Toxicological Sciences, Volume 172, Issue 2, December 2019, Pages 235-251

https://doi.org/10.1093/toxsci/kfz205

## Abstract
High(er) throughput toxicokinetics (HTTK) encompasses in vitro measures of 
key determinants of chemical toxicokinetics and reverse dosimetry 
approaches for *in vitro-in vivo* extrapolation (IVIVE). With HTTK, the 
bioactivity identified by any *in vitro* assay can be converted to human 
equivalent doses and compared with chemical intake estimates. Biological 
variability in HTTK has been previously considered, but the relative 
impact of measurement uncertainty has not. Bayesian methods were 
developed to provide chemical-specific uncertainty estimates for 2 in 
vitro toxicokinetic parameters: unbound fraction in plasma ($f_{up}$) and 
intrinsic hepatic clearance ($Cl_{int}$). New experimental measurements of 
$f_{up}$ and $Cl_{int}$ are reported for 418 and 467 chemicals, respectively. 
These data raise the HTTK chemical coverage of the ToxCast Phase I and II 
libraries to 57%. Although the standard protocol for $Cl_{int}$ was followed, 
a revised protocol for $f_{up}$ measured unbound chemical at 10%, 30%, and 
100% of physiologic plasma protein concentrations, allowing estimation of 
protein binding affinity. This protocol reduced the occurrence of 
chemicals with fup too low to measure from 44% to 9.1%. Uncertainty in 
$f_{up}$ was also reduced, with the median coefficient of variation dropping 
from 0.4 to 0.1. Monte Carlo simulation was used to propagate both 
measurement uncertainty and biological variability into IVIVE. The 
uncertainty propagation techniques used here also allow incorporation of 
other sources of uncertainty such as *in silico* predictors of HTTK 
parameters. These methods have the potential to inform risk-based 
prioritization based on the relationship between in vitro bioactivities 
and exposures.

## HTTK Version

This vignette was created with **httk** v1.10. Although we attempt to maintain 
backward compatibility, if you encounter issues with the latest release of 
**httk**
and cannot easily address the changes, historical versions of httk are 
available from: https://cran.r-project.org/src/contrib/Archive/httk/

## Prepare for session
R package **knitr** generates html and PDF documents from this RMarkdown file,
Each bit of code that follows is known as a "chunk". We start by telling 
**knitr** how we want our chunks to look.
```{r configure_knitr, eval = TRUE}
knitr::opts_chunk$set(collapse = TRUE, comment = '#>', fig.width=5, fig.height=3)
```

### Clear the memory
It is a bad idea to let variables and other information from previous R
sessions float around, so we first remove everything in the R memory.
```{r clear_memory, eval = TRUE}
rm(list=ls()) 
```

### eval = execute.vignette
If you are using the RMarkdown version of this vignette (extension, .RMD) you
will be able to see that several chunks of code in this vignette
have the statement "eval = execute.vignette". The next chunk of code, by default,
sets execute.vignette = FALSE.  This means that the code is included (and necessary) but was
not run when the vignette was built. We do this because some steps require 
extensive computing time and the checks on CRAN limit how long we can spend
building the package. If you want this vignette to work, you must run all code,
either by cutting and pasting it into R. Or, if viewing the .RMD file, you can
either change execute.vignette to TRUE or press "play" (the green arrow) on
each chunk in RStudio.
```{r runchunks, eval = TRUE}
# Set whether or not the following chunks will be executed (run):
execute.vignette <- FALSE
```

### Load the relevant libraries
We use the command 'library()' to load various R packages for our analysis.
If you get the message "Error in library(X) : there is no package called 'X'"
then you will need to install that package: 

From the R command prompt:

install.packages("X")

Or, if using RStudio, look for 'Install Packages' under 'Tools' 
```{r setup, eval = execute.vignette}
library(data.table)
library(httk)
library(httkexamples)
library(ggplot2)
library(stringr)
library(scales)
library(grid)
library(reshape)
```

## Define some needed code:
### RMSE and $R^2$
This returns an expression with 
[root mean squared error](https://en.wikipedia.org/wiki/Root-mean-square_deviation) 
(RMSE) and 
[coefficient of determination](https://en.wikipedia.org/wiki/Coefficient_of_determination) 
$R^2$ for plotting:
```{r lmr2, eval = execute.vignette}
lm_R2 <- function(m,prefix=NULL){
    out <- substitute("RMSE = "~mse*","~~italic(R)^2~"="~r2, 
         list(mse = signif(mean(m$residuals^2)^(1/2),3),
              r2 = format(summary(m)$adj.r.squared, digits = 2)))
    paste(prefix,as.character(as.expression(out)))                 
}
```

### Multiple plot function
From http://www.cookbook-r.com/Graphs/Multiple_graphs_on_one_page_(ggplot2)/
 ggplot objects can be passed in ..., or to plotlist (as a list of ggplot objects)
 - cols:   Number of columns in layout
 - layout: A matrix specifying the layout. If present, 'cols' is ignored.

 If the layout is something like matrix(c(1,2,3,3), nrow=2, byrow=TRUE),
 then plot 1 will go in the upper left, 2 will go in the upper right, and
 3 will go all the way across the bottom.
```{r multi.plot, eval = execute.vignette}
multiplot <- function(..., plotlist=NULL, file, cols=1, layout=NULL, heights=NULL, widths=unit(rep_len(1, cols), "null")) {

  # Make a list from the ... arguments and plotlist
  plots <- c(list(...), plotlist)

  numPlots = length(plots)

  # If layout is NULL, then use 'cols' to determine layout
  if (is.null(layout)) {
    # Make the panel
    # ncol: Number of columns of plots
    # nrow: Number of rows needed, calculated from # of cols
    layout <- matrix(seq(1, cols * ceiling(numPlots/cols)),
                    ncol = cols, nrow = ceiling(numPlots/cols))
  }

 if (numPlots==1) {
    print(plots[[1]])

  } else {
    # Set up the page
    grid.newpage()
    if (!is.null(heights))
    {
      pushViewport(viewport(layout = grid.layout(nrow(layout), ncol(layout),heights=heights,widths=widths)))
    } else {
      pushViewport(viewport(layout = grid.layout(nrow(layout), ncol(layout),widths=widths)))
    }
    # Make each plot, in the correct location
    for (i in 1:numPlots) {
      # Get the i,j matrix positions of the regions that contain this subplot
      matchidx <- as.data.frame(which(layout == i, arr.ind = TRUE))

      print(plots[[i]], vp = viewport(layout.pos.row = matchidx$row,
                                      layout.pos.col = matchidx$col))
    }
  }
}
```

### Calculates the $C_{ss}$ using uncertainty only:
$C_{ss}$ is the steady-state plasma concentration.
```{R cssfun.u, eval = execute.vignette}
cssfun_u <- function(chemcas, 
                      MW, 
                      hepatic.bioavailability, 
                      Fabsgut=1,
                      probs=0.95,
                      minimum.Funbound.plasma=0.0001)
{
  if (chemcas %in% intersect(get_cheminfo(suppress.messages=TRUE,
                                 model="3compartmentss"),
                     get_cheminfo(suppress.messages=TRUE,
                                  model="schmitt")))
  {
  # Create a data table with uncertainty only:
  pop_u_httk <- as.data.table(parameterize_steadystate(chem.cas=chemcas,
    clint.pvalue.threshold=1,
    minimum.Funbound.plasma=0,
                                 suppress.messages=TRUE))
  
  if (!is.na(pop_u_httk[,"Clint.dist"]) &
      !is.na(pop_u_httk[,"Funbound.plasma.dist"]))
  {
  # Get the physico-chemical properties:
  params.schmitt <-parameterize_schmitt(chem.cas=chemcas,
                                 suppress.messages=TRUE)
  psd <- params.schmitt$pKa_Donor
  psa <- params.schmitt$pKa_Accept
  params.schmitt <- params.schmitt[regexpr("pKa",names(params.schmitt))==-1]
  pop_u_httk[,names(params.schmitt):=params.schmitt]
  pop_u_httk[,pKa_Donor := paste(psd, collapse=",")]
  pop_u_httk[,pKa_Accept := paste(psa, collapse=",")]
  pop_u_httk <- pop_u_httk[rep(1,1000)]

  # Calculate the distribution coefficient:
  ions <- calc_ionization(pH=7.4,parameters=pop_u_httk)
  pop_u_httk[,Dow74 := Pow * (ions$fraction_neutral + 
    0.001 * ions$fraction_charged + ions$fraction_zwitter)]
  
  # Parse the Funbound.plasma.dist into quantiles:
  Funbound.plasma.dist <- unlist(pop_u_httk[1,"Funbound.plasma.dist"])
  if (nchar(Funbound.plasma.dist) - 
    nchar(gsub(",","",Funbound.plasma.dist))!=2)
  {
    stop("Funbound.plasma distribution should be three values (median,low95th,high95th) separated by commas.")
  }
  temp <- strsplit(Funbound.plasma.dist,",")
  ppb.median <- as.numeric(temp[[1]][1])
  ppb.low95 <- as.numeric(temp[[1]][2])
  ppb.high95 <- as.numeric(temp[[1]][3])
  
  if (ppb.median>minimum.Funbound.plasma)
  {
    # Use optim to estimate alpha and beta for fup such that the median and 95% 
    # credible interval approximate the estimate from MCMC:
    ppb.fit <- optim(c(2,(1-ppb.median)/ppb.median*2), 
      function(x) (0.95-pbeta(ppb.high95,x[1],x[2])+
      pbeta(ppb.low95,x[1],x[2]))^2+
      (ppb.median-qbeta(0.5,x[1],x[2]))^2,
      method="BFGS")
  # We are drawing new values for the unadjusted Fup:
    pop_u_httk[, unadjusted.Funbound.plasma:=rbeta(1000,
      ppb.fit$par[1],
      ppb.fit$par[2])]
  } else if (ppb.high95>minimum.Funbound.plasma)
  {
    # Assume that since the median is zero but the u95 is not, that there is 
    # an exponential distribution:
    # 97.5% of clearance values will be below Funbound.plasma.u95:
    pop_u_httk[,unadjusted.Funbound.plasma:=runif(1000,
      minimum.Funbound.plasma,
      min(1,minimum.Funbound.plasma+
      2*(ppb.high95-minimum.Funbound.plasma)))]
    pop_u_httk[as.logical(rbinom(1000,1,.95)),
      unadjusted.Funbound.plasma:=minimum.Funbound.plasma] 
  } else {
    pop_u_httk[, unadjusted.Funbound.plasma:=minimum.Funbound.plasma]
  }
  
# then we need to adjust for in vitro binding:
  pop_u_httk[,Flipid:=subset(physiology.data,
    Parameter=='Plasma Effective Neutral Lipid Volume Fraction')[,
    which(colnames(physiology.data) == 'Human')]]
  pop_u_httk[,Funbound.plasma.adjustment:=1 / (Dow74 * Flipid + 
    1 / unadjusted.Funbound.plasma)/unadjusted.Funbound.plasma]
  pop_u_httk[, 
    Funbound.plasma:=unadjusted.Funbound.plasma*Funbound.plasma.adjustment]

# Enforce a minimum ppb:
  pop_u_httk[Funbound.plasma<minimum.Funbound.plasma,
    Funbound.plasma:=minimum.Funbound.plasma]

# If Fup varies, then Rb2p and hepatic bioavailability also vary:
  Rblood2plasma <- get_rblood2plasma(chem.cas=chemcas)
  if (is.na(Rblood2plasma)) 
  {
    pop_u_httk[, Rblood2plasma:=calc_rblood2plasma(parameters=pop_u_httk,
                                 suppress.messages=TRUE)]
  # Right now we don't simulate variability on a known blood:plasma ratio 
  } else pop_u_httk[, Rblood2plasma:=Rblood2plasma] 

  # Parse the clint.dist to retrieve the quantiles:
  Clint.dist <- unlist(pop_u_httk[1,"Clint.dist"])
  if (nchar(Clint.dist) -
    nchar(gsub(",","",Clint.dist))!=3) 
  {
    stop("Clint distribution should be four values (median,low95th,high95th,pValue) separated by commas.")
  }
  temp <- strsplit(Clint.dist,",")
  Clint.median <- as.numeric(temp[[1]][1])
  Clint.low95 <- as.numeric(temp[[1]][2])
  Clint.high95 <- as.numeric(temp[[1]][3])
  Clint.pvalue <- as.numeric(temp[[1]][4])

    # Use optim to estimate mean and standard deviation of Clint such that the 
  # median and 95% credible interval approximate the estimate from MCMC:
  if (Clint.high95>0)
  {
    if (Clint.median>0)
    {
      clint.fit <- optim(c(log(Clint.median),0.3), function(x) 
        (0.95-plnorm(Clint.high95,x[1],x[2])+plnorm(Clint.low95,x[1],x[2]))^2+
        (Clint.median-qlnorm(0.5,x[1],x[2]))^2) 
      pop_u_httk[,Clint:=rlnorm(1000,clint.fit$par[1],clint.fit$par[2])]
    } else {
      pop_u_httk[,Clint:=exp(runif(1000,log(1),
      (log(Clint.high95)-log(1))/0.975))]
    }
  } else pop_u_httk[,Clint:=0]
  pop_u_httk[as.logical(rbinom(1000,1,Clint.pvalue)),Clint:=0] # the Bayesian "p-value" here reflects how often there is no clearance

  pop_u_httk[, CLh:=calc_hep_clearance(chem.cas=chemcas,
    parameters=pop_u_httk,hepatic.model='unscaled',
    suppress.messages=TRUE,clint.pvalue.threshold=1)]
  pop_u_httk[, Qliver:=Qtotal.liverc*BW^0.75]
  pop_u_httk[, hepatic.bioavailability:= Qliver / (Qliver + 
    Funbound.plasma * Clint / Rblood2plasma)]
  pop_u_httk[, (setdiff(names(pop_u_httk), 
    names(httk::parameterize_steadystate(chem.cas=chemcas,
                                 suppress.messages=TRUE)))):=NULL]
 
 
  #compute Css for each individual
  # calc_analytic_css is vectorized so that this will work.
  css <- httk::calc_analytic_css(parameters=pop_u_httk,
                                 clint.pvalue.threshold=1,
                                 daily.dose=1,
                                 clint.pop.cv=NULL,
                                 fup.pop.cv=NULL,
                                 output.units="uM",
                                 model="3compartmentss",
                                 species="Human",
                                 suppress.messages=TRUE)#,
                            #     recalc.blood2plasma=TRUE)
  #get Css95
  cssquants <- quantile(css, probs=probs)
  return(cssquants)
  }
  }
}
```

### This calculates the half-life using uncertainty only:
```{R hlfun.u, eval = execute.vignette}
hlfun_u <- function(chemcas, 
                      MW, 
                      probs=0.95,
                      minimum.Funbound.plasma=0.0001)
{
  if (chemcas %in% intersect(get_cheminfo(suppress.messages=TRUE,
                                 model="3compartmentss"),
                     get_cheminfo(suppress.messages=TRUE,
                                  model="schmitt")))
  {
  # Create a data table with uncertainty only:
  print(chemcas)
  pop_u_httk <- as.data.table(parameterize_steadystate(chem.cas=chemcas,
    clint.pvalue.threshold=1,
    minimum.Funbound.plasma=0,
    suppress.messages=TRUE))
  if (!is.na(pop_u_httk[,"Clint.dist"]) &
      !is.na(pop_u_httk[,"Funbound.plasma.dist"]))
  {
  params.schmitt <-parameterize_schmitt(chem.cas=chemcas,
    suppress.messages=TRUE)
  psd <- params.schmitt$pKa_Donor
  psa <- params.schmitt$pKa_Accept
  params.schmitt <- params.schmitt[regexpr("pKa",names(params.schmitt))==-1]
  pop_u_httk[,names(params.schmitt):=params.schmitt]
  pop_u_httk[,pKa_Donor := paste(psd, collapse=",")]
  pop_u_httk[,pKa_Accept := paste(psa, collapse=",")]
  pop_u_httk <- pop_u_httk[rep(1,1000)]

  ions <- calc_ionization(pH=7.4,parameters=pop_u_httk)
  pop_u_httk[,Dow74 := Pow * (ions$fraction_neutral + 0.001 * ions$fraction_charged + ions$fraction_zwitter)]
  
  # Parse the Funbound.plasma.dist into quantiles:
  Funbound.plasma.dist <- unlist(pop_u_httk[1,"Funbound.plasma.dist"])
  print(paste(chemcas,Funbound.plasma.dist))
  if (nchar(Funbound.plasma.dist) - 
    nchar(gsub(",","",Funbound.plasma.dist))!=2)
  {
    stop("Funbound.plasma distribution should be three values (median,low95th,high95th) separated by commas.")
  }
  temp <- strsplit(Funbound.plasma.dist,",")
  ppb.median <- as.numeric(temp[[1]][1])
  ppb.low95 <- as.numeric(temp[[1]][2])
  ppb.high95 <- as.numeric(temp[[1]][3])
  
  if (ppb.median>minimum.Funbound.plasma)
  {
    # Use optim to estimate alpha and beta for fup such that the median and 95% 
    # credible interval approximate the estimate from MCMC:
    ppb.fit <- optim(c(2,(1-ppb.median)/ppb.median*2), 
      function(x) (0.95-pbeta(ppb.high95,x[1],x[2])+
      pbeta(ppb.low95,x[1],x[2]))^2+
      (ppb.median-qbeta(0.5,x[1],x[2]))^2,
      method="BFGS")
  # We are drawing new values for the unadjusted Fup:
    pop_u_httk[, unadjusted.Funbound.plasma:=rbeta(1000,
      ppb.fit$par[1],
      ppb.fit$par[2])]
  } else if (ppb.high95>minimum.Funbound.plasma)
  {
    # Assume that since the median is zero but the u95 is not, that there is 
    # an exponential distribution:
    # 97.5% of clearance values will be below Funbound.plasma.u95:
    pop_u_httk[, unadjusted.Funbound.plasma:=runif(1000,
      minimum.Funbound.plasma,
      min(1,(ppb.high95-minimum.Funbound.plasma)/0.975))]
    pop_u_httk[as.logical(rbinom(1000,1,.975)),
      unadjusted.Funbound.plasma:=minimum.Funbound.plasma]
  } else {
    pop_u_httk[, unadjusted.Funbound.plasma:=minimum.Funbound.plasma]
  }
  
# then we need to adjust for in vitro binding:
  pop_u_httk[,Flipid:=subset(physiology.data,
    Parameter=='Plasma Effective Neutral Lipid Volume Fraction')[,
    which(colnames(physiology.data) == 'Human')]]
  pop_u_httk[,Funbound.plasma.adjustment:=1 / (Dow74 * Flipid + 
    1 / unadjusted.Funbound.plasma)/unadjusted.Funbound.plasma]
  pop_u_httk[, 
    Funbound.plasma:=unadjusted.Funbound.plasma*Funbound.plasma.adjustment]

# Enforce a minimum ppb:
  pop_u_httk[Funbound.plasma<minimum.Funbound.plasma,
    Funbound.plasma:=minimum.Funbound.plasma]

  Rblood2plasma <- get_rblood2plasma(chem.cas=chemcas)
  if (is.na(Rblood2plasma)) 
  {
    pop_u_httk[, Rblood2plasma:=calc_rblood2plasma(parameters=pop_u_httk,
                                        suppress.messages=TRUE)]
  } else pop_u_httk[, Rblood2plasma:=Rblood2plasma] # Right now we don't simulate variability on a known blood:plasma ratio 
  # Parse the clint.dist to retrieve the quantiles:
  Clint.dist <- unlist(pop_u_httk[1,"Clint.dist"])
  if (nchar(Clint.dist) -
    nchar(gsub(",","",Clint.dist))!=3) 
  {
    stop("Clint distribution should be four values (median,low95th,high95th,pValue) separated by commas.")
  }
  temp <- strsplit(Clint.dist,",")
  Clint.median <- as.numeric(temp[[1]][1])
  Clint.low95 <- as.numeric(temp[[1]][2])
  Clint.high95 <- as.numeric(temp[[1]][3])
  Clint.pvalue <- as.numeric(temp[[1]][4])

    # Use optim to estimate mean and standard deviation of Clint such that the 
  # median and 95% credible interval approximate the estimate from MCMC:
  if (Clint.high95>0)
  {
    if (Clint.median>0)
    {
      clint.fit <- optim(c(log(Clint.median),0.3), function(x) 
        (0.95-plnorm(Clint.high95,x[1],x[2])+plnorm(Clint.low95,x[1],x[2]))^2+
        (Clint.median-qlnorm(0.5,x[1],x[2]))^2) 
      pop_u_httk[,Clint:=rlnorm(1000,clint.fit$par[1],clint.fit$par[2])]
    } else {
      pop_u_httk[,Clint:=exp(runif(1000,log(1),
      (log(Clint.high95)-log(1))/0.975))]
    }
  } else pop_u_httk[,Clint:=0]
  pop_u_httk[as.logical(rbinom(1000,1,Clint.pvalue)),Clint:=0] # the Bayesian "p-value" here reflects how often there is no clearance

  pop_u_httk[, CLh:=calc_hep_clearance(
    chem.cas=chemcas,                                    
    parameters=pop_u_httk,
    hepatic.model='unscaled',
    suppress.messages=TRUE,
    clint.pvalue.threshold=1)]
  pop_u_httk[, Qliver:=Qtotal.liverc*BW^0.75]
  pop_u_httk[, hepatic.bioavailability:= Qliver / (Qliver + Funbound.plasma * Clint / Rblood2plasma)]

  PC.names <- names(predict_partitioning_schmitt(chem.cas="80-05-7",
                                        suppress.messages=TRUE))
  pop_u_httk<-cbind(pop_u_httk,
                    as.data.table(predict_partitioning_schmitt(parameters=pop_u_httk,
                                        suppress.messages=TRUE)))
  pop_u_httk[,hl:=calc_elimination_rate(parameters=pop_u_httk,
                                        suppress.messages=TRUE)]
  
  return(log(2)/quantile(unlist(pop_u_httk[,"hl",with=FALSE]),probs=probs))
  }
  }
}
```

# Figure 1: Histograms depicting the measured values
Histograms depicting the median measured values (**a**, **b**) and 95% credible 
intervals (**c**, **d**) for fraction unbound in plasma ($f_{up}$, **a**, **c**) 
and intrinsic 
hepatic clearance ($Cl_{int}$, **b**, **d**). In **panel a**, the distribution 
of estimated $f_{up}$ 
for the single protein concentration assay (solid line) is compared with the 
protein titration (three concentrations) method (dotted) line. In **panel b**, the 
median estimated $Cl_{int}$ is shown. In **panel c**, the distribution with larger 
credible intervals corresponds to the single protein concentration assay, with 
a median credible interval is 0.1, corresponding to a precision of roughly 
+-0.05. When data from the protein titration are jointly analyzed (smaller 
credible intervals), the certainty is increased to a median credible interval 
of 0.029, or roughly +-0.015. The width of the credible interval is a measure 
of the certainty in an estimate, that is, a smaller credible interval indicates 
greater certainty. For the $f_{up}$ values, a credible interval approaching 1 
indicates that all possible values are consistent with the data, that is, the 
data do not help identify fup since fup must be between 0 and 1. In **panel d** the 
distribution of credible intervals for $Cl_{int}$ is shown.
```{R Wambaugh2019.Fig1, eval = execute.vignette}
Fig1.table <- httkexamples::wambaugh2019.raw
Fig1.table$Error1 <- Fig1.table$Base.Fup.High - Fig1.table$Base.Fup.Low
Fig1.table$Error2 <- Fig1.table$Affinity.Fup.High - Fig1.table$Affinity.Fup.Low
Fig1.table$Sigma1 <- Fig1.table$Error1/(2*qnorm(0.975))
Fig1.table$Mean1 <- (Fig1.table$Base.Fup.High + Fig1.table$Base.Fup.Low)/(qnorm(0.975))
Fig1.table$CV1 <- Fig1.table$Sigma1/Fig1.table$Mean1
Fig1.table$Sigma2 <- Fig1.table$Error2/(2*qnorm(0.975))
Fig1.table$Mean2 <- (Fig1.table$Base.Fup.High + Fig1.table$Base.Fup.Low)/(qnorm(0.975))
Fig1.table$CV2 <- Fig1.table$Sigma2/Fig1.table$Mean2
Fig1.table$ErrorClint <- Fig1.table$CLint.1uM.High95th - Fig1.table$CLint.1uM.Low95th
Fig1.table$SigmaClint <- Fig1.table$ErrorClint/(2*qnorm(0.975))
Fig1.table$MeanClint <- (Fig1.table$CLint.1uM.High95th + Fig1.table$CLint.1uM.Low95th)/(qnorm(0.975))
Fig1.table$CVClint <- Fig1.table$SigmaClint/Fig1.table$MeanClint

Fupmeasured <- subset(Fig1.table,!is.na(Affinity.Fup.Med))
Fupmeasured <- subset(Fupmeasured,!duplicated(CAS))
CLintmeasured <- subset(Fig1.table,!is.na(CLint.1uM.Median))
CLintmeasured <- subset(CLintmeasured,!duplicated(CAS))



print(paste("New HTTK experimental measurements were made for",length(unique(Fig1.table$CAS)),"chemicals from the ToxCast HTS library."))

print(paste("Fup was successfully measured for",length(unique(subset(Fig1.table,!is.na(Affinity.Fup.Med))$CAS)),"chemicals from the ToxCast HTS library."))

print(paste("CLint was successfully measured for",length(unique(subset(Fig1.table,!is.na(CLint.1uM.Median))$CAS)),"chemicals from the ToxCast HTS library."))

                        
                        
                        
Fig1a <- ggplot(Fig1.table)+
   geom_freqpoly(binwidth = 0.5,lwd=1.5,color="Red",aes(Base.Fup.Med))+ 
   geom_freqpoly(binwidth = 0.5,lwd=1.5,lty=3,color="Blue",aes(Affinity.Fup.Med))+ 
  xlab(expression(paste("Measured ",F[up]))) +
  ylab("Number of chemicals")+
   scale_x_log10(label=label_log(),limits=c(10^-6,1.05))+
   labs(title=paste(length(unique(subset(Fig1.table,!is.na(Affinity.Fup.Med))$CAS)),"Chemicals Measured"))+
    theme_bw()+
    theme( text  = element_text(size=10)) +
    annotate("text", x=10^-6,y=80,size=8,label="a")
    
print(paste("Median 100%:",signif(median(Fig1.table$Base.Fup.Med,na.rm=TRUE),2)))
print(paste("Median Titration:",signif(median(Fig1.table$Affinity.Fup.Med,na.rm=TRUE),2)))
   
    

Fig1b <- ggplot(Fig1.table)+
   geom_histogram(binwidth = 0.5,alpha=0.6,fill="green",aes(CLint.1uM.Median))+              
   xlab(expression(paste("Measured ",Cl[int]," (uL/min/",10^6," hepatocytes)"))) +
  ylab("Number of chemicals")+
  scale_x_log10(label=label_log(),limits=c(10^-1,5*10^3))+
  labs(title=paste(length(unique(subset(Fig1.table,!is.na(CLint.1uM.Median))$CAS)),"Chemicals Measured"))+
    theme_bw()+
    theme( text  = element_text(size=10)) +
    annotate("text", x=2*10^-1,y=80,size=8,label="b")
    
print(paste(sum(Fig1.table$CLint.1uM.Median==0,na.rm=TRUE),"Zero Measurments"))
print(paste("Median Non-Zero:",signif(median(Fig1.table$CLint.1uM.Median,na.rm=TRUE),3)))



Fig1c <- ggplot(Fig1.table)+
   geom_histogram(binwidth = 0.1,alpha=0.2,fill="Red",aes(Error1))+ 
   geom_histogram(binwidth = 0.1,alpha=0.2,fill="Blue",aes(Error2))+ 
  xlab("Width of Credible Interval") +
  ylab("Number of chemicals")+
   scale_x_log10(label=label_log(),limits=c(5*10^-4,1.05))+
   labs(title=paste("CI:",signif(median(Fig1.table$Error1,na.rm=TRUE),2),"CV:",signif(median(Fig1.table$CV1,na.rm=TRUE),1),"/ CI:",signif(median(Fig1.table$Error2,na.rm=TRUE),1),"CV:",signif(median(Fig1.table$CV2,na.rm=TRUE),1)))+
    theme_bw()+
    theme( text  = element_text(size=10))+
    annotate("text", x=5*10^-4,y=42,size=8,label="c")
        
print(paste("Median 100% CI:",signif(median(Fig1.table$Error1,na.rm=TRUE),2),"CV:",signif(median(Fig1.table$CV1,na.rm=TRUE),2)))    
print(paste("Median Titr. CI:",signif(median(Fig1.table$Error2,na.rm=TRUE),2),"CV:",signif(median(Fig1.table$CV2,na.rm=TRUE),2)))


Fig1d <- ggplot(Fig1.table)+
   geom_histogram(binwidth = 0.1,alpha=0.6,fill="green",aes(ErrorClint))+ 
  xlab("Width of Credible Interval") +
  ylab("Number of chemicals")+
  scale_x_log10(label=label_log(),limits=c(10^0,10^3))+
   labs(title=paste("Median CI:",signif(median(Fig1.table$ErrorClint,na.rm=TRUE),2),"CV:",signif(median(Fig1.table$CVClint,na.rm=TRUE),2)))+
    theme_bw()+
    theme( text  = element_text(size=10))+
    annotate("text", x=1.5,y=25,size=8,label="d")
        
print(paste("Median CI:",signif(median(Fig1.table$ErrorClint,na.rm=TRUE),2),"CV:",signif(median(Fig1.table$CVClint,na.rm=TRUE),2)))

multiplot(Fig1a,Fig1c,Fig1b,Fig1d,cols=2,widths=c(1.75,1.75))
```

# Figure 2: Distribution of Binding Affinities Employed in Bayesian $f_{up}$ Estimations.  
Distribution of Binding Affinities Employed in Bayesian $f_{up}$ Estimations. 
To jointly analyze the data from the RED assay conducted at three protein 
concentrations, a model for binding to protein with an dissociation constant 
(that is, binding affinity) must be assumed. Although the specific binding protein 
(for example, hemoglobin) and the stoichiometry are unknown, this number 
provides a rough estimate for each chemical of how much that chemical would be 
expected to be impacted by the presence of plasma binding. 
```{R Wambaugh2019.Fig2, eval = execute.vignette}
Fig2.table <- httkexamples::wambaugh2019.raw
print(paste(sum(!is.na(Fig2.table$Fup.point)),"total successful Fup estimates using point estimation."))
print(paste(sum(!is.na(Fig2.table$Base.Fup.Med)),"total successful Fup estimates using BAyesian analysis of top protein concentration."))
Fig2.table$Error1 <- Fig2.table$Base.Fup.High - Fig2.table$Base.Fup.Low
Fig2.table$Error2 <- Fig2.table$Affinity.Fup.High - Fig2.table$Affinity.Fup.Low
Fig2.table$Sigma1 <- Fig2.table$Error1/(2*qnorm(0.975))
Fig2.table$Mean1 <- (Fig2.table$Base.Fup.High + Fig2.table$Base.Fup.Low)/(qnorm(0.975))
Fig2.table$CV1 <- Fig2.table$Sigma1/Fig2.table$Mean1
Fig2.table$Sigma2 <- Fig2.table$Error2/(2*qnorm(0.975))
Fig2.table$Mean2 <- (Fig2.table$Base.Fup.High + Fig2.table$Base.Fup.Low)/(qnorm(0.975))
Fig2.table$CV2 <- Fig2.table$Sigma2/Fig2.table$Mean2
Fig2.table$Point.Estimate <- "Good"                          
Fig2.table[Fig2.table$Fup.point<0&!is.na(Fig2.table$Fup.point),"Point.Estimate"]<-"<0"
Fig2.table[Fig2.table$Fup.point>1&!is.na(Fig2.table$Fup.point),"Point.Estimate"]<-">1"
Fig2.table[is.na(Fig2.table$Fup.point),"Point.Estimate"]<-"No Value"
Fig2.table[Fig2.table$Point.Estimate%in%c("<0","No Value"),"Fup.point"] <-  Fig2.table[Fig2.table$Point.Estimate%in%c("<0","No Value"),"Base.Fup.Med"]
Fig2.table$Uncertain<-"Yes"
Fig2.table[is.na(Fig2.table$CV1),"CV1"] <- -999
Fig2.table[Fig2.table$CV1<0.49,"Uncertain"] <- "No"
Fig2.table[Fig2.table$CV1==-999,"CV1"] <- NA

Fig2a <- ggplot(subset(Fig2.table,!is.na(Base.Fup.Med)),aes(x=Fup.point,y=Base.Fup.Med,shape=Point.Estimate,alpha=Uncertain,colour=Point.Estimate)) +
         geom_point(size=3)+
#         geom_errorbar(aes(ymax = Base.Fup.High, ymin=Base.Fup.Low))+
   scale_y_log10(label=label_log(),limits=c(10^-6,2)) +
   scale_x_log10(label=label_log(),limits=c(10^-6,2)) +
  ylab(expression(paste(F[up]," Bayesian Analysis (Single Conc.)"))) +
  xlab(expression(paste(F[up]," Point Estimate (Traditional Analysis)"))) +
  geom_abline(intercept = 0, slope = 1,linetype="dashed", colour="Blue") +
#  geom_vline(xintercept = 1, size=2,linetype="dashed", colour="red")+
  geom_vline(xintercept = 0.01, size=2,linetype="dotted", colour="red")+
  geom_hline(yintercept = 0.01, size=2,linetype="dotted", colour="red")+
    scale_colour_discrete(name="Point Estimate")+ 
    scale_shape_discrete(name="Point Estimate") +
    scale_alpha_manual(values=c(1,0.3))+
        theme_bw() +
     theme(legend.position="bottom", text  = element_text(size=12))+
     annotate("text", size=8,x = 10^-6, y = 2, label = "a")+
    guides(alpha=guide_legend(nrow=2,byrow=TRUE),colour=guide_legend(nrow=2,byrow=TRUE),shape=guide_legend(nrow=2,byrow=TRUE))

#print(Fig2a)

print(paste(sum(Fig2.table$Uncertain=="Yes"),"uncertain estimates using single conc."))
print(paste(sum(Fig2.table$Point.Estimate=="<0"),"chemicals with negative point estimates."))
print(paste(sum(Fig2.table$Point.Estimate==">1"),"chemicals with Fup > 1."))



summary(lm(data=subset(Fig2.table,!is.na(Fup.point)&Fup.point>0&Base.Fup.Med>0),log(Fup.point)~log(Base.Fup.Med)))




Fig2.table$Uncertain2<-"Yes"
Fig2.table[is.na(Fig2.table$CV2),"CV2"] <- -999
Fig2.table[Fig2.table$CV2<0.49,"Uncertain2"] <- "No"
Fig2.table[Fig2.table$CV2==-999,"CV2"] <- NA
Fig2.table$TopFail <- ""
Fig2.table[!is.na(Fig2.table$Affinity.Fup.Med)&Fig2.table$Uncertain2=="No","TopFail"]<-"No"
Fig2.table[Fig2.table$TopFail=="No"&!is.na(Fig2.table$Base.Fup.Med)&Fig2.table$Uncertain=="Yes","TopFail"]<-"Single Conc. Only"
Fig2.table[!is.na(Fig2.table$Affinity.Fup.Med)&Fig2.table$Uncertain2=="Yes","TopFail"]<-"Yes"
Fig2.table[!is.na(Fig2.table$Affinity.Fup.Med)&is.na(Fig2.table$Base.Fup.Med),"TopFail"] <- "Single Conc. Only"
Fig2.table[is.na(Fig2.table$Base.Fup.Med),"Base.Fup.Med"] <-  Fig2.table[is.na(Fig2.table$Base.Fup.Med),"Affinity.Fup.Med"]


Fig2b <- ggplot(subset(Fig2.table,!is.na(Affinity.Fup.Med)),aes(x=Base.Fup.Med,y=Affinity.Fup.Med,shape=TopFail,alpha=TopFail,colour=TopFail)) +
         geom_point(size=3)+
         geom_point(data=subset(Fig2.table,TopFail=="No"),size=3)+
#         geom_errorbar(aes(ymax = Fup.High.x, ymin=Fup.Low.x))+
#         geom_errorbarh(aes(xmin=Fup.Low.y,xmax=Fup.High.y))+
   scale_y_log10(label=label_log(),limits=c(10^-8,2)) +
   scale_x_log10(label=label_log(),limits=c(10^-8,2)) +
  xlab(expression(paste(F[up]," Bayesian Analysis (Single Conc.)"))) +
  ylab(expression(paste(F[up]," Bayesian Analysis (Three Conc.)"))) +
  geom_abline(intercept = 0, slope = 1,linetype="dashed", colour="Blue")+
  scale_colour_discrete(name="Uncertain")+
  scale_shape_discrete(name="Uncertain") +
#    annotate("text",size=8, x = 10^-4, y = 1, label = "B")+
   scale_alpha_manual(name="Uncertain",values=c(1,0.6,0.3))+
     theme_bw() +
  theme(legend.position="bottom", text  = element_text(size=12))+
      annotate("text", size=8,x = 10^-8, y = 2, label = "b")+
    guides(alpha=guide_legend(nrow=2,byrow=TRUE),colour=guide_legend(nrow=2,byrow=TRUE),shape=guide_legend(nrow=2,byrow=TRUE))
         
#print(Fig2b)

# Need to reduce to unique chemicals.
Fupbaseworked <- subset(Fig2.table,!is.na(Base.Fup.Med)&Uncertain=="No")
Fupbasenot <- subset(Fig2.table,!is.na(Base.Fup.Med)&Uncertain=="Yes")
Fupbaseworked <- subset(Fupbaseworked,!duplicated(CAS))
Fupbasenot <- subset(Fupbasenot,!duplicated(CAS))
# Also need to count a chemical as a success if it worked for either duplicate:
Fupbasenot <- subset(Fupbasenot,!(CAS%in%Fupbaseworked$CAS))

Fupaffinityworked <- subset(Fig2.table,!is.na(Affinity.Fup.Med)&Uncertain2=="No")
Fupaffinitynot <- subset(Fig2.table,!is.na(Affinity.Fup.Med)&Uncertain2=="Yes")
Fupaffinityworked <- subset(Fupaffinityworked,!duplicated(CAS))
Fupaffinitynot <- subset(Fupaffinitynot,!duplicated(CAS))
Fupaffinitynot <- subset(Fupaffinitynot,!(CAS%in%Fupaffinityworked$CAS))


print(paste(dim(Fupbaseworked)[1],"total successful Fup estimates using single conc."))
print(paste(signif(dim(Fupbasenot)[1]/(dim(Fupbaseworked)[1]+dim(Fupbasenot)[1])*100,3),"percent failure rate using single conc."))
print(paste(dim(Fupaffinityworked)[1],"total successful Fup estimates using protein titration."))
print(paste(signif(dim(Fupaffinitynot)[1]/(dim(Fupaffinityworked)[1]+dim(Fupaffinitynot)[1])*100,3),"percent failure rate using protein titration."))
print(paste(dim(Fupbasenot)[1],"uncertain estimates using original protocol."))
print(paste(dim(Fupaffinitynot)[1],"uncertain estimates using protein titration."))
print(paste(dim(Fupaffinityworked)[1]-dim(Fupbaseworked)[1],"chemicals that could not be measured at 100% plasma protein."))

Wetmore.data <- httkexamples:::Wetmore.data
W2015 <- subset(Wetmore.data,Reference=="Wetmore 2015")

W2012 <- subset(Wetmore.data,Reference=="Wetmore 2012")
print(paste("The Fup assay failed for ",signif(sum(W2012$Fub==0.005)/length(W2012$Fub)*100,3),"% of chemicals in {Wetmore, 2012} and ",signif(sum(W2015$Fub==0)/length(W2015$Fub)*100,3),"% of chemicals in {Wetmore, 2015}."))


Fuplod <- subset(Fig2.table,TopFail=="Single Conc. Only")
print(paste("Among the chemicals that were uncertain using the original protocol but could be measured using the new three concentration protocol, the median estimated Fup was ",signif(median(Fuplod$Affinity.Fup.Med),2),"with values as low as ",signif(min(Fuplod$Affinity.Fup.Med),2),"and as high as",signif(max(Fuplod$Affinity.Fup.Med),2),". Previously, a default of 0.005 has been assumed when Fup could not be measured {Rotroff, 2010}.}"))


summary(lm(data=subset(Fig2.table,!is.na(Base.Fup.Med)&Affinity.Fup.Med>0&Base.Fup.Med>0),log(Base.Fup.Med)~log(Affinity.Fup.Med)))

#dev.new(width=10,height=6)
multiplot(Fig2a,Fig2b,cols=2,widths=c(1.75,1.75))
```

# Figure 3: Comparison of Bayesian $f_{up}$ and Uncertainty Estimations to Experimental Point 
Estimates.
Two separate Bayesian analyses were performed: one including only 
those data collected at 100% PPP, and a second that used a binding model to 
relate data collected at 10%, 30%, and 100% PPP. In (**A**), $f_{up}$ point estimates 
<0 are plotted on the y-axis. These values are considered "good" if they lie 
between 0 and 1. The Bayesian median fup values (x-axis) derived from the 100% 
PPP data and the associated uncertainty estimates (vertical lines) were 
correlated with point estimates. Bayesian model estimates were constrained to 
be greater than zero and less than 1;. The red dotted line (at 1%) represents a 
previously assumed generic limit of quantification 
([Wetmore, 2015](https://doi.org/10.1093/toxsci/kfv171); 
[Wetmore, 2012](https://doi.org/10.1093/toxsci/kfr254)).  
In (**B**), the medians from the 
two Bayesian analyses are compared. In both plots, the diagonal dashed line 
indicates the identity line ("perfect predictions"). In both panels the 
Bayesian estimates are "uncertain" (semi-solid) if the CV was larger than 0.5 
and certain (solid) otherwise.
```{R Wambaugh2019.Fig3, eval = execute.vignette}
Fig1.table$Class <- "Other"
Fig1.table[Fig1.table$DTXSID %in% pharma[,1],"Class"]<-"Pharmaceutical"
Fig1.table$Class <- as.factor(Fig1.table$Class)

  Fig3 <- ggplot(Fig1.table,aes(Affinity.Kd.Med,fill=Class))+
    geom_histogram(binwidth = 0.5)+
    xlab(expression(paste("Binding Affinity (", mu,"M)",sep=""))) +
      ylab("Number of chemicals")+
    scale_x_log10(label=label_log())+
      scale_fill_discrete(name="Chemical Class")+
      theme_bw()  +
    theme(legend.position="bottom", text  = element_text(size=18))
      
 # dev.new()
  print(Fig3)
```

# Figure 4: Comparison of Bayesian $Cl_{int}$ and Uncertainty Estimations to Experimental Point Estimates. 
$Cl_{int}$ estimate for 1 uM chemical concentration displayed, 
though 1 and 10 uM were fit jointly. The size of the credible interval varies 
significantly from chemical to chemical, especially for the lower clearance 
rates. Plots of individual fits are provided as supplemental material 
<!-- (https://doi.org/10.5061/dryad.nf40jb4) -->.
```{R Wambaugh2019.Fig4, eval = execute.vignette}
clearance.table <- subset(httkexamples::wambaugh2019.raw,!is.na(CLint.1uM.Median))
    
print(paste(sum(clearance.table$CLint.1uM.Median==0),"zero valued median Bayesian posteriors"))
print(paste(sum(clearance.table$CLint.1uM.Point==0 &
                  clearance.table$CLint.1uM.Median>0,
                na.rm=TRUE),
            "zero valued point estimates where median posterior>0"))
print(paste(sum(clearance.table$CLint.1uM.Point>0 &
                  clearance.table$CLint.1uM.Median==0,
                na.rm=TRUE),
            "zero valued median Bayesian posteriors where point estimate was non-zero"))
print(paste(sum(is.na(clearance.table$CLint.1uM.Point) &
                  clearance.table$CLint.1uM.Median==0,
                na.rm=TRUE),
            "zero valued median Bayesian posteriors where point estimate was NA"))
print(paste(sum(is.na(clearance.table$CLint.1uM.Point) &
                  clearance.table$CLint.1uM.Median>0,
                na.rm=TRUE),
            "non-zero valued median Bayesian posteriors where point estimate was NA"))




clearance.table$Fit <- "Decreasing"
clearance.table[clearance.table$CLint.1uM.Median == 0,"Fit"] <- "Median Zero"
#clearance.table[is.na(clearance.table$CLint.1uM.Point == 0),"Fit"] <- "Point Est. Missing"
for (i in 1:dim(clearance.table)[1])
  if (!is.na(clearance.table[i,"CLint.1uM.Point"]))
  {
    if (clearance.table[i,"CLint.1uM.Point"] == 0) clearance.table[i,"Fit"] <- "Point Est. Zero"
  } else clearance.table[i,"Fit"] <- "Point Est. Failed"
   

set.seed(123456)
clearance.table[is.na(clearance.table$CLint.1uM.Point),"CLint.1uM.Point"]<-runif(sum(is.na(clearance.table$CLint.1uM.Point)),0.1,0.2)
clearance.table[clearance.table$CLint.1uM.Point==0,"CLint.1uM.Point"]<-runif(sum(clearance.table$CLint.1uM.Point==0),0.3,0.8)
clearance.table[clearance.table$CLint.1uM.Low95th==0,"CLint.1uM.Low95th"]<-0.1
clearance.table[clearance.table$CLint.1uM.Median==0,"CLint.1uM.Median"]<-0.1
clearance.table[clearance.table$CLint.1uM.High95th==0,"CLint.1uM.High95th"]<-0.1
clearance.table[clearance.table$CLint.1uM.High95th>1000,"CLint.1uM.High95th"]<-1000
clearance.table[clearance.table$CLint.1uM.Low95th<0.1,"CLint.1uM.Low95th"]<-0.1

clearance.fit <- lm(log10(CLint.1uM.Median)~log10(CLint.1uM.Point),data=subset(clearance.table,!is.na(CLint.1uM.Point)&CLint.1uM.Point>1))
Fig4 <- ggplot(clearance.table, aes(x=CLint.1uM.Point,y=CLint.1uM.Median,colour=Fit)) +
  geom_segment(aes(x=CLint.1uM.Point,xend=CLint.1uM.Point,y=CLint.1uM.Low95th,yend=CLint.1uM.High95th),size=1,alpha=0.5)+
  geom_point(size=3) +
  scale_y_log10(label=label_log(),limits=c(10^-1,1000)) + 
  scale_x_log10(label=label_log(),limits=c(10^-1,1000)) +
  xlab(expression(paste(CL[int]," (",mu,"L/min/",10^{6}," Hep.) Point Estimate",sep="")))+
  ylab(expression(paste(CL[int]," (",mu,"L/min/",10^{6}," Hep.) Bayesian",sep="")))+
  geom_vline(xintercept = 0.25, size=2,colour="black")+
  geom_vline(xintercept = 0.9, size=2,colour="black")+
  geom_abline(intercept = 0, slope = 1,linetype="dashed")+
  scale_colour_discrete(name="Assay Result")+
  theme_bw() +
  theme(legend.position="bottom", text  = element_text(size=14))+
  guides(colour=guide_legend(nrow=2,byrow=TRUE))+
  annotate("text",x = 10^2, y = 10^0,size=6, label = lm_R2(clearance.fit,prefix=""),parse=TRUE)

#dev.new()
print(Fig4)  

summary(clearance.fit)
```

# Figure 5: Uncertainty Assessment for TK Quantities half-life and $C_{ss}$.
The 
impact of uncertainty on estimated values for $f_{up}$ and $Cl_{int}$ could in turn 
affect additional TK quantities, for example elimination half-life ($t_{1/2}$, 
shown in **panel A**) and steady-state serum concentration ($C_{ss}$, shown in **panel B**). 
In both plots, the x-axis indicates the value that would have been estimated 
with previous methods, while the y-axis indicates the median and 95% credible 
interval for values calculated with our Bayesian method. Chemicals plotted with 
triangles are those that could be estimated with the previous, point estimate 
methods, while chemicals plotted with circles could not. The dashed line 
indicates the identity (perfect predictor) line. Chemicals that had no point 
estimate are plotted on the identity line.
```{R Wambaugh2019.Fig5, eval = execute.vignette}
# This section takes a long time because calc_vdist is not yet data.table compatible:
ceetox <- as.data.table(subset(httkexamples::wambaugh2019,
                               !is.na(Human.Funbound.plasma) &
                               !is.na(Human.Clint)&!is.na(logP)))
httk_cas <- ceetox$CAS[ceetox$CAS %in% get_cheminfo(model="3compartmentss",
                                                    suppress.messages=TRUE)]

# back up chem.physical_and_invitro.data:
HTTK.data <- chem.physical_and_invitro.data

# Use the point estimates:
chem.physical_and_invitro.data <- add_chemtable(httkexamples::wambaugh2019.raw,
  current.table=chem.physical_and_invitro.data,
  data.list=list(Compound="Name",
                 CAS="CAS",
                 Clint="CLint.1uM.Point",
                 Funbound.plasma="Fup.point"),
  reference="Wambaugh 2019",
  species="Human",
  overwrite=TRUE)



schmitt_cas <- httk_cas[httk_cas %in% get_cheminfo(model="schmitt",
                                                   suppress.messages=TRUE)]       
ceetox[CAS%in%schmitt_cas,
       hlpoint:=log(2)/httk::calc_elimination_rate(chem.cas=CAS,
                                        suppress.messages=TRUE),
       by=.(CAS)]
       
chem.physical_and_invitro.data <- HTTK.data

ceetox[CAS%in%schmitt_cas,
       hl_975:=hlfun_u(chemcas=CAS, 
                          MW=MW,
                          probs=0.975),
       by=.(CAS)]

ceetox[CAS%in%schmitt_cas,
       hl_med:=hlfun_u(chemcas=CAS, 
                          MW=MW,
                          probs=0.5),
       by=.(CAS)]
       
ceetox[CAS%in%schmitt_cas,
       hl_25:=hlfun_u(chemcas=CAS, 
                         MW=MW,
                          probs=0.025),
       by=.(CAS)]

ceetox[,hlpointEstimated:=TRUE]
ceetox[is.na(hlpoint),hlpointEstimated:=FALSE]
ceetox[is.na(hlpoint),hlpoint:=hl_med]
```

```{R Wambaugh2019.Fig6, eval = execute.vignette}
set.seed(42)
ceetox[CAS%in%httk_cas,
       css95_uv:=calc_mc_css(chem.cas=CAS,
                                # clint.pvalue.threshold=1, #Don't need to use p-values here (Bayesian)
                                 output.units="uM",
                                 model="3compartmentss",
                                 species="Human",
                                        suppress.messages=TRUE),
       by=.(CAS)]
      
set.seed(42)
ceetox[CAS%in%httk_cas,    
       css95_v:=calc_mc_css(chem.cas=CAS,
                                 #clint.pvalue.threshold=1, #Don't need to use p-values here (Bayesian)
                                 output.units="uM",
                                 invitro.mc.arg.list=list(
                                   clint.meas.cv=NULL,
                                   fup.meas.cv=NULL,
                                   clint.pop.cv=0.3,
                                   fup.pop.cv=0.3
                                 ),
                                 model="3compartmentss",
                                 species="Human",
                                        suppress.messages=TRUE),
       by=.(CAS)]


       
set.seed(42)
ceetox[CAS%in%httk_cas, 
       css95_u:=cssfun_u(chemcas=CAS, 
                          MW=MW),
       by=.(CAS)]

set.seed(42)
ceetox[CAS%in%httk_cas, 
       cssmed_u:=cssfun_u(chemcas=CAS, 
                          MW=MW,
                          probs=0.5),
       by=.(CAS)]
       
set.seed(42)       
ceetox[CAS%in%httk_cas, 
       css25_u:=cssfun_u(chemcas=CAS, 
                          MW=MW,
                          probs=0.025),
       by=.(CAS)]
       
set.seed(42)       
ceetox[CAS%in%httk_cas, 
       css975_u:=cssfun_u(chemcas=CAS, 
                          MW=MW,
                          probs=0.975),
       by=.(CAS)]
       
ceetox[CAS%in%httk_cas, 
       cssmed:=httk::calc_analytic_css(chem.cas=CAS,
                                 clint.pvalue.threshold=1,
                                 output.units="uM",
                                 model="3compartmentss",
                                 species="Human",
                                 suppress.messages=TRUE),
       by=.(CAS)]
```


```{R Wambaugh2019.Fig5.2, eval = execute.vignette}
hlfit <- lm(data=subset(ceetox,hlpointEstimated &
                          !is.na(log10(hlpoint)) &
                          !is.na(log10(hl_med)) &
                          !is.infinite(log10(hl_med))),
            log10(hlpoint)~log10(hl_med))
Fig5a <- ggplot(data=subset(ceetox,hlpointEstimated),aes(x=hlpoint,y=hl_med)) +
  geom_point(size=3,alpha=0.5) +
  geom_errorbar(aes(ymax = hl_975, ymin=hl_25),alpha=0.3)+
  scale_y_log10(label=label_log(),limits=c(1,10^6)) +
  scale_x_log10(label=label_log(),limits=c(1,10^6)) +
  xlab("half-life (h) Point Estimate")+
  ylab("Bayesian half-life (h)")+
  geom_abline(intercept = 0, slope = 1,linetype="dashed",color="blue")+
  annotate("text", size=8,x = 1, y = 10^6, label = "A")+
  theme_bw() +
  theme(text  = element_text(size=18))+
  annotate("text",x = 3*10^3, y = 10^0,size=5, label = lm_R2(hlfit,prefix=""),parse=TRUE) 


cssfit <- lm(data=subset(ceetox,
                         !is.na(log10(cssmed)) &
                         !is.na(log10(cssmed_u)) &
                         !is.infinite(log10(cssmed_u))),
             log10(cssmed)~log10(cssmed_u))
Fig5b <- ggplot(data=ceetox,aes(x=cssmed,y=cssmed_u)) +
  geom_point(size=3,alpha=0.5) +
  geom_errorbar(aes(ymin=css25_u,ymax=css975_u),alpha=0.3)+
  scale_y_log10(label=label_log(),limits=c(10^-3,10^5)) +
  scale_x_log10(label=label_log(),limits=c(10^-3,10^5)) +
  xlab(expression(paste(C[ss]," Point Estimate (uM)")))+
  ylab(expression(paste("Bayesian ",C[ss]," (uM)")))+
  annotate("text", size=8,x = 10^-3, y = 10^5, label = "B")+
  theme_bw() +
  theme(text  = element_text(size=18)) +
  geom_abline(intercept = 0, slope = 1,linetype="dashed",color="blue")+
  annotate("text",x = 10^2, y = 10^-3,size=5, label = lm_R2(cssfit,prefix=""),parse=TRUE)  


#dev.new(width=8,height=5)
multiplot(Fig5a,Fig5b,cols=2,widths=c(1.75,1.75))
```

# Figure 6: Relative contributions of uncertainty and variability 
Here we examine the telative contributions of uncertainty and variability to 
differences between the 95th percentile and median $C_{ss}$. Monte Carlo 
analysis of both variability (triangles) and uncertainty (circles) give 
distributions that can be characterized by a 95th percentile $C_{ss}$ for which 
individuals achieve a higher $C_{ss}$ for the same fixed dose rate -- these 
individuals can be considered more "sensitive" to chemical exposure. Uncertainty 
and variability can be combined (squares) to estimate a 95th percentile 
reflecting both factors. For most chemicals, variability contributes more than 
uncertainty to the difference between the $C_{ss}$ predicted for the median 
$Cl_{int}$ and $f_{up}$ values. 
```{R Wambaugh2019.Fig6.2, eval = execute.vignette}
# Go back to Bayes estimates:
chem.physical_and_invitro.data <- HTTK.data

dt_melt <- data.table::melt(ceetox[, .(Compound, CAS, css95_u, css95_v, css95_uv, cssmed)],
                            id.vars=c("Compound","CAS", "cssmed"),
                            variable.name="type",
                            value.name="css95")

dt_melt[, type:=gsub(x=type, pattern="css95_uv", replacement="Both", fixed=TRUE)]
dt_melt[, type:=gsub(x=type, pattern="css95_u", replacement="Uncertainty", fixed=TRUE)]
dt_melt[, type:=gsub(x=type, pattern="css95_v", replacement="Variability", fixed=TRUE)]


#now set the factor levels explicitly
dt_melt[, type:=factor(type,
                       levels=c("Uncertainty", "Variability", "Both"))]


dt_melt[, Norm:=css95/cssmed]


#now set the factor levels explicitly
dt_melt[, Compound:=factor(Compound,
                       levels=dt_melt[type=="Both",Compound][order(dt_melt[type=="Both",Norm])])]
                       
                       
Fig6 <- ggplot(data=dt_melt) +
  geom_point(size=2,alpha=0.7,aes(x=Compound,
                y=Norm,
                color=type,
                shape=type)) +
   scale_y_log10(label=label_log(),limits=c(0.9,500)) +
  ylab(expression(paste("Ratio of ",C[ss]," ",95^th," Percentile to Median Estimate"))) +
  xlab("Chemicals")+
  scale_colour_discrete(name=expression(paste(C[ss]," Varied to Reflect")))+ 
  scale_shape_discrete(name=expression(paste(C[ss]," Varied to Reflect"))) +
  theme_bw() +
  theme(legend.position="bottom",axis.text.x = element_blank())+
  annotate("text", size=8,x = levels(dt_melt$Compound)[length(unique(dt_melt$Compound))/2], y = 400, label = paste("Median Ratio for Uncertainty:",signif(median(subset(dt_melt,type=="Uncertainty")$Norm),3)))+
  annotate("text", size=8,x = levels(dt_melt$Compound)[length(unique(dt_melt$Compound))/2], y = 200, label = paste("Median Ratio for Variability:",signif(median(subset(dt_melt,type=="Variability")$Norm),3)))+
  annotate("text", size=8,x = levels(dt_melt$Compound)[length(unique(dt_melt$Compound))/2], y = 100, label = paste("Median Ratio for Both:",signif(median(subset(dt_melt,type=="Both")$Norm),3)))
    
#dev.new(width=10,height=6)  
print(Fig6)
```

# Figure 7: High throughput risk-based prioritization 
High throughput risk-based prioritization can be conducted by using doses 
predicted to cause bioactivity identified by high-throughput screening. High 
throughput exposure estimates have large uncertainty, indicated by the 
triangles (median of distribution) and vertical bar (upper 95th percentile 
range). There are many *in vitro* activities identified for each 
chemical, the 80% interval of equivalent dose rates is indicated by the 
vertical red bar, with a horizontal slash indicating the median and the circle 
plot points indicating the 10th percentile of the bioactive concentration. 
Anywhere the entire exposure bar is below the bioactivity circle there is 95% 
probability that the median exposure will not cause a dose sufficient to cause 
the 10th percentile *in vitro* bioactivity. Chemicals are sorted from 
left-to-right by the margin between the 10th percentile bioactivity 
(small circle) and the upper 95th percentile limit on estimated median intake 
rate. In **panel A**, all chemicals for which $C_{ss}$ could be calculated are shown 
using only variability. In **panel B**, the shaded region of **panel A** is shown, 
using both variability and uncertainty to calculate the bioactive dose. Arrows 
in **panel B** identify six chemicals where exposure and 10th percentile 
bioactivity potentially overlap that would have been missed as priority 
chemicals if uncertainty analysis was not performed. Two overlapping bars are 
shown for each chemical''s bioactive doses -- the upper one is for variability 
alone (as in **Panel A**), the lower is for uncertainty and variability together.
```{R Wambaugh2019.Fig7,  eval = execute.vignette}
# Head to ftp://newftp.epa.gov/COMPTOX/High_Throughput_Screening_Data/Previous_Data/ToxCast_Data_Release_Oct_2015/ to get the ToxCast/Tox21 data:
# These are the concentrations that caused activity in exess of the background (ACC) "hits".
# 
# # Load the ACC table into an object Tox21.acc:
# Tox21.acc <- read.csv("INVITRODB_V2_LEVEL5/EXPORT_LVL5&6_ASID7_TOX21_151020.csv",stringsAsFactors=FALSE)
# # Subset to the chemicals of interest:
# Tox21.acc <- subset(Tox21.acc,casn%in%Fig1.table$CAS)
# # We only need hits:
# Tox21.acc <- subset(Tox21.acc,hitc==1)
# 
# # Pare this down to just the data we need:
# Tox21.acc <- Tox21.acc[,c("code","chid","chnm","casn","aenm","modl_acc","flags")]
# 
# # In this vignette we use the precalculated quantiles of the ACC's 
# # to help keep the HTTK package smaller:
# 
# wambaugh2019.tox21 <- NULL
# for (this.chem in sort(unique(Tox21.acc$casn)))
# {
#   this.subset <- subset(Tox21.acc,casn==this.chem)
#   this.row <- data.frame(casn=this.chem,
#     med.conc = 
#       median(10^(this.subset$modl_acc)),
#     q10.conc = 
#       quantile(10^(this.subset$modl_acc),0.1),
#     low.conc = 
#       min(10^(this.subset$modl_acc)),
#     q90.conc = 
#       quantile(10^(this.subset$modl_acc),0.9),
#     high.conc = 
#       max(10^(this.subset$modl_acc)),
#     stringsAsFactors = F)
#   wambaugh2019.tox21  <- rbind(wambaugh2019.tox21, this.row)
# }

chem.preds <- httkexamples::wambaugh2019.seem3
directnhanes.preds <- httkexamples::wambaugh2019.nhanes
Tox21.acc.numeric <- httkexamples::wambaugh2019.tox21

#Subset to those chemicals with HTS hits:
human.hits <- subset(ceetox,CAS%in%Tox21.acc.numeric$casn)

# Now calculate the oral equivalent dose for each chemical:
# Must make sure that CSS is in units of uM!!
for (this.chem in human.hits$CAS)
{
  med.conc <-
    Tox21.acc.numeric[Tox21.acc.numeric$casn==this.chem,"med.conc"] 
  q10.conc <-
    Tox21.acc.numeric[Tox21.acc.numeric$casn==this.chem,"q10.conc"]
  low.conc <-
    Tox21.acc.numeric[Tox21.acc.numeric$casn==this.chem,"low.conc"]
  q90.conc <-
    Tox21.acc.numeric[Tox21.acc.numeric$casn==this.chem,"q90.conc"]
  high.conc <-
    Tox21.acc.numeric[Tox21.acc.numeric$casn==this.chem,"high.conc"] 
  css95.v <- human.hits[human.hits$CAS==this.chem][["css95_v"]]
  css95.uv <- human.hits[human.hits$CAS==this.chem][["css95_uv"]]
  human.hits[human.hits$CAS==this.chem,"HTS.Median.ACC"] <- med.conc
  human.hits[human.hits$CAS==this.chem,"HTS.Q10.ACC"] <- q10.conc
  human.hits[human.hits$CAS==this.chem,"HTS.Q90.ACC"] <- q90.conc
  human.hits[human.hits$CAS==this.chem,"HTS.Low.ACC"] <- low.conc
  human.hits[human.hits$CAS==this.chem,"HTS.High.ACC"] <- high.conc
  human.hits[human.hits$CAS==this.chem,"HTS.Median.equivdose.v"] <- med.conc/css95.v
  human.hits[human.hits$CAS==this.chem,"HTS.Q10.equivdose.v"] <- q10.conc/css95.v
  human.hits[human.hits$CAS==this.chem,"HTS.Q90.equivdose.v"] <- q90.conc/css95.v
  human.hits[human.hits$CAS==this.chem,"HTS.Low.equivdose.v"] <- low.conc/css95.v
  human.hits[human.hits$CAS==this.chem,"HTS.High.equivdose.v"] <- high.conc/css95.v
  human.hits[human.hits$CAS==this.chem,"HTS.Median.equivdose.uv"] <- med.conc/css95.uv
  human.hits[human.hits$CAS==this.chem,"HTS.Q10.equivdose.uv"] <- q10.conc/css95.uv
  human.hits[human.hits$CAS==this.chem,"HTS.Q90.equivdose.uv"] <- q90.conc/css95.uv
  human.hits[human.hits$CAS==this.chem,"HTS.Low.equivdose.uv"] <- low.conc/css95.uv
  human.hits[human.hits$CAS==this.chem,"HTS.High.equivdose.uv"] <- high.conc/css95.uv
}  



#Add the exposure predictions:
for (this.chem in human.hits$CAS)
{
  print(this.chem)
# If we have direct inferrences from NHANES, use those exposures:
  if (this.chem %in% directnhanes.preds$CASRN)
  {
    human.hits[human.hits$CAS==this.chem,"Exposure.median"] <- directnhanes.preds[directnhanes.preds$CASRN==this.chem,"lP"]
    human.hits[human.hits$CAS==this.chem,"Exposure.high"] <- directnhanes.preds[directnhanes.preds$CASRN==this.chem,"lP.max"]
# Otherwise use the heuristics model (Wambaugh 2014):    
  } else if (this.chem %in% chem.preds$CAS) {
    human.hits[human.hits$CAS==this.chem,"Exposure.median"] <- chem.preds[chem.preds$CAS==this.chem,"seem3"]
    human.hits[human.hits$CAS==this.chem,"Exposure.high"] <- chem.preds[chem.preds$CAS==this.chem,"seem3.u95"]  
  }
}

# Drop chemicals without exposure predictions:
human.hits<- subset(human.hits,!is.na(Exposure.median))


# This code puts the chemicals into order by margin between exposure and activity:
chem.names <- unique(human.hits$Compound)
chem.names <- chem.names[!is.na(chem.names)]
potency <- rep(Inf,times=length(chem.names))
names(potency) <- chem.names
potency.u <- potency
for (this.chem in chem.names)
{
  this.subset <- subset(human.hits,Compound==this.chem)
  if (dim(this.subset)[1]>0)
  {
    potency[this.chem] <- this.subset$HTS.Q10.equivdose.v/this.subset$Exposure.high
    potency.u[this.chem] <- this.subset$HTS.Q10.equivdose.uv/this.subset$Exposure.high
  }
}
potency <- sort(potency)
human.hits$Compound <- factor(human.hits$Compound, levels=names(potency))

potency.u <- potency.u[names(potency.u)[potency.u<1]]
if (any(names(potency)[potency>1] %in% names(potency.u)))
{
  potency.u <- potency.u[names(potency)[potency>1]]

new.overlaps <- names(potency.u[!is.na(potency.u)])
first.change <- new.overlaps[1]
last.change <- new.overlaps[length(new.overlaps)]
window.start <- names(potency)[which(names(potency)==first.change)-5]
window.end <- names(potency)[which(names(potency)==last.change)+5]
window.names <- names(potency)[(which(names(potency)==first.change)-5):(which(names(potency)==last.change)+5)]
# Initialize a new plot:
Fig7a <- ggplot(data=human.hits) +
  geom_segment(aes(x=Compound,xend=Compound,y=HTS.Q10.equivdose.v,yend=HTS.Q90.equivdose.v),size=1,color="white",alpha=0.5) + 
  geom_rect(mapping=aes(xmin=window.start,xmax=window.end,ymin=10^-9,ymax=10^3),color="grey",alpha=0.5)+
  geom_segment(aes(x=Compound,xend=Compound,y=HTS.Q10.equivdose.v,yend=HTS.Q90.equivdose.v),size=1,color="red",alpha=0.5) + 
  geom_point(aes(x=Compound,y=HTS.Median.equivdose.v),shape=3) +
  geom_point(aes(x=Compound,y=HTS.Q10.equivdose.v)) +
  theme_bw() +
  theme(axis.text.x = element_blank()) + 
  theme(axis.title.x = element_text(size=16)) + 
  theme(axis.title.y = element_text(size=16)) + 
  scale_y_log10(label=label_log(),limits = c(10^-9,10^3)) + 
  geom_segment(aes(x=Compound,xend=Compound,y=Exposure.high,yend=Exposure.median),size=1,color="blue",alpha=0.5) + 
  geom_point(aes(x=Compound,y=Exposure.median),shape=2) + 
  ylab("Bioactive Dose & Exposure\nmg/kg BW/day\n(Variability Only)") + 
  xlab("Chemicals Ranked By Ratio Between Bioactive Dose and Exposure")+
  annotate("text", size=8,x = names(potency)[10], y = 100, label = "a")

# Initialize a new plot:
Fig7c <- ggplot() +
  geom_segment(data=human.hits,aes(x=Compound,xend=Compound,y=HTS.Q10.equivdose.v,yend=HTS.Q90.equivdose.v),size=3,color="grey") + 
  geom_segment(data=human.hits,aes(x=Compound,xend=Compound,y=HTS.Q10.equivdose.uv,yend=HTS.Q90.equivdose.uv),size=3,color="red",alpha=0.5) + 
  geom_point(data=human.hits,aes(x=Compound,y=HTS.Median.equivdose.uv),shape=3,size=2) +
  geom_point(data=human.hits,aes(x=Compound,y=HTS.Q10.equivdose.uv),size=2) +
  theme_bw() +
  theme(axis.text.x = element_text(angle = 60, hjust = 1,size=6)) + 
  theme(axis.text.x = element_blank()) + 
  theme(axis.title.x = element_text(size=16)) + 
  theme(axis.title.y = element_text(size=16)) + 
  xlim(window.names) +
  scale_y_log10(label=label_log(),limits = c(10^-8,2*10^2)) + 
  geom_segment(data=human.hits,aes(x=Compound,xend=Compound,y=Exposure.high,yend=Exposure.median),size=3,color="blue",alpha=0.5) + 
  geom_segment(data=subset(human.hits,Compound%in%names(potency.u)),aes(x=Compound,xend=Compound,y=10^-8,yend=Exposure.median/1.5),size=2,arrow=arrow(length=unit(0.5,"cm")))+
  geom_point(data=human.hits,aes(x=Compound,y=Exposure.median),shape=2,size=2) + 
  xlab("") + 
  ylab("Bioactive Dose & Exposure\nmg/kg BW/day\n(Uncertainty and Variability)") + 
  annotate("text", size=8,x = window.names[1], y = 100, label = "b")
 

#print(Fig10b)
#dev.new(width=10,height=6)
multiplot(Fig7a,Fig7c,cols=1,heights=c(0.5,0.5))

write.csv(subset(human.hits,Exposure.high>HTS.Q10.equivdose.uv)[,c("Compound","DSSTox_Substance_Id","Human.Clint","Human.Funbound.plasma","HTS.Q10.ACC","HTS.Q10.equivdose.v","HTS.Q10.equivdose.uv","Exposure.high")],file=paste("SupTable5-",Sys.Date(),".txt",sep=""),row.names=FALSE)
}
```

# Final statistics:
```{R calc.stats,  eval = execute.vignette}
Wetmore.chems <- subset(chem.physical_and_invitro.data,regexpr("Wetmore",Human.Clint.Reference)!=-1)[,c("Compound","CAS","DTXSID","Formula")]
Wetmore.chems <- subset(Wetmore.chems,CAS%in%get_cheminfo())

for (this.cas in Wetmore.chems$CAS)
{
  Wetmore.chems[Wetmore.chems$CAS==this.cas,"Css.Lit"] <- get_lit_css(
    chem.cas=this.cas,
    output.units="uM")
  set.seed(42)
  Wetmore.chems[Wetmore.chems$CAS==this.cas,"Css.v192"] <- calc_mc_css(
    chem.cas=this.cas,
    invitro.mc.arg.list=list(
      fup.meas.cv=NULL,
      clint.meas.cv=NULL,
      fup.censored.dist=TRUE),
    output.units="uM")
  set.seed(42)
  Wetmore.chems[Wetmore.chems$CAS==this.cas,"Css.v110"] <- calc_mc_css(
    chem.cas=this.cas,
    output.units="uM")
}

median(Wetmore.chems$Css.v110/Wetmore.chems$Css.Lit,na.rm=TRUE)

ceetox$Human.Clint2 <- sapply(as.character(ceetox$Human.Clint),
                              function(x) as.numeric(strsplit(x,",")[[1]][1]))
ceetox$Human.Fup2 <- sapply(as.character(ceetox$Human.Funbound.plasma),
                            function(x) as.numeric(strsplit(x,",")[[1]][1]))
write.csv(ceetox[,c(1,2,8,9,16,17,6,7,12,30,10,11,15,31,13,14,18:28)],row.names=FALSE,file=paste("Supplemental-Table4-",Sys.Date(),".txt",sep=""))

print(paste("Complete HTTK data on",sum(get_cheminfo()%in%ceetox$CAS),"new chemicals."))
```

---
title: "Characterizing Accuracy of Model Predictions for Chemical
Concentration in High Throughput Screening Assays"
author: "Meredith Scherer, Madison Feshuk, James M. Armitage, Jon A. Arnot, 
David Crizer, Michael Devito, Stephen S. Ferguson, Kimberly Freeman, 
Gregory S. Honda, Josh Harrill, Alessandro Sangion, Caroline Tebes-Stevens, 
Katie Paul Friedman, John F. Wambaugh"
date: "`r Sys.Date()`"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{m) Scherer (Submitted): In Vitro Distribution}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---
*Please send questions to John.Wambaugh@UL.org*

from "Characterizing Accuracy of Model Predictions for Chemical 
Concentration in High Throughput Screening Assays"

Meredith Scherer, Madison Feshuk, James M. Armitage, Jon A. Arnot, 
David Crizer, Michael Devito, Stephen S. Ferguson, Kimberly Freeman, 
Gregory S. Honda, Josh Harrill, Alessandro Sangion, Caroline Tebes-Stevens, 
Katie Paul Friedman, John F. Wambaugh

## Abstract

The aim of in vitro - in vivo extrapolation (IVIVE) of dose is to predict 
potential whole animal effects from perturbations observed in vitro. Reliance 
on nominal (administered) concentration (assumed dose) does not account for 
chemical distribution to cellular and non-cellular elements of an in vitro 
assay system. Chemical distribution can reduce the free concentration 
available to cause effects and can result in an inaccurate estimate of the 
intracellular concentration causing any observed perturbations. There are 
mathematical, chemical property-based partitioning models for predicting 
cellular concentrations when not measured experimentally. This work evaluated 
two of these in vitro disposition models, Armitage et al., 2021 and Kramer et 
al., 2010, using a total of 153 experimental intracellular concentration 
measurements of 43 chemicals, along with parameters describing measurement 
conditions, from 12 peer reviewed studies in addition to data generated for 
this study. Intracellular concentrations were more accurately predicted by 
both the Armitage model (root mean squared log10 error (RMSLE) = 1.12) and the 
Kramer model (RMSLE = 1.30) than by the nominal concentration (RMSLE = 1.45). 
Although limited by the amount of available measurement data, these results 
indicate that mathematical modeling of in vitro distribution can improve the 
accuracy of IVIVE for toxicology.

## HTTK Version 

This vignette was created with **httk** v2.X.0. Although we attempt to maintain 
backward compatibility, if you encounter issues with the latest release of 
**httk**
and cannot easily address the changes, historical versions of httk are 
available from: https://cran.r-project.org/src/contrib/Archive/httk/

## Prepare for session
R package **knitr** generates html and PDF documents from this RMarkdown file,
Each bit of code that follows is known as a "chunk". We start by telling 
**knitr** how we want our chunks to look.
```{r configure_knitr, eval = TRUE}
knitr::opts_chunk$set(collapse = TRUE, comment = '#>')
options(rmarkdown.html_vignette.check_title = FALSE)
```

### Clear the memory
It is a bad idea to let variables and other information from previous R
sessions float around, so we first remove everything in the R memory.
```{r clear_memory, eval = TRUE}
rm(list=ls()) 
```

### eval = execute.vignette
If you are using the RMarkdown version of this vignette (extension, .RMD) you
will be able to see that several chunks of code in this vignette
have the statement "eval = execute.vignette". The next chunk of code, by 
default, sets execute.vignette = FALSE.  This means that the code is included 
(and necessary) but was not run when the vignette was built. We do this because 
some steps require extensive computing time and the checks on CRAN limit how 
long we can spend building the package. If you want this vignette to work, 
you must run all code, either by cutting and pasting it into R. Or, if viewing 
the .RMD file, you can either change execute.vignette to TRUE or press "play" 
(the green arrow) on each chunk in RStudio.
```{r runchunks, eval = TRUE}
# Set whether or not the following chunks will be executed (run):
execute.vignette <- FALSE
```

### Load the relevant libraries
We use the command 'library()' to load various R packages for our analysis.
If you get the message "Error in library(X) : there is no package called 'X'"
then you will need to install that package: 

From the R command prompt:

install.packages("X")

Or, if using RStudio, look for 'Install Packages' under 'Tools' tab.
```{r load_packages, eval = execute.vignette}
#
#
# Setup
#
#
library(httk)        # run Armitage.R and Kramer.R in vitro distribution models
library(tidyverse)   # data wrangling
library(data.table)  # data table functionality
library(ggplot2)     # plotting
library(ggrepel)     # jitter labels in plots
library(ggpubr)      # arrange plots for publication
library(viridis)     # colorblind palette
library(scales)      # required for label_log

#save figures and tables to working directory: yes/no
save_output = FALSE

#for saving outputs
data.date <- "16JUL2025"
path_out <- "C:/Users/mscherer/OneDrive - Environmental Protection Agency (EPA)
/Profile/Desktop/IVDManuscriptData/manuscript figures 16JUL25/"

```

```{r rmsle_func, eval = execute.vignette}
#function to calculate RMSLE
sle <- function (actual, predicted) 
{
    log.act <- log10(actual)
    log.pred <- log10(predicted)
    good <- !is.na(log.act) & is.finite(log.act) &
            !is.na(log.pred) & is.finite(log.pred)
    log.act <- log.act[good]
    log.pred <- log.pred[good]
    return((log.act - log.pred)^2)
}
msle <- function (actual, predicted) 
{
    mean(sle(actual, predicted))
}
rmsle <-function (actual, predicted) 
{
    sqrt(msle(actual, predicted))
}
```

# Data Collection

Data sets were curated from the literature and combined with two in house 
experiments to evaluate the in vitro distribution models. 

# Load and format the data
```{r load_IVD_Manuscript_data, eval = execute.vignette}

IVD_Manuscript_data <- httk::Scherer2025.IVD

cat(paste("Summarized data from ", 
          length(unique(IVD_Manuscript_data$Citation)),
          " studies covering ", 
          length(unique(IVD_Manuscript_data$ChemicalName)),
          " unique chemicals ", 
          "with ",
          length(IVD_Manuscript_data$CellConcentration_uM),
          " observations total.",
          sep="")
    )

#14 studies, 43 chemicals, 153 observations

#number each row
IVD_Manuscript_data[,X:=1:length(IVD_Manuscript_data$ChemicalName)]

```

#In vitro assay descriptors (optional step)
In vitro assay descriptors for the measurements in Supplemental Materials 
Table S2 were added as additional assays into 
httk:invitro.assay.params using the AENM “IVD” + Author + Year 
(that is, Smith et al. (2000) would be AENM “IVDSmith2000”.
```{r invitrodescriptors, eval = execute.vignette}

### Create assay_component_endpoint_name columns for assay parameters ###

#create assay_name column
IVD_Manuscript_data[, assay_name := 
                      gsub(", ", "", IVD_Manuscript_data$Citation)]

#create the assay_component_endpoint_name column
IVD_Manuscript_data[, assay_component_endpoint_name := 
                      paste("IVD", gsub(", ", "", assay_name), sep="")]

#tack on the "interesting" part for each assay to create the endpoint_name 
IVD_Manuscript_data[assay_component_endpoint_name=="IVDBellwon2015b" |
                      assay_component_endpoint_name == "IVDBroeders2013" |
                      assay_component_endpoint_name == "IVDWei2010",
                    assay_component_endpoint_name := 
                      paste(assay_component_endpoint_name, CellType, sep="_")]
#these two have multiple concentrations or time points
IVD_Manuscript_data[assay_component_endpoint_name=="IVDMundy2004" |
                      assay_component_endpoint_name=="IVDLundquist2014",
                assay_component_endpoint_name := 
                  paste(paste(assay_component_endpoint_name, 
                              paste(ExposureDuration_hrs, "hr", sep = ""), 
                              sep="_"), paste(FBSf, "FBSf", sep = ""), 
                        sep = "_")]

#create a copy with the assay parameters for the options table (Table S7)
options.IVD_Manuscript_data<-data.table::copy(IVD_Manuscript_data)

### Pull in httk assay parameter table ###
invitro.assay.params <- data.table::copy(invitro.assay.params)

#copy the experimental data frame to pull out the parameter lines
parameters_only<-data.table::copy(IVD_Manuscript_data)

### Set up assay parameters to match with invitro.assay.params.RData ###

#rename columns to align with the names in invitro.assay.params.RData
parameters_only[, timepoint_hr := ExposureDuration_hrs] %>%
  .[, media_serum := SerumType] %>%
  .[, cell_type := CellType] 

# get the list of columns we need
ivpnames<-names(invitro.assay.params)

#add on the extra columns to match invitro.assay.params and parameters_only
if(!all(ivpnames%in%names(parameters_only))){
    parameters_only[,ivpnames[!(ivpnames %in% names(parameters_only))]] <- 
      as.double(NA)}

#filter parameters_only to match up with ivpnames and only the unique rows
parameters_only<-parameters_only %>% select(as.character(ivpnames)) %>% unique()

# reassign own parameters table to pass to armitage and kramer functions
user_assay_parameters<-parameters_only
# should have 29 + 1649 = 1678 rows

#remove parameter columns since we will be pulling from "user_assay_parameters"
ivpnames[2]<-NA #remove endpoint_name bc we need to be able to reference it
IVD_Manuscript_data[,ivpnames[(ivpnames %in% names(IVD_Manuscript_data))]]<- 
  NULL

```


# Run the in vitro distribution models
```{r run_IVD_models, eval = execute.vignette}

# run Armitage model, output concentrations in umol/L (e.g. uM)
armitageOutput_data.dt <- armitage_eval(tcdata=IVD_Manuscript_data,
                                       surface.area.switch = TRUE,
                                       user_assay_parameters = 
                                         user_assay_parameters,
                                       restrict.ion.partitioning = TRUE)



# run Kramer model, output concentrations in umol/L (e.g. uM)
kramerOutput_data.dt <- kramer_eval(tcdata=IVD_Manuscript_data, 
                                    surface.area.switch = TRUE,
                                    user_assay_parameters = 
                                      user_assay_parameters,
                                    restrict.ion.partitioning = TRUE)

```

# Manipulate data and prep for plotting
```{r manipulate_for_plotting, eval = execute.vignette}

#delete nomconc column
Armitage.dt<-subset(armitageOutput_data.dt, select=-c(nomconc))

#pull ioc types from armitage since kramer doesn't generate them
IOC_Type_output<-Armitage.dt[,.(ChemicalName, IOC_Type)] %>% distinct()

#delete nomconc column and add in the IOC type column for Kramer
Kramer.dt_subset<-subset(kramerOutput_data.dt, select=-c(nomconc))
Kramer.dt<-Kramer.dt_subset[IOC_Type_output, on = "ChemicalName"]

#delete cellconc column and add in the IOC type column for Nominal
Nominal.dt_subset<-subset(kramerOutput_data.dt, 
                          select = -c(concentration_cells))
Nominal.dt<-Nominal.dt_subset[IOC_Type_output, on = "ChemicalName"]

#add tags
Armitage.dt[,label:= "Armitage"]
Kramer.dt[,label:= "Kramer"]
Nominal.dt[,label:= "Nominal"]

#combine data for plotting (datasets are side by side)
combodata<-merge(Armitage.dt, kramerOutput_data.dt, by = "X", all.x = TRUE) 
  #kramer output still has nomconc values 

if(save_output){
  write.csv(combodata, file = paste0(path_out,"ManuscriptOutput_",
                                     data.date,"_",Sys.Date(),".csv"))
}

```

```{r ggplot_set_up, eval = execute.vignette}

#set default theme elements for visually consistent manuscript plots
personal_theme <- function(){ 
  theme_bw() +
  theme(axis.line = element_blank(),
        panel.border = element_rect(colour = "black", linewidth=1),
        axis.title = element_text(size = rel(1.25)),
        axis.text = element_text(size = rel(1.15)),
        plot.title = element_text(size = rel(1.5),
                                  hjust = 0.5),
        panel.grid = element_blank(),
        legend.position = "none") 
}

#set plot colors to correspond with each chemica
plotcolors<-scales::viridis_pal()(length(
  unique(armitageOutput_data.dt$ChemicalName)))
names(plotcolors)<-armitageOutput_data.dt$ChemicalName %>% unique() %>% sort()

```

# Main Paper Plots:

## Figure 1: 
In Vitro Distribution Diagram (no code)

## Figure 2: 
Predicted and experimental intracellular concentrations from the 
Cnominal (left panel), Armitage (middle panel), and Kramer (right panel) models.
Dashed line shows unity.
```{r joint_intracel_plot_fig2, eval = execute.vignette}

#ARMITAGE:

#Armitage RMSLE:
arm_rmsle_long<-rmsle((Armitage.dt$CellConcentration_uM),(Armitage.dt$ccells))
arm_rmsle<-round(arm_rmsle_long, 2)
#1.12

#Armitage r^2:
ml_arm_overall = lm(CellConcentration_uM~ccells, data = Armitage.dt)
summary(ml_arm_overall)$r.squared 
#0.33

#plot set up
yrng <- range(Armitage.dt$CellConcentration_uM)
xrng <- range(Armitage.dt$ccells)
n_chems<-n_distinct(Nominal.dt$ChemicalName)
n_data<-nrow(Nominal.dt)

# now plot
Armitage_ccell<-ggplot(Armitage.dt) +
  geom_point(aes(x=ccells, y=CellConcentration_uM, color = ChemicalName)) +
  geom_abline(intercept=0,slope=1, linetype = "dashed") +
  xlab(expression("Armitage Predicted "*italic("C"["cell"])~"(\u03BCM)")) +
  ylab(expression("Experimental "*italic(" C"["cell"])~"(\u03BCM)")) +
  scale_x_log10(lim = c(0.00001, 400000), breaks = c(10^-4, 10^0, 10^4), 
                labels = label_log(digits = 2)) +
  scale_y_log10(lim = c(0.00001, 400000), breaks = c(10^-4, 10^0, 10^4), 
                labels = label_log(digits = 2)) +
  annotate(geom = "text", x = xrng[2], y = yrng[1], parse=TRUE, label = paste(
      "N[data] ", "~'='~", n_data), hjust = 1, vjust = 0, size = 4) +
  annotate(geom = "text", x = xrng[2], y = yrng[1], parse=TRUE, label = paste(
      "N[chemicals] ", "~'='~", n_chems), hjust = 1, vjust = 1.2, size = 4)+
  annotate(geom = "text", x = xrng[2], y = yrng[1], 
           label = paste("RMSLE =", arm_rmsle), 
           hjust = 1, vjust = 3, size = 4) +
  personal_theme() +
  scale_color_manual(values=plotcolors)

#KRAMER:

#Kramer RMSLE:
kram_rmsle_long<-
  rmsle((Kramer.dt$CellConcentration_uM),(Kramer.dt$concentration_cells))
kram_rmsle<-format(round(kram_rmsle_long, digits=2), nsmall = 2) 
#1.30

#Kramer r^2:
ml_kram_overall = lm(CellConcentration_uM~concentration_cells, data = Kramer.dt)
summary(ml_kram_overall)$r.squared 
#0.03

#plot
Kramer_ccell<-ggplot(Kramer.dt)+
  geom_point(aes(x=concentration_cells, y=CellConcentration_uM, 
                 colour = ChemicalName)) + 
  geom_abline(intercept=0,slope=1, linetype = "dashed") +
  scale_x_log10(lim = c(0.00001, 400000), breaks = c(10^-4, 10^0, 10^4), 
                labels = label_log(digits = 2)) +
  scale_y_log10(lim = c(0.00001, 400000), breaks = c(10^-4, 10^0, 10^4), 
                labels = label_log(digits = 2)) +
  xlab(expression("Kramer Predicted "*italic("C"["cell"])~"(\u03BCM)")) +
  ylab(expression("Experimental "*italic(" C"["cell"])~"(\u03BCM)")) +
  annotate(geom = "text", x = xrng[2], y = yrng[1], parse=TRUE, label = paste(
      "N[data] ", "~'='~", n_data), hjust = 1, vjust = 0, size = 4) +
  annotate(geom = "text", x = xrng[2], y = yrng[1], parse=TRUE, label = paste(
      "N[chemicals] ", "~'='~", n_chems), hjust = 1, vjust = 1.2, size = 4)+
  annotate(geom = "text", x = xrng[2], y = yrng[1], 
  label = paste("RMSLE =", kram_rmsle), hjust = 1, vjust = 3, size = 4) +
  personal_theme() +
  scale_color_manual(values=plotcolors)

#NOMINAL:

#Nominal RMSLE:
nom_rmsle_long<-rmsle((Nominal.dt$CellConcentration_uM),(Nominal.dt$nomconc))
nom_rmsle<-round(nom_rmsle_long, 2)
#1.45

Nominal_ccell<-ggplot(Nominal.dt) +
  geom_point(aes(x=nomconc, y=CellConcentration_uM, colour = ChemicalName))+
  geom_abline(intercept=0,slope=1, linetype = "dashed") +
  scale_x_log10(lim = c(0.00001, 400000), breaks = c(10^-4, 10^0, 10^4), 
                labels = label_log(digits = 2)) +
  scale_y_log10(lim = c(0.00001, 400000), breaks = c(10^-4, 10^0, 10^4), 
                labels = label_log(digits = 2)) +
  xlab(expression(italic("C"["nominal"])~"(\u03BCM)")) +
  ylab(expression("Experimental "~italic("C"["cell"])~"(\u03BCM)")) +
  labs(colour = "Chemical")+
  annotate(geom = "text", x = xrng[2], y = yrng[1], parse=TRUE, label = paste(
      "N[data] ", "~'='~", n_data), hjust = 1, vjust = 0, size = 4) +
  annotate(geom = "text", x = xrng[2], y = yrng[1], parse=TRUE, label = paste(
      "N[chemicals] ", "~'='~", n_chems), hjust = 1, vjust = 1.2, size = 4) +
  annotate(geom = "text", x = xrng[2], y = yrng[1], 
           label = paste("RMSLE =", nom_rmsle), 
           hjust = 1, vjust = 3, size = 4) +
  personal_theme() +
  theme(legend.position = "bottom",
        legend.key.size = unit(2, 'mm'),
        legend.spacing = unit(10, "pt"))+
        # legend.text = element_text(size = 8))+
  guides(col = guide_legend(ncol = 5)) +
  scale_color_manual(values=plotcolors)

#Combine the three plots w RMSLE
Ccells_comboplot<-ggarrange(Nominal_ccell, Armitage_ccell, Kramer_ccell, 
                            ncol=3 , legend = "bottom", common.legend = TRUE)

#save
if(save_output){
  ggsave(file = paste0("Figure2_",data.date,"_",Sys.Date(),".png"),
         path = path_out,
         Ccells_comboplot, width = 10, height = 5.5, dpi = 300)
}

print(Ccells_comboplot)

```

## Figure 3: 
Predicted and experimental intracellular concentrations from the Armitage 
(left panel) and Kramer (right panel) models for the ten chemicals with 
multiple observations. Solid lines connect multiple measurements for a 
single chemical. The dashed line shows unity. 
```{r multiobs_intracel_plot_fig3, eval = execute.vignette}

#Armitage.multobs.dt %>% count(ChemicalName, NominalDose_uM, Citation)
#some of these have super close nomconcs because they are experimentally 
#measured - not really relevant for this comparison because they are replicates
#chemicals to remove:
#Hexachlorobenzene, Malathion, Pentachlorophenol, Propiconazole 
#(all of the chemicals from Stadnicka, 2014)

multiObsChemnameList<-Armitage.dt %>% 
  dplyr::filter(Citation != "Stadnicka, 2014") %>% 
  count(ChemicalName, NominalDose_uM) %>% 
  count(ChemicalName) %>% dplyr::filter(n>=2) %>% 
  select(ChemicalName) %>% distinct()
#10 chemicals with multiple nominal doses measured

#filter measured data to just these chemicals
Armitage.multobs.dt_og <- Armitage.dt %>% 
  dplyr::filter(ChemicalName %in% multiObsChemnameList$ChemicalName)

Kramer.multobs.dt_og <- Kramer.dt %>% 
  dplyr::filter(ChemicalName %in% multiObsChemnameList$ChemicalName)

Nominal.multobs.dt_og <- Nominal.dt %>% 
  dplyr::filter(ChemicalName %in% multiObsChemnameList$ChemicalName)
#each have 89 observations

#merge the lines with multiple observations for the same nomconc (ie tox21)
Armitage.multobs.dt<-Armitage.multobs.dt_og %>% 
  group_by(ChemicalName, NominalDose_uM) %>% 
  mutate(mean_measuredccell = mean(CellConcentration_uM),
         mean_predictedccell = mean(ccells)) %>% 
  select(ChemicalName, NominalDose_uM, mean_measuredccell, 
         mean_predictedccell) %>% distinct()

Kramer.multobs.dt<-Kramer.multobs.dt_og %>% 
  group_by(ChemicalName, NominalDose_uM) %>% 
  mutate(mean_measuredccell = mean(CellConcentration_uM),
         mean_predictedccell = mean(concentration_cells)) %>% 
  select(ChemicalName, NominalDose_uM, mean_measuredccell, 
         mean_predictedccell) %>% distinct()

Nominal.multobs.dt<-Nominal.multobs.dt_og %>% 
  group_by(ChemicalName, NominalDose_uM) %>% 
  mutate(mean_measuredccell = mean(CellConcentration_uM),
         mean_predictedccell = mean(NominalDose_uM)) %>% 
  select(ChemicalName, NominalDose_uM, mean_measuredccell, 
         mean_predictedccell) %>% distinct()
#down to 50 observations because the duplicates have been averaged

### Plotting ###

#plot set up
yrng_mult <- range(Armitage.multobs.dt$mean_measuredccell)
xrng_mult <- range(Armitage.multobs.dt$mean_predictedccell)
n_chems_mult<-n_distinct(Armitage.multobs.dt$ChemicalName)
n_data_mult<-nrow(Armitage.multobs.dt)

#ARMITAGE

#Armitage RMSLE:
arm_mult_rmsle_long<-rmsle((Armitage.multobs.dt$mean_measuredccell),
                           (Armitage.multobs.dt$mean_predictedccell))
arm_mult_rmsle<-round(arm_mult_rmsle_long, 2)
#1.27

#r squared 
ml_arm <- lm(mean_measuredccell~mean_predictedccell, data = Armitage.multobs.dt)
rsq_armitage_mult <- summary(ml_arm)$r.squared
#0.87

# now plot
Armitage_ccell_mult<-ggplot(Armitage.multobs.dt) +
  geom_point(aes(mean_predictedccell, mean_measuredccell, 
                 colour = ChemicalName)) +
  geom_smooth(aes(mean_predictedccell, mean_measuredccell, 
                  colour = ChemicalName), method=lm, se = FALSE) +
  geom_abline(intercept=0,slope=1, linetype = "dashed") +
  scale_x_log10(lim = c(0.0001, 400000), breaks = c(10^-4, 10^0, 10^4), 
                labels = label_log(digits = 2)) +
  scale_y_log10(lim = c(0.0001, 400000), breaks = c(10^-4, 10^0, 10^4), 
                labels = label_log(digits = 2)) +
  xlab(expression("Armitage Predicted "*italic("C"["cell"])~"(\u03BCM)")) +
  ylab(expression("Experimental "*italic(" C"["cell"])~"(\u03BCM)")) +
  labs(colour = "Chemical")+
  annotate(geom = "text", x = xrng_mult[2], y = yrng_mult[1],
           parse=TRUE,
           label = paste("N[data] ", "~'='~", n_data_mult), 
           hjust = 1, vjust = 0, size = 4) +
  annotate(geom = "text", x = xrng_mult[2], y = yrng_mult[1], 
           parse=TRUE,
           label = paste("N[chemicals] ", "~'='~", n_chems_mult), 
           hjust = 1, vjust = 1.2, size = 4)+
  annotate(geom = "text", x = xrng_mult[2], y = yrng_mult[1], 
  label = paste("RMSLE =", arm_mult_rmsle), hjust = 1, vjust = 3, size = 4) +
  personal_theme()  +
  scale_color_manual(values=plotcolors)

#KRAMER

#Kramer RMSLE:
kram_mult_rmsle_long<-rmsle((Kramer.multobs.dt$mean_measuredccell),
                            (Kramer.multobs.dt$mean_predictedccell))
kram_mult_rmsle<-round(kram_mult_rmsle_long, 2)
# 1.58

#r squared 
ml_kram <- lm(mean_measuredccell~mean_predictedccell, data = Kramer.multobs.dt)
rsq_kramer_mult <- summary(ml_kram)$r.squared
#0.87

# now plot
Kramer_ccell_mult<-ggplot(Kramer.multobs.dt) +
  geom_point(aes(mean_predictedccell, mean_measuredccell, 
                 colour = ChemicalName)) +
  geom_smooth(aes(mean_predictedccell, mean_measuredccell, 
                  colour = ChemicalName), method=lm, se = FALSE) +
  geom_abline(intercept=0,slope=1, linetype = "dashed") +
  scale_x_log10(lim = c(0.0001, 400000), breaks = c(10^-4, 10^0, 10^4), 
                labels = label_log(digits = 2)) +
  scale_y_log10(lim = c(0.0001, 400000), breaks = c(10^-4, 10^0, 10^4), 
                labels = label_log(digits = 2)) +
  xlab(expression("Kramer Predicted "*italic("C"["cell"])~"(\u03BCM)")) +
  ylab(expression("Experimental "*italic(" C"["cell"])~"(\u03BCM)")) +
  labs(colour = "Chemical")+
  annotate(geom = "text", x = xrng_mult[2], y = yrng_mult[1],
           parse=TRUE,
           label = paste("N[data] ", "~'='~", n_data_mult), 
           hjust = 1, vjust = 0, size = 4) +
  annotate(geom = "text", x = xrng_mult[2], y = yrng_mult[1],
           parse=TRUE,
           label = paste("N[chemicals] ", "~'='~", n_chems_mult), 
           hjust = 1, vjust = 1.2, size = 4) +
  annotate(geom = "text", x = xrng_mult[2], y = yrng_mult[1], 
  label = paste("RMSLE =", kram_mult_rmsle), hjust = 1, vjust = 3, size = 4) +
  personal_theme()  +
  scale_color_manual(values=plotcolors) +
  theme(legend.key.size = unit(2, 'mm'),
        legend.text = element_text(size = 6))


#arrange
Ccells_comboplot_mult<-ggarrange(Armitage_ccell_mult, Kramer_ccell_mult, ncol=2,
                                 legend = "bottom", common.legend = TRUE)

if(save_output){
  ggsave(file = paste0("Figure3_",data.date,"_",Sys.Date(),".png"),
         path = path_out,
         Ccells_comboplot_mult, width = 8, height = 4, dpi = 300)
}

print(Ccells_comboplot_mult)

```

## Figure 4: 
Chemical partitioning into medium, air, cell, and plastic compartments for 
the Armitage and Kramer models. Dashed line shows unity.
```{r chemicalPart_intracel_plot_fig4, eval = execute.vignette}

#Cwat_uM -------- Cwat_R
Cwater_comparison<-ggplot(combodata) +
  geom_point(aes(concentration_medium, cwat_s, colour = ChemicalName.x)) +
  geom_abline(intercept=0,slope=1, linetype = "dashed") +
  ggtitle("Medium Concentration") +
  xlab(expression("Kramer Predicted "*italic("C"["medium"])~"(\u03BCM)")) +
  ylab(expression("Armitage Predicted "*italic(" C"["medium"])~"(\u03BCM)")) +
  scale_x_log10(labels = label_log(digits = 2)) +
  scale_y_log10(labels = label_log(digits = 2)) +
  personal_theme() +
  scale_color_manual(values=plotcolors)

#Cair_uM -------- Cair_R
Cair_comparison<-ggplot(combodata) +
  geom_point(aes(concentration_air, cair, colour = ChemicalName.x)) +
  geom_abline(intercept=0,slope=1, linetype = "dashed") +
  ggtitle("Air Concentration") +
  xlab(expression("Kramer Predicted "*italic("C"["air"])~"(\u03BCM)")) +
  ylab(expression("Armitage Predicted "*italic(" C"["air"])~"(\u03BCM)")) +
  scale_x_log10(labels = label_log(digits = 2)) +
  scale_y_log10(labels = label_log(digits = 2)) +
  personal_theme() +
  scale_color_manual(values=plotcolors)

#C_cells_uM ----- Ccells
Ccells_comparison<-ggplot(combodata) +
  geom_point(aes(concentration_cells, ccells, colour = ChemicalName.x)) +
  geom_abline(intercept=0,slope=1, linetype = "dashed") +
  ggtitle("Cell Concentration") +
  xlab(expression("Kramer Predicted "*italic("C"["cell"])~"(\u03BCM)")) +
  ylab(expression("Armitage Predicted "*italic(" C"["cell"])~"(\u03BCM)")) +
  scale_x_log10(lim = c(10^-4, 10^5), labels = label_log(digits = 2), 
                breaks = c(10^-2, 10^0, 10^2, 10^4)) +
  scale_y_log10(lim = c(10^-4, 10^5), labels = label_log(digits = 2), 
                breaks = c(10^-2, 10^0, 10^2, 10^4)) +
  personal_theme() +
  scale_color_manual(values=plotcolors)

#Aplastic_uM_m2 - (Cplastic_R / Sarea_R)
Aplastic_comparison<-ggplot(combodata) +
  geom_point(aes(concentration_plastic, cplastic, colour = ChemicalName.x)) +
  geom_abline(intercept=0,slope=1, linetype = "dashed") +
  ggtitle("Plastic Concentration") +
  xlab(expression("Kramer Predicted "*italic("C"["plastic"])~"(\u03BCM)")) +
  ylab(expression("Armitage Predicted "*italic(" C"["plastic"])~"(\u03BCM)")) +
  labs(colour = "Chemical")+
  scale_x_log10(labels = label_log(digits = 2), 
                breaks = c(10^-6, 10^-4, 10^-2, 10^0)) +
  scale_y_log10(labels = label_log(digits = 2)) +
  personal_theme() +
  scale_color_manual(values=plotcolors) +
  theme(legend.key.size = unit(1, 'mm'),
        legend.spacing = unit(2, "pt"),
        legend.text = element_text(size = 6))


compartment_plots<-ggarrange(Ccells_comparison, Aplastic_comparison, 
                             Cwater_comparison, Cair_comparison, 
                             common.legend = TRUE, legend = "none")

if(save_output){
  ggsave(file = paste0("Figure4_",data.date,"_",Sys.Date(),".png"),
         path = path_out,
         compartment_plots, width = 8, height = 6, dpi= 300)
}

print(compartment_plots)

```

## Figure 5:
Change in per-chemical RMSLE for predicted and experimental intracellular 
concentrations from the Armitage model with predictions made using batch 
downloaded physico-chemical property predictions from OPERA and ChemAxon or 
individually inspected physico-chemical property predictions. Boxed numbers 
show difference in RMSLE pertaining to corresponding chemicals 
and the dashed line shows unity. 

```{r curated_values_plot_fig5, eval = execute.vignette}

#load curated data info
original_curated.data.dt <- httk::Dimitrijevic.IVD

#first - run using the default/dashboard values
default.dt<-data.table::copy(original_curated.data.dt %>% 
                   select(-c( "Arnot_pka", "Arnot_pkb", "log KOW,N", "log KAW,N", 
                              "Predicted_Ccell_µM", "FoA")))

# run the model, output concentrations in umol/L (e.g. uM)
armitageOutput_default.dt <- armitage_eval(tcdata=default.dt,
                                        restrict.ion.partitioning = TRUE,
                                        surface.area.switch = FALSE)

#next- run using curated values (EAS-E Suite)
curated.data.dt<-data.table::copy(original_curated.data.dt)

#overwrite using curated physchem properties
curated.data.dt[, pKa_Donor := as.character(Arnot_pka)] %>% #acidic
  .[, pKa_Accept := as.character(Arnot_pkb)] %>% #basic
  .[, gkow := `log KOW,N`] %>% 
  .[, gkaw_n := `log KAW,N`] 

# run the model, output concentrations in umol/L (e.g. uM)
armitageOutput_curated.data.dt <- armitage_eval(tcdata=curated.data.dt,
                                        restrict.ion.partitioning = TRUE,
                                        surface.area.switch = FALSE)

#save output with these values (Supplemental Materials T9)
defaultvals<- armitageOutput_default.dt %>% 
  select(Name, casrn, gkow_n, gkaw_n, pKa_Donor, pKa_Accept)
curatedvals<-armitageOutput_curated.data.dt %>% 
  select(Name, casrn, gkow_n, gkaw_n, pKa_Donor, pKa_Accept)
#tie the two tables together for the supplement
s9_table<-rbind(curatedvals, defaultvals)

#calculate rmsle

#default values

#individual
armitageOutput_default.dt[,rmsle_ccell_default:=
                            rmsle(Reported_Ccell_µM, ccells), by = Name]

#total
RMSLE_default.dt<-rmsle(armitageOutput_default.dt$Reported_Ccell_µM, 
                        armitageOutput_default.dt$ccells)
RMSLE_default.dt<-round(RMSLE_default.dt, 3)
#0.586

#curated values

#individual
armitageOutput_curated.data.dt[,rmsle_ccell_curated:=
                                 rmsle(Reported_Ccell_µM, ccells), by = Name]

#total
RMSLE_curated.data.dt<-rmsle(armitageOutput_curated.data.dt$Reported_Ccell_µM, 
                             armitageOutput_curated.data.dt$ccells)
RMSLE_curated.data.dt<-round(RMSLE_curated.data.dt, 3)
#0.570

#improvement when using curated data:
RMSLE_default.dt-RMSLE_curated.data.dt
#0.016

## difference between the two on a per-chemical basis ##
curated_data.dt<-merge(armitageOutput_default.dt, 
                       armitageOutput_curated.data.dt, by = "Name")

#calculate rmsle difference for each chemical
curated_data.dt[,rmsle_difference:=
                  rmsle_ccell_curated-rmsle_ccell_default, by = Name]

#which chemicals had the greatest magnitude of difference
#largest improvement when using curated data
head(curated_data.dt %>% 
  select(rmsle_difference, Name) %>% 
  arrange(rmsle_difference), 2)

#largest improvement when using default data
tail(curated_data.dt %>% 
  select(rmsle_difference, Name) %>% 
  arrange(rmsle_difference), 2)

#set custom colors and shapes for plot below
#tricky to tell apart with just colors
custom_shapes <- c(22, 23, 24, 25, 22, 23, 
                   24, 25, 22, 23, 24, 25) # 12 distinct shapes
custom_colors <- scales::viridis_pal()(length(
  unique(curated_data.dt$Name))) # 12 distinct colors

#plot
curated_difference_httk_plot<-ggplot(curated_data.dt) +
  geom_point(aes(ccells.y, Reported_Ccell_µM.y, fill = Name, shape = Name), size = 4) +
  geom_label_repel(aes(ccells.y, Reported_Ccell_µM.y, 
                       label = round(rmsle_difference, 2))) +
  geom_abline(intercept=0,slope=1, linetype = "dashed") +
  xlab(expression("Armitage Predicted "*italic("C"["cell"])~"(\u03BCM)")) +
  ylab(expression("Experimental "*italic(" C"["cell"])~"(\u03BCM)")) +
  labs(fill = "Chemical", shape = "Chemical")+
  scale_x_log10(lim = c(10, 10000), labels = label_log(digits = 2)) +
  scale_y_log10(lim = c(10, 10000), labels = label_log(digits = 2)) +
  personal_theme() +
  scale_shape_manual(values = custom_shapes) +
  scale_fill_manual(values = custom_colors) +
  theme(legend.position = "bottom",
        legend.key.size = unit(2, 'mm'),
        legend.spacing = unit(10, "pt"),
        legend.text = element_text(size = 10))

if(save_output){
  ggsave(file = paste0("Figure5_",data.date,"_",Sys.Date(),".png"),
         path = path_out,
         curated_difference_httk_plot, width = 8, height = 5, dpi = 300)
  
  write.csv(s9_table, file = paste0(path_out,"table_s9_",data.date,"_",
                                    Sys.Date(),".csv"))
}

```

# Main Paper Calculations:

## Over/underestimation
```{r fold_change_calculation, eval = execute.vignette}

# The Armitage model resulted in a slight over prediction of Ccell whereas 
# the Kramer model had the greatest spread but most evenly over and 
# underpredicted Ccell (Figure 2). 
range(Armitage.dt$ccells)
#1.555754e-02 4.845393e+04
range(Kramer.dt$concentration_cells)
#5.838149e-04 2.663947e+04

#Kramer has a larger spread of predictions

##create datatable with both outputs stacked 
stacked.data<-rbind(Armitage.dt, Kramer.dt, fill=TRUE)

#overpredict or underpredict for each model compared to experimental
stacked.data_HL<-data.table::copy(stacked.data)
stacked.data_HL[ccells>CellConcentration_uM, 
                ARMITAGE_ccellcomp:="ARMITAGE higher"] %>%
  .[ccells<CellConcentration_uM, 
    ARMITAGE_ccellcomp:="ARMITAGE lower"] %>%
  .[concentration_cells>CellConcentration_uM, 
    KRAMER_ccellcomp:="KRAMER higher"] %>% 
  .[concentration_cells<CellConcentration_uM, 
    KRAMER_ccellcomp:="KRAMER lower"] 

stacked.data_HL %>% count(ARMITAGE_ccellcomp, KRAMER_ccellcomp)
#Armitage model more often over predicts
#Kramer is pretty even split of over and under predictions

#pick out where armitage prediction or kramer prediction is larger
sidebyside.data_HL<-data.table::copy(combodata)
sidebyside.data_HL[ccells>concentration_cells, ARMITAGE:="ARMITAGE higher"] %>%
  .[ccells<concentration_cells, KRAMER:="KRAMER higher"]

#count which is higher or lower by chemical
sidebyside.data_HL %>% select(ChemicalName.x, ARMITAGE, KRAMER) %>% 
  distinct() %>% count(ARMITAGE, KRAMER)
#armitage: higher for 38 chemicals
#kramer: higher for 5 chemicals
#38+5 = 43 chemicals overall

```

## Effect of water solubility value for Cyclosporin A
```{r water_solublity, eval = execute.vignette}

#Calculating water solubility using OPERA gswat
#pull cyc a values from input data
cycA.dt<-data.table::copy(IVD_Manuscript_data %>% 
                dplyr::filter(ChemicalName == "Cyclosporin A"))

#using regular gswat value:
#run armitage 
armitageOutput_cycA.dt_orig <- armitage_eval(tcdata=cycA.dt,
                                       surface.area.switch = TRUE,
                                       user_assay_parameters =
                                         user_assay_parameters,
                                       restrict.ion.partitioning = TRUE)

#regular gswat value is 2.341266 mg/L
#armitageOutput_cycA.dt_orig$gswat_n

#check gswat value: 
# 1. pull from data.table
chem.physical_and_invitro.data %>% 
  dplyr::filter(CAS == "59865-13-3") %>% 
  select(MW, logWSol, logWSol.Reference)

# 2. convert mol/L to mg/L which is what armitage uses
#from chem.physical_and_invitro.data table:
-3.739 #(mol/L) log10 water solubility
10^-3.739 # un-log = 0.0001823896 (mol/L)
#convert to mg/L
0.0001823896*(1203*convert_units("g", "mg")) #1203 is MW in g/mol
#output: 219.4147 mg/L = swat
log10(219.4147) 
#output: 2.341266 mg/L = gswat

#calculate RMSLE
cycA.dt_rmsle_orig<-round(rmsle((
  armitageOutput_cycA.dt_orig$CellConcentration_uM),
  (armitageOutput_cycA.dt_orig$ccells)),2)
#2.89 - overall rmsle

#Calculating water solubility using experimental gswat
#pull cyc a values from input data
cycA.dt<-data.table::copy(IVD_Manuscript_data %>% dplyr::filter(ChemicalName == "Cyclosporin A"))

#using measured gswat value: mg/L
cycA.dt[, gswat_n := log10(0.0073)]

#run armitage 
armitageOutput_cycA.dt_meas <- armitage_eval(tcdata=cycA.dt,
                                       surface.area.switch = TRUE,
                                       user_assay_parameters =
                                         user_assay_parameters,
                                       restrict.ion.partitioning = TRUE)

#measured gswat value is -2.136677 mg/L
#armitageOutput_cycA.dt_meas$gswat_n

#calculate RMSLE
cycA.dt_rmsle_meas<-round(rmsle((
  armitageOutput_cycA.dt_meas$CellConcentration_uM),
  (armitageOutput_cycA.dt_meas$ccells)),2)
#1.47 - overall rmsle

```

## Effect of experimentally measured nominal dose
Change in accuracy of intracellular concentration predicted by studies 
reporting experimentally measured nominal dose
```{r experimental_nomconc, eval = execute.vignette}

#pull observations that did experimentally measure the nominal dose
#exp_nom.dt<-data.table::copy(IVD_Manuscript_data[!(is.na(ExperimentalDose_uM)),]) 
#6 citations did measure experimental dose
#42 observations

#BUT - Stadnicka 2014 did not report a nominal dose to begin with, 
#only the experimentally measured values
exp_nom.dt<-data.table::copy(IVD_Manuscript_data[!(is.na(ExperimentalDose_uM)) &
                                       Citation != "Stadnicka, 2014",]) 
#unique(exp_nom.dt$Citation)
#5 citations measured experimental dose AND reported nominal dose
#27 observations

#run armitage with nomconc as NominalDose_uM.x (not experimentally measured)
arm_nomconc<-data.table::copy(exp_nom.dt[, nomconc := NominalDose_uM])

# run Armitage model, output concentrations in umol/L (e.g. uM)
armitageOutput_arm_nomconc <- armitage_eval(tcdata=arm_nomconc,
                                            surface.area.switch = TRUE,
                                            user_assay_parameters = 
                                              user_assay_parameters,
                                            restrict.ion.partitioning = TRUE)

#run armitage with nomconc as ExperimentalDose_uM.x (experimentally measured)
arm_expconc<-data.table::copy(exp_nom.dt[, nomconc := ExperimentalDose_uM])

armitageOutput_arm_expconc <- armitage_eval(tcdata=arm_expconc, 
                                            surface.area.switch = TRUE,
                                            user_assay_parameters = 
                                              user_assay_parameters,
                                            restrict.ion.partitioning = TRUE)

#Armitage NOMCONC RMSLE:
arm_nomconc_rmsle_long<-rmsle((armitageOutput_arm_nomconc$CellConcentration_uM),
                              (armitageOutput_arm_nomconc$ccells))
arm_nomconc_rmsle<-round(arm_nomconc_rmsle_long, 2)
#1.87

#Armitage EXPCONC RMSLE:
arm_expconc_rmsle_long<-rmsle((armitageOutput_arm_expconc$CellConcentration_uM),
                              (armitageOutput_arm_expconc$ccells))
arm_expconc_rmsle<-round(arm_expconc_rmsle_long, 2)
#1.75

#improvement between the experimental and nomconc rmsles
arm_nomconc_rmsle- arm_expconc_rmsle
#0.12

```

#Supplement:

## Table S1. 
Physicochemical properties of test chemicals and Ccell/Cnominal ratios 
from each reference.
```{r physchem_data_tableS1, eval = execute.vignette}

#create datatable to hold the info
table1.dt<-data.table::copy(Nominal.dt)

# pull out the columns we need
data.dt<-table1.dt[, c("Citation", "casrn", "ChemicalName", "IOC_Type", 
                       "nomconc", "CellConcentration_uM"), with = FALSE]


# pull dtxsids, log P, henry's law, and pka:

#dtxsids
cheminfo.dt<-as.data.table(get_chem_id(chem.cas=unique(data.dt$casrn)))

cheminfo.dt[, casrn:=chem.cas] %>% #rename
  .[,chem.cas:=NULL] %>% #delete
  .[,chem.name:=NULL] #delete

#add dtxsid info to the storage file
data.dt2<-data.dt[cheminfo.dt,on="casrn"]

#collect log P, henry's law, and pka values
data.dt2[, c("logP","logHenry", "pKa_Donor", "pKa_Accept") := 
           as.data.frame(get_physchem_param(param = c("logP","logHenry", 
                                                      "pKa_Donor", 
                                                      "pKa_Accept"), 
                                            chem.cas = casrn))] 


# calculate median CellConcentration_uM:cnom ratio 
# (for each citation if multiple) and number of observations per chemical

#get ccell : cnom ratio
data.dt2[,cellconc_cnom_ratio:=CellConcentration_uM/nomconc]

#for each chemical/citation combination, calculate the median ccell:cnom ratio
data.dt2[, median_ratio := median(cellconc_cnom_ratio), 
         by=list(Citation, ChemicalName)]

#count the number of observations by citation and chemname
data.dt2[, number_of_obs:=.N, by=list(Citation, ChemicalName)]

#filter down to one observation per citation/casrn combo
final_output<-data.dt2 %>% 
  mutate(logP=round(logP, 2),
         logHenry=round(logHenry, 2),
         median_ratio=round(median_ratio, 3)) %>% 
  select(-c("casrn", "nomconc", "CellConcentration_uM", 
            "cellconc_cnom_ratio")) %>% #get rid of extra rows
  distinct(Citation, ChemicalName, .keep_all = TRUE) 
#1 obs per citation/chem pair

#save the output
if(save_output){
  write.csv(final_output, file = paste0(path_out,"table_s1_",data.date,"_",
                                        Sys.Date(),".csv"))
}

```

## Table S2. In vitro assay descriptors for the measurements

```{r assay_descriptors_tableS2, eval = execute.vignette}

#copy table to manipulate
parameter_table<-data.table::copy(Nominal.dt)

table_s2<-parameter_table[, c("Citation", "ChemicalName", "nomconc", 
                              "NominalDose_uM", "v_total", "v_working", 
                              "sarea", "well_number", "cell_yield", "FBSf", 
                              "FigureNumber", "CellType")] #subset columns

#save the output
if(save_output){
  write.csv(table_s2, 
            file = paste0(path_out,"table_s2_raw_",data.date,"_",
                          Sys.Date(),".csv"))
}

```

## Table S3: 
Overall root mean squared log error (RMSLE) and coefficient of 
determination (r2) for the Armitage and Kramer models. 
See Figure 2 code above. 

## Table S4: 
RMSLE and r^2 for acids and bases.
```{r ionization_RMSLE_tableS4, eval = execute.vignette}

#copy for editing
ionization_rmsle<-data.table::copy(stacked.data)

#calculate RMSLSE and r^2 for each model and ionization type
ionization_rmsle_output<- data.table::copy(ionization_rmsle[label=="Armitage", 
                                                RMSLE_armitage_ionization:= 
                         rmsle(CellConcentration_uM, ccells), 
                       by = "IOC_Type"] %>% #RMSLE
  .[label=="Armitage", rsq_armitage_ionization:= 
      summary(lm(CellConcentration_uM~ccells))$r.squared, 
    by = "IOC_Type"] %>% #r^2
  .[label=="Kramer", RMSLE_kramer_ionization:= 
                         rmsle(CellConcentration_uM, concentration_cells), 
                       by = "IOC_Type"] %>% #RMSLE
  .[label=="Kramer", rsq_kramer_ionization:= 
      summary(lm(CellConcentration_uM~concentration_cells))$r.squared, 
    by = "IOC_Type"] %>% #r^2
  .[,numberofpoints:= .N/2, by = "IOC_Type"] %>% 
  .[, c("IOC_Type", "RMSLE_armitage_ionization",
        "rsq_armitage_ionization", "RMSLE_kramer_ionization", 
        "rsq_kramer_ionization", "numberofpoints")] %>% #select columns we want
  distinct())

print(ionization_rmsle_output)
#number of points is overall, not for each calculation

#save the output
if(save_output){
  write.csv(ionization_rmsle_output, 
            file = paste0(path_out,"table_s4_",data.date,"_",Sys.Date(),".csv"))
}

```

## Table S5:
RMSLE across lipophilicity.
```{r logP_RMSLE_tableS5, eval = execute.vignette}

#cut up into chunks
gkowbins<-stacked.data %>% mutate(LogP_bins = 
                                    cut(gkow, breaks = c(-Inf, 1.30, 3.36, Inf),
  labels = c("Hydrophilic", "Moderate Lipophilic", "Lipophilic")))

#calculate rmsle for each model and logP bin combo
gkowbins_rmsle_output<-suppressWarnings(data.table::copy(
  gkowbins[label == "Armitage", Armitage_RMSLE := rmsle(
  CellConcentration_uM, ccells), by = LogP_bins] %>% 
  .[label == "Kramer", Kramer_RMSLE := rmsle(
  CellConcentration_uM, concentration_cells), by = LogP_bins] %>% 
  .[, numberofpoints := .N, by = list(LogP_bins, label)] %>% 
  .[, c("LogP_bins", "Armitage_RMSLE", "Kramer_RMSLE", 
        "numberofpoints", "label")] %>% 
  distinct()))

print(gkowbins_rmsle_output)
#number of points is overall, not for each calculation

#save the output
if(save_output){
  write.csv(gkowbins_rmsle_output, 
            file = paste0(path_out,"table_s5_",data.date,"_",Sys.Date(),".csv"))
}

```

## Table S6. 
RMSLE across volatility.
```{r kaw_RMSLE_tableS6, eval = execute.vignette}

#source for chunks is table 2 Volatility class in water: 
#https://www.epa.gov/pesticide-science-and-assessing-pesticide-risks/
#guidance-reporting-environmental-fate-and-transport#:~:text=is%20very%20low.-,
#Volatility%20from%20Water,the%20reciprocal%20of%20KAW.&text=GMW%20=%20gram%20
#molecular%20weight%20in%20g/mole.&text=This%20value%20is%20the%20inverse,as%20
#Cwater/Cair.&text=Note%20that%20all%20chemicals%20may,volatility%20potential%20
#is%20very%20low.

#cut up kaw into relevant bins
kawbins<-stacked.data %>% 
  mutate(Kaw_bins = cut(DR_kaw, breaks = c(Inf, 10^-2, 10^-3, 10^-5, -Inf),
  labels = c("Rapidly lost from a water surface", 
             "Volatile from a water surface", 
             "Slightly volatile from a water surface", "Non-volatile")))

#calculate rmsle for each model and logP bin combo
kaw_rmsle_output<-suppressWarnings(kawbins[label == "Armitage", 
                                    Armitage_RMSLE := rmsle(
  CellConcentration_uM, ccells), by = Kaw_bins] %>% 
  .[label == "Kramer", Kramer_RMSLE := rmsle(
  CellConcentration_uM, concentration_cells), by = Kaw_bins] %>% 
  .[, numberofpoints := .N, by = list(Kaw_bins, label)] %>% 
  .[, c("Kaw_bins", "Armitage_RMSLE", "Kramer_RMSLE", 
        "numberofpoints", "label")] %>% 
  distinct())


#save the output
if(save_output){
  write.csv(kaw_rmsle_output, 
            file = paste0(path_out,"table_s6_",data.date,"_",Sys.Date(),".csv"))
}


```

## Table S7:
Root mean squared log error (RMSLE) and coefficient of determination (r2) 
for the chemicals with multiple observations. Note: Atrazine, Flusilazole, 
N-Phenyl-1,4-benzenediamine, Rosiglitazone, Thiacloprid, and Triphenyl phosphate
each only reflect two data points.
```{r multobs_RMSLE_tableS7, eval = execute.vignette}

#Armitage

#copy for editing
multobs_rmsle_armitage<-data.table::copy(as.data.table(Armitage.multobs.dt))

#group by chemname, calc RMSLE, r^2, and number of obs
multobs_rmsle_armitage[, RMSLE_armitage_mult:= 
                         rmsle(mean_measuredccell, mean_predictedccell), 
                       by = "ChemicalName"] %>% #rmsle
  .[, rsq_armitage_mult:= 
      summary(lm(mean_measuredccell~mean_predictedccell))$r.squared, 
    by = "ChemicalName"] %>% #r^2
  .[, numberofpoints:= .N, by = "ChemicalName"] 

#numberofpoints = number of datapoints considered (includes averaged points)

#repeat for kramer

#copy for editing
multobs_rmsle_kramer<-data.table::copy(as.data.table(Kramer.multobs.dt))

#group by chemname, calc RMSLE, r^2, and number of obs
multobs_rmsle_kramer[, RMSLE_kramer_mult:= 
                         rmsle(mean_measuredccell, mean_predictedccell), 
                       by = "ChemicalName"] %>% #rmsle
  .[, rsq_kramer_mult:= 
      summary(lm(mean_measuredccell~mean_predictedccell))$r.squared, 
    by = "ChemicalName"] %>% #r^2
  .[, numberofpoints:= .N, by = "ChemicalName"] 


#cut down both to the columns we need and only 1 obs per chemical
mult.dt<-merge(multobs_rmsle_armitage[, -c("NominalDose_uM", 
                                           "mean_measuredccell", 
                                           "mean_predictedccell")] %>% 
                 distinct() , 
               multobs_rmsle_kramer[, -c("NominalDose_uM", 
                                         "mean_measuredccell", 
                                         "mean_predictedccell")] %>% 
                 distinct())

#for higher/lower rmsle comparison
mult_HL<-data.table::copy(mult.dt[RMSLE_kramer_mult>RMSLE_armitage_mult, 
                      higherorlower:="Kramer higher"] %>% 
  .[RMSLE_kramer_mult<RMSLE_armitage_mult, 
    higherorlower:="kramer lower"])

mult_HL %>% count(higherorlower)
#armitage predictions have lower error for 6 chemicals
#kramer predictions are lower error for the other 4

#save the output
if(save_output){
  write.csv(mult.dt, 
            file = paste0(path_out,"table_s3_",data.date,"_",Sys.Date(),".csv"))
}

```

## Table S8:
Effect of "options" on rmsle in the Armitage model.
```{r options_tableS8, eval = execute.vignette}

#list of options that can be changed in the armitage model:

# 		- this.option.kbsa2 Use alternative bovine-serum-albumin partitioning
# 		- this.option.swat2 Use alternative water solubility correction
# 		- this.option.kpl2 Use alternative plastic-water partitioning model
# 		- option.plastic == TRUE (default) gives nonzero surface area
# 		- option.bottom == TRUE (default) includes surface area of the bottom of 
#       the well in determining sarea
# 		- restrict.ion.partitioning 
# 			§ False (default):  Treat entire chemical as neutral and allow it all 
#       to partition normally as such
# 			§ True: Restrict so only the neutral fraction of the chemical is 
#       available to partition normally but the ionized portion is scaled


##filter to just the ones we can run with the surface area calculation since 
#option.plastic and option.bottom require that function:
options.IVD_Manuscript_data_2<-
  options.IVD_Manuscript_data[!is.na(well_number), ] %>% 
  .[,sarea:=NULL]  #delete sarea so the surface area function will run 
#126 out of the original 153 observations
# length(options.IVD_Manuscript_data$Citation %>% unique()) #14 citations
# length(options.IVD_Manuscript_data_2$Citation %>% unique()) #12 citations
# 153-126 data points; 27 data points total removed

# create table to append the results to 
options.table <- NULL

# run basic armitage, only setting the surface area switch
option.basic <- armitage_eval(tcdata=options.IVD_Manuscript_data_2,
                              surface.area.switch = TRUE,
                              user_assay_parameters = user_assay_parameters)

option.basic_RMSLE<-rmsle((option.basic$CellConcentration_uM),
                          (option.basic$ccells))
#1.148

#append to table
options.table<-rbind(options.table, c(round(option.basic_RMSLE ,3), 
                                      "All Default"))

# run with this.option.kbsa2 == TRUE (default is false)
option.kbsa <- armitage_eval(tcdata=options.IVD_Manuscript_data_2,
                             this.option.kbsa2 = TRUE,
                             surface.area.switch = TRUE,
                             user_assay_parameters = user_assay_parameters)

option.kbsa_RMSLE<-rmsle((option.kbsa$CellConcentration_uM),
                         (option.kbsa$ccells))
#1.150

#append to table
options.table<-rbind(options.table, c(round(option.kbsa_RMSLE, 3), 
                                      "option.kbsa=TRUE"))


# run with this.option.swat2 == TRUE (default is false)
option.swat <- armitage_eval(tcdata=options.IVD_Manuscript_data_2,
                             this.option.swat2 = TRUE,
                             surface.area.switch = TRUE,
                             user_assay_parameters = user_assay_parameters)

option.swat_RMSLE<-rmsle((option.swat$CellConcentration_uM),
                         (option.swat$ccells))
#3.585

#append to table
options.table<-rbind(options.table, c(round(option.swat_RMSLE, 3), 
                                      "option.swat2=TRUE"))

# run with this.option.kpl2 == TRUE (Fischer) (default is false/kramer)
option.kpl <- armitage_eval(tcdata=options.IVD_Manuscript_data_2,
                             this.option.kpl2 = TRUE,
                            surface.area.switch = TRUE,
                            user_assay_parameters = user_assay_parameters)

option.kpl_RMSLE<-rmsle((option.kpl$CellConcentration_uM),(option.kpl$ccells))
#1.101

#append to table
options.table<-rbind(options.table, c(round(option.kpl_RMSLE, 3), 
                                      "option.kpl2=TRUE"))

# run with option.plastic == FALSE (default is true)
opt.plast_input<- data.table::copy(options.IVD_Manuscript_data_2)
opt.plast_input[,option.plastic := FALSE]

option.plast <- armitage_eval(tcdata=opt.plast_input,
                              surface.area.switch = TRUE,
                              user_assay_parameters = user_assay_parameters)

option.plast_RMSLE<-rmsle((option.plast$CellConcentration_uM),
                          (option.plast$ccells))
#1.178

#append to table
options.table<-rbind(options.table, c(round(option.plast_RMSLE, 3), 
                                      "option.plastic=FALSE"))

# run with option.bottom == FALSE (default is true)
option.bottom_input<- data.table::copy(options.IVD_Manuscript_data_2)
option.bottom_input[,option.bottom := FALSE]

option.bottom <- armitage_eval(tcdata=option.bottom_input,
                               surface.area.switch = TRUE,
                              user_assay_parameters = user_assay_parameters)

option.bottom_RMSLE<-rmsle((option.bottom$CellConcentration_uM),
                           (option.bottom$ccells))
#1.157

#append to table
options.table<-rbind(options.table, c(round(option.bottom_RMSLE,3), 
                                      "option.bottom=FALSE"))

# run with restrict.ion.partitioning == TRUE (default is FALSE)
option.restion <- armitage_eval(tcdata=options.IVD_Manuscript_data_2,
                             restrict.ion.partitioning = TRUE,
                             surface.area.switch = TRUE,
                              user_assay_parameters = user_assay_parameters)

option.restion_RMSLE<-rmsle((option.restion$CellConcentration_uM),
                            (option.restion$ccells))
#1.152

#append to table
options.table<-rbind(options.table, c(round(option.restion_RMSLE,3), 
                                      "restrict.ion.partitioning = TRUE"))

#save the output
if(save_output){
  write.csv(options.table, 
            file = paste0(path_out,"table_s7_",data.date,"_",Sys.Date(),".csv"))
}

```

## Table S9:
No code

## Table S10:
See Figure 5 code above

## Table S11:
Difference in RMSLE between liver and non-liver cells for 
the Armitage and Kramer models.
```{r cell_type_tableS11, eval = execute.vignette}

#copy for editing
celltype_rmsle<-data.table::copy(stacked.data)

#one set doesnt have cell type annotated, add here:
celltype_rmsle[assay_name == "Tox21 Experiment", cell_type := "MCF-7"]

#check all assays have cell type added (no nas)
unique(celltype_rmsle$cell_type)

#create bins for the cell types
celltype_rmsle[cell_type == "PRH" |
                 cell_type == "PHH" |
                 cell_type == "HepaRG" |
                 cell_type == "HepG2"
                 , cell_type_class:="Liver"] %>% 
  .[cell_type == "Neocortical" |
     cell_type == "PFC" |
     cell_type == "Caco-2" |
     cell_type == "LS180" |
     cell_type == "MCF-7" |
     cell_type == "H295R" |
     cell_type == "PC12" |
     cell_type == "RTgill W1" |
     cell_type == "HEK293" |
     cell_type == "Balb/c 3T3", cell_type_class:="Non-Liver"]

#check all are labeled
celltype_rmsle %>% select(cell_type, cell_type_class) %>% distinct()

#calculate RMSLSE and r^2 for each model and ionization type
celltype_rmsle_output<- data.table::copy(celltype_rmsle[label=="Armitage", 
                                                RMSLE_armitage_cell_type:= 
                         rmsle(CellConcentration_uM, ccells), 
                       by = "cell_type_class"] %>% #RMSLE
  .[label=="Armitage", rsq_armitage_cell_type:= 
      summary(lm(CellConcentration_uM~ccells))$r.squared, 
    by = "cell_type_class"] %>% #r^2
  .[label=="Kramer", RMSLE_kramer_cell_type:= 
                         rmsle(CellConcentration_uM, concentration_cells), 
                       by = "cell_type_class"] %>% #RMSLE
  .[label=="Kramer", rsq_kramer_cell_type:= 
      summary(lm(CellConcentration_uM~concentration_cells))$r.squared, 
    by = "cell_type_class"] %>% #r^2
  .[,numberofpoints:= .N/2, by = "cell_type_class"] %>% 
  .[, c("cell_type_class", "RMSLE_armitage_cell_type",
        "rsq_armitage_cell_type", "RMSLE_kramer_cell_type", 
        "rsq_kramer_cell_type", "numberofpoints")] %>% #select columns we want
  distinct())

print(celltype_rmsle_output)
#number of points is overall, not for each calculation

```

## Figure S1:
Histogram showing chemical-specific RMSLE for Armitage Ccell vs Measured Ccell 
and Kramer Ccell vs Measured Ccell:
```{r intracellular_histogram_plotS1, eval = execute.vignette}

#calculate RMSLE for each chemical
combodata[, RMSLE_armitage_by_chem:= rmsle(CellConcentration_uM.x, ccells), 
          by = "ChemicalName.x"]
combodata[, RMSLE_kramer_by_chem:= 
            rmsle(CellConcentration_uM.x, concentration_cells), 
          by = "ChemicalName.x"]
combodata[, RMSLE_nominal_by_chem:= rmsle(CellConcentration_uM.x, nomconc), 
          by = "ChemicalName.x"]

#cut down to one observation per chemical
histo.data<-data.table::copy(combodata %>% 
                   select(ChemicalName.x, RMSLE_armitage_by_chem, 
                          RMSLE_kramer_by_chem, RMSLE_nominal_by_chem) %>% 
                   unique())

#histo.data %>% arrange(desc(RMSLE_kramer_by_chem))

#plot histograms
nominal_histogram_by_chem <-ggplot(histo.data, aes(x=RMSLE_nominal_by_chem)) + 
  geom_histogram(binwidth = 0.5, boundary = 0) +
  labs(x = "Nominal RMSLE",
       y = "Number of Observations") + 
  xlim(0, 5) + ylim(0, 17) +
  theme_classic() +  
  theme(axis.text=element_text(size=12),
        axis.title=element_text(size=14))

armitage_histogram_by_chem <-ggplot(histo.data, aes(x=RMSLE_armitage_by_chem)) + 
  geom_histogram(binwidth = 0.5, boundary = 0) +
  labs(x = "Armitage RMSLE",
       y = "Number of Observations") +
  xlim(0, 5) + ylim(0, 17) +
  theme_classic() + 
  theme(axis.text=element_text(size=12),
        axis.title=element_text(size=14))

kramer_histogram_by_chem <- ggplot(histo.data, aes(x=RMSLE_kramer_by_chem)) + 
  geom_histogram(binwidth = 0.5, boundary = 0) +
  labs(x = "Kramer RMSLE",
       y = "Number of Observations") +
  xlim(0, 5) + ylim(0, 17) +
  theme_classic()+
  theme(axis.text=element_text(size=12),
        axis.title=element_text(size=14))

histogram_comboplot_by_chem<-ggarrange(nominal_histogram_by_chem +
                                         theme(axis.ticks.y = element_blank(),
                                               plot.margin = margin(r = 1)), 
                                       armitage_histogram_by_chem +
                                         theme(axis.text.y = element_blank(),
                                               axis.ticks.y = element_blank(),
                                               axis.title.y = element_blank(),
                                               plot.margin = margin(r = 1, 
                                                                    l = 1)), 
                                       kramer_histogram_by_chem +
                                         theme(axis.text.y = element_blank(),
                                               axis.ticks.y = element_blank(),
                                               axis.title.y = element_blank(),
                                               plot.margin = margin(r = 1, 
                                                                    l = 1)), 
                                       ncol=3)

if(save_output){
  ggsave(file = paste0("Figure_S1_by_chem_",data.date,"_",Sys.Date(),".png"),
         path = path_out,
         histogram_comboplot_by_chem, width = 10, height = 5, dpi = 300)
}

print(histogram_comboplot_by_chem)

```

---
title: "Wambaugh et al. (2018): Evaluating In Vitro-In Vivo Extrapolation"
author: "John Wambaugh"
date: "`r Sys.Date()`"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{d) Wambaugh (2018): Evaluating In Vitro-In Vivo Extrapolation}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---
*Please send questions to John.Wambaugh@UL.org*

This vignette provides the code used to generate the figures in Wambaugh et al. (2018) 
"Evaluating In Vitro-In Vivo Extrapolation of Toxicokinetics"

John F Wambaugh, Michael F Hughes, Caroline L Ring, Denise K MacMillan, Jermaine Ford, 
Timothy R Fennell, Sherry R Black, Rodney W Snyder, Nisha S Sipes, Barbara A Wetmore, 
Joost Westerhout, R Woodrow Setzer, Robert G Pearce, Jane Ellen Simmons, Russell S Thomas

Toxicological Sciences, Volume 163, Issue 1, May 2018, Pages 152-169,

https://doi.org/10.1093/toxsci/kfy020

## Abstract
Prioritizing the risk posed by thousands of chemicals potentially present in the 
environment requires exposure, toxicity, and toxicokinetic (TK) data, which are 
often unavailable. Relatively high-throughput, in vitro TK (HTTK) assays and *in 
vitro-to-in vivo* extrapolation (IVIVE) methods have been developed to predict TK, 
but most of the in vivo TK data available to benchmark these methods are from 
pharmaceuticals. Here we report on new, *in vivo* rat TK experiments for 26 
non-pharmaceutical chemicals with environmental relevance. Both intravenous and 
oral dosing were used to calculate bioavailability. These chemicals, and an 
additional 19 chemicals (including some pharmaceuticals) from previously published 
in vivo rat studies, were systematically analyzed to estimate in vivo TK 
parameters (e.g., volume of distribution [Vd], elimination rate). For each of the 
chemicals, rat-specific HTTK data were available and key TK predictions were 
examined: oral bioavailability, clearance, Vd, and uncertainty. For the 
non-pharmaceutical chemicals, predictions for bioavailability were not effective. 
While no pharmaceutical was absorbed at less than 10%, the fraction bioavailable 
for non-pharmaceutical chemicals was as low as 0.3%. Total clearance was 
generally more under-estimated for nonpharmaceuticals and Vd methods calibrated 
to pharmaceuticals may not be appropriate for other chemicals. However, the 
steady-state, peak, and time-integrated plasma concentrations of 
non-pharmaceuticals were predicted with reasonable accuracy. The plasma 
concentration predictions improved when experimental measurements of 
bioavailability were incorporated. In summary, HTTK and IVIVE methods are 
adequately robust to be applied to high-throughput *in vitro* toxicity 
screening data of environmentally relevant chemicals for prioritizing based 
on human health risks.

## HTTK Version

This vignette was created with **httk** v1.8. Although we attempt to maintain 
backward compatibility, if you encounter issues with the latest release of 
**httk**
and cannot easily address the changes, historical versions of httk are 
available from: https://cran.r-project.org/src/contrib/Archive/httk/


## Prepare for session
R package **knitr** generates html and PDF documents from this RMarkdown file,
Each bit of code that follows is known as a "chunk". We start by telling 
**knitr** how we want our chunks to look.
```{r knitrPrep, include=FALSE, eval = TRUE}
knitr::opts_chunk$set(collapse = TRUE, comment = '#>', fig.width=5, fig.height=3)
```

### Clear the memory
It is a bad idea to let variables and other information from previous R
sessions float around, so we first remove everything in the R memory.
```{r clear_memory, eval = TRUE}
rm(list=ls()) 
```

### eval = execute.vignette
If you are using the RMarkdown version of this vignette (extension, .RMD) you
will be able to see that several chunks of code in this vignette
have the statement "eval = execute.vignette". The next chunk of code, by default,
sets execute.vignette = FALSE.  This means that the code is included (and necessary) but was
not run when the vignette was built. We do this because some steps require 
extensive computing time and the checks on CRAN limit how long we can spend
building the package. If you want this vignette to work, you must run all code,
either by cutting and pasting it into R. Or, if viewing the .RMD file, you can
either change execute.vignette to TRUE or press "play" (the green arrow) on
each chunk in RStudio.
```{r runchunks, eval = TRUE}
# Set whether or not the following chunks will be executed (run):
execute.vignette <- FALSE
```

### Load the relevant libraries
To use the code in this vignette, you'll first need to load a few packages.
If you get the message "Error in library(X) : there is no package called 'X'"
then you will need to install that package: 

From the R command prompt:

install.packages("X")

Or, if using RStudio, look for 'Install Packages' under 'Tools' tab.
```{r load_packages, eval = execute.vignette}
library(scales)
library(ggplot2)
library(data.table)
library(httk)
library(RColorBrewer)
library(grid)
library(gplots)
```

The data we analyze were originally generated with the 
[R package invivoPKfit](https://github.com/USEPA/CompTox-ExpoCast-invivoPKfit), but all the outputs 
of that analysis are provided with **httk** >v1.8.

# Plot functions
These functions, which have been cobbled together from the internet, are reused in multiple figure to make things look nice.
```{r plot_funcs, eval = execute.vignette}
# Multiple plot function
#
# ggplot objects can be passed in ..., or to plotlist (as a list of ggplot objects)
# - cols:   Number of columns in layout
# - layout: A matrix specifying the layout. If present, 'cols' is ignored.
#
# If the layout is something like matrix(c(1,2,3,3), nrow=2, byrow=TRUE),
# then plot 1 will go in the upper left, 2 will go in the upper right, and
# 3 will go all the way across the bottom.
#
multiplot <- function(..., plotlist=NULL, file, cols=1, layout=NULL, widths=unit(rep_len(1, cols), "null")) {

  # Make a list from the ... arguments and plotlist
  plots <- c(list(...), plotlist)

  numPlots = length(plots)

  # If layout is NULL, then use 'cols' to determine layout
  if (is.null(layout)) {
    # Make the panel
    # ncol: Number of columns of plots
    # nrow: Number of rows needed, calculated from # of cols
    layout <- matrix(seq(1, cols * ceiling(numPlots/cols)),
                    ncol = cols, nrow = ceiling(numPlots/cols))
  }

 if (numPlots==1) {
    print(plots[[1]])

  } else {
    # Set up the page
    grid.newpage()
    pushViewport(viewport(layout = grid.layout(nrow(layout), ncol(layout),widths=widths)))

    # Make each plot, in the correct location
    for (i in 1:numPlots) {
      # Get the i,j matrix positions of the regions that contain this subplot
      matchidx <- as.data.frame(which(layout == i, arr.ind = TRUE))

      print(plots[[i]], vp = viewport(layout.pos.row = matchidx$row,
                                      layout.pos.col = matchidx$col))
    }
  }
}
                                                                
lm_R2 <- function(m,prefix=NULL){
    out <- substitute("MSE = "~mse*","~~italic(R)^2~"="~r2, 
         list(mse = signif(mean(m$residuals^2),3),
              r2 = format(summary(m)$adj.r.squared, digits = 2)))
    paste(prefix,as.character(as.expression(out)))                 
}
  
heatmap.3 <- function(x,
                      Rowv = TRUE, Colv = if (symm) "Rowv" else TRUE,
                      distfun = dist,
                      hclustfun = hclust,
                      dendrogram = c("both","row", "column", "none"),
                      symm = FALSE,
                      scale = c("none","row", "column"),
                      na.rm = TRUE,
                      revC = identical(Colv,"Rowv"),
                      add.expr,
                      breaks,
                      symbreaks = max(x < 0, na.rm = TRUE) || scale != "none",
                      col = "heat.colors",
                      colsep,
                      rowsep,
                      sepcolor = "white",
                      sepwidth = c(0.05, 0.05),
                      cellnote,
                      notecex = 1,
                      notecol = "cyan",
                      na.color = par("bg"),
                      trace = c("none", "column","row", "both"),
                      tracecol = "cyan",
                      hline = median(breaks),
                      vline = median(breaks),
                      linecol = tracecol,
                      margins = c(5,5),
                      ColSideColors,
                      RowSideColors,
                      side.height.fraction=0.3,
                      cexRow = 0.2 + 1/log10(nr),
                      cexCol = 0.2 + 1/log10(nc),
                      labRow = NULL,
                      labCol = NULL,
                      key = TRUE,
                      keysize = 1.5,
                      density.info = c("none", "histogram", "density"),
                      denscol = tracecol,
                      symkey = max(x < 0, na.rm = TRUE) || symbreaks,
                      densadj = 0.25,
                      main = NULL,
                      xlab = NULL,
                      ylab = NULL,
                      lmat = NULL,
                      lhei = NULL,
                      lwid = NULL,
                      ColSideColorsSize = 1,
                      RowSideColorsSize = 1,
                      KeyValueName="Value",...){

    invalid <- function (x) {
      if (missing(x) || is.null(x) || length(x) == 0)
          return(TRUE)
      if (is.list(x))
          return(all(sapply(x, invalid)))
      else if (is.vector(x))
          return(all(is.na(x)))
      else return(FALSE)
    }

    x <- as.matrix(x)
    scale01 <- function(x, low = min(x), high = max(x)) {
        x <- (x - low)/(high - low)
        x
    }
    retval <- list()
    scale <- if (symm && missing(scale))
        "none"
    else match.arg(scale)
    dendrogram <- match.arg(dendrogram)
    trace <- match.arg(trace)
    density.info <- match.arg(density.info)
    if (length(col) == 1 && is.character(col))
        col <- get(col, mode = "function")
    if (!missing(breaks) && (scale != "none"))
        warning("Using scale=\"row\" or scale=\"column\" when breaks are",
            "specified can produce unpredictable results.", "Please consider using only one or the other.")
    if (is.null(Rowv) || is.na(Rowv))
        Rowv <- FALSE
    if (is.null(Colv) || is.na(Colv))
        Colv <- FALSE
    else if (Colv == "Rowv" && !isTRUE(Rowv))
        Colv <- FALSE
    if (length(di <- dim(x)) != 2 || !is.numeric(x))
        stop("`x' must be a numeric matrix")
    nr <- di[1]
    nc <- di[2]
    if (nr <= 1 || nc <= 1)
        stop("`x' must have at least 2 rows and 2 columns")
    if (!is.numeric(margins) || length(margins) != 2)
        stop("`margins' must be a numeric vector of length 2")
    if (missing(cellnote))
        cellnote <- matrix("", ncol = ncol(x), nrow = nrow(x))
    if (!inherits(Rowv, "dendrogram")) {
        if (((!isTRUE(Rowv)) || (is.null(Rowv))) && (dendrogram %in%
            c("both", "row"))) {
            if (is.logical(Colv) && (Colv))
                dendrogram <- "column"
            else dedrogram <- "none"
            warning("Discrepancy: Rowv is FALSE, while dendrogram is `",
                dendrogram, "'. Omitting row dendogram.")
        }
    }
    if (!inherits(Colv, "dendrogram")) {
        if (((!isTRUE(Colv)) || (is.null(Colv))) && (dendrogram %in%
            c("both", "column"))) {
            if (is.logical(Rowv) && (Rowv))
                dendrogram <- "row"
            else dendrogram <- "none"
            warning("Discrepancy: Colv is FALSE, while dendrogram is `",
                dendrogram, "'. Omitting column dendogram.")
        }
    }
    if (inherits(Rowv, "dendrogram")) {
        ddr <- Rowv
        rowInd <- order.dendrogram(ddr)
    }
    else if (is.integer(Rowv)) {
        hcr <- hclustfun(distfun(x))
        ddr <- as.dendrogram(hcr)
        ddr <- reorder(ddr, Rowv)
        rowInd <- order.dendrogram(ddr)
        if (nr != length(rowInd))
            stop("row dendrogram ordering gave index of wrong length")
    }
    else if (isTRUE(Rowv)) {
        Rowv <- rowMeans(x, na.rm = na.rm)
        hcr <- hclustfun(distfun(x))
        ddr <- as.dendrogram(hcr)
        ddr <- reorder(ddr, Rowv)
        rowInd <- order.dendrogram(ddr)
        if (nr != length(rowInd))
            stop("row dendrogram ordering gave index of wrong length")
    }
    else {
        rowInd <- nr:1
    }
    if (inherits(Colv, "dendrogram")) {
        ddc <- Colv
        colInd <- order.dendrogram(ddc)
    }
    else if (identical(Colv, "Rowv")) {
        if (nr != nc)
            stop("Colv = \"Rowv\" but nrow(x) != ncol(x)")
        if (exists("ddr")) {
            ddc <- ddr
            colInd <- order.dendrogram(ddc)
        }
        else colInd <- rowInd
    }
    else if (is.integer(Colv)) {
        hcc <- hclustfun(distfun(if (symm)
            x
        else t(x)))
        ddc <- as.dendrogram(hcc)
        ddc <- reorder(ddc, Colv)
        colInd <- order.dendrogram(ddc)
        if (nc != length(colInd))
            stop("column dendrogram ordering gave index of wrong length")
    }
    else if (isTRUE(Colv)) {
        Colv <- colMeans(x, na.rm = na.rm)
        hcc <- hclustfun(distfun(if (symm)
            x
        else t(x)))
        ddc <- as.dendrogram(hcc)
        ddc <- reorder(ddc, Colv)
        colInd <- order.dendrogram(ddc)
        if (nc != length(colInd))
            stop("column dendrogram ordering gave index of wrong length")
    }
    else {
        colInd <- 1:nc
    }
    retval$rowInd <- rowInd
    retval$colInd <- colInd
    retval$call <- match.call()
    x <- x[rowInd, colInd]
    x.unscaled <- x
    cellnote <- cellnote[rowInd, colInd]
    if (is.null(labRow))
        labRow <- if (is.null(rownames(x)))
            (1:nr)[rowInd]
        else rownames(x)
    else labRow <- labRow[rowInd]
    if (is.null(labCol))
        labCol <- if (is.null(colnames(x)))
            (1:nc)[colInd]
        else colnames(x)
    else labCol <- labCol[colInd]
    if (scale == "row") {
        retval$rowMeans <- rm <- rowMeans(x, na.rm = na.rm)
        x <- sweep(x, 1, rm)
        retval$rowSDs <- sx <- apply(x, 1, sd, na.rm = na.rm)
        x <- sweep(x, 1, sx, "/")
    }
    else if (scale == "column") {
        retval$colMeans <- rm <- colMeans(x, na.rm = na.rm)
        x <- sweep(x, 2, rm)
        retval$colSDs <- sx <- apply(x, 2, sd, na.rm = na.rm)
        x <- sweep(x, 2, sx, "/")
    }
    if (missing(breaks) || is.null(breaks) || length(breaks) < 1) {
        if (missing(col) || is.function(col))
            breaks <- 16
        else breaks <- length(col) + 1
    }
    if (length(breaks) == 1) {
        if (!symbreaks)
            breaks <- seq(min(x, na.rm = na.rm), max(x, na.rm = na.rm),
                length = breaks)
        else {
            extreme <- max(abs(x), na.rm = TRUE)
            breaks <- seq(-extreme, extreme, length = breaks)
        }
    }
    nbr <- length(breaks)
    ncol <- length(breaks) - 1
    if (class(col) == "function")
        col <- col(ncol)
    min.breaks <- min(breaks)
    max.breaks <- max(breaks)
    x[x < min.breaks] <- min.breaks
    x[x > max.breaks] <- max.breaks
    if (missing(lhei) || is.null(lhei))
        lhei <- c(keysize, 4)
    if (missing(lwid) || is.null(lwid))
        lwid <- c(keysize, 4)
    if (missing(lmat) || is.null(lmat)) {
        lmat <- rbind(4:3, 2:1)

        if (!missing(ColSideColors)) {
           #if (!is.matrix(ColSideColors))
           #stop("'ColSideColors' must be a matrix")
            if (!is.character(ColSideColors) || nrow(ColSideColors) != nc)
                stop("'ColSideColors' must be a matrix of nrow(x) rows")
            lmat <- rbind(lmat[1, ] + 1, c(NA, 1), lmat[2, ] + 1)
            #lhei <- c(lhei[1], 0.2, lhei[2])
             lhei=c(lhei[1], side.height.fraction*ColSideColorsSize/2, lhei[2])
        }

        if (!missing(RowSideColors)) {
            #if (!is.matrix(RowSideColors))
            #stop("'RowSideColors' must be a matrix")
            if (!is.character(RowSideColors) || ncol(RowSideColors) != nr)
                stop("'RowSideColors' must be a matrix of ncol(x) columns")
            lmat <- cbind(lmat[, 1] + 1, c(rep(NA, nrow(lmat) - 1), 1), lmat[,2] + 1)
            #lwid <- c(lwid[1], 0.2, lwid[2])
            lwid <- c(lwid[1], side.height.fraction*RowSideColorsSize/2, lwid[2])
        }
        lmat[is.na(lmat)] <- 0
    }

    if (length(lhei) != nrow(lmat))
        stop("lhei must have length = nrow(lmat) = ", nrow(lmat))
    if (length(lwid) != ncol(lmat))
        stop("lwid must have length = ncol(lmat) =", ncol(lmat))
    op <- par(no.readonly = TRUE)
    on.exit(par(op))

    layout(lmat, widths = lwid, heights = lhei, respect = FALSE)

    if (!missing(RowSideColors)) {
        if (!is.matrix(RowSideColors)){
                par(mar = c(margins[1], 0, 0, 0.5))
                image(rbind(1:nr), col = RowSideColors[rowInd], axes = FALSE)
        } else {
            par(mar = c(margins[1], 0, 0, 0.5))
            rsc = t(RowSideColors[,rowInd, drop=FALSE])
            rsc.colors = matrix()
            rsc.names = names(table(rsc))
            rsc.i = 1
            for (rsc.name in rsc.names) {
                rsc.colors[rsc.i] = rsc.name
                rsc[rsc == rsc.name] = rsc.i
                rsc.i = rsc.i + 1
            }
            rsc = matrix(as.numeric(rsc), nrow = dim(rsc)[1])
            image(t(rsc), col = as.vector(rsc.colors), axes = FALSE)
            if (length(rownames(RowSideColors)) > 0) {
                axis(1, 0:(dim(rsc)[2] - 1)/max(1,(dim(rsc)[2] - 1)), rownames(RowSideColors), las = 2, tick = FALSE)
            }
        }
    }

    if (!missing(ColSideColors)) {

        if (!is.matrix(ColSideColors)){
            par(mar = c(0.5, 0, 0, margins[2]))
            image(cbind(1:nc), col = ColSideColors[colInd], axes = FALSE)
        } else {
            par(mar = c(0.5, 0, 0, margins[2]))
            csc = ColSideColors[colInd, , drop=FALSE]
            csc.colors = matrix()
            csc.names = names(table(csc))
            csc.i = 1
            for (csc.name in csc.names) {
                csc.colors[csc.i] = csc.name
                csc[csc == csc.name] = csc.i
                csc.i = csc.i + 1
            }
            csc = matrix(as.numeric(csc), nrow = dim(csc)[1])
            image(csc, col = as.vector(csc.colors), axes = FALSE)
            if (length(colnames(ColSideColors)) > 0) {
                axis(2, 0:(dim(csc)[2] - 1)/max(1,(dim(csc)[2] - 1)), colnames(ColSideColors), las = 2, tick = FALSE)
            }
        }
    }

    par(mar = c(margins[1], 0, 0, margins[2]))
    x <- t(x)
    cellnote <- t(cellnote)
    if (revC) {
        iy <- nr:1
        if (exists("ddr"))
            ddr <- rev(ddr)
        x <- x[, iy]
        cellnote <- cellnote[, iy]
    }
    else iy <- 1:nr
    image(1:nc, 1:nr, x, xlim = 0.5 + c(0, nc), ylim = 0.5 + c(0, nr), axes = FALSE, xlab = "", ylab = "", col = col, breaks = breaks, ...)
    retval$carpet <- x
    if (exists("ddr"))
        retval$rowDendrogram <- ddr
    if (exists("ddc"))
        retval$colDendrogram <- ddc
    retval$breaks <- breaks
    retval$col <- col
    if (!invalid(na.color) & any(is.na(x))) { # load library(gplots)
        mmat <- ifelse(is.na(x), 1, NA)
        image(1:nc, 1:nr, mmat, axes = FALSE, xlab = "", ylab = "",
            col = na.color, add = TRUE)
    }
    axis(1, 1:nc, labels = labCol, las = 2, line = -0.5, tick = 0,
        cex.axis = cexCol)
    if (!is.null(xlab))
        mtext(xlab, side = 1, line = margins[1] - 1.25)
    axis(4, iy, labels = labRow, las = 2, line = -0.5, tick = 0,
        cex.axis = cexRow)
    if (!is.null(ylab))
        mtext(ylab, side = 4, line = margins[2] - 1.25)
    if (!missing(add.expr))
        eval(substitute(add.expr))
    if (!missing(colsep))
        for (csep in colsep) rect(xleft = csep + 0.5, ybottom = rep(0, length(csep)), xright = csep + 0.5 + sepwidth[1], ytop = rep(ncol(x) + 1, csep), lty = 1, lwd = 1, col = sepcolor, border = sepcolor)
    if (!missing(rowsep))
        for (rsep in rowsep) rect(xleft = 0, ybottom = (ncol(x) + 1 - rsep) - 0.5, xright = nrow(x) + 1, ytop = (ncol(x) + 1 - rsep) - 0.5 - sepwidth[2], lty = 1, lwd = 1, col = sepcolor, border = sepcolor)
    min.scale <- min(breaks)
    max.scale <- max(breaks)
    x.scaled <- scale01(t(x), min.scale, max.scale)
    if (trace %in% c("both", "column")) {
        retval$vline <- vline
        vline.vals <- scale01(vline, min.scale, max.scale)
        for (i in colInd) {
            if (!is.null(vline)) {
                abline(v = i - 0.5 + vline.vals, col = linecol,
                  lty = 2)
            }
            xv <- rep(i, nrow(x.scaled)) + x.scaled[, i] - 0.5
            xv <- c(xv[1], xv)
            yv <- 1:length(xv) - 0.5
            lines(x = xv, y = yv, lwd = 1, col = tracecol, type = "s")
        }
    }
    if (trace %in% c("both", "row")) {
        retval$hline <- hline
        hline.vals <- scale01(hline, min.scale, max.scale)
        for (i in rowInd) {
            if (!is.null(hline)) {
                abline(h = i + hline, col = linecol, lty = 2)
            }
            yv <- rep(i, ncol(x.scaled)) + x.scaled[i, ] - 0.5
            yv <- rev(c(yv[1], yv))
            xv <- length(yv):1 - 0.5
            lines(x = xv, y = yv, lwd = 1, col = tracecol, type = "s")
        }
    }
    if (!missing(cellnote))
        text(x = c(row(cellnote)), y = c(col(cellnote)), labels = c(cellnote),
            col = notecol, cex = notecex)
    par(mar = c(margins[1], 0, 0, 0))
    if (dendrogram %in% c("both", "row")) {
        plot(ddr, horiz = TRUE, axes = FALSE, yaxs = "i", leaflab = "none")
    }
    else plot.new()
    par(mar = c(0, 0, if (!is.null(main)) 5 else 0, margins[2]))
    if (dendrogram %in% c("both", "column")) {
        plot(ddc, axes = FALSE, xaxs = "i", leaflab = "none")
    }
    else plot.new()
    if (!is.null(main))
        title(main, cex.main = 1.5 * op[["cex.main"]])
    if (key) {
        par(mar = c(5, 4, 2, 1), cex = 0.75)
        tmpbreaks <- breaks
        if (symkey) {
            max.raw <- max(abs(c(x, breaks)), na.rm = TRUE)
            min.raw <- -max.raw
            tmpbreaks[1] <- -max(abs(x), na.rm = TRUE)
            tmpbreaks[length(tmpbreaks)] <- max(abs(x), na.rm = TRUE)
        }
        else {
            min.raw <- min(x, na.rm = TRUE)
            max.raw <- max(x, na.rm = TRUE)
        }

        z <- seq(min.raw, max.raw, length = length(col))
        image(z = matrix(z, ncol = 1), col = col, breaks = tmpbreaks,
            xaxt = "n", yaxt = "n")
        par(usr = c(0, 1, 0, 1))
        lv <- pretty(breaks)
        xv <- scale01(as.numeric(lv), min.raw, max.raw)
        axis(1, at = xv, labels = lv)
        if (scale == "row")
            mtext(side = 1, "Row Z-Score", line = 2)
        else if (scale == "column")
            mtext(side = 1, "Column Z-Score", line = 2)
        else mtext(side = 1, KeyValueName, line = 2)
        if (density.info == "density") {
            dens <- density(x, adjust = densadj, na.rm = TRUE)
            omit <- dens$x < min(breaks) | dens$x > max(breaks)
            dens$x <- dens$x[-omit]
            dens$y <- dens$y[-omit]
            dens$x <- scale01(dens$x, min.raw, max.raw)
            lines(dens$x, dens$y/max(dens$y) * 0.95, col = denscol,
                lwd = 1)
            axis(2, at = pretty(dens$y)/max(dens$y) * 0.95, pretty(dens$y))
            title("Color Key\nand Density Plot")
            par(cex = 0.5)
            mtext(side = 2, "Density", line = 2)
        }
        else if (density.info == "histogram") {
            h <- hist(x, plot = FALSE, breaks = breaks)
            hx <- scale01(breaks, min.raw, max.raw)
            hy <- c(h$counts, h$counts[length(h$counts)])
            lines(hx, hy/max(hy) * 0.95, lwd = 1, type = "s",
                col = denscol)
            axis(2, at = pretty(hy)/max(hy) * 0.95, pretty(hy))
            title("Color Key\nand Histogram")
            par(cex = 0.5)
            mtext(side = 2, "Count", line = 2)
        }
        else title("Color Key")
    }
    else plot.new()
    retval$colorTable <- data.frame(low = retval$breaks[-length(retval$breaks)],
        high = retval$breaks[-1], color = retval$col)
    invisible(retval)
}

myclust <- function(c)
{
  hclust(c,method="average")
}

na.dist <- function(x,method="euclidian",...) 
{
  t.dist <- dist(x,...)
  t.dist <- as.matrix(t.dist)
  t.limit <- 1.1*max(t.dist,na.rm=TRUE)
  t.dist[is.na(t.dist)] <- t.limit
  t.dist <- as.dist(t.dist)
  return(t.dist)
}
```
## Figure Three
A "heatmap" of physico-chemical properties, in vitro TK parameters (Wetmore, et al., 2013), and TK parameters estimated from in vivo plasma concentration. Rows (chemicals) are clustered by Euclidean distance so that adjacent rows are more similar to each other. Each column (chemical properties) was scaled by the standard deviation of the column and the mean value was subtracted, such that a value of 0 corresponds to the mean and values of -1 or 1 correspond to values one standard deviation above or below the chemicals, respectively. In some cases, TK parameters could not be estimated (e.g., no oral data available for estimating Fbio and kgutabs). Fraction of the compound that is neutral, positively, or negatively ionized at pH 7.4 is indicated by "neutral ph74", "positive ph74" and "negative ph74". The color bar at the left-hand side indicates pharmaceuticals in grey and other chemicals in black.
```{r fig3, eval = execute.vignette}
physprop.matrix <- httk::chem.invivo.PK.aggregate.data[,c(
                                    "Vdist",
                                    "kelim",
                                    "kgutabs",
                                    "Fgutabs")]
rownames(physprop.matrix) <- httk::chem.invivo.PK.aggregate.data$DTXSID
rnames <- NULL
for (this.chem in rownames(physprop.matrix))
{ 
  this.subset <- subset(chem.physical_and_invitro.data,DTXSID==this.chem) 
  if (dim(this.subset)[1]>0)
  {
    physprop.matrix[this.chem,"MW"] <- this.subset$MW
    physprop.matrix[this.chem,"logP"] <- this.subset$logP
    physprop.matrix[this.chem,"logWSol"] <- this.subset$logWSol
    out <- calc_ionization(dtxsid=this.chem,pH=7.4)
    physprop.matrix[this.chem,"Neutral.pH74"] <- out$fraction_neutral
    physprop.matrix[this.chem,"Positive.pH74"] <- out$fraction_positive
    physprop.matrix[this.chem,"Negative.pH74"] <- out$fraction_negative
    physprop.matrix[this.chem,"Clint"] <- strsplit(this.subset$Human.Clint,",")[[1]][1]
    physprop.matrix[this.chem,"Fup"] <- strsplit(this.subset$Human.Funbound.plasma,",")[[1]][1]
  }
}

row.side.cols <- rep("Black",dim(physprop.matrix)[1])
row.side.cols[rownames(physprop.matrix) %in% pharma[1,]] <- "Grey"

apply(physprop.matrix,2,function(x) mean(x,na.rm=TRUE))
for (this.col in colnames(physprop.matrix)[regexpr("log",colnames(physprop.matrix))==-1])
  physprop.matrix[,this.col] <- log10(10^-6+as.numeric(physprop.matrix[,this.col]))

physprop.matrix <- apply(physprop.matrix,2,function(x) (x-mean(x,na.rm=TRUE))/sd(x,na.rm=TRUE))
```

```{r PlotFigure3, eval = execute.vignette}
main_title="in vivo Toxicokinetic Parameters"
heatmap.2(physprop.matrix, 
          hclustfun=myclust,
          Colv=FALSE,
          distfun=na.dist, 
          na.rm = TRUE, 
          scale="none",
          trace="none",
          RowSideColors=row.side.cols,
          col=brewer.pal(11,"Spectral"),
          margins=c(8,10)) 
# The following has to be adjusted manually:
#rect(0.65, 0.01, 0.87, 0.78, border="blue") 
#text(0.75,0.81,expression(paste("Estimated from ",italic("In Vivo")," Data")))
```


The original scripts used a data.table called FitData that contains a lot of stuff we don't need to make these figures. 
We recreate it from the httk object chem.invivo.PK.aggregate.data:
```{r Make FitData, eval = execute.vignette}
# Use joint analysis data from both labs:
FitData <- httk::chem.invivo.PK.aggregate.data
FitData$Compound <- unlist(sapply(FitData$DTXSID,
                                  function(x) 
                                    ifelse(x%in%chem.physical_and_invitro.data$DTXSID,
                                           chem.physical_and_invitro.data[
                                      chem.physical_and_invitro.data$DTXSID==x,
                                      "Compound"],
                                      NA)))
FitData$Source <- NA

FitData <- subset(FitData,Compound!="Bensulide"|Source=="Wambaugh et al. (2018), NHEERL/RTI")
FitData <- subset(FitData,Compound!="Propyzamide"|Source=="Wambaugh et al. (2018), NHEERL/RTI")
# Rename some columns to match original data files:
FitData$Compound.abbrev <- strtrim(gsub("\"","",gsub(",","",gsub("-","",FitData$Compound))),4)
# Add a column indicating chemical type:
FitData$Chemical <- "Other"
FitData[sapply(FitData$CAS,is.pharma),"Chemical"] <- "Pharmaceutical"
```

## Figure Four
Comparison of measured volumes of distribution (Vd) with predictions based upon in vitro data and in silico methods (Pearce, et al., 2017a;  Schmitt, 2008). The solid line in each panel indicates the identity line (1:1, perfect predictions). Chemicals can be identified by their chemical abbreviation given in Table 1.
```{r fig4, eval = execute.vignette}
# Get rid of chemicals with Fup < LOD:
FitData.Fup <- subset(FitData,
                      !(CAS %in% subset(chem.physical_and_invitro.data,
                                      Human.Funbound.plasma==0)$CAS))

# Rename some columns to match original data files:
FitData.Fup$SelectedVdist <- FitData.Fup$Vdist
#FitData.Fup$SelectedVdist.sd <- FitData.Fup$Vdist.sd

# Current invivoPKfit does not give SD's
FitData.Fup$SelectedVdist.sd <- 1
FitData.Fup$Vdist.sd <- 1
FitData.Fup$kelim.sd <- 1

#Predict volume of Distribution
FitData.Fup$Vdist.1comp.pred <- sapply(FitData.Fup$CAS,
  function(x) suppressWarnings(as.numeric(try(calc_vdist(chem.cas=x,
  species="Rat",
  default.to.human = TRUE,
  suppress.messages=TRUE)))))
FitData.Fup$Vdist.1comp.pred.nocal <- sapply(FitData.Fup$CAS,
  function(x) suppressWarnings(as.numeric(try(calc_vdist(chem.cas=x,
  regression=FALSE,
  species="Rat",
  default.to.human = TRUE,
  suppress.messages=TRUE)))))

FigVdista.fit <- lm(
  log(SelectedVdist)~log(Vdist.1comp.pred),
  data=subset(FitData.Fup,
              !is.na(SelectedVdist) &
              !is.na(Vdist.1comp.pred)))
summary(FigVdista.fit)

FigVdista.fit.weighted <- lm(
  log(SelectedVdist)~log(Vdist.1comp.pred),
  data=subset(FitData.Fup,
              !is.na(SelectedVdist) &
                !is.na(Vdist.1comp.pred)),
  weights=1/SelectedVdist.sd^2)
summary(FigVdista.fit)

FigVdista.fit.pharm <- lm(
  log(SelectedVdist)~log(Vdist.1comp.pred),
  data=subset(FitData.Fup,
              Chemical!="Other" &
                !is.na(Vdist.1comp.pred)))
summary(FigVdista.fit.pharm)

FigVdista.fit.other <- lm(
  log(SelectedVdist)~log(Vdist.1comp.pred),
  data=subset(FitData.Fup,
              Chemical=="Other" &
                !is.na(Vdist.1comp.pred)))
summary(FigVdista.fit.other)

dim(subset(FitData.Fup,
           !is.na(SelectedVdist.sd) &
             !is.na(Vdist.1comp.pred)))[1]

FigVdista <- ggplot(data=subset(FitData.Fup,!is.na(Vdist.1comp.pred))) +
    geom_segment(color="Grey",
                 aes(x=Vdist.1comp.pred,
                     y=exp(log(SelectedVdist)-SelectedVdist.sd),
                     xend=Vdist.1comp.pred,
                     yend=exp(log(SelectedVdist)+SelectedVdist.sd))) +
    geom_text(aes_string(y="SelectedVdist",
                         x="Vdist.1comp.pred",
                         label="Compound.abbrev",
                         color="Chemical")) + 
   scale_y_log10(label=label_log(),limits = c(5*10^-2, 10^2)) +
   scale_x_log10(label=label_log(),limits = c(5*10^-2, 10^2)) +
   annotation_logticks() + 
   geom_abline(slope=1, intercept=0) + 
   annotate("text", x = 1*10^-1, y = 3*10^1, label = "A",size=6)  +
   ylab(expression(paste(italic("In vivo")," estimated Volume of Distribution (L/kg)"))) + 
   xlab(expression(paste("Calibrated ",italic("In vitro")," predicted ",V[d]," (L/kg)"))) +
   theme_bw()  +
   theme(legend.position="bottom")+
    guides(shape=guide_legend(nrow=2,byrow=TRUE),color=guide_legend(nrow=2,byrow=TRUE))
   
FigVdistb.fit <- lm(log(SelectedVdist) ~ log(Vdist.1comp.pred.nocal),
                    data=subset(FitData.Fup,!is.na(Vdist.1comp.pred)))
summary(FigVdistb.fit)

FigVdistb.fit.weighted <- lm(
  log(SelectedVdist)~log(Vdist.1comp.pred.nocal),
  data=subset(FitData.Fup,
              !is.na(Vdist.1comp.pred)),
  weights=1/SelectedVdist.sd^2)
summary(FigVdistb.fit)

FigVdistb.fit.pharm <- lm(
  log(SelectedVdist)~log(Vdist.1comp.pred.nocal),
  data=subset(FitData.Fup,
              Chemical!="Other" &
              !is.na(Vdist.1comp.pred)))
summary(FigVdistb.fit.pharm)

FigVdistb.fit.other<- lm(
  log(SelectedVdist)~log(Vdist.1comp.pred.nocal),
  data=subset(FitData.Fup,
              Chemical=="Other" &
              !is.na(Vdist.1comp.pred)))
summary(FigVdistb.fit.other)

FigVdistb <- ggplot(data=subset(FitData.Fup,!is.na(Vdist.1comp.pred.nocal))) +
   geom_segment(color="Grey",aes(x=Vdist.1comp.pred.nocal,y=exp(log(SelectedVdist)-SelectedVdist.sd),xend=Vdist.1comp.pred.nocal,yend=exp(log(SelectedVdist)+SelectedVdist.sd)))+
   geom_text(aes_string(y="SelectedVdist",
                         x="Vdist.1comp.pred.nocal",
                         label="Compound.abbrev",
                         color="Chemical"))+ 
   scale_y_log10(label=label_log(),limits = c(5*10^-2, 10^2)) +
   scale_x_log10(label=label_log(),limits = c(5*10^-2, 10^2)) +
   annotation_logticks() + 
   geom_abline(slope=1, intercept=0) + 
   annotate("text", x = 1*10^-1, y = 3*10^1, label = "B",size=6) +
   ylab(expression(paste(italic("In vivo")," estimated Volume of Distribution (L/kg)"))) + 
   xlab(expression(paste("Original ",italic("In vitro")," predicted ",V[d]," (L/kg)"))) +
   theme_bw()  +
   theme(legend.position="bottom")+
    guides(shape=guide_legend(nrow=2,byrow=TRUE),color=guide_legend(nrow=2,byrow=TRUE))



#dev.new(width=10,height=6)
multiplot(FigVdista,FigVdistb,cols=2,widths=c(1.75,1.75))


Fig4a.data <- subset(FitData.Fup,!is.na(SelectedVdist)&!is.na(Vdist.1comp.pred))
Fig4a.MSE <- mean((log(Fig4a.data$Vdist.1comp.pred)-log(Fig4a.data$SelectedVdist))^2)


Fig4b.data <- subset(FitData.Fup,!is.na(SelectedVdist)&!is.na(Vdist.1comp.pred.nocal))
Fig4b.MSE <- mean((log(Fig4b.data$Vdist.1comp.pred.nocal)-log(Fig4b.data$SelectedVdist))^2)


```
## Figure Five
Comparison of the TK clearance estimated from the in vivo data with the clearance predictions made using HTTK data. The more likely empirical TK model (either one or two-compartments, as in Figure 2) is selected for each chemical using the AIC (Akaike, 1974). A non-compartmental estimate of clearance is used if neither model is selected. Estimated standard deviation is indicated by a vertical line, and is often smaller than the plot point. The solid line indicates the identity line (1:1, perfect predictions), while the dotted and dashed lines indicate the linear regression (log-scale) trend-lines for pharmaceuticals and other chemicals, respectively. Chemicals can be identified by their chemical abbreviation given in Table 1.
```{r fig5, eval = execute.vignette}
#FitData.Fup$CLtot.1comp <- FitData.Fup$Vdist.1comp.meas*FitData.Fup$kelim.1comp.meas
#FitData.Fup$CLtot.1comp.sd <- (FitData.Fup$Vdist.1comp.meas.sd^2+FitData.Fup$kelim.1comp.meas.sd^2)^(1/2)
#FitData.Fup[is.na(CLtot.1comp.sd)]$CLtot.1comp.sd <- Inf

#FitData.Fup[is.na(SelectedCLtot.sd)]$SelectedClearance.sd <- Inf

FitData.Fup$SelectedCLtot <- FitData.Fup$Vdist*FitData.Fup$kelim/24 # invivoPKfit rates are in units of 1/day
FitData.Fup$SelectedCLtot.sd <- (FitData.Fup$Vdist.sd^2 + 
  FitData.Fup$kelim.sd^2)^(1/2)
good.chems <- unique(c(get_cheminfo(suppress.messages=TRUE),
                       get_cheminfo(species="rat", suppress.messages=TRUE)))
FitData.Fup$CLtot.1comp.pred <- sapply(FitData.Fup$CAS, 
  function(x) as.numeric(try(
    ifelse(x %in% good.chems,
                    calc_total_clearance(chem.cas=x,
                                         species="Rat",
                                         default.to.human = TRUE,
                                         suppress.messages=TRUE),
           NA))))

Fig.SelectedClearance.fit <- lm(
  log(SelectedCLtot)~log(CLtot.1comp.pred),
  data=subset(FitData.Fup,!is.na(SelectedCLtot.sd)))
summary(Fig.SelectedClearance.fit)
Fig.SelectedClearance.fit.weighted <- lm(
  log(SelectedCLtot)~log(CLtot.1comp.pred),
  data=subset(FitData.Fup,!is.na(SelectedCLtot.sd)),
  weights=1/SelectedCLtot.sd^2)
summary(Fig.SelectedClearance.fit.weighted)
Fig.SelectedClearance.fit.pharma <- lm(
  log(SelectedCLtot)~log(CLtot.1comp.pred),
  data=subset(FitData.Fup,Chemical!="Other" &
                !is.na(SelectedCLtot.sd)),
  weights=1/SelectedCLtot.sd^2)
summary(Fig.SelectedClearance.fit.pharma)
Fig.SelectedClearance.fit.other<- lm(
  log(SelectedCLtot)~log(CLtot.1comp.pred),
  data=subset(FitData.Fup,Chemical=="Other" &
                !is.na(SelectedCLtot.sd)),
  weights=1/SelectedCLtot.sd^2)
summary(Fig.SelectedClearance.fit.other)
Fig.SelectedClearance.fit.pharma <- lm(
  log(SelectedCLtot)~log(CLtot.1comp.pred),
  data=subset(FitData.Fup,Chemical!="Other"))
summary(Fig.SelectedClearance.fit.pharma)
Fig.SelectedClearance.fit.other<- lm(
  log(SelectedCLtot)~log(CLtot.1comp.pred),
  data=subset(FitData.Fup,Chemical=="Other"))
summary(Fig.SelectedClearance.fit.other)

Fig.SelectedClearance <- 
  ggplot(
    data=FitData.Fup,
    aes(y=SelectedCLtot,x=CLtot.1comp.pred)) +
  geom_segment(
    data=subset(FitData.Fup,is.finite(SelectedCLtot.sd)),
    color="grey",
    aes(
      x=CLtot.1comp.pred,
      y=exp(log(SelectedCLtot)-SelectedCLtot.sd),
      xend=CLtot.1comp.pred,
      yend=exp(log(SelectedCLtot)+SelectedCLtot.sd))) +
  geom_text(
    aes_string(y="SelectedCLtot",
               x="CLtot.1comp.pred",
               label="Compound.abbrev",
               color="Chemical"))+ 
#    geom_point(data=twocomp.data,color="White",size=2,aes(shape=Source))+    
  scale_y_log10(label=label_log(),limits = c(10^-4, 10^3)) +
  scale_x_log10(label=label_log(),limits = c(10^-4, 10^3)) +
  annotation_logticks() + 
  geom_abline(slope=1, intercept=0) + 
  geom_line(aes(
    x = CLtot.1comp.pred, 
    y = exp(Fig.SelectedClearance.fit.pharma$coefficients[1] + 
              Fig.SelectedClearance.fit.pharma$coefficients[2]*log(CLtot.1comp.pred))),
    colour = "darkturquoise", 
    linetype="dotted", size=1.5) +
  geom_line(aes(
    x = CLtot.1comp.pred, 
    y = exp(Fig.SelectedClearance.fit.other$coefficients[1] +
              Fig.SelectedClearance.fit.other$coefficients[2]*log(CLtot.1comp.pred))),
    colour = "red",
    linetype="dashed", size=1.5) +
  ylab(expression(paste(italic("In vivo")," estimated clearance (mg/L/h)"))) +
  xlab(expression(paste(italic("In vitro")," predicted clearance (mg/L/h)"))) +
  theme_bw()   +
  theme(legend.position="bottom")+
  annotate("text",
           x = 10^2/3/3/3, 
           y = 3*3*10^-4
           ,size=4, 
           label = lm_R2(Fig.SelectedClearance.fit.pharma,prefix="Pharmaceutical:"),
           parse=TRUE) + 
  annotate("text",
           x = 10^2/3/3/3, 
           y = 3*3*3*10^-5,
           size=4, 
           label = lm_R2(Fig.SelectedClearance.fit.other,prefix="Other:"),
           parse=TRUE) +
  theme(plot.margin = unit(c(1,1,1,1), "cm")) +
  guides(
    shape=guide_legend(nrow=2,byrow=TRUE),
    color=guide_legend(nrow=2,byrow=TRUE))


#dev.new(width=6,height=6)
print(Fig.SelectedClearance)

paste("with",
      with(FitData.Fup, sum(SelectedCLtot<CLtot.1comp.pred,na.rm=TRUE)),
      "chemicals over-estimated and",
      with(FitData.Fup, sum(SelectedCLtot>CLtot.1comp.pred,na.rm=TRUE)),
      "under-estimated")

```
## Figure Six
Distribution of Gut Absorption Rate for Environmental and Pharmaceutical Chemicals.
```{r fig6, eval = execute.vignette}
FitData$Selectedkgutabs <- FitData$kgutabs/24 # invivoPKfit does time in days
# Cutoff from optimizer is 1000:
Figkgutabs <- ggplot(subset(FitData,Selectedkgutabs<999), aes(Selectedkgutabs, fill = Chemical)) +
  geom_histogram(binwidth=0.5) +
     scale_x_log10(label=label_log()) +
     ylab("Number of Chemicals")+
     xlab("Absorption Rate from Gut (1/h)")+
     theme_bw() +
        theme(legend.position="bottom")
     
#dev.new(width=6,height=6)
print(Figkgutabs) 

mean(subset(FitData,Selectedkgutabs<999)$Selectedkgutabs)
min(subset(FitData,Selectedkgutabs<999)$Selectedkgutabs)
max(subset(FitData,Selectedkgutabs<999)$Selectedkgutabs)
median(subset(FitData,Selectedkgutabs<999)$Selectedkgutabs)
cat(paste0("Median absortipon rate from the gut is ",
    signif(median(subset(FitData,Selectedkgutabs<999)$Selectedkgutabs),2),
    " h.\n"))
```
## Figure Seven
In panel A, the observed fraction of oral dose absorbed from the gut is compared with predictions made using httk::calc_fbio.oral. The solid line indicates the identity line (1:1, perfect predictions). These fractions are distrusted from nearly zero to effectively 100% (Panel B). Chemicals can be identified by their chemical abbreviation given in Table 1.
```{r fig7, eval = execute.vignette}
FitData$SelectedFbio <- FitData$Fgutabs
good.chems <- get_cheminfo(info="dtxsid",suppress.messages=TRUE)
FitData$Fbio.pred <- 
  unlist(sapply(FitData$DTXSID, function(x)
    as.numeric(try(ifelse(
      x %in% good.chems,
      calc_fbio.oral(dtxsid=x,
                     suppress.messages = TRUE),
      NA)))))

FigFbioa <- ggplot(data=FitData) +
    geom_text(aes_string(y="SelectedFbio",
                         x="Fbio.pred",
                         label="Compound.abbrev",
                         color="Chemical"))+ 
   scale_y_log10(label=label_log(),limits=c(10^-3,1)) +
   scale_x_log10(label=label_log(),limits=c(10^-3,1)) +
#    xlim(0, 1)+
#    ylim(0, 1)+
    annotate("text", x = .015/10, y = 0.55, label = "A",size=6) +
    annotation_logticks() + 
    geom_abline(slope=1, intercept=0) + 
    ylab(expression(paste(italic("In vivo")," estimated Fraction Bioavailable"))) + 
    xlab(expression(paste(italic("In silico")," predicted ",F[bio]))) +
#    scale_color_brewer(palette="Set2") + 
    theme_bw()  +
    theme(legend.position="bottom")+
    guides(shape=guide_legend(nrow=2,byrow=TRUE),color=guide_legend(nrow=2,byrow=TRUE))


FigFbiob <- ggplot(FitData, aes(SelectedFbio, fill = Chemical)) +
  geom_histogram(binwidth=0.5) +
    scale_x_log10(label=label_log(),limits=c(10^-3,3)) +
    annotate("text", x = .001, y = 18, label = "B",size=6) +
    ylab("Number of Chemicals")+
    xlab(expression(paste(italic("In vivo")," estimated Fraction Bioavailable"))) + 
    theme_bw()  +
    theme(legend.position="bottom")+
    guides(shape=guide_legend(nrow=2,byrow=TRUE),fill=guide_legend(nrow=2,byrow=TRUE))

     

#dev.new(width=10,height=6)
multiplot(FigFbioa,FigFbiob,cols=2,widths=c(1.75,1.75))

summary(lm(log(SelectedFbio)~log(Fbio.pred), data=FitData))

paste("Fbio ranged from",signif(min(FitData[FitData$Chemical=="Pharmaceutical","SelectedFbio"],na.rm=TRUE),2),"to",signif(max(FitData[FitData$Chemical=="Pharmaceutical","SelectedFbio"],na.rm=TRUE),2),"for pharmaceutical compounds, but was observed to be as low as", signif(min(FitData[FitData$Chemical=="Other","SelectedFbio"],na.rm=TRUE),3),"for other compounds.")

min(FitData$SelectedFbio,na.rm=TRUE)                       
```
## Figure Eight
Rat in vivo data were collected for diverse environmental chemicals to evaluate the predictive ability of HTTK, especially with respect to predicting steady-state serum concentration (Css). Chemicals can be identified by their chemical abbreviation given in Table 1. The abbreviations are centered at the measured and predicted values. The solid line indicates the identity line (1:1, perfect predictions). In panel A, the one-compartment model is parameterized with a predicted volume of distribution and clearance, based upon in vitro measured parameters. Fbio is assumed to be 100%. In panel B, the in vivo measured Fbio is used to reduce the amount of the oral dose absorbed in the one-compartment model, to illustrate the improvement possible if Fbio could be predicted accurately.
```{r fig8, eval = execute.vignette}
FitData$SelectedFbio <- FitData$Fgutabs
FitData$SelectedCss <- FitData$Css.tkstats
FitData$SelectedCss.sd <- 1
good.chems <- get_cheminfo(species="rat", default.to.human=TRUE)
FitData$Css.1comp.pred <- sapply(
  FitData$CAS,
  function(x) ifelse(x %in% good.chems,
                     calc_analytic_css(
                       chem.cas=x,
                       species="Rat",
                       model="3compartmentss",
                       suppress.messages=TRUE,
                       parameterize.args.list = list(
                         default.to.human=TRUE,
                         adjusted.Funbound.plasma=TRUE,
                         regression=TRUE,
                         minimum.Funbound.plasma=1e-4
                       )
                     ),
                     NA)
  )
Fig.1compCss.fit <- lm(
  log10(SelectedCss)~log10(Css.1comp.pred),
  data=subset(FitData, 
              !is.na(log10(Css.1comp.pred)) &
              !is.infinite(log10(Css.1comp.pred))))
Fig.1compCss.fit.weighted <- lm(
  log10(SelectedCss)~log10(Css.1comp.pred),
  data=subset(FitData, 
              !is.na(log10(Css.1comp.pred)) &
              !is.infinite(log10(Css.1comp.pred))),
  weights=1/SelectedCss.sd^2)
Fig.1compCss.fit.pharma <- lm(
  log10(SelectedCss)~log10(Css.1comp.pred),
  data=subset(FitData,Chemical!="Other" &
              !is.na(log10(Css.1comp.pred)) &
              !is.infinite(log10(Css.1comp.pred))))
Fig.1compCss.fit.other <- lm(
  log10(SelectedCss)~log10(Css.1comp.pred),
  data=subset(FitData,
              Chemical=="Other" &
              !is.na(log10(Css.1comp.pred)) &
              !is.infinite(log10(Css.1comp.pred))))

summary(Fig.1compCss.fit)
summary(Fig.1compCss.fit.pharma)
summary(Fig.1compCss.fit.other)


textx <- 10^-3
texty <- 1*10^1

Fig.Cssa <- ggplot(data=FitData) +
  geom_segment(color="grey",aes(x=Css.1comp.pred,y=exp(log(SelectedCss)-SelectedCss.sd),xend=Css.1comp.pred,yend=exp(log(SelectedCss)+SelectedCss.sd)))+
  geom_text(size=4,aes_string(y="SelectedCss", x="Css.1comp.pred",label="Compound.abbrev",color="Chemical"))+ 
  scale_y_log10(label=label_log(),limits = c(5*10^-6, 110)) +
  scale_x_log10(label=label_log(),limits = c(5*10^-6, 110)) +
  annotation_logticks() + 
  geom_abline(slope=1, intercept=0) + 
  ylab(expression(paste(italic("In vivo")," estimated ",C[ss]," (mg/L)"))) + 
 xlab(expression(paste(italic("In vitro")," predicted ",C[ss]," (mg/L)"))) +
#  scale_color_brewer(palette="Set2") + 
  theme_bw()  +
  theme(legend.position="bottom")+
    annotate("text", x = textx/15, y = 5*texty, label = "A",size=6) +
  annotate("text",x = textx, y = texty,size=6, label = lm_R2(Fig.1compCss.fit),parse=TRUE)+
    guides(shape=guide_legend(nrow=2,byrow=TRUE),color=guide_legend(nrow=2,byrow=TRUE)) 
#  annotate("text",x = textx/3, y = texty/3,size=4, label = lm_R2(Fig.1compCss.fit.weighted,prefix="Weighted:"),parse=TRUE) 
#  annotate("text",x = textx, y = texty,size=4, label = lm_R2(Fig.1compCss.fit.pharma,prefix="Pharmaceutical:"),parse=TRUE)
#  annotate("text",x = textx, y = texty/3,size=4, label = lm_R2(Fig.1compCss.fit.other,prefix="Other:"),parse=TRUE) 

FitData$Css.Bio <- FitData$Css.1comp.pred*FitData$SelectedFbio
Fig.1compCssb.fit <- lm(log(SelectedCss)~log(Css.Bio),data=FitData,na.rm=TRUE)
Fig.1compCssb.fit.weighted <- lm(log(SelectedCss)~log(Css.Bio),data=FitData,na.rm=TRUE,weights=1/SelectedCss.sd^2)
Fig.1compCssb.fit.pharma <- lm(log(SelectedCss)~log(Css.Bio),data=subset(FitData,Chemical!="Other"),na.rm=TRUE)
Fig.1compCssb.fit.other <- lm(log(SelectedCss)~log(Css.Bio),data=subset(FitData,Chemical=="Other"),na.rm=TRUE)

Fig.Cssb <- ggplot(data=FitData) +
  geom_segment(color="grey",aes(x=Css.Bio,y=exp(log(SelectedCss)-SelectedCss.sd),xend=Css.Bio,yend=exp(log(SelectedCss)+SelectedCss.sd)))+
  geom_text(size=4,aes_string(y="SelectedCss", x="Css.Bio",label="Compound.abbrev",color="Chemical"))+ 
  scale_y_log10(label=label_log(),limits = c(5*10^-6, 110)) +
  scale_x_log10(label=label_log(),limits = c(5*10^-6, 110)) +
  annotation_logticks() + 
  geom_abline(slope=1, intercept=0) + 
  ylab(expression(paste(italic("In vivo")," estimated ",C[ss]," (mg/L)"))) + 
 xlab(expression(paste(italic("In vitro")," predicted ",C[ss]," (mg/L) Using Measured ", F[bio]))) + 
 # scale_color_brewer(palette="Set2") + 
  theme_bw()  +
  theme(legend.position="bottom")+
    annotate("text", x = textx/15, y = 5*texty, label = "B",size=6) +
  annotate("text",x = textx, y = texty,size=6, label = lm_R2(Fig.1compCssb.fit),parse=TRUE)+
    guides(shape=guide_legend(nrow=2,byrow=TRUE),color=guide_legend(nrow=2,byrow=TRUE)) 

#dev.new(width=10,height=6)
multiplot(Fig.Cssa,Fig.Cssb,cols=2,widths=c(1.75,1.75))

                        
```
## Figure Nine
Evaluation of Wambaugh et al. (2015) classification scheme for predicting errors made when using HTTK data to predict in vivo steady state plasma concentration (Css). Chemicals were placed into categories, depending upon the size of the error. "On the Order" represented the best case, where errors were within 3.2 times over or under the true value. Some chemicals were determined to be problematic due to limitations in the HTTK methods (e.g., plasma protein binding estimation) or failure to come to steady state. Wherever the chemical names overlap the vertical, gray bands, the observed errors are consistent with predicted error. Chemicals can be identified by their chemical abbreviation given in Table 1.
```{r fig9, eval = execute.vignette}
FitData$TriageCat <- FitData$Triage.Call
FitData$CssResidual <- log10(FitData$Css.1comp.pred/FitData$SelectedCss)
FitData[FitData$TriageCat%in%c("Does Not Reach Steady State","Plasma Binding Assay Failed"),"TriageCat"]<-"Problem"
FitData$TriageCat <- factor(FitData$TriageCat,levels=c(">10x Underestimated",">3.2x Underestimated","On the Order",">3.2x Overestimated",">10x Overestimated","Problem"))


Fig.Triage <- ggplot(data=subset(FitData,!is.na(TriageCat)&is.finite(CssResidual))) +
  geom_text(size=4,aes_string(y="CssResidual", x="TriageCat",label="Compound.abbrev",color="Chemical"))+ 
  geom_segment(aes(x = factor(">10x Underestimated",levels=levels(FitData$TriageCat)), y = log10(1/10), xend = factor(">10x Underestimated",levels=levels(FitData$TriageCat)), yend = log10(1/30)), size=3,colour = "grey") +
 # geom_segment(aes(x = factor(">3.2x Underestimated",levels=levels(FitData$TriageCat)), y = log10(1/10), xend = factor(">3.2x Underestimated",levels=levels(FitData$TriageCat)), yend = log10(1/3.2)), size=3,colour = "grey") +
  geom_segment(aes(x = factor("On the Order",levels=levels(FitData$TriageCat)), y = log10(1/3.2), xend = factor("On the Order",levels=levels(FitData$TriageCat)), yend = log10(3.2)), size=3,colour = "grey") +
  geom_segment(aes(x = factor(">3.2x Overestimated",levels=levels(FitData$TriageCat)), y = log10(3.2), xend = factor(">3.2x Overestimated",levels=levels(FitData$TriageCat)), yend = log10(10)), size=3,colour = "grey") +
  geom_segment(aes(x = factor(">10x Overestimated",levels=levels(FitData$TriageCat)), y = log10(10), xend = factor(">10x Overestimated",levels=levels(FitData$TriageCat)), yend = log10(500)), size=3,colour = "grey") +
  geom_hline(yintercept=0)+
  geom_hline(yintercept=log10(1/10),linetype="dashed")+
    geom_hline(yintercept=log10(1/3.2),linetype="dashed")+
  geom_hline(yintercept=log10(3.2),linetype="dashed")+
  geom_hline(yintercept=log10(10),linetype="dashed")+
  geom_text(size=4,aes_string(y="CssResidual", x="TriageCat",label="Compound.abbrev",color="Chemical"))+ 
  scale_y_continuous(name=expression(paste("Actual error in ",C[ss]," prediction")),breaks=c(log10(1/10),log10(1/3.2),0,log10(3.2),1),labels=c(">10x Under",">3.2x Under","On the Order",">3.2x Over",">10x Over")) + 
  xlab("Predicted Error") +
  theme_bw()  +
  theme(legend.position="bottom")+
  theme(axis.text.x = element_text(angle = 45, hjust = 1))+
    guides(shape=guide_legend(nrow=2,byrow=TRUE),color=guide_legend(nrow=2,byrow=TRUE))


#dev.new(width=6,height=6)
print(Fig.Triage)


                        
```
## Figure Ten
Evaluation of the ability of in vitro HTTK data, coupled with a one-compartment model, to predict important TK statistics like the maximum plasma concentration (Cmax) for characterizing tissue exposure. A single point is plotted for each combination of chemical, dose amount, and dose route, either intravenous (iv) or per oral (po). In panel A, the one-compartment model is parameterized with a predicted volume of distribution and clearance, based upon in vitro measured parameters. Fbio is assumed to be 100%. In panel B, the in vivo measured Fbio is used to reduce the amount of the oral dose absorbed in the one-compartment model, to illustrate the improvement possible if Fbio could be predicted accurately.
```{r makestatpreds, eval = execute.vignette}
PKstats <- httk::chem.invivo.PK.summary.data
PKstats$Cmax <- PKstats$Cmax.tkstats
PKstats$AUC <- PKstats$AUC_infinity.tkstats

good.chems <- get_cheminfo(info="dtxsid",
                           species="rat",
                           model="pbtk",
                           default.to.human = TRUE,
                           suppress.messages=TRUE)
num.treatments <- dim(PKstats)[1]
preds <- data.frame(AUC= rep(NA,num.treatments),
                    mean = rep(NA,num.treatments),
                    max = rep(NA,num.treatments),
                    Fbio = rep(NA,num.treatments))
for (i in 1:dim(PKstats)[1])
{
  if (PKstats[i,"DTXSID"] %in% good.chems)
  {
    preds[i,c("AUC","peak","mean")] <-
      unlist(as.numeric(try(calc_tkstats(dtxsid=PKstats[i,"DTXSID"],
                 species=PKstats[i,"Species"],
                 route=PKstats[i,"Route"],
                 dose=PKstats[i,"Dose"],
                 concentration=PKstats[i,"Media"],
                 parameterize.args.list=list(default.to.human=TRUE),
                 suppress.messages=TRUE))))
    preds[i,"Fbio"] <- as.numeric(try(calc_fbio.oral(
      dtxsid=PKstats[i,"DTXSID"],
      suppress.messages=TRUE)$fbio.oral))
  }
}
# Values predicted with current httk:
PKstats$AUC.pred <- preds[,"AUC"]
PKstats$Cmax.pred <- preds[,"peak"]
# Value predicted as if httk used in vivo bioavailability:
PKstats$Cmax.pred.Fbio <- preds[,"peak"] / preds[,"Fbio"] * PKstats[,"Fgutabs"]
PKstats$AUC.pred.Fbio <- preds[,"AUC"] / preds[,"Fbio"] * PKstats[,"Fgutabs"]

# Add a column indicating chemical type:
PKstats$Chemical <- "Other"
PKstats[unlist(sapply(PKstats$CAS,function(x)
  ifelse(is.na(x),
         FALSE,
         is.pharma(x)))),"Chemical"] <- "Pharmaceutical"

```

```{r fig10, eval = execute.vignette}
FigCmaxa.fit <- lm(log10(Cmax)~log10(Cmax.pred),
                   data=subset(PKstats,
                               is.finite(log10(Cmax)) &
                               !is.na(log10(Cmax.pred)) &
                               is.finite(log10(Cmax.pred))))
  summary(FigCmaxa.fit)
                    
FigCmaxa <- ggplot(data=subset(PKstats,is.finite(Cmax))) +
    geom_point(size=3,aes_string(y="Cmax",
                         x="Cmax.pred",
                         shape="Route",
                         color="Chemical"))+ 
   scale_y_log10(label=label_log(),limits = c(10^-4, 10^4)) +
   scale_x_log10(label=label_log(),limits = c(10^-4, 10^4)) +
    annotation_logticks() + 
    geom_abline(slope=1, intercept=0) + 
    ylab(expression(paste(italic("In vivo")," estimated ",C[max]))) + 
    xlab(expression(paste(italic("In vitro")," predicted ",C[max]))) +
#    scale_color_brewer(palette="Set2") +
    annotate("text", x = 10^-3, y = 300, label = "A",size=6) +
    annotate("text",x = 3*10^1, y = 10^-3, label = lm_R2(FigCmaxa.fit),parse=TRUE,size=6) + 
    theme_bw()  +
    theme(legend.position="bottom")+
    guides(shape=guide_legend(nrow=2,byrow=TRUE),color=guide_legend(nrow=2,byrow=TRUE))




FigCmaxb.fit <- lm(
  log10(Cmax)~log10(Cmax.pred.Fbio),
  data=subset(PKstats,is.finite(Cmax)))
summary(FigCmaxb.fit)

FigCmaxb <- ggplot(data=subset(PKstats,is.finite(Cmax))) +
    geom_point(size=3,aes_string(y="Cmax",
                         x="Cmax.pred.Fbio",
                         shape="Route",
                         color="Chemical"))+ 
   scale_y_log10(label=label_log(),limits = c(10^-4, 10^4)) +
   scale_x_log10(label=label_log(),limits = c(10^-4, 10^4)) +
    annotation_logticks() + 
    geom_abline(slope=1, intercept=0) + 
    ylab(expression(paste(italic("In vivo")," estimated ",C[max]))) + 
    xlab(expression(paste("Predicted ", C[max], " Using Measured ", F[bio ]))) + 
    annotate("text", x = 10^-3, y = 300, label = "B",size=6) +
    annotate("text",x = 3*10^1, y = 10^-3, label = lm_R2(FigCmaxb.fit),parse=TRUE,size=6) + 
#    scale_color_brewer(palette="Set2") + 
    theme_bw()  +
    theme(legend.position="bottom")+
    guides(shape=guide_legend(nrow=2,byrow=TRUE),color=guide_legend(nrow=2,byrow=TRUE))

#dev.new(width=10,height=6)
multiplot(FigCmaxa,FigCmaxb,cols=2,widths=c(1.75,1.75))
                        
```
## Figure Eleven
Evaluation of predictions for the time integrated plasma concentration (i.e., area under the curve or AUC). A single point is plotted for each combination of chemical, dose amount, and dose route, either intravenous (iv) or per oral (po). In panel A, the one-compartment model is parameterized with a predicted volume of distribution and clearance, based upon in vitro measured parameters. Fbio is assumed to be 100%. In panel B, the in vivo measured Fbio is used to reduce the amount of the oral dose absorbed in the one-compartment model, to illustrate the improvement possible if Fbio could be predicted accurately. The solid line in each panel indicates the identity line (1:1, perfect predictions).
```{r fig11, eval = execute.vignette}
FigAUCa.fit <- lm(
  log10(AUC)~log10(AUC.pred),
  data=subset(PKstats,is.finite(log10(AUC))))
FigAUCb.fit <- lm(
  log10(AUC)~log10(AUC.pred.Fbio),
  data=subset(PKstats,is.finite(log10(AUC))))
summary(FigAUCa.fit)
summary(FigAUCb.fit)
                                              
FigAUCa <- ggplot(data=subset(PKstats,is.finite(log(AUC)))) +
    geom_point(size=3,aes_string(y="AUC",
                         x="AUC.pred",
                         shape="Route",
                         color="Chemical"))+ 
   scale_y_log10(label=label_log(),limits = c(10^-3, 10^4)) +
   scale_x_log10(label=label_log(),limits = c(10^-3, 10^4)) +
    annotation_logticks() + 
    geom_abline(slope=1, intercept=0) + 
    ylab(expression(paste(italic("In vivo")," estimated AUC (mg*h/L)"))) + 
    xlab(expression(paste(italic("In vitro")," predicted Area under the Curve (AUC, mg*h/L)"))) +
    annotate("text", x = 10^-2, y = 3000, label = "A",size=6) +
    annotate("text",x = 3*10^1, y = 10^-2, label = lm_R2(FigAUCa.fit),parse=TRUE,size=6) + 
    theme_bw()  +
    theme(legend.position="bottom")+
    guides(shape=guide_legend(nrow=2,byrow=TRUE),color=guide_legend(nrow=2,byrow=TRUE))


FigAUCb <- ggplot(data=subset(PKstats,is.finite(log(AUC)))) +
    geom_point(size=3,aes_string(y="AUC",
                         x="AUC.pred.Fbio",
                         shape="Route",
                         color="Chemical"))+ 
   scale_y_log10(label=label_log(),limits = c(10^-3, 10^4)) +
   scale_x_log10(label=label_log(),limits = c(10^-3, 10^4)) +
    annotation_logticks() + 
    geom_abline(slope=1, intercept=0) + 
    ylab(expression(paste(italic("In vivo")," estimated AUC (mg*h/L)"))) + 
    xlab(expression(paste("Predicted AUC (mg*h/L) Using Measured ", F[bio]))) + 
    annotate("text", x = 10^-2, y = 3000, label = "B",size=6) +
    annotate("text",x = 3*10^1, y = 10^-2, label = lm_R2(FigAUCb.fit),parse=TRUE,size=6) + 
    theme_bw()  +
    theme(legend.position="bottom")+
    guides(shape=guide_legend(nrow=2,byrow=TRUE),color=guide_legend(nrow=2,byrow=TRUE))

#dev.new(width=10,height=6)
multiplot(FigAUCa,FigAUCb,cols=2,widths=c(1.75,1.75))
                        
```
